# SymbolicUtils.jl

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/SymbolicUtils/stable/)

[![codecov](https://codecov.io/gh/JuliaSymbolics/SymbolicUtils.jl/branch/master/graph/badge.svg)](https://app.codecov.io/gh/JuliaSymbolics/SymbolicUtils.jl)
[![Build Status](https://github.com/JuliaSymbolics/SymbolicUtils.jl/workflows/CI/badge.svg)](https://github.com/JuliaSymbolics/SymbolicUtils.jl/actions?query=workflow%3ACI)
[![Build status](https://badge.buildkite.com/3db222e469784b365e4b45f2b0155d252cf0ae70fef708bfa1.svg?branch=master)](https://buildkite.com/julialang/symbolicutils-dot-jl)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)


## Tutorials and Documentation

For information on using the package,
[see the stable documentation](https://docs.sciml.ai/SymbolicUtils/stable/). Use the
[in-development documentation](https://docs.sciml.ai/SymbolicUtils/dev/) for the version of
the documentation, which contains the unreleased features.

SymbolicUtils.jl provides various utilities for symbolic computing. SymbolicUtils.jl is what one would use to build
a Computer Algebra System (CAS). If you're looking for a complete CAS, similar to SymPy or Mathematica, see
[Symbolics.jl](https://github.com/JuliaSymbolics/Symbolics.jl). If you want to build a crazy CAS for your weird
Octonian algebras, you've come to the right place.

[Symbols in SymbolicUtils](https://docs.sciml.ai/SymbolicUtils/stable/#Creating-symbolic-expressions) carry type information. Operations on them propagate this information. [A rule-based rewriting language](https://docs.sciml.ai/SymbolicUtils/stable/manual/rewrite/) can be used to find subexpressions that satisfy arbitrary conditions and apply arbitrary transformations on the matches. The library also contains a set of useful [simplification](https://docs.sciml.ai/SymbolicUtils/stable/#Simplification) rules for expressions of numeric symbols and numbers. These can be remixed and extended for special purposes.

If you are a Julia package developer in need of a rule rewriting system for your own types, have a look at the [interfacing guide](https://docs.sciml.ai/SymbolicUtils/stable/manual/interface/#Interfacing-with-SymbolicUtils.jl).


### "I don't want to read your manual, just show me some cool code"
```julia
julia> using SymbolicUtils

julia> SymbolicUtils.show_simplified[] = true

julia> @syms x::Real y::Real z::Complex{Real} f(::Number)::Real
(x, y, z, f(::Number)::Real)

julia> 2x^2 - y + x^2
(3 * (x ^ 2)) + (-1 * y)

julia> f(sin(x)^2 + cos(x)^2) + z
f(1) + z

julia> r = @rule sinh(im * ~x) => sin(~x)
sinh(im * ~x) => sin(~x)

julia> r(sinh(im * y))
sin(y)

julia> simplify(cos(y)^2 + sinh(im*y)^2, RuleSet([r]))
1
```

# Citations

- The pattern matcher is an adaption of the one by Gerald Jay Sussman (as seen in [6.945](https://groups.csail.mit.edu/mac/users/gjs/6.945/) at MIT), his use of symbolic programming in the book [SICM](https://groups.csail.mit.edu/mac/users/gjs/6946/sicm-html/book.html) inspired this package.
- [Rewrite.jl](https://github.com/HarrisonGrodin/Rewrite.jl) and [Simplify.jl](https://github.com/HarrisonGrodin/Simplify.jl) by [Harrison Grodin](https://github.com/HarrisonGrodin) also inspired this package.

module Code

using StaticArraysCore, SparseArrays, LinearAlgebra, NaNMath, SpecialFunctions,
      DocStringExtensions

export toexpr, Assignment, (←), Let, Func, DestructuredArgs, LiteralExpr,
       SetArray, MakeArray, MakeSparseArray, MakeTuple, AtIndex,
       SpawnFetch, Multithreaded, ForLoop, cse,
       symFunc, symAssignment, symLet, symDestructuredArgs

export OptimizationRule, substitute_in_ir, apply_optimization_rules

import ..SymbolicUtils
import ..SymbolicUtils.Rewriters
import SymbolicUtils: @matchable, BasicSymbolic, Sym, Term, iscall, operation, arguments, issym,
                      symtype, sorted_arguments, metadata, isterm, term, maketerm, unwrap_const,
                      ArgsT, Const, SymVariant, _is_array_of_symbolics, _is_tuple_of_symbolics,
                      ArrayOp, isarrayop, IdxToAxesT, ROArgsT, shape, Unknown, ShapeVecT, BSImpl,
                      search_variables!, _is_index_variable, RangesT, IDXS_SYM, is_array_shape,
                      symtype, vartype, add_worker, search_variables!, @union_split_smallvec,
                      ArrayMaker, TypeT, ShapeT, SymReal, SafeReal, TreeReal, _unreachable, unwrap,
                      AddMulVariant, _isone, _iszero, Fill, IRStructure, populate_ir!, FnType,
                      ifelse_eager, ifelse_branching
using Moshi.Match: @match
import TaskLocalValues: TaskLocalValue
import SymbolicIndexingInterface: symbolic_type, NotSymbolic
import Graphs

##== state management ==##

struct NameState
    rewrites::Dict{Any, Any}
end
NameState() = NameState(Dict{Any, Any}())
function union_rewrites!(n, ts)
    for t in ts
        n[t] = Symbol(string(t)::String)
    end
end

struct LazyState
    ref::Ref{Any}
end
LazyState() = LazyState(Ref{Any}(nothing))

function Base.get(st::LazyState)
    s = getfield(st, :ref)[]
    s === nothing ? getfield(st, :ref)[] = NameState() : s
end

@inline Base.getproperty(st::LazyState, f::Symbol) = f==:symbolify ?  getproperty(st, :rewrites) : getproperty(get(st), f)

##========================##

"""
The rewrite key used in conjunction with [`SymbolicUtils.Code.with_allocator`](@ref) to
store user-provided allocators.
"""
const ALLOCATOR_REWRITES_KEY = :__internal_allocator

"""
    $TYPEDSIGNATURES

Get the allocator to use for a symbolic expression. If the rewrite rules contain
an entry for `ALLOCATOR_REWRITES_KEY`, will return that value and erase the rule
(since allocators cannot be reused). Otherwise, returns `default`.
"""
function get_allocator!(state::Union{NameState, LazyState}, @nospecialize(default))
    result = get(state.rewrites, ALLOCATOR_REWRITES_KEY, default)
    delete!(state.rewrites, ALLOCATOR_REWRITES_KEY)
    return result
end

function add_allocator!(state::Union{NameState, LazyState}, @nospecialize(alloc))
    old_allocator = get(state.rewrites, ALLOCATOR_REWRITES_KEY, nothing)
    state.rewrites[ALLOCATOR_REWRITES_KEY] = alloc
    return old_allocator
end

function reset_allocator!(state::Union{NameState, LazyState}, @nospecialize(old_alloc))
    state.rewrites[ALLOCATOR_REWRITES_KEY] = old_alloc
    return nothing
end

@noinline function throw_bad_allocator()
    throw(ArgumentError("`with_allocator` can only be used on `array_literal`, `@arrayop` and `@makearray` expressions."))
end

function supports_with_allocator(ex::BasicSymbolic{T}) where {T}
    return @match ex begin
        BSImpl.Term(; f) && if f === SymbolicUtils.array_literal end => true
        BSImpl.ArrayOp(; term, shape) => if term === nothing && is_array_shape(shape)
            true
        else
            @match term begin
                BSImpl.Term(; f) => f isa Fill
                _ => false
            end
        end
        BSImpl.ArrayMaker(;) => true
        _ => false
    end
end

"""
    $TYPEDSIGNATURES

Associate an allocating expression with an allocator. Expressions such as [`@arrayop`](@ref),
[`@makearray`](@ref), and [`SymbolicUtils.array_literal`](@ref) need to allocate an array
for their results. By default, the generated code will allocate an array using any method it
deems appropriate (such as `zeros`). To use a specific allocation method, or perhaps provide
a preallocated array of the appropriate size and `eltype`, `with_allocator` can be used.
The first argument is an allocator (API described below), and the second argument is
an expression which allocates an array. The array allocation will use the provided allocator.
Note that this only applies to immediate next allocation in `ex`. For example, an
`array_literal` containing an `@arrayop` has two allocations. `with_allocator` on the
outer `array_literal` will only control the allocation used for `array_literal`, and not
`@arrayop`. Each allocating expression needs its own `with_allocator`.

# Allocator API

The API for the allocator is relatively simple. It should be a callable accepting an
`NTuple{N, Int}` indicating the size of the required array, and returning an array of the
appropriate `eltype` and indicated size. The array should be mutable, allowing `setindex!`.

Note that the `eltype` of the array is not provided, and is the responsibility of the
allocator to identify. This is intentional, since figuring this out ahead of time can be
prohibitively expensive. For example, to obtain a value representing the `eltype` of an
`@arrayop` can require running the entire set of reduction loops. The `symtype` of the
expression is also typically very wide - it is usually a type like `Real` or `Number`. The
provider of the allocator typically has more information about the required `eltype`, since
they know how the expression is involved in the larger code, where the arguments come from,
and the concrete types of the buffers.
"""
function with_allocator(@nospecialize(alloc), ex::BasicSymbolic{T}) where {T}
    supports_with_allocator(ex) || throw_bad_allocator()

    return BSImpl.Term{T}(
        with_allocator, ArgsT{T}((BSImpl.Const{T}(alloc), ex));
        type = symtype(ex), shape = shape(ex)
    )
end

SymbolicUtils.scalarization_function(::typeof(with_allocator)) = _with_allocator_scalarize

function _with_allocator_scalarize(::typeof(with_allocator), ex::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    args = arguments(ex)
    return SymbolicUtils.scalarize(args[2], Val{toplevel}())
end

SymbolicUtils.promote_symtype(::typeof(with_allocator), ::TypeT, T::TypeT) = T
function SymbolicUtils.promote_shape(::typeof(with_allocator), _sh::ShapeT, sh::ShapeT)
    @nospecialize _sh sh
    return sh
end

abstract type CodegenPrimitive end

function manual_dispatch_toexpr(@nospecialize(x), st)
    if x isa BasicSymbolic{SymReal}
        toexpr(x, st)
    elseif x isa Vector{BasicSymbolic{SymReal}}
        toexpr(x, st)
    elseif x isa Matrix{BasicSymbolic{SymReal}}
        toexpr(x, st)
    elseif x isa Symbol
        toexpr(x, st)
    elseif x isa Expr
        toexpr(x, st)
    elseif x isa Let
        toexpr(x, st)
    elseif x isa Assignment
        toexpr(x, st)
    elseif x isa DestructuredArgs
        toexpr(x, st)
    elseif x isa MakeArray
        toexpr(x, st)
    elseif x isa SetArray
        toexpr(x, st)
    elseif x isa SetArray
        toexpr(x, st)
    else
        toexpr(x, st)
    end
end

"""
    toexpr(ex, [st,])

Convert a symbolic expression into an `Expr`, suitable to be passed into `eval`.

For example,

```julia-repl
julia> @syms a b
(a, b)

julia> toexpr(a+b)
:((+)(a, b))

julia> toexpr(a+b) |> dump
Expr
  head: Symbol call
  args: Array{Any}((3,))
    1: + (function of type typeof(+))
    2: Symbol a
    3: Symbol b
```

Note that the function is an actual function object.

For more complex expressions, see other code-related combinators,

Namely `Assignment`, `Let`, `Func`, `SetArray`, `MakeArray`, `MakeSparseArray` and
`MakeTuple`.

To make your own type convertible to Expr using `toexpr` define `toexpr(x, st)` and
forward the state `st` in internal calls to `toexpr`. `st` is state used to know
when to leave something like `y(t)` as it is or when to make it `var"y(t)"`. E.g.
when `y(t)` is itself the argument of a function rather than `y`.

"""
toexpr(x) = toexpr(x, LazyState())

@matchable struct Assignment <: CodegenPrimitive
    lhs
    rhs
end

"""
    Assignment(lhs, rhs)

An assignment expression. Shorthand `lhs ← rhs` (`\\leftarrow`)
"""
Assignment

function search_variables!(buffer, asg::Assignment; kw...)
    lhs = asg.lhs
    rhs = asg.rhs
    if lhs isa BasicSymbolic{SymReal}
        search_variables!(buffer, lhs; kw...)
    elseif lhs isa BasicSymbolic{SafeReal}
        search_variables!(buffer, lhs; kw...)
    elseif lhs isa BasicSymbolic{TreeReal}
        search_variables!(buffer, lhs; kw...)
    elseif lhs isa Symbol
    else
        search_variables!(buffer, lhs; kw...)
    end
    if rhs isa BasicSymbolic{SymReal}
        search_variables!(buffer, rhs; kw...)
    elseif rhs isa BasicSymbolic{SafeReal}
        search_variables!(buffer, rhs; kw...)
    elseif rhs isa BasicSymbolic{TreeReal}
        search_variables!(buffer, rhs; kw...)
    elseif rhs isa Vector{BasicSymbolic{SymReal}}
        search_variables!(buffer, rhs; kw...)
    elseif rhs isa Vector{BasicSymbolic{SafeReal}}
        search_variables!(buffer, rhs; kw...)
    elseif rhs isa Vector{BasicSymbolic{TreeReal}}
        search_variables!(buffer, rhs; kw...)
    elseif rhs isa Matrix{BasicSymbolic{SymReal}}
        search_variables!(buffer, rhs; kw...)
    elseif rhs isa Matrix{BasicSymbolic{SafeReal}}
        search_variables!(buffer, rhs; kw...)
    elseif rhs isa Matrix{BasicSymbolic{TreeReal}}
        search_variables!(buffer, rhs; kw...)
    elseif rhs isa Symbol
    else
        search_variables!(buffer, rhs; kw...)
    end
end

lhs(a::Assignment) = a.lhs
rhs(a::Assignment) = a.rhs

const (←) = Assignment

Base.convert(::Type{Assignment}, p::Pair) = Assignment(pair[1], pair[2])

function toexpr(a::Assignment, st)
    return Expr(:(=), manual_dispatch_toexpr(a.lhs, st), manual_dispatch_toexpr(a.rhs, st))
end

const NaNMathFuns = (
    sin,
    cos,
    tan,
    asin,
    acos,
    acosh,
    atanh,
    log,
    log2,
    log10,
    lgamma,
    log1p,
    sqrt,
)

function function_to_expr_no_nanmath(@nospecialize(op), O::BasicSymbolic{T}, st) where {T}
    expr = Expr(:call)
    if op isa BasicSymbolic{T}
        push!(expr.args, manual_dispatch_toexpr(op, st))
    else
        push!(expr.args, op)
    end
    args = parent(arguments(O))
    @union_split_smallvec args for arg in args
        push!(expr.args, toexpr(arg, st))
    end
    return expr
end

function function_to_expr(@nospecialize(op), O, st)
    # Avoid using `op in NaNMathFuns` since that is dynamic dispatch.
    # Also avoid using `nameof(op)` for the same reason.
    if !get(st.rewrites, :nanmath, false)::Bool
        return function_to_expr_no_nanmath(op, O, st)
    elseif op === sin
        name = :sin
    elseif op === cos
        name = :cos
    elseif op === tan
        name = :tan
    elseif op === asin
        name = :asin
    elseif op === acos
        name = :acos
    elseif op === acosh
        name = :acosh
    elseif op === atanh
        name = :atanh
    elseif op === log
        name = :log
    elseif op === log2
        name = :log2
    elseif op === log10
        name = :log10
    elseif op === lgamma
        name = :lgamma
    elseif op === log1p
        name = :log1p
    elseif op === sqrt
        name = :sqrt
    else
        return function_to_expr_no_nanmath(op, O, st)
    end
    fun = GlobalRef(NaNMath, name)
    return function_to_expr_no_nanmath(fun, O, st)
end

function function_to_expr(@nospecialize(op::SymbolicUtils.Mapper), O, st)
    out = get(st.rewrites, O, nothing)
    out === nothing || return out
    expr = Expr(:call, map)
    push!(expr.args, toexpr(op.f, st))
    for arg in arguments(O)
        push!(expr.args, toexpr(arg, st))
    end
    return expr
end

function function_to_expr(@nospecialize(op::SymbolicUtils.Mapreducer), O, st)
    out = get(st.rewrites, O, nothing)
    out === nothing || return out
    expr = Expr(:call, mapreduce)
    kws = Expr(:parameters)
    if op.dims isa Int
        push!(kws.args, Expr(:kw, :dims, op.dims))
    end
    if op.init !== nothing
        push!(kws.args, Expr(:kw, :init, toexpr(op.init, st)))
    end
    if !isempty(kws.args)
        push!(expr.args, kws)
    end
    push!(expr.args, op.f)
    push!(expr.args, op.reduce)
    for arg in arguments(O)
        push!(expr.args, toexpr(arg, st))
    end
    return expr
end

const ARRAY_OUTSYM = Symbol("_out")

function function_to_expr(::typeof(getindex), O::BasicSymbolic{T}, st) where {T}
    out = get(st.rewrites, O, nothing)
    out === nothing || return out

    args = arguments(O)
    if issym(args[1]) && nameof(args[1]) == IDXS_SYM
        @assert length(args) == 2
        return Symbol(:_, unwrap_const(args[2]))
    end
    args = map(Base.Fix2(toexpr, st), arguments(O))
    expr = Expr(:call, getindex)
    append!(expr.args, args)
    return expr
end

function function_to_expr(::Type{ArrayOp{T}}, O::BasicSymbolic{T}, st) where {T}
    out = get(st.rewrites, O, nothing)
    out === nothing || return out

    # TODO: better infer default eltype from `O`
    _allocator = get_allocator!(st, nothing)

    output_eltype = get(st.rewrites, :arrayop_eltype, Float64)
    delete!(st.rewrites, :arrayop_eltype)
    sh = shape(O)
    default_output_buffer = if is_array_shape(sh)
        if _allocator === nothing
            term(zeros, output_eltype, size(O))
        else
            @match _allocator begin
                if _allocator isa BasicSymbolic{T} end && BSImpl.Const(; val) => term(val, size(O))
                _ => term(_allocator, size(O))
            end
        end
    else
        term(zero, output_eltype)
    end
    output_buffer = get(st.rewrites, :arrayop_output, default_output_buffer)
    delete!(st.rewrites, :arrayop_output)
    return toexpr(
        Let(
            [
                Assignment(ARRAY_OUTSYM, output_buffer),
            ], Let([Assignment(Symbol("%$ARRAY_OUTSYM"), inplace_expr(O, ARRAY_OUTSYM))], ARRAY_OUTSYM, false),
            true
        ), st
    )
end

function unidealize_indices(expr::BasicSymbolic{T}, ranges, new_ranges) where {T}
    iscall(expr) || return expr
    op = operation(expr)
    args = arguments(expr)
    if op !== getindex
        for i in eachindex(args)
            arg = unidealize_indices(args[i], ranges, new_ranges)
            isequal(arg, args[i]) && continue
            if args isa ROArgsT
                args = copy(parent(args))
            end
            args[i] = arg
        end
        args isa ROArgsT && return expr
        return maketerm(typeof(expr), op, args, nothing)
    end

    arr = first(args)
    sh = shape(arr)
    sh isa Unknown && return expr
    sh = sh::ShapeVecT

    for i in eachindex(sh)
        ax = sh[i]
        idx = args[i + 1]
        vars = Set{BasicSymbolic{T}}()
        search_variables!(vars, idx; is_atomic = _is_index_variable)
        length(vars) == 1 || continue
        idxvar = only(vars)
        haskey(ranges, idxvar) && continue
        new_ranges[idxvar] = 1:length(ax)
        first(ax) == 1 && continue

        if args isa ROArgsT
            args = copy(parent(args))
        end
        args[i + 1] = idx - (first(ax) - 1)
    end
    args isa ROArgsT && return expr
    return maketerm(typeof(expr), getindex, args, nothing)
end

function inplace_expr(x::BasicSymbolic{T}, outsym) where {T}
    # TODO:
    # if x.term !== nothing
    #     ex = inplace_builtin(x.term, outsym)
    #     if ex !== nothing
    #         return ex
    #     end
    # end
    if outsym isa Symbol
        outsym = Sym{T}(outsym; type = Any, shape = Unknown(-1))
    end
    sh = shape(x)
    ranges = x.ranges
    new_ranges = RangesT{T}()
    new_expr = unidealize_indices(x.expr, ranges, new_ranges)
    loopvar_order = unique!(filter(x -> x isa BasicSymbolic{T}, vcat(reverse(x.output_idx), collect(keys(ranges)), collect(keys(new_ranges)))))

    if is_array_shape(sh)
        inner_expr = SetArray(false, outsym, [AtIndex(term(CartesianIndex, x.output_idx...), term(x.reduce, term(getindex, outsym, x.output_idx...), new_expr))])
    else
        inner_expr = Assignment(outsym, term(x.reduce, outsym, new_expr))
    end
    merge!(new_ranges, ranges)
    loops = foldl(reverse(loopvar_order), init=inner_expr) do acc, k
        ForLoop(k, new_ranges[k], acc)
    end

    return loops
end

function function_to_expr(::Type{ArrayMaker{T}}, O::BasicSymbolic{T}, st) where {T}
    out = get(st.rewrites, O, nothing)
    out === nothing || return out

    _allocator = get_allocator!(st, nothing)
    # TODO: better infer default eltype from `O`
    output_eltype = get(st.rewrites, :arraymaker_eltype, Float64)
    delete!(st.rewrites, :arraymaker_eltype)
    sh = shape(O)
    default_output_buffer = if _allocator === nothing
        term(zeros, output_eltype, size(O))
    else
        term(_allocator, size(O))
    end
    output_buffer = get(st.rewrites, :arraymaker_output, default_output_buffer)
    delete!(st.rewrites, :arraymaker_output)
    ir = Assignment[]
    regions, values = @match O begin
        BSImpl.ArrayMaker(; regions, values) => (regions, values)
    end
    @union_split_smallvec regions @union_split_smallvec values begin
        for (region, val) in zip(regions, values)
            args = ArgsT{T}((ARRAY_OUTSYM,))
            # `append!`  doesn't convert on 1.10
            @union_split_smallvec region for reg in region
                push!(args, BSImpl.Const{T}(reg))
            end
            vw = BSImpl.Term{T}(view, args; type = Any)
            @match val begin
                BSImpl.ArrayOp(;) => begin
                    st.rewrites[:arrayop_output] = vw
                    push!(ir, Assignment(Symbol("__tmp_ₐ"), toexpr(val, st)))
                end
                BSImpl.ArrayMaker(;) => begin
                    st.rewrites[:arraymaker_output] = vw
                    push!(ir, Assignment(Symbol("__tmp_ₐ"), toexpr(val, st)))
                end
                _ => begin
                    push!(ir, Assignment(Symbol("__tmp_ₐ"), :($copyto!($view($ARRAY_OUTSYM, $(region...)), $(toexpr(val, st))))))
                end
            end
        end
    end
    return toexpr(Let([Assignment(ARRAY_OUTSYM, output_buffer)], Let(ir, ARRAY_OUTSYM, false), true), st)
end

function function_to_expr(::typeof(SymbolicUtils.array_literal), O::BasicSymbolic{T}, st) where {T}
    _allocator = get_allocator!(st, nothing)
    if _allocator === nothing
        return function_to_expr_no_nanmath(SymbolicUtils.array_literal, O, st)
    end
    expr = Expr(:block)
    if _allocator isa BasicSymbolic{T}
        push!(expr.args, Expr(:(=), :__array_literal_allocator, toexpr(_allocator, st)))
    else
        push!(expr.args, Expr(:(=), :__array_literal_allocator, _allocator))
    end
    args = parent(arguments(O))
    push!(expr.args, Expr(:(=), :__array_literal_result, Expr(:call, :__array_literal_allocator, unwrap_const(args[1]))))
    @union_split_smallvec args for (idx, arg) in enumerate(Iterators.drop(args, 1))
        push!(expr.args, Expr(:call, setindex!, :__array_literal_result, toexpr(arg, st), idx))
    end
    push!(expr.args, :__array_literal_result)
    return expr
end

function function_to_expr(@nospecialize(op::Union{typeof(*),typeof(+)}), O, st)
    out = get(st.rewrites, O, nothing)
    out === nothing || return out
    if get(st.rewrites, :sort_addmul, true)::Bool
        args = parent(sorted_arguments(O))
    else
        args = parent(arguments(O))
    end

    if length(args) == 1
        return Expr(:call, op, toexpr(args[1], st))
    end
    if symtype(O) <: Number
        cur = Expr(:call, op, toexpr(args[1], st), toexpr(args[2], st))
        for i in 3:length(args)
            cur = Expr(:call, op, cur, toexpr(args[i], st))
        end
        return cur
    else
        expr = Expr(:call, op)
        @union_split_smallvec args for arg in args
            push!(expr.args, toexpr(arg, st))
        end
        return expr
    end
end

function function_to_expr(op::typeof(^), O::BasicSymbolic{T}, st) where {T}
    base, exp = arguments(O)
    base = toexpr(base, st)
    @match exp begin
        BSImpl.Const(; val) => begin
            if val isa Real
                if _isone(val)
                    return toexpr(base, st)
                end
                if _isone(-val)
                    return Expr(:call, inv, base)
                end
                if (val < 0)::Bool
                    val = -val
                    base = Expr(:call, inv, base)
                end
                if !(val isa Integer) && get(st.rewrites, :nanmath, false)::Bool
                    op = NaNMath.pow
                end
            end
            return Expr(:call, op, base, val)
        end
        _ => begin
            sT = symtype(exp)
            if get(st.rewrites, :nanmath, false)::Bool
                return Expr(:call, NaNMath.pow, base, toexpr(exp, st))
            else
                return Expr(:call, ^, base, toexpr(exp, st))
            end
        end
    end
end

function function_to_expr(::typeof(ifelse), O, st)
    args = arguments(O)
    return Expr(:if, toexpr(args[1], st), toexpr(args[2], st), toexpr(args[3], st))
end

# `ifelse_branching` lowers to an `if`/`else` (only the taken branch is evaluated). `toexpr`
# inlines recursively, so this slow path is naturally lazy. `ifelse_eager` needs no special
# handling: it is a registered function whose definition calls `ifelse`, so the generic
# `function_to_expr` fallback lowers it to a plain (eager) call.
function function_to_expr(::typeof(ifelse_branching), O, st)
    args = arguments(O)
    return Expr(:if, toexpr(args[1], st), toexpr(args[2], st), toexpr(args[3], st))
end

toexpr(O::Expr, st) = O

function substitute_name(O, st)
    if (issym(O) || iscall(O)) && haskey(st.rewrites, O)
        st.rewrites[O]
    else
        O
    end
end

function toexpr(O, st)
    u = unwrap(O)
    if u !== O
        return toexpr(u, st)
    elseif _is_array_of_symbolics(O)
        return issparse(O) ? toexpr(MakeSparseArray(O), st) : toexpr(MakeArray(O, typeof(O)), st)
    else
        return O
    end
end

function toexpr(O::BasicSymbolic{T}, st) where {T}
    @match O begin
        BSImpl.Const(;) => nothing # Constants should not be rewritten; they are literal values.
        _ => begin
            rw = get(st.rewrites, O, nothing)
            if rw !== nothing
                O = rw
                if !(O isa BasicSymbolic{T})
                    return manual_dispatch_toexpr(O, st)
                end
            end
        end
    end
    O = O::BasicSymbolic{T}
    @match O begin
        BSImpl.Const(; val) => if val isa CodegenPrimitive
            return manual_dispatch_toexpr(val, st)
        else
            return val
        end
        BSImpl.Sym(; name) => return name
        BSImpl.ArrayOp(; term) => if term isa BasicSymbolic{T}
            return toexpr(term, st)
        else
            return function_to_expr(ArrayOp{T}, O, st)
        end
        BSImpl.ArrayMaker(;) => return function_to_expr(ArrayMaker{T}, O, st)
        BSImpl.Term(; f, args) => begin
            if f === (^)
                return function_to_expr((^), O, st)
            elseif f === ifelse
                return function_to_expr(ifelse, O, st)
            elseif f === SymbolicUtils.array_literal
                return function_to_expr(SymbolicUtils.array_literal, O, st)
            elseif f === with_allocator
                old_allocator = add_allocator!(st, args[1])
                result = toexpr(args[2], st)
                reset_allocator!(st, old_allocator)
                return result
            else
                return function_to_expr(f, O, st)
            end
        end
        BSImpl.Div(; num, den) => begin
            return Expr(:call, /, toexpr(num, st), toexpr(den, st))
        end
        BSImpl.AddMul(; variant) => if variant === AddMulVariant.ADD
            return function_to_expr((+), O, st)
        else
            return function_to_expr((*), O, st)
        end
    end
end

# Call elements of vector arguments by their name.
@matchable struct DestructuredArgs <: CodegenPrimitive
    elems
    inds
    name
    inbounds::Bool
    create_bindings::Bool
end

function DestructuredArgs(elems, name=nothing; inds=eachindex(elems), inbounds=false, create_bindings=true)
    if name === nothing
        # I'm sorry if you get a hash collision here lol
        name = Symbol("##arg#", hash((elems, inds, inbounds, create_bindings)))
    end
    DestructuredArgs(elems, inds, name, inbounds, create_bindings)
end

"""
    DestructuredArgs(elems, [name=gensym("arg")])

`elems` is a vector of symbols or call expressions.  When it appears as an argument in
`Func`, it expects a vector of the same length and de-structures the vector into its named
components. See example in `Func` for more information.

`name` is the name to be used for the argument in the generated function Expr.
"""
DestructuredArgs

function search_variables!(buffer, dargs::DestructuredArgs; kw...)
    elems = dargs.elems
    if elems isa Vector{BasicSymbolic{SymReal}}
        search_variables!(buffer, elems; kw...)
    elseif elems isa Vector{BasicSymbolic{SafeReal}}
        search_variables!(buffer, elems; kw...)
    elseif elems isa Vector{BasicSymbolic{TreeReal}}
        search_variables!(buffer, elems; kw...)
    else
        search_variables!(buffer, elems; kw...)
    end
end

toexpr(x::DestructuredArgs, st) = toexpr(x.name, st)
get_rewrites(args::DestructuredArgs) = []
function get_rewrites(args::Union{AbstractArray, Tuple})
    rws = []
    for arg in args
        append!(rws, get_rewrites(arg))
    end
    return rws
end
get_rewrites(x) = []
get_rewrites(x::BasicSymbolic) = iscall(x) ? Any[x] : []

# Used in Symbolics
Base.@deprecate_binding get_symbolify get_rewrites

@inline function destructured_elem_expr(@nospecialize(name), @nospecialize(idx))
    if idx isa Symbol
        return Expr(:., name, QuoteNode(idx))
    else
        return Expr(:ref, name, idx)
    end
end

function get_assignments(d::DestructuredArgs, st)
    name = manual_dispatch_toexpr(d, st)
    n = length(d.inds)::Int
    assigns = Vector{Assignment}(undef, n)
    for i in 1:n
        ex = destructured_elem_expr(name, d.inds[i])
        if d.inbounds && d.create_bindings
            ex = Expr(:macrocall, Symbol("@inbounds"), LineNumberNode(0), ex)
        end
        assigns[i] = Assignment(d.elems[i], ex)
    end
    return assigns
end

@matchable struct Let <: CodegenPrimitive
    pairs::Vector{Union{Assignment,DestructuredArgs}} # an iterator of pairs, ordered
    body
    let_block::Bool
end

"""
    Let(assignments, body[, let_block])

A Let block.

- `assignments` is a vector of `Assignment`s
- `body` is the body of the let block
- `let_block` boolean (default=true) -- do not create a let block if false.
"""
Let(assignments, body) = Let(assignments, body, true)

function search_variables!(buffer, l::Let; kw...)
    lhsbuf = empty(buffer)
    rhsbuf = empty(buffer)
    for elem in l.pairs
        if elem isa Assignment
            lhs = elem.lhs
            rhs = elem.rhs
            if lhs isa BasicSymbolic{SymReal}
                search_variables!(lhsbuf, lhs; kw...)
            elseif lhs isa BasicSymbolic{SafeReal}
                search_variables!(lhsbuf, lhs; kw...)
            elseif lhs isa BasicSymbolic{TreeReal}
                search_variables!(lhsbuf, lhs; kw...)
            elseif lhs isa Symbol
            else
                search_variables!(lhsbuf, lhs; kw...)
            end
            if rhs isa BasicSymbolic{SymReal}
                search_variables!(rhsbuf, rhs; kw...)
            elseif rhs isa BasicSymbolic{SafeReal}
                search_variables!(rhsbuf, rhs; kw...)
            elseif rhs isa BasicSymbolic{TreeReal}
                search_variables!(rhsbuf, rhs; kw...)
            elseif rhs isa Vector{BasicSymbolic{SymReal}}
                search_variables!(rhsbuf, rhs; kw...)
            elseif rhs isa Vector{BasicSymbolic{SafeReal}}
                search_variables!(rhsbuf, rhs; kw...)
            elseif rhs isa Vector{BasicSymbolic{TreeReal}}
                search_variables!(rhsbuf, rhs; kw...)
            elseif rhs isa Matrix{BasicSymbolic{SymReal}}
                search_variables!(rhsbuf, rhs; kw...)
            elseif rhs isa Matrix{BasicSymbolic{SafeReal}}
                search_variables!(rhsbuf, rhs; kw...)
            elseif rhs isa Matrix{BasicSymbolic{TreeReal}}
                search_variables!(rhsbuf, rhs; kw...)
            elseif rhs isa Symbol
            else
                search_variables!(rhsbuf, rhs; kw...)
            end
        else
            search_variables!(rhsbuf, elem; kw...)
        end
    end
    setdiff!(rhsbuf, lhsbuf)
    union!(buffer, rhsbuf)
end

@inline function store_rewrite!(rewrites::Dict{Any, Any}, @nospecialize(key), @nospecialize(val))
    if key isa BasicSymbolic{SymReal}
        rewrites[key] = val
    elseif key isa BasicSymbolic{SafeReal}
        rewrites[key] = val
    elseif key isa BasicSymbolic{TreeReal}
        rewrites[key] = val
    else
        rewrites[key] = val
    end
    return nothing
end

"""
    $TYPEDEF

Cache entry for [`store_destructuring_rewrites!`](@ref). Holds strong references to the
`elems` and `inds` of the `DestructuredArgs` it was created from so that the `objectid`s
used in the cache key cannot be recycled while the entry is alive.
"""
struct DestructuringRewrites
    elems::Any
    inds::Any
    exprs::Vector{Expr}
end

const DESTRUCTURING_REWRITES_CACHE = TaskLocalValue{Dict{Tuple{Any, UInt, UInt}, DestructuringRewrites}}(
    () -> Dict{Tuple{Any, UInt, UInt}, DestructuringRewrites}())

const DESTRUCTURING_MARKER = :__destructuring_rewrites_marker

# `sizehint!`'s `shrink` keyword was added in Julia 1.11.
@static if VERSION >= v"1.11"
    _sizehint_noshrink!(d, n) = sizehint!(d, n; shrink = false)
else
    _sizehint_noshrink!(d, n) = sizehint!(d, n)
end

"""
    $TYPEDSIGNATURES

Store the rewrites for a `create_bindings = false` `DestructuredArgs` directly into
`st.rewrites` without materializing the `Vector{Assignment}` that
[`get_assignments`](@ref) would allocate.

The generated right-hand-side `Expr`s depend only on the destructured name, `elems` and
`inds`, so they are memoized in a task-local cache. Codegen for a system with many
functions destructures the same (shared, `===`) parameter buffers once per generated
function; the cache turns every repeat into a lookup instead of `length(inds)` fresh
`Expr` allocations.
"""
function store_destructuring_rewrites!(d::DestructuredArgs, st)
    name = manual_dispatch_toexpr(d, st)
    n = length(d.inds)::Int
    elems = d.elems
    key = (name, objectid(elems), objectid(d.inds))
    # `Symbolics.codegen_function` generates the out-of-place and in-place variants with
    # the same `rewrites` dict. The rewrites this function stores depend only on `key`,
    # so mark the dict and skip the (identical) re-population on the second call.
    marker = (DESTRUCTURING_MARKER, key)
    len_before = length(st.rewrites)
    get!(st.rewrites, marker, true)
    length(st.rewrites) == len_before && return nothing

    cache = DESTRUCTURING_REWRITES_CACHE[]
    entry = get(cache, key, nothing)
    if entry === nothing
        exprs = Vector{Expr}(undef, n)
        for i in 1:n
            exprs[i] = destructured_elem_expr(name, d.inds[i])
        end
        # crude bound to avoid unbounded growth over a long session
        length(cache) > 10_000 && empty!(cache)
        cache[key] = DestructuringRewrites(elems, d.inds, exprs)
    else
        exprs = entry.exprs
    end
    _sizehint_noshrink!(st.rewrites, length(st.rewrites) + n)
    for i in 1:n
        store_rewrite!(st.rewrites, elems[i], exprs[i])
    end
    return nothing
end

function handle_let_pair!(dargs::Vector{Assignment}, x::Union{DestructuredArgs, Assignment}, st)
    if x isa DestructuredArgs
        if x.create_bindings
            for a in get_assignments(x, st)
                handle_let_pair!(dargs, a, st)
            end
        else
            store_destructuring_rewrites!(x, st)
        end
    elseif x isa Assignment
        lhs = x.lhs
        if lhs isa DestructuredArgs
            if lhs.create_bindings
                handle_let_pair!(dargs, Assignment(lhs.name, x.rhs), st)
                for a in get_assignments(lhs, st)
                    handle_let_pair!(dargs, a, st)
                end
            else
                handle_let_pair!(dargs, Assignment(lhs.name, x.rhs), st)
                store_destructuring_rewrites!(lhs, st)
            end
        else
            push!(dargs, x)
        end
    else
        _unreachable()
    end
end

function toexpr(l::Let, st)
    if all(x->x isa Assignment && !(x.lhs isa DestructuredArgs), l.pairs)
        dargs = Vector{Assignment}(l.pairs)
    else
        dargs = Assignment[]
        for x in l.pairs
            handle_let_pair!(dargs, x, st)
        end
    end

    bindings = Expr(:block)
    for asg in dargs
        union_rewrites!(st.rewrites, get_rewrites(asg.lhs))
        push!(bindings.args, toexpr(asg, st))
    end

    if l.let_block
        return Expr(:let, bindings, manual_dispatch_toexpr(l.body, st))
    end
    isempty(bindings.args) && return manual_dispatch_toexpr(l.body, st)
    push!(bindings.args, manual_dispatch_toexpr(l.body, st))
    return bindings
end

@matchable struct Func <: CodegenPrimitive
    args::Vector{Any}
    kwargs::Vector{Assignment}
    body
    pre::Vector{Any}
end

function search_variables!(buffer, f::Func; kw...)
    search_variables!(buffer, f.args; kw...)
    search_variables!(buffer, f.kwargs; kw...)
    body = f.body
    if body isa BasicSymbolic{SymReal}
        search_variables!(buffer, body; kw...)
    elseif body isa BasicSymbolic{SafeReal}
        search_variables!(buffer, body; kw...)
    elseif body isa BasicSymbolic{TreeReal}
        search_variables!(buffer, body; kw...)
    elseif body isa Vector{BasicSymbolic{SymReal}}
        search_variables!(buffer, body; kw...)
    elseif body isa Vector{BasicSymbolic{SafeReal}}
        search_variables!(buffer, body; kw...)
    elseif body isa Vector{BasicSymbolic{TreeReal}}
        search_variables!(buffer, body; kw...)
    elseif body isa Matrix{BasicSymbolic{SymReal}}
        search_variables!(buffer, body; kw...)
    elseif body isa Matrix{BasicSymbolic{SafeReal}}
        search_variables!(buffer, body; kw...)
    elseif body isa Matrix{BasicSymbolic{TreeReal}}
        search_variables!(buffer, body; kw...)
    elseif body isa Let
        search_variables!(buffer, body; kw...)
    elseif body isa Symbol
    else
        search_variables!(buffer, body; kw...)
    end
end

Func(args, kwargs, body) = Func(args, kwargs, body, Assignment[])

"""
    Func(args, kwargs, body[, pre])

A function.

- `args` is a vector of expressions
- `kwargs` is a vector of `Assignment`s
- `body` is the body of the function
- `pre` a vector of expressions to be prepended to the function body,
   for example, it could be `[Expr(:meta, :inline), Expr(:meta, :propagate_inbounds)]`
   to create an `@inline @propagate_inbounds` function definition.

**Special features in `args`**:

- args can contain `DestructuredArgs`
- call expressions

For example,

```julia-repl
julia> @syms a b c t f(d) x(t) y(t) z(t)
(a, b, c, t, f(::Number)::Number, x(::Number)::Number, y(::Number)::Number, z(::Number)::Number)

julia> func = Func([a,x(t), DestructuredArgs([b, y(t)]), f], # args
                   [c ← 2, z(t) ← 42], # kwargs
                   f((a + b + c) / x(t) + y(t) + z(t)));

julia> toexpr(func)
:(function (a, var"x(t)", var"##arg#255", f; c = 2, var"z(t)" = 42)
      let b = var"##arg#255"[1], var"y(t)" = var"##arg#255"[2]
          f((+)(var"y(t)", var"z(t)", (*)((+)(a, b, c), (inv)(var"x(t)"))))
      end
  end)
```

- the second argument is a `DestructuredArgs`, in the `Expr` form, it is given a random name, and is expected to receive a vector or tuple of size 2 containing the values of `b` and `y(t)`. The let block that is automatically generated "destructures" these arguments.
- `x(t)` and `y(t)` have been replaced with `var"x(t)"` and `var"y(t)"` symbols throughout
  the generated Expr. This makes sure that we are not actually calling the expressions `x(t)` or `y(t)` but instead passing the right values in place of the whole expression.
- `f` is also a function-like symbol, same as `x` and `y`, but since the `args` array contains `f` as itself rather than as say, `f(t)`, it does not become a `var"f(t)"`. The generated function expects a function of one argument to be passed in the position of `f`.

An example invocation of this function is:

```julia-repl
julia> executable = eval(toexpr(func))
#10 (generic function with 1 method)

julia> executable(1, 2.0, [2,3.0], x->string(x); var"z(t)" = sqrt(42))
"11.98074069840786"
```
"""
Func

include("symbolic_codegen_primitives.jl")

toexpr_kw(f, st) = Expr(:kw, toexpr(f, st).args...)

function toexpr(f::Func, st)
    for arg in f.args
        union_rewrites!(st.rewrites, get_rewrites(arg))
    end
    for arg in f.kwargs
        union_rewrites!(st.rewrites, get_rewrites(arg.lhs))
    end
    dargs = Union{Assignment, DestructuredArgs}[]
    for arg in f.args
        if arg isa DestructuredArgs
            push!(dargs, arg)
        end
    end
    body = manual_dispatch_toexpr(Let(dargs, f.body, false), st)
    fn_args = Expr(:tuple)
    if !isempty(f.kwargs)
        fn_kws = Expr(:parameters)
        for asg in f.kwargs
            asg_expr = toexpr(asg, st)
            push!(fn_kws.args, Expr(:kw, asg_expr.args[1], asg_expr.args[2]))
        end
        push!(fn_args.args, fn_kws)
    end
    for arg in f.args
        push!(fn_args.args, manual_dispatch_toexpr(arg, st))
    end
    fn_body = Expr(:block)
    append!(fn_body.args, f.pre)
    push!(fn_body.args, body)
    return Expr(:function, fn_args, fn_body)
end

@matchable struct SetArray <: CodegenPrimitive
    inbounds::Bool
    arr
    elems  # Either iterator of Pairs or just an iterator
    return_arr::Bool
end

"""
    SetArray(inbounds::Bool, arr, elems[, return_arr::Bool])

An expression representing setting of elements of `arr`.

By default, every element of `elems` is copied over to `arr`,

but if `elems` contains `AtIndex(i, val)` objects, then `arr[i] = val`
is performed in its place.

`inbounds` is a boolean flag, `true` surrounds the resulting expression
in an `@inbounds`.

`return_arr` is a flag which controls whether the generated `begin..end` block
returns the `arr`. Defaults to `false`, in which case the block returns `nothing`.
"""
SetArray

SetArray(inbounds, arr, elems) = SetArray(inbounds, arr, elems, false)

function search_variables!(buffer, sa::SetArray; kw...)
    body = sa.arr
    if body isa BasicSymbolic{SymReal}
        search_variables!(buffer, body; kw...)
    elseif body isa BasicSymbolic{SafeReal}
        search_variables!(buffer, body; kw...)
    elseif body isa BasicSymbolic{TreeReal}
        search_variables!(buffer, body; kw...)
    elseif body isa Symbol
    else
        search_variables!(buffer, body; kw...)
    end
    elems = sa.elems
    if elems isa Vector{AtIndex}
        search_variables!(buffer, elems; kw...)
    else
        search_variables!(buffer, elems; kw...)
    end
end

@matchable struct AtIndex <: CodegenPrimitive
    i
    elem
end

function search_variables!(buffer, ai::AtIndex; kw...)
    i = ai.i
    elem = ai.elem
    if i isa BasicSymbolic{SymReal}
        search_variables!(buffer, i; kw...)
    elseif i isa BasicSymbolic{SafeReal}
        search_variables!(buffer, i; kw...)
    elseif i isa BasicSymbolic{TreeReal}
        search_variables!(buffer, i; kw...)
    elseif i isa CartesianIndex
    elseif i isa Integer
    elseif i isa Symbol
    else
        search_variables!(buffer, i; kw...)
    end
    if elem isa BasicSymbolic{SymReal}
        search_variables!(buffer, elem; kw...)
    elseif elem isa BasicSymbolic{SafeReal}
        search_variables!(buffer, elem; kw...)
    elseif elem isa BasicSymbolic{TreeReal}
        search_variables!(buffer, elem; kw...)
    elseif elem isa Symbol
    else
        search_variables!(buffer, elem; kw...)
    end
end

function toexpr(a::AtIndex, st)
    toexpr(a.elem, st)
end

function toexpr(s::SetArray, st)
    ex = quote
        $([:($(toexpr(s.arr, st))[$(ex isa AtIndex ? toexpr(ex.i, st) : i)] = $(toexpr(ex, st)))
           for (i, ex) in enumerate(s.elems)]...)
        $(s.return_arr ? toexpr(s.arr, st) : nothing)
    end
    s.inbounds ? :(@inbounds $ex) : ex
end

@matchable struct MakeArray <: CodegenPrimitive
    elems
    similarto # Must be either a reference to an array or a concrete type
    output_eltype
end

function search_variables!(buffer, ma::MakeArray; kw...)
    elems = ma.elems
    if elems isa Vector{BasicSymbolic{SymReal}}
        search_variables!(buffer, elems; kw...)
    elseif elems isa Vector{BasicSymbolic{SafeReal}}
        search_variables!(buffer, elems; kw...)
    elseif elems isa Vector{BasicSymbolic{TreeReal}}
        search_variables!(buffer, elems; kw...)
    elseif elems isa Matrix{BasicSymbolic{SymReal}}
        search_variables!(buffer, elems; kw...)
    elseif elems isa Matrix{BasicSymbolic{SafeReal}}
        search_variables!(buffer, elems; kw...)
    elseif elems isa Matrix{BasicSymbolic{TreeReal}}
        search_variables!(buffer, elems; kw...)
    else
        search_variables!(buffer, elems; kw...)
    end
end

"""
    MakeArray(elems, similarto, [output_eltype=nothing])

An expression which constructs an array.

- `elems` is the output array
- `similarto` can either be a type, or some symbol that is an array whose type needs to
   be emulated. If `similarto` is a StaticArrays.SArray, then the output array is also
   created as an `SArray`, similarly, an `Array` will result in an `Array`, and a
   `LabelledArrays.SLArray` will result in a labelled static array.
- `output_eltype`: if set, then forces the element type of the output array to be this.
   by default, the output type is inferred automatically.

You can define:
```julia
@inline function create_array(A::Type{<:MyArray},a
                              ::Nothing, d::Val{dims}, elems...) where dims

# and

@inline function create_array(::Type{<:MyArray}, T, ::Val{dims}, elems...) where dims
```

which creates an array of size `dims` using the elements `elems` and eltype `T`, to allow
`MakeArray` to create arrays similarto `MyArray`s.

"""
MakeArray

MakeArray(elems, similarto) = MakeArray(elems, similarto, nothing)

function toexpr(a::MakeArray, st)
    similarto = toexpr(a.similarto, st)
    T = similarto isa Type ? similarto : :(typeof($similarto))
    ndim = ndims(a.elems)
    elT = a.output_eltype
    quote
        $create_array($T,
                     $elT,
                     Val{$ndim}(),
                     Val{$(size(a.elems))}(),
                     $(map(x->toexpr(x, st), a.elems)...),)
    end
end

## Array
@inline function _create_array(::Type{<:Array}, T, ::Val{dims}, elems...) where dims
    arr = Array{T}(undef, dims)
    @assert prod(dims) == nfields(elems)
    @inbounds for i=1:prod(dims)
        arr[i] = elems[i]
    end
    arr
end

@inline function create_array(A::Type{<:Array}, T, ::Val, d::Val, elems...)
    _create_array(A, T, d, elems...)
end

@inline function create_array(A::Type{<:Array}, ::Nothing, ::Val, d::Val{dims}, elems...) where dims
    T = promote_type(map(typeof, elems)...)
    _create_array(A, T, d, elems...)
end

## Vector
#
@inline function create_array(::Type{<:Array}, ::Nothing, ::Val{1}, ::Val{dims}, elems...) where dims
    [elems...]
end

@inline function create_array(::Type{<:Array}, T, ::Val{1}, ::Val{dims}, elems...) where dims
    T[elems...]
end

## Matrix

@inline function create_array(::Type{<:Array}, ::Nothing, ::Val{2}, ::Val{dims}, elems...) where dims
    vhcat(dims, elems...)
end

@inline function create_array(::Type{<:Array}, T, ::Val{2}, ::Val{dims}, elems...) where dims
    typed_vhcat(T, dims, elems...)
end

@inline function create_array(::Type{<:Base.ReinterpretArray}, ::Nothing,
        ::Val{1}, ::Val{dims}, elems...) where {dims}
    [elems...]
end

@inline function create_array(
        ::Type{<:Base.ReinterpretArray}, T, ::Val{1}, ::Val{dims}, elems...) where {dims}
    T[elems...]
end


vhcat(sz::Tuple{Int,Int}, xs::T...) where {T} = typed_vhcat(T, sz, xs...)
vhcat(sz::Tuple{Int,Int}, xs::Number...) = typed_vhcat(Base.promote_typeof(xs...), sz, xs...)
vhcat(sz::Tuple{Int,Int}, xs...) = typed_vhcat(Base.promote_eltypeof(xs...), sz, xs...)

function typed_vhcat(::Type{T}, sz::Tuple{Int, Int}, xs...) where T
    nr,nc = sz
    a = Matrix{T}(undef, nr, nc)
    k = 1
    for j=1:nc
        @inbounds for i=1:nr
            a[i, j] = xs[k]
            k += 1
        end
    end
    a
end

## Arrays of the special kind
@inline function create_array(A::Type{<:SubArray{T,N,P,I,L}}, S, nd::Val, d::Val, elems...) where {T,N,P,I,L}
    create_array(P, S, nd, d, elems...)
end

@inline function create_array(A::Type{<:PermutedDimsArray{T,N,perm,iperm,P}}, S, nd::Val, d::Val, elems...) where {T,N,perm,iperm,P}
    create_array(P, S, nd, d, elems...)
end


@inline function create_array(A::Type{<:Transpose{T,P}}, S, nd::Val, d::Val, elems...) where {T,P}
    create_array(P, S, nd, d, elems...)
end

@inline function create_array(A::Type{<:UpperTriangular{T,P}}, S, nd::Val, d::Val, elems...) where {T,P}
    create_array(P, S, nd, d, elems...)
end

@inline function create_array(::Type{A}, S, ::Val{ND}, ::Val{D}, elems...) where {E, N, I, A <: Base.ReshapedArray{E, N, I}, ND, D}
    create_array(I, S, Val(ND), Val(D), elems...)
end

## SArray
@inline function create_array(::Type{<:SArray}, ::Nothing, nd::Val, ::Val{dims}, elems...) where dims
    SArray{Tuple{dims...}}(elems)
end

@inline function create_array(::Type{<:SArray}, T, nd::Val, ::Val{dims}, elems...) where dims
    SArray{Tuple{dims...}, T}(elems)
end

## MArray
@inline function create_array(::Type{<:MArray}, ::Nothing, nd::Val, ::Val{dims}, elems...) where dims
    MArray{Tuple{dims...}}(elems)
end

@inline function create_array(::Type{<:MArray}, T, nd::Val, ::Val{dims}, elems...) where dims
    MArray{Tuple{dims...}, T}(elems)
end

## We use a separate type for Sparse Arrays to sidestep the need for
## iszero to be defined on the expression type
@matchable struct MakeSparseArray{S<:AbstractSparseArray} <: CodegenPrimitive
    array::S
end

function search_variables!(buffer, msa::MakeSparseArray; kw...)
    search_variables!(buffer, msa.array; kw...)
end

"""
    MakeSpaseArray(array)

An expression which creates a `SparseMatrixCSC` or a `SparseVector`.

The generated expression contains the sparsity information of `array`,

it only creates the `nzval` field at run time.
"""
MakeSparseArray

function toexpr(a::MakeSparseArray{<:SparseMatrixCSC}, st)
    sp = a.array
    :(SparseMatrixCSC($(sp.m), $(sp.n),
                      $(copy(sp.colptr)), $(copy(sp.rowval)),
                      [$(toexpr.(sp.nzval, (st,))...)]))
end

function toexpr(a::MakeSparseArray{<:SparseVector}, st)
    sp = a.array
    :(SparseVector($(sp.n),
                   $(copy(sp.nzind)),
                   [$(toexpr.(sp.nzval, (st,))...)]))
end

@matchable struct MakeTuple <: CodegenPrimitive
    elems
end

MakeTuple(x::Tuple) = MakeTuple(collect(x))

"""
    MakeTuple(tup)

Make a Tuple from a tuple of expressions.
"""
MakeTuple

function toexpr(a::MakeTuple, st)
    :(($(toexpr.(a.elems, (st,))...),))
end

"""
    Multithreaded

A parallelism type for `SpawnFetch` that uses Julia's threading system.

When used with `SpawnFetch{Multithreaded}`, expressions are executed
in parallel using `Threads.@spawn`.

# Examples
```julia
julia> SpawnFetch{Multithreaded}([func1, func2], combine_func)
```

See also: [`SpawnFetch`](@ref)
"""
struct Multithreaded end
"""
    SpawnFetch{ParallelType}(funcs [, args], reduce)

Run every expression in `funcs` in its own task, the expression
should be a `Func` object and is passed to `Threads.Task(f)`.
If `Func` takes arguments, then the arguments must be passed in as `args`--a vector of vector of arguments to each function in `funcs`. We don't use `@spawn` in order to support RuntimeGeneratedFunctions which disallow closures, instead we interpolate these functions or closures as smaller RuntimeGeneratedFunctions.

`reduce` function is used to combine the results of executing `exprs`. A SpawnFetch expression returns the reduced result.


Use `Symbolics.MultithreadedForm` ParallelType from the Symbolics.jl package to get the RuntimeGeneratedFunction version SpawnFetch.

`ParallelType` can be used to define more parallelism types
SymbolicUtils supports `Multithreaded` type. Which spawns
threaded tasks.
"""
struct SpawnFetch{Typ} <: CodegenPrimitive
    exprs::Vector
    args::Union{Nothing, Vector}
    combine
end

function search_variables!(buffer, sf::SpawnFetch; kw...)
    search_variables!(buffer, sf.exprs)
    search_variables!(buffer, sf.args)
end

(::Type{SpawnFetch{T}})(exprs, combine) where {T} = SpawnFetch{T}(exprs, nothing, combine)

function toexpr(p::SpawnFetch{Multithreaded}, st)
    args = p.args === nothing ? Iterators.repeated((), length(p.exprs)) : p.args
    spawns = map(p.exprs, args) do thunk, xs
        :(Base.Threads.@spawn $(toexpr(thunk, st))($(toexpr.(xs, (st,))...)))
    end
    quote
        $(toexpr(p.combine, st))(map(fetch, ($(spawns...),))...)
    end
end

"""
    LiteralExpr(ex)

Literally `ex`, an `Expr`. `toexpr` on `LiteralExpr` recursively calls
`toexpr` on any interpolated symbolic expressions.
"""
struct LiteralExpr <: CodegenPrimitive
    ex
end

recurse_expr(ex::Expr, st) = Expr(ex.head, recurse_expr.(ex.args, (st,))...)
recurse_expr(ex, st) = toexpr(ex, st)

function toexpr(exp::LiteralExpr, st)
    recurse_expr(exp.ex, st)
end

"""
    ForLoop(itervar, range, body)

Generate a `for` loop of the form
```julia
for itervar in range
    body
end
```
"""
struct ForLoop <: CodegenPrimitive
    itervar
    range
    body
end

function search_variables!(buffer, fl::ForLoop; kw...)
    itervar = fl.itervar
    range = fl.range
    body = fl.body

    if itervar isa BasicSymbolic{SymReal}
        search_variables!(buffer, itervar; kw...)
    elseif itervar isa BasicSymbolic{SafeReal}
        search_variables!(buffer, itervar; kw...)
    elseif itervar isa BasicSymbolic{TreeReal}
        search_variables!(buffer, itervar; kw...)
    elseif itervar isa Symbol
    else
        search_variables!(buffer, itervar; kw...)
    end

    if range isa BasicSymbolic{SymReal}
        search_variables!(buffer, range; kw...)
    elseif range isa BasicSymbolic{SafeReal}
        search_variables!(buffer, range; kw...)
    elseif range isa BasicSymbolic{TreeReal}
        search_variables!(buffer, range; kw...)
    elseif range isa Symbol
    else
        search_variables!(buffer, range; kw...)
    end

    if body isa BasicSymbolic{SymReal}
        search_variables!(buffer, body; kw...)
    elseif body isa BasicSymbolic{SafeReal}
        search_variables!(buffer, body; kw...)
    elseif body isa BasicSymbolic{TreeReal}
        search_variables!(buffer, body; kw...)
    elseif body isa Symbol
    else
        search_variables!(buffer, body; kw...)
    end
end

function toexpr(f::ForLoop, st)
    :(for $(toexpr(f.itervar, st)) in $(toexpr(f.range, st))
        $(toexpr(f.body, st))
    end)
end

include("faster_code.jl")

### Code-related utilities

### Common subexprssion evaluation

const CSE_PREFIX = Vector{UInt8}("##cse#")
const IDXS_SYM_PREFIX = Vector{UInt8}("_")

function get_numbered_symbol_with_prefix(prefix::Vector{UInt8}, idx)
    buffer = UInt8[]
    sizehint!(buffer, length(prefix) + ndigits(idx))
    append!(buffer, prefix)
    if idx == 0
        push!(buffer, '0')
    end
    while idx > 0
        push!(buffer, '0' + (idx % 10))
        idx = div(idx, 10)
    end
    reverse!(@view(buffer[(length(prefix) + 1):end]))
    return Symbol(buffer)
end

function get_cse_name(idx::Int)
    return get_numbered_symbol_with_prefix(CSE_PREFIX, idx)
end

function codegen_arrayop_indexer(idx::Int)
    return get_numbered_symbol_with_prefix(IDXS_SYM_PREFIX, idx)
end

"""
    newsym!(state::CSEState, ::Type{T})

Generates new symbol of type `T` with unique name in `state`.
"""
@inline function newsym!(state, ::Type{T}, symtype::TypeT, sh::ShapeT) where {T <: SymVariant}
    @nospecialize symtype sh

    idx = state.varid[]
    state.varid[] += 1
    name = get_cse_name(idx)
    Sym{T}(name; type = symtype, shape = sh)
end

"""
    $(TYPEDSIGNATURES)

Return `true` if CSE should descend inside `sym`, which has operation `f`.
"""
function cse_inside_expr(sym, f)
    return true
end

# Keep the branches of `ifelse_branching` out of CSE so they are not hoisted ahead of the
# conditional; the codegen for `ifelse_branching` emits them inside their `if`/`else` arms.
cse_inside_expr(sym, ::typeof(ifelse_branching)) = false

"""
    $(TYPEDSIGNATURES)

Only consulted when [`cse_inside_expr`](@ref) returns `false` for `sym`, which has operation
`f`. Return `true` if CSE should still bind `sym` itself to a temporary variable — so that
multiple references to it share a single computation — while leaving its arguments un-CSEd.
The default `false` leaves the expression fully inline at each reference site.
"""
function cse_bind_expr(sym, f)
    return false
end

# Bind the conditional itself so multiple references share one `if`/`else` instead of
# duplicating it per use site. The branches remain un-CSEd (and therefore lazy).
cse_bind_expr(sym, ::typeof(ifelse_branching)) = true

"""
    $(TYPEDEF)

A struct maintaining the state of CSE across multiple expressions. This allows
leveraging common subexpressions across a hierarchy of codegen constructs.

# Fields

$(TYPEDFIELDS)
"""
struct CSEState
    """
    An ordered list of assignment statements computing intermediate expressions
    for CSE. Also allows `DestructuredArgs` for `Let` CSE.
    """
    sorted_exprs::Vector{Union{Assignment, DestructuredArgs}}
    """
    A mapping of symbolic expression to the LHS in `sorted_exprs` that computes it.
    """
    visited::IdDict{SymbolicUtils.IDType, Union{BasicSymbolic{SymReal}, BasicSymbolic{SafeReal}, BasicSymbolic{TreeReal}}}
    """
    Integer counter, used to generate unique names for intermediate variables.
    """
    varid::Ref{Int}
end

CSEState() = CSEState(Union{Assignment, DestructuredArgs}[], IdDict(), Ref(1))

# the copy still references the same `varid` Ref to work in nested scopes
Base.copy(x::CSEState) = CSEState(copy(x.sorted_exprs), copy(x.visited), x.varid)

"""
    $(TYPEDSIGNATURES)

Return a `CSEState` for a new scope inside the one represented by `state`. The new
`CSEState` will use previously-CSEd bindings for expressions only involving variables
outside the new scope, but will generate new bindings for variables defined in this scope.
The new bindings will not affect the outer scope.
"""
function new_scope(state::CSEState)
    state = copy(state)
    empty!(state.sorted_exprs)
    return state
end

"""
$(SIGNATURES)

Perform a topological sort on a symbolic expression represented as a Directed Acyclic
Graph (DAG).

This function takes a symbolic expression `graph` (potentially containing shared common
sub-expressions) and returns an array of `Assignment` objects.  Each `Assignment`
represents a node in the sorted order, assigning a fresh symbol to its corresponding
expression. The order ensures that all dependencies of a node appear before the node itself
in the array.

Hash consing is assumed, meaning that structurally identical expressions are represented by
the same object in memory. This allows for efficient equality checks using `IdDict`.
"""
function topological_sort(graph)
    state = CSEState()
    cse!(graph, state)
    return state.sorted_exprs
end

"""
    $(TYPEDSIGNATURES)

Perform common subexpression elimination on an expression.

This optimization identifies repeated subexpressions and replaces them with
variables to avoid redundant computation.

# Arguments
- `expr`: The expression to optimize

# Returns
An optimized expression with common subexpressions eliminated

# Examples
```julia-repl
julia> expr = :(sin(x) + sin(x) * cos(y))
julia> cse(expr)  # sin(x) is computed only once
```
"""
function cse(expr)
    state = CSEState()
    newexpr = cse!(expr, state)
    return apply_cse(newexpr, state)
end

"""
    $(TYPEDSIGNATURES)

Given a CSEd expression `newexpr` and the corresponding `state`, return an equivalent
expression with optimized computation.

This is also used when introducing new scopes in subexpressions.
"""
function apply_cse(newexpr, state::CSEState)
    # we special-case an empty `sorted_exprs` because e.g. if `expr` is a `Func`, it will
    # introduce a new scope and not add bindings to `state`. We don't want to wrap it
    # in a `Let`.
    isempty(state.sorted_exprs) && return newexpr
    return Let(state.sorted_exprs, newexpr, false)
end

"""
    cse!(x, state::CSEState)

Perform CSE on `x`, updating `state` with the required assignments and returning the
modified `x`. The returned value should be computable given the assignments in `state`
and should have the same type as `x`.
"""
function cse! end

function cse!(expr::BasicSymbolic{T}, state::CSEState) where {T}
    cached = get(state.visited, expr.id, nothing)
    cached === nothing || return cached::BasicSymbolic{T}
    result = _cse_compute(expr, state)::BasicSymbolic{T}
    state.visited[expr.id] = result
    return result
end

function _cse_compute(expr::BasicSymbolic{T}, state::CSEState) where {T}
    @match expr begin
        BSImpl.Const(;) => begin
            new_expr = expr
            sym = newsym!(state, T, symtype(new_expr), shape(new_expr))
            push!(state.sorted_exprs, sym ← new_expr)
            return sym
        end
        BSImpl.Sym(;) => return expr
        BSImpl.ArrayOp(; term) => if term === nothing
            sym = newsym!(state, T, symtype(expr), shape(expr))
            push!(state.sorted_exprs, sym ← expr)
            return sym
        else
            return cse!(term, state)
        end
        BSImpl.ArrayMaker(; regions, values, type, shape) => begin
            values = copy(parent(values))
            for i in eachindex(values)
                values[i] = cse!(values[i], state)::BasicSymbolic{T}
            end
            return BSImpl.ArrayMaker{T}(regions, values; type, shape)
        end
        BSImpl.Term(; f, args, type, shape) && if f === SymbolicUtils.array_literal end => begin
            args = copy(args)
            # don't CSE the size
            for i in Iterators.drop(eachindex(args), 1)
                args[i] = cse!(args[i], state)::BasicSymbolic{T}
            end
            sym = newsym!(state, T, type, shape)
            push!(state.sorted_exprs, sym ← BSImpl.Term{T}(f, args; type, shape))
            return sym
        end
        BSImpl.Term(; f, args, type = atype, shape = ashape) && if f === with_allocator end => begin
            allocop = @match args[2] begin
                BSImpl.Term(; f = finner, args = argsinner, shape, type) && if finner === SymbolicUtils.array_literal end => begin
                    argsinner = copy(argsinner)
                    for i in Iterators.drop(eachindex(argsinner), 1)
                        argsinner[i] = cse!(argsinner[i], state)::BasicSymbolic{T}
                    end
                    BSImpl.Term{T}(finner, argsinner; type, shape)
                end
                BSImpl.ArrayOp(;) => args[2]
                BSImpl.ArrayMaker(; regions, values, type, shape) => begin
                    values = copy(parent(values))
                    for i in eachindex(values)
                        values[i] = cse!(values[i], state)::BasicSymbolic{T}
                    end
                    BSImpl.ArrayMaker{T}(regions, values; type, shape)
                end
            end

            return BSImpl.Term{T}(with_allocator, ArgsT{T}((args[1], allocop)); type = atype, shape = ashape)
        end
        _ => begin
            op = operation(expr)
            args = arguments(expr)
            if op isa BasicSymbolic{T}
                SymbolicUtils.is_function_symbolic(op) || return expr
            end
            if !(cse_inside_expr(expr, op)::Bool)
                cse_bind_expr(expr, op)::Bool || return expr
                # Bind the node as-is (arguments un-CSEd) so references share one
                # computation. `cse!` caches the binding by node id, so every reference
                # in this scope resolves to the same temporary.
                sym = newsym!(state, T, symtype(expr), shape(expr))
                push!(state.sorted_exprs, sym ← expr)
                return sym
            end
            args = copy(parent(args))
            for i in eachindex(args)
                args[i] = cse!(args[i], state)::BasicSymbolic{T}
            end
            # use `term` instead of `maketerm` because we only care about the operation being performed
            # and not the representation. This avoids issues with `newsym` symbols not having sizes, etc.
            new_expr = Term{T}(op, args; type = symtype(expr), shape = shape(expr))
            sym = newsym!(state, T, symtype(expr), shape(expr))
            push!(state.sorted_exprs, sym ← new_expr)
            return sym
        end
    end
end

cse!(x, ::CSEState) = x
cse!(x::Expr, ::CSEState) = x
cse!(x::LiteralExpr, ::CSEState) = x

cse!(x::CodegenPrimitive, state::CSEState) = throw(MethodError(cse!, (x, state)))

cse!(x::AbstractRange, ::CSEState) = x
function cse!(x::AbstractArray, state::CSEState)
    ux = SymbolicUtils.unwrap(x)
    if ux !== x
        return cse!(ux, state)
    end
    res = map(Base.Fix2(cse!, state), x)
    return res
end

function cse!(x::AbstractSparseArray, state::CSEState)
    I, J, V = findnz(x)
    V = map(Base.Fix2(cse!, state), V)
    return SparseArrays.sparse(I, J, V, size(x)...)
end

function cse!(x::Tuple, state::CSEState)
    res = map(Base.Fix2(cse!, state), x)
    return res
end

function cse!(x::MakeArray, state::CSEState)
    elems = x.elems
    if elems isa Vector{BasicSymbolic{SymReal}}
        return MakeArray(cse!(elems, state), x.similarto, x.output_eltype)
    elseif elems isa Matrix{BasicSymbolic{SymReal}}
        return MakeArray(cse!(elems, state), x.similarto, x.output_eltype)
    else
        return MakeArray(cse!(elems, state), x.similarto, x.output_eltype)
    end
end

function cse!(x::SetArray, state::CSEState)
    elems = x.elems
    if elems isa Vector{BasicSymbolic{SymReal}}
        return SetArray(x.inbounds, x.arr, cse!(elems, state), x.return_arr)
    elseif elems isa Matrix{BasicSymbolic{SymReal}}
        return SetArray(x.inbounds, x.arr, cse!(elems, state), x.return_arr)
    elseif elems isa Vector{AtIndex}
        return SetArray(x.inbounds, x.arr, cse!(elems, state), x.return_arr)
    elseif elems isa Matrix{AtIndex}
        return SetArray(x.inbounds, x.arr, cse!(elems, state), x.return_arr)
    else
        return SetArray(x.inbounds, x.arr, cse!(elems, state), x.return_arr)
    end
end

function cse!(x::MakeSparseArray, state::CSEState)
    arr = x.array
    if arr isa SparseMatrixCSC{BasicSymbolic{SymReal}, Int}
        return MakeSparseArray(cse!(arr, state))
    else
        return MakeSparseArray(cse!(arr, state))
    end
end

function cse!(x::Assignment, state::CSEState)
    lhs = x.lhs
    rhs = x.rhs
    if rhs isa BasicSymbolic{SymReal}
        result = Assignment(lhs, cse!(rhs, state))
    elseif rhs isa Vector{BasicSymbolic{SymReal}}
        result = Assignment(lhs, cse!(rhs, state))
    elseif rhs isa Matrix{BasicSymbolic{SymReal}}
        result = Assignment(lhs, cse!(rhs, state))
    elseif rhs isa Let
        result = Assignment(lhs, cse!(rhs, state))
    elseif rhs isa MakeArray
        result = Assignment(lhs, cse!(rhs, state))
    elseif rhs isa SetArray
        result = Assignment(lhs, cse!(rhs, state))
    else
        result = Assignment(lhs, cse!(rhs, state))
    end
    if lhs isa BasicSymbolic{SymReal}
        state.visited[lhs.id] = lhs
    elseif lhs isa BasicSymbolic{SafeReal}
        state.visited[lhs.id] = lhs
    elseif lhs isa BasicSymbolic{TreeReal}
        state.visited[lhs.id] = lhs
    end
    return result
end

function cse!(x::DestructuredArgs, state::CSEState)
    name = x.name
    if name isa BasicSymbolic{SymReal}
        return DestructuredArgs(x.elems, x.inds, cse!(name, state), x.inbounds, x.create_bindings)
    elseif name isa BasicSymbolic{SafeReal}
        return DestructuredArgs(x.elems, x.inds, cse!(name, state), x.inbounds, x.create_bindings)
    elseif name isa BasicSymbolic{TreeReal}
        return DestructuredArgs(x.elems, x.inds, cse!(name, state), x.inbounds, x.create_bindings)
    elseif name isa Symbol
        return DestructuredArgs(x.elems, x.inds, cse!(name, state), x.inbounds, x.create_bindings)
    elseif name isa Expr
        return DestructuredArgs(x.elems, x.inds, cse!(name, state), x.inbounds, x.create_bindings)
    else
        return DestructuredArgs(x.elems, x.inds, cse!(name, state), x.inbounds, x.create_bindings)
    end
end

function cse!(x::Let, state::CSEState)
    state = new_scope(state)
    # `Let` introduces a new scope. For each assignment `p` in `x.pairs`, we CSE it
    # and then append it to the new assignments from CSE. This is because the assignments
    # are imperative, so the CSE assignments for a given `p` can include previous `p`,
    # preventing us from simply wrapping the `Let` in another `Let`.
    for p in x.pairs
        if p isa Assignment
            push!(state.sorted_exprs, cse!(p, state))
        elseif p isa DestructuredArgs
            push!(state.sorted_exprs, cse!(p, state))
        else
            _unreachable()
        end
    end
    body = x.body
    if body isa BasicSymbolic{SymReal}
        return Let(state.sorted_exprs, cse!(body, state), x.let_block)
    elseif body isa BasicSymbolic{SafeReal}
        return Let(state.sorted_exprs, cse!(body, state), x.let_block)
    elseif body isa BasicSymbolic{TreeReal}
        return Let(state.sorted_exprs, cse!(body, state), x.let_block)
    elseif body isa Vector{BasicSymbolic{SymReal}}
        return Let(state.sorted_exprs, cse!(body, state), x.let_block)
    elseif body isa Matrix{BasicSymbolic{SymReal}}
        return Let(state.sorted_exprs, cse!(body, state), x.let_block)
    elseif body isa Let
        return Let(state.sorted_exprs, cse!(body, state), x.let_block)
    elseif body isa MakeArray
        return Let(state.sorted_exprs, cse!(body, state), x.let_block)
    elseif body isa ForLoop
        return Let(state.sorted_exprs, cse!(body, state), x.let_block)
    elseif body isa Symbol
        return Let(state.sorted_exprs, cse!(body, state), x.let_block)
    elseif body isa Expr
        return Let(state.sorted_exprs, cse!(body, state), x.let_block)
    elseif body isa Nothing
        return Let(state.sorted_exprs, cse!(body, state), x.let_block)
    else
        return Let(state.sorted_exprs, cse!(body, state), x.let_block)
    end
end

function cse!(x::Func, state::CSEState)
    state = new_scope(state)
    body = x.body
    if body isa BasicSymbolic{SymReal}
        return Func(x.args, x.kwargs, apply_cse(cse!(body, state), state), x.pre)
    elseif body isa BasicSymbolic{SafeReal}
        return Func(x.args, x.kwargs, apply_cse(cse!(body, state), state), x.pre)
    elseif body isa BasicSymbolic{TreeReal}
        return Func(x.args, x.kwargs, apply_cse(cse!(body, state), state), x.pre)
    elseif body isa Vector{BasicSymbolic{SymReal}}
        return Func(x.args, x.kwargs, apply_cse(cse!(body, state), state), x.pre)
    elseif body isa Matrix{BasicSymbolic{SymReal}}
        return Func(x.args, x.kwargs, apply_cse(cse!(body, state), state), x.pre)
    elseif body isa Let
        return Func(x.args, x.kwargs, apply_cse(cse!(body, state), state), x.pre)
    elseif body isa MakeArray
        return Func(x.args, x.kwargs, apply_cse(cse!(body, state), state), x.pre)
    elseif body isa ForLoop
        return Func(x.args, x.kwargs, apply_cse(cse!(body, state), state), x.pre)
    elseif body isa Symbol
        return Func(x.args, x.kwargs, apply_cse(cse!(body, state), state), x.pre)
    elseif body isa Expr
        return Func(x.args, x.kwargs, apply_cse(cse!(body, state), state), x.pre)
    elseif body isa Nothing
        return Func(x.args, x.kwargs, apply_cse(cse!(body, state), state), x.pre)
    else
        return Func(x.args, x.kwargs, apply_cse(cse!(body, state), state), x.pre)
    end
end

function cse!(x::AtIndex, state::CSEState)
    return AtIndex(cse!(x.i, state), cse!(x.elem, state))
end

function cse!(x::MakeTuple, state::CSEState)
    return MakeTuple(cse!(x.elems, state))
end

function cse!(x::SpawnFetch{T}, state::CSEState) where {T}
    # SpawnFetch is special. We want to CSE the individual functions independently, since
    # they shouldn't refer to global state. The arguments use `state`.
    return SpawnFetch{T}(map(cse, x.exprs), cse!(x.args, state), x.combine)
end

function cse!(x::ForLoop, state::CSEState)
    # cse the range with current scope, CSE the body with a new scope
    new_state = new_scope(state)
    return ForLoop(x.itervar, cse!(x.range, state), apply_cse(cse!(x.body, new_state), new_state))
end

"""
    OptimizationRule(name, detector, transformer, priority)

Defines an optimization rule with:
- `name`: A string identifier for the optimization.
- `detector`: A function that detects patterns in the IR.
- `transformer`: A function that transforms the IR based on detected patterns, and returns updated IR
- `priority`: Integer priority (higher = applied first)

The detector function should implement the signature

```julia
detector(expr::Code.Let, state::Code.CSEState) -> Union{Nothing, Vector{<:AbstractMatched}}
```

Likewise, the transformer function should implement the signature

```julia
transformer(expr::Code.Let, match_data::Union{Nothing, Vector{<:AbstractMatched}}, state::Code.CSEState) -> Code.Let
```
"""
struct OptimizationRule{D, T}
    name::String
    detector::D
    transformer::T
    priority::Int
end

abstract type AbstractMatched end

function apply_substitution_map(expr::Code.Let, substitution_map::Dict)
    substitute_in_ir(expr, substitution_map)
end

function substitute_in_ir(s::Symbol, substitution_map::Dict)
    get(substitution_map, s, s)
end

function substitute_in_ir_base(s, substitution_map::Dict)
    if haskey(substitution_map, s)
        v = substitution_map[s]
        if issym(v)
            v
        else
            add_worker(vartype(first(v)), v)
        end
    else
        s
    end
end

function substitute_in_ir(expr, substitution_map::Dict)
    if iscall(expr)
        new_args = map(arguments(expr)) do arg
            substitute_in_ir(arg, substitution_map)
        end
        return Term{vartype(expr)}(operation(expr), new_args; type = symtype(expr))
    elseif issym(expr)
        substitute_in_ir_base(expr, substitution_map)
    else
        expr
    end
end

function substitute_in_ir(x::Code.Assignment, substitution_map::Dict)
    new_lhs = substitute_in_ir(Code.lhs(x), substitution_map)
    new_rhs = substitute_in_ir(Code.rhs(x), substitution_map)
    return Code.Assignment(new_lhs, new_rhs)
end

"""
    substitute_in_ir(expr::Code.Let, substitution_map::Dict) -> Code.Let

Recursively substitutes variables in the IR `expr` according to `substitution_map`.
"""
function substitute_in_ir(expr::Code.Let, substitution_map::Dict)
    isempty(substitution_map) && return expr

    new_pairs = map(expr.pairs) do p
        substitute_in_ir(p, substitution_map)
    end
    new_body = substitute_in_ir(expr.body, substitution_map)
    return Code.Let(new_pairs, new_body, expr.let_block)
end

Base.isempty(l::Code.Let) = isempty(l.pairs)

# Apply optimization rules during CSE
function apply_optimization_rule(expr::Code.Let, state::Union{Code.CSEState, Code.LazyState}, rules::OptimizationRule)
    match_data = rules.detector(expr, state)
    if match_data !== nothing
        return rules.transformer(expr, match_data, state)
    end

    return expr
end
apply_optimization_rule(expr::Code.Let, state::Union{Code.CSEState, Code.LazyState}, rules::Nothing) = expr

function apply_optimization_rule(func::Code.Func, state, rule)
    Func(func.args, func.kwargs,
         apply_optimization_rule(func.body, state, rule),
         func.pre)
end

apply_optimization_rules(expr, state, ::Nothing) = expr
function apply_optimization_rules(expr, state, rules)
    isnothing(rules) && return expr
    isempty(rules) && return expr
    for rule in sort(rules, by = x -> x.priority)
        expr_new = apply_optimization_rule(expr, state, rule)
        expr = expr_new
    end

    expr
end

apply_optimization_rules(ir::IRStructure, expr::Any, ::Nothing) = ir, expr
function apply_optimization_rule(ir::IRStructure, expr, rules)
    match_data = rules.detector(ir, expr)
    if match_data !== nothing
        new_ir, new_expr = rules.transformer(ir, expr, match_data)
        return new_ir, new_expr
    end

    return ir, expr
end

function apply_optimization_rules(ir::IRStructure, expr, rules)
    isnothing(rules) && return ir, expr
    isempty(rules) && return ir, expr
    for rule in sort(rules, by = x -> x.priority)
        ir_new, expr_new = apply_optimization_rule(ir, expr, rule)
        expr = expr_new
        ir = ir_new
    end

    ir, expr
end

end

using Random: shuffle, seed!
using SymbolicUtils
using SymbolicUtils: getdepth, Rewriters, Term, unwrap_const

include("utils.jl")

@testset "Chain, Postwalk and Fixpoint" begin
    @syms w z α::Real β::Real

    r1 = @rule ~x + ~x => 2 * (~x)
    r2 = @acrule ~x * +(~~ys) => sum(map(y -> ~x * y, ~~ys))

    rset = Rewriters.Postwalk(Rewriters.Chain([r2]))
    @test getdepth(rset) == typemax(Int)

    ex = 2 * (w + w + α + β)

    @eqtest rset(ex) == (((2 * w) + (2 * w)) + (2 * α)) + (2 * β)
    @eqtest Rewriters.Fixpoint(rset)(ex) == ((2 * (2 * w)) + (2 * α)) + (2 * β)
end

@testset "Numeric" begin
    @syms a::Integer b c d x::Real y::Number
    @eqtest simplify(Term{SymReal}(conj, [x]; type = Real)) == x
    @eqtest simplify(Term{SymReal}(real, [x]; type = Real)) == x
    @eqtest unwrap_const(simplify(Term{SymReal}(imag, [x]; type = Real))) == 0
    @eqtest simplify(Term{SymReal}(imag, [y]; type = Real)) == imag(y)
    @eqtest simplify(x - y) == x + -1 * y
    @eqtest simplify(x - sin(y)) == x + -1 * sin(y)
    @eqtest simplify(-sin(x)) == -1 * sin(x)
    @eqtest simplify(1 * x * 2) == 2 * x
    @eqtest simplify(1 + x + 2) == 3 + x
    @eqtest simplify(b * b) == b^2 # tests merge_repeats
    @eqtest simplify((a * b)^2) == a^2 * b^2
    @eqtest simplify((a * b)^c) == (a * b)^c

    @eqtest simplify(1x + 2x) == 3x
    @eqtest simplify(3x + 2x) == 5x

    @eqtest simplify(a + b + (x * y) + c + 2 * (x * y) + d) == simplify((3 * x * y) + a + b + c + d)
    @eqtest simplify(a + b + 2 * (x * y) + c + 2 * (x * y) + d) == simplify((4 * x * y) + a + b + c + d)

    @eqtest simplify(a * x^y * b * x^d) == simplify(a * b * (x^(d + y)))

    # Issue JuliaSymbolics/Symbolics.jl#1815: x^a * x should simplify to x^(a + 1)
    @eqtest simplify(x^a * x) == simplify(x^(a + 1))
    @eqtest simplify(x * x^a) == simplify(x^(a + 1))

    @eqtest simplify(a + b + 0 * c + d) == simplify(a + b + d)
    @eqtest simplify(a * b * c^0 * d) == simplify(a * b * d)
    @eqtest simplify(a * b * 1 * c * d) == simplify(a * b * c * d)
    @eqtest simplify_fractions(x^2.0 / (x * y)^2.0) == simplify_fractions(1 / (y^2.0))

    @test unwrap_const(simplify(Term{SymReal}(one, [a]))) == 1
    @test unwrap_const(simplify(Term{SymReal}(one, [b + 1]))) == 1
    @test unwrap_const(simplify(Term{SymReal}(one, [x + 2]))) == 1


    @test unwrap_const(simplify(Term{SymReal}(zero, [a]))) == 0
    @test unwrap_const(simplify(Term{SymReal}(zero, [b + 1]))) == 0
    @test unwrap_const(simplify(Term{SymReal}(zero, [x + 2]))) == 0
end

@testset "LiteralReal" begin
    @syms x1 x2 vartype=TreeReal
    s = cos(x1 * 3.2) - x2 * 5.8 + x2 * 1.2
    @eqtest s == cos(x1 * 3.2) - x2 * 5.8 + x2 * 1.2

    # Prevents automatic simplification:
    @eqtest s != cos(3.2(x1^1)) - 4.6x2

    # However, manual simplification should still work:
    @eqtest simplify(s) == simplify(cos(3.2x1) - 4.6x2)
end

@testset "boolean" begin
    @syms a::Real b c

    @eqtest simplify(a < 0) == (a < 0)
    @eqtest simplify(0 < a) == (0 < a)
    @eqtest unwrap_const(simplify((0 < a) | true)) == true
    @eqtest unwrap_const(simplify(true | (0 < a))) == true
    @eqtest simplify((0 < a) & true) == (0 < a)
    @eqtest simplify(true & (0 < a)) == (0 < a)
    @eqtest unwrap_const(simplify(false & (0 < a))) == false
    @eqtest unwrap_const(simplify((0 < a) & false)) == false
    @eqtest unwrap_const(simplify(Term{SymReal}(!, [true]; type = Bool))) == false
    @eqtest unwrap_const(simplify(Term{SymReal}(|, [false, true]; type = Bool))) == true
    @eqtest simplify(ifelse(true, a, b)) == a
    @eqtest simplify(ifelse(false, a, b)) == b

    # abs
    @test unwrap_const(simplify(substitute(ifelse(!(a < 0), a, -a), Dict(a => -1)))) == 1
    @test unwrap_const(simplify(substitute(ifelse(!(a < 0), a, -a), Dict(a => 1)))) == 1
    @test unwrap_const(simplify(substitute(ifelse(a < 0, -a, a), Dict(a => -1)))) == 1
    @test unwrap_const(simplify(substitute(ifelse(a < 0, -a, a), Dict(a => 1)))) == 1
end

@testset "Pythagorean Identities" begin
    @syms a::Integer x::Real y::Number

    @test unwrap_const(simplify(cos(x)^2 + 1 + sin(x)^2)) == 2
    @test unwrap_const(simplify(cos(y)^2 + 1 + sin(y)^2)) == 2
    @test unwrap_const(simplify(sin(y)^2 + cos(y)^2 + 1)) == 2

    @eqtest simplify(1 + y + tan(x)^2) == sec(x)^2 + y
    @eqtest simplify(1 + y + cot(x)^2) == csc(x)^2 + y
    @eqtest simplify(cos(x)^2 - 1) == -sin(x)^2
    @eqtest simplify(sin(x)^2 - 1) == -cos(x)^2

    @eqtest unwrap_const(simplify(cosh(x)^2 + 1 - sinh(x)^2)) == 2
    @eqtest unwrap_const(simplify(cosh(y)^2 + 1 - sinh(y)^2)) == 2
    @eqtest unwrap_const(simplify(-sinh(y)^2 + cosh(y)^2 + 1)) == 2

    @eqtest simplify(cosh(x)^2 - 1) == sinh(x)^2
    @eqtest simplify(sinh(x)^2 + 1) == cosh(x)^2
end

@testset "Double angle formulas" begin
    @syms r x

    @eqtest simplify(r * cos(x / 2)^2 - r * sin(x / 2)^2) == r * cos(x)
    @eqtest simplify(r * sin(x / 2)^2 - r * cos(x / 2)^2) == -r * cos(x)
    @eqtest simplify(2cos(x) * sin(x)) == sin(2x)

    @eqtest simplify(r * cosh(x / 2)^2 + r * sinh(x / 2)^2) == r * cosh(x)
    @eqtest simplify(r * sinh(x / 2)^2 + r * cosh(x / 2)^2) == r * cosh(x)
    @eqtest simplify(2cosh(x) * sinh(x)) == sinh(2x)
end

@testset "Exponentials" begin
    @syms a::Real b::Real
    @eqtest simplify(exp(a) * exp(b)) == simplify(exp(a + b))
    @eqtest simplify(exp(a) * exp(a)) == simplify(exp(2a))
    @test unwrap_const(simplify(exp(a) * exp(-a))) == 1
    @eqtest simplify(exp(a)^2) == simplify(exp(2a))
    @eqtest simplify(exp(a) * a * exp(b)) == simplify(a * exp(a + b))
    @eqtest unwrap_const(simplify(one(Int)^a)) == 1
    @eqtest unwrap_const(simplify(one(Complex{Float64})^a)) == 1
    @eqtest simplify(a^b * 1^a) == a^b
end

@testset "simplify_fractions" begin
    @syms x y z
    @eqtest unwrap_const(simplify(2 * ((y + z) / x) - 2 * y / x - z / x * 2)) == 0
end

@testset "Depth" begin
    @syms x
    R = Rewriters.Postwalk(Rewriters.Chain([@rule(sin(~x) => cos(~x)),
        @rule(1 + ~x => ~x - 1)]))
    @eqtest R(sin(sin(sin(x + 1)))) == cos(cos(cos(x - 1)))
    #@eqtest R(sin(sin(sin(x + 1))), depth=2) == cos(cos(sin(x + 1)))
end

pred(x) = error("Fail")
@testset "RuleRewriteError" begin
    @syms a b

    rs = Rewriters.Postwalk(Rewriters.Chain(([@rule ~x + ~y::pred => ~x])))
    @test_throws SymbolicUtils.RuleRewriteError rs(a + b)
    err = try
        rs(a + b)
    catch err
        err
    end
    @test sprint(io -> Base.showerror(io, err)) == "Failed to apply rule ~x + ~(y::pred) => ~x on expression a + b"
end

# @testset "Threading" begin
#     @syms a b c d
#     ex = (((0.6666666666666666 / (c / 1)) + ((1 * a) / (c / 1))) +
#           (1.0 / (((1 * d) / (1 + b)) * (1 / b)))) +
#          ((((1 * a) + (1 * a)) / ((2.0 * (d + 1)) / 1.0)) +
#           ((((d * 1) / (1 + c)) * 2.0) / ((1 / d) + (1 / c))))
#     @eqtest simplify(ex) == simplify(ex, threaded=true, thread_subtree_cutoff=3)
#     @test SymbolicUtils.node_count(a + b * c / d) == 7
# end

_g(y) = sin
@testset "interpolation" begin
    @syms a

    @test isnothing(@rule(_g(1)(a) => 2)(sin(a)))
    @test @rule($(_g(1))(a) => 2)(sin(a)) == 2
end

@testset "where" begin

    @syms a b
    _f(x) = x === a
    r = @rule ~x => ~x where {_f(~x)}
    @eqtest r(a) == a
    @test isnothing(r(b))

    r = @acrule ~x => ~x where {_f(~x)}
    @eqtest r(a) == a
    @test r(b) === nothing
end

using SymbolicUtils
using SymbolicUtils: BasicSymbolic, Term, Const, ArgsT, ShapeVecT, scalarize, symtype, isarrayop, shape
using SymbolicUtils.Code
using LinearAlgebra
using Test

limit2(a, N) = a == N + 1 ? 1 : a == 0 ? N : a
limit2(a::BasicSymbolic{T}, N) where {T} = Term{T}(limit2, ArgsT{T}((a, Const{T}(N))); type = Int, shape = ShapeVecT())
brusselator_f(x, y, t) = (((x - 0.3)^2 + (y - 0.6)^2) <= 0.1^2) * (t >= 1.1) * 5.0

SymbolicUtils.promote_symtype(::typeof(brusselator_f), args...) = Real

@testset "Brusselator stencil" begin
    n = 8
    @syms t::Real u(t)[1:n, 1:n]::Real v(t)[1:n, 1:n]::Real
    u = u(t)
    v = v(t)

    x = y = range(0, stop=1, length=n)
    dx = step(x)

    A = 3.4
    alpha = 10.0

    dtu = @arrayop (i, j) alpha * (u[limit2(i - 1, n), j] +
                                   u[limit2(i + 1, n), j] +
                                   u[i, limit2(j + 1, n)] +
                                   u[i, limit2(j - 1, n)] -
                                   4u[i, j]) +
                          1.0 + u[i, j]^2 * v[i, j] - (A + 1) *
                            u[i, j] + brusselator_f(x[i], y[j], t) i in 1:n j in 1:n
    dtv = @arrayop (i, j) alpha * (v[limit2(i - 1, n), j] +
                                   v[limit2(i + 1, n), j] +
                                   v[i, limit2(j + 1, n)] +
                                   v[i, limit2(j - 1, n)] -
                                   4v[i, j]) -
                          u[i, j]^2 * v[i, j] + A * u[i, j] i in 1:n j in 1:n
    lapu = @arrayop (i, j) (u[limit2(i - 1, n), j] +
                            u[limit2(i + 1, n), j] +
                            u[i, limit2(j + 1, n)] +
                            u[i, limit2(j - 1, n)] -
                            4u[i, j]) i in 1:n j in 1:n
    lapv = @arrayop (i, j) (v[limit2(i - 1, n), j] +
                            v[limit2(i + 1, n), j] +
                            v[i, limit2(j + 1, n)] +
                            v[i, limit2(j - 1, n)] -
                            4v[i, j]) i in 1:n j in 1:n
    s = brusselator_f.(x, y', t)

    st = Code.NameState()
    st.rewrites[:arrayop_eltype] = BasicSymbolic{SymReal}
    st.rewrites[:arrayop_output] = :du
    st.rewrites[u] = :u
    st.rewrites[v] = :v
    du = eval(quote
        let du = fill(Const{SymReal}(0), $n, $n), u = $(collect(u)), v = $(collect(v)), t = $t
            $(toexpr(dtu, st))
            du
        end
    end)
    @test isequal(collect(du), scalarize(dtu))

    vv = collect(v)
    uu = collect(u)
    @test isequal(scalarize(dtu), collect(1 .+ vv .* uu.^2 .- (A + 1) .* uu .+ alpha .* scalarize(lapu) .+ s))
    @test isequal(scalarize(dtv), collect(A .* uu .- uu.^2 .* vv .+ alpha .* scalarize(lapv)))
end

@testset "broadcast & scalarize" begin
    @syms A[1:5,1:3] b[1:3] t x(t)[1:4] u[1:1]
    x = x(t)
    AA = scalarize(A)
    bb = scalarize(b)
    @test isequal(scalarize(b .^ 1), bb)
    c = A * b

    @syms d[1:3] E[1:3, 1:3]
    d_vec = collect(d)
    @test d_vec' isa Adjoint{BasicSymbolic{SymReal}, Vector{BasicSymbolic{SymReal}}}
    result1 = d_vec' * E
    result2 = d_vec' * inv(E) * d_vec
    @test size(result1) == (1, 3)
    @test size(result2) == ()

    @test isequal(scalarize(sin.(x)),
        sin.([x[i] for i in 1:4]))

    @test isequal(scalarize(sin.(A .* c)[1, 1]),
        sin(A[1, 1] * (b[1] * A[1, 1] +
                       b[2] * A[1, 2] +
                       b[3] * A[1, 3])))

    @test isequal(scalarize(u + u), [2u[1]])

    @syms A[1:2, 1:2]
    test_mat = [1 2; 3 4]
    repl_dict = Dict(scalarize(A .=> test_mat))
    A2 = A^2
    A3 = A^3
    A4 = A^4
    A5 = A^5
    A6 = A^6
    A7 = A^7

    @syms i::Int j::Int k::Int l::Int m::Int n::Int

    A_ = A
    A3_ = @arrayop (i, j) A_[i, k] * A_[k, l] * A_[l, j]
    A4_ = @arrayop (i, j) A_[i, k] * A_[k, l] * A_[l, m] * A_[m, j]
    A5_ = @arrayop (i, j) A_[i, k] * A_[k, l] * A_[l, m] * A_[m, n] * A_[n, j]

    @test_broken isequal(scalarize((A*A)[k,k]), A[k, 1]*A[1, k] + A[2, k]*A[k, 2])

    # basic tests:
    @test iszero(unwrap_const(expand((scalarize(A^2) * scalarize(A))[1,1] -
                  scalarize(A^3)[1,1])))
    @testset "nested scalarize" begin
        @test isequal(unwrap_const.(substitute(scalarize(A2 ), repl_dict)), test_mat^2)
        @test isequal(unwrap_const.(substitute(scalarize(A3_), repl_dict)), test_mat^3)
        @test isequal(unwrap_const.(substitute(scalarize(A3 ), repl_dict)), test_mat^3)
        @test isequal(unwrap_const.(substitute(scalarize(A4_), repl_dict)), test_mat^4)
        @test isequal(unwrap_const.(substitute(scalarize(A4 ), repl_dict)), test_mat^4)
        @test isequal(unwrap_const.(substitute(scalarize(A5_), repl_dict)), test_mat^5)
        @test isequal(unwrap_const.(substitute(scalarize(A5 ), repl_dict)), test_mat^5)
        @test isequal(unwrap_const.(substitute(scalarize(A6 ), repl_dict)), test_mat^6)
        @test isequal(unwrap_const.(substitute(scalarize(A7 ), repl_dict)), test_mat^7)
    end

    @test isequal(scalarize(inv(A)), [inv(A)[i] for i in eachindex(A)])
end

@testset "map/mapreduce" begin
    @syms a[1:2] b[1:2, 1:2] c[1:2, 1:2, 1:2]
    @testset "$f($v)" for v in [a, b, c], f in [sum, prod]
        var = f(v)
        @test isarrayop(var)
        @test SymbolicUtils.shape(var) == ShapeVecT()
        @test symtype(var) == Number
        @test isequal(scalarize(var), f(collect(v)))
    end
end

@testset "`map` and `mapreduce` on oddly sized arrays" begin
    @syms a[1:4] b[1:3] c[1:2, 1:2] d[1:1, 1:4] e::Vector{Number} f::Matrix{Number} g

    ex = map(+, a, b)
    @test shape(ex) == [1:3]
    @test symtype(ex) == Vector{Number}
    ex = mapreduce(+, +, a, b)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number

    ex = map(+, a, c)
    @test shape(ex) == [1:4]
    @test symtype(ex) == Vector{Number}
    ex = mapreduce(+, +, a, c)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number

    # Assumes unknowns match shape so `ArrayOp` can be constructed
    ex = map(+, a, e)
    @test shape(ex) == [1:4]
    @test symtype(ex) == Vector{Number}
    ex = mapreduce(+, +, a, e)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number

    ex = map(+, a, f)
    @test shape(ex) == [1:4]
    @test symtype(ex) == Vector{Number}
    ex = mapreduce(+, +, a, f)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number

    ex = map(+, a, g)
    @test shape(ex) == [1:1]
    @test symtype(ex) == Vector{Number}
    ex = mapreduce(+, +, a, g)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number

    ex = map(+, b, c)
    @test shape(ex) == [1:3]
    @test symtype(ex) == Vector{Number}
    ex = mapreduce(+, +, b, c)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number

    ex = map(+, c, c)
    @test shape(ex) == [1:2, 1:2]
    @test symtype(ex) == Matrix{Number}
    ex = mapreduce(+, +, c, c)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number

    @test_throws ArgumentError map(+, c, d)

    ex = map(+, c, e)
    @test shape(ex) == [1:4]
    @test symtype(ex) == Vector{Number}
    ex = mapreduce(+, +, c, e)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number

    ex = map(+, c, f)
    @test shape(ex) == [1:2, 1:2]
    @test symtype(ex) == Matrix{Number}
    ex = mapreduce(+, +, c, f)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number

    ex = map(+, c, g)
    @test shape(ex) == [1:1]
    @test symtype(ex) == Vector{Number}
    ex = mapreduce(+, +, c, g)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number

    ex = map(+, e, f)
    @test shape(ex) == SymbolicUtils.Unknown(1)
    @test symtype(ex) == Vector{Number}
    ex = mapreduce(+, +, e, f)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number

    ex = map(+, e, g)
    @test shape(ex) == [1:1]
    @test symtype(ex) == Vector{Number}
    ex = mapreduce(+, +, e, g)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number

    ex = map(+, f, g)
    @test shape(ex) == [1:1]
    @test symtype(ex) == Vector{Number}
    ex = mapreduce(+, +, f, g)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number

    ex = map(+, g, g)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number
    ex = mapreduce(+, +, g, g)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number
end

@testset "`mapreduce` kwargs" begin
    @syms a[1:4, 1:5, 1:6]

    ex = mapreduce(+, +, a; dims = 2)
    @test shape(ex) == [1:4, 1:1, 1:6]
    @test symtype(ex) == Array{Number, 3}
    io = IOBuffer()
    print(io, ex)
    str = String(take!(io))
    @test str == "mapreduce(+, +, a; dims = 2)"
    @test toexpr(ex) == :($mapreduce($+, $+, a; dims = 2))

    ex = mapreduce(+, +, a; init = 2)
    @test shape(ex) == UnitRange{Int}[]
    @test symtype(ex) == Number
    io = IOBuffer()
    print(io, ex)
    str = String(take!(io))
    @test str == "mapreduce(+, +, a; init = 2)"
    @test toexpr(ex) == :($mapreduce($+, $+, a; init = 2))

    ex = mapreduce(+, +, a; dims = 2, init = 3)
    @test shape(ex) == [1:4, 1:1, 1:6]
    @test symtype(ex) == Array{Number, 3}
    io = IOBuffer()
    print(io, ex)
    str = String(take!(io))
    @test str == "mapreduce(+, +, a; dims = 2, init = 3)"
    @test toexpr(ex) == :($mapreduce($+, $+, a; dims = 2, init = 3))
end

@testset "CSE works" begin
    @syms x[1:4, 1:4] y[1:4, 1:4]
    ex = @arrayop (i, j) x[i, k] * y[k, j]
    xval = rand(4, 4)
    yval = rand(4, 4)
    expr = quote
        let x = $xval, y = $yval
            $(Code.toexpr(Code.cse(ex)))
        end
    end
    @test eval(expr) ≈ xval * yval
end

@testset "ArrayOp: nested substitution scoping (#876)" begin
    using SymbolicUtils: idxs_for_arrayop, ArrayOp, term, scalarize

    @syms A[1:3]
    i = idxs_for_arrayop(SymReal)[1]

    inner = ArrayOp{SymReal}([i], 2A[i], +, nothing, Dict(i => 1:3))
    expr  = term(getindex, inner, i) + 1
    outer = ArrayOp{SymReal}([i], expr, +, nothing, Dict(i => 1:3))

    @test isequal(scalarize(outer), [2A[1]+1, 2A[2]+1, 2A[3]+1])
end

@testset "Array summand reconstruction (no `vector ^ 1`)" begin
    using SymbolicUtils: ismul, ACDict, Mul

    @syms y[1:3] w[1:3]

    @test isequal(y - y + y + y, 2y)
    @test isequal(y - y, 0y)
    @test isequal(y + w - y, w)

    # Reconstructing a `coeff * vector` summand must not raise the vector base to a
    # power (`y ^ 1`), which `^` rejects for non-matrix arrays.
    ex = 2y + 3w
    @test all(s -> operation(s) === (*) && length(arguments(s)) == 2, arguments(ex))

    # `Mul` keeps the invariant directly: an array base never becomes a MUL key.
    m = Mul{SymReal}(3, ACDict{SymReal}(y => 1))
    @test operation(m) === (*) && !ismul(m)
    @test isequal(Mul{SymReal}(1, ACDict{SymReal}(y => 1)), y)  # coeff 1, power 1 -> bare vector
end

@testset "scalarize shares reused sub-expressions" begin
    @syms x[1:3]::Real R[1:3, 1:3]::Real
    xv = scalarize(x); Rm = scalarize(R)

    # Orthonormal frame reused at several nesting levels, as a corotational beam
    # element does; `BasicSymbolic` hash-consing makes this a shared DAG.
    frame(d, M) = begin
        e1 = d ./ sqrt(sum(abs2, d))
        y = M[:, 2]
        e2raw = y .- sum(y .* e1) .* e1
        e2 = e2raw ./ sqrt(sum(abs2, e2raw))
        e3 = e1 × e2
        [e1[1] e2[1] e3[1]; e1[2] e2[2] e3[2]; e1[3] e2[3] e3[3]]
    end
    nested(E, M, depth) = begin
        A = E
        for _ in 1:depth
            A = (E' * M) * A
        end
        A * [A[1, 1], A[2, 2], A[3, 3]]
    end

    E = frame(xv, Rm)
    sc = scalarize.(nested(E, Rm, 3))

    xn = [1.1, 0.3, -0.7]
    Rn = [0.2 -0.9 0.4; 1.3 0.1 -0.5; 0.6 -0.2 0.8]
    ref = nested(frame(xn, Rn), Rn, 3)

    d = Dict(vcat(vec(xv .=> xn), vec(Rm .=> Rn)))
    got = [unwrap_const(substitute(e, d; fold = Val(true))) for e in sc]
    @test got ≈ ref
end

"""
    Substituter{Fold}

An abstract supertype for functors that perform substitution operations on symbolic
expressions. This can also be used as a constructor for the functor used by
[`substitute`](@ref). `Fold` corresponds to the `fold` keyword of `substitute`. Passing
`fold = Val(true)` corresponds to `Substituter{true}` (and similarly for `Val(false)`). To
define substitution rules for custom types that wrap/contain [`BasicSymbolic`](@ref),
define methods for this abstract type. For example,

```julia
struct Equation
    lhs::BasicSymbolic{SymReal}
    rhs::BasicSymbolic{SymReal}
end

function (subst::Substituter)(eq::Equation)
    return Equation(subst(eq.lhs), subst(eq.rhs))
end
```

Custom substitution algorithms should define functors that subtype `Substituter`. For
example, a functor may be defined for substituting until the expression reaches a fixpoint.
These functors should then implement:
- `(s::Substituter{Fold})(ex::BasicSymbolic{T}) where {T}` to perform the appropriate
  substitution on the given symbolic expression.
- `get_substitution_dict(::Substituter)` returning an `AbstractDict` of the substitution rules.

Instead of repeatedly calling `substitute` with the same rules, it is usually more
efficient to build a `Substituter` and reuse it.

`Substituter` is also allowed to cache intermediate results as necessary. When
constructing `Substituter` with an `AbstractDict`, it will alias the provided
mapping. Mutating the map such that the identity of the substitution rules
changes invalidates the substituter. It can be reused by clearing the
cache using [`SymbolicUtils.clear_cache!`](@ref).

The caching is only available when the [`SymbolicUtils.vartype`](@ref) of the
expressions is inferable from the substitution rules, or explicitly specified.
As long as either the keys or values of the substitution rules are all
`BasicSymbolic{T}` (for some `T`) the automatic inference will work. To allow
the inference to work for your custom wrapper type, implement
[`SymbolicUtils.infer_vartype`](@ref). For example:

```julia
struct Num <: Real
  inner::BasicSymbolic{SymReal}
end

SymbolicUtils.infer_vartype(::Type{Num}) = SymReal
```

Alternatively, the vartype can be provided as the third positional argument
to the `Substituter` constructor.

# Extended help

The following is internal details of `Substituter` and should not be relied on
as public API.

## Fields

$TYPEDFIELDS
"""
abstract type Substituter{Fold} end

struct DefaultSubstituter{Fold, D <: AbstractDict, F, C} <: Substituter{Fold}
    """
    The `AbstractDict` of substitution rules.
    """
    dict::D
    """
    The filter function to eliminate trees that do not need substitution.
    """
    filter::F
    """
    Cache of intermediate results.
    """
    cache::C
end

"""
    $TYPEDSIGNATURES

Clear the cached values associated with `subst`. See the documentation of
[`SymbolicUtils.Substituter`](@ref) for more details.
"""
function clear_cache!(subst::DefaultSubstituter)
    empty!(subst.cache)
end

"""
    $TYPEDSIGNATURES

Get an `AbstractDict` of the substitution rules for the given
[`SymbolicUtils.Substituter`](@ref).
"""
get_substitution_dict(s::DefaultSubstituter) = s.dict

infer_vartype(x) = infer_vartype(typeof(x))
infer_vartype(::Type{T}) where {T} = Nothing
function infer_vartype(::Type{D}) where {K, V, D <: AbstractDict{K, V}}
    T = infer_vartype(K)
    if T !== Nothing
        return T
    end
    T = infer_vartype(V)
    if T !== Nothing
        return T
    end
    return Nothing
end
infer_vartype(::Type{BasicSymbolic{T}}) where {T} = T

# This exists more for backward compat than anything
Substituter{Fold}(args...) where {Fold} = DefaultSubstituter{Fold}(args...)

"""
    $METHODLIST
"""
@inline DefaultSubstituter{Fold}(d) where {Fold} = DefaultSubstituter{Fold}(d, default_substitute_filter)
@inline function DefaultSubstituter{Fold}(d::AbstractDict, filter::F, ::Type{Nothing}) where {Fold, F}
    return DefaultSubstituter{Fold, typeof(d), F, Nothing}(d, filter, nothing)
end
@inline function DefaultSubstituter{Fold}(d::AbstractDict, filter::F, ::Type{T}) where {Fold, F, T}
    # Since `substitute` retains metadata, this needs to be an `IdDict`. Otherwise, keys
    # with different metadata get cached to the same result.
    return DefaultSubstituter{Fold, typeof(d), F, IdDict{BasicSymbolic{T}, BasicSymbolic{T}}}(
        d, filter, IdDict{BasicSymbolic{T}, BasicSymbolic{T}}()
    )
end
@inline function DefaultSubstituter{Fold}(d::AbstractDict, filter) where {Fold}
    return DefaultSubstituter{Fold}(d, filter, infer_vartype(d))
end
@inline function DefaultSubstituter{Fold}(d::Pair, filter::F) where {Fold, F}
    DefaultSubstituter{Fold}(OrderedDict(d), filter)
end
@inline function DefaultSubstituter{Fold}(d::AbstractArray{<:Pair}, filter::F) where {Fold, F}
    DefaultSubstituter{Fold}(OrderedDict(d), filter)
end

function (s::Substituter)(ex)
    return get(get_substitution_dict(s), ex, ex)
end

function (s::Substituter)(ex::AbstractArray)
    [s(x) for x in ex]
end

function (s::Substituter)(ex::SparseMatrixCSC)
    I, J, V = findnz(ex)
    V = s(V)
    m, n = size(ex)
    return sparse(I, J, V, m, n)
end

function (s::DefaultSubstituter{Fold})(ex::BasicSymbolic{T}) where {T, Fold}
    result = unwrap(get(s.dict, ex, nothing))
    result === nothing || return Const{T}(result)
    iscall(ex) || return ex
    s.filter(ex) || return ex
    if s.cache !== nothing
        result = get(s.cache, ex, nothing)
        result === nothing || return result
    end
    op = operation(ex)
    # We need to `unwrap_const` because `op` could be a symbolic function with
    # a substitution in `s.dict`, in which case this method will be called recursively
    # and return a symbolic result.
    _op = unwrap_const(s(op))

    args = arguments(ex)
    dirty = false
    can_fold = !(_op isa BasicSymbolic{T})
    newargs = parent(args)
    for i in eachindex(args)
        arg = args[i]
        # This is `unsafe` because comparing `Const` equality is cheap, and we don't want to
        # pay the cost of hashconsing if it is identical.
        newarg = Const{T}(s(arg); unsafe = true)
        if arg === newarg || @manually_scope COMPARE_FULL => true isequal(arg, newarg)::Bool true
            can_fold &= isconst(arg)
            continue
        end
        newarg = hashcons(newarg)
        if !dirty
            newargs = copy(parent(args))::ArgsT{T}
        end
        dirty = true
        can_fold &= isconst(newarg)
        newargs[i] = newarg
    end
    dirty |= op !== _op
    result = if dirty || can_fold
        if Fold
            combine_fold(T, _op, newargs, metadata(ex), can_fold)::BasicSymbolic{T}
        else
            maketerm(BasicSymbolic{T}, _op, newargs, metadata(ex))::BasicSymbolic{T}
        end
    else
        ex
    end
    if s.cache !== nothing
        s.cache[ex] = result
    end
    return result
end

function combine_fold(::Type{T}, op, args::Union{ROArgsT{T}, ArgsT{T}}, meta::MetadataT, can_fold::Bool) where {T}
    @nospecialize op args meta
    if can_fold
        if length(args) == 1
            Const{T}(op(unwrap_const(args[1])))
        elseif length(args) == 2
            Const{T}(op(unwrap_const(args[1]), unwrap_const(args[2])))
        elseif length(args) == 3
            Const{T}(op(unwrap_const(args[1]), unwrap_const(args[2]), unwrap_const(args[3])))
        else
            Const{T}(op(unwrap_const.(args)...))
        end
    else
        maketerm(BasicSymbolic{T}, op, args, meta)::BasicSymbolic{T}
    end
end

"""
    $TYPEDSIGNATURES

The default filter function used by [`substitute`](@ref) to determine whether to substitute
within an expression. Returns `false` for expressions that are `Term`s with an `Operator` as
the operation (preventing substitution within operator calls), and `true` otherwise.

# Arguments
- `ex::BasicSymbolic{T}`: The expression to check.

# Returns
- `Bool`: `false` if the expression should not be substituted into, `true` otherwise.
"""
@inline function default_substitute_filter(ex::BasicSymbolic{T}) where {T}
    @match ex begin
        BSImpl.Term(; f) && if f isa Operator end => false
        BSImpl.Term(; f) && if f isa BasicSymbolic{T} end => is_function_symbolic(f)
        _ => true
    end
end

"""
    substitute(expr, dict; fold=Val(false))

substitute any subexpression that matches a key in `dict` with
the corresponding value. If `fold=Val(false)`,
expressions which can be evaluated won't be evaluated.

```julia-repl
julia> substitute(1+sqrt(y), Dict(y => 2), fold=Val(true))
2.414213562373095
julia> substitute(1+sqrt(y), Dict(y => 2), fold=Val(false))
1 + sqrt(2)
```
"""
function substitute(expr, dict; fold::Val{Fold}=Val{false}(), filterer=default_substitute_filter) where {Fold}
    # This is kind of ugly (inlines some of the constructor logic of `DefaultSubstituter` but is needed to avoid runtime subtyping in
    # when calling this function. It makes a very big difference in runtime.
    d = dict isa AbstractDict ? dict : OrderedDict(dict)
    isempty(d) && !Fold && return expr
    VT = infer_vartype(d)
    if VT === Nothing
        sub = DefaultSubstituter{Fold, typeof(d), typeof(filterer), Nothing}(d, filterer, nothing)
    else
        cache = IdDict{BasicSymbolic{VT}, BasicSymbolic{VT}}()
        sub = DefaultSubstituter{Fold, typeof(d), typeof(filterer), typeof(cache)}(d, filterer, cache)
    end
    return sub(expr)
end

const EMPTY_DICT = Dict{Int, Int}()

function evaluate(expr; filterer = default_substitute_filter)
    return substitute(expr, EMPTY_DICT; fold = Val{true}(), filterer)
end

"""
    $TYPEDSIGNATURES

Recursively search an expression tree to determine if any subexpression satisfies a given
predicate. This function traverses the expression tree and returns `true` if the predicate
returns `true` for any node in the tree.

# Arguments
- `predicate::F`: A function that takes an expression and returns a `Bool`.
- `expr::BasicSymbolic`: The expression to search.

# Keyword Arguments
- `recurse::G=iscall`: A function determining whether to recurse into a subexpression.
- `default::Bool=false`: The default value to return if the expression is not a call or
  recursion is prevented.

# Returns
- `Bool`: `true` if any subexpression satisfies the predicate, `false` otherwise.
"""
function query(predicate::F, expr::BasicSymbolic{T}; recurse::G = iscall, default::Bool = false) where {F, G, T}
    return _query(predicate, expr, recurse, default, nothing)
end
query(predicate::F, expr; kw...) where {F} = predicate(expr)

function _query(predicate::F, expr::BasicSymbolic{T}, recurse::G, default::Bool,
        _seen::Union{Base.IdSet{BasicSymbolic{T}}, Nothing}) where {F, G, T}
    predicate(expr) && return true
    iscall(expr) || return default
    recurse(expr) || return default

    # A node in `seen` was already explored
    # without ending the query, so revisiting cannot change the result.
    if _seen === nothing
        seen = Base.IdSet{BasicSymbolic{T}}()
    else
        seen = _seen
        expr in seen && return false
    end
    push!(seen, expr)

    return @match expr begin
        BSImpl.Term(; f, args) => begin
            for arg in args
                _query(predicate, arg, recurse, default, seen) && return true
            end
            false
        end
        BSImpl.AddMul(; dict) => begin
            for arg in keys(dict)
                _query(predicate, arg, recurse, default, seen) && return true
            end
            false
        end
        BSImpl.Div(; num, den) => _query(predicate, num, recurse, default, seen) || _query(predicate, den, recurse, default, seen)
        BSImpl.ArrayOp(; expr = inner_expr, term) => begin
            _query(predicate, @something(term, inner_expr), recurse, default, seen)
        end
        BSImpl.ArrayMaker(; values) => begin
            for arg in values
                _query(predicate, arg, recurse, default, seen) && return true
            end
            false
        end
    end
end
_query(predicate::F, expr, recurse, default::Bool, _seen) where {F} = predicate(expr)


search_variables!(buffer, expr; kw...) = nothing

"""
    $(TYPEDSIGNATURES)

The default `is_atomic` predicate for [`search_variables!`](@ref). `ex` is considered
atomic if one of the following conditions is true:
- It is a `Sym` and not an internal index variable for an arrayop
- It is a `Term`, the operation is a `BasicSymbolic` and the operation represents a
  dependent variable according to [`is_function_symbolic`](@ref).
- It is a `Term`, the operation is `getindex` and the variable being indexed is atomic.
"""
function default_is_atomic(ex::BasicSymbolic{T}) where {T}
    @match ex begin
        BSImpl.Sym(; name) => name !== IDXS_SYM
        BSImpl.Term(; f) && if f isa Operator end => true
        BSImpl.Term(; f) && if f isa BasicSymbolic{T} end => !is_function_symbolic(f)
        BSImpl.Term(; f, args) && if f === getindex end => default_is_atomic(args[1])
        _ => false
    end
end

"""
    $(TYPEDSIGNATURES)

Find all variables used in `expr` and add them to `buffer`. A variable is identified by the
predicate `is_atomic`. The predicate `recurse` determines whether to search further inside
`expr` if it is not a variable. Note that `recurse` must at least return `false` if
`iscall` returns `false`.

Wrappers for [`BasicSymbolic`](@ref) should implement this function by unwrapping.

See also: [`default_is_atomic`](@ref).
"""
function search_variables!(buffer, expr::BasicSymbolic{T}; is_atomic::F = default_is_atomic, recurse::G = iscall, _seen::Union{Base.IdSet{BasicSymbolic{T}}, Nothing} = nothing) where {T, F, G}
    if is_atomic(expr)
        push!(buffer, expr)
        return nothing
    end
    recurse(expr) || return nothing
    seen = _seen === nothing ? Base.IdSet{BasicSymbolic{T}}() : _seen
    _search_variables_impl!(buffer, expr, is_atomic, recurse, seen)
    return nothing
end

function _search_variables_impl!(buffer, expr::BasicSymbolic{T}, is_atomic::F, recurse::G, seen::Base.IdSet{BasicSymbolic{T}}) where {T, F, G}
    expr in seen && return nothing
    push!(seen, expr)
    if is_atomic(expr)
        push!(buffer, expr)
        return nothing
    end
    recurse(expr) || return nothing
    @match expr begin
        BSImpl.Term(; f, args) => begin
            if f isa BasicSymbolic{T}
                _search_variables_impl!(buffer, f, is_atomic, recurse, seen)
            end
            for arg in args
                _search_variables_impl!(buffer, arg, is_atomic, recurse, seen)
            end
        end
        BSImpl.AddMul(; dict) => begin
            for k in keys(dict)
                _search_variables_impl!(buffer, k, is_atomic, recurse, seen)
            end
        end
        BSImpl.Div(; num, den) => begin
            _search_variables_impl!(buffer, num, is_atomic, recurse, seen)
            _search_variables_impl!(buffer, den, is_atomic, recurse, seen)
        end
        BSImpl.ArrayOp(; expr = inner_expr, term) => begin
            _search_variables_impl!(buffer, @something(term, inner_expr), is_atomic, recurse, seen)
        end
        BSImpl.ArrayMaker(; values) => @union_split_smallvec values for val in values
            _search_variables_impl!(buffer, val, is_atomic, recurse, seen)
        end
    end
    return nothing
end

function search_variables!(buffer, expr::Union{AbstractArray, AbstractSet}; kw...)
    for el in expr
        search_variables!(buffer, unwrap(el); kw...)
    end
end
function search_variables!(buffer, expr::SparseMatrixCSC; kw...)
    _, _, V = findnz(expr)
    search_variables!(buffer, V; kw...)
end

_default_buffer(::BasicSymbolic{T}) where {T} = OrderedSet{BasicSymbolic{T}}()
_default_buffer(x::Any) = unwrap(x) === x ? Set() : _default_buffer(unwrap(x))

function search_variables(expr; kw...)
    buffer = _default_buffer(expr)
    search_variables!(buffer, expr; kw...)
    return buffer
end

struct ArrayOpReduceCache{T}
    new_ranges::RangesT{T}
    subrules::OrderedDict{BasicSymbolic{T}, Int}
    collapsed_idxs::OrderedSet{BasicSymbolic{T}}
    collapsed_ranges::Vector{StepRange{Int, Int}}
end

function ArrayOpReduceCache{T}() where {T}
    ArrayOpReduceCache{T}(RangesT{T}(), OrderedDict{BasicSymbolic{T}, Int}(), OrderedSet{BasicSymbolic{T}}(), StepRange{Int, Int}[])
end

function Base.empty!(x::ArrayOpReduceCache)
    empty!(x.new_ranges)
    empty!(x.subrules)
    empty!(x.collapsed_idxs)
    empty!(x.collapsed_ranges)
    return x
end

const ARRAYOP_REDUCE_SYMREAL = TaskLocalValue{ArrayOpReduceCache{SymReal}}(ArrayOpReduceCache{SymReal})
const ARRAYOP_REDUCE_SAFEREAL = TaskLocalValue{ArrayOpReduceCache{SafeReal}}(ArrayOpReduceCache{SafeReal})

arrayop_reduce_cache(::Type{SymReal}) = empty!(ARRAYOP_REDUCE_SYMREAL[])
arrayop_reduce_cache(::Type{SafeReal}) = empty!(ARRAYOP_REDUCE_SAFEREAL[])

function _reduce_eliminated_idxs(expr::BasicSymbolic{T}, output_idx::OutIdxT{T}, ranges::RangesT{T}, @nospecialize(reduce)) where {T}
    cache = arrayop_reduce_cache(T)
    new_ranges = cache.new_ranges
    subrules = cache.subrules
    new_expr = Code.unidealize_indices(expr, ranges, new_ranges)
    merge!(new_ranges, ranges)
    collapsed = cache.collapsed_idxs
    union!(collapsed, keys(new_ranges))
    setdiff!(collapsed, output_idx)
    collapsed_ranges = cache.collapsed_ranges
    for i in collapsed
        push!(collapsed_ranges, new_ranges[i])
    end
    return mapreduce(reduce, Iterators.product(collapsed_ranges...)) do iidxs
        for (idx, ii) in zip(iidxs, collapsed)
            subrules[ii] = idx
        end
        return substitute(new_expr, subrules)::BasicSymbolic{T}
    end::BasicSymbolic{T}
end

struct IdHashWrapper{T}
    val::T
    h::UInt
end
IdHashWrapper(x) = IdHashWrapper(x, objectid(x))
Base.hash(x::IdHashWrapper, h::UInt) = hash(x.h, h)
Base.isequal(a::IdHashWrapper, b::IdHashWrapper) = a.val === b.val

@cache function reduce_eliminated_idxs_1(expr::BasicSymbolic{SymReal}, output_idx::OutIdxT{SymReal}, ranges_wrapped::IdHashWrapper{RangesT{SymReal}}, reduce)::BasicSymbolic{SymReal}
    @nospecialize reduce
    _reduce_eliminated_idxs(expr, output_idx, ranges_wrapped.val, reduce)::BasicSymbolic{SymReal}
end
@cache function reduce_eliminated_idxs_2(expr::BasicSymbolic{SafeReal}, output_idx::OutIdxT{SafeReal}, ranges_wrapped::IdHashWrapper{RangesT{SafeReal}}, reduce)::BasicSymbolic{SafeReal}
    @nospecialize reduce
    _reduce_eliminated_idxs(expr, output_idx, ranges_wrapped.val, reduce)::BasicSymbolic{SafeReal}
end

"""
    $TYPEDSIGNATURES

Reduce (collapse) all indices in an `ArrayOp` expression that are not present in the output
index list. This function performs a reduction operation (like summation) over the eliminated
indices by substituting concrete values for each eliminated index and combining the results
using the provided reduction function.

# Arguments
- `expr::BasicSymbolic{T}`: The expression containing indices to be reduced.
- `output_idx::OutIdxT{T}`: The indices that should remain in the output (not reduced).
- `ranges::RangesT{T}`: A dictionary mapping indices to their ranges.
- `reduce`: The reduction function to apply (e.g., `+` for summation).

# Returns
- `BasicSymbolic{T}`: The expression with eliminated indices reduced according to the
  reduction function.
"""
function reduce_eliminated_idxs(expr::BasicSymbolic{T}, output_idx::OutIdxT{T}, ranges::RangesT{T}, @nospecialize(reduce)) where {T}
    wrapped = IdHashWrapper(ranges)
    if T === SymReal
        return reduce_eliminated_idxs_1(expr, output_idx, wrapped, reduce)::BasicSymbolic{T}
    elseif T === SafeReal
        return reduce_eliminated_idxs_2(expr, output_idx, wrapped, reduce)::BasicSymbolic{T}
    end
    _unreachable()
end

"""
    $TYPEDSIGNATURES

Given a function `f`, return a function that will scalarize an expression with `f` as the
head. The returned function is passed `f`, the expression with `f` as the head, and
`Val(true)` or `Val(false)` indicating whether to recursively scalarize or not.

This function provides a dispatch mechanism for customizing scalarization behavior based on
the operation type. Different operations may require different scalarization strategies
(e.g., array operations, determinants, indexing operations).

# Arguments
- `f`: The function/operation to get a scalarization function for.

# Returns
- A function that takes `(f, x::BasicSymbolic{T}, ::Val{toplevel})` and returns the
  scalarized form of `x`.
"""
scalarization_function(@nospecialize(_)) = _default_scalarize

scalarization_function(::typeof(+)) = _scalarize_add

function _scalarize_add(f, x::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    @nospecialize f
    args = arguments(x)
    reduce(+, map(unwrap_const ∘ Base.Fix2(scalarize, Val{toplevel}()), args))
end

scalarization_function(::typeof(*)) = _scalarize_mul

function _scalarize_mul(f, x::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    @nospecialize f
    args = arguments(x)
    scal_args = map(Base.Fix2(scalarize, Val{toplevel}()), args)
    is_array_shape(shape(x)) || return mul_worker(T, scal_args)
    is_array_shape(shape(args[1])) && return mapreduce(unwrap_const, *, scal_args)
    coeff = scal_args[1]
    res = mapreduce(unwrap_const, *, @view(scal_args[2:end]))
    return map(Base.Fix2(*, coeff), res)
end

scalarization_function(::typeof(broadcast)) = _scalarize_broadcast

function _scalarize_broadcast(f, x::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    @nospecialize f
    args = arguments(x)
    scal_args = Vector{Any}(undef, length(args))
    map!(unwrap_const ∘ Base.Fix2(scalarize, Val{toplevel}()), scal_args, args)
    for i in eachindex(scal_args)
        val = scal_args[i]
        if val isa BasicSymbolic{T}
            @assert !is_array_shape(shape(val))
            scal_args[i] = Ref(val)
        end
    end
    return broadcast(scal_args...)
end

scalarization_function(::Union{typeof(adjoint), typeof(transpose)}) = _scalarize_adjoint_transpose

function _scalarize_adjoint_transpose(f, x::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    @nospecialize f
    args = arguments(x)
    val = scalarize(args[1], Val{toplevel}())::Array{BasicSymbolic{T}}
    if f === adjoint
        return adjoint(val)
    elseif f === transpose
        return transpose(val)
    end
    _unreachable()
end

scalarization_function(::typeof(/)) = _scalarize_rdiv

function _scalarize_rdiv(f, x::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    @nospecialize f
    args = arguments(x)
    num = scalarize(args[1], Val{toplevel}())
    den = scalarize(args[2], Val{toplevel}())
    shnum = shape(num)
    shden = shape(den)
    if !is_array_shape(shnum) && !is_array_shape(shden)
        return num / den
    elseif !is_array_shape(shden)
        return map(Base.Fix2(/, den), num)
    else
        res = num / den
        return BasicSymbolic{T}[res[i] for i in eachindex(res)]
    end
end

scalarization_function(::typeof(\)) = _scalarize_ldiv

function _scalarize_ldiv(f, x::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    @nospecialize f
    args = arguments(x)
    fst = scalarize(args[1], Val{toplevel}())
    lst = scalarize(args[2], Val{toplevel}())
    shfst = shape(fst)
    shlst = shape(lst)
    if !is_array_shape(shfst) && !is_array_shape(shlst)
        return fst \ lst
    elseif !is_array_shape(shfst)
        return map(Base.Fix2(/, fst), lst)
    else
        return BasicSymbolic{T}[x[i] for i in eachindex(x)]
    end
end

scalarization_function(::Union{typeof(-), typeof(^)}) = _default_scalarize_array
function _default_scalarize_array(f, x::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    @nospecialize f
    args = arguments(x)
    if toplevel
        f(map(unwrap_const, args)...)
    else
        f(map(unwrap_const ∘ Base.Fix2(scalarize, Val{toplevel}()), args)...)
    end
end

function _default_scalarize(f, x::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    @nospecialize f

    sh = shape(x)
    is_array_shape(sh) && return [x[idx] for idx in eachindex(x)]

    args = arguments(x)
    if toplevel
        f(map(unwrap_const, args)...)
    else
        f(map(unwrap_const ∘ scalarize, args)...)
    end
end

scalarization_function(::Fill) = _scalarize_fill
# Fast path for scalarizing a constant `Fill` array
function _scalarize_fill(f, x::BasicSymbolic{T}, v::Val{toplevel}) where {T, toplevel}
    @nospecialize f
    sh = shape(x)
    is_array_shape(sh) || return _default_scalarize(f, x, v)
    val = @match x begin
        BSImpl.ArrayOp(; expr) => expr
        _ => nothing
    end
    if val isa BasicSymbolic{T} && !is_array_shape(shape(val))
        return fill(val, map(length, sh)...)
    end
    return _default_scalarize(f, x, v)
end

scalarization_function(::Type{ArrayOp{T}}) where {T} = _scalarize_arrayop

function _scalarize_arrayop(_, x::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    @match x begin
        BSImpl.ArrayOp(; output_idx, expr, term, ranges, reduce, shape = sh) => begin
            subrules = OrderedDict()
            new_expr = reduce_eliminated_idxs(expr, output_idx, ranges, reduce)
            empty!(subrules)

            scope_filter = function (y)
                @match y begin
                    BSImpl.ArrayOp(; output_idx=_) => false
                    _ => true
                end
            end

            res = map(Iterators.product(sh...)) do idxs
                for (i, ii) in enumerate(output_idx)
                    ii isa Int && continue
                    subrules[ii] = idxs[i]
                end

                if toplevel
                    substitute(new_expr, subrules; filterer = scope_filter, fold = Val{true}())
                else
                    scalarize(substitute(new_expr, subrules; filterer = scope_filter, fold = Val{true}()))
                end
            end
            return isempty(sh) ? res[] : res
        end
    end
end

scalarization_function(::Type{ArrayMaker{T}}) where {T} = _scalarize_arraymaker

function _scalarize_arraymaker(_, x::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    sh = shape(x)::ShapeVecT
    buffer = Array{BasicSymbolic{T}}(undef, size(x))
    regbuf = ShapeVecT()
    sizehint!(regbuf, length(sh))
    @match x begin
        BSImpl.ArrayMaker(; regions, values) => begin
            @union_split_smallvec regions @union_split_smallvec values @union_split_smallvec sh begin
                for (reg, val) in zip(regions, values)
                    empty!(regbuf)
                    @union_split_smallvec reg for (ax, canonical_ax) in zip(reg, sh)
                        offset = first(canonical_ax)
                        push!(regbuf, (first(ax) - offset + 1):(last(ax) - offset + 1))
                    end
                    setindex!(buffer, scalarize(val, Val{toplevel}())::AbstractArray{BasicSymbolic{T}}, regbuf...)
                end
            end
        end
    end
    return buffer
end

scalarization_function(::Mapper) = _scalarize_arrayop
scalarization_function(::Mapreducer) = _scalarize_arrayop

function _scalarize_norm(_, x::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    @match x begin
        BSImpl.Term(; args) => begin
            if length(args) == 1
                return sqrt(scalarize(sum(abs2, args[1]), Val{toplevel}())::BasicSymbolic{T})
            end
            @match args[2] begin
                BSImpl.Const(;val) => begin
                    if val === Inf
                        return scalarize(mapreduce(abs, max, args[1]), Val{toplevel}())::BasicSymbolic{T}
                    elseif val === -Inf
                        return scalarize(mapreduce(abs, min, args[1]), Val{toplevel}())::BasicSymbolic{T}
                    elseif safe_isinteger(val::Number) && iseven(Int(val::Number))
                        exp = Int(val::Number)
                        return (sum(scalarize(args[1], Val{toplevel}()) .^ args[2])) ^ (1 / args[2])
                    else
                        return (sum(abs.(scalarize(args[1], Val{toplevel}())) .^ args[2])) ^ (1 / args[2])
                    end
                end
                _ => return (sum(scalarize(args[1], Val{toplevel}()) .^ args[2])) ^ (1 / args[2])
            end
        end
    end
end

scalarization_function(::typeof(LinearAlgebra.norm)) = _scalarize_norm

function scalarize_uncache(v)
    v isa SparseMatrixCSC && return copy(v)
    v isa AbstractArray && return collect(v)
    return v
end

"""
    $TYPEDSIGNATURES

Convert a symbolic expression with array operations into a fully scalarized form. This function
expands array operations into element-wise operations, converting symbolic array expressions
into arrays of scalar symbolic expressions.

For `ArrayOp` expressions, this function reduces eliminated indices and substitutes concrete
values for output indices to generate scalar expressions for each array element.

# Arguments
- `x::BasicSymbolic{T}`: The symbolic expression to scalarize.
- `::Val{toplevel}=Val{false}()`: Whether to evaluate constant expressions at the top level.
  When `true`, constant subexpressions are evaluated; when `false`, they are recursively
  scalarized.

# Returns
- The scalarized expression. For array-shaped expressions, returns an array of scalar
  expressions. For scalar expressions, returns the expression unchanged or with recursively
  scalarized subexpressions.
"""
function scalarize(x::BasicSymbolic{T}, v::Val{toplevel} = Val{false}()) where {T, toplevel}
    return scalarize_uncache(scalarize_cached(x, v))
end

@cache function scalarize_cached(x::BasicSymbolic, v::Val)::Any
    scalarize_impl(x, v)
end

function scalarize_impl(x::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    sh = shape(x)
    sh isa Unknown && return x
    @match x begin
        BSImpl.Const(; val) => begin
            is_array_shape(sh) || return x
            if val isa SparseMatrixCSC
                I, J, V = findnz(val)
                V = Const{T}.(V)
                return sparse(I, J, V, size(val)::NTuple{2, Int}...)
            else
                return Const{T}.(val)
            end
        end
        BSImpl.Sym(;) => is_array_shape(sh) ? [x[idx] for idx in eachindex(x)] : x
        _ => begin
            f = operation(x)
            if f isa BasicSymbolic{T} || f isa Operator
                return length(sh) == 0 ? x : [x[idx] for idx in eachindex(x)]
            end
            return scalarization_function(f)(f, x, Val{toplevel}())
        end
    end
end
function scalarize(arr::AbstractArray, v::Val{toplevel} = Val{false}()) where {toplevel}
    map(Base.Fix2(scalarize, v), arr)
end
scalarize(x, _...) = x

scalarization_function(::typeof(inv)) = _inv_scal

function _inv_scal(::typeof(inv), x::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    sh = shape(x)
    (sh isa ShapeVecT && !isempty(sh)) ? [x[idx] for idx in eachindex(x)] : x
end

scalarization_function(::typeof(LinearAlgebra.det)) = _det_scal

function _det_scal(::typeof(LinearAlgebra.det), x::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    arg = arguments(x)[1]
    sh = shape(arg)
    sh isa Unknown && return collect(x)
    sh = sh::ShapeVecT
    isempty(sh) && return x
    sarg = toplevel ? collect(arg) : scalarize(arg)
    _det_scal(LinearAlgebra.det, T, sarg)
end

function _det_scal(::typeof(LinearAlgebra.det), ::Type{T}, x::AbstractMatrix) where {T}
    length(x) == 1 && return x[]
    add_buffer = BasicSymbolic{T}[]
    for i in 1:size(x, 1)
        ex = _det_scal(LinearAlgebra.det, T, view(x, setdiff(axes(x, 1), i), 2:size(x, 2)))
        push!(add_buffer, (isodd(i) ? 1 : -1) * x[i, 1] * ex)
    end
    return add_worker(T, add_buffer)
end

scalarization_function(::typeof(getindex)) = _getindex_scal

function _getindex_scal(::typeof(getindex), x::BasicSymbolic{T}, ::Val{toplevel}) where {T, toplevel}
    sh = shape(x)
    if length(sh) > 0
        return [x[idx] for idx in eachindex(x)]
    end
    args = MData.variant_getfield(x, BSImpl.Term, :args)
    idx = try
        StableIndex{Int}(x)
    catch
        nothing
    end
    if idx !== nothing
        return getindex(scalarize(args[1]), idx)
    end

    idxs = Iterators.map((-), Iterators.map(unwrap_const, Iterators.drop(args, 1)), Iterators.map(Base.Fix2((-), 1) ∘ first, shape(args[1])))
    return getindex(scalarize(args[1]), idxs...)
end

using Base: ImmutableDict

"""
    $TYPEDSIGNATURES

Check if a number is an integer and within safe bounds for `Int`.

# Arguments
- `x`: The value to check (either a `Number` or other type)

# Returns
- `true` if `x` is an integer with absolute value less than `typemax(Int)`, `false` otherwise

# Details
This function ensures that integer values are safe to convert to `Int` without overflow.
For non-numeric types, always returns `false`. The bounds check prevents issues with
very large integers that cannot be accurately represented as `Int`.
"""
safe_isinteger(@nospecialize(x::Number)) = isinteger(x) && abs(x) < typemax(Int)
safe_isinteger(x) = false

"""
    $TYPEDSIGNATURES

Safe power operation that handles special cases for symbolic and numeric values.

# Arguments
- `x`: The base (can be numeric or symbolic)
- `y`: The exponent (can be numeric or symbolic)

# Returns
- The result of `x^y` with special handling for edge cases

# Details
This function provides a safe implementation of exponentiation with special case handling:
- For numeric exponents: `y==0` returns `1`, `y<0` uses `inv(x)^(-y)` for numerical stability
- For symbolic values: delegates to `Base.:^` to maintain proper symbolic behavior
Multiple dispatch ensures correct behavior for all combinations of numeric and symbolic arguments.
"""
pow(x,y) = y==0 ? 1 : y<0 ? inv(x)^(-y) : x^y
pow(x::BasicSymbolic,y) = y==0 ? 1 : Base.:^(x,y)
pow(x, y::BasicSymbolic) = Base.:^(x,y)
pow(x::BasicSymbolic,y::BasicSymbolic) = Base.:^(x,y)

# Simplification utilities
"""
    $TYPEDSIGNATURES

Check if a term contains trigonometric or exponential functions.

# Arguments
- `term`: The symbolic term to check

# Returns
- `true` if the term contains any of: `sin`, `cos`, `tan`, `cot`, `sec`, `csc`, `exp`, `cosh`, `sinh`
- `false` otherwise

# Details
This function recursively searches a symbolic expression tree to determine if it contains
any trigonometric or exponential functions. It checks both the operation at the current
level and recursively checks all arguments. Used by simplification routines to identify
expressions requiring special handling.
"""
function has_trig_exp(term)
    !iscall(term) && return false
    fns = (sin, cos, tan, cot, sec, csc, exp, cosh, sinh)
    op = operation(term)

    if Base.@nany 9 i->fns[i] === op
        return true
    else
        return any(has_trig_exp, parent(arguments(term)))
    end
end

### Predicates

sym_isa(::Type{T}) where {T} = @nospecialize(x) -> x isa T || symtype(x) <: T

isliteral(::Type{T}) where {T} = x -> x isa T
is_literal_number(x) = isliteral(Number)(unwrap_const(x))

# checking the type directly is faster than dynamic dispatch in type unstable code
"""
    $TYPEDSIGNATURES

Check if a value is zero, with caching for performance.

# Arguments
- `x`: The value to check (can be a number, array, or symbolic expression)

# Returns
- `true` if the unwrapped value is zero, `false` otherwise

# Details
This cached function efficiently checks if a value is zero by first unwrapping any
constant wrappers. Handles both numeric values and arrays. Returns `false` for symbolic
expressions that are not constant zero. The `@cache` macro improves performance by
memoizing results for previously seen values.
"""
@cache function _iszero(x)::Bool
    @nospecialize x
    x = unwrap_const(unwrap(x))
    if x isa Int
        return iszero(x)
    elseif x isa BigInt
        return iszero(x)
    elseif x isa Float64
        return iszero(x)
    elseif x isa Float32
        return iszero(x)
    elseif x isa BigFloat
        return iszero(x)
    elseif x isa Rational{Int}
        return iszero(x)
    elseif x isa Rational{BigInt}
        return iszero(x)
    elseif x isa Bool
        return iszero(x)
    elseif x isa ComplexF64
        return iszero(x)
    elseif x isa ComplexF32
        return iszero(x)
    elseif x isa Complex{Int}
        return iszero(x)
    elseif x isa Complex{Rational{Int}}
        return iszero(x)
    elseif x isa Vector{Int}
        return iszero(x)
    elseif x isa Vector{Float64}
        return iszero(x)
    elseif x isa Matrix{Int}
        return iszero(x)
    elseif x isa Matrix{Float64}
        return iszero(x)
    elseif x isa Number
        return iszero(x)::Bool
    elseif x isa Array
        return iszero(x)::Bool
    else
        return false
    end
end
"""
    $TYPEDSIGNATURES

Check if a value is one, with caching for performance.

# Arguments
- `x`: The value to check (can be a number, array, or symbolic expression)

# Returns
- `true` if the unwrapped value is one, `false` otherwise

# Details
This cached function efficiently checks if a value is one by first unwrapping any
constant wrappers. Handles both numeric values and arrays. Returns `false` for symbolic
expressions that are not constant one. The `@cache` macro improves performance by
memoizing results for previously seen values.
"""
@cache function _isone(x)::Bool
    @nospecialize x
    x = unwrap_const(unwrap(x))
    if x isa Int
        return isone(x)
    elseif x isa BigInt
        return isone(x)
    elseif x isa Float64
        return isone(x)
    elseif x isa Float32
        return isone(x)
    elseif x isa BigFloat
        return isone(x)
    elseif x isa Rational{Int}
        return isone(x)
    elseif x isa Rational{BigInt}
        return isone(x)
    elseif x isa Bool
        return isone(x)
    elseif x isa ComplexF64
        return isone(x)
    elseif x isa ComplexF32
        return isone(x)
    elseif x isa Complex{Int}
        return isone(x)
    elseif x isa Complex{Rational{Int}}
        return isone(x)
    elseif x isa Vector{Int}
        return isone(x)
    elseif x isa Vector{Float64}
        return isone(x)
    elseif x isa Matrix{Int}
        return isone(x)
    elseif x isa Matrix{Float64}
        return isone(x)
    elseif x isa Number
        return isone(x)::Bool
    elseif x isa Array
        return isone(x)::Bool
    else
        return false
    end
end
"""
    $TYPEDSIGNATURES

Check if a value is an integer (numeric or symbolic with integer type).

# Arguments
- `x`: The value to check

# Returns
- `true` if `x` is a numeric integer or a symbolic with `Integer` symtype, `false` otherwise

# Details
This predicate returns `true` for both concrete integer values and symbolic expressions
with integer type annotations. Used in simplification and code generation to determine
when integer-specific optimizations can be applied.
"""
_isinteger(x) = (x isa Number && isinteger(x)) || (x isa BasicSymbolic && symtype(x) <: Integer)

"""
    $TYPEDSIGNATURES

Check if a value is real (numeric or symbolic with real type).

# Arguments
- `x`: The value to check

# Returns
- `true` if `x` is a numeric real or a symbolic with `Real` symtype, `false` otherwise

# Details
This predicate returns `true` for both concrete real values and symbolic expressions
with real type annotations. Used in simplification and rewriting to enable real-specific
mathematical transformations.
"""
_isreal(x) = (x isa Number && isreal(x)) || (x isa BasicSymbolic && symtype(x) <: Real)

issortedₑ(args) = issorted(args, lt=<ₑ)

"""
    $TYPEDSIGNATURES

Create a predicate that checks if an expression with operation `f` needs argument sorting.

# Arguments
- `f`: The operation to check for

# Returns
- A function that returns `true` if an expression has operation `f` and unsorted arguments

# Details
Returns a predicate function that checks whether a given expression:
1. Has operation `f`
2. Has arguments that are not sorted according to the `<ₑ` ordering

This is used in simplification to identify expressions that need canonicalization through
argument sorting.
"""
needs_sorting(f) = x -> is_operation(f)(x) && !issortedₑ(arguments(x))

# are there nested ⋆ terms?
"""
    $TYPEDSIGNATURES

Create a predicate that checks if an expression has nested operations of type `⋆`.

# Arguments
- `⋆`: The operation to check for nesting

# Returns
- A function that returns `true` if any argument has operation `⋆` (indicating nesting)

# Details
Returns a predicate function that checks whether an expression contains nested instances
of the same operation. For example, if `⋆` is `*`, this would detect `*(x, *(y, z))`
which should be flattened to `*(x, y, z)`. Used in normalization to identify expressions
that need flattening.
"""
function isnotflat(⋆)
    function (x)
        args = arguments(x)
        for t in args
            if iscall(t) && operation(t) === (⋆)
                return true
            end
        end
        return false
    end
end

"""
    $TYPEDSIGNATURES

Check if a sequence has consecutive repeated elements.

# Arguments
- `x`: A sequence (array or tuple) to check

# Returns
- `true` if any element is equal to the next element, `false` otherwise

# Details
This function scans through a sequence to detect consecutive duplicates. Returns `false`
for sequences of length 0 or 1. Uses `isequal` for comparison, which handles symbolic
expressions correctly. Used in simplification to identify terms that can be merged
(e.g., `x + x` → `2x`).
"""
function hasrepeats(x)
    length(x) <= 1 && return false
    for i=1:length(x)-1
        if isequal(x[i], x[i+1])
            return true
        end
    end
    return false
end

"""
    $TYPEDSIGNATURES

Merge consecutive repeated elements in a sequence using a combining function.

# Arguments
- `merge`: A function `(element, count) -> merged_value` to combine repeated elements
- `xs`: The sequence to process

# Returns
- A new sequence with consecutive repeats merged, or `false` if `xs` has length ≤ 1

# Details
This function scans through a sequence and merges consecutive equal elements by calling
`merge(element, count)` where `count` is the number of repetitions. For example, with
`merge = (x, n) -> n*x`, this transforms `[x, x, x, y]` to `[3x, y]`. Elements that
don't repeat are kept as-is. Uses `isequal` for comparison.
"""
function merge_repeats(merge, xs)
    length(xs) <= 1 && return false
    merged = Any[]
    i=1

    while i<=length(xs)
        l = 1
        for j=i+1:length(xs)
            if isequal(xs[i], xs[j])
                l += 1
            else
                break
            end
        end
        if l > 1
            push!(merged, merge(xs[i], l))
        else
            push!(merged, xs[i])
        end
        i+=l
    end
    return merged
end

"""
    flatten_term(⋆, x)

Return a flattened expression with the numbers at the back.

# Example
```jldoctest
julia> @syms x y;

julia> SymbolicUtils.flatten_term(+, y + y + x)
x + 2y
```
"""
function flatten_term(⋆, x)
    args = arguments(x)
    # flatten nested ⋆
    flattened_args = []
    for t in args
        if iscall(t) && operation(t) === (⋆)
            append!(flattened_args, arguments(t))
        else
            push!(flattened_args, t)
        end
    end
    maketerm(typeof(x), ⋆, flattened_args, metadata(x))
end

"""
    $TYPEDSIGNATURES

Sort the arguments of a term according to the canonical ordering `<ₑ`.

# Arguments
- `f`: The operation of the term
- `t`: The term whose arguments should be sorted

# Returns
- A new term with the same operation and metadata, but with arguments sorted by `<ₑ`

# Details
This function creates a canonical form for commutative operations by sorting arguments.
For 0-1 arguments, returns unchanged. For 2 arguments, performs a direct comparison.
For more arguments, sorts using the full `<ₑ` ordering. This ensures expressions like
`x + y` and `y + x` have the same representation.
"""
function sort_args(f, t)
    args = arguments(t)
    if length(args) < 2
        return maketerm(typeof(t), f, args, metadata(t))
    elseif length(args) == 2
        x, y = args
        return maketerm(typeof(t), f, x <ₑ y ? [x,y] : [y,x], metadata(t))
    end
    args = args isa Tuple ? [args...] : args
    maketerm(typeof(t), f, sort(args, lt=<ₑ), metadata(t))
end

# Linked List interface
@inline function assoc(d::ImmutableDict{Symbol, Any}, k::Symbol, v::Any)
    @nospecialize v
    ImmutableDict(d, k, unwrap_const(v))
end

struct LL{V}
    v::V
    i::Int
end

islist(x) = iscall(x) || !isempty(x)

Base.empty(l::LL) = empty(l.v)
Base.isempty(l::LL) = l.i > length(l.v)

Base.length(l::LL) = length(l.v)-l.i+1
@inline car(l::LL) = l.v[l.i]
@inline cdr(l::LL) = isempty(l) ? empty(l) : LL(l.v, l.i+1)

Base.length(t::Term) = length(arguments(t)) + 1 # PIRACY
Base.isempty(t::Term) = false
@inline car(t::Term) = operation(t)
@inline cdr(t::Term) = arguments(t)

@inline car(v) = iscall(v) ? operation(v) : first(v)
@inline function cdr(v)
    if iscall(v)
        arguments(v)
    else
        islist(v) ? LL(v, 2) : error("asked cdr of empty")
    end
end

@inline take_n(ll::LL, n) = isempty(ll) || n == 0 ? empty(ll) : @views ll.v[ll.i:n+ll.i-1] # @views handles Tuple
@inline take_n(ll, n) = @views ll[1:n]

@inline function drop_n(ll, n)
    if n === 0
        return ll
    else
        iscall(ll) ? drop_n(arguments(ll), n-1) : drop_n(cdr(ll), n-1)
    end
end
@inline drop_n(ll::Union{Tuple, AbstractArray}, n) = drop_n(LL(ll, 1), n)
@inline drop_n(ll::LL, n) = LL(ll.v, ll.i+n)

# Take a struct definition and make it be able to match in `@rule`
macro matchable(expr)
    @assert expr.head == :struct
    name = expr.args[2]
    if Meta.isexpr(name, :<:)
        name = name.args[1]
    end
    if name isa Expr && name.head === :curly
        name = name.args[1]
    end
    fields = filter(x-> !(x isa LineNumberNode), expr.args[3].args)
    get_name(s::Symbol) = s
    get_name(e::Expr) = (@assert(e.head == :(::)); e.args[1])
    fields = map(get_name, fields)
    quote
        # TODO: fix this to be not a call. Make pattern matcher work for these
        $expr
        SymbolicUtils.operation(::$name) = $name
        SymbolicUtils.arguments(x::$name) = getfield.((x,), ($(QuoteNode.(fields)...),))
        SymbolicUtils.children(x::$name) = [SymbolicUtils.operation(x); SymbolicUtils.children(x)]
        Base.length(x::$name) = $(length(fields) + 1)
        SymbolicUtils.maketerm(x::$name, f, args, metadata) = f(args...)
    end |> esc
end

"""
  node_count(t)
Count the nodes in a symbolic expression tree satisfying `iscall` and `arguments`.
"""
node_count(t) = iscall(t) ? reduce(+, node_count(x) for x in arguments(t), init = 0) + 1 : 1

const INVALID_MAKEARRAY_DEFINITION_MSG = """
The `@makearray` definition must be of the form `ident[start1:stop1, start2:stop2, ...]`.
"""

const INVALID_MAKEARRAY_SEQ_MSG = """
The LHS of each sequence entry in `@makearray` must be of the form \
`ident[start1:stop1, start2:stop2, ...]`.
"""

"""
    @makearray arr[shape...] begin
        arr[subarray...] => value
        # ...
    end

Construct an `ArrayMaker`. `ArrayMaker` symbolically represents an array
composed of blocks of other arrays. To demonstrate, consider the following example:

```julia
@syms x[1:3]::Real y[1:3]::Real z[1:3]::Real
w = @makearray foo[1:3, 1:3] begin
    foo[1:1, 1:3] => x'
    foo[2:2, 1:3] => @arrayop (1, i) y[i] + z[i]
    foo[3:3, 1:1] => [1;;]
    foo[3:3, 2:2] => [z[1];;]
    foo[3:3, 3:3] => [z'z;;]
end
```

The first argument to `@makearray` is an indexing expression denoting the shape of the
constructed array. The identifier used here (`foo`) is arbitrary. It has no bearing
on the result, and is only used as part of the macro syntax inside the `begin..end` block.

Each entry in the `begin..end` block is a pair denoting a subarray to assign, and the
value to assign it. Note that each subarray thus assigned must have the same number
of dimensions as the created array. In other words, inside the block `foo` can only be
indexed using ranges with a unit step (`UnitRange{Int}`). `foo[3, 1] => 1` is invalid
syntax and will error. The RHS of each pair (the value assigned to the subarray) must have
the same size as the subarray. Extra unit dimensions must be added as necessary, for
example via the `1` in `@arrayop (1, i) y[i] + z[i]`. The identifier `foo` has no
meaning if used in the RHS. It will simply refer to a variable named `foo` in the current
scope, if such a variable exists.

For convenience, `ArrayMaker` and `@makearray` allow assigning overlapping ranges. In such
cases, later assignments in `@makearray` override earlier ones. For example:

```julia
q = @makearray q[1:3] begin
    q[1:3] => x
    q[2:3] => y[1:2]
end
```

Here, `q` represents the array `[x[1], y[1], y[2]]`.

Nesting `@makearray` is permitted. The following is valid syntax:

```julia
w = @makearray w[1:3, 1:3] begin
    w[1:1, 1:3] => x'
    w[2:2, 1:3] => @makearray _[1:1, 1:3] begin
        _[1:1, 1:1] => [y[1];;]
        _[1:1, 2:3] => z'[:, 1:2]
    end
    w[3:3, 1:1] => [1;;]
    w[3:3, 2:2] => [z[1];;]
    w[3:3, 3:3] => [z'z;;]
end
```
"""
macro makearray(definition::Expr, sequence::Expr)
    shape = get_shape_from_ref_expr(definition, INVALID_MAKEARRAY_DEFINITION_MSG)
    regions = Expr[]
    values = Expr[]

    @assert Meta.isexpr(sequence, :block) """
    The `@makearray` sequence must be a `begin..end` block.
    """
    sequence = sequence::Expr
    for entry in sequence.args
        entry isa LineNumberNode && continue
        @assert Meta.isexpr(entry, :call) && (entry::Expr).args[1] == :(=>) """
        Each entry in the `@makearray` sequence must be of the form \
        `ident[start1:stop1, ...] => value`. Found $entry, which does not have `=>` as \
        the operation.
        """
        entry = entry::Expr
        region = get_shape_from_ref_expr(entry.args[2], INVALID_MAKEARRAY_SEQ_MSG, true)
        value = entry.args[3]
        push!(regions, region)
        push!(values, esc(value))
    end

    @assert length(regions) == length(values)
    innerhead = length(regions) <= 10 ? :tuple : :vect
    regions_expr = Expr(:call, RegionsT, tuple_or_vect(regions, innerhead))
    values_expr = tuple_or_vect(values, innerhead)

    result = :(let shape = $shape, values = $values_expr
        vartype = $vartype_from_values(values)
        regions = $regions_expr
        $ArrayMaker{vartype}(regions, values; shape)
    end)

    return result
end

function get_shape_from_ref_expr(def::Expr, err::String, parse_begin_end = false)
    @assert Meta.isexpr(def, :ref) err

    shape_tuple = Expr(:tuple)
    sizehint!(shape_tuple.args, length(def.args) - 1)
    for (i, arg) in enumerate(Iterators.drop(def.args, 1))
        @assert Meta.isexpr(arg, :call) && (arg::Expr).args[1] === :(:) err
        arg = arg::Expr
        @assert length(arg.args) == 3 """
        The ranges in `@makearray` must be unit ranges. They cannot have an explicit step \
        size. Found invalid range $arg.
        """
        if parse_begin_end
            arg = :(let var"begin" = $first(shape[$i]), var"end" = $last(shape[$i])
                        $(esc(arg))
                    end)
        else
            arg = esc(arg)
        end
        push!(shape_tuple.args, arg)
    end
    shape_expr = Expr(:call, ShapeVecT, shape_tuple)
    return shape_expr
end

function tuple_or_vect(vals::Vector{Expr}, innerhead::Symbol)
    vals_expr = Expr(innerhead)
    append!(vals_expr.args, vals)
    return vals_expr
end

function _vartype_from_values()
    error("""
    Could not infer vartype from `@arraymaker` macro usage. All values in the sequence \
    are not symbolic. Wrap at least one of the values in a `SymbolicUtils.Const` of the \
    appropriate vartype.
    """)
end
_vartype_from_values(::BasicSymbolic{T}, _...) where {T} = T
_vartype_from_values(fst, rest...) = _vartype_from_values(rest...)
vartype_from_values(vals::Tuple) = _vartype_from_values(vals...)
vartype_from_values(vals::Vector{BasicSymbolic{T}}) where {T} = T
function vartype_from_values(@nospecialize(vals::Vector))
    for val in vals
        if val isa BasicSymbolic{SymReal}
            return SymReal
        elseif val isa BasicSymbolic{SafeReal}
            return SafeReal
        elseif val isa BasicSymbolic{TreeReal}
            return TreeReal
        end
    end
    _vartype_from_values()
end

"""
    @syms <lhs_expr>[::T1] <lhs_expr>[::T2]...

For instance:

    @syms foo::Real bar baz(x, y::Real)::Complex

Create one or more variables. `<lhs_expr>` can be just a symbol in which case
it will be the name of the variable, or a function call in which case a function-like
variable which has the same name as the function being called. The Sym type, or
in the case of a function-like Sym, the output type of calling the function
can be set using the `::T` syntax.

# Examples:

- `@syms foo bar::Real baz::Int` will create
  variable `foo` of symtype `Number` (the default), `bar` of symtype `Real`
  and `baz` of symtype `Int`
- `@syms f(x) g(y::Real, x)::Int h(a::Int, f(b))` creates 1-arg `f` 2-arg `g`
  and 2 arg `h`. The second argument to `h` must be a one argument function-like
  variable. So, `h(1, g)` will fail and `h(1, f)` will work.

# Formal syntax

Following is a semi-formal CFG of the syntax accepted by this macro:

```python
# any variable accepted by this macro must be a `var`.
# `var` can represent a quantity (`value`) or a function `(fn)`.
var = value | fn
# A `value` is represented as a name followed by a suffix
value = name suffix
# A `name` can be a valid Julia identifier
name = ident |
# Or it can be an interpolated variable, in which case `ident` is assumed to refer to
# a variable in the current scope of type `Symbol` containing the name of this variable.
# Note that in this case the created symbolic variable will be bound to a randomized
# Julia identifier.
       "\$" ident |
# Or it can be of the form `Foo.Bar.baz` referencing a value accessible as `Foo.Bar.baz`
# in the current scope.
       getproperty_literal
getproperty_literal = ident "." getproperty_literal | ident "." ident
# The `suffix` can be empty (no suffix) which defaults the type to `Number`
suffix = "" |
# or it can be a type annotation (setting the type of the prefix). The shape of the result
# is inferred from the type as best it can be. In particular, `Array{T, N}` is inferred
# to have shape `Unknown(N)`.
         "::" type |
# or it can be a shape annotation, which sets the shape to the one specified by `ranges`.
# The type defaults to `Array{Number, length(ranges)}`
         "[" ranges "]" |
# lastly, it can be a combined shape and type annotation. Here, the type annotation
# sets the `eltype` of the symbolic array.
         "[" ranges "]::" type
# `ranges` is either a single `range` or a single range followed by one or more `ranges`.
ranges = range | range "," ranges
# A `range` is simply two bounds separated by a colon, as standard Julia ranges work.
# The range must be non-empty. Each bound can be a literal integer or an identifier
# representing an integer in the current scope.
range = (int | ident) ":" (int | ident) |
# Alternatively, a range can be a Julia expression that evaluates to a range. All identifiers
# used in `expr` are assumed to exist in the current scope.
        expr |
# Alternatively, a range can be a Julia expression evaluating to an iterable of ranges,
# followed by the splat operator.
        expr "..."
# A function is represented by a function-call syntax `fncall` followed by the `suffix`
# above. The type and shape from `suffix` represent the type and shape of the value
# returned by the symbolic function.
fn = fncall suffix
# a function call is a call `head` followed by a parenthesized list of arguments.
fncall = head "(" args ")"
# A function call head can be a name, representing the name of the symbolic function.
head = ident |
# Alternatively, it can be a parenthesized type-annotated name, where the type annotation
# represents the intended supertype of the function. In other words, if this symbolic
# function were to be replaced by an "actual" function, the type-annotation constrains the
# type of the "actual" function.
       "(" ident "::" type ")"
# Arguments to a function is a list of one or more arguments
args = arg | arg "," args
# An argument can take the syntax of a variable (which means we can represent functions of
# functions of functions of...). The type of the variable constrains the type of the
# corresponding argument of the function. The name and shape information is discarded.
arg = var |
# Or an argument can be an unnamed type-annotation, which constrains the type without
# requiring a name.
      "::" type |
# Or an argument can be the identifier `..`, which is used as a stand-in for `Vararg{Any}`
      ".." |
# Or an argument can be a type-annotated `..`, representing `Vararg{type}`. Note that this
# and the previous version of `arg` can only be the last element in `args` due to Julia's
# `Tuple` semantics.
      "(..)::" type |
# Or an argument can be a Julia expression followed by a splat operator. This assumes the
# expression evaluates to an iterable of symbolic variables whose `symtype` should be used
# as the argument types. Note that `expr` may be evaluated multiple times in the macro
# expansion.
      expr "..."
```
"""
macro syms(xs...)
    isempty(xs) && return ()
    _vartype = SymReal
    if Meta.isexpr(xs[end], :(=))
        x = xs[end]
        key, val = x.args
        @assert key == :vartype
        if val == :SymReal
            _vartype = SymReal
        elseif val == :SafeReal
            _vartype = SafeReal
        elseif val == :TreeReal
            _vartype = TreeReal
        else
            error("Invalid vartype $val")
        end
        xs = Base.front(xs)
    end
    expr = Expr(:block)
    allofem = Expr(:tuple)
    ntss = []
    for x in xs
        nts = parse_variable(x)
        push!(ntss, nts)
        res = sym_from_parse_result(nts, _vartype)
        if nts[:isruntime]
            varname = Symbol(nts[:name])
        else
            varname = esc(nts[:name])
        end
        res = :($varname = $res)
        push!(expr.args, res)
        push!(allofem.args, varname)
    end
    push!(expr.args, allofem)
    return expr
end

function syms_syntax_error(x)
    error("Incorrect @syms syntax $x. Try `@syms x::Real y::Complex g(a) f(::Real)::Real` for instance.")
end

const ParseDictT = Dict{Symbol, Any}

"""
    $TYPEDSIGNATURES

Return an `Expr` which constructs a `Sym` for the given parsed variable `result`. `vartype`
is the vartype of the variable to be constructed. `do_esc` controls whether this function
is responsible for `esc`ing necessary values, or the caller will manually sanitize and `esc`
the expression.
"""
function sym_from_parse_result(result::ParseDictT, vartype; do_esc = true)::Expr
    n, t, s = result[:name], result[:type], result[:shape]
    T = do_esc ? esc(t) : t
    s = do_esc ? esc(s) : s
    if result[:isruntime]::Bool
        varname = do_esc ? esc(n) : n
    else
        varname = Expr(:quote, n)
    end
    return :($Sym{$vartype}($(varname); type = $T, shape = $s))
end

"""
    $(TYPEDSIGNATURES)

Parse an `Expr` or `Symbol` representing a variable in the syntax of the `@syms` macro.
Returns a `$ParseDictT` with the following keys guaranteed to exist:

- `:name`: The name of the variable. `nothing` if not specified.
- `:type`: The type of the variable. `default_type` if not specified.
- `:shape`: The shape of the variable.
- `:isruntime`: Whether the name is a runtime value (comes from a `\$name` interpolation syntax).

This does not attempt to `eval` to interpret types. Values in the above keys are concrete
values when possible and `Expr`s when not.

If the variable is a function, it contains additional keys:

- `:head`: A `$ParseDictT` containing the name and type of the function.
- `:args`: A list of `$ParseDictT` corresponding to each argument of the function. If there
  is a single argument `..`, the only `$ParseDictT` in `:args` will only contain
  `:name => :..`. For arguments of the form `::T` (type annotation without a name) the
  name will be `nothing`.

Refer to the docstring for [`@syms`](@ref) for a description of the grammar accepted by
this function.
"""
Base.@nospecializeinfer function parse_variable(x; default_type = Number)::ParseDictT
    @nospecialize x
    x = unwrap(x)
    if x isa Symbol
        # just a symbol
        type = if x == :..
            Vararg{Any}
        else
            default_type
        end
        return ParseDictT(:name => x, :type => type, :shape => ShapeVecT(), :isruntime => false)
    elseif Meta.isexpr(x, :.)
        # just a symbol
        type = if x == :..
            Vararg{Any}
        else
            default_type
        end
        return ParseDictT(:name => x, :type => type, :shape => ShapeVecT(), :isruntime => true)
    elseif Meta.isexpr(x, :$)
        return ParseDictT(:name => x.args[1], :type => default_type, :shape => ShapeVecT(), :isruntime => true)
    elseif Meta.isexpr(x, :call)
        # a function
        head = x.args[1]
        args = x.args[2:end]
        result = ParseDictT()
        result[:head] = parse_variable(head; default_type = Nothing)
        fname = result[:head][:name]
        ftype = result[:head][:type]
        result[:args] = [parse_variable(arg; default_type) for arg in args]
        arg_types = [arg[:type] for arg in result[:args]]
        signature = :(Tuple{$(arg_types...)})
        result[:name] = fname
        result[:type] = :($FnType{$signature, $default_type, $ftype})
        result[:shape] = ShapeVecT()
        result[:isruntime] = result[:head][:isruntime]
        return result
    elseif Meta.isexpr(x, :ref)
        result = parse_variable(x.args[1]; default_type)
        shape = Expr(:call, ShapeVecT, Expr(:tuple, x.args[2:end]...))
        ntype = result[:type]
        ndim = 0
        for i in 2:length(x.args)
            if Meta.isexpr(x.args[i], :...)
                ndim = :($(ndim) + length($(x.args[i].args[1])))
            else
                ndim = ndim isa Int ? ndim + 1 : :($(ndim) + 1)
            end
        end
        if Meta.isexpr(ntype, :curly) && ntype.args[1] === FnType
            ntype.args[3] = :($Array{$(ntype.args[3]), $(ndim)})
        else
            ntype = :($Array{$ntype, $(ndim)})
        end
        result[:type] = ntype
        result[:shape] = shape
        return result
    elseif Meta.isexpr(x, :(::))
        if length(x.args) == 1
            type = x.args[1]
            shape = shape_from_type(type, ShapeVecT())
            return ParseDictT(:name => nothing, :type => x.args[1], :shape => shape)
        end
        head, type = x.args
        result = parse_variable(head; default_type)
        shape = shape_from_type(type, result[:shape])
        ntype = result[:type]
        if Meta.isexpr(ntype, :curly) && ntype.args[1] === FnType
            if Meta.isexpr(ntype.args[3], :curly) && ntype.args[3].args[1] === Array
                ntype.args[3].args[2] = type
            else
                ntype.args[3] = type
            end
        elseif Meta.isexpr(ntype, :curly) && ntype.args[1] === Array
            ntype.args[2] = type
        elseif head == :..
            ntype = :(Vararg{$type})
        else
            ntype = type
        end
        result[:type] = ntype
        result[:shape] = shape
        return result
    elseif Meta.isexpr(x, :...)
        result = ParseDictT()
        result[:name] = x
        result[:type] = :($symtype.($(x.args[1]))...)
        result[:shape] = nothing
        result[:isruntime] = false
        return result
    elseif x isa BasicSymbolic{SymReal}
        result = ParseDictT()
        result[:name] = SymbolicIndexingInterface.getname(x)
        result[:type] = symtype(x)
        result[:shape] = (@__MODULE__).shape(x)
        result[:isruntime] = false
        return result
    elseif x isa BasicSymbolic{SafeReal}
        result = ParseDictT()
        result[:name] = SymbolicIndexingInterface.getname(x)
        result[:type] = symtype(x)
        result[:shape] = (@__MODULE__).shape(x)
        result[:isruntime] = false
        return result
    elseif x isa BasicSymbolic{TreeReal}
        result = ParseDictT()
        result[:name] = SymbolicIndexingInterface.getname(x)
        result[:type] = symtype(x)
        result[:shape] = (@__MODULE__).shape(x)
        result[:isruntime] = false
        return result
    else
        syms_syntax_error(x)
    end
end

function shape_from_type(type::Union{Expr, Symbol}, default)
    if type == :Vector
        return Unknown(1)
    elseif type == :Matrix
        return Unknown(2)
    elseif type == :Array
        return Unknown(-1)
    elseif Meta.isexpr(type, :curly)
        if type.args[1] == :Vector
            return Unknown(1)
        elseif type.args[1] == :Matrix
            return Unknown(2)
        elseif type.args[1] == :Array
            return Expr(:call, Unknown, length(type.args) == 3 ? type.args[3] : -1)
        else
            return default
        end
    else
        return default
    end
end

function shape_from_type(t::Type, default)
    if t <: AbstractArray
        if hasmethod(ndims, Tuple{t})
            Unknown(ndims(t))
        else
            Unknown(-1)
        end
    else
        default
    end
end

"""
    BS[...]
    BS{T}[...]

`BS` is a utility defined in SymbolicUtils for constructing arrays of symbolics. Similar to
how `T[...]` creates an `Array` of eltype `T`, `BS[...]` creates an array of eltype
`BasicSymbolic{T}`. To infer the [`vartype`](@ref) of the result, at least one of the values
in `...` must be a symbolic. `BS{T}[...]` can be used to explicitly specify the `vartype`.
"""
struct BS{T} end

@inline vartype_from_literal(::BasicSymbolic{T}, xs...) where {T} = T
@inline vartype_from_literal(_, xs...) = vartype_from_literal(xs...)
@inline function vartype_from_literal()
    error("Cannot infer `vartype` from array literal - use `BS{T}[...]` instead of `BS[...]`")
end

@inline function Base.getindex(::Type{BS}, xs...)
    BasicSymbolic{vartype_from_literal(xs...)}[xs...]
end
@inline function Base.getindex(::Type{BS{T}}, xs...) where {T}
    BasicSymbolic{T}[xs...]
end
@inline function Base.typed_vcat(::Type{BS}, xs...)
    Base.typed_vcat(BasicSymbolic{vartype_from_literal(xs...)}, xs...)
end
@inline function Base.typed_vcat(::Type{BS{T}}, xs...) where {T}
    Base.typed_vcat(BasicSymbolic{T}, xs...)
end
@inline function Base.typed_vcat(::Type{BS}, xs::Number...)
    Base.typed_vcat(BasicSymbolic{vartype_from_literal(xs...)}, xs...)
end
@inline function Base.typed_vcat(::Type{BS{T}}, xs::Number...) where {T}
    Base.typed_vcat(BasicSymbolic{T}, xs...)
end
@inline function Base.typed_hcat(::Type{BS}, xs...)
    Base.typed_hcat(BasicSymbolic{vartype_from_literal(xs...)}, xs...)
end
@inline function Base.typed_hcat(::Type{BS{T}}, xs...) where {T}
    Base.typed_hcat(BasicSymbolic{T}, xs...)
end
@inline function Base.typed_hcat(::Type{BS}, xs::Number...)
    Base.typed_hcat(BasicSymbolic{vartype_from_literal(xs...)}, xs...)
end
@inline function Base.typed_hcat(::Type{BS{T}}, xs::Number...) where {T}
    Base.typed_hcat(BasicSymbolic{T}, xs...)
end
@inline function Base.typed_hvcat(::Type{BS}, dims::Base.Dims, xs...)
    Base.typed_hvcat(BasicSymbolic{vartype_from_literal(xs...)}, dims, xs...)
end
@inline function Base.typed_hvcat(::Type{BS{T}}, dims::Base.Dims, xs...) where {T}
    Base.typed_hvcat(BasicSymbolic{T}, dims, xs...)
end
@inline function Base.typed_hvcat(::Type{BS}, dims::Base.Dims, xs::Number...)
    Base.typed_hvcat(BasicSymbolic{vartype_from_literal(xs...)}, dims, xs::Number...)
end
@inline function Base.typed_hvcat(::Type{BS{T}}, dims::Base.Dims, xs::Number...) where {T}
    Base.typed_hvcat(BasicSymbolic{T}, dims, xs...)
end
@inline function Base.typed_hvncat(::Type{BS}, dims::Base.Dims, rf::Bool, xs...)
    Base.typed_hvncat(BasicSymbolic{vartype_from_literal(xs...)}, dims, rf, xs...)
end
@inline function Base.typed_hvncat(::Type{BS{T}}, dims::Base.Dims, rf::Bool, xs...) where {T}
    Base.typed_hvncat(BasicSymbolic{T}, dims, rf, xs...)
end
@inline function Base.typed_hvncat(::Type{BS}, dim::Int, xs...)
    Base.typed_hvncat(BasicSymbolic{vartype_from_literal(xs...)}, dim, xs...)
end
@inline function Base.typed_hvncat(::Type{BS{T}}, dim::Int, xs...) where {T}
    Base.typed_hvncat(BasicSymbolic{T}, dim, xs...)
end

function SymbolicUtils.promote_symtype(::Type{DestructuredArgs}, name_type::TypeT, elem_types::TypeT...)
    return name_type
end

function SymbolicUtils.promote_shape(::Type{DestructuredArgs}, name_shape::ShapeT, @nospecialize(elem_shapes::ShapeT...))
    @nospecialize name_shape
    return name_shape
end

"""
    symDestructuredArgs(name, elems)

Construct a symbolic expression representing an array argument that is destructured into
its elements. `name` is a symbolic variable representing the array argument; `elems` is an
iterable of symbolic variables that will be bound to successive elements of the array.

The result is a `Term{T}(Code.DestructuredArgs, [name, elem1, ...])` with `symtype` and
`shape` equal to those of `name`. It may only be used as an argument in [`symFunc`](@ref).

!!! note
    `symDestructuredArgs` cannot be nested: the element variables (`elems`) must be plain
    symbolic variables, not themselves `symDestructuredArgs` terms.
"""
function symDestructuredArgs(name::BasicSymbolic{T}, elems) where {T}
    args = ArgsT{T}()
    sizehint!(args, 1 + length(elems))
    push!(args, name)
    for elem in elems
        push!(args, elem isa BasicSymbolic{T} ? elem : BSImpl.Const{T}(elem))
    end
    return BSImpl.Term{T}(DestructuredArgs, args; type = symtype(name), shape = shape(name))
end

function SymbolicUtils.promote_symtype(::Type{Let}, Ts::TypeT...)
    return last(Ts)
end

function SymbolicUtils.promote_shape(::Type{Let}, @nospecialize(shs::ShapeT...))
    return last(shs)
end

"""
    symLet(assignments, body)

Construct a symbolic expression representing a `let` block. `assignments` must be an
iterable of `symAssignment` terms. Returns a `Term{T}(Code.Let, [asgn..., body])` with
`symtype` and `shape` equal to those of `body`.
"""
function symLet(assignments::AbstractArray{BasicSymbolic{T}}, body::BasicSymbolic{T}) where {T}
    args = ArgsT{T}(assignments)
    push!(args, body)
    return BSImpl.Term{T}(Let, args; type = symtype(body), shape = shape(body))
end

function SymbolicUtils.promote_symtype(::Type{Assignment}, lhs_type::TypeT, rhs_type::TypeT)
    return rhs_type
end

function SymbolicUtils.promote_shape(::Type{Assignment}, @nospecialize(_lhs_shape::ShapeT), rhs_shape::ShapeT)
    @nospecialize rhs_shape
    return rhs_shape
end

"""
    symAssignment(lhs, rhs)

Construct a symbolic expression representing `lhs = rhs`. Returns a
`Term{T}(Code.Assignment, [lhs, rhs])` with `symtype` and `shape` equal to those of `rhs`.
"""
function symAssignment(lhs::BasicSymbolic{T}, rhs::BasicSymbolic{T}) where {T}
    return BSImpl.Term{T}(
        Assignment, ArgsT{T}((lhs, rhs));
        type = symtype(rhs),
        shape = shape(rhs)
    )
end
function symAssignment(lhs::BasicSymbolic{T}, rhs) where {T}
    return symAssignment(lhs, BSImpl.Const{T}(rhs))
end
function symAssignment(lhs, rhs::BasicSymbolic{T}) where {T}
    return symAssignment(BSImpl.Const{T}(lhs), rhs)
end

function SymbolicUtils.promote_symtype(::Type{Func}, args_type::TypeT, body_type::TypeT)
    @assert args_type <: Tuple
    return FnType{args_type, body_type, Nothing}::TypeT
end

function SymbolicUtils.promote_shape(::Type{Func}, @nospecialize(_args_shape::ShapeT), body_shape::ShapeT)
    @nospecialize body_shape
    return body_shape
end

"""
    symFunc(args, body)

Construct a symbolic expression representing an anonymous function with argument list `args`
and body `body`. `args` must be an iterable of symbolic variables. Returns a
`Term{T}(Code.Func, [args_term, body])` where `args_term = term(tuple, args...)`, with
`symtype` `FnType{symtype(args_term), symtype(body), Nothing}` and `shape` equal to
`shape(body)`.
"""
function symFunc(args::BasicSymbolic{T}, body::BasicSymbolic{T}) where {T}
    return BSImpl.Term{T}(
        Func, ArgsT{T}((args, body));
        type = SymbolicUtils.promote_symtype(Func, symtype(args), symtype(body)),
        shape = SymbolicUtils.promote_shape(Func, shape(args), shape(body))
    )
end
function symFunc(args::Union{AbstractArray, Tuple}, body::BasicSymbolic{T}) where {T}
    return symFunc(
        BSImpl.Term{T}(
            tuple, args;
            type = SymbolicUtils.promote_symtype(tuple, symtype.(args)...),
            shape = ShapeVecT((1:length(args),))
        ), body
    )
end
function symFunc(args::BasicSymbolic{T}, body) where {T}
    return symFunc(args, BSImpl.Const{T}(body))
end

using SymbolicUtils, SymbolicUtils.Code, SparseArrays, Test
using SymbolicUtils.Code: topological_sort
using RuntimeGeneratedFunctions

RuntimeGeneratedFunctions.init(@__MODULE__)

@testset "CSE" begin
    @syms x
    t = cse(hypot(hypot(cos(x), sin(x)), atan(cos(x), sin(x))))

    @test t isa Let
    @test length(t.pairs) == 5
    @test SymbolicUtils.query(isequal(t.pairs[3].lhs), t.pairs[5].rhs)
    @test SymbolicUtils.query(isequal(t.pairs[4].lhs), t.pairs[5].rhs)
end

@testset "DAG CSE" begin
    @syms a b
    expr = sin(a + b) * (a + b)
    sorted_nodes = topological_sort(expr)
    @test length(sorted_nodes) == 3
    node = sorted_nodes[1].rhs
    @test operation(node) === (+) && issetequal(arguments(node), [a, b])
    @test isequal(sin(sorted_nodes[1].lhs), sorted_nodes[2].rhs)

    expr = (a + b)^(a + b)
    sorted_nodes = topological_sort(expr)
    @test length(sorted_nodes) == 2
    node = sorted_nodes[1].rhs
    @test operation(node) === (+) && issetequal(arguments(node), [a, b])
    ab_node = sorted_nodes[1].lhs
    @test isequal(term(^, ab_node, ab_node), sorted_nodes[2].rhs)
    let_expr = cse(expr)
    @test length(let_expr.pairs) == 2
    node = let_expr.pairs[1].rhs
    @test operation(node) === (+) && issetequal(arguments(node), [a, b])
    corresponding_sym = let_expr.pairs[1].lhs
    @test isequal(let_expr.pairs[end].rhs, term(^, corresponding_sym, corresponding_sym))

    expr = a + b
    sorted_nodes = topological_sort(expr)
    @test length(sorted_nodes) == 1
    node = sorted_nodes[1].rhs
    @test operation(node) === (+) && issetequal(arguments(node), [a, b])
    let_expr = cse(expr)
    @test length(let_expr.pairs) == 1
    node = let_expr.pairs[end].rhs
    @test operation(node) === (+) && issetequal(arguments(node), [a, b])

    expr = a
    sorted_nodes = topological_sort(expr)
    @test isempty(sorted_nodes)
    let_expr = cse(expr)
    @test isequal(let_expr, expr)

    # array symbolics
    # https://github.com/JuliaSymbolics/SymbolicUtils.jl/pull/688#pullrequestreview-2554931739
    @syms a b c
    function foo(args...)
        return args
    end
    ex = term(foo, [a^2 + b^2, b^2 + c], (a^2 + b^2, b^2 + c), c; type = Real)
    sorted_nodes = topological_sort(ex)
    @test length(sorted_nodes) == 8
    @test operation(sorted_nodes[6].rhs) === SymbolicUtils.array_literal
    @test operation(sorted_nodes[7].rhs) === tuple
    expr = quote
        a = 1
        b = 2
        c = 3
        $(toexpr(cse(ex)))
    end
    vals = eval(expr)
    @test vals[1] == [1 + 4, 4 + 3]
    @test vals[2] == (1 + 4, 4 + 3)
    @test vals[3] == 3
end

@testset "Expr" begin
    ex = :(a^2 + sin(a^2))
    @test isequal(cse(ex), ex)
    ex = LiteralExpr(ex)
    @test isequal(cse(ex), ex)
end

@testset "Tuple" begin
    @syms a b
    ex = (a^2 + sin(a^2), sin(a^2) + b^2, b^2 + sin(b^2))
    csex = cse(ex)
    i, j, k = findfirst.(isequal.(csex.body) .∘ Code.lhs, (csex.pairs,))
    @test i !== nothing
    @test j !== nothing
    @test k !== nothing
    csex = Let(csex.pairs, MakeTuple(csex.body), false)
    expr = quote
        let a = 1, b = 2
            $(toexpr(csex))
        end
    end
    csex2 = cse(MakeTuple(collect(ex)))
    expr2 = quote
        let a = 1, b = 2
            $(toexpr(csex2))
        end
    end
    @test collect(eval(expr)) ≈ [1 + sin(1), sin(1) + 4, 4 + sin(4)]
    @test collect(eval(expr)) ≈ collect(eval(expr2))
end

@testset "MakeArray, SetArray, MakeSparseArray, AtIndex" begin
    @syms a b c
    arr = [a^2 + sin(a * b) sin(a * b) + c^2
           c^2 + sin(b * c) sin(b * c) + a^2]
    marr = MakeArray(arr, Array)
    sparr = sparse([1, 2, 3, 4], [1, 2, 3, 4], vec(arr))
    msparr = MakeSparseArray(sparr)
    sarr = SetArray(false, :buffer, [[a^2 + c^2], AtIndex(3, arr), AtIndex(4, msparr)], true)

    csex = cse(sarr)
    # test that simple array is CSEd
    @test findfirst(isequal(csex.body.elems[1][1]), Code.lhs.(csex.pairs)) !== nothing
    # test that `AtIndex` is CSEd
    i, j, k, l = findfirst.(isequal.(csex.body.elems[2].elem), (Code.lhs.(csex.pairs),))
    @test i !== nothing
    @test j !== nothing
    @test k !== nothing
    @test l !== nothing
    # test that `MakeSpareArray` is CSEd, and re-uses the values from the `MakeArray`
    ii, jj, kk, ll = findfirst.(isequal.(findnz(csex.body.elems[3].elem.array)[3]), (Code.lhs.(csex.pairs),))
    @test i == ii
    @test j == jj
    @test k == kk
    @test l == ll
    expr = quote
        let a = 1, b = 2, c = 3, buffer = Any[0, "A", 0, 0]
            $(toexpr(csex))
        end
    end
    val = eval(expr)
    @test val[1] == [10]
    @test val[2] == "A"
    result = [1 + sin(2) sin(2) + 9
              9 + sin(6) sin(6) + 1]
    @test val[3] == result
    @test val[4] == sparse([1, 2, 3, 4], [1, 2, 3, 4], vec(result))
end

@testset "Let, Func, Assignment, DestructuredArgs" begin
    @syms a b c d::Vector{Real} e f
    fn = Func([a, DestructuredArgs([b, c])], [], Let([Assignment(d, [a^2 + b^2, b^2 + c^2]), DestructuredArgs([e, f], term(broadcast, *, 2, d))], a^2 + b^2 + e + f))
    csex = cse(fn)
    sexprs = csex.body.pairs
    assignments = filter(x -> x isa Assignment, sexprs)
    didx = findfirst(x -> isequal(x.lhs, d), sexprs)
    # the array in the assignment should be CSEd
    i, j = findfirst.(isequal.(sexprs[didx].rhs), (Code.lhs.(assignments),))
    @test i !== nothing
    @test j !== nothing
    didx = findfirst(x -> x isa DestructuredArgs, sexprs)
    @test sexprs[didx] isa DestructuredArgs
    @test findfirst(isequal(sexprs[didx].name), Code.lhs.(assignments)) !== nothing

    rgf = @RuntimeGeneratedFunction(toexpr(csex))
    trueval = let a = 1,
        b = 2,
        c = 3,
        tmp1 = b^2,
        tmp2 = a^2,
        tmp3 = tmp1 + tmp2,
        tmp4 = c^2,
        tmp5 = tmp1 + tmp4,
        d = [tmp3, tmp5],
        tmp6 = 2 .* d,
        e = tmp6[1],
        f = tmp6[2],
        tmp7 = f + tmp1 + tmp2 + e
        tmp7
    end
    @test rgf(1, [2, 3]) == trueval
end

@testset "SpawnFetch" begin
    @syms a b c d
    fn = Func([c, d], [], c^2 + d^2 + sin(c^2))
    ex = SpawnFetch{Multithreaded}([fn], [[a^2 + b^2, sin(a^2)]], only)
    csex = cse(ex)
    # arguments to the inner function are CSEd
    i, j = findfirst.(isequal.(csex.body.args[1]), (Code.lhs.(csex.pairs),))
    @test i !== nothing
    @test j !== nothing
    innerkeys = Code.lhs.(csex.body.exprs[1].body.pairs)
    @test findfirst(isequal(csex.body.exprs[1].body.body), innerkeys) !== nothing

    expr = quote
        let a = 1, b = 2
            $(toexpr(csex))
        end
    end
    trueval = let a = 1, b = 2, c = a^2 + b^2, d = sin(a^2)
        c^2 + d^2 + sin(c^2)
    end
    @test eval(expr) == trueval
    innerfn = csex.body.exprs[1]

    # test inner function is CSEd independently
    rgf = @RuntimeGeneratedFunction(toexpr(innerfn))
    @test rgf(5, sin(1)) == trueval
end

@testset "ForLoop" begin
    @syms a b c::Vector{Real}
    ex = ForLoop(a, term(range, b^2, b^2 + 3), SetArray(false, c, [AtIndex(a, a^2 + sin(a^2))]))
    csex = cse(ex)
    @test findfirst(isequal(csex.body.range), Code.lhs.(csex.pairs)) !== nothing
    @test findfirst(isequal(csex.body.body.body.elems[1].elem), Code.lhs.(csex.body.body.pairs)) !== nothing
    expr = quote
        let b = 2, c = zeros(10)
            $(toexpr(ex))
            c
        end
    end
    arr = eval(expr)
    @test arr[4] == 4^2 + sin(4^2)
    @test arr[5] == 5^2 + sin(5^2)
    @test arr[6] == 6^2 + sin(6^2)
    @test arr[7] == 7^2 + sin(7^2)
    @test all(iszero, arr[1:3])
    @test all(iszero, arr[8:end])
end

@testset "CSE doesn't affect ranges" begin
    @syms x::Vector{Real}
    t = term(view, x, 1:3)
    fnexpr = Func([x], [], t)
    fn1 = @RuntimeGeneratedFunction(toexpr(fnexpr))
    fn2 = @RuntimeGeneratedFunction(cse(toexpr(fnexpr)))
    @test fn1(ones(5)) == fn2(ones(5))
end

@testset "Tuples and arrays of `Symbol`s aren't symbolic" begin
    @syms x y
    f(a, b, c) = a + b + length(c)
    ex = term(f, x, y, (:a, :b, :c))
    expr = quote
        let x = 1, y = 2
            $(toexpr(cse(ex)))
        end
    end
    @test eval(expr) == 6
    ex = term(f, x, y, [:a, :b, :c])
    expr = quote
        let x = 1, y = 2
            $(toexpr(cse(ex)))
        end
    end
    @test eval(expr) == 6
end

@noinline function throw_bad_div_shape(x, y)
    throw(ArgumentError(LazyString("Arguments have invalid shapes for division - found shapes ", x, " and ", y, ".")))
end

@noinline function throw_vecdiv(x, y)
    throw(ArgumentError(LazyString(
        "When dividing a vector, the denominator must be a scalar,",
        " vector or column matrix.",
        " Found arguments with shapes ", x, " and ", y, ".")))
end

@noinline function throw_scalardiv(x, y)
    throw(ArgumentError(LazyString(
        "When dividing a scalar, the denominator must be a scalar or vector.",
        " Found arguments with shapes ", x, " and ", y, ".")))
end

# S = Scalar, * = Any, V = Vector, M = Matrix
# * / S -> *
# S / V -> (1, length(B))
# S / M -> ERR
# V / V -> (length(A), length(B))
# V / M -> (length(A), size(B, 1))    ; size(B, 2) == 1
# M / V -> ERR
# M / M -> (size(A, 1), size(B, 1))   ; size(A, 2) == size(B, 2)
function promote_shape(::typeof(/), sha::ShapeT, shb::ShapeT)
    @nospecialize sha shb
    ndims_a = _ndims_from_shape(sha)
    ndims_b = _ndims_from_shape(shb)
    if sha isa Unknown && shb isa Unknown
        ndims_a <= 2 || throw_bad_div_shape(sha, shb)
        ndims_b <= 2 || throw_bad_div_shape(sha, shb)
        ndims_a != 2 || ndims_b != 1 || throw_bad_dims(sha, shb)
        # either we get a matrix or the operation errors
        return Unknown(2)
    elseif sha isa Unknown && shb isa ShapeVecT
        ndims_b == 0 && return sha
        ndims_a <= 2 || throw_bad_div_shape(sha, shb)
        ndims_b <= 2 || throw_bad_div_shape(sha, shb)
        ndims_a != 1 || (ndims_b == 1 || length(shb[2]) == 1) || throw_vecdiv(sha, shb)
        ndims_a != 2 || ndims_b != 1 || throw_bad_dims(sha, shb)
        return Unknown(2)
    elseif sha isa ShapeVecT && shb isa Unknown
        ndims_a <= 2 || throw_bad_div_shape(sha, shb)
        ndims_b <= 2 || throw_bad_div_shape(sha, shb)
        ndims_a != 0 || ndims_b <= 1 || throw_scalardiv(sha, shb)
        ndims_a != 2 || ndims_b != 1 || throw_bad_dims(sha, shb)
        return Unknown(2)
    elseif sha isa ShapeVecT && shb isa ShapeVecT
        ndims_b == 0 && return sha
        ndims_a <= 2 || throw_bad_div_shape(sha, shb)
        ndims_b <= 2 || throw_bad_div_shape(sha, shb)
        if ndims_a == 0
            ndims_b == 1 && return ShapeVecT((1:1, shb[1]))
            throw_scalardiv(sha, shb)
        elseif ndims_a == 1
            ndims_b == 1 || length(shb[2]) == 1 || throw_vecdiv(sha, shb)
            return ShapeVecT((sha[1], shb[1]))
        else
            # ndims_a == 2
            ndims_b == 1 && throw_bad_div_shape(sha, shb)
            length(sha[2]) == length(shb[2]) || throw_bad_div_shape(sha, shb)
            return ShapeVecT((sha[1], shb[1]))
        end
    end
    _unreachable()
end

function _fslash_worker(::Type{T}, a, b) where {T}
    if !_numeric_or_arrnumeric_symtype(a) || !_numeric_or_arrnumeric_symtype(b)
        throw(MethodError(/, (a, b)))
    end
    type = promote_symtype(/, symtype(a), symtype(b))
    newshape = promote_shape(/, shape(a), shape(b))
    Div{T}(a, b, false; type, shape = newshape)
end

function /(a::Union{S,Number,AbstractArray{<:Number}}, b::S) where {S <: NonTreeSym}
    _fslash_worker(vartype(S), a, b)
end
function /(a::AbstractArray{S}, b::S) where {S <: NonTreeSym}
    _fslash_worker(vartype(S), Const{vartype(S)}(a), b)
end

function /(a::S, b::Union{Number,AbstractArray{<:Number}}) where {S <: NonTreeSym}
    _fslash_worker(vartype(S), a, b)
end
function /(a::S, b::AbstractArray{S}) where {S <: NonTreeSym}
    _fslash_worker(vartype(S), a, Const{vartype(S)}(b))
end

function //(a::Union{S,Number,AbstractArray{<:Number}}, b::S) where {S <: NonTreeSym}
    if !_rational_or_arrrational_symtype(a) || !_rational_or_arrrational_symtype(b)
        throw(MethodError(//, (a, b)))
    end
    _fslash_worker(vartype(S), a, b)
end
function //(a::AbstractArray{S}, b::S) where {S <: NonTreeSym}
    a = Const{vartype(S)}(a)
    if !_rational_or_arrrational_symtype(a) || !_rational_or_arrrational_symtype(b)
        throw(MethodError(//, (a, b)))
    end
    _fslash_worker(vartype(S), a, b)
end

function //(a::S, b::Union{Number,AbstractArray{<:Number}}) where {S <: NonTreeSym}
    if !_rational_or_arrrational_symtype(a) || !_rational_or_arrrational_symtype(b)
        throw(MethodError(//, (a, b)))
    end
    _fslash_worker(vartype(S), a, b)
end
function //(a::S, b::AbstractArray{S}) where {S <: NonTreeSym}
    b = Const{vartype(S)}(b)
    if !_rational_or_arrrational_symtype(a) || !_rational_or_arrrational_symtype(b)
        throw(MethodError(//, (a, b)))
    end
    _fslash_worker(vartype(S), a, b)
end

@noinline function throw_bad_dims(x, y)
    throw(ArgumentError(LazyString(
        "Both arguments to \\ must have <= 2 dimensions.",
        " Found arguments with shapes ", x, " and ", y, ".")))
end

@noinline function throw_scalar_rhs(x, y)
    throw(ArgumentError(LazyString(
        "The second argument to \\ cannot be a scalar",
        " if the first argument is an array.",
        " Found arguments with shapes ", x, " and ", y, ".")))
end

@noinline function throw_first_dim_different(x, y)
    throw(ArgumentError(LazyString(
        "The length of the first dimension of both arguments",
        " to \\ must be identical.",
        " Found arguments with shapes ", x, " and ", y, ".")))
end

# S = Scalar, * = Any, V = Vector, M = Matrix
# S \ * -> *
# V \ S -> ERR
# V \ V -> S                        ; len(A) == len(B)
# V \ M -> (1, shape(B, 2))         ; len(A) == size(B, 1)
# M \ S -> ERR
# M \ V -> (size(A, 2))             ; size(A, 1) == length(B)
# M \ M -> (size(A, 2), size(B, 2)) ; size(A, 1) == size(B, 1)
function promote_shape(::typeof(\), sha::ShapeT, shb::ShapeT)
    @nospecialize sha shb
    ndims_a = _ndims_from_shape(sha)
    ndims_b = _ndims_from_shape(shb)
    if sha isa Unknown && shb isa Unknown
        sha.ndims <= 2 || throw_bad_dims(sha, shb)
        shb.ndims <= 2 || throw_bad_dims(sha, shb)
        sha.ndims == -1 && return Unknown(-1)
        shb.ndims == -1 && return Unknown(-1)
        sha.ndims == 1 && shb.ndims == 1 && return ShapeVecT()
        return shb
    elseif sha isa Unknown && shb isa ShapeVecT
        sha.ndims <= 2 || throw_bad_dims(sha, shb)
        length(shb) <= 2 || throw_bad_dims(sha, shb)
        length(shb) == 0 && throw_scalar_rhs(sha, shb)
        sha.ndims == -1 && return Unknown(-1)
        sha.ndims == 1 && ndims_b == 1 && return ShapeVecT()
        sha.ndims == 1 && ndims_b == 2 && return ShapeVecT((1:1, shb[2]))
        sha.ndims == 2 && return Unknown(ndims_b)
        _unreachable()
    elseif sha isa ShapeVecT && shb isa Unknown
        shb.ndims == -1 && return Unknown(-1)
        ndims_a == 0 && return shb
        ndims_a <= 2 || throw_bad_dims(sha, shb)
        shb.ndims <= 2 || throw_bad_dims(sha, shb)
        ndims_a == 1 && shb.ndims == 1 && return ShapeVecT()
        ndims_a == 1 && shb.ndims == 2 && return shb
        ndims_a == 2 && shb.ndims == 1 && return ShapeVecT((sha[1],))
        ndims_a == 2 && shb.ndims == 2 && return shb
        _unreachable()
    elseif sha isa ShapeVecT && shb isa ShapeVecT
        ndims_a == 0 && return shb
        ndims_b == 0 && throw_scalar_rhs(sha, shb)
        length(sha[1]) == length(shb[1]) || throw_first_dim_different(sha, shb)
        ndims_a <= 2 || throw_bad_dims(sha, shb)
        ndims_b <= 2 || throw_bad_dims(sha, shb)
        if ndims_a == 1 && ndims_b == 1
            return ShapeVecT()
        elseif ndims_a == 1 && ndims_b == 2
            return ShapeVecT((1:1, shb[2]))
        elseif ndims_a == 2 && ndims_b == 1
            return ShapeVecT((sha[2],))
        elseif ndims_a == 2 && ndims_b == 2
            return ShapeVecT((sha[2], shb[2]))
        end
        _unreachable()
    end
    _unreachable()
end

function _bslash_worker(::Type{T}, a, b) where {T}
    if !_numeric_or_arrnumeric_symtype(a) || !_numeric_or_arrnumeric_symtype(b)
        throw(MethodError(\, (a, b)))
    end
    if isconst(a) || isconst(b)
        return Const{T}(unwrap_const(a) \ unwrap_const(b))
    end
    sha = shape(a)
    type = promote_symtype(\, symtype(a), symtype(b))
    newshape = promote_shape(\, shape(a), shape(b))
    if is_array_shape(newshape) || is_array_shape(sha)
        # Scalar \ Anything == Anything / Scalar
        return Term{T}(\, ArgsT{T}((a, b)); type, shape = newshape)
    else
        return Div{T}(b, a, false; type, shape = newshape)
    end
end

function \(a::Union{S,Number,AbstractArray{<:Number}}, b::S) where {S <: NonTreeSym}
    _bslash_worker(vartype(S), a, b)
end
function \(a::T, b::Union{Number, <:AbstractArray{<:Number}}) where {T <: NonTreeSym}
    _bslash_worker(vartype(T), a, b)
end
function \(a::AbstractArray{S}, b::S) where {S <: NonTreeSym}
    a = Const{vartype(S)}(a)
    _bslash_worker(vartype(S), a, b)
end
function \(a::T, b::AbstractArray{T}) where {T <: NonTreeSym}
    b = Const{vartype(T)}(b)
    _bslash_worker(vartype(T), a, b)
end

const NonTreeSym = Union{BasicSymbolic{SymReal}, BasicSymbolic{SafeReal}}

import Base: (+), (-), (*), (//), (/), (\), (^)

macro __generate_numeric_or_arrrnumeric_type()
    expr = Expr(:if)
    cur_expr = expr
    push!(cur_expr.args, :(S === Number))
    push!(cur_expr.args, true)
    new_expr = Expr(:elseif)
    push!(cur_expr.args, new_expr)
    cur_expr = new_expr

    push!(cur_expr.args, :(S === Real))
    push!(cur_expr.args, true)
    new_expr = Expr(:elseif)
    push!(cur_expr.args, new_expr)
    cur_expr = new_expr

    push!(cur_expr.args, :(S === Vector{Number}))
    push!(cur_expr.args, true)
    new_expr = Expr(:elseif)
    push!(cur_expr.args, new_expr)
    cur_expr = new_expr

    push!(cur_expr.args, :(S === Vector{Real}))
    push!(cur_expr.args, true)
    new_expr = Expr(:elseif)
    push!(cur_expr.args, new_expr)
    cur_expr = new_expr

    push!(cur_expr.args, :(S === Matrix{Number}))
    push!(cur_expr.args, true)
    new_expr = Expr(:elseif)
    push!(cur_expr.args, new_expr)
    cur_expr = new_expr

    push!(cur_expr.args, :(S === Matrix{Real}))
    push!(cur_expr.args, true)
    new_expr = Expr(:elseif)
    push!(cur_expr.args, new_expr)
    cur_expr = new_expr

    i = 0

    N = length(SCALARS)
    for t1 in SCALARS
        for T in [t1, Vector{t1}, Matrix{t1}, LinearAlgebra.UniformScaling{t1}]
            i += 1
            push!(cur_expr.args, :(S === $T))
            push!(cur_expr.args, true)
            i == 4N && continue
            new_expr = Expr(:elseif)
            push!(cur_expr.args, new_expr)
            cur_expr = new_expr
        end
    end
    push!(cur_expr.args, :(S <: Union{Number, AbstractArray{<:Number}}))

    return esc(expr)
end

function _numeric_or_arrnumeric_type(@nospecialize(S::TypeT))
    @__generate_numeric_or_arrrnumeric_type
end

function _numeric_or_arrnumeric_symtype(x)
    if x isa Array{<:BasicSymbolic}
        all(_numeric_or_arrnumeric_symtype, x)
    else
        _numeric_or_arrnumeric_type(symtype(x))
    end
end

macro __generate_rational_or_arrrational_type()
    expr = Expr(:if)
    cur_expr = expr
    i = 0
    N = length(SCALARS)
    for t1 in SCALARS
        for T in [t1, Vector{t1}, Matrix{t1}, LinearAlgebra.UniformScaling{t1}]
            i += 1
            push!(cur_expr.args, :(S === $T))
            push!(cur_expr.args, t1 <: Rat)
            i == 4N && continue
            new_expr = Expr(:elseif)
            push!(cur_expr.args, new_expr)
            cur_expr = new_expr
        end
    end
    push!(cur_expr.args, :(S <: Union{Rat, AbstractArray{<:Rat}}))
    return esc(expr)
end

function _rational_or_arrrational_type(@nospecialize(S::TypeT))
    @__generate_rational_or_arrrational_type
end

function _rational_or_arrrational_symtype(x)
    if x isa Array{<:BasicSymbolic}
        all(_rational_or_arrrational_symtype, x)
    else
        _rational_or_arrrational_type(symtype(x))
    end
end

abstract type Operator end
promote_shape(::Operator, @nospecialize(shx::ShapeT)) = shx
promote_symtype(::Operator, ::Type{T}) where {T} = T

using SymbolicUtils, SymbolicUtils.Code
using Zygote

@testset "create_array adjoint" begin
  elems = (1,2,3,4,5,)

  Ts = (Float64, Float32, Float16, Int64, Int32)
  dims_candidates = ((1, (2,3)), (2, (1,3)))
  As = (Array,)

  for T in Ts,
      dims in dims_candidates,
      A in As

    u, dim = dims
    ŷ, pb = Zygote.pullback(elems) do elems
      SymbolicUtils.Code.create_array(A, T, Val(u), Val(dim), elems...)
    end
    y = SymbolicUtils.Code.create_array(A, T, Val(u), Val(dim), elems...)
    @test y == ŷ

    gs = pb(ones(T, length(elems)))
    @test length(gs[1]) == length(elems)
    for i = 1:(prod(dim)-1)
      @test gs[1][i] == one(eltype(ŷ))
    end
  end
end

const IDXS_SYM = :𝑖ᵢₓ
const IDXS_SYMREAL = Sym{SymReal}(IDXS_SYM; type = Vector{Int}, shape = Unknown(1))
const IDXS_SAFEREAL = Sym{SafeReal}(IDXS_SYM; type = Vector{Int}, shape = Unknown(1))
const IDXS_TREEREAL = Sym{TreeReal}(IDXS_SYM; type = Vector{Int}, shape = Unknown(1))

idxs_for_arrayop(::Type{SymReal}) = IDXS_SYMREAL
idxs_for_arrayop(::Type{SafeReal}) = IDXS_SAFEREAL
idxs_for_arrayop(::Type{TreeReal}) = IDXS_TREEREAL

"""
    @arrayop (idxs...,) expr [idx in range, ...] [options...]

Construct a vectorized array operation using Tullio.jl-like generalized Einstein notation.
`idxs` is a tuple corresponding to the indices in the result. `expr` is the indexed
expression. Indices used in `expr` not present in `idxs` will be collapsed using the
`reduce` function, which defaults to `+`. For example, matrix multiplication can be
expressed as follows:

```julia
@syms A[1:5, 1:5] B[1:5, 1:5]
matmul = @arrayop (i, j) A[i, k] * B[k, j]
```

Here the elements of the collapsed dimension `k` are reduced using the `+` operation. To
use a different reducer, the `reduce` option can be supplied:

```julia
C = @arrayop (i, j) A[i, k] * B[k, j] reduce=max
```

Now, `C[i, j]` is the maximum value of `A[i, k] * B[k, j]` for across all `k`.

# Singleton dimensions

Arbitrary singleton dimensions can be added in the result by inserting `1` at the desired
position in `idxs`:

```julia
C = @arrayop (i, 1, j, 1) A[i, k] * B[k, j]
```

Here, `C` is a symbolic array of size `(5, 1, 5, 1)`.

# Restricted ranges

For any index variable `i` in `expr`, all its usages in `expr` must correspond to axes of
identical length. For example:

```julia
@syms D[1:3, 1:5]
@arrayop (i, j) A[i, k] * D[k, j]
```

The above usage is invalid, since `k` in `A` is used to index an axis of length `5` and in
`D` is used to index an axis of length `3`. The iteration range of variables can be manually
restricted:

```julia
@arrayop (i, j) A[i, k] * D[k, j] k in 1:3
```

This expression is valid. Note that when manually restricting iteration ranges, the range
must be a subset of the axes where the iteration variable is used. Here `1:3` is a subset
of both `1:5` and `1:3`.

# Axis offsets

The usages of index variables can be offset.

```julia
A2 = @arrayop (i, j) A[i + 1, j] + A[i, j + 1]
```

Here, `A2` will have size `(4, 4)` since SymbolicUtils.jl is able to recognize that `i` and
`j` can only iterate in the range `1:4`. For trivial offsets of the form `idx + offset`
(`offset` can be negative), the bounds of `idx` can be inferred. More complicated offsets
can be used, but this requires manually specifying ranges of the involved index variables.

```julia
A3 = @arrayop (i, j) A[2i - 1, j] i in 1:3
```

In this scenario, it is the responsibility of the user to ensure the arrays are always
accessed within their bounds.

# Usage with non-standard axes

The index variables are "idealized" indices. This means that as long as the length of
all axes where an index variable is used is identical, the bounds of the axes are
irrelevant.

```julia
@syms E[0:4, 0:4]
F = @arrayop (i, j) A[i, k] * E[k, j]
```

Despite `axes(A, 2)` being `1:5` and `axes(E, 1)` being `0:4`, the above expression is
valid since `length(1:5) == 5 == length(0:4)`. When generating code, index variables will
be appropriately offset to index the involved axes.

If the range of an index variable is manually specified, the index variable is no longer
"idealized" and the user is responsible for offsetting appropriately. The above example
with a manual range for `k` should be written as:

```julia
F2 = @arrayop (i, j) A[i, k] * E[k - 1, j] k in 1:5
```

# Result shape

The result is always 1-indexed with axes of appropriate lengths, regardless of the shape of
the inputs.
"""
macro arrayop(output_idx, expr, options...)
    rs = []
    reduce = +
    call = nothing

    extra = []
    for o in options
        if Meta.isexpr(o, :call) && o.args[1] == :in
            push!(rs, :($(o.args[2]) => $(o.args[3])))
        elseif Meta.isexpr(o, :(=)) && o.args[1] == :reduce
            reduce = o.args[2]
        elseif Meta.isexpr(o, :(=)) && o.args[1] == :term
            call = o.args[2]
        else
            push!(extra, o)
        end
    end
    @assert output_idx.head == :tuple

    oidxs = filter(x->x isa Symbol, output_idx.args)
    iidxs = find_indices(expr)
    vartype_ref = find_vartype_reference(expr)
    idxs  = union(oidxs, iidxs)
    fbody = :($unwrap($expr))
    wrap_indexed_arrays!(fbody)

    let_assigns = Expr(:block)
    push!(let_assigns.args, Expr(:(=), :__vartype, :($vartype($unwrap($vartype_ref)))))
    push!(let_assigns.args, Expr(:(=), :__idx, :($idxs_for_arrayop(__vartype))))
    for (i, idx) in enumerate(idxs)
        push!(let_assigns.args, Expr(:(=), idx, :(__idx[$i])))
    end
    push!(let_assigns.args, Expr(:(=), :__expr, fbody))
    push!(let_assigns.args, Expr(:(=), :__output_idx, :($OutIdxT{__vartype}($output_idx))))
    push!(let_assigns.args, Expr(:(=), :__ranges, :($RangesT{__vartype}($(rs...)))))
    return Expr(:let, let_assigns, quote
        $ArrayOp{__vartype}(__output_idx,
                 __expr,
                 $reduce,
                 $unwrap($call),
                 __ranges)
    end) |> esc
end

function wrap_indexed_arrays!(e::Expr)
    if Meta.isexpr(e, :ref)
        e.args[1] = :($(BSImpl.Const){__vartype}($(e.args[1])))
        return e
    end
    for i in eachindex(e.args)
        arg = e.args[i]
        if arg isa Expr
            e.args[i] = wrap_indexed_arrays!(arg)
        end
    end
    return e
end

"""
    $TYPEDSIGNATURES

Recursively find all index symbols used in array indexing operations within an expression.

# Arguments
- `expr`: The expression to search for index variables
- `idxs`: Accumulator array for found index symbols (defaults to empty array)

# Returns
- Array of symbols that are used as indices in array references or `getindex` calls

# Details
This function traverses an expression tree looking for array indexing patterns (`:ref` or
`:getindex` calls) and collects all symbols used as indices. The function recursively
processes nested expressions to find all index variables used throughout the expression.
"""
function find_indices(expr, idxs=[])
    !(expr isa Expr) && return idxs
    if expr.head == :ref
        return append!(idxs, filter(x->x isa Symbol, expr.args[2:end]))
    elseif expr.head == :call && expr.args[1] == :getindex || expr.args[1] == getindex
        return append!(idxs, filter(x->x isa Symbol, expr.args[3:end]))
    else
        foreach(x->find_indices(x, idxs), expr.args)
        return idxs
    end
end

"""
    $TYPEDSIGNATURES

Find a reference variable in an expression to determine the variant type for array operations.

# Arguments
- `expr`: The expression to search for a variable reference

# Returns
- The first array variable found in the expression, or `nothing` if none exists

# Details
This function searches for the first array variable used in indexing operations within an
expression. It returns the array being indexed (not the indices themselves). The found
variable is used to determine the symbolic type (e.g., `SymReal`, `SafeReal`, `TreeReal`)
for the array operation being constructed.
"""
function find_vartype_reference(expr)
    !(expr isa Expr) && return nothing
    if expr.head == :ref
        return expr.args[1]
    elseif expr.head == :call && (expr.args[1] == :getindex || expr.args[1] === getindex)
        return expr.args[2]
    end
    for arg in expr.args
        res = find_vartype_reference(arg)
        res === nothing || return res
    end
    return nothing
end

# A total ordering

<ₑ(a::Real,    b::Real) = abs(a) < abs(b)
<ₑ(a::Complex, b::Complex) = (abs(real(a)), abs(imag(a))) < (abs(real(b)), abs(imag(b)))
<ₑ(a::Real,    b::Complex) = true
<ₑ(a::Complex, b::Real) = false

<ₑ(a::BasicSymbolic, b::Number) = false
<ₑ(a::Number, b::BasicSymbolic) = true

<ₑ(a::Function, b::Function) = nameof(a) <ₑ nameof(b)

<ₑ(a::Type, b::Type) = nameof(a) <ₑ nameof(b)
<ₑ(a::T, b::S) where{T,S} = T<S
<ₑ(a::T, b::T) where{T} = a < b

"""
$(SIGNATURES)

Get the degrees of symbols within a given expression.

This internal function is used to define the order of terms in a symbolic expression,
which is a variation on degree lexicographic order. It is used for printing and
by [`sorted_arguments`](@ref).

Returns a tuple of degree and lexicographically sorted *multiplier* ⇒ *power* pairs,
where the *multiplier* is a tuple of the symbol optionally followed by its indices.
For a sum expression, returns the `get_degrees()` result for term with the highest degree.

See also `monomial_lt` and `lexlt`.
"""
function get_degrees(expr::BasicSymbolic{T}) where {T}
    if T === SymReal
        return _get_degrees_1(expr)
    elseif T === SafeReal
        return _get_degrees_2(expr)
    elseif T === TreeReal
        return _get_degrees_3(expr)
    end
    _unreachable()
end

const DegreesT = SmallV{Pair{SmallV{Symbol}, Float64}}
const RODegreesT = ReadOnlyVector{Pair{SmallV{Symbol}, Float64}, DegreesT}

@cache function _get_degrees_1(expr::BasicSymbolic{SymReal})::RODegreesT
    __get_degrees(expr)
end
@cache function _get_degrees_2(expr::BasicSymbolic{SafeReal})::RODegreesT
    __get_degrees(expr)
end
@cache function _get_degrees_3(expr::BasicSymbolic{TreeReal})::RODegreesT
    __get_degrees(expr)
end

function __default_degrees!(degrees::DegreesT, expr::BasicSymbolic{T}) where {T}
    @match expr begin
        BSImpl.Term(; f) => begin
            if f isa BasicSymbolic{T}
                if hasname(f)
                    push!(degrees, SmallV{Symbol}((getname(f),)) => 1.0)
                else
                    __default_degrees!(degrees, f)
                end
            elseif applicable(nameof, f)
                push!(degrees, SmallV{Symbol}((nameof(f),)) => 1.0)
            else
                push!(degrees, SmallV{Symbol}((:zzz_ZZZ_unknown,)) => 1.0)
            end
        end
        _ => push!(degrees, SmallV{Symbol}((:zzz__ZZZ_unknown,)) => 1.0)
    end
end

function __get_degrees(expr::BasicSymbolic{T})::RODegreesT where {T}
    degrees = DegreesT()
    @match expr begin
        BSImpl.Const(;) => return RODegreesT(degrees)
        BSImpl.Sym(; name) => return RODegreesT(push!(degrees, SmallV{Symbol}((name,)) => 1.0))
        BSImpl.Term(; f, args) => begin
            if f === (^)
                base, pow = args
                if isconst(pow) && (_pow = unwrap_const(pow)) isa Real
                    # Powers can be made `Float64` because we don't care about accuracy,
                    # just relative ordering. Also absurdly large powers are arguably rare
                    # enough that we don't mind them being `Inf`.
                    _pow = convert(Float64, _pow)
                    base_degs = copy(parent(get_degrees(base)))
                    @union_split_smallvec base_degs begin
                        # Multiply degrees by `_pow`
                        for (i, deg) in enumerate(base_degs)
                            base_degs[i] = deg[1] => (deg[2] * _pow)
                        end
                        # If `_pow` is negative, we re-sort
                        if _pow < 0 && length(base_degs) > 1
                            sort!(base_degs)
                        end
                    end
                    return RODegreesT(base_degs)
                else
                    return RODegreesT(__default_degrees!(degrees, expr))
                end
            elseif f === getindex
                syms = SmallV{Symbol}()
                sizehint!(syms, length(args))
                @union_split_smallvec args begin
                    for arg in args
                        if isconst(arg)
                            push!(syms, index_arg_to_symbol(arg))
                            continue
                        end
                        arg_deg = parent(get_degrees(arg))
                        @union_split_smallvec arg_deg begin
                            for (_syms, _) in arg_deg
                                append!(syms, _syms)
                            end
                        end
                    end
                end
                push!(degrees, syms => 1.0)
                return RODegreesT(degrees)
            else
                return RODegreesT(__default_degrees!(degrees, expr))
            end
        end
        BSImpl.Div(; num, den) => begin
            if isconst(den)
                return get_degrees(num)
            elseif isconst(num)
                degs = copy(parent(get_degrees(den)))
                @union_split_smallvec degs begin
                    for (i, deg) in enumerate(degs)
                        degs[i] = deg[1] => -deg[2]
                    end
                    sort!(degs)
                end
                return RODegreesT(degs)
            else
                return RODegreesT(__default_degrees!(degrees, expr))
            end
        end
        BSImpl.AddMul(; variant, dict) => begin
            if variant === AddMulVariant.ADD
                cur_degsum = 0
                # Technically we want to call `_get_degrees` on `arguments(..)` but since
                # constants don't contribute to the result, it is equivalent to calling
                # `_get_degrees` on `keys(dict)`.
                for k in keys(dict)
                    kdegs = parent(get_degrees(k))
                    kdegsum = sum(last, kdegs)
                    if isempty(degrees) || kdegsum > cur_degsum ||
                        kdegsum == cur_degsum && lexlt(kdegs, degrees)
                        degrees = kdegs
                        cur_degsum = kdegsum
                    end
                end
                return RODegreesT(degrees)
            else
                # For multiplication, we just use `arguments` since otherwise we'd need to
                # duplicate the `^` code.
                args = parent(arguments(expr))
                sizehint!(degrees, length(args))
                @union_split_smallvec args begin
                    for arg in args
                        append!(degrees, get_degrees(arg))
                    end
                end
                @union_split_smallvec degrees sort!(degrees)
                return RODegreesT(degrees)
            end
        end
        BSImpl.ArrayOp(;) => return RODegreesT(__default_degrees!(degrees, expr))
        BSImpl.ArrayMaker(;) => return RODegreesT(__default_degrees!(degrees, expr))
        _ => return RODegreesT(__default_degrees!(degrees, expr))
    end
end

function index_arg_to_symbol(x::BasicSymbolic{T})::Symbol where {T}
    x = unwrap_const(x)
    if x isa Int
        return Symbol(x)
    elseif x isa Colon
        return Symbol(x)
    elseif x isa UnitRange{Int}
        return Symbol(x)
    elseif x isa StepRange{Int, Int}
        return Symbol(x)
    else
        return Symbol(x)::Symbol
    end
end

function monomial_lt(degs1::RODegreesT, degs2::RODegreesT)
    monomial_lt(parent(degs1), parent(degs2))
end

function monomial_lt(degs1::DegreesT, degs2::DegreesT)
    @union_split_smallvec degs1 begin
        @union_split_smallvec degs2 begin
            d1 = sum(last, degs1; init=0.0)
            d2 = sum(last, degs2; init=0.0)
            d1 != d2 ?
                # lower absolute degree first, or if equal, positive degree first
                (abs(d1) < abs(d2) || abs(d1) == abs(d2) && d1 > d2) :
                lexlt(degs1, degs2)
        end
    end
end

function lexlt(degs1::AbstractVector{eltype(DegreesT)}, degs2::AbstractVector{eltype(DegreesT)})
    for ((a_base, a_deg), (b_base, b_deg)) in zip(degs1, degs2)
        if a_base == b_base && a_deg != b_deg
            # same base, higher absolute degree first, positive degree first
            return abs(a_deg) > abs(b_deg) || abs(a_deg) == abs(b_deg) && a_deg > b_deg
        elseif a_base != b_base
            # lexicographic order for the base
            return a_base < b_base
        end
    end
    return false # they are equal
end
function lexlt(degs1::DegreesT, degs2::DegreesT)
    @union_split_smallvec degs1 begin
        @union_split_smallvec degs2 begin
            return lexlt(degs1, degs2)
        end
    end
end

_arglen(a) = iscall(a) ? length(arguments(a)) : 0

"""
    a <ₑ b

Compare symbolic expressions and their degree representations using the
canonical expression ordering. The operator is intended for deterministic
ordering of terms, not for mathematical less-than comparisons.
"""
function <ₑ(a::Tuple, b::Tuple)
    for (x, y) in zip(a, b)
        if x <ₑ y
            return true
        elseif y <ₑ x
            return false
        end
    end
    return length(a) < length(b)
end
function <ₑ(a::RODegreesT, b::RODegreesT)
    <ₑ(parent(a), parent(b))
end
function <ₑ(a::DegreesT, b::RODegreesT)
    <ₑ(a, parent(b))
end
function <ₑ(a::RODegreesT, b::DegreesT)
    <ₑ(parent(a), b)
end
function <ₑ(a::DegreesT, b::DegreesT)
    @union_split_smallvec a begin
        @union_split_smallvec b begin
            for (x, y) in zip(a, b)
                if x <ₑ y
                    return true
                elseif y <ₑ x
                    return false
                end
            end
            return length(a) < length(b)
        end
    end
end

function <ₑ(a::BasicSymbolic{T}, b::BasicSymbolic{T}) where {T}
    if isconst(a) || isconst(b)
        return <ₑ(unwrap_const(a), unwrap_const(b))
    end
    da, db = get_degrees(a), get_degrees(b)
    fw = monomial_lt(da, db)
    bw = monomial_lt(db, da)
    if fw === bw && !isequal(a, b)
        nargsa = _arglen(a)
        nargsb = _arglen(b)
        nargsa == nargsb || return nargsa < nargsb
        nargsa == 0 && return false

        opa = operation(a)
        opb = operation(b)
        if opa isa BasicSymbolic{T} && opb isa BasicSymbolic{T} && opa !== opb
            return <ₑ(opa, opb)
        end
        sargsa = sorted_arguments(a)
        sargsb = sorted_arguments(b)
        for i in eachindex(sargsa)
            isequal(sargsa[i], sargsb[i]) && continue
            return <ₑ(sargsa[i], sargsb[i])
        end
    end
    return fw
end

*(a::BasicSymbolic) = a

@noinline function throw_expected_matrix(x)
    throw(ArgumentError(LazyString("Expected matrix in multiplication, got argument of shape ", x, ".")))
end
@noinline function throw_expected_matvec(x)
    throw(ArgumentError(LazyString("Expected matrix or vector in multiplication, got argument of shape ", x, ".")))
end
@noinline function throw_incompatible_shapes(x, y)
    throw(ArgumentError(LazyString("Encountered incompatible shapes ", x, " and ", y, " when multiplying.")))
end

is_array_shape(sh::ShapeT) = sh isa Unknown || _ndims_from_shape(sh) > 0
function _multiplied_shape(shapes)
    first_arr = findfirst(is_array_shape, shapes)
    first_arr === nothing && return ShapeVecT(), first_arr, nothing
    last_arr::Int = findlast(is_array_shape, shapes)
    first_arr == last_arr && return shapes[first_arr], first_arr, last_arr

    sh1::ShapeT = shapes[first_arr]
    shend::ShapeT = shapes[last_arr]
    ndims_1 = _ndims_from_shape(sh1)
    ndims_end = _ndims_from_shape(shend)
    # Vector * transpose(Vector) works
    ndims_1 == -1 || ndims_1 == 2 || ndims_1 == 1 || throw_expected_matrix(sh1)
    ndims_end <= 2 || throw_expected_matvec(shend)
    if ndims_end == 1
        # NOTE: This lies because the shape of a matvec mul isn't solely determined by the
        # shapes of inputs. If the first array is an adjoint or transpose, the result
        # is a scalar.
        result = sh1 isa Unknown ? Unknown(1) : ShapeVecT((sh1[1],))
    elseif sh1 isa Unknown || shend isa Unknown
        result = Unknown(ndims_end)
    else
        result = ShapeVecT((first(sh1), last(shend)))
    end
    cur_shape = sh1
    is_matmatmul = ndims_1 != 1
    for i in (first_arr + 1):last_arr
        sh = shapes[i]
        ndims_sh = _ndims_from_shape(sh)
        is_array_shape(sh) || continue
        ndims_sh <= 2 || throw_expected_matvec(shend)
        if is_matmatmul
            if cur_shape isa ShapeVecT && sh isa ShapeVecT
                if length(last(cur_shape)) != length(first(sh))
                    throw_incompatible_shapes(cur_shape, sh)
                end
            end
        else
            ndims_sh == 2 || throw_incompatible_shapes(cur_shape, sh)
            if cur_shape isa ShapeVecT && sh isa ShapeVecT
                length(first(sh)) == 1 || throw_incompatible_shapes(cur_shape, sh)
            end
        end
        is_matmatmul = ndims_sh != 1
        cur_shape = sh
    end

    return result, first_arr, last_arr
end

function promote_shape(::typeof(*), shs::ShapeT...)
    _multiplied_shape(shs)[1]
end

const AdjointOrTranspose = Union{LinearAlgebra.Adjoint, LinearAlgebra.Transpose}

function _check_adjoint_or_transpose(terms, result::ShapeT, first_arr::Union{Int, Nothing}, last_arr::Union{Int, Nothing})
    @nospecialize first_arr result last_arr
    first_arr === nothing && return result
    last_arr = last_arr::Int
    first_arr == last_arr && return result
    farr = terms[first_arr]
    ndlarr = ndims(terms[last_arr])
    if result isa ShapeVecT && length(result) <= 2 && all(isone ∘ length, result) && (farr isa AdjointOrTranspose || iscall(farr) && (operation(farr) === adjoint || operation(farr) === transpose)) && ndlarr < 2
        return ShapeVecT()
    end
    return result
end

function _multiplied_terms_shape(terms::Tuple)
    result, first_arr, last_arr = _multiplied_shape(ntuple(shape ∘ unwrap ∘ Base.Fix1(getindex, terms), Val(length(terms))))
    return _check_adjoint_or_transpose(terms, result, first_arr, last_arr)
end

function _multiplied_terms_shape(terms)
    shapes = SmallV{ShapeT}()
    sizehint!(shapes, length(terms))
    for t in terms
        push!(shapes, shape(t))
    end
    result, first_arr, last_arr = _multiplied_shape(shapes)
    return _check_adjoint_or_transpose(terms, result, first_arr, last_arr)
end

function _split_arrterm_scalar_coeff(::Type{T}, ex::BasicSymbolic{T}) where {T}
    sh = shape(ex)
    is_array_shape(sh) || return ex, one_of_vartype(T)
    @match ex begin
        BSImpl.Term(; f, args, type) && if f === (*) && !is_array_shape(shape(first(args))) end => begin
            if length(args) == 2
                return args[1], args[2]
            end
            rest = ArgsT{T}()
            sizehint!(rest, length(args) - 1)
            coeff, restargs = Iterators.peel(args)
            for arg in restargs
                push!(rest, arg)
            end
            return coeff, Term{T}(f, rest; type, shape = sh)
        end
        BSImpl.ArrayOp(; output_idx, expr, reduce, term, ranges, shape, type) => begin
            coeff, rest = @match expr begin
                BSImpl.Term(; f, args, type, shape) && if f === (*) end => begin
                    if query(isequal(idxs_for_arrayop(T)), args[1])
                        one_of_vartype(T), expr
                    elseif length(args) == 2
                        args[1], args[2]
                    else
                        newargs = ArgsT{T}()
                        _coeff, rest = Iterators.peel(args)
                        append!(newargs, rest)
                        _coeff, BSImpl.Term{T}(*, newargs; type, shape)
                    end
                end
                _ => (one_of_vartype(T), expr)
            end
            if term === nothing
                termrest = nothing
            else
                termcoeff, termrest = _split_arrterm_scalar_coeff(T ,term)
                @assert isequal(termcoeff, coeff)
            end
            return coeff, BSImpl.ArrayOp{T}(output_idx, rest, reduce, termrest, ranges; shape, type)
        end
        _ => (one_of_vartype(T), ex)
    end
end
_split_arrterm_scalar_coeff(::Type{T}, ex) where {T} = one_of_vartype(T), Const{T}(ex)

function _mul_worker!(::Type{T}, num_coeff, den_coeff, num_dict, den_dict, term) where {T}
    @nospecialize term
    if term isa BasicSymbolic{T}
        @match term begin
            BSImpl.Const(; val) => (num_coeff[] *= val)
            BSImpl.AddMul(; coeff, dict, variant) && if variant == AddMulVariant.MUL end => begin
                num_coeff[] *= coeff
                for (k, v) in dict
                    _accumulate!(num_dict, k, v)
                end
            end
            BSImpl.Term(; f, args) && if f === (^) && !isconst(args[1]) && isconst(args[2]) end => begin
                base, exp = args
                _accumulate!(num_dict, base, unwrap_const(exp))
            end
            BSImpl.Div(; num, den) => begin
                _mul_worker!(T, num_coeff, den_coeff, num_dict, den_dict, num)
                _mul_worker!(T, den_coeff, num_coeff, den_dict, num_dict, den)
            end
            x => begin
                _accumulate!(num_dict, x, 1)
            end
        end
    elseif term isa BasicSymbolic{SymReal} || term isa BasicSymbolic{SafeReal}
        error(LazyString("Cannot operate on symbolics with different vartypes. Found `", T, "` and `", vartype(term), "`."))
    elseif term isa AbstractIrrational
        base = BSImpl.Term{T}(identity, ArgsT{T}((Const{T}(term),)); type = Real, shape = ShapeVecT())
        _accumulate!(num_dict, base, 1)
    else
        num_coeff[] *= term
    end
    return nothing
end

mutable struct MulWorkerBuffer{T}
    num_dict::ACDict{T}
    den_dict::ACDict{T}
    const num_coeff::RefValue{PolyCoeffT}
    const den_coeff::RefValue{PolyCoeffT}
    busy::Bool
end

function MulWorkerBuffer{T}() where {T}
    MulWorkerBuffer{T}(ACDict{T}(), ACDict{T}(), Ref{PolyCoeffT}(1), Ref{PolyCoeffT}(1), false)
end

function Base.empty!(mwb::MulWorkerBuffer)
    empty!(mwb.num_dict)
    empty!(mwb.den_dict)
    mwb.num_coeff[] = 1
    mwb.den_coeff[] = 1
    return mwb
end

const SYMREAL_MULBUFFER = TaskLocalValue{MulWorkerBuffer{SymReal}}(MulWorkerBuffer{SymReal})
const SAFEREAL_MULBUFFER = TaskLocalValue{MulWorkerBuffer{SafeReal}}(MulWorkerBuffer{SafeReal})

function (mwb::MulWorkerBuffer{T})(terms) where {T}
    if terms isa ArgsT{T}
        @union_split_smallvec terms begin
            for x in terms
                _is_array_of_symbolics(x) && continue
                _numeric_or_arrnumeric_symtype(x) && continue
                throw(MethodError(*, Tuple(symtype.(terms))))
            end
        end
    else
        for x in terms
            _is_array_of_symbolics(x) && continue
            _numeric_or_arrnumeric_symtype(x) && continue
            throw(MethodError(*, Tuple(symtype.(terms))))
        end
    end
    isempty(terms) && return one_of_vartype(T)
    length(terms) == 1 && return Const{T}(terms[1])
    empty!(mwb)
    newshape = _multiplied_terms_shape(terms)
    num_dict = mwb.num_dict
    num_coeff = mwb.num_coeff
    den_dict = mwb.den_dict
    den_coeff = mwb.den_coeff
    arrterms = BasicSymbolic{T}[]

    # We're multiplying numbers here. If we don't take the `eltype`
    # and the first element is an array, `promote_symtype` may fail
    # so we take the eltype, since `scalar * scalar` and `scalar * array`
    # both give the correct result regardless of whether the first element
    # is a scalar or array.
    type::TypeT = safe_eltype(symtype(Const{T}(first(terms))))

    for term in terms
        term = unwrap(term)
        if _is_array_of_symbolics(term)
            term = Const{T}(term)
        end
        sh = shape(term)
        type = promote_symtype(*, type, symtype(term))
        if is_array_shape(sh)
            coeff, arrterm = _split_arrterm_scalar_coeff(T, term)
            _mul_worker!(T, num_coeff, den_coeff, num_dict, den_dict, coeff)
            if iscall(arrterm) && operation(arrterm) === (*)
                append!(arrterms, arguments(arrterm))
            else
                push!(arrterms, arrterm)
            end
            continue
        end
        _mul_worker!(T, num_coeff, den_coeff, num_dict, den_dict, term)
    end
    for k in keys(num_dict)
        haskey(den_dict, k) || continue
        numexp = num_dict[k]
        denexp = den_dict[k]
        if (numexp >= denexp)::Bool
            num_dict[k] = numexp - denexp
            den_dict[k] = 0
        else
            num_dict[k] = 0
            den_dict[k] = denexp - numexp
        end
    end
    filter!(kvp -> !iszero(kvp[2]), num_dict)
    filter!(kvp -> !iszero(kvp[2]), den_dict)

    ntrivialcoeff = _isone(num_coeff[])::Bool
    dtrivialcoeff = _isone(den_coeff[])::Bool
    ntrivialdict = isempty(num_dict)
    dtrivialdict = isempty(den_dict)
    ntrivial = ntrivialcoeff && ntrivialdict
    dtrivial = dtrivialcoeff && dtrivialdict

    if ntrivialcoeff && ntrivialdict
        num = one_of_vartype(T)
    elseif ntrivialdict
        num = Const{T}(num_coeff[])
    else
        num = Mul{T}(num_coeff[], num_dict; type = safe_eltype(type)::TypeT)::BasicSymbolic{T}
        @match num begin
            BSImpl.AddMul(; dict) && if dict === num_dict end => begin
                mwb.num_dict = ACDict{T}()
            end
            _ => nothing
        end
    end
    if dtrivialcoeff && dtrivialdict
        den = one_of_vartype(T)
    elseif dtrivialdict
        den = Const{T}(den_coeff[])
    else
        den = Mul{T}(den_coeff[], den_dict; type = safe_eltype(type)::TypeT)::BasicSymbolic{T}
        @match den begin
            BSImpl.AddMul(; dict) && if dict === den_dict end => begin
                mwb.den_dict = ACDict{T}()
            end
            _ => nothing
        end
    end

    if ntrivial && dtrivial
        result = one_of_vartype(T)
    elseif dtrivial
        result = num
    else
        result = Div{T}(num, den, false; type = safe_eltype(type)::TypeT)::BasicSymbolic{T}
    end

    isempty(arrterms) && return result

    scalartrivial = ntrivial && dtrivial
    new_arrterms = ArgsT{T}()
    _nontrivial_coeff = !scalartrivial
    if _nontrivial_coeff
        push!(new_arrterms, result)
    end
    cur = 2
    acc_arrterm = arrterms[1]
    acc_pow = 1
    @match acc_arrterm begin
        BSImpl.Term(; f, args) && if f === (^) && isconst(args[2]) end => begin
            acc_arrterm = args[1]
            acc_pow = unwrap_const(args[2])::Number
        end
        _ => nothing
    end
    n_arrterms = length(arrterms)
    while cur <= n_arrterms
        cur_arrterm = arrterms[cur]
        cur += 1
        @match cur_arrterm begin
            BSImpl.Term(; f, args) && if f === (^) && isequal(args[1], acc_arrterm) && isconst(args[2]) end => begin
                acc_pow += unwrap_const(args[2])
            end
            _ => begin
                if isequal(acc_arrterm, cur_arrterm)
                    acc_pow += 1
                    continue
                end
                push!(new_arrterms, _isone(acc_pow) ? acc_arrterm : (acc_arrterm ^ acc_pow))
                acc_arrterm = cur_arrterm
                acc_pow = 1
            end
        end
    end
    push!(new_arrterms, _isone(acc_pow) ? acc_arrterm : (acc_arrterm ^ acc_pow))
    if length(new_arrterms) == 1
        return new_arrterms[1]
    end
    return Term{T}(*, new_arrterms; type, shape = newshape)
end

@inline function _run_mulbuffer(buf::MulWorkerBuffer{T}, terms) where {T}
    if buf.busy
        buf = MulWorkerBuffer{T}()
    end
    buf.busy = true
    try
        return buf(terms)
    finally
        buf.busy = false
    end
end

"""
    $METHODLIST

Multiply an indexable list or tuple of terms `terms` with the given vartype. Applicable
only for symbolic expressions with numeric or array of numeric symtype.
"""
mul_worker(::Type{SymReal}, terms) = _run_mulbuffer(SYMREAL_MULBUFFER[], terms)
mul_worker(::Type{SafeReal}, terms) = _run_mulbuffer(SAFEREAL_MULBUFFER[], terms)

function *(x::T, args::Union{Number, T, AbstractArray{<:Number}, AbstractArray{T}}...) where {T <: NonTreeSym}
    length(args) == 1 && args[1] isa Number && _isone(args[1]) && return x
    mul_worker(vartype(T), (x, args...))
end

for T in [:(PolyadicNumericOpFirstArgT{T}), Int, Float64, Bool]
    @eval function *(a::$T, b::T, bs::Union{Number, T, AbstractArray{<:Number}, AbstractArray{T}}...) where {T <: NonTreeSym}
        isempty(bs) && a isa Number && _isone(a) && return b
        return mul_worker(vartype(T), (a, b, bs...))
    end
end

struct __InternalInvalidator1 <: Real end
struct __InternalInvalidator2 <: AbstractArray{Real, 1} end
struct __InternalInvalidator3 <: AbstractArray{Number, 2} end
struct __InternalInvalidator4 <: Operator end
struct __InternalInvalidator5 <: Operator end
struct __InternalInvalidator6 <: Operator end
symtype(::__InternalInvalidator1) = _unreachable()
symtype(::__InternalInvalidator2) = _unreachable()
symtype(::__InternalInvalidator3) = _unreachable()
symtype(::Vector{Int}) = Vector{Int}
symtype(::Matrix{Float64}) = Matrix{Float64}
symtype(::Array{UInt, 3}) = Array{UInt, 3}
symtype(::Int) = Int
symtype(::Float64) = Float64
symtype(::UInt) = UInt
unwrap(::__InternalInvalidator1) = _unreachable()
unwrap(::__InternalInvalidator2) = _unreachable()
unwrap(::__InternalInvalidator3) = _unreachable()
unwrap(x::AbstractArray{Int}) = x
unwrap(x::AbstractArray{Float64}) = x
unwrap(x::AbstractArray{UInt}) = x
unwrap(x::Int) = x
unwrap(x::Float64) = x
unwrap(x::UInt) = x
(::Rule)(::__InternalInvalidator1) = _unreachable()
(::Rule)(::__InternalInvalidator2) = _unreachable()
(::Rule)(::__InternalInvalidator3) = _unreachable()
(::ACRule)(::__InternalInvalidator1) = _unreachable()
(::ACRule)(::__InternalInvalidator2) = _unreachable()
(::ACRule)(::__InternalInvalidator3) = _unreachable()
promote_symtype(::__InternalInvalidator1, args...) = _unreachable()
promote_symtype(::__InternalInvalidator2, args...) = _unreachable()
promote_symtype(::__InternalInvalidator3, args...) = _unreachable()
Base.convert(::Type{__InternalInvalidator1}, ::BasicSymbolic) = _unreachable()
Base.convert(::Type{Int}, ::BasicSymbolic) = _unreachable()
Base.convert(::Type{Float64}, ::BasicSymbolic) = _unreachable()
Base.convert(::Type{UInt}, ::BasicSymbolic) = _unreachable()
expand(x::Int, _...) = x
expand(x::Complex{Int}, _...) = x
expand(x::Complex{Float64}, _...) = x
simplify(x::Int; _...) = x
simplify(x::Complex{Int}; _...) = x
simplify(x::Complex{Float64}; _...) = x
"""
    isbinop(x)

Return whether `x` is recognized as a binary symbolic operator. This extension
point defaults to `false` for non-symbolic values and can be specialized by
symbolic operator implementations.
"""
function isbinop end

isbinop(::Int) = false
isbinop(::String) = false
isbinop(::__InternalInvalidator1) = false
operator_to_term(::__InternalInvalidator4, ::BasicSymbolic) = _unreachable()
operator_to_term(::__InternalInvalidator5, ::BasicSymbolic) = _unreachable()
operator_to_term(::__InternalInvalidator6, ::BasicSymbolic) = _unreachable()
show_metadata(::IO, ::BasicSymbolic, ::Type{__InternalInvalidator1}, ::Any) = _unreachable()
show_metadata(::IO, ::BasicSymbolic, ::Type{__InternalInvalidator2}, ::Any) = _unreachable()
show_metadata(::IO, ::BasicSymbolic, ::Type{__InternalInvalidator3}, ::Any) = _unreachable()

using SymbolicUtils: OrderedDiGraph, AdjView, OrderedDiGraphEdgeIter, rem_outedges!
using Graphs
using Test

# ── helpers ────────────────────────────────────────────────────────────────────

# Build a graph from a list of (src, dst) pairs and return it.
function make_graph(n::Int, edges::Pair{Int,Int}...)
    g = OrderedDiGraph{Int}(n)
    for (s, d) in edges
        add_edge!(g, s, d)
    end
    return g
end

# Helper functions for @inferred tests — must be at module scope so that the
# compiler can fully specialize them.
function _sum_outneighbors(g::OrderedDiGraph{Int}, v::Int)
    s = 0
    for x in outneighbors(g, v)
        s += x
    end
    return s
end

function _sum_inneighbors(g::OrderedDiGraph{Int}, v::Int)
    s = 0
    for x in inneighbors(g, v)
        s += x
    end
    return s
end

function _has_any_outneighbor(g::OrderedDiGraph{Int}, v::Int, target::Int)
    for x in outneighbors(g, v)
        x == target && return true
    end
    return false
end

# ── Construction ───────────────────────────────────────────────────────────────

@testset "Construction" begin
    @testset "empty constructors" begin
        g = OrderedDiGraph{Int}()
        @test nv(g) == 0
        @test ne(g) == 0

        g2 = OrderedDiGraph()
        @test eltype(g2) == Int
        @test nv(g2) == 0

        g3 = OrderedDiGraph(Int32)
        @test eltype(g3) == Int32
        @test nv(g3) == 0
    end

    @testset "n-vertex constructor" begin
        g = OrderedDiGraph{Int}(5)
        @test nv(g) == 5
        @test ne(g) == 0
        @test vertices(g) == 1:5

        # Infer T from argument
        g2 = OrderedDiGraph(Int16(4))
        @test eltype(g2) == Int16
        @test nv(g2) == 4
    end

    @testset "copy constructor" begin
        g = make_graph(3, 1=>2, 1=>3, 2=>3)
        h = OrderedDiGraph(g)
        @test g == h
        # Mutating the copy does not affect the original
        add_edge!(h, 3, 1)
        @test !has_edge(g, 3, 1)
        @test ne(h) == ne(g) + 1
    end

    @testset "type-converting copy constructor" begin
        g = make_graph(3, 1=>2, 2=>3)
        h = OrderedDiGraph{Int32}(g)
        @test eltype(h) == Int32
        @test nv(h) == 3 && ne(h) == 2
        @test has_edge(h, 1, 2) && has_edge(h, 2, 3)
        # Insertion order preserved after type conversion
        @test collect(outneighbors(h, 1)) == Int32[2]
        @test collect(outneighbors(h, 2)) == Int32[3]
    end

    @testset "construct from SimpleDiGraph" begin
        sdg = SimpleDiGraph(3)
        add_edge!(sdg, 1, 2)
        add_edge!(sdg, 2, 3)
        g = OrderedDiGraph(sdg)
        @test nv(g) == 3 && ne(g) == 2
        @test has_edge(g, 1, 2) && has_edge(g, 2, 3)
        @test !has_edge(g, 1, 3)
    end

    @testset "zero" begin
        g = zero(OrderedDiGraph{Int})
        @test nv(g) == 0 && ne(g) == 0

        g2 = make_graph(3, 1=>2)
        @test zero(g2) == zero(OrderedDiGraph{Int})
    end
end

# ── Graphs.jl interface ────────────────────────────────────────────────────────

@testset "Graphs.jl interface" begin
    g = make_graph(4, 1=>2, 1=>3, 2=>4, 3=>4)

    @testset "basic queries" begin
        @test nv(g) == 4
        @test ne(g) == 4
        @test vertices(g) == 1:4
        @test is_directed(g)
        @test is_directed(OrderedDiGraph{Int})
        @test edgetype(g) == Graphs.Edge{Int}
    end

    @testset "has_vertex" begin
        @test has_vertex(g, 1)
        @test has_vertex(g, 4)
        @test !has_vertex(g, 0)
        @test !has_vertex(g, 5)
    end

    @testset "has_edge" begin
        @test has_edge(g, 1, 2)
        @test has_edge(g, 1, 3)
        @test has_edge(g, 2, 4)
        @test has_edge(g, 3, 4)
        @test !has_edge(g, 2, 1)   # directed: reverse absent
        @test !has_edge(g, 1, 4)   # no direct edge
        @test !has_edge(g, 4, 4)   # no self-loop
        # Out-of-bounds vertices
        @test !has_edge(g, 0, 1)
        @test !has_edge(g, 1, 5)
    end

    @testset "outneighbors / inneighbors types" begin
        # both always return AdjView{T}
        @test outneighbors(g, 1) isa AdjView{Int}
        @test inneighbors(g, 4)  isa AdjView{Int}
    end

    @testset "indegree / outdegree" begin
        @test outdegree(g, 1) == 2
        @test outdegree(g, 4) == 0
        @test indegree(g, 4) == 2
        @test indegree(g, 1) == 0
    end
end

# ── Insertion-order invariant ──────────────────────────────────────────────────

@testset "Insertion-order invariant" begin
    @testset "spec example" begin
        # From the docstring: insert 2=>3, 1=>3, 1=>2 in that order
        g = OrderedDiGraph{Int}(3)
        add_edge!(g, 2, 3)
        add_edge!(g, 1, 3)
        add_edge!(g, 1, 2)

        @test collect(outneighbors(g, 1)) == [3, 2]
        @test collect(outneighbors(g, 2)) == [3]
        @test isempty(outneighbors(g, 3))
        @test Set(inneighbors(g, 3)) == Set([2, 1])
        @test Set(inneighbors(g, 2)) == Set([1])
    end

    @testset "order is preserved through insertions" begin
        g = OrderedDiGraph{Int}(5)
        add_edge!(g, 1, 5)
        add_edge!(g, 1, 3)
        add_edge!(g, 1, 2)
        add_edge!(g, 1, 4)
        @test collect(outneighbors(g, 1)) == [5, 3, 2, 4]

        # Adding another edge appends
        add_edge!(g, 1, 3)
        @test collect(outneighbors(g, 1)) == [5, 3, 2, 4, 3]
    end

    @testset "differs from SimpleDiGraph sorted order" begin
        # SimpleDiGraph would have sorted adjacency [2,3]; we should have [3,2]
        g = OrderedDiGraph{Int}(3)
        add_edge!(g, 1, 3)
        add_edge!(g, 1, 2)
        @test collect(outneighbors(g, 1)) == [3, 2]    # insertion order

        sdg = SimpleDiGraph(3)
        add_edge!(sdg, 1, 3)
        add_edge!(sdg, 1, 2)
        @test outneighbors(sdg, 1) == [2, 3]  # sorted
    end
end

# ── fadjlist representation (NTuple / Vector) ──────────────────────────────────

@testset "fadjlist NTuple/Vector representation" begin
    @testset "0 out-edges → AdjView of length 0" begin
        g = OrderedDiGraph{Int}(1)
        nbrs = outneighbors(g, 1)
        @test nbrs isa AdjView{Int}
        @test length(nbrs) == 0
        @test collect(nbrs) == Int[]
    end

    @testset "1 out-edge → AdjView of length 1" begin
        g = OrderedDiGraph{Int}(2)
        add_edge!(g, 1, 2)
        nbrs = outneighbors(g, 1)
        @test nbrs isa AdjView{Int}
        @test length(nbrs) == 1
        @test collect(nbrs) == [2]
    end

    @testset "2 out-edges → AdjView of length 2" begin
        g = OrderedDiGraph{Int}(3)
        add_edge!(g, 1, 3); add_edge!(g, 1, 2)
        nbrs = outneighbors(g, 1)
        @test nbrs isa AdjView{Int}
        @test length(nbrs) == 2
        @test collect(nbrs) == [3, 2]
    end

    @testset "3rd out-edge triggers transition to Vector" begin
        g = OrderedDiGraph{Int}(4)
        add_edge!(g, 1, 2); add_edge!(g, 1, 3); add_edge!(g, 1, 4)
        @test g.fadjlist[1] isa Vector{Int}  # internal representation
        @test outneighbors(g, 1) isa AdjView{Int}
        @test collect(outneighbors(g, 1)) == [2, 3, 4]
    end

    @testset "AdjView supports in-operator" begin
        g = OrderedDiGraph{Int}(3)
        add_edge!(g, 1, 3); add_edge!(g, 1, 2)
        nbrs = outneighbors(g, 1)
        @test 3 in nbrs
        @test 2 in nbrs
        @test !(1 in nbrs)
    end

end

# ── badjlist representation (NTuple / Set) ────────────────────────────────────

@testset "badjlist NTuple/Set representation" begin
    @testset "0 in-edges → AdjView of length 0" begin
        g = OrderedDiGraph{Int}(1)
        nbrs = inneighbors(g, 1)
        @test nbrs isa AdjView{Int}
        @test length(nbrs) == 0
        @test collect(nbrs) == Int[]
    end

    @testset "1 in-edge → AdjView of length 1" begin
        g = OrderedDiGraph{Int}(2)
        add_edge!(g, 2, 1)
        nbrs = inneighbors(g, 1)
        @test nbrs isa AdjView{Int}
        @test length(nbrs) == 1
        @test 2 in nbrs
    end

    @testset "2 in-edges → AdjView backed by NTuple" begin
        g = OrderedDiGraph{Int}(3)
        add_edge!(g, 2, 1); add_edge!(g, 3, 1)
        nbrs = inneighbors(g, 1)
        @test nbrs isa AdjView{Int}
        @test length(nbrs) == 2
        @test g.badjlist[1] isa NTuple{2, Int}  # internal representation
        @test 2 in nbrs && 3 in nbrs
    end

    @testset "3rd in-edge triggers transition to Set" begin
        g = OrderedDiGraph{Int}(4)
        add_edge!(g, 2, 1); add_edge!(g, 3, 1); add_edge!(g, 4, 1)
        @test g.badjlist[1] isa Set{Int}         # internal representation
        nbrs = inneighbors(g, 1)
        @test nbrs isa AdjView{Int}
        @test length(nbrs) == 3
        @test Set(nbrs) == Set([2, 3, 4])
    end

    @testset "AdjView supports in-operator (in-neighbors)" begin
        g = OrderedDiGraph{Int}(3)
        add_edge!(g, 2, 1); add_edge!(g, 3, 1)
        nbrs = inneighbors(g, 1)
        @test 2 in nbrs
        @test 3 in nbrs
        @test !(1 in nbrs)
    end

end

# ── add_vertex! / add_vertices! ────────────────────────────────────────────────

@testset "add_vertex! / add_vertices!" begin
    g = OrderedDiGraph{Int}()

    @test add_vertex!(g)
    @test nv(g) == 1

    @test add_vertex!(g)
    @test nv(g) == 2

    add_edge!(g, 1, 2)
    @test ne(g) == 1

    # add_vertices! returns count added
    n_added = add_vertices!(g, 3)
    @test n_added == 3
    @test nv(g) == 5

    # New vertices have empty adjacency
    @test isempty(outneighbors(g, 5))
    @test isempty(inneighbors(g, 5))

    # UInt8 overflow guard
    g8 = OrderedDiGraph{UInt8}(typemax(UInt8))
    @test !add_vertex!(g8)
    @test nv(g8) == typemax(UInt8)
end

# ── add_edge! ──────────────────────────────────────────────────────────────────

@testset "add_edge!" begin
    @testset "returns true on success, false for out-of-range vertices" begin
        g = OrderedDiGraph{Int}(3)
        @test add_edge!(g, 1, 2)           == true
        @test add_edge!(g, 1, 2)           == true   # multi-edge allowed
        @test add_edge!(g, 0, 1)           == false  # src out of range
        @test add_edge!(g, 1, 4)           == false  # dst out of range
        @test ne(g) == 2
    end

    @testset "via Edge object" begin
        g = OrderedDiGraph{Int}(2)
        @test add_edge!(g, Graphs.Edge(1, 2))
        @test has_edge(g, 1, 2)
        @test ne(g) == 1
    end

    @testset "via AbstractEdge" begin
        g = OrderedDiGraph{Int}(3)
        e = Graphs.Edge{Int32}(1, 3)   # different integer type
        @test add_edge!(g, e)
        @test has_edge(g, 1, 3)
    end

    @testset "self-loops allowed" begin
        g = OrderedDiGraph{Int}(2)
        @test add_edge!(g, 1, 1)
        @test has_edge(g, 1, 1)
        @test 1 in outneighbors(g, 1)
        @test 1 in inneighbors(g, 1)
        # Duplicate self-loop is a multi-edge, also allowed
        @test add_edge!(g, 1, 1)
        @test ne(g) == 2
    end

    @testset "adjacency state after insertion" begin
        g = OrderedDiGraph{Int}(3)
        add_edge!(g, 1, 2)
        add_edge!(g, 1, 3)
        @test collect(outneighbors(g, 1)) == [2, 3]
        @test 1 in inneighbors(g, 2)
        @test 1 in inneighbors(g, 3)
        @test ne(g) == 2
    end
end

# ── multi-edges ────────────────────────────────────────────────────────────────

@testset "multi-edges" begin
    @testset "same src→dst edge can be added multiple times" begin
        g = OrderedDiGraph{Int}(3)
        @test add_edge!(g, 1, 2) == true
        @test add_edge!(g, 1, 2) == true   # second edge allowed
        @test ne(g) == 2
        @test collect(outneighbors(g, 1)) == [2, 2]
        # badjlist records src only once
        @test length(inneighbors(g, 2)) == 1
        @test 1 in inneighbors(g, 2)
    end

    @testset "has_edge returns true with multi-edges" begin
        g = make_graph(2, 1=>2)
        add_edge!(g, 1, 2)
        @test has_edge(g, 1, 2)
        @test ne(g) == 2
    end

    @testset "rem_outedges! correctly handles NTuple-backed multi-edge" begin
        g = OrderedDiGraph{Int}(3)
        add_edge!(g, 1, 2); add_edge!(g, 1, 2)
        @test g.fadjlist[1] isa NTuple{2, Int}
        rem_outedges!(g, 1)
        @test ne(g) == 0
        @test isempty(outneighbors(g, 1))
        @test !(1 in inneighbors(g, 2))
    end

    @testset "rem_outedges! correctly handles Vector-backed multi-edge" begin
        g = OrderedDiGraph{Int}(3)
        add_edge!(g, 1, 2); add_edge!(g, 1, 2); add_edge!(g, 1, 3)
        @test g.fadjlist[1] isa Vector{Int}
        rem_outedges!(g, 1)
        @test ne(g) == 0
        @test isempty(outneighbors(g, 1))
        @test !(1 in inneighbors(g, 2))
        @test !(1 in inneighbors(g, 3))
    end

    @testset "multi-edge self-loop" begin
        g = OrderedDiGraph{Int}(2)
        @test add_edge!(g, 1, 1) == true
        @test add_edge!(g, 1, 1) == true
        @test ne(g) == 2
        @test collect(outneighbors(g, 1)) == [1, 1]
        @test length(inneighbors(g, 1)) == 1
    end

    @testset "three or more identical edges" begin
        g = OrderedDiGraph{Int}(2)
        for _ in 1:4
            add_edge!(g, 1, 2)
        end
        @test ne(g) == 4
        @test collect(outneighbors(g, 1)) == [2, 2, 2, 2]
        @test length(inneighbors(g, 2)) == 1
        rem_outedges!(g, 1)
        @test ne(g) == 0
        @test !(1 in inneighbors(g, 2))
    end
end

# ── rem_outedges! ─────────────────────────────────────────────────────────────

@testset "rem_outedges!" begin
    @testset "returns true on success, false for invalid vertex" begin
        g = make_graph(3, 1=>2, 1=>3)
        @test rem_outedges!(g, 1) == true
        @test rem_outedges!(g, 0) == false
        @test rem_outedges!(g, 4) == false
    end

    @testset "empty vertex: returns true without changing ne" begin
        g = make_graph(3, 2=>3)
        @test rem_outedges!(g, 1) == true
        @test ne(g) == 1
        @test isempty(outneighbors(g, 1))
    end

    @testset "NTuple backing: 1 out-edge" begin
        g = make_graph(2, 1=>2)
        @test rem_outedges!(g, 1) == true
        @test ne(g) == 0
        @test isempty(outneighbors(g, 1))
        @test !(1 in inneighbors(g, 2))
    end

    @testset "NTuple backing: 2 out-edges" begin
        g = make_graph(3, 1=>2, 1=>3)
        @test rem_outedges!(g, 1) == true
        @test ne(g) == 0
        @test isempty(outneighbors(g, 1))
        @test !(1 in inneighbors(g, 2))
        @test !(1 in inneighbors(g, 3))
    end

    @testset "Vector backing: 3+ out-edges" begin
        g = make_graph(5, 1=>2, 1=>3, 1=>4, 1=>5)
        @test rem_outedges!(g, 1) == true
        @test ne(g) == 0
        @test isempty(outneighbors(g, 1))
        for d in 2:5
            @test !(1 in inneighbors(g, d))
        end
    end

    @testset "destination with Set-backed badjlist" begin
        # vertex 5 acquires 4 in-edges, so its badjlist transitions to Set
        g = make_graph(5, 1=>5, 2=>5, 3=>5, 4=>5)
        @test g.badjlist[5] isa Set{Int}
        @test rem_outedges!(g, 1) == true
        @test ne(g) == 3
        @test !(1 in inneighbors(g, 5))
        @test 2 in inneighbors(g, 5)
        @test 3 in inneighbors(g, 5)
        @test 4 in inneighbors(g, 5)
    end

    @testset "unrelated edges are unaffected" begin
        g = make_graph(4, 1=>2, 1=>3, 4=>2)
        rem_outedges!(g, 1)
        @test ne(g) == 1
        @test has_edge(g, 4, 2)
        @test 4 in inneighbors(g, 2)
    end

    @testset "internal consistency after rem_outedges!" begin
        g = make_graph(5, 1=>2, 1=>3, 1=>4, 2=>3, 3=>5)
        rem_outedges!(g, 1)
        for v in vertices(g)
            for u in outneighbors(g, v)
                @test v in inneighbors(g, u)
            end
            for u in inneighbors(g, v)
                @test v in outneighbors(g, u)
            end
        end
        @test ne(g) == sum(outdegree(g, v) for v in vertices(g); init=0)
    end
end

# ── rem_vertex! / rem_vertices! ───────────────────────────────────────────────

@testset "rem_vertex! and rem_vertices! are unsupported" begin
    g = make_graph(3, 1=>2, 2=>3)
    @test_throws ErrorException rem_vertex!(g, 1)
    @test_throws ErrorException rem_vertex!(g, 3)
    @test_throws ErrorException rem_vertices!(g, [1, 2])
    @test_throws ErrorException rem_vertices!(g, Int[]; keep_order=true)
end

# ── edges iterator ─────────────────────────────────────────────────────────────

@testset "edges iterator" begin
    g = make_graph(3, 1=>3, 1=>2, 2=>3)

    @testset "length" begin
        @test length(edges(g)) == ne(g)
    end

    @testset "eltype" begin
        @test eltype(edges(g)) == Graphs.Edge{Int}
    end

    @testset "contains all edges" begin
        edge_set = Set(edges(g))
        @test Graphs.Edge(1, 3) in edge_set
        @test Graphs.Edge(1, 2) in edge_set
        @test Graphs.Edge(2, 3) in edge_set
        @test length(edge_set) == 3
    end

    @testset "in-operator uses has_edge" begin
        es = edges(g)
        @test Graphs.Edge(1, 3) in es
        @test !(Graphs.Edge(3, 1) in es)
    end

    @testset "empty graph" begin
        g0 = OrderedDiGraph{Int}()
        @test length(edges(g0)) == 0
        @test collect(edges(g0)) == Graphs.Edge{Int}[]
    end

    @testset "single vertex, no edges" begin
        g1 = OrderedDiGraph{Int}(1)
        @test collect(edges(g1)) == Graphs.Edge{Int}[]
    end

    @testset "iteration order follows fadjlist" begin
        # Edges from vertex 1 should appear in insertion order
        g2 = make_graph(4, 1=>4, 1=>2, 1=>3, 2=>4)
        collected = collect(edges(g2))
        from1 = [e for e in collected if src(e) == 1]
        @test dst.(from1) == [4, 2, 3]
    end
end

# ── copy and equality ──────────────────────────────────────────────────────────

@testset "copy and ==" begin
    g = make_graph(3, 1=>2, 2=>3)

    @testset "copy is equal to original" begin
        h = copy(g)
        @test g == h
    end

    @testset "copy is independent" begin
        h = copy(g)
        add_edge!(h, 3, 1)
        @test !has_edge(g, 3, 1)
        @test g != h
    end

    @testset "badjlist independence" begin
        h = copy(g)
        add_edge!(h, 3, 1)
        @test !has_edge(g, 3, 1)
        @test 3 in inneighbors(h, 1)
        @test !(3 in inneighbors(g, 1))
    end

    @testset "inequality on different structure" begin
        g1 = make_graph(3, 1=>2)
        g2 = make_graph(3, 2=>1)
        @test g1 != g2
    end

    @testset "inequality on different vertex count" begin
        g1 = make_graph(3, 1=>2)
        g2 = make_graph(4, 1=>2)
        @test g1 != g2
    end
end

# ── Graphs.jl algorithm compatibility ─────────────────────────────────────────

@testset "Graphs.jl algorithm compatibility" begin
    @testset "topological_sort_by_dfs on DAG" begin
        g = make_graph(4, 1=>2, 1=>3, 2=>4, 3=>4)
        topo = topological_sort_by_dfs(g)
        # In a valid topological order every src comes before its dst
        pos = Dict(v => i for (i, v) in enumerate(topo))
        for e in edges(g)
            @test pos[src(e)] < pos[dst(e)]
        end
    end

    @testset "topological_sort on linear chain" begin
        g = make_graph(5, 1=>2, 2=>3, 3=>4, 4=>5)
        topo = topological_sort_by_dfs(g)
        @test topo == [1, 2, 3, 4, 5]
    end

    @testset "indegree / outdegree" begin
        g = make_graph(4, 1=>2, 1=>3, 2=>4, 3=>4)
        @test indegree(g, 1) == 0
        @test outdegree(g, 1) == 2
        @test indegree(g, 4) == 2
        @test outdegree(g, 4) == 0
    end

    @testset "neighbors / all_neighbors" begin
        g = make_graph(3, 1=>2, 3=>1)
        @test Set(all_neighbors(g, 1)) == Set([2, 3])
    end
end

# ── show ───────────────────────────────────────────────────────────────────────

@testset "show" begin
    g = make_graph(3, 1=>2, 2=>3)
    s = sprint(show, g)
    @test occursin("directed ordered", s)
    @test occursin("3", s)   # nv
    @test occursin("2", s)   # ne
end

# ── Type parameterization ──────────────────────────────────────────────────────

@testset "Int32 and UInt8 vertex types" begin
    g32 = OrderedDiGraph{Int32}(3)
    add_edge!(g32, 1, 2); add_edge!(g32, 1, 3)
    @test collect(outneighbors(g32, 1)) == Int32[2, 3]
    @test inneighbors(g32, 2)  isa AdjView{Int32}
    @test has_edge(g32, 1, 2)

    g8 = OrderedDiGraph{UInt8}(4)
    add_edge!(g8, UInt8(1), UInt8(4))
    @test collect(outneighbors(g8, 1)) == UInt8[4]
    @test UInt8(1) in inneighbors(g8, 4)
end

# ── Internal consistency ───────────────────────────────────────────────────────

@testset "Internal consistency (fadjlist ↔ badjlist)" begin
    function check_consistent(g)
        for v in vertices(g)
            for u in outneighbors(g, v)
                @test v in inneighbors(g, u)
            end
            for u in inneighbors(g, v)
                @test v in outneighbors(g, u)
            end
        end
        # ne matches sum of out-degrees
        @test ne(g) == sum(outdegree(g, v) for v in vertices(g); init=0)
    end

    @testset "after insertions" begin
        g = make_graph(5, 1=>2, 1=>3, 2=>4, 3=>4, 4=>5, 2=>5)
        check_consistent(g)
    end

end

# ── Type stability (@inferred) ─────────────────────────────────────────────────

@testset "Type stability (@inferred)" begin
    # `@inferred` requires typeof(result) === inferred_type, so it is only
    # applicable to operations whose inferred return type is a concrete singleton
    # (not a Union). `iterate` always infers to Union{Nothing, Tuple{...}}, so
    # it is excluded here; JET covers iterate in adjview_jet.jl.

    # ── AdjView primitives ────────────────────────────────────────────────────
    ntup0 = AdjView{Int}((0, 0))
    ntup2 = AdjView{Int}((3, 7))
    vec3  = AdjView{Int}([4, 5, 6])
    set3  = AdjView{Int}(Set([4, 5, 6]))

    # length → Int
    @test @inferred(length(ntup0)) === 0
    @test @inferred(length(ntup2)) === 2
    @test @inferred(length(vec3))  === 3
    @test @inferred(length(set3))  === 3

    # in → Bool
    @test  @inferred(3 in ntup2)
    @test !@inferred(5 in ntup2)
    @test  @inferred(5 in vec3)
    @test  @inferred(5 in set3)
    @test !@inferred(9 in set3)

    # getindex → T (ordered backing only)
    @test @inferred(ntup2[1]) === 3
    @test @inferred(ntup2[2]) === 7
    @test @inferred(vec3[2])  === 5

    # ── AdjView loop helpers ──────────────────────────────────────────────────
    # outneighbors / inneighbors return the single concrete type AdjView{T}.
    # A function accumulating an Int across the loop has a concrete inferred type.

    g = OrderedDiGraph{Int}(5)
    add_edge!(g, 1, 3); add_edge!(g, 1, 4)                      # NTuple out-adj for v=1
    add_edge!(g, 2, 1); add_edge!(g, 3, 1); add_edge!(g, 5, 1)  # Set in-adj for v=1

    @test @inferred(_sum_outneighbors(g, 1)) == 7        # 3 + 4
    @test @inferred(_sum_inneighbors(g, 1))  == 10       # 2 + 3 + 5
    @test @inferred(_has_any_outneighbor(g, 1, 3))

    g2 = make_graph(4, 1=>2, 1=>3, 1=>4)                # Vector out-adj for v=1
    @test @inferred(_sum_outneighbors(g2, 1)) == 9       # 2 + 3 + 4

    # ── Graphs.jl API: basic queries ──────────────────────────────────────────
    @test @inferred(nv(g))           === 5
    @test @inferred(ne(g))           === 5
    @test @inferred(vertices(g))     === Base.OneTo(5)
    @test @inferred(is_directed(g))  === true
    @test @inferred(is_directed(OrderedDiGraph{Int})) === true
    @test @inferred(has_vertex(g, 1)) === true
    @test @inferred(has_vertex(g, 6)) === false
    @test @inferred(has_edge(g, 1, 3)) === true
    @test @inferred(has_edge(g, 1, 2)) === false

    # outneighbors / inneighbors return the single concrete type AdjView{T}
    @test @inferred(outneighbors(g, 1)) isa AdjView{Int}
    @test @inferred(inneighbors(g, 1))  isa AdjView{Int}

    # ── Graphs.jl API: edges iterator ─────────────────────────────────────────
    @test @inferred(edges(g))          isa OrderedDiGraphEdgeIter{Int}
    @test @inferred(length(edges(g)))  === 5
    @test @inferred(Graphs.Edge(1, 3) in edges(g)) === true

    # ── Graphs.jl API: mutation ───────────────────────────────────────────────
    gm = OrderedDiGraph{Int}(4)
    add_edge!(gm, 1, 2)
    @test @inferred(add_vertex!(gm))        === true
    @test @inferred(add_edge!(gm, 2, 3))    === true
    @test @inferred(rem_outedges!(gm, 1))   === true

    # ── copy / zero / == ──────────────────────────────────────────────────────
    @test @inferred(copy(g))                   isa OrderedDiGraph{Int}
    @test @inferred(zero(OrderedDiGraph{Int})) isa OrderedDiGraph{Int}
    h = copy(g)
    @test @inferred(g == h) === true
end

using SymbolicUtils, Test
import SymbolicUtils: iscall, issym, operation, arguments, symtype

issym(s::Symbol) = true
Base.nameof(s::Symbol) = s

for f ∈ [:+, :-, :*, :/, :^]
    @eval begin
        Base.$f(x::Union{Expr, Symbol}, y::Number) = Expr(:call, $f, x, y)
        Base.$f(x::Number, y::Union{Expr, Symbol}) = Expr(:call, $f, x, y)
        Base.$f(x::Union{Expr, Symbol}, y::Union{Expr, Symbol}) = (Expr(:call, $f, x, y))
    end
end

Base.zero(t::Expr) = 0
symtype(::Expr) = Real
symtype(::Symbol) = Real

ex = 1 + (:x - 2)

@test_skip simplify(ex) == -1 + :x
@test_skip simplify(:a * (:b + -1 * :c) + -1 * (:b * :a + -1 * :c * :a), expand=true) == 0

using SymbolicUtils
using SymbolicUtils: unwrap_const
using Test
include("utils.jl")

@syms a b c d x

@testset "Equality" begin
    @eqtest a == a
    @eqtest a != b
    @eqtest a*b == a*b
    @eqtest a*b != a
    @eqtest a != a*b
end

@testset "Literal Matcher" begin
    r = @rule 1 => 4
    @test r(1) === 4
    @test r(1.0) === 4
    @test r(2) === nothing
end

@testset "Slot matcher" begin
    @test @rule(~x => true)("?") === true
    @test @rule( ~x => ~x)(2) === 2
end

@testset "Term matcher" begin
    @test @rule(sin(~x) => ~x)(sin(a)) === a
    @eqtest @rule(sin(~x) => ~x)(sin(a^2)) == a^2
    @test @rule(sin(~x) => ~x)(sin(a)^2) === nothing
    @test @rule(sin(sin(~x)) => ~x)(sin(a^2)) === nothing
    @test @rule(sin(sin(~x)) => ~x)(sin(sin(a))) === a
    @test @rule(sin(~x)^2 => ~x)(sin(a)^2) === a
end

@testset "Equality matching" begin
    @test @rule((~x)^(~x) => ~x)(a^a) === a
    @test @rule((~x)^(~x) => ~x)(b^a) === nothing
    @test @rule((~x)^(~x) => ~x)(a+a) === nothing
    @eqtest @rule((~x)^(~x) => ~x)(sin(a)^sin(a)) == sin(a)
    # NOTE: This rule fails intermittently despite AC matching on * and +, due to lack of
    # "nested retries". Essentially, the first term will match `~x => b, ~y => a`, which
    # will go back to the matcher for `+`, which will try it on the second term and fail.
    # The matcher for `+` then reverses the order of the addition, the second term then
    # matches `~x => c, ~z => a` and the matcher for `+` tries it on the first term and
    # fails. There needs to be proper AC nesting so that a failure for `+` tries the next
    # matching of `*`.
    # For now, just reorder the slots in the rule to make it pass.
    # @eqtest @rule((~x*~y + ~z*~x)  => ~x * (~y+~z))(a*b + a*c) == a*(b+c)

    @test issetequal(@rule(+(~~x) => ~~x)(a + b), [a,b])
    @eqtest @rule(+(~~x) => ~~x)(term(+, a, b, c)) == [a,b,c]
    @eqtest @rule(+(~~x,~y, ~~x) => (unwrap_const.(~~x), unwrap_const(~y)))(term(+,9,8,9,type=Any)) == ([9,],8)
    @eqtest @rule(+(~~x,~y, ~~x) => (unwrap_const.(~~x), unwrap_const(~y), unwrap_const.(~~x)))(term(+,9,8,9,9,8,type=Any)) == ([9,8], 9, [9,8])
    @eqtest @rule(+(~~x,~y,~~x) => (unwrap_const.(~~x), unwrap_const(~y), unwrap_const.(~~x)))(term(+,6,type=Any)) == ([], 6, [])
end

@testset "Commutative + and *" begin
    r1 = @rule exp(sin(~x) + cos(~x)) => ~x
    # using a or x changes the order of the arguments in the call
    @test r1(exp(sin(a)+cos(a))) === a
    @test r1(exp(sin(x)+cos(x))) === x
    r2 = @rule (~x+~y)*(~z+~w)^(~m) => (~x, ~y, ~z, ~w, ~m)
    r3 = @rule (~z+~w)^(~m)*(~x+~y) => (~x, ~y, ~z, ~w, ~m)
    res1 = r2((a+b)*(x+c)^b)
    @test issetequal(res1[1:2], [a, b])
    @test issetequal(res1[3:4], [x, c])
    @test isequal(res1[5], b)
    res2 = r3((a+b)*(x+c)^b)
    @test issetequal(res2[1:2], [a, b])
    @test issetequal(res2[3:4], [x, c])
    @test isequal(res2[5], b)
    rPredicate1 = @rule ~x::(x->isa(x,Number)) + ~y => (~x, ~y)
    rPredicate2 = @rule ~y + ~x::(x->isa(x,Number)) => (~x, ~y)
    @test rPredicate1(2+x) === (2, x)
    @test rPredicate2(2+x) === (2, x)
    r5 = @rule (~y*(~z+~w))+~x => (~x, ~y, ~z, ~w)
    r6 = @rule ~x+((~z+~w)*~y) => (~x, ~y, ~z, ~w)
    res3 = r5(c*(a+b)+d)
    @test res3 === (d, c, a, b) || res3 === (d, c, b, a)
    res4 = r6(c*(a+b)+d)
    @test res4 === (d, c, a, b) || res4 === (d, c, b, a)
end

@testset "Slot matcher with default value" begin
    r_sum = @rule (~x + ~!y)^2 => ~y
    @test r_sum((a + b)^2) in Set([a, b])
    @test r_sum(b^2) === 0

    r_mult = @rule ~x * ~!y  => ~y
    @test r_mult(a * b) in Set([a, b])
    @test r_mult(a) === 1

    r_mult2 = @rule (~x * ~!y + ~z) => ~y
    # can match either `a` or `b` or coefficient of `c`
    @test r_mult2(c + a*b) in Set([1, a, b])
    @test r_mult2(c + b) === 1

    # here the "normal part" in the defslot_term_matcher is not a symbol but a tree
    r_mult3 = @rule (~!x)*(~y + ~z) => ~x
    @test r_mult3(a*(c+2)) === a
    @test r_mult3(2*(c+2)) === 2
    @test r_mult3(c+2) === 1

    r_pow = @rule (~x)^(~!m) => ~m
    @test isequal(r_pow(a^(b+1)), b+1)
    @test r_pow(a) === 1
    @test r_pow(a+1) === 1

    # here the "normal part" in the defslot_term_matcher is not a symbol but a tree
    r_pow2 = @rule (~x + ~y)^(~!m) => ~m
    @test r_pow2((a+b)^c) === c
    @test r_pow2(a+b) === 1

    r_mix = @rule (~x + (~y)*(~!c))^(~!m) => (~m, ~c)
    res =  r_mix((a + b*c)^2)
    @test res === (2, c) || res === (2, b) || res === (2, 1)
    res = r_mix((a + b*c))
    @test res === (1, c) || res === (1, b) || res === (1, 1)
    @test r_mix((a + b)) === (1, 1)

    r_more_than_two_arguments = @rule (~!a)*exp(~x)*sin(~x) => (~a, ~x)
    @test r_more_than_two_arguments(sin(x)*exp(x)) === (1, x)
    @test r_more_than_two_arguments(sin(x)*exp(x)*a) === (a, x)

    r_mixmix = @rule (~!a)*exp(~x)*sin(~!b + (~x)^2 + ~x) => (~a, ~b, ~x)
    @test r_mixmix(exp(x)*sin(1+x+x^2)*2) === (2, 1, x)
    @test r_mixmix(exp(x)*sin(x+x^2)*2) === (2, 0, x)
    @test r_mixmix(exp(x)*sin(x+x^2)) === (1, 0, x)

    # predicate checked in normal matching process
    r_predicate1 = @rule x + (~!m::(var->isa(var, Int))) => ~m
    @test r_predicate1(x+2) === 2
    @test r_predicate1(x+2.1) === nothing

    # predicate checked in defslot matching process
    r_predicate2 = @rule x + ~!m::(var->!(var===0)) => ~m
    @test r_predicate2(x+1)===1 # matches normally
    @test r_predicate2(x)===nothing # doesnt matches bc the default value is 0 and doesnt respect the predicate

    # multiple defslots with the same name
    r3 = @rule sin(~!f*~x)+cos(~!f*~x) => ~
    @test r3(sin(2x)+cos(2x))[:f]===2
    @test r3(sin(2x)+cos(x))===nothing
end

@testset "power matcher with negative exponent" begin
    r1 = @rule (~x)^(~y) => (~x, ~y) # rule with slot as exponent
    @test r1(1/a^b) === (a, -b) # uses frankestein
    @test r1(1/a^(b+2c)) === (a, -b-2c) # uses frankestein
    @test r1(1/a^2) === (a, -2) # uses opposite_sign_matcher
    @test r1(1/a) === (a, -1)

    r2 = @rule (~x)^(~y + ~z) => (~x, ~y, ~z) # rule with term as exponent
    res = r2(1/a^(b+2c))
    @test res === (a, -b, -2c) || res === (a, -2c, -b) # uses frankestein
    @test r2(1/a^3) === nothing # should use a term_matcher that flips the sign, but is not implemented

    r1defslot = @rule (~x)^(~!y) => (~x, ~y) # rule with defslot as exponent
    @test r1defslot(1/a^b) === (a, -b) # uses frankestein
    @test r1defslot(1/a^(b+2c)) === (a, -b-2c) # uses frankestein
    @test r1defslot(1/a^2) === (a, -2) # uses opposite_sign_matcher
    @test r1defslot(a) === (a, 1)

    r = @rule (~x + ~y)^(~m) => (~x, ~y, ~m) # rule to match (1/...)^(...)
    res = r((1/(a+b))^3)
    @test res === (a,b,-3) || res === (b, a, -3)
end

@testset "Return the matches dictionary" begin
    r = @rule (~x + (~y)^2) => ~
    res = r(a + b^2)
    @test isa(res, Base.ImmutableDict)
    @test res[:x] === a
    @test res[:y] === b

    r2 = @rule (~x + (~y)^(~m)) => (~) where ~m===2
    @test isa(r2(a + b^2), Base.ImmutableDict)
    @test r2(a + b^3)===nothing

    r3 = @rule (~x + (~y)^(~m)) => ~m===2 ? (~) : ~x
    @test isa(r3(a + b^2), Base.ImmutableDict)
    @test r3(a + b^3)===a
end

@testset "special power matches" begin
    r1 = @rule (~x)^(~y) => (~x, ~y)
    @test r1(exp(a)) === (ℯ, a) # uses exp_matcher
    @test r1(sqrt(a)) === (a, 1//2) # uses sqrt_matcher
end

@testset "Alternate form of special functions" begin
    rsqrt = @rule sqrt(~x) => ~x
    @test rsqrt(sqrt(x))===x
    @test rsqrt((x)^(1//2))===x

    rexp = @rule exp(~x) => ~x
    @test rexp(exp(x)) === x
    @test rexp(ℯ^x) === x
end

using SymbolicUtils: @capture

@testset "Capture form" begin

    ex = a^a

    #note that @test inserts a soft local scope (try-catch) that would gobble
    #the matches from assignment statements in @capture macro, so we call it
    #outside the test macro
    ret = @capture ex (~x)^(~x)
    @test ret
    @test @isdefined x
    @test x === a

    ex = b^a
    ret = @capture ex (~y)^(~y)
    @test !ret
    @test !(@isdefined y)

    ret = @capture (a + b) (+)(~~z)
    @test ret
    @test @isdefined z
    @test all(z .=== arguments(a + b))

    #a more typical way to use the @capture macro

    f(x) = if @capture x (~w)^(~w)
        w
    end

    @eqtest f(b^b) == b
    @test f(b+b) == nothing
end

@testset "Rewriter tweaks #548" begin
    struct MetaData end
    ex = a
    ex = setmetadata(ex, MetaData, :metadata)
    ex1 = ex + b

    @test getmetadata(sorted_arguments(ex1)[1], MetaData) == :metadata

    ex = a
    ex = setmetadata(ex, MetaData, :metadata)
    ex1 = ex * b

    @test getmetadata(sorted_arguments(ex1)[1], MetaData) == :metadata
end

using SymbolicUtils, NaNMath
using SymbolicUtils.Code
using Test
using StaticArrays
using LabelledArrays
using SparseArrays
using ReverseDiff
using LinearAlgebra

using SymbolicUtils: Const
import SymbolicUtils: replace_node!
using Moshi.Match: @match
import SymbolicUtils.BasicSymbolicImpl as BSImpl

test_repr(a, b) = @test repr(Base.remove_linenums!(a)) == repr(Base.remove_linenums!(b))

@testset "Code" begin
    @syms a b c d e p q t x(t) y(t) z(t)
    ir = IRStructure{SymReal}()
    test_repr(
        Code.fast_toexpr(Let([], Assignment(a, b)), ir, Dict()),
        :(
            let
                a = begin
                    local var"##cse#0" = b
                end
            end
        )
    )
    test_repr(
        Code.fast_toexpr(a + b, ir, Dict()),
        quote
            local var"##cse#0" = a
            local var"##cse#1" = b
            local var"##cse#2" = $(+)(var"##cse#0", var"##cse#1")
        end
    )
    test_repr(
        Code.fast_toexpr(a * b * c * d * e, ir, Dict()),
        quote
            local var"##cse#0" = a
            local var"##cse#1" = b
            local var"##cse#2" = c
            local var"##cse#3" = d
            local var"##cse#4" = e
            local var"##cse#5" = $(*)(var"##cse#0", var"##cse#1", var"##cse#2", var"##cse#3", var"##cse#4")
        end
    )
    newsym = eval(
        quote
            let x = $x, y = $y, t = $t
                $(Code.fast_toexpr(x(t) + y(t), ir, Dict()))
            end
        end
    )
    @test operation(newsym) === (+) && issetequal(arguments(newsym), [x(t), y(t)])
    newsym = eval(
        quote
            let x = $x, y = $y, t = $t
                $(Code.fast_toexpr(x(t) + y(t) + x(t + 1), ir, Dict()))
            end
        end
    )
    @test operation(newsym) === (+) && issetequal(arguments(newsym), [x(t), y(t), x(1 + t)])

    test_repr(
        Code.fast_toexpr(Let([a ← 3, b ← 1 + a], a + b), ir, Dict()),
        :(let a = begin
                    __miscₛᵧₘ0 = 3
                end, b = begin
                    local var"##cse#0" = 1
                    local var"##cse#1" = a
                    local var"##cse#2" = $(+)(var"##cse#0", var"##cse#1")
                end
                local var"##cse#0" = a
                local var"##cse#1" = b
                local var"##cse#2" = $(+)(var"##cse#0", var"##cse#1")
            end
        )
    )
    newsym = eval(Code.fast_toexpr(Let([a ← 3, b ← 1 + a], a + b), ir, Dict()))
    @test isequal(newsym, 7)

    test_repr(
        Code.fast_toexpr(Func([], [], a + b), ir, Dict()),
        :(
            function ()
                begin
                    local var"##cse#0" = a
                    local var"##cse#1" = b
                    local var"##cse#2" = $(+)(var"##cse#0", var"##cse#1")
                end
            end
        )
    )

    newf = eval(
        Code.fast_toexpr(
            Func([x(t), x, a, t], [b ← a + 2, y(t) ← b], x(t) + x(t + 1) + b + y(t)), ir, Dict()
        )
    )
    newsym = newf(x(t), x, a, t; var"y(t)" = y(t))
    @test operation(newsym) === (+) && issetequal(arguments(newsym), [x(t), x(1 + t), a, y(t), Const{SymReal}(2)])

    fexpr1 = Code.fast_toexpr(
        Func(
            [
                DestructuredArgs([x, x(t), t], :state),
                DestructuredArgs((a, b), :params),
            ], [],
            x(t + 1) + x(t) + a + b
        ), ir, Dict()
    )
    newf = eval(fexpr1)
    newsym = newf([x, x(t), t], [a, b])
    @test operation(newsym) === (+) && issetequal(arguments(newsym), [x(t + 1), x(t), a, b])

    fexpr2 = Code.fast_toexpr(
        Func(
            [
                DestructuredArgs([x, x(t), t], :state, create_bindings = false),
                DestructuredArgs((a, b), :params, create_bindings = false),
            ], [],
            x(t + 1) + x(t) + a + b
        ), ir, Dict()
    )
    newf = eval(fexpr2)
    newsym = newf([x, x(t), t], [a, b])
    @test operation(newsym) === (+) && issetequal(arguments(newsym), [x(t + 1), x(t), a, b])
    @test fexpr1 != fexpr2

    fexpr = Code.fast_toexpr(Func([], [], :(rand()), [Expr(:meta, :inline)]), ir, Dict())
    @test any(isequal(Expr(:meta, :inline)), fexpr.args[2].args)

    ex = Code.fast_toexpr(Func([DestructuredArgs([x, x(t)], :state, inbounds = true)], [], x(t + 1) + x(t)), ir, Dict())
    ex = Base.remove_linenums!(ex)
    for e in ex.args[2].args[1].args[[1, 2]]
        @test occursin("@inbounds", repr(e.args[2]))
    end

    test_repr(
        Code.fast_toexpr(Let([], SetArray(false, a, [x(t), AtIndex(9, b), AtIndex(10, d), c])), ir, Dict()),
        :(
            let
                local var"##cse#0" = a
                local var"##cse#1" = x
                local var"##cse#2" = t
                local var"##cse#3" = var"##cse#1"(var"##cse#2")
                __miscₛᵧₘ0 = 9
                local var"##cse#4" = b
                __miscₛᵧₘ1 = 10
                local var"##cse#5" = d
                local var"##cse#6" = c
                __miscₛᵧₘ3 = begin
                    var"##cse#0"[1] = var"##cse#3"
                    var"##cse#0"[__miscₛᵧₘ0] = var"##cse#4"
                    var"##cse#0"[__miscₛᵧₘ1] = var"##cse#5"
                    var"##cse#0"[4] = var"##cse#6"
                    __miscₛᵧₘ2 = nothing
                end
            end
        )
    )
    @test Code.fast_toexpr(SetArray(true, a, [x(t), AtIndex(9, b), c]), ir, Dict()).head == :macrocall

    for fname in (:sin, :cos, :tan, :asin, :acos, :acosh, :atanh, :log, :log2, :log10, :log1p, :sqrt)
        f = getproperty(Base, fname)
        test_repr(
            Code.fast_toexpr(f(a), ir, Dict()), quote
                local var"##cse#0" = a
                local var"##cse#1" = $(f)(var"##cse#0")
            end
        )
        test_repr(
            Code.fast_toexpr(f(a), ir, Dict{Any, Any}(:nanmath => true)), quote
                local var"##cse#0" = a
                local var"##cse#1" = $(GlobalRef(NaNMath, fname))(var"##cse#0")
            end
        )

        nanmath_f = getproperty(NaNMath, fname)
        test_repr(
            Code.fast_toexpr(nanmath_f(a), ir, Dict()), quote
                local var"##cse#0" = a
                local var"##cse#1" = $nanmath_f(var"##cse#0")
            end
        )
        test_repr(
            Code.fast_toexpr(nanmath_f(a), ir, Dict{Any, Any}(:nanmath => true)), quote
                local var"##cse#0" = a
                local var"##cse#1" = $nanmath_f(var"##cse#0")
            end
        )
    end

    test_repr(
        Code.fast_toexpr(a^b, ir, Dict()), quote
            local var"##cse#0" = a
            local var"##cse#1" = b
            local var"##cse#2" = $(^)(var"##cse#0", var"##cse#1")
        end
    )
    test_repr(
        Code.fast_toexpr(a^b, ir, Dict{Any, Any}(:nanmath => true)), quote
            local var"##cse#0" = a
            local var"##cse#1" = b
            local var"##cse#2" = $(NaNMath.pow)(var"##cse#0", var"##cse#1")
        end
    )
    test_repr(
        Code.fast_toexpr(NaNMath.pow(a, b), ir, Dict()), quote
            local var"##cse#0" = a
            local var"##cse#1" = b
            local var"##cse#2" = $(NaNMath.pow)(var"##cse#0", var"##cse#1")
        end
    )
    test_repr(
        Code.fast_toexpr(NaNMath.pow(a, b), ir, Dict{Any, Any}(:nanmath => true)), quote
            local var"##cse#0" = a
            local var"##cse#1" = b
            local var"##cse#2" = $(NaNMath.pow)(var"##cse#0", var"##cse#1")
        end
    )

    test_repr(
        Code.fast_toexpr(a^2, ir, Dict()), quote
            local var"##cse#0" = a
            local var"##cse#1" = $(^)(var"##cse#0", 2)
        end
    )
    test_repr(
        Code.fast_toexpr(a^2, ir, Dict{Any, Any}(:nanmath => true)), quote
            local var"##cse#0" = a
            local var"##cse#1" = $(^)(var"##cse#0", 2)
        end
    )
    test_repr(
        Code.fast_toexpr(NaNMath.pow(a, 2), ir, Dict()), quote
            local var"##cse#0" = a
            local var"##cse#1" = $(^)(var"##cse#0", 2)
        end
    )
    test_repr(
        Code.fast_toexpr(NaNMath.pow(a, 2), ir, Dict{Any, Any}(:nanmath => true)), quote
            local var"##cse#0" = a
            local var"##cse#1" = $(^)(var"##cse#0", 2)
        end
    )

    test_repr(
        Code.fast_toexpr(a^-1, ir, Dict()),
        quote
            local var"##cse#0" = 1
            local var"##cse#1" = a
            local var"##cse#2" = $(/)(var"##cse#0", var"##cse#1")
        end
    )
    test_repr(
        Code.fast_toexpr(a^-1, ir, Dict{Any, Any}(:nanmath => true)), quote
            local var"##cse#0" = 1
            local var"##cse#1" = a
            local var"##cse#2" = $(/)(var"##cse#0", var"##cse#1")
        end
    )
    test_repr(
        Code.fast_toexpr(NaNMath.pow(a, -1), ir, Dict()), quote
            local var"##cse#0" = 1
            local var"##cse#1" = a
            local var"##cse#2" = $(/)(var"##cse#0", var"##cse#1")
        end
    )
    test_repr(
        Code.fast_toexpr(NaNMath.pow(a, -1), ir, Dict{Any, Any}(:nanmath => true)),
        quote
            local var"##cse#0" = 1
            local var"##cse#1" = a
            local var"##cse#2" = $(/)(var"##cse#0", var"##cse#1")
        end
    )

    test_repr(
        Code.fast_toexpr(a^-2, ir, Dict()),
        quote
            local var"##cse#0" = 1
            local var"##cse#1" = a
            local var"##cse#2" = $(^)(var"##cse#1", 2)
            local var"##cse#3" = $(/)(var"##cse#0", var"##cse#2")
        end
    )
    test_repr(
        Code.fast_toexpr(a^-2, ir, Dict{Any, Any}(:nanmath => true)),
        quote
            local var"##cse#0" = 1
            local var"##cse#1" = a
            local var"##cse#2" = $(^)(var"##cse#1", 2)
            local var"##cse#3" = $(/)(var"##cse#0", var"##cse#2")
        end
    )
    test_repr(
        Code.fast_toexpr(NaNMath.pow(a, -2), ir, Dict()),
        quote
            local var"##cse#0" = 1
            local var"##cse#1" = a
            local var"##cse#2" = $(^)(var"##cse#1", 2)
            local var"##cse#3" = $(/)(var"##cse#0", var"##cse#2")
        end
    )
    test_repr(
        Code.fast_toexpr(NaNMath.pow(a, -2), ir, Dict{Any, Any}(:nanmath => true)),
        quote
            local var"##cse#0" = 1
            local var"##cse#1" = a
            local var"##cse#2" = $(^)(var"##cse#1", 2)
            local var"##cse#3" = $(/)(var"##cse#0", var"##cse#2")
        end
    )

    @test eval(
        quote
            let a = 1, b = 2, arr = [1, 2]
                $(Code.fast_toexpr(Let([], MakeArray([a, b, a + b], :arr)), ir, Dict()))
            end
        end
    ) == [1, 2, 3]

    @test eval(
        Code.fast_toexpr(
            Let([a ← 1, b ← 2, :arr ← [1, 2]], MakeArray([a, b, a + b, a / b], :arr)), ir, Dict()
        )
    ) == [1, 2, 3, 1 / 2]

    test_repr(
        Code.fast_toexpr(
            Let(
                [DestructuredArgs([x(t), b, c], :foo) ← [3, 3, [1, 4]], DestructuredArgs([p, q], c)],
                x(t) + a + b + c
            ), ir, Dict{Any, Any}(:readable_variables => true)
        ),
        :(
            let foo = begin
                    __miscₛᵧₘ0 = Vector{Any}
                    __miscₛᵧₘ1 = 3
                    __miscₛᵧₘ2 = 3
                    __miscₛᵧₘ3 = Vector{Int64}
                    __miscₛᵧₘ4 = 1
                    __miscₛᵧₘ5 = 4
                    __miscₛᵧₘ6 = $(SymbolicUtils.Code.create_array)(__miscₛᵧₘ3, nothing, $(Val){1}(), $(Val){(2,)}(), __miscₛᵧₘ4, __miscₛᵧₘ5)
                    __miscₛᵧₘ7 = $(SymbolicUtils.Code.create_array)(__miscₛᵧₘ0, nothing, $(Val){1}(), $(Val){(3,)}(), __miscₛᵧₘ1, __miscₛᵧₘ2, __miscₛᵧₘ6)
                end, var"x(t)" = begin
                    __miscₛᵧₘ0 = foo[1]
                end, b = begin
                    __miscₛᵧₘ0 = foo[2]
                end, c = begin
                    __miscₛᵧₘ0 = foo[3]
                end, p = begin
                    __miscₛᵧₘ0 = c[1]
                end, q = begin
                    __miscₛᵧₘ0 = c[2]
                end
                local var"##cse#0" = a
                local var"##cse#1" = b
                local var"##cse#2" = c
                local var"##cse#3" = var"x(t)"
                local var"##cse#4" = $(+)(var"##cse#0", var"##cse#1", var"##cse#2", var"##cse#3")
            end
        )
    )

    test_repr(
        Code.fast_toexpr(Func([DestructuredArgs([a, b], c, inds = [:a, :b])], [], a + b), ir, Dict()),
        Expr(
            :function,
            Expr(:tuple, c),
            quote
                begin
                    a = begin
                        __miscₛᵧₘ0 = c.a
                    end
                    b = begin
                        __miscₛᵧₘ0 = c.b
                    end
                    local var"##cse#0" = a
                    local var"##cse#1" = b
                    local var"##cse#2" = $(+)(var"##cse#0", var"##cse#1")
                end
            end
        )
    )

    @syms arr

    @test eval(
        Code.fast_toexpr(
            Let([a ← 1, b ← 2, arr ← [1, 2]], MakeArray([a, b, a + b, a / b], arr)), ir, Dict()
        )
    ) == [1, 2, 3, 1 / 2]

    @test eval(
        Code.fast_toexpr(
            Let([a ← 1, b ← 2, arr ← [1, 2]], MakeArray(view([a, b, a + b, a / b], :), arr)), ir, Dict()
        )
    ) == [1, 2, 3, 1 / 2]

    @test eval(
        Code.fast_toexpr(
            Let(
                [a ← 1, b ← 2, arr ← [1, 2]],
                MakeArray(PermutedDimsArray([a b; a + b a / b], (1, 2)), arr)
            ), ir, Dict()
        )
    ) == [1 2; 3 1 / 2]

    @test eval(
        Code.fast_toexpr(
            Let([a ← 1, b ← 2, arr ← [1, 2]], MakeArray(transpose([a b; a + b a / b]), arr)), ir, Dict()
        )
    ) == [1 3; 2 1 / 2]

    @test eval(
        Code.fast_toexpr(
            Let([a ← 1, b ← 2, arr ← [1, 2]], MakeArray(UpperTriangular([a b; a + b a / b]), arr)), ir, Dict()
        )
    ) == [1 2; 0 1 / 2]

    @test eval(
        Code.fast_toexpr(
            Let([a ← 1, b ← 2, arr ← [1, 2]], MakeArray([a b; a + b a / b], arr)), ir, Dict()
        )
    ) == [1 2; 3 1 / 2]

    @test eval(
        Code.fast_toexpr(
            Let([a ← 1, b ← 2, arr ← @SVector([1, 2])], MakeArray([a, b, a + b, a / b], arr)), ir, Dict()
        )
    ) === @SVector [1, 2, 3, 1 / 2]

    @test eval(
        Code.fast_toexpr(
            Let([a ← 1, b ← 2, arr ← @SVector([1, 2])], MakeArray([a b; a + b a / b], arr)), ir, Dict()
        )
    ) === @SMatrix [1 2; 3 1 / 2]

    @test eval(
        Code.fast_toexpr(
            Let(
                [a ← 1, b ← 2, arr ← @SLVector((:a, :b))(@SVector[1, 2])],
                MakeArray([a + b, a / b], arr)
            ), ir, Dict()
        )
    ) === @SLVector((:a, :b))(@SVector [3, 1 / 2])

    trackedarr = eval(
        Code.fast_toexpr(
            Let(
                [a ← ReverseDiff.track(1.0), b ← 2, arr ← ReverseDiff.track(ones(2))],
                MakeArray([a + b, a / b], arr)
            ), ir, Dict()
        )
    )
    @test trackedarr isa ReverseDiff.TrackedArray
    @test trackedarr == [3, 1 / 2]

    trackedarr = eval(
        Code.fast_toexpr(
            Let(
                [a ← ReverseDiff.track(1.0), b ← 2, arr ← ReverseDiff.track(ones(2))],
                MakeArray([a b; a + b a / b], arr)
            ), ir, Dict()
        )
    )
    @test trackedarr isa ReverseDiff.TrackedArray
    @test trackedarr == [1 2; 3 1 / 2]

    R1 = eval(
        Code.fast_toexpr(
            Let([a ← 1, b ← 2, arr ← @MVector([1, 2])], MakeArray([a, b, a + b, a / b], arr)), ir, Dict()
        )
    )
    @test R1 == (@MVector [1, 2, 3, 1 / 2]) && R1 isa MVector

    R2 = eval(
        Code.fast_toexpr(
            Let([a ← 1, b ← 2, arr ← @MVector([1, 2])], MakeArray([a b; a + b a / b], arr)), ir, Dict()
        )
    )
    @test R2 == (@MArray [1 2; 3 1 / 2]) && R2 isa MMatrix

    mksp = MakeSparseArray(
        sparse(
            [1, 2, 31, 32, 2],
            [1, 2, 31, 32, 2],
            [a, b, a + b, a / b, a - b + e]
        )
    )
    reference = sparse(
        [1, 2, 31, 32],
        [1, 2, 31, 32],
        [a, a + e, a + b, a / b]
    )

    test_repr(mksp.array, reference)

    test_repr(
        Code.fast_toexpr(Let([], mksp), ir, Dict()),
        :(
            let
                local var"##cse#0" = (4,)
                local var"##cse#1" = a
                local var"##cse#2" = e
                local var"##cse#3" = $(+)(var"##cse#1", var"##cse#2")
                local var"##cse#4" = b
                local var"##cse#5" = $(+)(var"##cse#1", var"##cse#4")
                local var"##cse#6" = $(/)(var"##cse#1", var"##cse#4")
                local var"##cse#7" = $(SymbolicUtils.array_literal)(var"##cse#0", var"##cse#1", var"##cse#3", var"##cse#5", var"##cse#6")
                __miscₛᵧₘ0 = $(sparse)([1, 2, 31, 32], [1, 2, 31, 32], var"##cse#7", 32, 32)
            end
        )
    )

    spvec = sparsevec([5], [a], 10)

    test_repr(
        Code.fast_toexpr(Let([], MakeSparseArray(spvec)), ir, Dict()),
        :(
            let
                local var"##cse#0" = (1,)
                local var"##cse#1" = a
                local var"##cse#2" = $(SymbolicUtils.array_literal)(var"##cse#0", var"##cse#1")
                __miscₛᵧₘ0 = $(SparseVector)(10, [5], var"##cse#2")
            end
        )
    )

    test_repr(
        Code.fast_toexpr(Let([], MakeTuple((a, b, a + b))), ir, Dict()),
        :(
            let
                local var"##cse#0" = a
                local var"##cse#1" = b
                local var"##cse#2" = $(+)(var"##cse#0", var"##cse#1")
                __miscₛᵧₘ0 = (var"##cse#0", var"##cse#1", var"##cse#2")
            end
        )
    )

    let
        @syms a b
        f = eval(Code.fast_toexpr(Func([a + b], [], a + b), ir, Dict()))
        @test @invokelatest(f(1)) == 1
        @test @invokelatest(f(2)) == 2

        f = eval(Code.fast_toexpr(Func([a, b], [], sqrt(a - b)), ir, Dict{Any, Any}(:nanmath => true)))
        @test isnan(@invokelatest f(0, 10))
        @test @invokelatest(f(10, 2)) ≈ sqrt(8)
    end

    let
        io = IOBuffer()
        twoπ = Base.Irrational{:twoπ}()
        for q in Base.Irrational[Base.MathConstants.catalan, Base.MathConstants.γ, π, Base.MathConstants.φ, ℯ, twoπ]
            Base.show(io, q)
            s1 = String(take!(io))
            SymbolicUtils.show_term(io, SymbolicUtils.Term{SymReal}(identity, [q]))
            s2 = String(take!(io))
            @test s1 == s2
        end
    end

    let
        @syms a b
        t = term(sum, [a, b, a + b, 3a + 2b, sqrt(b)]; type = Number)
        f = eval(Code.fast_toexpr(Func([a, b], [], t), ir, Dict()))
        @test @invokelatest(f(1.0, 2.0)) ≈ 13.0 + sqrt(2)
    end
end

@testset "Sparse array CSE" begin
    @syms x y z
    ir = IRStructure{SymReal}()
    arr = BS[x^2 + y^2 0 0; 0 sin(y^2 + z^2) 0; 0 0 z^2 + x^2]
    sarr = sparse(arr)
    fn = eval(Code.fast_toexpr(Func([x, y, z], [], sarr), ir, Dict()))

    expected = eval(toexpr(Let([x ← 1, y ← 2, z ← 3], sarr)))
    @test fn(1, 2, 3) ≈ expected
end

@testset "CSE does not alias constants with function arguments" begin
    # When build_function is given argument arrays containing constants (e.g., zeros
    # from erased cache variables), CSE should not replace identical constants in the
    # expression body with references to those argument positions. This is a regression
    # test for https://github.com/JuliaSymbolics/Symbolics.jl/issues/1811.
    @syms x1 x2 x3 x4 x5 x6
    x_vars = [x1, x2, x3, x4, x5, x6]
    ir = IRStructure{SymReal}()
    # A sparse diagonal jacobian-like expression
    ZERO = SymbolicUtils.Const{SymReal}(0)
    expr = fill(ZERO, 12, 6)
    for i in 1:6
        expr[i, i] = cos(x_vars[i])
        expr[i + 6, i] = -sin(x_vars[i])
    end
    # Second argument is all-zeros (simulating erased cache variables passed to build_function)
    zero_args = [SymbolicUtils.Const{SymReal}(0) for _ in 1:12]
    f_cse = eval(
        Code.fast_toexpr(
            Func(
                [
                    DestructuredArgs(x_vars, :arg1, inbounds = true, create_bindings = false),
                    DestructuredArgs(zero_args, :arg2, inbounds = true, create_bindings = false),
                ],
                [], MakeArray(expr, Array)
            ), ir, Dict()
        )
    )
    # Call with non-zero values for arg2 to expose incorrect aliasing
    result = @invokelatest f_cse(collect(1.0:6.0), ones(12) * 99.0)
    @test result[1, 2] == 0.0  # off-diagonal should be 0, NOT 99.0
    @test result[2, 1] == 0.0
    @test result[1, 1] ≈ cos(1.0)
    @test result[2, 2] ≈ cos(2.0)
end

@testset "`AtIndex` with symbolic index" begin
    @syms a b c::Matrix{Int}
    ir = IRStructure{SymReal}()
    ex = Let([], SetArray(false, c, [AtIndex(MakeArray([a, b], Array), [a + b, a - b])]))
    expr = quote
        let a = 1, b = 2, c = zeros(Int, 3, 3)
            $(Code.fast_toexpr(ex, ir, Dict()))
            c
        end
    end
    arr = eval(expr)
    @test arr[1] == 3
    @test arr[2] == -1
    for i in 3:length(arr)
        @test arr[i] == 0
    end
end

@testset "`ForLoop`" begin
    @syms a b c::Vector{Int}
    ir = IRStructure{SymReal}()
    ex = ForLoop(a, term(range, b^2, b^2 + 3), SetArray(false, c, [AtIndex(a, a + 1)]))
    expr = quote
        let b = 2, c = zeros(Int, 10)
            $(Code.fast_toexpr(ex, ir, Dict()))
            c
        end
    end
    arr = eval(expr)
    @test arr[4] == 5
    @test arr[5] == 6
    @test arr[6] == 7
    @test arr[7] == 8
    @test all(iszero, arr[1:3])
    @test all(iszero, arr[8:end])
end

@testset "`SetArray` with `return_arr`" begin
    @syms a b c::Vector{Int}
    ir = IRStructure{SymReal}()
    ex = Let([], SetArray(false, c, [3, 2, 1], false))
    expr = quote
        let b = 2, c = zeros(Int, 3)
            $(Code.fast_toexpr(ex, ir, Dict()))
        end
    end
    @test eval(expr) === nothing
    ex = Let([], SetArray(false, c, [3, 2, 1], true))
    expr = quote
        let b = 2, c = zeros(Int, 3)
            $(Code.fast_toexpr(ex, ir, Dict()))
        end
    end
    @test eval(expr) == [3, 2, 1]
end

@testset "`with_allocator`" begin
    @testset "`array_literal`" begin
        @syms x y z
        ir = IRStructure{SymReal}()
        arr = SymbolicUtils.Const{SymReal}([x, y + 2x^2 + sin(z), 2z + 1])
        wrapped = Code.with_allocator(ones, arr)
        test_repr(
            Code.fast_toexpr(wrapped, ir, Dict()),
            quote
                local var"##cse#0" = ones
                local var"##cse#1" = var"##cse#0"((3,))
                local var"##cse#2" = x
                local var"##cse#3" = z
                local var"##cse#4" = $(sin)(var"##cse#3")
                local var"##cse#5" = y
                local var"##cse#6" = 2
                local var"##cse#7" = $(^)(var"##cse#2", 2)
                local var"##cse#8" = $(*)(var"##cse#6", var"##cse#7")
                local var"##cse#9" = $(+)(var"##cse#4", var"##cse#5", var"##cse#8")
                local var"##cse#10" = 1
                local var"##cse#11" = $(*)(var"##cse#6", var"##cse#3")
                local var"##cse#12" = $(+)(var"##cse#10", var"##cse#11")
                __miscₛᵧₘ0 = $(Code.fill_arr!)(var"##cse#1", $Val($((3,))), var"##cse#2", var"##cse#9", var"##cse#12")
            end
        )

        reference = eval(
            quote
                let x = 1, y = 2, z = 3
                    $(Code.fast_toexpr(arr, ir, Dict()))
                end
            end
        )
        value = eval(
            quote
                let x = 1, y = 2, z = 3
                    $(Code.fast_toexpr(wrapped, ir, Dict()))
                end
            end
        )
        @test isequal(reference, value)
    end

    @testset "`@arrayop`" begin
        @syms x[1:3] y[1:3]
        ir = IRStructure{SymReal}()
        arr = @arrayop (i,) x[i] * y[i]
        wrapped = Code.with_allocator(ones, arr)
        @test isequal(collect(arr), collect(wrapped))
        test_repr(
            Code.fast_toexpr(wrapped, ir, Dict()),
            quote
                local var"##cse#0" = ones
                local var"##cse#1" = var"##cse#0"((3,))
                _ = begin
                    for _1 in 1:1:3
                        begin
                            local var"##cse#2" = x
                            local var"##cse#3" = var"##cse#2"[_1]
                            local var"##cse#4" = y
                            local var"##cse#5" = var"##cse#4"[_1]
                            local var"##cse#6" = $(*)(var"##cse#3", var"##cse#5")
                            __accum = $(+)(var"##cse#1"[$(CartesianIndex)(_1)], var"##cse#6")
                            _ = (var"##cse#1"[$(CartesianIndex)(_1)] = __accum)
                        end
                    end
                end
            end
        )
    end

    @testset "`Fill`" begin
        @syms x::Real
        ir = IRStructure{SymReal}()
        f1d = SymbolicUtils.Fill(SymbolicUtils.ShapeVecT((1:3,)))
        expr1d = f1d(x)

        xv = 2.0
        result1d = eval(quote
            let x = $xv
                $(Code.fast_toexpr(expr1d, ir, Dict()))
            end
        end)
        @test result1d == fill(xv, 3)

        wrapped1d = Code.with_allocator(ones, expr1d)
        result1d_wa = eval(quote
            let x = $xv
                $(Code.fast_toexpr(wrapped1d, ir, Dict()))
            end
        end)
        @test result1d_wa == fill(xv, 3)

        f2d = SymbolicUtils.Fill(SymbolicUtils.ShapeVecT((1:2, 1:4)))
        expr2d = f2d(x)
        result2d = eval(quote
            let x = $xv
                $(Code.fast_toexpr(expr2d, ir, Dict()))
            end
        end)
        @test result2d == fill(xv, 2, 4)

        wrapped2d = Code.with_allocator(ones, expr2d)
        result2d_wa = eval(quote
            let x = $xv
                $(Code.fast_toexpr(wrapped2d, ir, Dict()))
            end
        end)
        @test result2d_wa == fill(xv, 2, 4)
    end

    @testset "`Returns(buf)` allocator" begin
        @syms x y z buf[1:3]
        ir = IRStructure{SymReal}()
        arr = SymbolicUtils.Const{SymReal}([x, y, z])
        returns_alloc = SymbolicUtils.Term{SymReal}(Returns{SymReal}, (buf,))

        test_repr(
            Code.fast_toexpr(arr, ir, Dict{Any,Any}(Code.ALLOCATOR_REWRITES_KEY => returns_alloc)),
            quote
                local var"##cse#0" = buf
                local var"##cse#1" = var"##cse#0"
                local var"##cse#2" = x
                local var"##cse#3" = y
                local var"##cse#4" = z
                __miscₛᵧₘ0 = $(Code.fill_arr!)(var"##cse#1", $Val($((3,))), var"##cse#2", var"##cse#3", var"##cse#4")
            end
        )

        reference = eval(quote
            let x = 1.0, y = 2.0, z = 3.0
                $(Code.fast_toexpr(arr, ir, Dict{Any,Any}()))
            end
        end)
        result = eval(quote
            let x = 1.0, y = 2.0, z = 3.0, buf = zeros(3)
                $(Code.fast_toexpr(arr, ir, Dict{Any,Any}(Code.ALLOCATOR_REWRITES_KEY => SymbolicUtils.Term{SymReal}(Returns{SymReal}, (buf,)))))
            end
        end)
        @test isequal(reference, result)
    end
end

@testset "fast_toexpr" begin
    @syms x[1:3] y[1:3] z[1:3]
    w = @makearray w[1:3, 1:3] begin
        w[1:1, 1:3] => x'
        w[2:2, 1:3] => @arrayop (1, i) y[i] + z[i]
        w[3:3, 1:1] => [1;;]
        w[3:3, 2:2] => [z[1];;]
        w[3:3, 3:3] => [z'z;;]
    end
    xv = rand(3)
    yv = rand(3)
    zv = rand(3)
    expected = eval(quote
        let x = $xv, y = $yv, z = $zv
            $(Code.toexpr(w))
        end
    end)
    actual = eval(quote
        let x = $xv, y = $yv, z = $zv
            $(Code.fast_toexpr(w, Dict{Any,Any}()))
        end
    end)
    @test expected ≈ actual
end

@testset "Fill in region" begin
    @syms a::Real b::Real
    f = SymbolicUtils.Fill(SymbolicUtils.ShapeVecT((1:3,)))
    w = @makearray w[1:6] begin
        w[1:3] => f(a)
        w[4:6] => f(b)
    end
    av = 2.0
    bv = 5.0
    wv = eval(quote
        let a = $av, b = $bv
            $(Code.fast_toexpr(w, Dict{Any,Any}()))
        end
    end)
    @test wv[1:3] == fill(av, 3)
    @test wv[4:6] == fill(bv, 3)
end

# Helper: build a CodegenState, run codegen for `expr`, and append the result symbol so the
# block evaluates to the generated buffer (needed for ArrayOp / Fill whose codegen writes
# into a buffer rather than returning it as the last block statement).
function _codegen_to_block(ir, expr, rewrites = Dict{Any,Any}())
    block = Expr(:block)
    cs = Code.CodegenState(block, block, ir, rewrites)
    result_sym = cs(expr)
    push!(block.args, result_sym)
    return block
end

@testset "codegen on non-canonical `IRStructure`" begin
    # Extract the `term` field from an ArrayOp (used by Fill / map / mapreduce).
    # That inner Term must be pre-populated before replace_node! so that its
    # outneighbors in the graph already point to the replaced node.
    function _arrayop_term(expr)
        @match expr begin
            BSImpl.ArrayOp(; term) => term
            _ => error("expected ArrayOp")
        end
    end

    @testset "generic op" begin
        # sin(a + b) with a+b → a*b: codegen should produce sin(a*b)
        @syms a::Real b::Real
        ir = IRStructure{SymReal}()
        populate_ir!(ir, sin(a + b))
        replace_node!(ir, a + b, a * b)
        @test !isempty(ir.non_canonical_idxs)
        expr = Code.fast_toexpr(sin(a + b), ir, Dict{Any,Any}(:sort_addmul => false))
        result = eval(quote let a = 2.0, b = 3.0; $expr end end)
        @test result ≈ sin(2.0 * 3.0)
    end

    @testset "nanmath op" begin
        @syms a::Real b::Real
        ir = IRStructure{SymReal}()
        populate_ir!(ir, sin(a + b))
        replace_node!(ir, a + b, a * b)
        @test !isempty(ir.non_canonical_idxs)
        expr = Code.fast_toexpr(
            sin(a + b), ir, Dict{Any,Any}(:nanmath => true, :sort_addmul => false)
        )
        result = eval(quote let a = 2.0, b = 3.0; $expr end end)
        @test result ≈ sin(2.0 * 3.0)
    end

    @testset "`+` and `*`" begin
        @syms a::Real b::Real c::Real d::Real
        let ir = IRStructure{SymReal}()
            populate_ir!(ir, a + b + c)
            replace_node!(ir, a, d)
            @test !isempty(ir.non_canonical_idxs)
            expr = Code.fast_toexpr(a + b + c, ir, Dict{Any,Any}(:sort_addmul => false))
            result = eval(quote let a = 1.0, b = 2.0, c = 3.0, d = 10.0; $expr end end)
            @test result ≈ 10.0 + 2.0 + 3.0
        end

        let ir = IRStructure{SymReal}()
            populate_ir!(ir, a * b * c)
            replace_node!(ir, a, d)
            @test !isempty(ir.non_canonical_idxs)
            expr = Code.fast_toexpr(a * b * c, ir, Dict{Any,Any}(:sort_addmul => false))
            result = eval(quote let a = 1.0, b = 2.0, c = 3.0, d = 10.0; $expr end end)
            @test result ≈ 10.0 * 2.0 * 3.0
        end
    end

    @testset "`^`" begin
        @syms a::Real b::Real c::Real
        # symbolic exponent: a^b with a → c
        let ir = IRStructure{SymReal}()
            populate_ir!(ir, a^b)
            replace_node!(ir, a, c)
            @test !isempty(ir.non_canonical_idxs)
            expr = Code.fast_toexpr(a^b, ir, Dict{Any,Any}(:sort_addmul => false))
            result = eval(quote let a = 2.0, b = 3.0, c = 4.0; $expr end end)
            @test result ≈ 4.0^3.0
        end
        # constant exponent: a^2 with a → c
        let ir = IRStructure{SymReal}()
            populate_ir!(ir, a^2)
            replace_node!(ir, a, c)
            @test !isempty(ir.non_canonical_idxs)
            expr = Code.fast_toexpr(a^2, ir, Dict{Any,Any}(:sort_addmul => false))
            result = eval(quote let a = 2.0, c = 3.0; $expr end end)
            @test result ≈ 3.0^2
        end
    end

    @testset "`ifelse`" begin
        @syms a::Real b::Real c::Real d::Real
        cond = a < 0
        ir = IRStructure{SymReal}()
        populate_ir!(ir, ifelse(cond, b, c))
        replace_node!(ir, b, d)
        @test !isempty(ir.non_canonical_idxs)
        expr = Code.fast_toexpr(ifelse(cond, b, c), ir, Dict{Any,Any}(:sort_addmul => false))
        result = eval(quote let a = -1.0, b = 10.0, c = 20.0, d = 30.0; $expr end end)
        @test result ≈ 30.0  # a < 0 is true, so uses d (replaced from b)
    end

    @testset "`getindex`" begin
        @syms x[1:3]::Real idx1::Int idx2::Int
        ir = IRStructure{SymReal}()
        populate_ir!(ir, x[idx1])
        replace_node!(ir, idx1, idx2)
        @test !isempty(ir.non_canonical_idxs)
        expr = Code.fast_toexpr(x[idx1], ir, Dict{Any,Any}())
        result = eval(quote let x = [10, 20, 30], idx1 = 1, idx2 = 2; $expr end end)
        @test result == 20  # x[idx2] = x[2] = 20
    end

    @testset "`ArrayOp`" begin
        @syms xv[1:3]::Real yv[1:3]::Real zv[1:3]::Real
        arr = @arrayop (i,) xv[i] * yv[i]
        ir = IRStructure{SymReal}()
        populate_ir!(ir, arr)
        replace_node!(ir, Const{SymReal}(yv), Const{SymReal}(zv))
        @test !isempty(ir.non_canonical_idxs)
        block = _codegen_to_block(ir, arr, Dict{Any,Any}(:sort_addmul => false))
        xdata = [1.0, 2.0, 3.0]; ydata = [10.0, 10.0, 10.0]; zdata = [4.0, 5.0, 6.0]
        result = eval(quote let xv = $xdata, yv = $ydata, zv = $zdata; $block end end)
        @test result ≈ xdata .* zdata
    end

    @testset "`Fill`" begin
        @syms a::Real b::Real
        f = SymbolicUtils.Fill(SymbolicUtils.ShapeVecT((1:3,)))
        fill_expr = f(a)
        ir = IRStructure{SymReal}()
        populate_ir!(ir, fill_expr)
        # Pre-populate the inner Term so its graph edges already exist before replace_node!
        populate_ir!(ir, _arrayop_term(fill_expr))
        replace_node!(ir, a, b)
        @test !isempty(ir.non_canonical_idxs)
        block = _codegen_to_block(ir, fill_expr)
        result = eval(quote let a = 2.0, b = 5.0; $block end end)
        @test result == fill(5.0, 3)
    end

    @testset "`ArrayMaker`" begin
        @syms a::Real b::Real c::Real
        f = SymbolicUtils.Fill(SymbolicUtils.ShapeVecT((1:3,)))
        w = @makearray w[1:6] begin
            w[1:3] => f(a)
            w[4:6] => f(b)
        end
        ir = IRStructure{SymReal}()
        populate_ir!(ir, w)
        replace_node!(ir, a, c)
        @test !isempty(ir.non_canonical_idxs)
        expr = Code.fast_toexpr(w, ir, Dict{Any,Any}(:sort_addmul => false))
        av = 2.0; bv = 5.0; cv = 7.0
        result = eval(quote let a = $av, b = $bv, c = $cv; $expr end end)
        @test result[1:3] == fill(cv, 3)
        @test result[4:6] == fill(bv, 3)
    end

    @testset "`array_literal`" begin
        @syms a::Real b::Real c::Real d::Real
        # without allocator
        arr_lit = Const{SymReal}([a, b, c])
        let ir = IRStructure{SymReal}()
            populate_ir!(ir, arr_lit)
            replace_node!(ir, a, d)
            @test !isempty(ir.non_canonical_idxs)
            expr = Code.fast_toexpr(arr_lit, ir, Dict{Any,Any}())
            result = eval(quote let a = 1.0, b = 2.0, c = 3.0, d = 10.0; $expr end end)
            @test result ≈ [10.0, 2.0, 3.0]
        end
        # with allocator
        let ir = IRStructure{SymReal}()
            populate_ir!(ir, arr_lit)
            replace_node!(ir, a, d)
            @test !isempty(ir.non_canonical_idxs)
            wrapped = Code.with_allocator(ones, arr_lit)
            expr = Code.fast_toexpr(wrapped, ir, Dict{Any,Any}(:sort_addmul => false))
            result = eval(quote let a = 1.0, b = 2.0, c = 3.0, d = 10.0; $expr end end)
            @test result ≈ [10.0, 2.0, 3.0]
        end
    end

    @testset "`Mapper`" begin
        @syms av[1:3]::Real bv[1:3]::Real cv[1:3]::Real
        ex_map = map(+, av, bv)
        ir = IRStructure{SymReal}()
        populate_ir!(ir, ex_map)
        populate_ir!(ir, _arrayop_term(ex_map))
        replace_node!(ir, Const{SymReal}(bv), Const{SymReal}(cv))
        @test !isempty(ir.non_canonical_idxs)
        block = _codegen_to_block(ir, ex_map, Dict{Any,Any}(:sort_addmul => false))
        xdata = [1.0, 2.0, 3.0]; ydata = [10.0, 10.0, 10.0]; zdata = [4.0, 5.0, 6.0]
        result = eval(quote let av = $xdata, bv = $ydata, cv = $zdata; $block end end)
        @test result ≈ xdata .+ zdata
    end

    @testset "`Mapreducer`" begin
        @syms av[1:3]::Real bv[1:3]::Real cv[1:3]::Real
        ex_mapred = mapreduce(+, +, av, bv)
        ir = IRStructure{SymReal}()
        populate_ir!(ir, ex_mapred)
        populate_ir!(ir, _arrayop_term(ex_mapred))
        replace_node!(ir, Const{SymReal}(bv), Const{SymReal}(cv))
        @test !isempty(ir.non_canonical_idxs)
        block = _codegen_to_block(ir, ex_mapred, Dict{Any,Any}(:sort_addmul => false))
        xdata = [1.0, 2.0, 3.0]; ydata = [10.0, 10.0, 10.0]; zdata = [4.0, 5.0, 6.0]
        result = eval(quote let av = $xdata, bv = $ydata, cv = $zdata; $block end end)
        @test result ≈ sum(xdata .+ zdata)
    end
end

@testset "batched_setindex!" begin
    # NTuple of values, NTuple of CartesianIndex (1D)
    buf = zeros(Int, 5)
    Code.batched_setindex!(buf, (10, 20, 30), (CartesianIndex(1), CartesianIndex(3), CartesianIndex(5)))
    @test buf == [10, 0, 20, 0, 30]

    # NTuple of values, NTuple of CartesianIndex (2D)
    buf2d = zeros(Int, 3, 3)
    Code.batched_setindex!(buf2d, (7, 8), (CartesianIndex(1, 2), CartesianIndex(3, 2)))
    @test buf2d[1, 2] == 7
    @test buf2d[3, 2] == 8
    @test count(!iszero, buf2d) == 2

    # Broadcast single value, array of CartesianIndex (1D)
    buf = zeros(Int, 5)
    Code.batched_setindex!(buf, 42, [CartesianIndex(1), CartesianIndex(3), CartesianIndex(5)])
    @test buf == [42, 0, 42, 0, 42]

    # Broadcast single value, array of CartesianIndex (2D)
    buf2d = zeros(Int, 3, 3)
    Code.batched_setindex!(buf2d, -1, [CartesianIndex(1, 1), CartesianIndex(2, 2), CartesianIndex(3, 3)])
    @test buf2d == [-1 0 0; 0 -1 0; 0 0 -1]

    # Empty index array is a no-op
    buf = zeros(Int, 3)
    Code.batched_setindex!(buf, 99, CartesianIndex{1}[])
    @test buf == [0, 0, 0]
end

@testset "ArrayMaker batched scalar-write codegen" begin
    @syms a::Real b::Real

    # 20-element array: exercises the batched_setindex! codegen path.
    # FILL_ARR_LIMIT == 16, so arrays of size > 16 use batched_setindex! for scalar writes.
    # Entries 1–3 are 1 (→ idxs_buffer broadcast path for value 1).
    # Entries 4–5 are -1 (→ idxs_buffer broadcast path for value -1).
    # Entries 6–20 are symbolic (→ NTuple batching, split across multiple calls because
    # BATCHED_SETINDEX_BATCH_SIZE == 8).
    w = @makearray w[1:20] begin
        w[1:1]   => [1]
        w[2:2]   => [1]
        w[3:3]   => [1]
        w[4:4]   => [-1]
        w[5:5]   => [-1]
        w[6:6]   => [a]
        w[7:7]   => [b]
        w[8:8]   => [a + b]
        w[9:9]   => [2a]
        w[10:10] => [2b]
        w[11:11] => [a - b]
        w[12:12] => [3a]
        w[13:13] => [a^2]
        w[14:14] => [b^2]
        w[15:15] => [a + 1]
        w[16:16] => [b + 1]
        w[17:17] => [a * b]
        w[18:18] => [a - 1]
        w[19:19] => [b - 1]
        w[20:20] => Const{SymReal}([a + b + 1])
    end
    av = 3.0
    bv = 2.0
    result = eval(quote
        let a = $av, b = $bv
            $(Code.fast_toexpr(w, Dict{Any,Any}()))
        end
    end)
    expected = [1.0, 1.0, 1.0, -1.0, -1.0, av, bv, av+bv, 2av, 2bv, av-bv, 3av, av^2, bv^2, av+1, bv+1, av*bv, av-1, bv-1, av+bv+1]
    @test result ≈ expected

    @testset "later scalar writes overwrite earlier ones" begin
        # Scalar writes to the same index are stored in a Dict; later entries win.
        w2 = @makearray w2[1:20] begin
            w2[1:1]  => [a]
            w2[2:2]  => [1]
            w2[3:3]  => [1]
            w2[4:4]  => [1]
            w2[5:5]  => [1]
            w2[6:6]  => [1]
            w2[7:7]  => [1]
            w2[8:8]  => [1]
            w2[9:9]  => [1]
            w2[10:10] => [1]
            w2[11:11] => [1]
            w2[12:12] => [1]
            w2[13:13] => [1]
            w2[14:14] => [1]
            w2[15:15] => [1]
            w2[16:16] => [1]
            w2[17:17] => [1]
            w2[18:18] => [1]
            w2[19:19] => [1]
            w2[20:20] => [1]
            w2[1:1]  => Const{SymReal}([b])
        end
        result2 = eval(quote
            let a = $av, b = $bv
                $(Code.fast_toexpr(w2, Dict{Any,Any}()))
            end
        end)
        @test result2[1] ≈ bv
        @test all(result2[2:end] .≈ 1.0)
    end

    @testset "scalar writes flushed before block write" begin
        @syms xv[1:3]::Real
        # Scalar writes at indices 1–17 followed by a block write at 18–20.
        # The block write must trigger flushing of all preceding scalar writes.
        w3 = @makearray w3[1:20] begin
            w3[1:1]   => [1]
            w3[2:2]   => [1]
            w3[3:3]   => [1]
            w3[4:4]   => [1]
            w3[5:5]   => [1]
            w3[6:6]   => [1]
            w3[7:7]   => [1]
            w3[8:8]   => [1]
            w3[9:9]   => [1]
            w3[10:10] => [1]
            w3[11:11] => [1]
            w3[12:12] => [1]
            w3[13:13] => [1]
            w3[14:14] => [1]
            w3[15:15] => [1]
            w3[16:16] => [1]
            w3[17:17] => [1]
            w3[18:20] => xv
        end
        xdata = [10.0, 20.0, 30.0]
        result3 = eval(quote
            let xv = $xdata
                $(Code.fast_toexpr(w3, Dict{Any,Any}()))
            end
        end)
        @test all(result3[1:17] .≈ 1.0)
        @test result3[18:20] ≈ xdata
    end
end

@testset "`replace_node!` on an argument of `ArrayOp` with a `term` codegens correctly" begin
    @syms x[1:3]
    ir = IRStructure{SymReal}()
    inner = x .+ 1
    inner_idx = populate_ir!(ir, inner)
    outer_idx = populate_ir!(ir, sum(inner))
    replace_node!(ir, ir[inner_idx], x .+ 2)
    x_val = [1, 2, 3]
    reference = sum(x_val .+ 2)
    value = eval(quote
        let x = $x_val
            $(Code.fast_toexpr(ir[outer_idx], ir, Dict()))
        end
    end)
    @test reference == value
end

@testset "`LHS_HOOK_KEY`" begin
    @syms x
    ir = IRStructure{SymReal}()
    rw = Dict()
    rw[Code.LHS_HOOK_KEY] = (_, _, lhs) -> :($lhs::Any)
    expr = Code.fast_toexpr(sin(x), ir, rw)
    test_repr(expr, quote
        local var"##cse#0"::Any = x
        local var"##cse#1"::Any = $sin(var"##cse#0")
    end)
end

@testset "Matrix multiplication CSEs common prefixes" begin
    @syms x[1:3, 1:3] y[1:3, 1:3] z[1:3, 1:3] w[1:3, 1:3]
    ir = IRStructure{SymReal}()
    rw = Dict()
    expr = Code.fast_toexpr((x * y * z) \ (x * y * w), ir, rw)
    test_repr(expr, quote
        local var"##cse#0" = x
        local var"##cse#1" = y
        local var"##cse#2" = $(*)(var"##cse#0", var"##cse#1")
        local var"##cse#3" = z
        local var"##cse#4" = $(*)(var"##cse#2", var"##cse#3")
        local var"##cse#5" = w
        local var"##cse#6" = $(*)(var"##cse#2", var"##cse#5")
        local var"##cse#7" = $(\)(var"##cse#4", var"##cse#6")
    end)
end

using Documenter, DocStringExtensions, SymbolicUtils, TermInterface

include("pages.jl")
DocMeta.setdocmeta!(SymbolicUtils, :DocTestSetup, :(using SymbolicUtils); recursive=true)

makedocs(
    sitename="SymbolicUtils.jl",
    authors="Shashi Gowda",
    clean=true, doctest=true,
    format = Documenter.HTML(#analytics = "UA-90474609-3",
                             assets = ["assets/favicon.ico"],
                             canonical="https://docs.sciml.ai/SymbolicUtils/stable/"),
    pages=pages
    )

deploydocs(
   repo = "github.com/JuliaSymbolics/SymbolicUtils.jl.git";
   push_preview = true
)

struct Const{T} end
struct Sym{T} end
struct Term{T} end
struct Add{T} end
struct Mul{T} end
struct Div{T} end
struct ArrayOp{T} end
struct ArrayMaker{T} end

"""
    Const{T}(val) where {T}

Alias for [`BSImpl.Const{T}`](@ref).
"""
@inline Const{T}(@nospecialize(val); unsafe = false) where {T} = BSImpl.Const{T}(val; unsafe)

"""
    Sym{T}(name; kw...) where {T}

Alias for [`BSImpl.Sym{T}`](@ref).
"""
@inline Sym{T}(name; kw...) where {T} = BSImpl.Sym{T}(name; kw...)

"""
    Term{T}(f, args; type = _promote_symtype(f, args), kw...) where {T}

Alias for [`BSImpl.Term{T}`](@ref) except it also unwraps `args`.
"""
@inline function Term{T}(@nospecialize(f), args; type = _promote_symtype(f, args), kw...) where {T}
    args = unwrap_args(args)
    BSImpl.Term{T}(f, args; type, kw...)
end

"""
    Add{T}(coeff, dict; kw...) where {T}

High-level constructor for addition expressions.

# Arguments
- `coeff`: The constant term (additive offset)
- `dict`: Dictionary mapping terms to their coefficients
- `kw...`: Additional keyword arguments (e.g., `type`, `shape`, `metadata`, `unsafe`)

# Returns
- `BasicSymbolic{T}`: An optimized representation of `coeff + sum(k * v for (k, v) in dict)`

# Details

This constructor maintains invariants required by the `AddMul` variant. This should be
preferred over the `BSImpl.AddMul{T}` constructor.
"""
@inline function Add{T}(coeff, dict; kw...) where {T}
    @nospecialize coeff kw
    coeff = unwrap(coeff)
    dict = unwrap_dict(dict)
    if isempty(dict)
        return Const{T}(coeff)
    elseif _iszero(coeff) && length(dict) == 1
        k, v = first(dict)
        if _isone(v)
            return k
        else
            return (k * v)::BasicSymbolic{T}
        end
    end

    BSImpl.AddMul{T}(coeff, dict, AddMulVariant.ADD; kw...)
end

function _has_array_key(dict)
    for k in keys(dict)
        is_array_shape(shape(k)) && return true
    end
    return false
end

"""
    Mul{T}(coeff, dict; kw...) where {T}

High-level constructor for multiplication expressions.

# Arguments
- `coeff`: The multiplicative coefficient
- `dict`: Dictionary mapping base terms to their exponents
- `kw...`: Additional keyword arguments (e.g., `type`, `shape`, `metadata`, `unsafe`)

# Returns
- `BasicSymbolic{T}`: An optimized representation of `coeff * prod(k ^ v for (k, v) in dict)`

# Details

This constructor maintains invariants required by the `AddMul` variant. This should be
preferred over the `BSImpl.AddMul{T}` constructor.
"""
@inline function Mul{T}(coeff, dict; kw...) where {T}
    @nospecialize coeff kw
    coeff = unwrap(coeff)
    dict = unwrap_dict(dict)
    if isempty(dict)
        return Const{T}(coeff)
    elseif _iszero(coeff)
        return zero_of_vartype(T)
    end
    if _has_array_key(dict)
        factors = ArgsT{T}()
        sizehint!(factors, length(dict) + 1)
        push!(factors, Const{T}(coeff))
        for (k, v) in dict
            # `k ^ 1` is just `k`; avoid `^` so an array base isn't rejected.
            push!(factors, _isone(v) ? k : k ^ v)
        end
        return mul_worker(T, factors)::BasicSymbolic{T}
    end
    if _isone(coeff) && length(dict) == 1
        k, v = first(dict)
        if _isone(v)
            return k
        else
            return (k ^ v)::BasicSymbolic{T}
        end
    elseif length(dict) == 1 && _isone(-coeff)
        k, v = first(dict)
        if _isone(v)
            @match k begin
                BSImpl.AddMul(; coeff = c2, dict = d2, variant) && if variant === AddMulVariant.ADD end => begin
                    empty!(dict)
                    for (k, v) in d2
                        dict[k] = -v
                    end
                    return BSImpl.AddMul{T}(-c2, dict, variant; kw...)
                end
                _ => nothing
            end
        end
    end

    BSImpl.AddMul{T}(coeff, dict, AddMulVariant.MUL; kw...)
end

const Rat = Union{Rational, Integer}

"""
    $(TYPEDSIGNATURES)

Return a tuple containing a boolean indicating whether `x` has a rational/integer factor
and the rational/integer factor (or `NaN` otherwise).
"""
function ratcoeff(x)
    if iscall(x) && operation(x) === (*)
        ratcoeff(get_mul_coefficient(x))
    elseif safe_isinteger(x)
        (true, Int(x))
    elseif x isa Rat
        (true, x)
    else
        (false, NaN)
    end
end

"""
    safe_div(a::Number, b::Number)::Number

Perform division with automatic rational conversion for integer inputs.

# Arguments
- `a::Number`: The numerator
- `b::Number`: The denominator

# Returns
- `Number`: The result of `a / b`, using rational arithmetic for integers
"""
function safe_div(a::Number, b::Number)::Number
    # @nospecialize a b
    if (!(a isa Integer) && safe_isinteger(a))
        a = Int(a)
    end
    if (!(b isa Integer) && safe_isinteger(b))
        b = Int(b)
    end
    if a isa Integer && b isa Integer
        return a // b
    end
    return a / b
end

"""
    Div{T}(n, d, simplified; type = promote_symtype(/, symtype(n), symtype(d)), kw...) where {T}

High-level constructor for division expressions with simplification.

# Arguments
- `n`: The numerator
- `d`: The denominator
- `simplified::Bool`: Whether simplification has been attempted
- `type`: The result type (default: inferred using `promote_symtype`)
- `kw...`: Additional keyword arguments (e.g., `shape`, `metadata`, `unsafe`)

# Returns
- `BasicSymbolic{T}`: An optimized representation of `n / d`

# Details
This constructor creates symbolic division expressions with extensive simplification:
- Zero numerator returns zero
- Unit denominator returns the numerator
- Zero denominator returns `Const{T}(1 // 0)` (infinity). Any infinity may be returned.
- Nested divisions are flattened
- Constant divisions are evaluated
- Rational coefficients are simplified
- Multiplications in numerator/denominator are handled specially

For non-`SafeReal` variants, automatic cancellation is attempted using `quick_cancel`.
The `simplified` flag prevents infinite simplification loops.

"""
function Div{T}(n, d, simplified; type = promote_symtype(/, symtype(n), symtype(d)), kw...) where {T}
    n = Const{T}(unwrap(n))
    d = Const{T}(unwrap(d))

    if !(type <: Number)
        _iszero(n) && return Const{T}(n)
        _isone(d) && return Const{T}(n)
        return BSImpl.Div{T}(n, d, simplified; type, kw...)
    end

    if !(T === SafeReal)
        n, d = quick_cancel(Const{T}(n), Const{T}(d))
    end

    _iszero(n) && return Const{T}(n)
    _isone(d) && return Const{T}(n)
    _iszero(d) && return Const{T}(1 // 0)

    if isdiv(n) && isdiv(d)
        return Div{T}(n.num * d.den, n.den * d.num, simplified; type, kw...)
    elseif isdiv(n)
        return Div{T}(n.num, n.den * d, simplified; type, kw...)
    elseif isdiv(d)
        return Div{T}(n * d.den, d.num, simplified; type, kw...)
    end

    isconst(d) && _isone(-d) && return Const{T}(-n)
    if isconst(n) && isconst(d)
        nn = unwrap_const(n)
        dd = unwrap_const(d)
        nn isa Rat && dd isa Rat && return Const{T}(nn // dd)
        return Const{T}(nn / dd)
    end

    @match (n, d) begin
        (BSImpl.Const(; val = v1), BSImpl.Const(; val = v2)) => Const{T}(safe_div(v1, v2))
        (BSImpl.Const(; val = c1), BSImpl.AddMul(; coeff = c2, dict, type, shape, variant)) && if variant == AddMulVariant.MUL end => begin
            if c1 isa Rat && c2 isa Rat
                tmp = c1 // c2
                c1 = tmp.num
                c2 = tmp.den
            end
            n = Const{T}(c1)
            d = Mul{T}(c2, dict, ; type, shape)
        end
        (BSImpl.AddMul(; coeff, dict, type, shape, variant), BSImpl.Const(; val)) && if variant == AddMulVariant.MUL end => begin
            return Mul{T}(safe_div(coeff, val), dict, ; type, shape)
        end
        (BSImpl.AddMul(; coeff = c1, dict = d1, type = t1, shape = sh1, variant = v1),
            BSImpl.AddMul(; coeff = c2, dict = d2, type = t2, shape = sh2, variant = v2)) &&
            if v1 == AddMulVariant.MUL && v2 == AddMulVariant.MUL end => begin

            if c1 isa Rat && c2 isa Rat
                tmp = c1 // c2
                c1 = tmp.num
                c2 = tmp.den
            end
            n = Mul{T}(c1, d1, ; type = t1, shape = sh1)
            d = Mul{T}(c2, d2, ; type = t2, shape = sh2)
        end
        _ => nothing
    end

    _isone(d) && return Const{T}(n)
    _isone(-d) && return Const{T}(-n)

    BSImpl.Div{T}(n, d, simplified; type, kw...)
end

"""
    IndexedAxis{T}

Helper struct tracking how an array is indexed along one dimension.

# Fields
- `sym::BasicSymbolic{T}`: The array being indexed
- `dim::Int`: Which dimension of the array
- `pad::Union{Int, Nothing}`: Offset added to the index variable, or `nothing` for complex indexing

# Details
Used internally by `arrayop_shape` to track and validate index variable usage patterns.
"""
struct IndexedAxis{T}
    sym::BasicSymbolic{T}
    dim::Int
    pad::Union{Int, Nothing}
end

const IdxToAxesT{T} = Dict{BasicSymbolic{T}, Vector{IndexedAxis{T}}}

"""
    IndexedAxes{T}

Helper struct for tracking index variable usage in array operations.

# Fields
- `idx_to_axes::IdxToAxesT{T}`: Maps index variables to the axes they index
- `search_buffer::OrderedSet{BasicSymbolic{T}}`: Reusable buffer for variable searches
- `buffers::Vector{Vector{IndexedAxis{T}}}`: Pool of reusable buffers

# Details
Used internally for shape inference in `ArrayOp` expressions. Tracks which arrays
are indexed by which index variables and validates consistency.
"""
struct IndexedAxes{T}
    idx_to_axes::IdxToAxesT{T}
    search_buffer::OrderedSet{BasicSymbolic{T}}
    buffers::Vector{Vector{IndexedAxis{T}}}
end

function IndexedAxes{T}() where {T}
    IndexedAxes{T}(IdxToAxesT{T}(), OrderedSet{BasicSymbolic{T}}(), Vector{IndexedAxis{T}}[])
end

function Base.empty!(ix::IndexedAxes)
    append!(ix.buffers, values(ix.idx_to_axes))
    empty!(ix.search_buffer)
    empty!(ix.idx_to_axes)
    return ix
end

function getbuffer(ix::IndexedAxes{T}) where {T}
    if isempty(ix.buffers)
        return IndexedAxis{T}[]
    else
        return empty!(pop!(ix.buffers))
    end
end

"""
    Base.setindex!(ix::IndexedAxes{T}, val::IndexedAxis{T}, ax::BasicSymbolic{T}) where {T}

Record that an index variable `ax` is used to index an array.

# Arguments
- `ix::IndexedAxes{T}`: The tracking structure
- `val::IndexedAxis{T}`: Information about how the array is indexed
- `ax::BasicSymbolic{T}`: The index variable
"""
function Base.setindex!(ix::IndexedAxes{T}, val::IndexedAxis{T}, ax::BasicSymbolic{T}) where {T}
    buffer = get!(() -> getbuffer(ix), ix.idx_to_axes, ax)
    push!(buffer, val)
    return ix
end

const INDEXED_AXES_BUFFER_SYMREAL = TaskLocalValue{IndexedAxes{SymReal}}(IndexedAxes{SymReal})
const INDEXED_AXES_BUFFER_SAFEREAL = TaskLocalValue{IndexedAxes{SafeReal}}(IndexedAxes{SafeReal})

"""
    _is_index_variable(expr::BasicSymbolic{T}) where T

Check if an expression is an index variable for array operations.

# Arguments
- `expr::BasicSymbolic{T}`: Expression to check
"""
function _is_index_variable end

for T in [SymReal, SafeReal, TreeReal]
    @eval function _is_index_variable(expr::BasicSymbolic{$T})
        iscall(expr) && operation(expr) === getindex && first(arguments(expr)) === idxs_for_arrayop($T)
    end
end

"""
    $TYPEDSIGNATURES

Extract and record index variable usage patterns from an expression.

# Arguments
- `ix::IndexedAxes{T}`: The tracking structure to populate
- `expr::BasicSymbolic{T}`: The expression to analyze

# Returns
- `IndexedAxes{T}`: The updated tracking structure

# Details
Recursively searches for `getindex` operations in the expression and records how
index variables are used. For each indexed array access, it identifies:
- Which array is being indexed
- Which dimension is accessed
- The offset applied to the index variable (if constant)

Special cases are optimized for performance:
- Direct index variables (`arr[i]`)
- Simple offsets (`arr[i + c]`)

For complex indexing patterns, searches for all index variables in the expression
and validates that only one is used per dimension.
"""
function get_indexed_axes!(ix::IndexedAxes{T}, expr::BasicSymbolic{T}) where {T}
    iscall(expr) || return ix
    args = arguments(expr)
    if operation(expr) !== getindex
        for arg in args
            get_indexed_axes!(ix, arg)
        end
        return ix
    end

    sym, idxs = Iterators.peel(args)
    for (dim, idx) in enumerate(idxs)
        # special case `i` and `i + offset` for performance
        @match idx begin
            BSImpl.Const(;) => continue
            BSImpl.Sym(;) => begin
                ix[idx] = IndexedAxis(sym, dim, 0)
                continue
            end
            BSImpl.AddMul(; variant, coeff, dict) && if variant == AddMulVariant.ADD && length(dict) == 1 && !iscall(first(keys(dict))) && _isone(first(values(dict))) end => begin
                idxsym = first(keys(dict))
                ix[idxsym] = IndexedAxis(sym, dim, Int(coeff))
                continue
            end
            _ => nothing
        end
        vars = ix.search_buffer
        empty!(vars)
        search_variables!(vars, idx; is_atomic = _is_index_variable)
        if length(vars) != 1
            throw(ArgumentError(LazyString(
                "Expected ", dim, "-th index of ", expr,
                " to be a function of a single index variable.",
                " Found expression ", idx, " involving variables ", vars, ".")))
        end
        idxsym = first(vars)
        _pad = idx - idxsym
        # either it's `i + offset` in a non-special-cased form, or it's a more complicated function
        # and we use `nothing` as a sentinel.
        pad = isconst(_pad) ? Int(unwrap_const(_pad)) : nothing
        ix[first(vars)] = IndexedAxis(sym, dim, pad)
    end
    return ix
end

"""
    $TYPEDSIGNATURES

Wraps [`get_indexed_axes!`](@ref).
"""
function get_indexed_axes(expr::BasicSymbolic{SymReal})
    buffer = INDEXED_AXES_BUFFER_SYMREAL[]
    empty!(buffer)
    get_indexed_axes!(buffer, expr)
end

function get_indexed_axes(expr::BasicSymbolic{SafeReal})
    buffer = INDEXED_AXES_BUFFER_SAFEREAL[]
    empty!(buffer)
    get_indexed_axes!(buffer, expr)
end

"""
    $TYPEDSIGNATURES

Infer the shape of an `ArrayOp` result from index variables and ranges.

# Arguments
- `output_idx::AbstractVector`: Output index variables defining result dimensions
- `expr::BasicSymbolic{T}`: The expression being computed over indices
- `ranges::AbstractDict`: Dictionary mapping bound index variables to their ranges

# Returns
- `ShapeVecT`: The inferred shape of the result array
- `Unknown(length(output_idx))`: If shape cannot be fully inferred

# Throws
- `ArgumentError`: If index variable usage is inconsistent or out of bounds

# Details
This function performs comprehensive shape inference and validation:
1. Extracts all index variable usages from `expr`
2. For each bound index variable (in `ranges`), validates that its range fits within
   all arrays it indexes
3. For each unbound index variable, validates that all usages have consistent ranges
4. Constructs the output shape from the ranges of output index variables

The function ensures that array operations are well-formed before code generation.
"""
function arrayop_shape(output_idx::AbstractVector, expr::BasicSymbolic{T}, ranges::AbstractDict) where {T}
    ix = get_indexed_axes(expr)
    idx_to_axes = ix.idx_to_axes

    for (idxsym, iaxes) in idx_to_axes
        if haskey(ranges, idxsym)
            is_bound = true
            offset = 1
            reference_axis = ranges[idxsym]
        else
            is_bound = false
            offset = findfirst(iaxes) do iaxis
                !(shape(iaxis.sym) isa Unknown)
            end
            offset === nothing && continue
            iaxis = iaxes[offset]
            reference_axis = (shape(iaxis.sym)::ShapeVecT)[iaxis.dim]
        end

        for i in (offset + 1):length(iaxes)
            iaxis = iaxes[i]
            sh = shape(iaxis.sym)
            sh isa Unknown && continue
            sh = sh::ShapeVecT
            if is_bound
                iaxis.pad === nothing && continue
                if !issubset(reference_axis .+ iaxis.pad, sh[iaxis.dim])
                    throw(ArgumentError(LazyString(
                        "Expected bound range ", reference_axis,
                        " of ", idxsym, " with offset ", iaxis.pad,
                        " to be within bounds of dimension ", iaxis.dim,
                        " of variable ", iaxis.sym,
                        " (", sh[iaxis.dim], ") where it is used.")))
                end
            else
                if !isequal(length(reference_axis), length(sh[iaxis.dim]))
                    throw(ArgumentError(LazyString(
                        "Expected all usages of index variable ", idxsym,
                        " be in axes of equal range.",
                        " Found usage in dimension ", iaxis.dim,
                        " of variable ", iaxis.sym,
                        " which has range ", sh[iaxis.dim],
                        " different from inferred range ", reference_axis, ".")))
                end
            end
        end
    end

    result = ShapeVecT()
    for idx in output_idx
        if idx isa Int
            push!(result, 1:1)
        elseif idx isa BasicSymbolic{T}
            if haskey(ranges, idx)
                push!(result, 1:length(ranges[idx]))
                continue
            end
            if !haskey(idx_to_axes, idx)
                throw(ArgumentError(LazyString("Could not infer range of output index ", idx, ".")))
            end
            iaxes = idx_to_axes[idx]
            canonical_axis_idx = findfirst(iaxes) do iaxis
                !(shape(iaxis.sym) isa Unknown)
            end
            if canonical_axis_idx === nothing
                return Unknown(length(output_idx))
            end
            canonical_axis = iaxes[canonical_axis_idx]
            push!(result, shape(canonical_axis.sym)[canonical_axis.dim])
        end
    end
    return result
end

function promote_symtype(::Type{ArrayOp{T}}, _outidx::TypeT, expr::TypeT, _reduce::TypeT,
                         _term::TypeT, _ranges::TypeT) where {T}
    Array{expr}
end

"""
    ArrayOp{T}(output_idx, expr, reduce, term, ranges; metadata = nothing) where {T}

High-level constructor for array operation expressions.

# Arguments
- `output_idx`: Output indices defining result dimensions
- `expr`: Expression to evaluate for each index combination
- `reduce`: Reduction operation (or `nothing`)
- `term`: Optional accumulation term (or `nothing`)
- `ranges`: Dictionary mapping index variables to ranges
- `metadata`: Optional metadata (default: `nothing`)

# Returns
- `BasicSymbolic{T}`: An `ArrayOp` representing the array comprehension

# Details

This constructor validates and parses fields of the `ArrayOp` variant. It is usually never
called directly. Prefer using the [`@arrayop`](@ref) macro.

# Extended help

The `unsafe` keyword argument (default: `false`) can be used to skip hash consing for
performance in internal operations.
"""
function ArrayOp{T}(output_idx, expr, reduce, term, ranges; metadata = nothing, unsafe = false) where {T}
    if isempty(output_idx)
        type = symtype(expr)
    else
        type = Array{symtype(expr), length(output_idx)}
    end
    output_idx = unwrap_args(collect(unwrap(output_idx)))
    expr = unwrap(expr)
    ranges = unwrap_dict(unwrap_const(ranges))
    reduce = unwrap_const(reduce)
    term = unwrap_const(unwrap(term))
    sh = arrayop_shape(collect(unwrap(output_idx)), unwrap(expr), unwrap_const(ranges))
    if term !== nothing && shape(term) != sh
        throw(ArgumentError(LazyString(
            "Shape of `term` ", term, " provided to `ArrayOp` (",
            shape(term), ") must be identical to inferred shape ", sh, ".")))
    end
    return BSImpl.ArrayOp{T}(output_idx, expr, reduce, term, ranges; type, shape = sh, metadata, unsafe)
end

"""
    ArrayMaker{T}(regions, values; shape = nothing, metadata = nothing, unsafe = false)

High-level constructor for arrays composed of blocks of other arrays.

# Arguments
- `regions`: A list of `AbstractVector{UnitRange{Int}}` denoting subarrays of the resultant
  array to assign.
- `values`: A corresponding list of (symbolic) values assigned to each entry in `regions`.

# Returns
- `BasicSymbolic{T}`: An `ArrayMaker` representing the resultant array.

# Details
This constructor validates and parses the data necessary to construct an `ArrayMaker`. The
[`SymbolicUtils.symtype`](@ref) of the resultant array is automatically inferred. Refer to
the [`@makearray`](@ref) documentation for the constraints on `regions` and `values`.

# Extended help

The `unsafe` keyword argument (default: `false`) can be used to skip hash consing for
performance in internal operations.
"""
function ArrayMaker{T}(regions, values; shape = nothing, metadata = nothing, unsafe = false) where {T}
    regions = parse_regions(unwrap_args(regions))
    values = parse_args(T, unwrap_args(values))
    if shape === nothing
        shape = shape_from_regions(regions)
    end
    shape = shape::ShapeVecT
    type = symtype_from_values(values, length(shape))
    validate_values_shapes(regions, values)
    return BSImpl.ArrayMaker{T}(regions, values; metadata, shape, type, unsafe)
end

function shape_from_regions(regions::RegionsT)::ShapeVecT
    all_same_ndims = @union_split_smallvec regions allequal(Iterators.map(length, regions))
    @assert all_same_ndims """
    All regions provided to `ArrayMaker` must have the same number of dimensions.
    """
    ndim = length(first(regions))
    starts = SmallV{Int}()
    stops = SmallV{Int}()
    sizehint!(starts, ndim)
    sizehint!(stops, ndim)
    for _ in 1:ndim
        push!(starts, typemax(Int))
        push!(stops, typemin(Int))
    end

    for region in regions
        for (i, axis) in enumerate(region)
            starts[i] = min(starts[i], first(axis))
            stops[i] = max(stops[i], last(axis))
        end
    end

    shape = ShapeVecT()
    sizehint!(shape, ndim)
    @union_split_smallvec starts begin
        @union_split_smallvec stops begin
            for (i, (start, stop)) in enumerate(zip(starts, stops))
                if start == typemax(Int) || stop == typemin(Int)
                    throw(ArgumentError(LazyString("Unable to infer bounds for ", i, "-th dimension of `ArrayMaker`.")))
                end
                push!(shape, start:stop)
            end
        end
    end

    return shape
end

function symtype_from_values(values::ArgsT, ndims::Int)
    sT = symtype(first(values))::TypeT
    @assert sT <: AbstractArray
    T::TypeT = safe_eltype(sT)::TypeT
    for v in values
        sT = symtype(v)
        @assert sT <: AbstractArray
        eT = safe_eltype(sT)::TypeT
        T = promote_type_fast_path(T, eT)
    end

    return Array{T, ndims}
end

function _throw_arraymaker_incompatible_shapes(region, val)
    throw(ArgumentError(LazyString(
        "Incompatible shapes found in `@arraymaker`: Value `", val,
        "` of shape ", shape(val), " assigned to region ", region, ".")))
end

function validate_values_shapes(regions::RegionsT, values::ArgsT{T}) where {T}
    szbuf1 = SmallV{Int}()
    szbuf2 = SmallV{Int}()
    @union_split_smallvec regions @union_split_smallvec values begin
        for (reg, val) in zip(regions, values)
            empty!(szbuf1)
            empty!(szbuf2)
            sh = shape(val)
            if sh isa ShapeVecT
                @union_split_smallvec sh for ax in sh
                    push!(szbuf2, length(ax))
                end
            else
                sh.ndims == length(reg) || _throw_arraymaker_incompatible_shapes(reg, val)
            end
            @union_split_smallvec reg for ax in reg
                push!(szbuf1, length(ax))
            end
            isequal(szbuf1, szbuf2) || _throw_arraymaker_incompatible_shapes(reg, val)
        end
    end
end

using SnoopCompileCore, SymbolicUtils, AbstractTrees, Test

syms_inf = @snoop_inference @syms x y
@syms x y z
add_inf = @snoop_inference x + y
sub_inf = @snoop_inference x - y
neg_inf = @snoop_inference -x
mul_inf = @snoop_inference x * y
coeff_inf = @snoop_inference 2x
div_inf = @snoop_inference x / y
const_div_inf = @snoop_inference x / 5
pow_inf = @snoop_inference x ^ y
print(devnull, Val{5}())
z = rand(Int)
const_pow_inf = @snoop_inference x ^ z
expr = x + sin(y) * z
rules = Dict(x => y)
fold = Val{false}()
subs_inf = @snoop_inference substitute(expr, rules; fold)
args_inf = @snoop_inference arguments(expr)

using SnoopCompile

@testset "$name" for (name, inf) in [
    ("syms", syms_inf),
    ("add", add_inf),
    ("sub", sub_inf),
    ("neg", neg_inf),
    ("mul", mul_inf),
    ("coeff", coeff_inf),
    ("div", div_inf),
    ("const_div", const_div_inf),
    ("pow", pow_inf),
    ("const_pow", const_pow_inf),
    ("substitute", subs_inf),
    ("arguments", args_inf)
]
    @test isempty(staleinstances(inf)) broken = (name == "substitute")
    @test isempty(children(inf))
    # print_tree(inf; maxdepth = 100)
end

using SymbolicUtils
using SymbolicUtils: Sym, BasicSymbolic, fraction_iszero, fraction_isone
using TermInterface

# to avoid running into hashconsed variables that have precomputed `arguments` etc
a = Sym{SymReal}(gensym(:a), type = Number)
b = Sym{SymReal}(gensym(:b), type = Number)
c = Sym{SymReal}(gensym(:c), type = Int)
d = Sym{SymReal}(gensym(:d), type = Real)

@testset "Add" begin
    @test_nowarn @inferred a + b
    @test_nowarn @inferred a + c
    @test_nowarn @inferred a + b + c + d
    @test_nowarn @inferred 2 + a + b + c
    @test_nowarn @inferred a + 2 + b + 2 + c
    @test_nowarn @inferred 1 + 2 + 3 + 4 + a + b
    tmp = (a + b)
    @test_nowarn @inferred tmp + c
end

@testset "Sub" begin
    @test_nowarn @inferred a - b
    @test_nowarn @inferred a - 2
    @test_nowarn @inferred 2 - a
    @test_nowarn @inferred -a
end

@testset "Mul" begin
    @test_nowarn @inferred a * b
    @test_nowarn @inferred a * c
    @test_nowarn @inferred a * b * c * d
    @test_nowarn @inferred 2 * a * b * c
    @test_nowarn @inferred a * 2 * b * 2 * c
    @test_nowarn @inferred 1 * 2 * 3 * 4 * a * b
    tmp = (a * b)
    @test_nowarn @inferred tmp * c
    tmp = a^2
    @test_nowarn @inferred tmp * a * b
end

@static if VERSION > v"1.11"
    @testset "Div" begin
        @test_nowarn @inferred a / 2
        @test_nowarn @inferred 2 / a
        @test_nowarn @inferred a / b
        @test_nowarn @inferred a / 2 / b / 2 / c / 2 / d
        @test_nowarn @inferred (a * b) / (b * c)
        @test_nowarn @inferred (2a*b) / (4b * c)
        @test_nowarn @inferred (a^2 * b) / (a^3 * c)
    end
end

@testset "Pow" begin
    @test_nowarn @inferred a ^ 2
    @test_nowarn @inferred 2 ^ a
    @test_nowarn @inferred a ^ b
    @test_nowarn @inferred (a * b) ^ 2
    @test_nowarn @inferred (a / b) ^ 4
    @test_nowarn @inferred (a / b) ^ c
    @test_nowarn @inferred (a ^ b) ^ c
end

# again in case stuff was precomputed in the previous tests
a = Sym{SymReal}(gensym(:a), type = Number)
b = Sym{SymReal}(gensym(:b), type = Number)
c = Sym{SymReal}(gensym(:c), type = Int)
d = Sym{SymReal}(gensym(:d), type = Real)

@testset "Arguments" begin
    @test_nowarn @inferred arguments(sin(a))
    @test_nowarn @inferred arguments(ifelse(a == b, b, c))
    @test_nowarn @inferred arguments(a + b + c + 2)
    @test_nowarn @inferred arguments(a * b * c * 2)
    @test_nowarn @inferred arguments(a ^ 2)
    @test_nowarn @inferred arguments(a / b)
end

@testset "hashequal" begin
    @test_nowarn @inferred hash(a)
    @test_nowarn @inferred hash(a + b)
    @test_nowarn @inferred hash(a * b)
    @test_nowarn @inferred hash(a ^ b)
    @test_nowarn @inferred hash(a / b)
    @test_nowarn @inferred hash(sin(a))
    @test_nowarn @inferred isequal(a, a)
    @test_nowarn @inferred isequal(a + b, a + b)
    @test_nowarn @inferred isequal(a * b, a * b)
    @test_nowarn @inferred isequal(a ^ b, a ^ b)
    @test_nowarn @inferred isequal(a / b, a / b)
    @test_nowarn @inferred isequal(sin(a), sin(a))
end

function foo end

@testset "`term`" begin
    @test_nowarn @inferred term(foo, a, b, c)
    @test_nowarn @inferred term(foo, a, b, c; type = Any)
    @test_nowarn @inferred term(foo, a, b, c; type = Number)
end

@static if VERSION > v"1.11"
    @testset "`maketerm`" begin
        @test_nowarn @inferred maketerm(BasicSymbolic{SymReal}, +, [a, b, c], nothing)
        @test_nowarn @inferred maketerm(BasicSymbolic{SymReal}, +, (a, b, c), nothing)
        @test_nowarn @inferred maketerm(BasicSymbolic{SymReal}, *, [a, b, c], nothing)
        @test_nowarn @inferred maketerm(BasicSymbolic{SymReal}, *, (a, b, c), nothing)
        @test_nowarn @inferred maketerm(BasicSymbolic{SymReal}, ^, [a, b], nothing)
        @test_nowarn @inferred maketerm(BasicSymbolic{SymReal}, ^, (a, b), nothing)
        @test_nowarn @inferred maketerm(BasicSymbolic{SymReal}, /, [a, b], nothing)
        @test_nowarn @inferred maketerm(BasicSymbolic{SymReal}, /, (a, b), nothing)
        @test_nowarn @inferred maketerm(BasicSymbolic{SymReal}, -, [a, b], nothing)
        @test_nowarn @inferred maketerm(BasicSymbolic{SymReal}, -, (a, b), nothing)
        @test_nowarn @inferred maketerm(BasicSymbolic{SymReal}, sin, [a], nothing)
        @test_nowarn @inferred maketerm(BasicSymbolic{SymReal}, sin, (a,), nothing)
        @test_nowarn @inferred maketerm(BasicSymbolic{SymReal}, ifelse, [a == b, b, c], nothing)
        @test_nowarn @inferred maketerm(BasicSymbolic{SymReal}, ifelse, (a == b, b, c), nothing)
    end
end

@testset "`expand`" begin
    @test_nowarn @inferred expand((a + b) ^ 3 * d)
end

@testset "`simplify_div`" begin
    @test_nowarn @inferred SymbolicUtils.simplify_div((a ^ 2 + b^2 + 2a*b) / ((a + b) * (b + c)))
end

@testset "`flatten_fractions`" begin
    @test_nowarn @inferred flatten_fractions((1+(1+1/a)/a)/a)
end

@testset "`simplify_fractions`" begin
    @syms a b c d e f g h i
    ex = (f + ((((g*(c^2)*(e^2)) / d - e*h*(c^2)) / b + (-c*e*f*g) / d + c*e*i) /
              (i + ((c*e*g) / d - c*h) / b + (-f*g) / d) - c*e) / b +
         ((g*(f^2)) / d + ((-c*e*f*g) / d + c*f*h) / b - f*i) /
         (i + ((c*e*g) / d - c*h) / b + (-f*g) / d)) / d
    @test_nowarn @inferred simplify_fractions(ex)
end

@testset "`fraction_iszero`, `fraction_isone`" begin
    @syms a b c d e f g h i
    o = (d + (e*((c*(g + (-d*g) / d)) / (i + (-c*(h + (-e*g) / d)) / b + (-f*g) / d))) / b +
         (-f*(g + (-d*g) / d)) / (i + (-c*(h + (-e*g) / d)) / b + (-f*g) / d)) / d
    @test_nowarn @inferred fraction_iszero(o)
    @test_nowarn @inferred fraction_isone(o)
end

@testset "`simplify`" begin
    function random_term(len; atoms, funs, fallback_atom=1)
        xs = rand(atoms, len)
        while length(xs) > 1
            xs = map(Iterators.partition(xs, 2)) do xy
                x = xy[1]; y = get(xy, 2, fallback_atom)
                rand(funs)(x, y)
            end
        end
        xs[]
    end
    ex1 = random_term(10, atoms=[a, b, c, d, a^(-1), b^(-1), 1, 2.0], funs=[+, *])
    ex2 = random_term(10, atoms=[a, b, c, d, a^(-1), b^(-1), 1, 2.0], funs=[/, *])
    @test_nowarn @inferred simplify(ex1; simplify_fractions = true)
    @test_nowarn @inferred simplify(ex2; simplify_fractions = true)
    @test_nowarn @inferred simplify(ex1; simplify_fractions = false)
    @test_nowarn @inferred simplify(ex2; simplify_fractions = false)
end

using SymbolicUtils: Term, symtype, unwrap_const, Add, Mul
using Test, SymbolicUtils

include("utils.jl")

@testset "div and polyform" begin
    @syms x y z
    @test repr(x/y*x/z) == "(x^2) / (y*z)"
    @test repr(simplify_fractions(((x-y+z)*(x+4z+1)) /
                                  (y*(2x - 3y + 3z) +
                                   x*(x + z)))) == repr(simplify_fractions((1 + x + 4z) / (x + 3y)))
    @test unwrap_const(simplify_fractions( (1/x)^2 * x^2)) == 1
    @test unwrap_const(simplify_fractions(x/(x+3) + 3/(x+3))) == 1
    @test repr(simplify(simplify_fractions(cos(x)/sin(x) + sin(x)/cos(x)))) == "2 / sin(2x)"
end

@testset "expand" begin
    @syms a b c d

    @test unwrap_const(expand(term(*, 0, a))) == 0
    @test unwrap_const(expand(a * (b + -1 * c) + -1 * (b * a + -1 * c * a))) == 0
    @eqtest simplify(expand(sin((a+b)^2)^2)) == simplify(sin(a^2+2*(b*a)+b^2)^2)
    @test unwrap_const(simplify(expand(sin((a+b)^2)^2 + cos((a+b)^2)^2))) == 1
    @syms x1::Real f(::Real)::Real

    # issue 193
    #@test isequal(expand(f(2.0 + x1)), f(2.0 + x1))
    @test symtype(expand(f(x1 + 2.0))) == Real

    # cleanup rules
    # I don't think we need this anymore?
   #@test expand(Term{Number}(identity, 0)) == 0
   #@test expand(Term{Number}(one, 0)) == 1
   #@test expand(Term{Number}(zero, 0)) == 0
   #@test expand(identity(a * b) - b * a) == 0
    @test unwrap_const(expand(a * b - b * a)) == 0

    @syms A::Vector{Real}
    # test that the following works
    expand(Term{SymReal}(getindex, [A, 3]; type = Real) - 3)
end

@testset "simplify_fractions with quick-cancel" begin
    @syms x y
    @test unwrap_const(simplify_fractions(x/2x)) == 1//2
    @test unwrap_const(simplify_fractions(2x/x)) == 2
    @eqtest simplify_fractions((x+y) * (x-y) / (x+y)) == (x-y)
    @eqtest simplify_fractions(x^3 * y / x) == y*x^2
    @eqtest simplify_fractions(2x^3 * y / x) == 2y*x^2
    @eqtest simplify_fractions(x / (3(x^3)*y)) == simplify_fractions(1/(3*(y*x^2)))
    @eqtest simplify_fractions(2x / (3(x^3)*y)) == simplify_fractions(2/(3*(y*x^2)))
    @eqtest simplify_fractions(x^2 / (3(x^3)*y)) == simplify_fractions(1/(3*(y*x)))
    @eqtest simplify_fractions((3(x^3)*y) / x^2) == simplify_fractions(3*(y*x))
    @eqtest simplify_fractions(x^2/x^4) == (1/x^2)
    @eqtest simplify_fractions(x^2/x^3) == 1/x
    @eqtest simplify_fractions(x^3/x^2) == x
    @eqtest unwrap_const(simplify_fractions(x^2/x^2)) == 1
    @eqtest simplify_fractions(3x^2/x^3) == 3/x
    @eqtest simplify_fractions(3*(x^2)*(y^3)/(3*(x^3)*(y^2))) == y/x
    @eqtest simplify_fractions(3*(x^x)/x*y) == 3*(x^x)/x*y

    ##404#issuecomment-939404030
    a = 1 / (x - (2//1)) + ((-5//1) - x) / ((x - (2//1))^2)
    @test isequal(simplify_fractions(a), 7/expand(-(x-2)^2))

    # https://github.com/JuliaSymbolics/Symbolics.jl/issues/968
    @eqtest simplify_fractions((x * y + (1//2) * x) / (2 * x)) == (1//2 + y) / 2
end

import DynamicPolynomials as DP
import MultivariatePolynomials as MP
using SymbolicUtils: PolynomialT, poly_to_gcd_form, MonomialOrder

# `to_poly!` returns `PolynomialT = DP.Polynomial{V,M,Number}` — the
# coefficient eltype is the abstract `Number`. The previous broadcast form in
# `poly_to_gcd_form` (`Integer.(coeffs)`, `rationalize.(...)`, `float.(...)`,
# `(complex ∘ float).(...)`) preserved abstractness whenever the underlying
# concrete element types were *heterogeneous* — e.g.
# `Integer.(Number[Int8(1), Int64(-2), Int64(1)])` returns
# `Vector{Signed}` rather than `Vector{Int64}`. The resulting
# `DP.Polynomial` then carried an abstract type parameter
# (`Signed` / `Integer` / `AbstractFloat` / `Real`), and `MP.gcd`'s
# `isolate_variable` crashed downstream with a
# `MethodError(Term{T,M} where T, (::Vector{Term{<:Any, M}},))`.
#
# Guard: each branch of `poly_to_gcd_form` must return a polynomial with a
# *concrete* coefficient type even when the input vector is heterogeneous
# within the relevant numeric kind.
let v = only(DP.@polyvar __PolyToGcdFormTest__ monomial_order = MonomialOrder)
    # CRITICAL: build the coefficient vector with the typed-literal form
    # `Number[Int8(1), Int64(-2), Int64(1)]` rather than going through
    # `Vector{Number}([…])` — the latter passes through an inner untyped
    # literal which `promote_type`-normalises to the LUB element type
    # (collapsing Int8+Int64 down to Int64 before reaching `Vector{Number}`),
    # so the heterogeneity is gone and the bug doesn't reproduce.
    function poly_with_coeffs(coeffs::Vector{Number}, monos_template)
        DP.Polynomial(coeffs, MP.monomials(monos_template))
    end

    @testset "poly_to_gcd_form gives concrete coefficient eltype" begin
        @testset "heterogeneous integer kinds (Int8 + Int64)" begin
            # Pre-fix: `Integer.(Number[Int8(1), Int64(-2), Int64(1)])` →
            # `Vector{Signed}` → polynomial type parameter `Signed` (abstract).
            p = poly_with_coeffs(Number[Int8(1), Int64(-2), Int64(1)],
                                  (1 - v) * (1 - v))   # 1 - 2v + v^2
            @test p isa PolynomialT
            g = poly_to_gcd_form(p)
            T = eltype(MP.coefficients(g))
            @test isconcretetype(T)
            @test T <: Integer
            @test MP.coefficients(g) == [1, -2, 1]
        end

        @testset "heterogeneous rational kinds (Rational{Int8} + Rational{Int64})" begin
            p = poly_with_coeffs(Number[Rational{Int8}(1, 2), Rational{Int64}(-1, 3)],
                                  (1//2 - v))
            g = poly_to_gcd_form(p)
            T = eltype(MP.coefficients(g))
            @test isconcretetype(T)
            @test T <: Rational
        end

        @testset "heterogeneous float kinds (Float32 + Float64)" begin
            p = poly_with_coeffs(Number[Float32(1.5), Float64(-2.5)], (1.5 - v))
            g = poly_to_gcd_form(p)
            T = eltype(MP.coefficients(g))
            @test isconcretetype(T)
            @test T <: AbstractFloat
        end

        @testset "heterogeneous complex kinds (ComplexF32 + ComplexF64)" begin
            p = poly_with_coeffs(Number[ComplexF32(1, 2), ComplexF64(0, 0.5)],
                                  (1.0 + 2.0im - v))
            g = poly_to_gcd_form(p)
            T = eltype(MP.coefficients(g))
            @test isconcretetype(T)
            @test T <: Complex
        end

        @testset "MP.gcd works on heterogeneous-coefficient polynomials" begin
            # On the buggy version this used to throw
            # `MethodError(Term{T,M} where T, (::Vector{Term{<:Any, M}},))`
            # via the `isolate_variable` path inside `multivariate_gcd`.
            p1 = poly_with_coeffs(Number[Int8(1), Int64(-2), Int64(1)],
                                   (1 - v) * (1 - v))     # 1 - 2v + v^2
            p2 = poly_with_coeffs(Number[Int8(1), Int64(-1)],
                                   (1 + v^2))             # 1 + v^2 (template; coeffs replaced)
            g1 = poly_to_gcd_form(p1)
            g2 = poly_to_gcd_form(p2)
            @test gcd(g1, g2) isa DP.Polynomial
        end
    end
end

@testset "simplify_fractions doesn't crash on heterogeneous coefficients" begin
    # End-to-end repro of the crash surfaced via SymbolicIntegration.jl's
    # difficult-test verifier: a `simplify(num/den; expand=true)` whose num/den
    # both go through `to_poly!` → `safe_gcd` → `poly_to_gcd_form`, where
    # heterogeneous coefficient types (e.g. integers in `num` mixed with
    # rationals/floats in `den`) used to send `MP.gcd` into the abstract-eltype
    # `MethodError` path.
    @syms x

    # Mix of integer, rational, and float coefficients across num and den.
    num = (x^4 - x^3 + 2x^2 - x + 2)
    den = (x - 1) * (x^2 + 2)^2
    @test simplify_fractions(num / den) isa Any   # just must not throw

    # Float ↔ rational mix.
    @test simplify_fractions((1.0 + 0.5*x - x^2) / ((1//2)*x^2 - 1)) isa Any
end

@testset "isone iszero" begin
    @syms a b c d e f g h i
    x = (f + ((((g*(c^2)*(e^2)) / d - e*h*(c^2)) / b + (-c*e*f*g) / d + c*e*i) /
              (i + ((c*e*g) / d - c*h) / b + (-f*g) / d) - c*e) / b +
         ((g*(f^2)) / d + ((-c*e*f*g) / d + c*f*h) / b - f*i) /
         (i + ((c*e*g) / d - c*h) / b + (-f*g) / d)) / d

    o = (d + (e*((c*(g + (-d*g) / d)) / (i + (-c*(h + (-e*g) / d)) / b + (-f*g) / d))) / b + (-f*(g + (-d*g) / d)) / (i + (-c*(h + (-e*g) / d)) / b + (-f*g) / d)) / d
    @test SymbolicUtils.fraction_iszero(x)
    @test !SymbolicUtils.fraction_isone(x)
    @test SymbolicUtils.fraction_isone(o)
end

module SymbolicUtilsLabelledArraysExt

using LabelledArrays
using LabelledArrays.StaticArrays
using SymbolicUtils

@inline function SymbolicUtils.Code.create_array(A::Type{<:SLArray}, T, nd::Val, d::Val{dims}, elems...) where {dims}
    a = SymbolicUtils.Code.create_array(SArray, T, nd, d, elems...)
    if nfields(dims) === ndims(A)
        similar_type(A, eltype(a), Size(dims))(a)
    else
        a
    end
end

@inline function SymbolicUtils.Code.create_array(A::Type{<:LArray}, T, nd::Val, d::Val{dims}, elems...) where {dims}
    data = SymbolicUtils.Code.create_array(Array, T, nd, d, elems...)
    if nfields(dims) === ndims(A)
        LArray{eltype(data),nfields(dims),typeof(data),LabelledArrays.symnames(A)}(data)
    else
        data
    end
end

end

using SymbolicUtils
using SymbolicUtils: BasicSymbolic, IRStructure, IRSubstituter, populate_ir!, subset_ir, get_reachability, replace_node!, replace_edge!
import SymbolicUtils as SU
import Graphs

@syms t x y z(..) w[1:3] fn(::Number)
z = z(t)

function sanity_check(ir, expr)
    idx = ir[expr]
    @test isequal(ir[idx], expr)
    if !iscall(expr)
        # Ensure this is a leaf
        @test isempty(get_reachability(ir, idx))
        @test isempty(Graphs.outneighbors(ir.dependency_graph, idx))
        return
    end
    reference = Int[]
    # Arguments should all have smaller indices and be present in reachability
    for arg in arguments(expr)
        sanity_check(ir, arg)
        @test ir[arg] < idx
        @test ir[arg] in get_reachability(ir, idx)
        append!(reference, get_reachability(ir, ir[arg]))
        push!(reference, ir[arg])
    end
    if operation(expr) isa SU.BasicSymbolic{SymReal}
        op = operation(expr)::SU.BasicSymbolic{SymReal}
        @test ir[op] < idx
        @test ir[op] in get_reachability(ir, idx)
        append!(reference, get_reachability(ir, ir[op]))
        push!(reference, ir[op])
    end
    # Check reachability
    sort!(reference)
    unique!(reference)
    @test issetequal(get_reachability(ir, idx), reference)
end

@testset "Construction and invariants" begin
    ir = IRStructure{SymReal}()

    expr = x + 2y + 3sin(z + fn(w[1] + sum(w) * tanh(w'w)))
    idx = populate_ir!(ir, expr)
    @test length(ir) == idx
    sanity_check(ir, expr)

    # Invalid accesses should error
    expr2 = sin(x)
    @test_throws KeyError ir[expr2]
    @test_throws BoundsError ir[idx + 1]

    # `eachindex` should work and iterate integers
    @test all(Base.Fix2(isa, BasicSymbolic{SymReal}), [ir[i] for i in eachindex(ir)])

    # re-inserting the same expression should return the same index
    subidx = ir[2y]
    @test populate_ir!(ir, 2y) == subidx

    @testset "Uses hashconsing equality" begin
        ir2 = IRStructure{SymReal}()
        a = SU.Const{SymReal}(1)
        b = SU.Const{SymReal}(1.0)
        populate_ir!(ir2, a)
        populate_ir!(ir2, b)
        @test ir2[a] != ir2[b]
    end
end

@testset "`subset_ir`" begin
    expr1 = x + 2y + 3sin(z + fn(w[1] + sum(w) * tanh(w'w)))
    expr2 = 2x + 3y + 3sin(z + fn(w[1] + sum(w) * tanh(w'w)))
    ir1 = IRStructure{SymReal}()
    populate_ir!(ir1, expr1)
    populate_ir!(ir1, expr2)

    subexpr = 3sin(z + fn(w[1] + sum(w) * tanh(w'w)))
    subidx = ir1[subexpr]

    ir2 = subset_ir(ir1, [subexpr])
    ir_reference = IRStructure{SymReal}()
    populate_ir!(ir_reference, subexpr)
    @test length(ir2) == length(ir_reference)
    # SimpleDiGraph is lazy
    for i in eachindex(ir2)
        nbors = Graphs.outneighbors(ir2.dependency_graph, i)
        nbors_ref = Graphs.outneighbors(ir_reference.dependency_graph, i)
        @test isequal(nbors, nbors_ref)
    end
    @test isequal(ir2.symbols, ir_reference.symbols)
    @test isequal(ir2.definition, ir_reference.definition)
end

@testset "`search_variables!`" begin
    expr = x + 2y + 3sin(z + fn(w[1] + sum(w) * tanh(w'w)))
    ir = IRStructure{SymReal}()
    populate_ir!(ir, expr)

    buffer = Set{BasicSymbolic{SymReal}}()
    SU.search_variables!(buffer, ir, expr)
    buffer2 = empty(buffer)
    SU.search_variables!(buffer2, expr)
    @test issetequal(buffer, buffer)
end

@testset "`query`" begin
    expr = x + 2y + 3sin(z + fn(w[1] + sum(w) * tanh(w'w)))
    ir = IRStructure{SymReal}()
    populate_ir!(ir, expr)

    @test SU.query(isequal(y), ir, expr)
    @test !SU.query(isequal(w[2]), ir, expr)
    @test !SU.query(isequal(z), ir, expr; recurse = ex -> iscall(ex) && operation(ex) !== sin)
end

@testset "show" begin
    # Single leaf node: exact output check (indegree 0, never inlined)
    ir = IRStructure{SymReal}()
    populate_ir!(ir, x)
    @test sprint(show, ir) == "IRStructure with 1 node:\n  %1 = x\n"

    # Single-use nodes are inlined: x^2 + y has no sharing, collapses to one line
    ir = IRStructure{SymReal}()
    populate_ir!(ir, x^2 + y)
    output = sprint(show, ir)
    lines = split(output, '\n'; keepempty = false)
    @test startswith(lines[1], "IRStructure with ")
    @test endswith(lines[1], "nodes:")
    # Every definition line has the SSA format
    @test all(l -> occursin(r"^\s+%\d+ = ", l), lines[2:end])
    # With full inlining only the root remains, raw symbols appear inline
    @test occursin("x", lines[end]) && occursin("y", lines[end])

    # Shared subexpressions are kept as SSA vars and referenced by %i
    ir = IRStructure{SymReal}()
    populate_ir!(ir, x^2 + sin(x^2))  # x^2 used twice → stays as %1
    shared_output = sprint(show, ir)
    shared_lines = split(shared_output, '\n'; keepempty = false)
    # At least two printed lines (shared node + root)
    @test length(shared_lines) >= 3
    # Some line contains a call with an SSA ref as argument
    @test any(l -> occursin(r"\(%\d+", l), shared_lines)

    # Symbolic-op calls (default_is_atomic OR operation isa BasicSymbolic) are
    # printed as a single unit; their internal dependencies are never assigned SSA
    # variables.  z(..) creates a dependent variable; z(t) is a print-leaf.
    ir = IRStructure{SymReal}()
    populate_ir!(ir, z + 2t)   # z = z(t) defined at top of file
    atomic_output = sprint(show, ir)
    # z(t) appears literally, not decomposed as z(%1) or z(%i)
    @test occursin("z(t)", atomic_output)
    @test !occursin("z(%", atomic_output)
    # t only appears inside the print-leaf z(t) and once in *(2,t); with
    # visible ref-count 1 it is inlined, so no standalone "%i = t" line exists.
    @test !occursin(r"%\d+ = t\b", atomic_output)

    # Color: %i identifiers are highlighted yellow (ANSI code 33)
    colored = sprint(show, ir; context = :color => true)
    @test occursin("\e[33m%", colored)
    # Plain output (no color context) must not contain escape codes
    @test !occursin('\e', atomic_output)
end

@testset "Edge/outneighbor ordering invariant" begin
    # Verify that outneighbors of each callable node agree with the invariant:
    # - For a non-symbolic op:  outneighbors == [ir[arg] for arg in arguments(expr)]
    # - For a symbolic op:       outneighbors == [ir[op], ir[arg1], ir[arg2], ...]
    function check_edge_ordering_invariant(ir::IRStructure{T}) where {T}
        g = ir.dependency_graph
        for i in eachindex(ir)
            sym = ir[i]
            iscall(sym) || continue
            nbors = collect(Graphs.outneighbors(g, i))
            op = operation(sym)
            expected = Int32[]
            if op isa BasicSymbolic{T}
                push!(expected, ir.definition[op])
            end
            for arg in arguments(sym)
                arg isa BasicSymbolic{T} || continue
                push!(expected, ir.definition[arg])
            end
            @test nbors == expected
        end
    end

    @testset "Non-symbolic operation" begin
        ir = IRStructure{SymReal}()
        populate_ir!(ir, sin(x + y))
        check_edge_ordering_invariant(ir)
    end

    @testset "Symbolic operation prefixes arguments" begin
        @syms ordtest_fn(..)
        ir = IRStructure{SymReal}()
        expr = ordtest_fn(x, y)
        @test operation(expr) isa BasicSymbolic{SymReal}
        populate_ir!(ir, expr)
        check_edge_ordering_invariant(ir)
        # The symbolic op must be the first outneighbor after sorting
        idx = ir[expr]
        nbors = collect(Graphs.outneighbors(ir.dependency_graph, idx))
        @test nbors[1] == ir.definition[operation(expr)]
    end

    @testset "Complex expression" begin
        ir = IRStructure{SymReal}()
        # z = z(t) so operation(z) isa BasicSymbolic{SymReal}; exercises the symbolic-op path
        populate_ir!(ir, x + 2y + 3sin(z + fn(w[1] + sum(w) * tanh(w'w))))
        check_edge_ordering_invariant(ir)
    end

    @testset "After replace_node! (non-symbolic op)" begin
        ir = IRStructure{SymReal}()
        populate_ir!(ir, x + y)
        idx = ir[x + y]
        replace_node!(ir, x + y, x * y)
        check_edge_ordering_invariant(ir)
    end

    @testset "array_literal with duplicated arguments" begin
        # Const{T}([x, y, x]) creates an array_literal Term whose argument list is
        # [Const((3,)), x, y, x].  Because x appears twice, the dependency graph
        # must have two edges from the array_literal node to ir[x] (multi-edges).
        arr = SU.Const{SymReal}([x, y, x])
        @test operation(arr) === SymbolicUtils.array_literal
        ir = IRStructure{SymReal}()
        populate_ir!(ir, arr)
        check_edge_ordering_invariant(ir)
        arr_idx = ir[arr]
        nbors = collect(Graphs.outneighbors(ir.dependency_graph, arr_idx))
        x_idx = ir.definition[x]
        # x must appear at position 2 and 4 of outneighbors (after the size Const)
        @test count(==(x_idx), nbors) == 2
        @test nbors[2] == x_idx
        @test nbors[4] == x_idx
    end

    @testset "After replace_node! (symbolic op)" begin
        @syms ordtest_replace_fn(..)
        ir = IRStructure{SymReal}()
        populate_ir!(ir, x + y)
        idx = ir[x + y]
        replace_node!(ir, x + y, ordtest_replace_fn(x, y))
        check_edge_ordering_invariant(ir)
        nbors = collect(Graphs.outneighbors(ir.dependency_graph, idx))
        @test nbors[1] == ir.definition[ordtest_replace_fn]
    end
end

@testset "`replace_node!`" begin
    @testset "Leaf replacement" begin
        # Replacing a leaf: edges unchanged (early return after symbol update)
        ir = IRStructure{SymReal}()
        populate_ir!(ir, sin(x))
        x_idx = ir[x]
        n_before = length(ir)

        replace_node!(ir, x, y)

        @test isequal(ir[x_idx], y)
        @test length(ir) == n_before          # no new node created
        @test !haskey(ir.definition, x)       # old removed from definition
        @test ir.definition[y] == x_idx
        @test x_idx in ir.weak_definitions[y] # new registered at same index
        @test !isempty(ir.non_canonical_idxs)
        # leaf had no outgoing edges; they are still absent
        @test isempty(Graphs.outneighbors(ir.dependency_graph, x_idx))
    end

    @testset "Callable → callable, non-symbolic op" begin
        ir = IRStructure{SymReal}()
        populate_ir!(ir, x + y)
        idx    = ir[x + y]
        n_before = length(ir)

        replace_node!(ir, x + y, x * y)

        @test isequal(ir[idx], x * y)
        @test length(ir) == n_before          # no new node for the expression itself
        @test !haskey(ir.definition, x + y)
        @test ir.definition[x * y] == idx
        @test idx in ir.weak_definitions[x * y]
        # Nothing depends on `idx`, so the IR is still canonical
        @test isempty(ir.non_canonical_idxs)
        # outneighbors now match x*y's arguments in argument order
        nbors    = collect(Graphs.outneighbors(ir.dependency_graph, idx))
        expected = [ir.definition[arg] for arg in arguments(x * y)
                    if arg isa BasicSymbolic{SymReal}]
        @test nbors == expected
    end

    @testset "Callable → callable, symbolic op" begin
        @syms rn_symfn(..)
        ir = IRStructure{SymReal}()
        populate_ir!(ir, x + y)
        idx = ir[x + y]

        replace_node!(ir, x + y, rn_symfn(x, y))

        @test isequal(ir[idx], rn_symfn(x, y))
        @test !haskey(ir.definition, x + y)
        @test ir.definition[rn_symfn(x, y)] == idx
        @test isempty(ir.non_canonical_idxs)
        # symbolic op must be first outneighbor, then args in order
        nbors = collect(Graphs.outneighbors(ir.dependency_graph, idx))
        @test nbors[1] == ir.definition[rn_symfn]
        @test nbors[2] == ir.definition[x]
        @test nbors[3] == ir.definition[y]
    end

    @testset "Missing arguments are added to IR" begin
        ir = IRStructure{SymReal}()
        populate_ir!(ir, x + y)          # IR contains x, y, x+y; t absent
        @test !haskey(ir.definition, t)
        n_before = length(ir)

        replace_node!(ir, x + y, x + t)

        @test haskey(ir.definition, t)   # t was inserted by populate_ir! inside replace_node!
        @test length(ir) == n_before + 1
    end

    @testset "old weak_definitions entry is pruned" begin
        ir = IRStructure{SymReal}()
        populate_ir!(ir, x + y)
        idx = ir[x + y]
        @test idx in ir.weak_definitions[x + y]

        replace_node!(ir, x + y, x * y)

        old_defs = get(ir.weak_definitions, x + y, Int32[])
        @test !(idx in old_defs)
    end

    @testset "Old outgoing edges are removed" begin
        ir = IRStructure{SymReal}()
        populate_ir!(ir, x + y)
        idx   = ir[x + y]
        x_idx = ir[x]
        y_idx = ir[y]
        # Before: idx → x_idx and idx → y_idx
        @test x_idx in Graphs.outneighbors(ir.dependency_graph, idx)
        @test y_idx in Graphs.outneighbors(ir.dependency_graph, idx)

        replace_node!(ir, x + y, sin(x))   # different arg set

        nbors = collect(Graphs.outneighbors(ir.dependency_graph, idx))
        @test !(y_idx in nbors)             # y is no longer a dependency
        @test x_idx in nbors               # x is still used
    end
end

@testset "`get_canonical_expr!`" begin
    @testset "Canonical IR: returns ir[idx] directly" begin
        ir = IRStructure{SymReal}()
        expr = x + sin(y)
        populate_ir!(ir, expr)
        @test isempty(ir.non_canonical_idxs)
        idx = ir[expr]
        @test SU.get_canonical_expr!(ir, idx) === ir[idx]
    end

    @testset "Non-canonical, unaffected subtree: returns same object" begin
        ir = IRStructure{SymReal}()
        populate_ir!(ir, sin(x))
        populate_ir!(ir, cos(y))
        sin_idx = ir[sin(x)]
        replace_node!(ir, y, x)   # affects cos(y) only, not sin(x)
        @test !isempty(ir.non_canonical_idxs)
        @test SU.get_canonical_expr!(ir, sin_idx) === ir[sin_idx]
    end

    @testset "After leaf replacement: parent argument updated" begin
        ir = IRStructure{SymReal}()
        populate_ir!(ir, sin(x))
        sin_idx = ir[sin(x)]
        replace_node!(ir, x, y)
        @test !isempty(ir.non_canonical_idxs)
        @test isequal(SU.get_canonical_expr!(ir, sin_idx), sin(y))
    end

    @testset "After callable replacement: grandparent updated" begin
        ir = IRStructure{SymReal}()
        populate_ir!(ir, cos(x + y))
        cos_idx = ir[cos(x + y)]
        replace_node!(ir, x + y, x * y)
        @test !isempty(ir.non_canonical_idxs)
        @test isequal(SU.get_canonical_expr!(ir, cos_idx), cos(x * y))
    end

    @testset "Symbolic operation: arg replaced (n_drop=1 path)" begin
        # fn is a symbolic function; operation(fn(x)) isa BasicSymbolic, so the op
        # node is the first outneighbor and must be skipped when iterating args.
        ir = IRStructure{SymReal}()
        populate_ir!(ir, fn(x))
        fn_x_idx = ir[fn(x)]
        replace_node!(ir, x, y)
        @test !isempty(ir.non_canonical_idxs)
        @test isequal(SU.get_canonical_expr!(ir, fn_x_idx), fn(y))
    end
end

@testset "`IRSubstituter`" begin
    expr = x + 2y + 3sin(z + fn(w[1] + sum(w) * tanh(w'w)))
    ir = IRStructure{SymReal}()
    populate_ir!(ir, expr)

    rules = Dict(w => SU.Const{SymReal}(ones(3)))
    irsub = IRSubstituter{false}(ir, rules)
    sub = SU.Substituter{false}(rules)
    @test isequal(irsub(expr), sub(expr))

    ir = IRStructure{SymReal}()
    populate_ir!(ir, expr)

    rules = Dict(w => SU.Const{SymReal}(ones(3)))
    irsub = IRSubstituter{true}(ir, rules)
    sub = SU.Substituter{true}(rules)
    @test isequal(irsub(expr), sub(expr))

    @testset "On dependent variables" begin
        @syms t foo(..)
        foo = foo(t) # `foo` is now a dependent variable
        irsub = IRSubstituter{false}(ir, Dict(foo => 2t + 1))
        @test isequal(irsub(foo), 2t+1)
    end

    @testset "On symbolic functions" begin
        @syms foo(t)
        irsub = IRSubstituter{false}(ir, Dict(foo => SU.Const{SymReal}(sin)))
        @test isequal(irsub(foo(t + 1)), sin(t + 1))
    end
end

# Helper: build an IRStructure for `expr` with the ordering invariant intentionally
# violated. Expressions are added in reverse of the natural postorder (roots first),
# so parents end up at lower indices than their children.
function make_reversed_ir(T, root_expr::BasicSymbolic)
    ir_normal = IRStructure{T}()
    populate_ir!(ir_normal, root_expr)
    n = length(ir_normal)

    dep_graph = SymbolicUtils.OrderedDiGraph{Int32}(n)
    reversed_symbols = reverse(ir_normal.symbols)  # root at index 1, leaves at end
    reversed_def = IdDict{BasicSymbolic{T}, Int32}()
    for (i, sym) in enumerate(reversed_symbols)
        reversed_def[sym] = i
    end
    for (i, sym) in enumerate(reversed_symbols)
        if iscall(sym)
            for arg in arguments(sym)
                arg isa BasicSymbolic{T} || continue
                haskey(reversed_def, arg) || continue
                Graphs.add_edge!(dep_graph, i, reversed_def[arg])
            end
            op = operation(sym)
            if op isa BasicSymbolic{T} && haskey(reversed_def, op)
                Graphs.add_edge!(dep_graph, i, reversed_def[op])
            end
        end
    end
    IRStructure{T}(dep_graph, reversed_symbols, reversed_def, Dict{BasicSymbolic{T}, Vector{Int32}}(), BitVector(), Int32[], BitSet())
end

@testset "Out-of-order IRStructure" begin
    # Use a simple expression so the reversed layout is easy to reason about.
    # x + y: normal layout x=1,y=2,x+y=3; reversed: x+y=1,y=2,x=3.
    expr = x + y
    ir = make_reversed_ir(SymReal, expr)

    # Verify the invariant is intentionally violated
    @test ir[expr] < ir[x]
    @test ir[expr] < ir[y]

    # get_reachability returns indices of x and y (in some topological order)
    reach = get_reachability(ir, ir[expr])
    @test Set(reach) == Set([ir[x], ir[y]])

    # search_variables! finds both variables
    buffer = Set{BasicSymbolic{SymReal}}()
    SU.search_variables!(buffer, ir, expr)
    @test x in buffer
    @test y in buffer

    # query detects x but not an unrelated symbol
    @test SU.query(isequal(x), ir, expr)
    @test !SU.query(isequal(z), ir, expr)

    # show / print_ir produce valid output without errors
    ir_output = sprint(show, ir)
    @test occursin(r"IRStructure with \d+ node", ir_output)
    @test occursin(r"%\d+ = ", ir_output)

    # subset_ir extracts the full sub-expression correctly
    ir_sub = subset_ir(ir, [expr])
    @test length(ir_sub) == 3  # x, y, x+y

    # IRSubstituter applies substitution correctly on out-of-order IR
    rules = Dict{BasicSymbolic{SymReal}, BasicSymbolic{SymReal}}(x => 2y)
    irsub = IRSubstituter{false}(ir, rules)
    sub = SU.Substituter{false}(rules)
    @test isequal(irsub(expr), sub(expr))
end

@testset "`IRSubstituter` doesn't process filtered subtrees" begin
    # It used to still give the correct result, but processed (and thus cached)
    # subtrees which are filtered out.
    @syms x y
    filterer = x -> iscall(x) && operation(x) !== sin
    expr = sin(x) + cos(y)
    ir = IRStructure{SymReal}()
    subber = IRSubstituter{false}(ir, Dict(y => x); filterer)
    res = subber(expr)
    @test isequal(res, sin(x) + cos(x))
    x_idx = ir[x]
    @test !haskey(subber.cache, x_idx)
end

@testset "Calling `replace_node!` when `new` already exists in `IRStructure`" begin
    @syms x y z
    ir = IRStructure{SymReal}()
    xidx = populate_ir!(ir, x)
    yidx = populate_ir!(ir, y)
    zidx = populate_ir!(ir, z)
    replace_node!(ir, x, y)
    @test !haskey(ir, x)
    @test isequal(ir[xidx], y)
    @test ir[xidx] !== y # different metadata
    @test ir[ir[xidx]] == xidx
    @test ir[ir[yidx]] == yidx
    replace_node!(ir, z, y)
    @test !haskey(ir, z)
    @test isequal(ir[zidx], y)
    @test ir[zidx] !== y # different metadata
    @test ir[ir[zidx]] == zidx
    @test ir[ir[yidx]] == yidx

    @testset "`isconst(new)`" begin
        @syms x y z
        ir = IRStructure{SymReal}()
        xidx = populate_ir!(ir, x)
        yidx = populate_ir!(ir, y)
        zidx = populate_ir!(ir, z)
        r = SymbolicUtils.Const{SymReal}(0)
        replace_node!(ir, x, r)
        replace_node!(ir, y, r)
        @test operation(ir[yidx]) === identity
    end
end

@testset "`replace_node!` replacing `!iscall(old)` with `iscall(new)`" begin
    @syms x
    ir = IRStructure{SymReal}()
    xidx = populate_ir!(ir, x)
    @test length(ir) == 1
    replace_node!(ir, x, sin(x))
    @test length(ir) == 2
    @test ir[x] != xidx
    @test isequal(ir[xidx], sin(x))
    @test collect(Graphs.outneighbors(ir.dependency_graph, xidx)) == [ir[x]]
end

@testset "Issue#981: `get_canonical_expr!` folding in `maketerm` resulting in different arguments" begin
    @syms a::Real b::Real a2::Real
    a = SU.unwrap(a); b = SU.unwrap(b); a2 = SU.unwrap(a2)

    # An *unfolded* multiplication node  M = (-1) * (a / b)
    # (raw `Term` ctor so it is not eagerly folded into a Div).
    M = SU.Term{SymReal}(*, Any[SU.Const{SymReal}(-1), a / b]; type = Real)

    ir  = IRStructure{SymReal}()
    idx = populate_ir!(ir, M)

    # Break canonical form (`a` is a descendant of M via a/b), then canonicalize.
    replace_node!(ir, a, a2)
    SU.get_canonical_expr!(ir, idx)

    node  = ir[idx]
    args  = collect(arguments(node))
    edges = [ir[j] for j in Graphs.outneighbors(ir.dependency_graph, idx)]
    @test isequal(args, edges)
    expr1 = SU.Code.fast_toexpr(ir[idx], ir, Dict{Any,Any}())
    Base.remove_linenums!(expr1)
    expr2 = SU.Code.fast_toexpr((-1)*(a2/b), Dict{Any,Any}())
    Base.remove_linenums!(expr2)
    @test isequal(repr(expr1), repr(expr2))
end

@testset "`IRSubstituter` doesn't cache filtered expressions" begin
    @syms t::Real a::Real b(..)::Real
    expr = a + b(t)
    @test !SU.default_substitute_filter(b(t))
    rules = Dict{typeof(a), typeof(a)}(a => 2a)
    ir = IRStructure{SymReal}()
    subber = IRSubstituter{false}(ir, rules)
    subber(expr)
    @test !haskey(subber.cache, ir[b(t)])
    subber(t)
    @test !haskey(subber.cache, ir[t])
end

@testset "`replace_edge!`" begin
    @testset "Basic single-edge replacement" begin
        # sin(x): sin_idx → x_idx; replace with sin_idx → y_idx
        ir = IRStructure{SymReal}()
        populate_ir!(ir, sin(x))
        sin_idx = ir[sin(x)]
        x_idx   = ir[x]
        y_idx   = populate_ir!(ir, y)
        g = ir.dependency_graph

        @test collect(Graphs.outneighbors(g, sin_idx)) == [x_idx]
        @test isempty(ir.non_canonical_idxs)

        replace_edge!(ir, sin_idx, x_idx, y_idx)

        @test collect(Graphs.outneighbors(g, sin_idx)) == [y_idx]
        @test sin_idx in ir.non_canonical_idxs
    end

    @testset "Only matching edges are replaced, others preserved" begin
        # x + y: plus_idx → [x_idx, y_idx]; replace x_idx with z_idx
        ir = IRStructure{SymReal}()
        populate_ir!(ir, x + y)
        plus_idx = ir[x + y]
        x_idx    = ir[x]
        y_idx    = ir[y]
        z_idx    = populate_ir!(ir, z)
        g = ir.dependency_graph

        replace_edge!(ir, plus_idx, x_idx, z_idx)

        nbors = collect(Graphs.outneighbors(g, plus_idx))
        @test z_idx in nbors          # old x_idx replaced by z_idx
        @test y_idx in nbors          # y edge untouched
        @test !(x_idx in nbors)       # original x edge removed
        @test length(nbors) == 2      # edge count preserved
    end

    @testset "Multiple identical edges: all replaced" begin
        # Build a Term with x appearing twice as an argument, producing two edges to x_idx.
        @syms arr_x::Real arr_y::Real arr_z::Real
        arr_x = SU.unwrap(arr_x); arr_y = SU.unwrap(arr_y); arr_z = SU.unwrap(arr_z)
        # Term{SymReal}(+, [arr_x, arr_x]) creates x+x unfolded (two edges to arr_x)
        dup_expr = SU.Term{SymReal}(+, Any[arr_x, arr_x]; type = Real)
        ir = IRStructure{SymReal}()
        populate_ir!(ir, dup_expr)
        dup_idx = ir[dup_expr]
        x_idx   = ir[arr_x]
        z_idx   = populate_ir!(ir, arr_z)
        g = ir.dependency_graph

        # Confirm two edges to arr_x exist before replacement
        nbors_before = collect(Graphs.outneighbors(g, dup_idx))
        @test count(==(x_idx), nbors_before) == 2

        replace_edge!(ir, dup_idx, x_idx, z_idx)

        nbors_after = collect(Graphs.outneighbors(g, dup_idx))
        @test count(==(z_idx), nbors_after) == 2   # both edges now point to z
        @test !(x_idx in nbors_after)               # no residual edge to x
        @test length(nbors_after) == 2              # edge count preserved
        @test dup_idx in ir.non_canonical_idxs
    end

    @testset "get_canonical_expr! after replace_edge!" begin
        # After redirecting an edge, get_canonical_expr! should reflect the new arg.
        ir = IRStructure{SymReal}()
        populate_ir!(ir, sin(x))
        sin_idx = ir[sin(x)]
        x_idx   = ir[x]
        y_idx   = populate_ir!(ir, y)

        replace_edge!(ir, sin_idx, x_idx, y_idx)

        @test isequal(SU.get_canonical_expr!(ir, sin_idx), sin(y))
        # IR should be canonical again after the call
        @test isempty(ir.non_canonical_idxs)
    end

    @testset "old_dst == new_dst is a pure no-op" begin
        # When old_dst === new_dst the function returns immediately — edges and
        # non_canonical_idxs are both unchanged.
        ir = IRStructure{SymReal}()
        populate_ir!(ir, x + y)
        plus_idx = ir[x + y]
        x_idx    = ir[x]
        g = ir.dependency_graph
        nbors_before = collect(Graphs.outneighbors(g, plus_idx))

        replace_edge!(ir, plus_idx, x_idx, x_idx)

        @test collect(Graphs.outneighbors(g, plus_idx)) == nbors_before
        @test isempty(ir.non_canonical_idxs)
    end

    @testset "no edge to old_dst is a pure no-op" begin
        # When src has no edge to old_dst the function returns without mutating anything.
        ir = IRStructure{SymReal}()
        populate_ir!(ir, sin(x))
        sin_idx = ir[sin(x)]
        x_idx   = ir[x]
        y_idx   = populate_ir!(ir, y)   # y is in the IR but not a neighbor of sin
        g = ir.dependency_graph
        nbors_before = collect(Graphs.outneighbors(g, sin_idx))

        replace_edge!(ir, sin_idx, y_idx, x_idx)   # y_idx not an outneighbor of sin_idx

        @test collect(Graphs.outneighbors(g, sin_idx)) == nbors_before
        @test isempty(ir.non_canonical_idxs)
    end
end

@testset "`IRSubstituter` does constant folding even if no rules apply" begin
    expr = SU.Term{SymReal}(+, [SU.Term{SymReal}(sin, [1.0]; type = Real, shape = UnitRange{Int}[]), 2.0]; type = Real, shape = UnitRange{Int}[])
    ir = IRStructure{SymReal}()
    subber = IRSubstituter{true}(ir, Dict{typeof(expr), typeof(expr)}())
    @test unwrap_const(subber(expr))::Float64 ≈ (2.0 + sin(1.0))
end

using Test, SymbolicUtils
using NaNMath
using SymbolicUtils.Code
using SymbolicUtils.Code: LazyState
using StaticArrays
using LabelledArrays
using SparseArrays
using ReverseDiff
using LinearAlgebra
using SymbolicUtils: Const

test_repr(a, b) = @test repr(Base.remove_linenums!(a)) == repr(Base.remove_linenums!(b))
nanmath_st = Code.NameState()
nanmath_st.rewrites[:nanmath] = true

@testset "public array-construction extension point" begin
    if isdefined(Base, :ispublic)
        @test Base.ispublic(SymbolicUtils.Code, :create_array)
    end
    @test @doc(SymbolicUtils.Code.create_array) !== nothing
end

@testset "Code" begin
    @syms a b c d e p q t x(t) y(t) z(t)
    @test toexpr(Assignment(a, b)) == :(a = b)
    @test toexpr(a ← b) == :(a = b)
    @test toexpr(a+b) == :($(+)(a, b))
    @test toexpr(a*b*c*d*e) == :($(*)($(*)($(*)($(*)(a, b), c), d), e))
    @test toexpr(a+b+c+d+e) == :($(+)($(+)($(+)($(+)(a, b), c), d), e))
    @test toexpr(a+b) == :($(+)(a, b))
    newsym = eval(quote
        let x = $x, y = $y, t = $t
            $(toexpr(x(t)+y(t)))
        end
    end)
    @test operation(newsym) === (+) && issetequal(arguments(newsym), [x(t), y(t)])
    newsym = eval(quote
        let x = $x, y = $y, t = $t
            $(toexpr(x(t)+y(t)+x(t+1)))
        end
    end)
    @test operation(newsym) === (+) && issetequal(arguments(newsym), [x(t), y(t), x(1+t)])
    s = LazyState()
    Code.union_rewrites!(s.rewrites, [x(t), y(t)])
    newsym = eval(quote
        let var"x(t)" = $(x(t)), x = $x, var"y(t)" = $(y(t)), t = $t
            $(toexpr(x(t)+y(t)+x(t+1), s))
        end
    end)
    @test operation(newsym) === (+) && issetequal(arguments(newsym), [x(t), x(1+t), y(t)])

    ex = :(let a = 3, b = $(+)(1,a)
               $(+)(a, b)
           end)

    test_repr(toexpr(Let([a ← 3, b ← 1+a], a + b)), ex)

    test_repr(toexpr(Func([],[], a+b)) |>Base.remove_linenums!, :(function ()
            $(+)(a, b)
        end))

    newf = eval(toexpr(Func([x(t), x, a, t],[b ← a+2, y(t) ← b], x(t)+x(t+1)+b+y(t))))
    newsym = newf(x(t), x, a, t; var"y(t)" = y(t))
    @test operation(newsym) === (+) && issetequal(arguments(newsym), [x(t), x(1+t), a, y(t), Const{SymReal}(2)])

    fexpr1 = toexpr(Func([DestructuredArgs([x, x(t), t], :state),
                           DestructuredArgs((a, b), :params)], [],
                          x(t+1) + x(t) + a  + b))
    newf = eval(fexpr1)
    newsym = newf([x, x(t), t], [a, b])
    @test operation(newsym) === (+) && issetequal(arguments(newsym), [x(t+1), x(t), a, b])

    fexpr2 = toexpr(Func([DestructuredArgs([x, x(t), t], :state, create_bindings=false),
                           DestructuredArgs((a, b), :params, create_bindings=false)], [],
                          x(t+1) + x(t) + a  + b))
    newf = eval(fexpr2)
    newsym = newf([x, x(t), t], [a, b])
    @test operation(newsym) === (+) && issetequal(arguments(newsym), [x(t+1), x(t), a, b])
    @test fexpr1 != fexpr2

    fexpr = toexpr(Func([],[],:(rand()), [Expr(:meta, :inline)]))
    @test any(isequal(Expr(:meta, :inline)), fexpr.args[2].args)

    ex = toexpr(Func([DestructuredArgs([x, x(t)], :state, inbounds=true)], [], x(t+1) + x(t)))
    ex = Base.remove_linenums!(ex)
    for e ∈ ex.args[2].args[1].args[1:2]
        @test e.args[2].head == :macrocall
    end

    test_repr(toexpr(SetArray(false, a, [x(t), AtIndex(9, b), c])),
              quote
                  a[1] = x(t)
                  a[9] = b
                  a[3] = c
                  nothing
              end)
    @test toexpr(SetArray(true, a, [x(t), AtIndex(9, b), c])).head == :macrocall

    for fname in (:sin, :cos, :tan, :asin, :acos, :acosh, :atanh, :log, :log2, :log10, :log1p, :sqrt)
        f = getproperty(Base, fname)
        @test toexpr(f(a)) == :($f(a))
        @test toexpr(f(a), nanmath_st) == :($(GlobalRef(NaNMath, fname))(a))

        nanmath_f = getproperty(NaNMath, fname)
        @test toexpr(nanmath_f(a)) == :($nanmath_f(a))
        @test toexpr(nanmath_f(a), nanmath_st) == :($nanmath_f(a))
    end

    @test toexpr(a^b) == :($(^)(a, b))
    @test toexpr(a^b, nanmath_st) == :($(NaNMath.pow)(a, b))
    @test toexpr(NaNMath.pow(a, b)) == :($(NaNMath.pow)(a, b))
    @test toexpr(NaNMath.pow(a, b), nanmath_st) == :($(NaNMath.pow)(a, b))

    @test toexpr(a^2) == :($(^)(a, 2))
    @test toexpr(a^2, nanmath_st) == :($(^)(a, 2))
    @test toexpr(NaNMath.pow(a, 2)) == :($(^)(a, 2))
    @test toexpr(NaNMath.pow(a, 2), nanmath_st) == :($(^)(a, 2))

    @test toexpr(a^-1) == :($(/)(1, a))
    @test toexpr(a^-1, nanmath_st) == :($(/)(1, a))
    @test toexpr(NaNMath.pow(a, -1)) == :($(/)(1, a))
    @test toexpr(NaNMath.pow(a, -1), nanmath_st) == :($(/)(1, a))

    @test toexpr(a^-2) == :($(/)(1, $(^)(a, 2)))
    @test toexpr(a^-2, nanmath_st) == :($(/)(1, $(^)(a, 2)))
    @test toexpr(NaNMath.pow(a, -2)) == :($(/)(1, $(^)(a, 2)))
    @test toexpr(NaNMath.pow(a, -2), nanmath_st) == :($(/)(1, $(^)(a, 2)))

    f = GlobalRef(NaNMath, :sin)
    test_repr(toexpr(LiteralExpr(:(let x=1, y=2
                                       $(sin(a+b))
                                   end)), nanmath_st),
              :(let x = 1, y = 2
                    $(f)($(+)(a, b))
                end))
    test_repr(toexpr(LiteralExpr(:(let x=1, y=2
                                       $(sin(a+b))
                                   end))),
              :(let x = 1, y = 2
                    $(sin)($(+)(a, b))
                end))

    test_repr(toexpr(MakeArray([a,b,a+b], :arr)),
              quote
                  $(SymbolicUtils.Code.create_array)(typeof(arr), nothing, Val{1}(), Val{(3,)}(), a, b, $(+)(a, b))
              end)

    toexpr(Let([a ← 1, b ← 2, :arr ← [1,2]],
               MakeArray([a,b,a+b,a/b], :arr)))

    test_repr(toexpr(Let([DestructuredArgs([x(t),b,c], :foo) ← [3,3,[1,4]],
                          DestructuredArgs([p,q], c)],
                         x(t)+a+b+c)),
              :(let foo = Any[3, 3, [1, 4]],
                    var"x(t)" = foo[1], b = foo[2], c = foo[3],
                    p = c[1], q = c[2]
                    $(+)($(+)($(+)(a, b), c), var"x(t)")
                end))

    test_repr(toexpr(Func([DestructuredArgs([a,b],c,inds=[:a, :b])], [],
                          a + b)),
              :(function (c,)
                    begin
                        a = c.a
                        b = c.b
                        $(+)(a, b)
                    end
                end))
    @syms arr

    @test eval(toexpr(Let([a ← 1, b ← 2, arr ← [1,2]],
                          MakeArray([a,b,a+b,a/b], arr)))) == [1, 2, 3, 1/2]

    @test eval(toexpr(Let([a ← 1, b ← 2, arr ← [1,2]],
                          MakeArray(view([a,b,a+b,a/b], :), arr)))) == [1, 2, 3, 1/2]

    @test eval(toexpr(Let([a ← 1, b ← 2, arr ← [1,2]],
                          MakeArray(PermutedDimsArray([a b;a+b a/b], (1,2)), arr)))) == [1 2 ; 3  1/2]

    @test eval(toexpr(Let([a ← 1, b ← 2, arr ← [1,2]],
                          MakeArray(transpose([a b;a+b a/b]), arr)))) == [1 3;2 1/2]

    @test eval(toexpr(Let([a ← 1, b ← 2, arr ← [1,2]],
                          MakeArray(UpperTriangular([a b;a+b a/b]), arr)))) == [1 2;0 1/2]

    @test eval(toexpr(Let([a ← 1, b ← 2, arr ← [1,2]],
                          MakeArray([a b;a+b a/b], arr)))) == [1 2; 3 1/2]

    @test eval(toexpr(Let([a ← 1, b ← 2, arr ← @SVector([1,2])],
                          MakeArray([a,b,a+b,a/b], arr)))) === @SVector [1, 2, 3, 1/2]

    @test eval(toexpr(Let([a ← 1, b ← 2, arr ← @SVector([1,2])],
                          MakeArray([a b;a+b a/b], arr)))) === @SMatrix [1 2; 3 1/2]

    @test eval(toexpr(Let([a ← 1, b ← 2, arr ← @SLVector((:a, :b))(@SVector[1,2])],
                          MakeArray([a+b,a/b], arr)))) === @SLVector((:a, :b))(@SVector [3, 1/2])

    trackedarr = eval(toexpr(Let([a ← ReverseDiff.track(1.0), b ← 2, arr ← ReverseDiff.track(ones(2))],
                          MakeArray([a+b,a/b], arr))))
    @test trackedarr isa ReverseDiff.TrackedArray
    @test trackedarr == [3, 1/2]

    trackedarr = eval(toexpr(Let([a ← ReverseDiff.track(1.0), b ← 2, arr ← ReverseDiff.track(ones(2))],
                          MakeArray([a b; a+b a/b], arr))))
    @test trackedarr isa ReverseDiff.TrackedArray
    @test trackedarr == [1 2; 3 1/2]


    R1 = eval(toexpr(Let([a ← 1, b ← 2, arr ← @MVector([1,2])],MakeArray([a,b,a+b,a/b], arr))))
    @test R1 == (@MVector [1, 2, 3, 1/2]) && R1 isa MVector

    R2 = eval(toexpr(Let([a ← 1, b ← 2, arr ← @MVector([1,2])],MakeArray([a b;a+b a/b], arr))))
    @test R2 == (@MArray [1 2; 3 1/2]) && R2 isa MMatrix

    mksp = MakeSparseArray(sparse([1,2,31,32,2],
                                  [1,2,31,32,2],
                                  [a, b, a+b, a/b, a-b+e]))
    reference = sparse([1,2,31,32],
                     [1,2,31,32],
                     [a, a+e, a+b, a/b])

    test_repr(mksp.array, reference)

    test_repr(toexpr(mksp),
              :(SparseMatrixCSC(32, 32,
                                $(reference.colptr),
                                $(reference.rowval),
                                [$(map(toexpr, reference.nzval)...)])))


    spvec = sparsevec([5], [a], 10)

    test_repr(toexpr(MakeSparseArray(spvec)),
              :(SparseVector(10, $(spvec.nzind), [a])))
    test_repr(toexpr(MakeTuple((a, b, a+b))),
              :((a,b,$(+)(a,b))))

    @test SpawnFetch{Multithreaded}([()->1,()->2],vcat)|>toexpr|>eval == [1,2]
    @test @elapsed(SpawnFetch{Multithreaded}([:(()->sleep(2)),
                                              Func([:x],
                                                   [],
                                                   :(sleep(x)))],
                                             [(),
                                              (2,)],
                                             vcat)|>toexpr|>eval) < 3

    let
        @syms a b

        f = eval(toexpr(Func([a+b], [], a+b)))
        @test @invokelatest(f(1)) == 1
        @test @invokelatest(f(2)) == 2

        f = eval(toexpr(Func([a, b], [], sqrt(a - b)), nanmath_st))
        @test isnan(@invokelatest f(0, 10))
        @test @invokelatest(f(10, 2)) ≈ sqrt(8)
    end

    let
        io = IOBuffer()
        twoπ = Base.Irrational{:twoπ}()
        for q ∈ Base.Irrational[Base.MathConstants.catalan, Base.MathConstants.γ, π, Base.MathConstants.φ, ℯ, twoπ]
            Base.show(io, q)
            s1 = String(take!(io))
            SymbolicUtils.show_term(io, SymbolicUtils.Term{SymReal}(identity, [q]))
            s2 = String(take!(io))
            @test s1 == s2
        end
    end

    let
        @syms a b

        t = term(sum, [a, b, a + b, 3a + 2b, sqrt(b)]; type = Number)
        f = eval(toexpr(Func([a, b], [], t)))
        @test @invokelatest(f(1.0, 2.0)) ≈ 13.0 + sqrt(2)
    end
end

@testset "Sparse array CSE" begin
    @syms x y z
    arr = [x^2 + y^2 0 0; 0 sin(y^2 + z^2) 0; 0 0 z^2 + x^2]
    sarr = sparse(arr);
    fn = eval(toexpr(Func([x, y, z], [], Code.cse(sarr))))

    expected = eval(toexpr(Let([x ← 1, y ← 2, z ← 3], sarr)))
    @test fn(1, 2, 3) ≈ expected
end

function foo(args...) end

SymbolicUtils.Code.cse_inside_expr(sym, ::typeof(foo), args...) = false

@testset "`cse_inside_expr`" begin
    @syms x y
    ex1 = (x^2 + y^2)
    exfoo = term(foo, ex1; type = Real)
    ex2 = ex1 + exfoo
    letblock = cse(ex2)
    ex3 = Code.rhs(last(letblock.pairs))
    @test any(isequal(exfoo), arguments(ex3))
end

@testset "CSE does not alias constants with function arguments" begin
    # When build_function is given argument arrays containing constants (e.g., zeros
    # from erased cache variables), CSE should not replace identical constants in the
    # expression body with references to those argument positions. This is a regression
    # test for https://github.com/JuliaSymbolics/Symbolics.jl/issues/1811.
    @syms x1 x2 x3 x4 x5 x6
    x_vars = [x1, x2, x3, x4, x5, x6]
    # A sparse diagonal jacobian-like expression
    ZERO = SymbolicUtils.Const{SymReal}(0)
    expr = fill(ZERO, 12, 6)
    for i in 1:6
        expr[i, i] = cos(x_vars[i])
        expr[i + 6, i] = -sin(x_vars[i])
    end
    # Second argument is all-zeros (simulating erased cache variables passed to build_function)
    zero_args = [SymbolicUtils.Const{SymReal}(0) for _ in 1:12]
    f_cse = eval(toexpr(Func([DestructuredArgs(x_vars, :arg1, inbounds = true, create_bindings = false),
                               DestructuredArgs(zero_args, :arg2, inbounds = true, create_bindings = false)],
                              [], Code.cse(MakeArray(expr, Array)))))
    # Call with non-zero values for arg2 to expose incorrect aliasing
    result = @invokelatest f_cse(collect(1.0:6.0), ones(12) * 99.0)
    @test result[1, 2] == 0.0  # off-diagonal should be 0, NOT 99.0
    @test result[2, 1] == 0.0
    @test result[1, 1] ≈ cos(1.0)
    @test result[2, 2] ≈ cos(2.0)
end

@testset "`AtIndex` with symbolic index" begin
    @syms a b c::Matrix{Int}
    ex = SetArray(false, c, [AtIndex(MakeArray([a, b], Array), [a + b, a - b])])
    expr = quote
        let a = 1, b = 2, c = zeros(Int, 3, 3)
            $(toexpr(ex))
            c
        end
    end
    arr = eval(expr)
    @test arr[1] == 3
    @test arr[2] == -1
    for i in 3:length(arr)
        @test arr[i] == 0
    end
end

@testset "`ForLoop`" begin
    @syms a b c::Vector{Int}
    ex = ForLoop(a, term(range, b^2, b^2 + 3), SetArray(false, c, [AtIndex(a, a + 1)]))
    expr = quote
        let b = 2, c = zeros(Int, 10)
            $(toexpr(ex))
            c
        end
    end
    arr = eval(expr)
    @test arr[4] == 5
    @test arr[5] == 6
    @test arr[6] == 7
    @test arr[7] == 8
    @test all(iszero, arr[1:3])
    @test all(iszero, arr[8:end])
end

@testset "`SetArray` with `return_arr`" begin
    @syms a b c::Vector{Int}
    ex = SetArray(false, c, [3, 2, 1], false)
    expr = quote
        let b = 2, c = zeros(Int, 3)
            $(toexpr(ex))
        end
    end
    @test eval(expr) === nothing
    ex = SetArray(false, c, [3, 2, 1], true)
    expr = quote
        let b = 2, c = zeros(Int, 3)
            $(toexpr(ex))
        end
    end
    @test eval(expr) == [3, 2, 1]
end

@testset "`create_array` creating single-element SArray of SArray" begin
    val = Code.create_array(SArray, nothing, Val(1), Val((1,)), Code.create_array(SArray, nothing, Val(1), Val((1,)), 1.0))
    @test val == SA[SA[1.0]]
end

@testset "`cse` retains shape information" begin
    @syms x[1:3, 1:3] y[1:3, 1:3]
    ex = (x*y)^2 + (x*y)^3
    block = cse(ex)
    @test SymbolicUtils.shape(block.pairs[1].lhs) == [1:3, 1:3]
end

@testset "`with_allocator`" begin
    @testset "`array_literal`" begin
        @syms x y z
        arr = SymbolicUtils.Const{SymReal}([x, y + 2x^2 + sin(z), 2z + 1])
        wrapped = Code.with_allocator(ones, arr)
        @test isequal(collect(arr), collect(wrapped))
        test_repr(
            toexpr(wrapped), quote
                __array_literal_allocator = ones
                __array_literal_result = __array_literal_allocator((3,))
                $(setindex!)(__array_literal_result, x, 1)
                $(setindex!)(__array_literal_result, $(+)($(+)($(sin)(z), y), $(*)(2, $(^)(x, 2))), 2)
                $(setindex!)(__array_literal_result, $(+)(1, $(*)(2, z)), 3)
                __array_literal_result
            end
        )

        reference = eval(
            quote
                let x = 1, y = 2, z = 3
                    $(toexpr(arr))
                end
            end
        )
        value = eval(
            quote
                let x = 1, y = 2, z = 3
                    $(toexpr(wrapped))
                end
            end
        )
        @test isequal(reference, value)

        value = eval(
            quote
                let x = 1, y = 2, z = 3
                    $(toexpr(Code.cse(wrapped)))
                end
            end
        )
        @test isequal(reference, value)
    end

    @testset "`@arrayop`" begin
        @syms x[1:3] y[1:3]
        arr = @arrayop (i,) x[i] * y[i]
        wrapped = Code.with_allocator(ones, arr)
        @test isequal(collect(arr), collect(wrapped))
        test_repr(
            toexpr(wrapped), (
                quote
                    let _out = $(ones)((3,))
                        var"%_out" = for _1 in 1:1:3
                            begin
                                _out[$(CartesianIndex)(_1)] = $(+)($(getindex)(_out, _1), $(*)($(getindex)(x, _1), $(getindex)(y, _1)))
                                nothing
                            end
                        end
                        _out
                    end
                end
            ).args[2]
        )
    end
end

@testset "`create_array` with `ReshapedArray`" begin
    v = rand(5)
    r = reshape(view(v, 1:4), 2, 2)
    @test r isa Base.ReshapedArray
    a = Code.create_array(typeof(r), nothing, Val(2), Val((2, 2)), r...)
    @test a isa Matrix{Float64}
end

module SymbolicUtilsChainRulesCoreExt

using ChainRulesCore
import ChainRulesCore: rrule
import SymbolicUtils.Code

function rrule(::typeof(Code.create_array), A::Type{<:AbstractArray}, T, u::Val{j}, d::Val{dims}, elems...) where {dims, j}
  y = Code.create_array(A, T, u, d, elems...)
  function create_array_pullback(Δ)
    dx = Δ
    (ZeroTangent(), NoTangent(), NoTangent(), NoTangent(), NoTangent(), dx..., ntuple(_ -> NoTangent(), length(elems) - prod(dims) + j)...)
  end
  y, create_array_pullback
end

end

module SymbolicUtilsReverseDiffExt

using ReverseDiff
using SymbolicUtils

@inline function SymbolicUtils.Code.create_array(::Type{<:ReverseDiff.TrackedArray}, T, v1::Val, v2::Val{dims}, elems...) where dims
    SymbolicUtils.ArrayInterface.aos_to_soa(SymbolicUtils.Code.create_array(Array, T, v1, v2, elems...))
end

end

pages = Any["index.md",
            "Manual" => Any["manual/variants.md",
                            "manual/rewrite.md",
                            "manual/interface.md",
                            "manual/codegen.md",
                            "manual/caching.md",
                            "manual/recursive_utils.md",
                            ],
            "api.md",
            "developer_api.md",
            "upgrade.md"
            ]

"""
    StackDict{K, V}

A dictionary that only allows inserting new keys (not updating existing ones).
Keys are tracked in insertion order. Deletion is only permitted for the most
recently inserted key (stack discipline).
"""
struct StackDict{K, V}
    dict::Dict{K, V}
    keys::Vector{K}
end

StackDict{K, V}() where {K, V} = StackDict{K, V}(Dict{K, V}(), Vector{K}())

Base.length(sd::StackDict) = length(sd.keys)
Base.isempty(sd::StackDict) = isempty(sd.keys)

# Returns the last inserted key.
Base.lastindex(sd::StackDict) = last(sd.keys)

function Base.insert!(sd::StackDict, key, value)
    @assert !haskey(sd.dict, key)
    sd.dict[key] = value
    push!(sd.keys, key)
    return sd
end

function Base.empty!(sd::StackDict)
    empty!(sd.dict)
    empty!(sd.keys)
    return sd
end

# Only the last inserted key may be deleted.
function Base.delete!(sd::StackDict, key)
    @assert !isempty(sd.keys) && last(sd.keys) == key
    pop!(sd.keys)
    delete!(sd.dict, key)
    return sd
end

Base.get(sd::StackDict, key, default) = get(sd.dict, key, default)

"""
    OrderedDiGraph{T<:Integer}

A directed graph where the forward adjacency list preserves edge insertion
order. Mirrors `Graphs.SimpleDiGraph` with two differences:
- `outneighbors(g, v)` returns neighbors in the order edges were inserted.
- `inneighbors(g, v)` returns an `AdjView` (unordered); membership tests are O(1).
- Multi-edges are supported: the same `(src, dst)` pair may appear more than
  once in `fadjlist`, each occurrence representing a distinct edge.

### Adjacency representation

Each entry of `fadjlist` is a `Union{NTuple{2,T}, Vector{T}}`:
- `NTuple{2,T}` for vertices with 0, 1, or 2 out-edges. `zero(T)` is a
  sentinel: `(0,0)` means 0 edges, `(dst,0)` means 1 edge, `(a,b)` (both
  non-zero) means 2 edges. Non-zero entries always occupy the front slots.
- `Vector{T}` once a vertex acquires a third out-edge.

Each entry of `badjlist` is a `Union{NTuple{2,T}, Set{T}}`:
- `NTuple{2,T}` for vertices with 0, 1, or 2 in-edges (same sentinel convention).
- `Set{T}` once a vertex acquires a third in-edge.
- Each source vertex is recorded **at most once**, regardless of how many
  parallel edges connect it to the destination.

For example, after inserting edges `2 => 3`, `1 => 3`, `1 => 2` in that order:
- `outneighbors(g, 1)` returns `[3, 2]`
- `inneighbors(g, 3)` returns a `Set` containing `{2, 1}` (order unspecified)
"""
mutable struct OrderedDiGraph{T <: Integer} <: Graphs.AbstractGraph{T}
    ne::Int
    fadjlist::Vector{Union{NTuple{2, T}, Vector{T}}}
    badjlist::Vector{Union{NTuple{2, T}, Set{T}}}

    function OrderedDiGraph{T}(
            ne::Int,
            fadjlist::Vector{Union{NTuple{2, T}, Vector{T}}},
            badjlist::Vector{Union{NTuple{2, T}, Set{T}}},
        ) where {T <: Integer}
        return new{T}(ne, fadjlist, badjlist)
    end
end

function OrderedDiGraph(
        ne::Int,
        fadjlist::Vector{Union{NTuple{2, T}, Vector{T}}},
        badjlist::Vector{Union{NTuple{2, T}, Set{T}}},
    ) where {T}
    return OrderedDiGraph{T}(ne, fadjlist, badjlist)
end

#
# Internal helpers for adjacency list entries.
# fadjlist entries are Union{NTuple{2,T}, Vector{T}}.
# badjlist entries are Union{NTuple{2,T}, Set{T}}.
#

# Effective length (number of real, non-sentinel neighbors).
@inline _flen(t::NTuple{2, T}) where {T} = iszero(t[1]) ? 0 : iszero(t[2]) ? 1 : 2
@inline _flen(v::Vector) = length(v)
@inline _flen(s::Set) = length(s)

# Indexed access into effective elements (assumes 1 <= i <= _flen(entry)).
# Only valid for NTuple and Vector (not Set, which is unordered).
@inline _fget(t::NTuple{2}, i::Int) = t[i]
@inline _fget(v::Vector, i::Int) = v[i]

# Membership test. Assumes x is a valid (non-zero) vertex index.
@inline _fin(t::NTuple{2, T}, x) where {T} = t[1] == x || t[2] == x
@inline _fin(v::Vector, x) = x in v
@inline _fin(s::Set, x) = x in s

# Remove s from badjlist[d]. Assumes the edge s→d exists.
@inline function _rem_badjlist_entry!(g::OrderedDiGraph{T}, d::T, s::T) where {T}
    @inbounds bentry = g.badjlist[d]
    if bentry isa Set{T}
        delete!(bentry, s)
    else
        a, b = bentry
        if iszero(b)
            @inbounds g.badjlist[d] = (zero(T), zero(T))
        else
            @inbounds g.badjlist[d] = a == s ? (b, zero(T)) : (a, zero(T))
        end
    end
end

#
# AdjView{T}: lightweight non-allocating view over an adjacency list entry.
# The entry field stores one of three concrete backing types:
#   NTuple{2,T} — 0–2 neighbors (small case, no heap allocation)
#   Vector{T}   — 3+ out-neighbors (fadjlist after transition)
#   Set{T}      — 3+ in-neighbors  (badjlist after transition)
#
# Storing the union inside the struct (rather than as a type parameter) means
# outneighbors and inneighbors both return the single concrete type AdjView{T},
# avoiding a Union return type at call sites.  Efficiency is recovered by
# manually union-splitting on entry type inside each method: isa checks let the
# compiler specialize each branch.  All three backing types use Int as their
# iteration state, so the inferred state type is concrete across all branches.
#

struct AdjView{T <: Integer}
    entry::Union{NTuple{2, T}, Vector{T}, Set{T}}
end

Base.empty(::AdjView{T}) where {T} = AdjView((zero(T), zero(T)))

Base.eltype(::Type{AdjView{T}}) where {T} = T

# length and membership dispatch through _flen / _fin (defined for all three).
@inline Base.length(v::AdjView) = _flen(v.entry)
@inline Base.in(x, v::AdjView) = _fin(v.entry, x)

# getindex: valid only for ordered backing (NTuple / Vector).
Base.@propagate_inbounds function Base.getindex(v::AdjView, i::Int)
    @boundscheck 1 <= i <= length(v)
    _fget(v.entry, i)
end

# --- iterate: manual union-split on entry type ---
# NTuple and Vector use sequential Int indices as state; Set uses its internal
# hash-table slot index, also an Int.  All branches share Int state so the
# inferred return type is Union{Nothing, Tuple{T, Int}} — no dynamic dispatch.

function Base.iterate(v::AdjView{T}) where {T}
    entry = v.entry
    if entry isa NTuple{2, T}
        _flen(entry) == 0 && return nothing
        return _fget(entry, 1)::T, 2
    elseif entry isa Vector{T}
        isempty(entry) && return nothing
        return @inbounds(entry[1])::T, 2
    else
        return iterate(entry::Set{T})
    end
end

function Base.iterate(v::AdjView{T}, state::Int) where {T}
    entry = v.entry
    if entry isa NTuple{2, T}
        state > _flen(entry) && return nothing
        return _fget(entry, state)::T, state + 1
    elseif entry isa Vector{T}
        state > length(entry) && return nothing
        return @inbounds(entry[state])::T, state + 1
    else
        return iterate(entry::Set{T}, state)
    end
end


#
# Constructors
#

"""
    OrderedDiGraph{T}(n=0)

Construct an `OrderedDiGraph{T}` with `n` vertices and 0 edges.
"""
function OrderedDiGraph{T}(n::Integer = 0) where {T <: Integer}
    z = zero(T)
    fadjlist = Union{NTuple{2, T}, Vector{T}}[(z, z) for _ in Base.OneTo(n)]
    badjlist = Union{NTuple{2, T}, Set{T}}[(z, z) for _ in Base.OneTo(n)]
    return OrderedDiGraph{T}(0, fadjlist, badjlist)
end

OrderedDiGraph(n::T) where {T <: Integer} = OrderedDiGraph{T}(n)
OrderedDiGraph() = OrderedDiGraph{Int}()

"""
    OrderedDiGraph(::Type{T})

Construct an empty `OrderedDiGraph{T}` with 0 vertices and 0 edges.
"""
OrderedDiGraph(::Type{T}) where {T <: Integer} = OrderedDiGraph{T}()

"""
    OrderedDiGraph{T}(g::OrderedDiGraph)

Construct a copy of `g`, converting vertex indices to type `T`.
"""
function OrderedDiGraph{T}(g::OrderedDiGraph) where {T <: Integer}
    fadj = Union{NTuple{2, T}, Vector{T}}[
        entry isa Vector ? Vector{T}(entry) : (T(entry[1]), T(entry[2]))
            for entry in g.fadjlist
    ]
    badj = Union{NTuple{2, T}, Set{T}}[
        entry isa Set ? Set{T}(entry) : (T(entry[1]), T(entry[2]))
            for entry in g.badjlist
    ]
    return OrderedDiGraph{T}(g.ne, fadj, badj)
end

OrderedDiGraph(g::OrderedDiGraph) = Base.copy(g)

"""
    OrderedDiGraph{T}(g::AbstractGraph)
    OrderedDiGraph(g::AbstractGraph)

Construct an `OrderedDiGraph` from any `AbstractGraph` by enumerating its edges.
If `g` is undirected, both directed edges `(u, v)` and `(v, u)` are added.
"""
function OrderedDiGraph{T}(g::Graphs.AbstractGraph) where {T <: Integer}
    h = OrderedDiGraph{T}(Graphs.nv(g))
    for e in Graphs.edges(g)
        Graphs.add_edge!(h, T(Graphs.src(e)), T(Graphs.dst(e)))
        if !Graphs.is_directed(g)
            Graphs.add_edge!(h, T(Graphs.dst(e)), T(Graphs.src(e)))
        end
    end
    return h
end

OrderedDiGraph(g::Graphs.AbstractGraph{T}) where {T} = OrderedDiGraph{T}(g)

#
# Graphs.jl interface
#

Graphs.edgetype(::OrderedDiGraph{T}) where {T} = Graphs.Edge{T}

Graphs.nv(g::OrderedDiGraph{T}) where {T} = T(length(g.fadjlist))

Graphs.ne(g::OrderedDiGraph) = g.ne

Graphs.vertices(g::OrderedDiGraph) = Base.OneTo(Graphs.nv(g))

Graphs.is_directed(::Type{<:OrderedDiGraph}) = true

Graphs.has_vertex(g::OrderedDiGraph, v::Integer) = v in Graphs.vertices(g)

function Graphs.has_edge(g::OrderedDiGraph, s, d)
    verts = Graphs.vertices(g)
    (s in verts && d in verts) || return false
    return _fin(@inbounds(g.badjlist[d]), s)
end

Graphs.outneighbors(g::OrderedDiGraph{T}, v::Integer) where {T} = AdjView{T}(@inbounds g.fadjlist[v])
Graphs.inneighbors(g::OrderedDiGraph{T}, v::Integer) where {T} = AdjView{T}(@inbounds g.badjlist[v])

Base.zero(::Type{OrderedDiGraph{T}}) where {T} = OrderedDiGraph{T}()
Base.zero(g::G) where {G <: OrderedDiGraph} = zero(G)

#
# Edge iteration
#

struct OrderedDiGraphEdgeIter{T <: Integer} <: Graphs.AbstractEdgeIter
    g::OrderedDiGraph{T}
end

Graphs.edges(g::OrderedDiGraph) = OrderedDiGraphEdgeIter(g)

Base.eltype(::Type{OrderedDiGraphEdgeIter{T}}) where {T} = Graphs.Edge{T}
Base.length(it::OrderedDiGraphEdgeIter) = Graphs.ne(it.g)

@inline function Base.iterate(
        it::OrderedDiGraphEdgeIter{T}, state = (one(T), 1)
    ) where {T}
    g = it.g
    n = Graphs.nv(g)
    u, i = state
    n == 0 && return nothing
    return @inbounds while true
        entry = g.fadjlist[u]
        if i > _flen(entry)
            u == n && return nothing
            u += one(T)
            i = 1
            continue
        end
        return Graphs.Edge(u, _fget(entry, i)), (u, i + 1)
    end
end

Base.in(e, it::OrderedDiGraphEdgeIter) = Graphs.has_edge(it.g, e)

function Base.show(io::IO, it::OrderedDiGraphEdgeIter)
    return print(io, "OrderedDiGraphEdgeIter $(Graphs.ne(it.g))")
end

#
# Display and equality
#

function Base.show(io::IO, ::MIME"text/plain", g::OrderedDiGraph{T}) where {T}
    return print(io, "{$(Graphs.nv(g)), $(Graphs.ne(g))} directed ordered $T graph")
end

Base.show(io::IO, g::OrderedDiGraph) = show(io, MIME"text/plain"(), g)

function Base.:(==)(g::OrderedDiGraph, h::OrderedDiGraph)
    Graphs.nv(g) == Graphs.nv(h) || return false
    Graphs.ne(g) == Graphs.ne(h) || return false
    return g.fadjlist == h.fadjlist && g.badjlist == h.badjlist
end

function Base.copy(g::OrderedDiGraph{T}) where {T}
    # NTuples are immutable — share them; only Vector/Set entries need copying.
    fadj = Union{NTuple{2, T}, Vector{T}}[
        entry isa Vector{T} ? copy(entry) : entry for entry in g.fadjlist
    ]
    badj = Union{NTuple{2, T}, Set{T}}[
        entry isa Set{T} ? copy(entry) : entry for entry in g.badjlist
    ]
    return OrderedDiGraph{T}(g.ne, fadj, badj)
end

#
# Mutation
#

function Graphs.add_vertex!(g::OrderedDiGraph{T}) where {T}
    (Graphs.nv(g) + one(T) <= Graphs.nv(g)) && return false  # overflow guard
    push!(g.fadjlist, (zero(T), zero(T)))
    push!(g.badjlist, (zero(T), zero(T)))
    return true
end

function Graphs.add_edge!(g::OrderedDiGraph{T}, e::Graphs.Edge{T}) where {T}
    s, d = Graphs.src(e), Graphs.dst(e)
    verts = Graphs.vertices(g)
    (s in verts && d in verts) || return false

    @inbounds entry = g.fadjlist[s]
    @inbounds bentry = g.badjlist[d]

    if entry isa Vector{T}
        push!(entry, d)
    else
        a, b = entry
        if iszero(a)
            @inbounds g.fadjlist[s] = (d, zero(T))
        elseif iszero(b)
            @inbounds g.fadjlist[s] = (a, d)
        else
            @inbounds g.fadjlist[s] = T[a, b, d]
        end
    end

    g.ne += 1
    # Record s in badjlist[d] only if not already present (deduplication).
    if !_fin(bentry, s)
        if bentry isa Set{T}
            push!(bentry, s)
        else
            a, b = bentry
            if iszero(a)
                @inbounds g.badjlist[d] = (s, zero(T))
            elseif iszero(b)
                @inbounds g.badjlist[d] = (a, s)
            else
                @inbounds g.badjlist[d] = Set{T}((a, b, s))
            end
        end
    end
    return true
end

function Graphs.add_edge!(g::OrderedDiGraph{T}, s::Integer, d::Integer) where {T}
    return Graphs.add_edge!(g, Graphs.Edge{T}(T(s), T(d)))
end

function Graphs.add_edge!(g::OrderedDiGraph{T}, e::Graphs.AbstractEdge) where {T}
    return Graphs.add_edge!(g, T(Graphs.src(e)), T(Graphs.dst(e)))
end

"""
    rem_outedges!(g::OrderedDiGraph, v) -> Bool

Remove all outgoing edges from vertex `v` in `g`. The backward adjacency lists
of every out-neighbor of `v` are updated accordingly. Returns `true` on success,
`false` if `v` is not a vertex of `g`.
"""
function rem_outedges!(g::OrderedDiGraph{T}, v::Integer) where {T}
    Graphs.has_vertex(g, v) || return false
    @inbounds entry = g.fadjlist[v]

    if entry isa NTuple{2, T}
        a, b = entry
        iszero(a) && return true
        _rem_badjlist_entry!(g, a, T(v))
        if iszero(b)
            g.ne -= 1
        else
            # Skip badjlist removal for b if it equals a (multi-edge: already removed).
            a != b && _rem_badjlist_entry!(g, b, T(v))
            g.ne -= 2
        end
    else
        n = length(entry::Vector{T})
        for d in entry::Vector{T}
            # Guard against double-removal for duplicate destinations (multi-edges).
            if _fin(@inbounds(g.badjlist[d]), T(v))
                _rem_badjlist_entry!(g, d, T(v))
            end
        end
        g.ne -= n
    end

    @inbounds g.fadjlist[v] = (zero(T), zero(T))
    return true
end

Graphs.rem_vertex!(g::OrderedDiGraph, v::Integer) =
    error("OrderedDiGraph does not support vertex removal")

Graphs.rem_vertices!(g::OrderedDiGraph, vs::AbstractVector{<:Integer}; kwargs...) =
    error("OrderedDiGraph does not support vertex removal")

@inline alwaystrue(x) = true
const COMM_CHECKS_LIMIT = Ref(10)

# Matcher patterns with Slot, DefSlot and Segment

# matches one term
# syntax:  ~x
struct Slot{P}
    name::Symbol
    predicate::P
end

Slot(s) = Slot(s, alwaystrue)

Base.isequal(s1::Slot, s2::Slot) = s1.name == s2.name

Base.show(io::IO, s::Slot) = (print(io, "~"); print(io, s.name))
Base.nameof(x::Slot) = x.name

# for when the slot is a symbol, like `~x`
makeslot(s::Symbol, keys) = (push!(keys, s); Slot(s))

# for when the slot is an expression, like `~x::predicate`
function makeslot(s::Expr, keys)
    if !(s.head == :(::))
        error("Syntax for specifying a slot is ~x::predicate, where predicate is a boolean function")
    end

    name = s.args[1]

    push!(keys, name)
    :(Slot($(QuoteNode(name)), $(esc(s.args[2]))))
end






# matches one term with built in default value.
# syntax: ~!x
# Example usage:
# (~!x + ~y) can match (a + b) but also just "a" and x takes default value of zero.
# (~!x)*(~y) can match a*b but also just "a", and x takes default value of one.
# (~x + ~y)^(~!z) can match (a + b)^c but also just "a + b", and z takes default value of one.
# only these three operations are supported for default values.

struct DefSlot{P, O}
    name::Symbol
    predicate::P
    operation::O
    defaultValue::Real
end

# operation | default
# + | 0
# * | 1
# ^ | 1
function defaultValOfCall(call)
    if call == :+
        return 0
    elseif call == :*
        return 1
    elseif call == :^
        return 1
    end
    # else no default value for this call
    error("You can use default slots only with +, * and ^, but you tried with: $call")
end

DefSlot(s) = DefSlot(s, alwaystrue, nothing, 0)
Base.isequal(s1::DefSlot, s2::DefSlot) = s1.name == s2.name
Base.show(io::IO, s::DefSlot) = (print(io, "~!"); print(io, s.name))
Base.nameof(x::DefSlot) = x.name

makeDefSlot(s::Symbol, keys, op) = (push!(keys, s); DefSlot(s, alwaystrue, op, defaultValOfCall(op)))

function makeDefSlot(s::Expr, keys, op)
    if !(s.head == :(::))
        error("Syntax for specifying a default slot is ~!x::\$predicate, where predicate is a boolean function")
    end

    name = s.args[1]

    push!(keys, name)
    tmp = defaultValOfCall(op)
    :(DefSlot($(QuoteNode(name)), $(esc(s.args[2])), $(esc(op)), $(esc(tmp))))
end





# matches zero or more terms
# syntax: ~~x
struct Segment{F}
    name::Symbol
    predicate::F
end

Segment(s) = Segment(s, alwaystrue)

Base.show(io::IO, s::Segment) = (print(io, "~~"); print(io, s.name))
Base.nameof(x::Segment) = x.name

makesegment(s::Symbol, keys) = (push!(keys, s); Segment(s))

function makesegment(s::Expr, keys)
    if !(s.head == :(::))
        error("Syntax for specifying a segment is ~~x::\$predicate, where predicate is a boolean function")
    end

    name = s.args[1]

    push!(keys, name)
    :(Segment($(QuoteNode(name)), $(esc(s.args[2]))))
end

# parent call is needed to know which default value to give if any default slots are present
"""
    $TYPEDSIGNATURES

Convert a rule pattern expression into a pattern matcher structure.

# Arguments
- `expr`: The pattern expression to convert (can contain slots like `~x`, segments like `~~x`, etc.)
- `keys`: A collection to accumulate pattern variable names
- `parentCall`: The parent operation (used to determine default values for default slots)

# Returns
- A pattern matcher structure that can be used to match against symbolic expressions

# Details
This function recursively transforms a pattern expression into an internal representation used
by the rule system. It handles several special syntaxes:
- `~x`: Matches a single term (creates a `Slot`)
- `~~x`: Matches zero or more terms (creates a `Segment`)
- `~!x`: Matches a term with a default value (creates a `DefSlot`)
- `~x::predicate`: Adds a predicate constraint to the slot
- `\$expr`: Interpolates a value directly

The function tracks pattern variable names in `keys` and uses `parentCall` to determine
appropriate default values for default slots in operations like `+`, `*`, and `^`.
"""
function makepattern(expr, keys, parentCall=nothing)
    if expr isa Expr
        if expr.head === :call
            if expr.args[1] === :(~)
                if expr.args[2] isa Expr && expr.args[2].args[1] == :(~)
                    # matches ~~x::predicate
                    makesegment(expr.args[2].args[2], keys)
                elseif expr.args[2] isa Expr && expr.args[2].args[1] == :(!)
                    # matches ~!x::predicate
                    makeDefSlot(expr.args[2].args[2], keys, parentCall)
                else
                    # matches ~x::predicate
                    makeslot(expr.args[2], keys)
                end
            elseif expr.args[1] === :(//)
                # bc when the expression is not quoted, 3//2 is a Rational{Int64}, not a call
                return esc(expr.args[2] // expr.args[3])
            else
                # make a pattern for every argument of the expr.
                :(term($(map(x->makepattern(x, keys, operation(expr)), expr.args)...); type=Any, shape=$ShapeVecT()))
            end
        elseif expr.head === :ref
            :(term(getindex, $(map(x->makepattern(x, keys), expr.args)...); type=Any))
        elseif expr.head === :$
            return esc(expr.args[1])
        else
            Expr(expr.head, makepattern.(expr.args, (keys,))...)
        end
    else
        # treat as a literal
        return esc(expr)
    end
end

"""
    $TYPEDSIGNATURES

Convert a rule consequent expression into code that constructs the result.

# Arguments
- `expr`: The consequent expression to convert (the right-hand side of a rewrite rule)

# Returns
- An expression that, when evaluated with matched bindings, produces the replacement term

# Details
This function recursively transforms the right-hand side of a rewrite rule into code that
constructs the result using matched values. It handles special syntax for referencing
matched pattern variables:
- `~x`: References the value matched by pattern variable `x`
- `~~x`: References the sequence matched by segment variable `x`
- `~` alone: References the entire match dictionary

The function generates code that looks up pattern variables in the `__MATCHES__` dictionary,
which is populated during pattern matching. All other parts of the expression are treated
as literal values to be included in the result.
"""
function makeconsequent(expr)
    if expr isa Expr
        if expr.head === :call
            if expr.args[1] === :(~)
                if expr.args[2] isa Symbol
                    return :(getindex(__MATCHES__, $(QuoteNode(expr.args[2]))))
                elseif expr.args[2] isa Expr && expr.args[2].args[1] == :(~)
                    @assert expr.args[2].args[2] isa Symbol
                    return :(getindex(__MATCHES__, $(QuoteNode(expr.args[2].args[2]))))
                end
            else
                return Expr(:call, map(makeconsequent, expr.args)...)
            end
        else
            return Expr(expr.head, map(makeconsequent, expr.args)...)
        end
    elseif expr===:(~)
        return :(__MATCHES__)
    else
        # treat as a literal
        return esc(expr)
    end
end

abstract type AbstractRule end # Currently doesn't really do anything. Can be removed.

#-----------------------------
#### Regular Rewriting Rules

struct Rule{L, M, R} <: AbstractRule
    expr::Expr               # rule pattern stored for pretty printing
    lhs::L                   # the pattern
    matcher::M               # matcher(lhs)
    rhs::R                   # consequent
    depth::Int               # number of levels of expr this rule touches
end

getdepth(r::Rule) = r.depth

function rule_depth(rule, d=0, maxdepth=0)
    if iscall(rule)
        maxdepth = reduce(max, (rule_depth(r, d+1, maxdepth) for r in arguments(rule)), init=1)
    elseif rule isa Slot || rule isa Segment
        maxdepth = max(d, maxdepth)
    end
    return maxdepth
end

function Base.show(io::IO, r::Rule)
    Base.print(io, r.expr)
end

const EMPTY_IMMUTABLE_DICT = ImmutableDict{Symbol, Any}(:____, nothing)

function (r::Rule)(term)
    rhs = r.rhs

    try
        # n == 1 means that exactly one term of the input (term,) was matched
        success(bindings, n) = n == 1 ? (rhs(assoc(bindings, :MATCH, term))) : nothing
        return r.matcher(success, (term,), EMPTY_IMMUTABLE_DICT)
    catch err
        throw(RuleRewriteError(r, term))
    end
end

"""
    rewrite_rhs(expr::Expr)

Rewrite the `expr` by dealing with `:where` if necessary.
The `:where` is rewritten from, for example, `~x where f(~x)` to `f(~x) ? ~x : nothing`.
"""
function rewrite_rhs(expr::Expr)
    if expr.head == :where
        rhs = expr.args[1]
        predicate = expr.args[2]
        expr = :($predicate ? $rhs : nothing)
    end
    return expr
end
rewrite_rhs(expr) = expr

"""
    @rule LHS => RHS

Creates a `Rule` object. A rule object is callable, and  takes an expression and rewrites
it if it matches the LHS pattern to the RHS pattern, returns `nothing` otherwise.
The rule language is described below.

LHS can be any possibly nested function call expression where any of the arguments can
optionally be a Slot (`~x`), Default Value Slot (`~!x` also called DefSlot) or a Segment
 (`~~x`) (described below).

If an expression matches LHS entirely, then it is rewritten to the pattern in the RHS.
Slot, DefSlot and Segment variables on the RHS will substitute the result of the
matches found for these variables in the LHS.

**Slot**:

A Slot variable is written as `~x` and matches a single expression. `x` is the name of the variable. If a slot appears more than once in an LHS expression then expression matched at every such location must be equal (as shown by `isequal`).

_Example:_

Simple rule to turn any `sin` into `cos`:

```julia-repl
julia> @syms a b c
(a, b, c)

julia> r = @rule sin(~x) => cos(~x)
sin(~x) => cos(~x)

julia> r(sin(1+a))
cos((1 + a))
```

A rule with 2 segment variables

```julia-repl
julia> r = @rule sin(~x + ~y) => sin(~x)*cos(~y) + cos(~x)*sin(~y)
sin(~x + ~y) => sin(~x) * cos(~y) + cos(~x) * sin(~y)

julia> r(sin(a + b))
cos(a)*sin(b) + sin(a)*cos(b)
```

A rule that matches two of the same expressions:

```julia-repl
julia> r = @rule sin(~x)^2 + cos(~x)^2 => 1
sin(~x) ^ 2 + cos(~x) ^ 2 => 1

julia> r(sin(2a)^2 + cos(2a)^2)
1

julia> r(sin(2a)^2 + cos(a)^2)
# nothing
```

**DefSlot**:

A DefSlot variable is written as `~!x`. Works like a normal slot, but can also take default values if not present in the expression.

_Example in power:_
```julia-repl
julia> r_pow = @rule (~x)^(~!m) => ~m
(~x) ^ ~(!m) => ~m

julia> r_pow(x^2)
2

julia> r_pow(x)
1
```

_Example in sum:_
```julia-repl
julia> r_sum = @rule ~x + ~!y => ~y
~x + ~(!y) => ~y

julia> r_sum(x+2)
x

julia> r_sum(x)
0
```

Currently DefSlot is implemented in:

| Operation         | Default value |
|-------------------|---------------|
| \\*               | 1             |
| \\+               | 0             |
| 2nd argument of ^ | 1             |

**Segment**:

A Segment variable is written as `~~x` and matches zero or more expressions in the
function call.

_Example:_

This implements the distributive property of multiplication: `+(~~ys)` matches expressions
like `a + b`, `a+b+c` and so on. On the RHS `~~ys` presents as any old julia array.

```julia-repl
julia> r = @rule ~x * +((~~ys)) => sum(map(y-> ~x * y, ~~ys));

julia> r(2 * (a+b+c))
((2 * a) + (2 * b) + (2 * c))
```

**Predicates**:

There are two kinds of predicates, namely over slot variables and over the whole rule.
For the former, predicates can be used on both `~x` and `~~x` by using the `~x::f` or `~~x::f`.
Here `f` can be any julia function. In the case of a slot the function gets a single
matched subexpression, in the case of segment, it gets an array of matched expressions.

The predicate should return `true` if the current match is acceptable, and `false`
otherwise.

```julia-repl
julia> two_πs(x::Number) = abs(round(x/(2π)) - x/(2π)) < 10^-9
two_πs (generic function with 1 method)

julia> two_πs(x) = false
two_πs (generic function with 2 methods)

julia> r = @rule sin(~~x + ~y::two_πs + ~~z) => sin(+(~~x..., ~~z...))
sin(~(~x) + ~(y::two_πs) + ~(~z)) => sin(+(~(~x)..., ~(~z)...))

julia> r(sin(a+3π))

julia> r(sin(a+6π))
sin(a)

julia> r(sin(a+6π+c))
sin((a + c))
```

Predicate function gets an array of values if attached to a segment variable (`~~x`).

For the predicate over the whole rule, use `@rule <LHS> => <RHS> where <predicate>`:

```julia-repl
julia> @syms a b;

julia> predicate(x) = x === a;

julia> r = @rule ~x => ~x where predicate(~x);

julia> r(a)
a

julia> r(b) === nothing
true
```

Note that this is syntactic sugar and that it is the same as something like
`@rule ~x => f(~x) ? ~x : nothing`.

**Debugging Rules**:
Note that if the RHS is a single tilde `~`, then the rule returns a a dictionary of all [slot variable, expression matched], this is useful for debugging.

_Example:_

```julia-repl
julia> r = @rule (~x + (~y)^(~m)) => ~
~x + (~y) ^ ~m => (~)

julia> r(a + b^2)
Base.ImmutableDict{Symbol, Any} with 5 entries:
  :MATCH => a + b^2
  :m     => 2
  :y     => b
  :x     => a
  :____  => nothing
```

**Context**:

_In predicates_: Contextual predicates are functions wrapped in the `Contextual` type.
The function is called with 2 arguments: the expression and a context object
passed during a call to the Rule object (maybe done by passing a context to `simplify` or
a `RuleSet` object).

The function can use the inputs however it wants, and must return a boolean indicating
whether the predicate holds or not.

_In the consequent pattern_: Use `(@ctx)` to access the context object on the right hand side
of an expression.
"""
macro rule(expr)
    @assert expr.head == :call && expr.args[1] == :(=>)
    lhs = expr.args[2]
    rhs = rewrite_rhs(expr.args[3])
    keys = Symbol[]
    lhs_term = makepattern(lhs, keys)
    unique!(keys)
    quote
        $(__source__)
        lhs_pattern = $(lhs_term)
        Rule(
            $(QuoteNode(expr)),
            lhs_pattern,
            matcher(lhs_pattern, permutations),
            __MATCHES__ -> $(makeconsequent(rhs)),
            rule_depth($lhs_term)
        )
    end
end

"""
    @capture ex pattern

Uses a `Rule` object to capture an expression if it matches the `pattern`. Returns `true` and injects
slot variable match results into the calling scope when the `pattern` matches, otherwise returns false. The
rule language for specifying the `pattern` is the same in @capture as it is in `@rule`. Contextual matching
is not yet supported

```julia-repl
julia> @syms a; ex = a^a;

julia> if @capture ex (~x)^(~x)
           @show x
       elseif @capture ex 2(~y)
           @show y
       end;
x = a
```

See also: [`@rule`](@ref)
"""
macro capture(ex, lhs)
    keys = Symbol[]
    lhs_term = makepattern(lhs, keys)
    unique!(keys)
    bind = Expr(:block, map(key-> :($(esc(key)) = getindex(__MATCHES__, $(QuoteNode(key)))), keys)...)
    quote
        $(__source__)
        lhs_pattern = $(lhs_term)
        __MATCHES__ = Rule($(QuoteNode(lhs)),
             lhs_pattern,
             matcher(lhs_pattern, nothing),
             identity,
             rule_depth($lhs_term))($(esc(ex)))
        if __MATCHES__ !== nothing
            $bind
            true
        else
            false
        end
    end
end

#-----------------------------
#### Associative Commutative Rules

struct ACRule{F,R} <: AbstractRule
    sets::F
    rule::R
    arity::Int
end

Rule(acr::ACRule)   = acr.rule
getdepth(r::ACRule) = getdepth(r.rule)

"""
    @acrule(lhs => rhs)

Create an associative-commutative rule that matches all permutations of the arguments.

This macro creates a rule that can match patterns regardless of the order of arguments
in associative and commutative operations like addition and multiplication.

# Arguments
- `lhs`: The pattern to match (left-hand side)
- `rhs`: The replacement expression (right-hand side)

# Examples
```julia-repl
julia> @syms x y z
(x, y, z)

julia> r = @acrule x + y => 2x  # Matches both x + y and y + x
ACRule(x + y => 2x)

julia> r(x + y)
2x

julia> r(y + x)
2x
```

See also: [`@rule`](@ref), [`@ordered_acrule`](@ref)
"""
macro acrule(expr)
    @assert expr.head == :call && expr.args[1] == :(=>)
    lhs = expr.args[2]
    rhs = rewrite_rhs(expr.args[3])
    keys = Symbol[]
    lhs_term = makepattern(lhs, keys)
    unique!(keys)

    arity = length(lhs.args[2:end])

    quote
        $(__source__)
        lhs_pattern = $(lhs_term)
        rule = Rule($(QuoteNode(expr)),
             lhs_pattern,
             matcher(lhs_pattern, permutations),
             __MATCHES__ -> $(makeconsequent(rhs)),
             rule_depth($lhs_term))
        ACRule(permutations, rule, $arity)
    end
end

macro ordered_acrule(expr)
    @assert expr.head == :call && expr.args[1] == :(=>)
    lhs = expr.args[2]
    rhs = rewrite_rhs(expr.args[3])
    keys = Symbol[]
    lhs_term = makepattern(lhs, keys)
    unique!(keys)

    arity = length(lhs.args[2:end])

    quote
        $(__source__)
        lhs_pattern = $(lhs_term)
        rule = Rule($(QuoteNode(expr)),
             lhs_pattern,
             matcher(lhs_pattern, combinations),
             __MATCHES__ -> $(makeconsequent(rhs)),
             rule_depth($lhs_term))
        ACRule(combinations, rule, $arity)
    end
end

Base.show(io::IO, acr::ACRule) = print(io, "ACRule(", acr.rule, ")")

function (acr::ACRule)(term)
    r = Rule(acr)
    if !iscall(term)
        # different operations -> try deflsot
        r(term)
    else
        f = operation(term)
        # Assume that the matcher was formed by closing over a term
        if f !== operation(r.lhs)
            # different operations -> try deflsot
            return r(term)
        end

        T = vartype(term)
        args = arguments(term)
        is_full_perm = acr.arity == length(args)
        if is_full_perm
            args_buf = copy(parent(args))
        else
            args_buf = ArgsT{T}(@view args[1:acr.arity])
        end

        itr = acr.sets(eachindex(args), acr.arity)

        for inds in itr
            for (i, ind) in enumerate(inds)
                args_buf[i] = args[ind]
            end
            # this is temporary and only constructed so the rule can
            # try and match it - no need to hashcons it.
            tempterm = BSImpl.Term{T}(f, args_buf; unsafe = true, type = symtype(term))
            # this term will be hashconsed regardless
            result = r(tempterm)
            if result !== nothing
                # Assumption: inds are unique
                is_full_perm && return result
                inds_set = BitSet(inds)
                full_args_buf = ArgsT{T}(@view args[1:(length(args)-acr.arity+1)])
                idx = 1
                for i in eachindex(args)
                    i in inds_set && continue
                    full_args_buf[idx] = args[i]
                    idx += 1
                end
                full_args_buf[idx] = Const{T}(result)
                return maketerm(typeof(term), f, full_args_buf, metadata(term); type = symtype(term))
            end
        end
    end
end


struct RuleRewriteError
    rule
    expr
end

getdepth(::Any) = typemax(Int)

@noinline function Base.showerror(io::IO, err::RuleRewriteError)
    msg = "Failed to apply rule $(err.rule) on expression "
    msg *= sprint(io->show(io, err.expr))
    print(io, msg)
end

Base.@deprecate RuleSet(x) Postwalk(Chain(x))

"""
    RuleSet(rules)

Deprecated. Build the rewriter explicitly instead:

```julia
using SymbolicUtils.Rewriters
Postwalk(Chain(rules))
```

`RuleSet` was the original way to turn a collection of `@rule`s into a callable rewriter.
It applied every rule in order at every node of the expression, bottom up. That is exactly
`Postwalk(Chain(rules))`, and `RuleSet(rules)` now constructs and returns that object while
emitting a deprecation warning; it will be removed in the next breaking release.

Spelling the rewriter out is preferred because the traversal and the combination strategy
become explicit and independently choosable. `Chain` can be swapped for
[`SymbolicUtils.Rewriters.RestartedChain`](@ref) to restart the rule list after every
successful rewrite, [`SymbolicUtils.Rewriters.Fixpoint`](@ref) to iterate to convergence, or
[`SymbolicUtils.Rewriters.Prewalk`](@ref) to rewrite top down instead of bottom up. See
[`SymbolicUtils.Rewriters`](@ref) for the full set of combinators.
"""
RuleSet

using SymbolicUtils
using SymbolicUtils: ifelse_eager, ifelse_branching, term, symtype
using SymbolicUtils.Code
using RuntimeGeneratedFunctions
using Test

RuntimeGeneratedFunctions.init(@__MODULE__)

# Errors if it is ever actually evaluated; used to detect whether the untaken branch runs.
boom(v) = error("untaken branch was evaluated: boom($v)")
boomterm(v) = term(boom, v; type = Real, shape = SymbolicUtils.shape(v))

compile(body, args...) = @RuntimeGeneratedFunction(toexpr(cse(Func(collect(args), [], body))))

@testset "Construction, symtype and shape mirror `ifelse`" begin
    @syms cond::Bool a b x[1:3] y[1:3] z[1:4]
    for op in (ifelse_eager, ifelse_branching)
        e = op(cond, a, b)
        @test operation(e) === op
        @test symtype(e) == symtype(ifelse(cond, a, b))
        @test SymbolicUtils.promote_symtype(op, Bool, Int, Bool) == Int
        @test_throws ArgumentError SymbolicUtils.promote_symtype(op, Real, Int, Float64)
        # array-branch rules match `ifelse`
        @test SymbolicUtils.shape(op(cond, x, y)) == [1:3]
        @test_throws ErrorException op(cond, x, z)
    end
end

@testset "Lowering forms" begin
    @syms cond::Bool a b
    @test toexpr(ifelse_branching(cond, a, b)).head === :if
    # `ifelse_eager` lowers via the generic fallback to a plain (eager) call
    @test toexpr(ifelse_eager(cond, a, b)).head === :call
end

@testset "simplify folds like `ifelse`" begin
    @syms cond::Bool b
    for op in (ifelse_eager, ifelse_branching)
        @test isequal(simplify(op(cond, b, b)), b)
    end
end

@testset "ifelse_branching does not evaluate the untaken branch" begin
    @syms x::Real
    f = compile(ifelse_branching(x > 0, x^2, boomterm(x)), x)
    @test f(2.0) == 4.0          # takes the valid branch; `boom` never runs
    g = compile(ifelse_branching(x > 0, boomterm(x), 1 / x), x)
    @test g(-2.0) == -0.5
end

@testset "ifelse_eager evaluates both branches" begin
    @syms x::Real
    f = compile(ifelse_eager(x > 0, x^2, boomterm(x)), x)
    @test_throws ErrorException f(2.0)
end

# Counts how many times it is evaluated; used to detect duplicated computation.
const FIRE_COUNT = Ref(0)
fire(v) = (FIRE_COUNT[] += 1; v)
fireterm(v) = term(fire, v; type = Real, shape = SymbolicUtils.shape(v))

@testset "multiply-referenced ifelse_branching is computed once under CSE" begin
    @syms x::Real
    z = ifelse_branching(x > 0, fireterm(x)^2, boomterm(x))
    # CSE binds the conditional itself to a temporary...
    csex = cse(z + 2z)
    @test csex isa Let
    @test count(p -> p isa Assignment && iscall(p.rhs) &&
        operation(p.rhs) === ifelse_branching, csex.pairs) == 1
    # ...so referencing it twice evaluates the taken branch once and the untaken
    # branch (`boom`) not at all.
    f = compile(z + 2z, x)
    FIRE_COUNT[] = 0
    @test f(2.0) == 12.0
    @test FIRE_COUNT[] == 1

    # One-sided nesting stays linear: each level is emitted once, matching `ifelse`.
    # (A conditional referenced inside *both* branches of an enclosing one is still
    # emitted per branch — hoisting it out would evaluate it eagerly.)
    nested_b = ifelse_branching(x > 0, x, -x)
    nested_i = ifelse(x > 0, x, -x)
    for i in 1:5
        nested_b = ifelse_branching(x > i, nested_b + 1, -x)
        nested_i = ifelse(x > i, nested_i + 1, -x)
    end
    code_b = string(toexpr(cse(Func([x], [], nested_b))))
    code_i = string(toexpr(cse(Func([x], [], nested_i))))
    nif(s) = length(collect(eachmatch(r"\bif\b", s)))
    @test nif(code_b) == nif(code_i) == 6
    fb = compile(nested_b, x)
    fi = compile(nested_i, x)
    @test fb(2.5) == fi(2.5) == -2.5
end

using SymbolicUtils
using SymbolicUtils.Code
using TermInterface
using StaticArrays
using Test
import SymbolicUtils as SU

@syms x[1:3]::Real y[1:3]::Real z[1:3]::Real
@testset "macro" begin
    w = @makearray w[1:3, 1:3] begin
        w[1:1, 1:3] => x'
        w[2:2, 1:3] => @arrayop (1, i) y[i] + z[i]
        w[3:3, 1:1] => [1;;]
        w[3:3, 2:2] => [z[1];;]
        w[3:3, 3:3] => [z'z;;]
    end

    truew = BS[
        x[1] x[2] x[3]
        y[1] + z[1] y[2] + z[2] y[3] + z[3]
        1 z[1] z'z
    ]
    @test isequal(collect(w), truew)

    @testset "round-tripping" begin
        @test isequal(w, maketerm(typeof(w), operation(w), arguments(w), nothing))
    end

    @testset "codegen" begin
        xv = rand(3)
        yv = rand(3)
        zv = rand(3)
        truev = eval(quote
            let x = $xv, y = $yv, z = $zv
                $(Code.toexpr(truew))
            end
        end)
        wv = eval(quote
            let x = $xv, y = $yv, z = $zv
                $(Code.toexpr(w))
            end
        end)
        wv_cse = eval(quote
            let x = $xv, y = $yv, z = $zv
                $(Code.toexpr(Code.cse(w)))
            end
        end)
        @test truev ≈ wv
        @test truev ≈ wv_cse
    end
end

@testset "nested" begin
    w = @makearray w[1:3, 1:3] begin
        w[1:1, 1:3] => x'
        w[2:2, 1:3] => @makearray _[1:1, 1:3] begin
            _[1:1, 1:1] => [y[1];;]
            _[1:1, 2:3] => z'[:, 1:2]
        end
        w[3:3, 1:1] => [1;;]
        w[3:3, 2:2] => [z[1];;]
        w[3:3, 3:3] => [z'z;;]
    end
    truew = BS[
        x[1] x[2] x[3]
        y[1] z'[1, 1] z'[1, 2]
        1 z[1] z'z
    ]
    @test isequal(collect(w), truew)

    @testset "indexing" begin
        @test isequal(w[1, 1], x'[1, 1])
        @test isequal(w[1, 2], x'[1, 2])
        @test isequal(w[1, 3], x'[1, 3])
        @test isequal(w[2, 1], y[1])
        @test isequal(w[2, 2], z'[1, 1])
        @test isequal(w[2, 3], z'[1, 2])
        @test isequal(w[3, 1], SymbolicUtils.Const{SymReal}(1))
        @test isequal(w[3, 2], z[1])
        @test isequal(w[3, 3], z'z)
    end
end

@testset "later ranges take priority" begin
    w = @makearray w[1:3] begin
        w[1:3] => x
        w[2:3] => y[1:2]
    end
    truew = BS[x[1], y[1], y[2]]
    @test isequal(collect(w), truew)
end

@testset "`SVector` in arguments" begin
    @syms x y z
    regions = SU.RegionsT((SU.ShapeVecT((1:1,)), SU.ShapeVecT((2:2,)), SU.ShapeVecT((3:3,))))
    vals = SymbolicUtils.term(SVector{3}, [x], [y], [z])
    maker = maketerm(typeof(x), SymbolicUtils.ArrayMaker{SymReal}, SymbolicUtils.ArgsT{SymReal}((regions, vals)), nothing)
    reference = @makearray w[1:3] begin
        w[1:1] => vals[1]
        w[2:2] => vals[2]
        w[3:3] => vals[3]
    end
    @test isequal(maker, reference)
end

#### Pattern matching
### Matching procedures
# A matcher is a function which takes 3 arguments
# 1. Expression
# 2. Dictionary
# 3. Callback: takes arguments Dictionary × Number of elements matched
#

function matcher(val::Any, acSets)
    val = unwrap_const(val)
    # if val is a call (like an operation) creates a term matcher or term matcher with defslot
    if iscall(val)
        # if has two arguments and one of them is a DefSlot, create a term matcher with defslot
        # just two arguments bc defslot is only supported with operations with two args: *, ^, +
        if any(x -> isa(unwrap_const(x), DefSlot), parent(arguments(val)))
            return defslot_term_matcher_constructor(val, acSets)
        end
        # else return a normal term matcher
        return term_matcher_constructor(val, acSets)
    end

    function literal_matcher(next, data, bindings)
        # car data is the first element of data
        islist(data) && isequal(unwrap_const(car(data)), val) ? next(bindings, 1) : nothing
    end
end

# acSets is not used but needs to be there in case matcher(::Slot) is directly called from the macro
function matcher(slot::Slot, acSets)
    function slot_matcher(next, data, bindings)
        !islist(data) && return nothing
        cd = unwrap_const(car(data))
        val = get(bindings, slot.name, nothing)
        # if slot name already is in bindings, check if it matches
        if val !== nothing
            if isequal(val, cd)::Bool
                return next(bindings, 1)
            end
        # elseif the first element of data matches the slot predicate, add it to bindings and call next
        elseif slot.predicate(cd)::Bool
            binds = assoc(bindings, slot.name, cd)
            next(binds, 1)
        end
    end
end

# this is called only when defslot_term_matcher finds the operation and tries
# to match it, so no default value used. So the same function as slot_matcher
# can be used
function matcher(defslot::DefSlot, acSets)
    matcher(Slot(defslot.name, defslot.predicate), nothing) # slot matcher doesnt use acsets
end

# returns n == offset, 0 if failed
function trymatchexpr(data, value, n)
    if !islist(value)
        return n
    elseif islist(value) && islist(data)
        if !islist(data)
            # didn't fully match
            return nothing
        end

        while isequal(car(value), car(data))
            n += 1
            value = cdr(value)
            data = cdr(data)

            if !islist(value)
                return n
            elseif !islist(data)
                return nothing
            end
        end

        return !islist(value) ? n : nothing
    elseif isequal(unwrap_const(value), unwrap_const(data))
        return n + 1
    end
end

function matcher(segment::Segment, acSets)
    function segment_matcher(success, data, bindings)
        val = get(bindings, segment.name, nothing)

        if val !== nothing
            n = trymatchexpr(data, val, 0)
            if n !== nothing
                success(bindings, n)
            end
        else
            res = nothing

            for i=length(data):-1:0
                subexpr = take_n(data, i)

                !segment.predicate(unwrap_const(subexpr)) && continue
                res = success(assoc(bindings, segment.name, subexpr), i)
                res !== nothing && break
            end

            return res
        end
    end
end

function term_matcher_constructor(term, acSets)
    matchers = vcat([matcher(operation(term), acSets)], map(x -> matcher(unwrap_const(x), acSets), parent(arguments(term))))

    function loop(term, bindings′, matchers′) # Get it to compile faster
        if !islist(matchers′)
            if  !islist(term)
                return bindings′
            end
            return nothing
        end
        car(matchers′)(term, bindings′) do b, n
            loop(drop_n(term, n), b, cdr(matchers′))
        end
        # explanation of above 3 lines:
        # car(matchers′)(b,n -> loop(drop_n(term, n), b, cdr(matchers′)), term, bindings′)
        #                <------ next(b,n) ---------------------------->
        # car = first element of list, cdr = rest of the list, drop_n = drop first n elements of list
        # Calls the first matcher, with the "next" function being loop again but with n terms dropepd from term
        # Term is a linked list (a list and a index). drop n advances the index. when the index sorpasses
        # the length of the list, is considered empty
    end

    # if the operation is a pow, we have to match also 1/(...)^(...) with negative exponent
    if operation(term) === ^
        function pow_term_matcher(success, data, bindings)
            !islist(data) && return nothing # if data is not a list, return nothing
            data = car(data) # from (..., ) to ...
            !iscall(data) && return nothing # if first element is not a call, return nothing

            result = loop(data, bindings, matchers)
            result !== nothing && return success(result, 1)

            frankestein = nothing
            if (operation(data) === ^) && iscall(arguments(data)[1]) && (operation(arguments(data)[1]) === /) && _isone(arguments(arguments(data)[1])[1])
                # if data is of the alternative form (1/...)^(...)
                one_over_smth = arguments(data)[1]
                T = vartype(one_over_smth)
                frankestein = Term{T}(^, [arguments(one_over_smth)[2], -arguments(data)[2]])
            elseif (operation(data) === /) && _isone(arguments(data)[1]) && iscall(arguments(data)[2]) && (operation(arguments(data)[2]) === ^)
                # if data is of the alternative form 1/(...)^(...)
                denominator = arguments(data)[2]
                T = vartype(denominator)
                frankestein = Term{T}(^, [arguments(denominator)[1], -arguments(denominator)[2]])
            elseif (operation(data) === /) && _isone(arguments(data)[1])
                # if data is of the alternative form 1/(...), it might match with exponent = -1
                denominator = arguments(data)[2]
                T = vartype(denominator)
                frankestein = Term{T}(^, [denominator, -1])
            elseif operation(data)===exp
                # if data is a exp call, it might match with base e
                T = vartype(arguments(data)[1])
                frankestein = Term{T}(^,[ℯ, arguments(data)[1]])
            elseif operation(data)===sqrt
                # if data is a sqrt call, it might match with exponent 1//2
                T = vartype(arguments(data)[1])
                frankestein = Term{T}(^,[arguments(data)[1], 1//2])
            end

            if frankestein !==nothing
                result = loop(frankestein, bindings, matchers)
                result !== nothing && return success(result, 1)
            end

            return nothing
        end
        return pow_term_matcher
    # if we want to do commutative checks, i.e. call matcher with different order of the arguments
    elseif acSets!==nothing && (operation(term) === (+) || operation(term) === (*))
        has_segment = any([isa(unwrap_const(a),Segment) for a in arguments(term)])
        op = operation(term)
        function commutative_term_matcher(success, data, bindings)
            !islist(data) && return nothing # if data is not a list, return nothing
            data = car(data)
            !iscall(data) && return nothing # if first element is not a call, return nothing
            f = operation(data)
            op !== f && return nothing # if the operation of data is not the correct one, don't even try
            data_args = arguments(data)
            # if the number of arguments is different, and the rule doesnt have a segment, return nothing
            !has_segment && length(matchers)-1 !== length(data_args) && return nothing

            T = vartype(data)
            ST = symtype(data)
            if ST <: Number && length(data_args)<COMM_CHECKS_LIMIT[]
                for inds in acSets(eachindex(data_args), length(data_args))
                    candidate = Term{T}(f, @views data_args[inds]; type = ST)

                    result = loop(candidate, bindings, matchers)
                    result !== nothing && return success(result,1)
                end
            # if data does not subtype to number, it might not be commutative
            else
                # call the normal matcher
                result = loop(data, bindings, matchers)
                result !== nothing && return success(result, 1)
            end
            return nothing
        end
        return commutative_term_matcher
    # if the operation is sqrt, we have to match also ^(1//2)
    elseif operation(term)==sqrt
        function sqrt_matcher(success, data, bindings)
            !islist(data) && return nothing # if data is not a list, return nothing
            data = car(data)
            !iscall(data) && return nothing # if first element is not a call, return nothing

            # do the normal matcher
            result = loop(data, bindings, matchers)
            result !== nothing && return success(result, 1)

            if (operation(data) === ^) && (unwrap_const(arguments(data)[2]) === 1//2)
                T = vartype(arguments(data)[1])
                frankestein = Term{T}(sqrt,[arguments(data)[1]])
                result = loop(frankestein, bindings, matchers)
                result !== nothing && return success(result, 1)
            end
            return nothing
        end
        return sqrt_matcher
    # if the operation is exp, we have to match also ℯ^
    elseif operation(term)==exp
        function exp_matcher(success, data, bindings)
            !islist(data) && return nothing # if data is not a list, return nothing
            data = car(data)
            !iscall(data) && return nothing # if first element is not a call, return nothing

            # do the normal matcher
            result = loop(data, bindings, matchers)
            result !== nothing && return success(result, 1)

            if (operation(data) === ^) && (unwrap_const(arguments(data)[1]) === ℯ)
                T = vartype(arguments(data)[2])
                frankestein = Term{T}(exp,[arguments(data)[2]])
                result = loop(frankestein, bindings, matchers)
                result !== nothing && return success(result, 1)
            end
            return nothing
        end
        return exp_matcher
    else
        function term_matcher(success, data, bindings)
            !islist(data) && return nothing # if data is not a list, return nothing
            !iscall(car(data)) && return nothing # if first element is not a call, return nothing

            result = loop(car(data), bindings, matchers)
            result !== nothing && return success(result, 1)
            return nothing
        end
        return term_matcher
    end
end

# creates a matcher for a term containing a defslot, such as:
# (~x + ...complicated pattern...)     *          ~!y
#    normal part (can bee a tree)   operation     defslot part

# Note: there is a bit of a waste here bc the matcher get created twice, both
# in the normal_matcher and in defslot_matcher and other_part_matcher
function defslot_term_matcher_constructor(term, acSets)
    a = parent(arguments(term))
    defslot_index = findfirst(x -> isa(unwrap_const(x), DefSlot), a) # find the defslot in the term
    defslot = unwrap_const(a[defslot_index])
    defslot_matcher = matcher(defslot, acSets)
    if length(a) == 2
        other_part_matcher = matcher(unwrap_const(a[defslot_index == 1 ? 2 : 1]), acSets)
    else
        # if we hare here the operation is a multiplication or sum of n>2 terms
        # (because ^ cannot have more than 2 terms).
        # creates the term matcher of the multiplication or sum of n-1 terms
        others = [a[i] for i in eachindex(a) if i != defslot_index]
        T = vartype(term)
        f = operation(term)
        other_part_matcher = term_matcher_constructor(Term{T}(f, others), acSets)
    end

    normal_matcher = term_matcher_constructor(term, acSets)

    function defslot_term_matcher(success, data, bindings)
        !islist(data) && return nothing # if data is not a list, return nothing
        # call the normal matcher, with success function that returns the bindings (foo1)
        #                       <-foo1->
        result = normal_matcher((b,n)->b, data, bindings)
        result !== nothing && return success(result, 1)
        # if no match, try to match with a defslot.
        # checks whether it matches the normal part if yes executes foo2
        # foo2: adds the pair (default value name, default value) to the found bindings
        #       after checking predicate and presence in the bindings. If added
        #       successfully returns the bindings (foo3), otherwise return nothing
        #                           <-------------------foo2----------------------------------->
        #                                                  <-foo3->
        result = other_part_matcher((b,n)->defslot_matcher((b,n)->b, (defslot.defaultValue,), b), data, bindings)
        result !== nothing && return success(result, 1)
        nothing
    end
end

using .Rewriters
"""
  is_operation(f)
Returns a single argument anonymous function predicate, that returns `true` if and only if
the argument to the predicate satisfies `iscall` and `operation(x) == f`
"""
is_operation(f) = @nospecialize(x) -> iscall(x) && (operation(x) === f)

const CANONICALIZE_PLUS = (
    @rule(~x::isnotflat(+) => flatten_term(+, ~x)),
    @rule(~x::needs_sorting(+) => sort_args(+, ~x)),
    @ordered_acrule(~a::is_literal_number + ~b::is_literal_number => ~a + ~b),

    @acrule(*(~~x) + *(~β, ~~x) => *(1 + ~β, (~~x)...)),

    @acrule(~x + *(~β, ~x) => *(1 + ~β, ~x)),
    @acrule(*(~α::is_literal_number, ~x) + ~x => *(~α + 1, ~x)),
    @rule(+(~~x::hasrepeats) => +(merge_repeats(*, ~~x)...)),

    @ordered_acrule((~z::_iszero + ~x) => ~x),
    @rule(+(~x) => ~x),
)

const PLUS_DISTRIBUTE = (
    @acrule(*(~α, ~~x) + *(~β, ~~x) => *(~α + ~β, (~~x)...)),
    @acrule(*(~~x, ~α) + *(~~x, ~β) => *(~α + ~β, (~~x)...)),
)

const CANONICALIZE_TIMES = (
    @rule(~x::isnotflat(*) => flatten_term(*, ~x)),
    @rule(~x::needs_sorting(*) => sort_args(*, ~x)),

    @ordered_acrule(~a::is_literal_number * ~b::is_literal_number => ~a * ~b),
    @rule(*(~~x::hasrepeats) => *(merge_repeats(^, ~~x)...)),

    @acrule((~y)^(~n) * ~y => (~y)^(~n+1)),

    @ordered_acrule((~z::_isone  * ~x) => ~x),
    @ordered_acrule((~z::_iszero *  ~x) => ~z),
    @rule(*(~x) => ~x),
)

const MUL_DISTRIBUTE = Chain((
    @ordered_acrule((~x)^(~n) * (~x)^(~m) => (~x)^(~n + ~m)),
    @acrule((~y)^(~n) * ~y => (~y)^(~n + 1)),
))

const CANONICALIZE_POW = (
    @rule(^(*(~~x), ~y::_isinteger) => *(map(a->pow(a, ~y), ~~x)...)),
    @rule((((~x)^(~p::_isinteger))^(~q::_isinteger)) => (~x)^((~p)*(~q))),
    @rule(^(~x, ~z::_iszero) => 1),
    @rule(^(~x, ~z::_isone) => ~x),
    @rule(inv(~x) => 1/(~x)),
)

const POW_RULES = (
    @rule(^(~x::_isone, ~z) => 1),
    @rule(ℯ^(~x) => exp(~x)),
    @rule((~x)^(1//2) => sqrt(~x)),
)

const ASSORTED_RULES = (
    @rule(identity(~x) => ~x),
    @rule(-(~x) => -1*~x),
    @rule(-(~x, ~y) => ~x + -1(~y)),
    @rule(~x::_isone \ ~y => ~y),
    @rule(~x \ ~y => ~y / (~x)),
    @rule(one(~x) => one(symtype(~x))),
    @rule(zero(~x) => zero(symtype(~x))),
    @rule(conj(~x::_isreal) => ~x),
    @rule(real(~x::_isreal) => ~x),
    @rule(imag(~x::_isreal) => zero(symtype(~x))),
    @rule(ifelse(~x::is_literal_number, ~y, ~z) => ~x ? ~y : ~z),
    @rule(ifelse(~x, ~y, ~y) => ~y),
    @rule(ifelse_eager(~x::is_literal_number, ~y, ~z) => ~x ? ~y : ~z),
    @rule(ifelse_eager(~x, ~y, ~y) => ~y),
    @rule(ifelse_branching(~x::is_literal_number, ~y, ~z) => ~x ? ~y : ~z),
    @rule(ifelse_branching(~x, ~y, ~y) => ~y),
)

const TRIG_EXP_RULES = (
    @acrule(~r*~x::has_trig_exp + ~r*~y => ~r*(~x + ~y)),
    @acrule(~r*~x::has_trig_exp + -1*~r*~y => ~r*(~x - ~y)),
    @acrule(sin(~x)^2 + cos(~x)^2 => one(~x)),
    @acrule(sin(~x)^2 + -1        => -1*cos(~x)^2),
    @acrule(cos(~x)^2 + -1        => -1*sin(~x)^2),

    @acrule(cos(~x)^2 + -1*sin(~x)^2 => cos(2 * ~x)),
    @acrule(sin(~x)^2 + -1*cos(~x)^2 => -cos(2 * ~x)),
    @acrule(cos(~x) * sin(~x) => sin(2 * ~x)/2),

    @acrule(tan(~x)^2 + -1*sec(~x)^2 => one(~x)),
    @acrule(-1*tan(~x)^2 + sec(~x)^2 => one(~x)),
    @acrule(tan(~x)^2 +  1 => sec(~x)^2),
    @acrule(sec(~x)^2 + -1 => tan(~x)^2),

    @acrule(cot(~x)^2 + -1*csc(~x)^2 => one(~x)),
    @acrule(cot(~x)^2 +  1 => csc(~x)^2),
    @acrule(csc(~x)^2 + -1 => cot(~x)^2),

    @acrule(cosh(~x)^2 + -1*sinh(~x)^2 => one(~x)),
    @acrule(cosh(~x)^2 + -1            => sinh(~x)^2),
    @acrule(sinh(~x)^2 +  1            => cosh(~x)^2),

    @acrule(cosh(~x)^2 + sinh(~x)^2 => cosh(2 * ~x)),
    @acrule(cosh(~x) * sinh(~x) => sinh(2 * ~x)/2),

    @acrule(exp(~x) * exp(~y) => _iszero(~x + ~y) ? 1 : exp(~x + ~y)),
    @rule(exp(~x)^(~y) => exp(~x * ~y)),
)

const BOOLEAN_RULES = (
    @rule((true | (~x)) => true),
    @rule(((~x) | true) => true),
    @rule((false | (~x)) => ~x),
    @rule(((~x) | false) => ~x),
    @rule((true & (~x)) => ~x),
    @rule(((~x) & true) => ~x),
    @rule((false & (~x)) => false),
    @rule(((~x) & false) => false),

    @rule(!(~x) & ~x => false),
    @rule(~x & !(~x) => false),
    @rule(!(~x) | ~x => true),
    @rule(~x | !(~x) => true),
    @rule(xor(~x, !(~x)) => true),
    @rule(xor(~x, ~x) => false),

    @rule(~x == ~x => true),
    @rule(~x != ~x => false),
    @rule(~x < ~x => false),
    @rule(~x > ~x => false),

    # simplify terms with no symbolic arguments
    # e.g. this simplifies term(isodd, 3, type=Bool)
    # or term(!, false)
    @rule((~f)(~x::is_literal_number) => (~f)(~x)),
    # and this simplifies any binary comparison operator
    @rule((~f)(~x::is_literal_number, ~y::is_literal_number) => (~f)(~x, ~y)),
)

const NUMBER_SIMPLIFIER = RestartedChain((
    If(iscall, Chain(ASSORTED_RULES)),
    If(x -> !isadd(x) && is_operation(+)(x),
    Chain(CANONICALIZE_PLUS)),
    If(is_operation(+), Chain(PLUS_DISTRIBUTE)), # This would be useful even if isadd
    If(x -> !ismul(x) && is_operation(*)(x),
    Chain(CANONICALIZE_TIMES)),
    If(is_operation(*), MUL_DISTRIBUTE),
    If(x -> !ispow(x) && is_operation(^)(x),
    Chain(CANONICALIZE_POW)),
    If(is_operation(^), Chain(POW_RULES)),
))

const TRIG_EXP_SIMPLIFIER = Chain(TRIG_EXP_RULES)

const BOOLEAN_SIMPLIFIER = Chain(BOOLEAN_RULES)


function get_default_simplifier(; kw...)
    IfElse(has_trig_exp,
           Postwalk(IfElse(x->symtype(x) <: Number,
                           Chain((NUMBER_SIMPLIFIER, TRIG_EXP_SIMPLIFIER)),
                           If(x->symtype(x) <: Bool, BOOLEAN_SIMPLIFIER))
                    ; kw...),
           Postwalk(Chain((If(x->symtype(x) <: Number,
                              NUMBER_SIMPLIFIER),
                           If(x->symtype(x) <: Bool,
                              BOOLEAN_SIMPLIFIER)))
                    ; kw...))
end

# reduce overhead of simplify by defining these as constant
const serial_simplifier = If(iscall, Fixpoint(get_default_simplifier()))

threaded_simplifier(cutoff) = Fixpoint(get_default_simplifier(threaded=true,
                                                          thread_cutoff=cutoff))

const serial_expand_simplifier = If(iscall,
                                  Fixpoint(Chain((expand,
                                                  Fixpoint(get_default_simplifier())))))

import NaNMath
import SpecialFunctions: gamma, loggamma, erf, erfc, erfcinv, erfi, erfcx,
                         dawson, digamma, trigamma, invdigamma, polygamma,
                         airyai, airyaiprime, airybi, airybiprime, besselj0,
                         besselj1, bessely0, bessely1, besselj, bessely, besseli,
                         besselk, hankelh1, hankelh2, polygamma, beta, logbeta, expint,
                         expinti, sinint, cosint

const monadic = [deg2rad, rad2deg, asind, log1p, acsch,
                 acos, asec, acosh, acsc, cscd, log, tand, log10, csch, asinh,
                 abs2, cosh, sin, cos, atan, cospi, cbrt, acosd, acoth, acotd,
                 asecd, exp, acot, sqrt, sind, sinpi, asech, log2, tan, exp10,
                 sech, coth, asin, cotd, cosd, sinh, abs, csc, tanh, secd,
                 atand, sec, acscd, cot, exp2, expm1, atanh, gamma,
                 loggamma, erf, erfc, erfcinv, erfi, erfcx, dawson, digamma,
                 trigamma, invdigamma, polygamma, airyai, airyaiprime, airybi,
                 airybiprime, besselj0, besselj1, bessely0, bessely1, isfinite,
                 NaNMath.sin, NaNMath.cos, NaNMath.tan, NaNMath.asin, NaNMath.acos,
                 NaNMath.acosh, NaNMath.atanh, NaNMath.log, NaNMath.log2,
                 NaNMath.log10, NaNMath.lgamma, NaNMath.log1p, NaNMath.sqrt, sign,
                 signbit, ceil, floor, factorial, expint, expinti, sinint, cosint]

const diadic = [max, min, hypot, atan, NaNMath.atanh, mod, rem, copysign,
                besselj, bessely, besseli, besselk, hankelh1, hankelh2,
                polygamma, beta, logbeta, NaNMath.pow, expint]
const previously_declared_for = Set([])

const basic_monadic = [-, +]
const basic_diadic = [+, -, *, /, //, \, ^]
#######################################################

@inline function safe_eltype(T::TypeT)
    if T <: AbstractArray
        T.parameters[1]::TypeT
    else
        T
    end
end

@inline function promote_type_fast_path(T::TypeT, S::TypeT)
    if T === S
        return T
    elseif T <: S
        return S
    elseif S <: T
        return T
    else
        return promote_type(T, S)::TypeT
    end
end

assert_like(@nospecialize(f), @nospecialize(T)) = nothing
# a and b are objects, arguments gets recursively checked
function assert_like(f, T, a, b...)
    @nospecialize f T a b
    islike(a, T) || throw(ArgumentError(LazyString(
        "The function ", f, " cannot be applied to ", a,
        " which is not a ", T, "-like object.",
        " Define `islike(::", typeof(a), ", ::Type{", T,
        "}) = true` to enable this.")))
    assert_like(f, T, b...)
end

islike(a, T) = symtype(a) <: T

# TODO: keep domains tighter than this
"""
    @number_methods T unary_body binary_body [options]

Generate the standard arithmetic methods needed for a symbolic type `T`.
`unary_body` and `binary_body` are expressions evaluated with the generated
function and binary-operation variables in scope. `options` may be `nothing`,
`:skipbasics`, `:onlybasics`, or a vector expression naming operations to skip.

This is a developer macro for symbolic-type implementations. It performs no
runtime dispatch by itself; it emits methods for the numeric and symbolic
promotion combinations supported by `T`.
"""
function number_methods(T, rhs1, rhs2, options=nothing)
    exprs = []

    skip_basics = options !== nothing ? options == :skipbasics : false
    only_basics = options !== nothing ? options == :onlybasics : false
    skips = Meta.isexpr(options, [:vcat, :hcat, :vect]) ? Set(options.args) : []

    rhs2 = :($assert_like(f, Number, a, b); $rhs2)
    rhs1 = :($assert_like(f, Number, a); $rhs1)

    for f in (skip_basics ? diadic : only_basics ? basic_diadic : vcat(basic_diadic, diadic))
        nameof(f) in skips && continue
        for S in previously_declared_for
            push!(exprs, quote
                      (f::$(typeof(f)))(a::$T, b::$S) = $rhs2
                      (f::$(typeof(f)))(a::$S, b::$T) = $rhs2
                  end)
        end

        # TODO: modularize and make another macro?
        expr = quote
            (f::$(typeof(f)))(a::$T, b::$T) = $rhs2
            (f::$(typeof(f)))(a::$T, b::Real)   = $rhs2
            (f::$(typeof(f)))(a::Real, b::$T)   = $rhs2
            (f::$(typeof(f)))(a::$T, b::Number) = $rhs2
            (f::$(typeof(f)))(a::Number, b::$T) = $rhs2
        end

        push!(exprs, expr)

        # Fix method ambiguity error on NaNMath >= 1.0.2 and promotion of `Integer`s on NaNMath < 1.0.2
        if f === NaNMath.pow
            push!(exprs, :((f::$(typeof(f)))(a::$T, b::Integer) = a ^ b))
        end
    end

    for f in (skip_basics ? monadic : only_basics ? basic_monadic : vcat(basic_monadic, monadic))
        nameof(f) in skips && continue
        if f === isfinite
            push!(exprs, :((f::$(typeof(f)))(a::$T) = true))
        else
            push!(exprs, :((f::$(typeof(f)))(a::$T)   = $rhs1))
        end
    end
    push!(exprs, :(push!($previously_declared_for, $T)))
    Expr(:block, exprs...)
end

"""
    @number_methods T unary_body binary_body [options]

Emit arithmetic methods for `T` using the supplied unary and binary expression
bodies. See [`number_methods`](@ref) for the generated dispatch combinations
and supported `options` values.
"""
macro number_methods(T, rhs1, rhs2, options=nothing)
    number_methods(T, rhs1, rhs2, options) |> esc
end

@number_methods(BasicSymbolic{SymReal},
                Term{SymReal}(f, ArgsT{SymReal}((Const{SymReal}(a),)); type = promote_symtype(f, symtype(a))),
                Term{SymReal}(f, ArgsT{SymReal}((Const{SymReal}(a), Const{SymReal}(b))); type = promote_symtype(f, symtype(a), symtype(b))),
                # Avoid declaring for `exp` since matrix exponential method exists
                [+, -, *, /, //, \, ^, exp])
@number_methods(BasicSymbolic{TreeReal},
                Term{TreeReal}(f, ArgsT{TreeReal}((Const{TreeReal}(a),)); type = promote_symtype(f, symtype(a))),
                Term{TreeReal}(f, ArgsT{TreeReal}((Const{TreeReal}(a), Const{TreeReal}(b))); type = promote_symtype(f, symtype(a), symtype(b))))

for f in vcat(diadic, [+, -, *, ^, Base.add_sum, Base.mul_prod])
    @eval function promote_symtype(::$(typeof(f)), T::TypeT, S::TypeT)
        if T === S
            return T
        elseif T <: S
            return S
        elseif S <: T
            return T
        elseif $(f === (*) || f === Base.mul_prod) && T <: AdjointOrTranspose &&
                T.parameters[2]::TypeT <: AbstractVector && S <: AbstractVector
            # `Adjoint` and `Transpose` need special handling since `x'x` is a scalar
            return promote_symtype($f, T.parameters[1]::TypeT, S.parameters[1]::TypeT)
        elseif $(f === (*) || f === Base.mul_prod) && T <: AdjointOrTranspose
            wrapped_arr = T.parameters[2]::TypeT
            if wrapped_arr.parameters[2]::Int == 1
                # `AdjointOrTranspose{<:Vector} * anything` should stay an `Adjoint`
                # This mimics the behavior of e.g. `rand(3)' * rand(3, 4)` being an `Adjoint`
                pT = promote_symtype($f, wrapped_arr, S)
                return LinearAlgebra.Adjoint{pT.parameters[1]::TypeT, pT}
            else
                return promote_symtype($f, wrapped_arr, S)
            end
        elseif $(f === (*) || f === Base.mul_prod) && T <: Number && S <: AdjointOrTranspose
            # scalar * `AdjointOrTranspose` should retain the `Adjoint`
            # This handles a multiplication chain with interspersed scalars
            pT = promote_symtype($f, T, S.parameters[2]::TypeT)
            return LinearAlgebra.Adjoint{pT.parameters[1]::TypeT, pT}
        elseif T <: AbstractArray && !(T <: Array)
            return promote_symtype($f, Array{eltype(T), ndims(T)::Int}, S)
        elseif S <: AbstractArray && !(S <: Array)
            return promote_symtype($f, T, Array{eltype(S), ndims(S)::Int})
        elseif $(f === (*) || f === Base.mul_prod) && T <: AbstractVecOrMat && S <: AbstractVecOrMat
            return Array{promote_symtype(*, T.parameters[1]::TypeT, S.parameters[1]::TypeT), S.parameters[2]::Int}
        elseif $(f === (*) || f === Base.mul_prod) && T <: AbstractArray && S <: Number
            return Array{promote_symtype(*, T.parameters[1]::TypeT, S), T.parameters[2]::Int}
        elseif $(f === (*) || f === Base.mul_prod) && T <: Number && S <: AbstractArray
            return Array{promote_symtype(*, T, S.parameters[1]::TypeT), S.parameters[2]::Int}
        elseif $(f === (+) || f === Base.add_sum || f === (-)) && T <: AbstractArray && S <: AbstractArray
            nd = T.parameters[2]::Int
            @assert nd == S.parameters[2]::Int
            return Array{promote_symtype(+, T.parameters[1]::TypeT, S.parameters[1]::TypeT), nd}
        elseif $(f === (^)) && T <: Number && S <: AbstractArray
            nd = S.parameters[2]::Int
            @assert nd == 2
            return Matrix{promote_symtype(^, T, S.parameters[1]::TypeT)}
        elseif $(f === (^)) && T <: AbstractArray && S <: Number
            nd = T.parameters[2]::Int
            @assert nd == 2
            if S <: Integer
                return Matrix{T.parameters[1]::TypeT}
            else
                eT = promote_symtype(^, T.parameters[1]::TypeT, S)
                if eT <: Complex
                    return Matrix{eT}
                elseif eT === Number
                    return Matrix{Number}
                else
                    return Matrix{Complex{eT}}
                end
            end
        elseif T === BigInt && S === BigFloat
            return BigFloat
        elseif T === BigFloat && S === BigInt
            return BigFloat
        elseif T === BigInt
            return promote_symtype($f, Integer, S)
        elseif S === BigInt
            return promote_symtype($f, T, Integer)
        elseif T === BigFloat
            return promote_symtype($f, Real, S)
        elseif S === BigFloat
            return promote_symtype($f, T, Real)
        elseif T <: Rational && S <: Integer
            return Real
        elseif T <: Integer && S <: Rational
            return Real
        elseif T <: Complex{<:Rational} && S <: Integer
            return Complex{Real}
        elseif T <: Integer && S <: Complex{<:Rational}
            return Complex{Real}
        else
            return promote_type(T, S)::TypeT
        end
    end
end

for f in [/, \]
    @eval function promote_symtype(::$(typeof(f)), T::TypeT, S::TypeT)
        if T <: Integer && S <: Integer
            return Real
        elseif T <: Integer && S <: Rational
            return Real
        elseif T <: Rational && S <: Integer
            return Real
        elseif T <: AbstractArray && !(T <: Array)
            return promote_symtype($f, Array{eltype(T), ndims(T)::Int}, S)
        elseif S <: AbstractArray && !(S <: Array)
            return promote_symtype($f, T, Array{eltype(S), ndims(S)::Int})
        elseif $(f === (\)) && T <: Number && S <: AbstractArray
            return Array{promote_symtype(/, T, S.parameters[1]::TypeT), S.parameters[2]::Int}
        elseif $(f === (\)) && T <: AbstractVector && S <: AbstractVector
            return promote_symtype(/, T.parameters[1]::TypeT, S.parameters[1]::TypeT)
        elseif $(f === (\)) && T <: AbstractVecOrMat && S <: AbstractMatrix
            return Matrix{promote_symtype(/, T.parameters[1]::TypeT, S.parameters[1]::TypeT)}
        elseif $(f === (\)) && T <: AbstractMatrix && S <: AbstractVector
            return Vector{promote_symtype(/, T.parameters[1]::TypeT, S.parameters[1]::TypeT)}
        elseif $(f === (/)) && T <: AbstractVecOrMat && S <: AbstractVecOrMat
            # we don't actually care about specifically making the Mat/Vec case error because
            # `promote_shape` handles it with a much nicer error message than we can give here.
            return Matrix{promote_symtype(/, T.parameters[1]::TypeT, S.parameters[1]::TypeT)}
        elseif $(f === (/)) && T <: Number && S <: AbstractVector
            return Matrix{promote_symtype(/, T, S.parameters[1]::TypeT)}
        elseif $(f === (/)) && T <: AbstractArray && S <: Number
            return Array{promote_symtype(/, T.parameters[1]::TypeT, S), T.parameters[2]::Int}
        elseif T <: Complex && S <: Complex
            return Complex{promote_symtype(/, T.parameters[1]::TypeT, S.parameters[1]::TypeT)}
        elseif T <: Complex
            eT = promote_symtype(/, T.parameters[1]::TypeT, S)
            return eT === Number ? eT : Complex{eT}
        elseif S <: Complex
            eT = promote_symtype(/, T, S.parameters[1]::TypeT)
            return eT === Number ? eT : Complex{eT}
        else
            return promote_type(promote_type(T, S)::TypeT, Real)::TypeT
        end
    end
end

promote_symtype(::typeof(identity), T::TypeT) = T
promote_shape(::typeof(identity), @nospecialize(sh::ShapeT)) = sh

function _sequential_promote(T::TypeT, Ts::TypeT...)
    T = T === Nothing ? Union{} : T
    for _T in Ts
        _T === Nothing && continue
        T = promote_type(T, _T)::TypeT
    end
    return T::TypeT
end


function promote_symtype(::typeof(tuple), Ts::TypeT...)
    return Tuple{Ts...}::TypeT
end
function promote_shape(::typeof(tuple), @nospecialize(shs::ShapeT...))
    return ShapeVecT((1:length(shs),))
end

function promote_symtype(::typeof(array_literal), Tp::TypeT, Ts::TypeT...)
    @assert Tp <: Tuple
    return Array{_sequential_promote(Ts...), length(Tp.parameters)}
end

function promote_symtype(::Type{T}, args::TypeT...) where {T <: StaticArraysCore.StaticArray}
    # We don't gain anything by making the symtype `SArray`, just more cases to handle
    return Array{_sequential_promote(args...), ndims(T)}
end

function promote_shape(::Type{T}, @nospecialize(shs::ShapeT...)) where {T <: StaticArraysCore.StaticArray}
    return ShapeVecT((:).(1, size(T)))
end

promote_symtype(::typeof(rem2pi), T::TypeT, mode::TypeT) = T

@noinline function _throw_array(f, shs...)
    throw(ArgumentError(LazyString("Invalid shapes for ", f, ": ", shs, ".")))
end

for f in diadic
    f === NaNMath.pow && continue
    @eval function promote_shape(::$(typeof(f)), sh1::ShapeT, sh2::ShapeT)
        @nospecialize sh1 sh2
        is_array_shape(sh1) && _throw_array($f, sh1, sh2)
        is_array_shape(sh2) && _throw_array($f, sh1, sh2)
        return ShapeVecT()
    end
end
promote_shape(::typeof(NaNMath.pow), @nospecialize(shs::ShapeT...)) = promote_shape(^, shs...)

for f in monadic
    if f === log || f === NaNMath.log
        @eval function promote_shape(::$(typeof(f)), sh::ShapeT)
            @nospecialize sh
            if sh isa Unknown
                sh.ndims == -1 && return sh
                sh.ndims == 2 && return sh
            elseif sh isa ShapeVecT
                length(sh) == 0 && return sh
                length(sh) == 2 && return sh
            end
            _throw_array($f, sh)
        end
    elseif f !== exp
        @eval function promote_shape(::$(typeof(f)), sh::ShapeT)
            @nospecialize sh
            is_array_shape(sh) && _throw_array($f, sh)
            return ShapeVecT()
        end
    end
end

function promote_symtype(::typeof(exp), T::TypeT)
    if T === Real
        return Real
    elseif T === Number
        return Number
    elseif T <: Integer
        return Real
    elseif T <: Rational
        return Real
    elseif T <: Complex
        return Complex{promote_symtype(exp, T.parameters[1]::TypeT)}
    elseif T <: Number
        return T
    elseif T <: Array
        eT = T.parameters[1]::TypeT
        eT <: Number || error_f_symbolic(exp, T)
        nd = T.parameters[2]::Int
        nd == 2 || error_f_symbolic(exp, T)
        return Array{promote_symtype(exp, eT), nd}
    elseif T <: AdjointOrTranspose
        eT = T.parameters[1]::TypeT
        eT <: Number || error_f_symbolic(exp, T)
        eT = promote_symtype(exp, eT)
        # We can always assume the second type parameter is a matrix, since vectors aren't
        # square and then `promote_shape` will error. The exception is 1-vectors, in which
        # case this doesn't really matter since the `exp` is a `Matrix` so `exp(v')v` won't
        # be a scalar anyway.
        return LinearAlgebra.Adjoint{eT, Matrix{eT}}
    elseif T <: AbstractMatrix
        return Matrix{promote_symtype(exp, T.parameters[1]::TypeT)}
    else
        error_f_symbolic(exp, T)
    end
end

@noinline function _throw_not_square(sh)
    throw(ArgumentError(LazyString("Expected square matrix, got argument of shape ", sh)))
end

function promote_shape(::typeof(exp), sh::ShapeT)
    @nospecialize sh
    if sh isa Unknown
        sh.ndims == -1 || sh.ndims == 2 || _throw_not_matrix(sh)
        return sh
    elseif sh isa ShapeVecT
        length(sh) == 0 && return sh
        length(sh) == 2 || _throw_not_matrix(sh)
        length(sh[1]) == length(sh[2]) || _throw_not_square(sh)
        return sh
    end
    _unreachable()
end

function Base.exp(x::BasicSymbolic{T}) where {T}
    type = promote_symtype(exp, symtype(x))
    sh = promote_shape(exp, shape(x))
    return BSImpl.Term{T}(exp, ArgsT{T}((x,)); type, shape = sh)
end

error_f_symbolic(f, T) = error(LazyString(f, " is not defined for ", T, "."))

function promote_shape(::typeof(rem2pi), sha::ShapeT, shb::ShapeT)
    is_array_shape(sha) && _throw_array(rem2pi, sha, shb)
    ShapeVecT()
end
function Base.rem2pi(x::BasicSymbolic{T}, mode::Base.RoundingMode) where {T}
    type = symtype(x)
    type <: Number || error_f_symbolic(rem2pi, type)
    return Term{T}(rem2pi, ArgsT{T}((x, Const{T}(mode))); type)
end

function promote_symtype(::typeof(inv), T::TypeT)
    if T <: Number
        return promote_symtype(/, T, T)
    elseif T <: AbstractMatrix
        return Matrix{promote_symtype(/, T.parameters[1]::TypeT)}
    else
        error(LazyString("Cannot call `inv` on ", T, "."))
    end
end
function promote_shape(::typeof(inv), sh::ShapeT)
    @nospecialize sh
    if sh isa Unknown
        sh.ndims == -1 && return sh
        sh.ndims == 2 && return sh
    elseif sh isa ShapeVecT
        length(sh) == 0 && return sh
        length(sh) == 2 && return ShapeVecT((sh[2], sh[1]))
    end
    _throw_array(inv, sh)
end

# Specially handle inv and literal pow
function Base.inv(x::BasicSymbolic{T}) where {T}
    sh = shape(x)
    type = promote_symtype(inv, symtype(x))
    if is_array_shape(sh)
        return Term{T}(inv, ArgsT{T}((x,)); type = type, shape = sh)
    else
        return x ^ (-1)
    end
end
function Base.literal_pow(::typeof(^), x::BasicSymbolic{T}, ::Val{p}) where {T, p}
    _numeric_or_arrnumeric_symtype(x) || error_f_symbolic(^, symtype(x))
    return Const{T}(x ^ p)
end
function promote_symtype(::typeof(Base.literal_pow), ::TypeT, T::TypeT, ::Type{Val{S}}) where {S}
    return promote_symtype(^, T, typeof(S))
end

promote_symtype(::Any, T) = promote_type(T, Real)
for f in monadic
    if f in [sign, signbit, ceil, floor, factorial, exp]
        continue
    end
    @eval function promote_symtype(::$(typeof(f)), T::TypeT)
        # equivalent to `promote_type(T, Real)`
        if T === Number
            return Number
        elseif T === Real
            return Real
        elseif T <: Complex
            return Complex{Real}
        else
            return Real
        end
    end
end

"""
promote_symtype(f::ComposedFunction, arg_symtypes::TypeT...)

Compute the symbolic type of applying a composed function to arguments.

For a composed function `f ∘ g ∘ h`, this computes the result type by propagating
type information from the innermost function outward:
1. Apply `h` to the input argument types
2. Use that result type as input to `g`
3. Use that result type as input to `f`

This implementation assumes each function returns a single value that becomes
the argument to the next function. Multi-argument returns (tuples) are not
currently supported but could be added if needed.
"""
function promote_symtype(f::Base.ComposedFunction, arg_symtypes::TypeT...)
    inner_result = promote_symtype(f.inner, arg_symtypes...)
    return promote_symtype(f.outer, inner_result)
end

for f in [one, zero, *, +, -]
    @eval promote_symtype(::$(typeof(f)), T::TypeT) = T
end

for f in [real, imag]
    @eval function promote_symtype(::$(typeof(f)), T::TypeT)
        if T <: Complex
            return T.parameters[1]::TypeT
        else
            return T
        end
    end
end
for f in [real, imag, conj]
    @eval function promote_shape(::typeof($f), sh::ShapeT)
        @nospecialize sh
        return sh
    end
end
function Base.real(s::BasicSymbolic{T}) where {T}
    islike(s, Real) && return s
    @match s begin
        BSImpl.Const(; val) => Const{T}(real(val))
        BSImpl.Term(; f, args) && if f === complex && length(args) == 2 end => args[1]
        _ => Term{T}(real, ArgsT{T}((s,)); type = Real)
    end
end
promote_symtype(::typeof(Base.conj), T::TypeT) = T
function Base.conj(s::BasicSymbolic{T}) where {T}
    eltype(symtype(s)) <: Real && return s
    @match s begin
        BSImpl.Const(; val) => Const{T}(conj(val))
        BSImpl.Term(; f, args, type, shape) && if f === complex && length(args) == 2 end => begin
            BSImpl.Term{T}(f, ArgsT{T}(args[1], -args[2]); type, shape)
        end
        _ => Term{T}(conj, ArgsT{T}((s,)); type = symtype(s), shape = shape(s))
    end
end
function Base.imag(s::BasicSymbolic{T}) where {T}
    islike(s, Real) && return zero_of_vartype(T)
    @match s begin
        BSImpl.Const(; val) => Const{T}(imag(val))
        BSImpl.Term(; f, args) && if f === complex && length(args) == 2 end => args[2]
        _ => Term{T}(imag, ArgsT{T}((s,)); type = Real)
    end
end

function promote_symtype(::typeof(adjoint), T::TypeT)
    if T <: Number
        return T
    elseif T <: AbstractVecOrMat
        return LinearAlgebra.Adjoint{T.parameters[1]::TypeT, T}
    else
        error(LazyString("Invalid type ", T, " for `adjoint`"))
    end
end

@noinline function _throw_adjont_vec_or_mat(sh)
    throw(ArgumentError(LazyString("`adjoint` is only applicable to vectors and matrices - found argument of shape ", sh, ".")))
end

function promote_shape(::typeof(adjoint), @nospecialize(sh::ShapeT))
    ndims = _ndims_from_shape(sh)
    ndims > 2 && _throw_adjont_vec_or_mat(sh)
    if sh isa Unknown
        ndims == 0 && _throw_adjont_vec_or_mat(sh)
        return Unknown(2)
    elseif sh isa ShapeVecT
        ndims == 0 && return ShapeVecT()
        return ShapeVecT((ndims == 1 ? (1:1) : sh[2], sh[1]))
    end
end

function Base.adjoint(s::BasicSymbolic{T}) where {T}
    @match s begin
        BSImpl.Const(; val) => return Const{T}(adjoint(val))
        _ => nothing
    end
    sh = shape(s)
    stype = symtype(s)
    if is_array_shape(sh)
        type = promote_symtype(adjoint, stype)
        newsh = promote_shape(adjoint, sh)
        return Term{T}(adjoint, ArgsT{T}((s,)); type, shape = newsh)
    elseif stype <: Real
        return s
    else
        return conj(s)
    end
end

promote_symtype(::typeof(transpose), T::TypeT) = promote_symtype(adjoint, T)
promote_shape(::typeof(transpose), @nospecialize(sh::ShapeT)) = promote_shape(adjoint, sh)

function Base.transpose(s::BasicSymbolic{T}) where {T}
    @match s begin
        BSImpl.Const(; val) => return Const{T}(transpose(val))
        _ => nothing
    end
    sh = shape(s)
    stype = symtype(s)
    if is_array_shape(sh)
        type = promote_symtype(transpose, stype)
        newsh = promote_shape(transpose, sh)
        return Term{T}(transpose, ArgsT{T}((s,)); type, shape = newsh)
    else
        return s
    end
end

## Booleans

function promote_symtype(::typeof(==), T::TypeT, S::TypeT)
    return Bool
end
function promote_shape(::typeof(==), sha::ShapeT, shb::ShapeT)
    @nospecialize sha shb
    return ShapeVecT()
end
function promote_symtype(::typeof(!=), T::TypeT, S::TypeT)
    return Bool
end
function promote_shape(::typeof(!=), sha::ShapeT, shb::ShapeT)
    @nospecialize sha shb
    return ShapeVecT()
end

macro __registered_and_body()
    return quote
        if _isone(x)
            return Const{T}(y)
        elseif _iszero(x)
            return Const{T}(x)
        elseif _isone(y)
            return Const{T}(x)
        elseif _iszero(y)
            return Const{T}(y)
        end
        return Term{T}(&, ArgsT{T}((x, y)); type = Bool, shape = ShapeVecT())
    end |> esc
end
macro __registered_or_body()
    return quote
        if _isone(x)
            return Const{T}(x)
        elseif _iszero(x)
            return Const{T}(y)
        elseif _isone(y)
            return Const{T}(y)
        elseif _iszero(y)
            return Const{T}(x)
        end
        return Term{T}(|, ArgsT{T}((x, y)); type = Bool, shape = ShapeVecT())
    end |> esc
end
macro __registered_xor_body()
    return quote
        if _iszero(x)
            return Const{T}(y)
        elseif _iszero(y)
            return Const{T}(x)
        end
        return Term{T}(xor, ArgsT{T}((x, y)); type = Bool, shape = ShapeVecT())
    end |> esc
end
function Base.:(&)(x::BasicSymbolic{T}, y::BasicSymbolic{T}) where {T}
    @__registered_and_body()
end
function Base.:(&)(x::BasicSymbolic{T}, y::Bool) where {T}
    @__registered_and_body()
end
function Base.:(&)(x::Bool, y::BasicSymbolic{T}) where {T}
    @__registered_and_body()
end
function Base.:(|)(x::BasicSymbolic{T}, y::BasicSymbolic{T}) where {T}
    @__registered_or_body()
end
function Base.:(|)(x::BasicSymbolic{T}, y::Bool) where {T}
    @__registered_or_body()
end
function Base.:(|)(x::Bool, y::BasicSymbolic{T}) where {T}
    @__registered_or_body()
end
function Base.xor(x::BasicSymbolic{T}, y::BasicSymbolic{T}) where {T}
    @__registered_xor_body()
end
function Base.xor(x::BasicSymbolic{T}, y::Bool) where {T}
    @__registered_xor_body()
end
function Base.xor(x::Bool, y::BasicSymbolic{T}) where {T}
    @__registered_xor_body()
end

# binary ops that return Bool
for (f, Domain) in [(==) => Number, (!=) => Number,
                    (<=) => Real,   (>=) => Real,
                    (isless) => Real,
                    (<) => Real,
                    (& ) => Bool,   (| ) => Bool,
                    xor => Bool]
    if f !== (==) && f !== (!=)
        @eval begin
            function promote_symtype(::$(typeof(f)), T::TypeT, S::TypeT)
                @assert T <: $Domain
                @assert S <: $Domain
                return Bool
            end
            function promote_shape(::$(typeof(f)), sha::ShapeT, shb::ShapeT)
                @nospecialize sha shb
                is_array_shape(sha) && _throw_array($f, sha, shb)
                is_array_shape(shb) && _throw_array($f, sha, shb)
                return ShapeVecT()
            end
        end
    end
    if f === (&) || f === (|) || f === xor
        continue
    end
    @eval begin
        function (::$(typeof(f)))(a::BasicSymbolic{T}, b::$Domain) where {T}
            if !(symtype(a) <: $Domain)
                throw(MethodError($f, (a, b)))
            end
            Term{T}($f, ArgsT{T}((a, Const{T}(b))); type = Bool)
        end
        function (::$(typeof(f)))(a::$Domain, b::BasicSymbolic{T}) where {T}
                if !(symtype(b) <: $Domain)
                    throw(MethodError($f, (a, b)))
                end
                Term{T}($f, ArgsT{T}((Const{T}(a), b)); type = Bool)
        end
        function (::$(typeof(f)))(a::BasicSymbolic{T}, b::BasicSymbolic{T}) where {T}
                if !(symtype(b) <: $Domain) || !(symtype(a) <: $Domain)
                    throw(MethodError($f, (a, b)))
                end
                Term{T}($f, ArgsT{T}((a, b)); type = Bool)
        end
    end
end

for f in [!, ~]
    @eval begin
        function promote_symtype(::$(typeof(f)), T::TypeT)
            @assert T === Bool
            Bool
        end
        function promote_shape(::$(typeof(f)), sha::ShapeT)
            @nospecialize sha
            is_array_shape(sha) && _throw_array($f, sha)
            return ShapeVecT()
        end
        function (::$(typeof(f)))(s::BasicSymbolic{T}) where {T}
            if _isone(s)
                return Const{T}(false)
            elseif _iszero(s)
                return Const{T}(true)
            end
            type = symtype(s)
            if type !== Bool
                throw(MethodError(!, (s,)))
            end
            Term{T}(!, ArgsT{T}((s,)); type)
        end
    end
end


# An ifelse node
function Base.ifelse(_if::BasicSymbolic{T}, _then, _else) where {T}
    if _isone(_if)
        return _then
    elseif _iszero(_if)
        return _else
    elseif isconst(_then) && isconst(_else) && unwrap_const(_then) === true && unwrap_const(_else) === false
        return _if
    elseif isconst(_then) && isconst(_else) && unwrap_const(_then) === false && unwrap_const(_else) === true
        return !_if
    end
    type = promote_symtype(ifelse, symtype(_if), symtype(_then), symtype(_else))
    sh = promote_shape(ifelse, shape(_if), shape(_then), shape(_else))
    Term{T}(ifelse, ArgsT{T}((_if, _then, _else)); type, shape = sh)
end
function promote_symtype(::typeof(ifelse), C::TypeT, T::TypeT, S::TypeT)
    C === Bool || throw(ArgumentError("Condition of `ifelse` must be a `Bool`"))
    return promote_type_fast_path(T, S)
end
function promote_shape(::typeof(ifelse), shc::ShapeT, sht::ShapeT, shf::ShapeT)
    @nospecialize shc sht shf
    is_array_shape(shc) && error("Condition of `ifelse` cannot be an array.")
    sht == shf || error("Both branches of `ifelse` must have the same shape.")
    return sht
end

"""
    ifelse_eager(cond, x, y)

Conditional that builds the same kind of symbolic expression as `ifelse`, but **always lowers
to an eager `ifelse` call** during code generation: both branches `x` and `y` are evaluated
unconditionally and `cond` selects between the computed values.

Use it when both branches are always valid to evaluate and branch-free code is desirable (e.g.
to keep generated code vectorizable/SIMD-friendly or GPU-divergence-free). Contrast with
[`ifelse_branching`](@ref), which never evaluates the untaken branch.

`ifelse`, `ifelse_eager` and `ifelse_branching` differ only in how code generation lowers them;
`ifelse` is the default and is intended to eventually pick a strategy via a cost heuristic.
"""
ifelse_eager(cond, x, y) = ifelse(cond, x, y)

"""
    ifelse_branching(cond, x, y)

Conditional that builds the same kind of symbolic expression as `ifelse`, but **always lowers
to an `if`/`else` branch** during code generation, so that only the taken branch is evaluated.
The untaken branch's code is emitted inside the branch and is never executed when `cond`
selects the other branch — even under common-subexpression elimination (`ifelse_branching`
opts out of CSE for the conditional via `cse_inside_expr`).

Use it when a branch is only valid to evaluate when its condition holds (it divides by a
quantity that is zero otherwise, indexes into something that does not exist, errors, or
produces `NaN`/`Inf`). Contrast with [`ifelse_eager`](@ref), which evaluates both branches.

`ifelse`, `ifelse_eager` and `ifelse_branching` differ only in how code generation lowers them;
`ifelse` is the default and is intended to eventually pick a strategy via a cost heuristic.

While the branch interiors are excluded from common subexpression elimination (hoisting them
would defeat the laziness), the conditional itself is still bound by CSE (see
`cse_bind_expr`), so multiple references to one `ifelse_branching` expression share a
single `if`/`else`.
"""
ifelse_branching(cond, x, y) = cond ? x : y

# Symbolic nodes and type/shape promotion for the two variants mirror `ifelse`.
for op in (:ifelse_eager, :ifelse_branching)
    @eval begin
        function $op(_if::BasicSymbolic{T}, _then, _else) where {T}
            type = promote_symtype($op, symtype(_if), symtype(_then), symtype(_else))
            sh = promote_shape($op, shape(_if), shape(_then), shape(_else))
            Term{T}($op, ArgsT{T}((_if, _then, _else)); type, shape = sh)
        end
        function promote_symtype(::typeof($op), C::TypeT, T::TypeT, S::TypeT)
            return promote_symtype(ifelse, C, T, S)
        end
        function promote_shape(::typeof($op), shc::ShapeT, sht::ShapeT, shf::ShapeT)
            @nospecialize shc sht shf
            return promote_shape(ifelse, shc, sht, shf)
        end
    end
end

# Array-like operations
Base.IndexStyle(::Type{<:BasicSymbolic}) = Base.IndexCartesian()
function _size_from_shape(shape::ShapeT)
    @nospecialize shape
    if shape isa Unknown
        return shape
    else
        return Tuple(map(length, shape))
    end
end
Base.size(x::BasicSymbolic) = _size_from_shape(shape(x))
function Base.size(x::BasicSymbolic, i::Integer)
    sh = shape(x)
    if sh isa Unknown
        return sh
    elseif sh isa ShapeVecT
        return length(sh[i])
    end
    _unreachable()
end
Base.axes(x::BasicSymbolic) = Tuple(shape(x))
Base.axes(x::BasicSymbolic, i::Integer) = shape(x)[i]
function _length_from_shape(sh::ShapeT)
    @nospecialize sh
    if sh isa Unknown
        return sh
    else
        len = 1
        for dim in sh
            len *= length(dim)
        end
        return len
    end
end
Base.length(x::BasicSymbolic) = _length_from_shape(shape(x))
function _ndims_from_shape(sh::ShapeT)
    @nospecialize sh
    if sh isa Unknown
        return sh.ndims
    else
        return length(sh)
    end
end
Base.ndims(x::BasicSymbolic) = _ndims_from_shape(shape(x))
Base.broadcastable(x::BasicSymbolic) = is_array_shape(shape(x)) ? x : Ref(x)
function Base.eachindex(x::BasicSymbolic)
    sh = shape(x)
    if sh isa Unknown
        throw(ArgumentError(LazyString("Indices of variable ", x, " with unknown shape ", sh, " are not defined.")))
        # throw(ArgumentError("Indices of variable $x with unknown shape $sh are not defined."))
    end
    CartesianIndices(Tuple(sh))
end

"""
    $TYPEDEF

An iterator that produces [`StableIndex`](@ref) values representing all possible
multi-dimensional indices for a given shape in a type-stable, allocation-efficient manner.

This type is used to iterate over multi-dimensional index spaces where each
dimension can have its own range (stored in `sh`). The iterator produces all
combinations of indices in column-major order, similar to `CartesianIndices`,
but with better type stability and allocation characteristics.

This is similar to `CartesianIndices` for symbolic arrays, but avoids type-instability due
to the type parameters of `CartesianIndices` being uninferrable. Note that iterator
iterates over multidimensional indices, but is not a multidimensional iterator. In other
words, `collect`ing this iterator will return a vector regardless of the number of
dimensions it iterates over.

# Fields
$TYPEDFIELDS

# Examples
```julia
sh = ShapeVecT([1:2, 1:3])
indices = StableIndices(sh)
for idx in indices
    # idx is a StableIndex with values like [1,1], [1,2], [1,3], [2,1], [2,2], [2,3]
end
```

# See also
- [`StableIndex`](@ref): The index type produced by this iterator.
- [`stable_eachindex`](@ref): Convenience function that returns a `StableIndices` iterator for a symbolic array.
"""
struct StableIndices
    """
    A small vector of `UnitRange{Int}` values, one for each dimension, defining the range
    of valid indices for that dimension.
    """
    sh::ShapeVecT
end

Base.length(x::StableIndices) = prod(length, x.sh; init = 1)
Base.eltype(::Type{StableIndices}) = StableIndex{Int}
Base.keys(x::StableIndices) = Base.OneTo(length(x))

function Base.iterate(x::StableIndices)
    idx = SmallV{Int}()
    resize!(idx, length(x.sh))
    for i in eachindex(x.sh)
        idx[i] = first(x.sh[i])
    end
    idx = StableIndex(idx)
    return idx, idx
end
function Base.iterate(x::StableIndices, st::StableIndex)
    idxs = st.idxs
    buffer = copy(idxs)
    i = 1
    N = length(x.sh)
    while i <= N
        buffer[i] += 1
        buffer[i] > last(x.sh[i]) || break
        buffer[i] = first(x.sh[i])
        i += 1
    end
    i <= N || return nothing
    idxs = StableIndex(buffer)
    return idxs, idxs
end
function Base.getindex(x::StableIndices, idx::Integer)
    buffer = SmallV{Int}()
    N = length(x.sh)
    idx -= 1
    for i in 1:N
        push!(buffer, idx % length(x.sh[i]) + first(x.sh[i]))
        idx ÷= length(x.sh[i])
    end
    return StableIndex(buffer)
end

"""
    $TYPEDSIGNATURES

Returns a type-stable iterator over all indices of a symbolic array `x`.

This function provides an efficient, allocation-friendly way to iterate over
multi-dimensional symbolic arrays. Unlike `Base.eachindex`, which returns
`CartesianIndices` with type parameters that may be uninferrable for symbolic
arrays, `stable_eachindex` returns a [`StableIndices`](@ref) iterator that
produces [`StableIndex`](@ref) values in a fully type-stable manner.

Note that the returned iterator does not match the shape of `x`. In other
words, `collect(stable_eachindex(x))` will be a vector regardless of the shape
of `x`.

# Arguments
- `x::BasicSymbolic`: A symbolic array expression with a known concrete shape.

# Returns
- `StableIndices`: An iterator that yields `StableIndex` values for each position in the array.

# Throws
- This function assumes `x` has a concrete shape (i.e., `shape(x)` is a `ShapeVecT`,
  not `Unknown`). If the shape is unknown, it will error.

# Examples
```julia
using SymbolicUtils

# Create a symbolic 2×3 matrix
@variables x[1:2, 1:3]

# Iterate over all indices in a type-stable manner
for idx in stable_eachindex(x)
    println("Index: ", idx, " -> Value: ", x[idx])
end

# Compare with regular eachindex
for idx in eachindex(x)  # Returns CartesianIndices
    println("Index: ", idx, " -> Value: ", x[idx])
end
```

# See also
- [`StableIndices`](@ref): The iterator type returned by this function
- [`StableIndex`](@ref): The index type produced by `StableIndices`
- `Base.eachindex`: The standard Julia function for iterating over array indices
"""
function stable_eachindex(x::BasicSymbolic)
    StableIndices(shape(x)::ShapeVecT)
end
function Base.collect(x::BasicSymbolic)
    scalarize(x, Val{true}())
end
function Base.iterate(x::BasicSymbolic)
    sh = shape(x)
    is_array_shape(sh) || return x, nothing
    idxs = eachindex(x)
    idx, state = iterate(idxs)
    return x[idx], (idxs, state)
end
function Base.iterate(x::BasicSymbolic, _state)
    _state === nothing && return nothing
    idxs, state = _state
    innerstate = iterate(idxs, state)
    innerstate === nothing && return nothing
    idx, state = innerstate
    return x[idx], (idxs, state)
end
function Base.isempty(x::BasicSymbolic)
    sh = shape(x)
    if sh isa Unknown
        return false
    elseif sh isa ShapeVecT
        return _length_from_shape(sh) == 0
    end
    _unreachable()
end

promote_symtype(::Type{CartesianIndex}, xs::TypeT...) = CartesianIndex{length(xs)}
promote_symtype(::Type{CartesianIndex{N}}, xs::Vararg{TypeT, N}) where {N} = CartesianIndex{N}
function promote_shape(::Type{CartesianIndex}, xs::ShapeT...)
    @nospecialize xs
    @assert all(!is_array_shape, xs)
    return ShapeVecT((1:length(xs),))
end
function promote_shape(::Type{CartesianIndex{N}}, xs::Vararg{ShapeT, N}) where {N}
    @nospecialize xs
    @assert all(!is_array_shape, xs)
    return ShapeVecT((1:length(xs),))
end
function Base.CartesianIndex(x::BasicSymbolic{T}, xs::BasicSymbolic{T}...) where {T}
    @assert symtype(x) <: Integer
    @assert all(x -> symtype(x) <: Integer, xs)
    type = promote_symtype(CartesianIndex, symtype(x), symtype.(xs)...)
    sh = promote_shape(CartesianIndex, shape(x), shape.(xs)...)
    BSImpl.Term{T}(CartesianIndex{length(xs) + 1}, ArgsT{T}((x, xs...)); type, shape = sh)
end

for (f, vT) in [(sign, Number), (ceil, Number), (floor, Number), (factorial, Integer)]
    @eval function promote_symtype(::typeof($f), T::TypeT)
        @assert T <: $vT
        return T
    end
end

function promote_symtype(::typeof(signbit), T::TypeT)
    @assert T <: Number
    return Bool
end

function promote_symtype(::typeof(clamp),
                         T::TypeT,
                         S::TypeT,
                         R::TypeT)
    if T <: Number && S <: Number && R <: Number
        return promote_type_fast_path(T, promote_type_fast_path(S, R))
    elseif T <: AbstractVector && S <: AbstractVector && R <: AbstractVector
        return Vector{promote_symtype(clamp, T.parameters[1]::TypeT, S.parameters[1]::TypeT, R.parameters[1]::TypeT)}
    else
        error(LazyString("Invalid types for `clamp`: ", T, ", ", S, ", ", R, "."))
    end
end

function promote_shape(::typeof(clamp), sh1::ShapeT, sh2::ShapeT, sh3::ShapeT)
    @nospecialize sh1 sh2 sh3
    nd1 = _ndims_from_shape(sh1)
    nd2 = _ndims_from_shape(sh2)
    nd3 = _ndims_from_shape(sh3)
    maxd = max(nd1, nd2, nd3)
    @assert maxd <= 1
    if maxd >= 0
        @assert nd1 == -1 || nd1 == maxd
        @assert nd2 == -1 || nd2 == maxd
        @assert nd3 == -1 || nd3 == maxd
    end
    if maxd == 0
        return ShapeVecT()
    elseif sh1 isa ShapeVecT
        return ShapeVecT((1:length(sh1[1])))
    elseif sh2 isa ShapeVecT
        return ShapeVecT((1:length(sh2[1])))
    elseif sh3 isa ShapeVecT
        return ShapeVecT((1:length(sh3[1])))
    else
        return Unknown(1)
    end
end

for valT in [Number, AbstractVector{<:Number}]
    for (T1, T2, T3) in Iterators.product(Iterators.repeated((valT, :(BasicSymbolic{T})), 3)...)
        if T1 == T2 == T3 == valT
            continue
        end
        if valT != Number && T1 == T2 == T3
            continue
        end
        @eval function Base.clamp(a::$T1, b::$T2, c::$T3) where {T}
            isconst(a) && isconst(b) && isconst(c) && return Const{T}(clamp(unwrap_const(a), unwrap_const(b), unwrap_const(c)))
            sh = promote_shape(clamp, shape(a), shape(b), shape(c))
            type = promote_symtype(clamp, symtype(a), symtype(b), symtype(c))
            return BSImpl.Term{T}(clamp, ArgsT{T}((Const{T}(a), Const{T}(b), Const{T}(c))); type, shape = sh)
        end
    end
end

"""
    SymBroadcast{T}

Broadcast style for `BasicSymbolic{T}` expressions. It keeps symbolic arrays in
the symbolic broadcast path and rejects broadcasts that combine incompatible
symbolic variants.
"""
struct SymBroadcast{T <: SymVariant} <: Broadcast.BroadcastStyle end
Broadcast.BroadcastStyle(::Type{BasicSymbolic{T}}) where {T} = SymBroadcast{T}()
Broadcast.BroadcastStyle(::SymBroadcast{T}, ::Broadcast.BroadcastStyle) where {T} = SymBroadcast{T}()
Broadcast.BroadcastStyle(::SymBroadcast{T}, ::SymBroadcast{T}) where {T} = SymBroadcast{T}()
function Broadcast.BroadcastStyle(::SymBroadcast{T}, ::SymBroadcast{R}) where {T, R}
    throw(ArgumentError(LazyString("Cannot broadcast symbolics of different `vartype`s ", T, " and ", R, ".")))
end

mutable struct BroadcastBuffer{T}
    canonical_args::Vector{BasicSymbolic{T}}
    args::ArgsT{T}
    getindex_args::ArgsT{T}
end

BroadcastBuffer{T}() where {T} = BroadcastBuffer{T}(BasicSymbolic{T}[], ArgsT{T}(), ArgsT{T}())

function Base.empty!(bb::BroadcastBuffer)
    empty!(bb.canonical_args)
    empty!(bb.args)
    empty!(bb.getindex_args)
    return bb
end

function maybe_reallocate_getindex_buffer!(bb::BroadcastBuffer{T}, term::BasicSymbolic{T}) where {T}
    @match term begin
        BSImpl.Term(; args) && if args === bb.getindex_args end => begin
            bb.getindex_args = ArgsT{T}()
        end
        _ => empty!(bb.getindex_args)
    end
    return nothing
end
function maybe_reallocate_args_buffer!(bb::BroadcastBuffer{T}, term::BasicSymbolic{T}) where {T}
    @match term begin
        BSImpl.Term(; args) && if args === bb.args end => begin
            bb.args = ArgsT{T}()
        end
        _ => empty!(bb.args)
    end
    return nothing
end

const SYMREAL_BROADCAST_BUFFER = TaskLocalValue{BroadcastBuffer{SymReal}}(BroadcastBuffer{SymReal})
const SAFEREAL_BROADCAST_BUFFER = TaskLocalValue{BroadcastBuffer{SafeReal}}(BroadcastBuffer{SafeReal})
const TREEREAL_BROADCAST_BUFFER = TaskLocalValue{BroadcastBuffer{TreeReal}}(BroadcastBuffer{TreeReal})

broadcast_buffer(::Type{SymReal}) = SYMREAL_BROADCAST_BUFFER[]
broadcast_buffer(::Type{SafeReal}) = SAFEREAL_BROADCAST_BUFFER[]
broadcast_buffer(::Type{TreeReal}) = TREEREAL_BROADCAST_BUFFER[]

function Broadcast.copy(bc::Broadcast.Broadcasted{SymBroadcast{T}}) where {T}
    buffer = broadcast_buffer(T)
    empty!(buffer)
    _copy_broadcast!(buffer, bc)
end

function _copy_broadcast!(buffer::BroadcastBuffer{T}, bc::Broadcast.Broadcasted{SymBroadcast{T}, A, typeof(Base.literal_pow), Tuple{Base.RefValue{typeof(^)}, B, Base.RefValue{Val{N}}}}) where {T, A, B, N}
    _copy_broadcast!(buffer, Broadcast.Broadcasted{SymBroadcast{T}}(^, (bc.args[2], N), bc.axes))
end

function _copy_broadcast!(buffer::BroadcastBuffer{T}, bc::Broadcast.Broadcasted{SymBroadcast{T}}) where {T}
    offset = length(buffer.canonical_args)
    for arg in bc.args
        if arg isa Broadcast.Broadcasted
            push!(buffer.canonical_args, _copy_broadcast!(buffer, Broadcast.instantiate(arg)))
        elseif arg isa Base.RefValue
            push!(buffer.canonical_args, Const{T}(arg[]))
        else
            push!(buffer.canonical_args, Const{T}(arg))
        end
    end
    canonical_args = view(buffer.canonical_args, (offset+1):(offset+length(bc.args)))
    # Do the thing here
    ndim = length(bc.axes)
    if ndim == 0
        return maketerm(BasicSymbolic{T}, bc.f, bc.args, nothing)
    end
    subscripts = idxs_for_arrayop(T)

    args = buffer.args

    for arg in canonical_args
        sh = shape(arg)
        is_arr = is_array_shape(sh)
        if !is_arr
            push!(args, arg)
            continue
        end
        getindex_args = buffer.getindex_args
        push!(getindex_args, arg)
        if sh isa Unknown
            # unknown ndims, assume full shape
            limit = sh.ndims == -1 ? ndim : sh.ndims
            for i in 1:limit
                push!(getindex_args,  length(bc.axes[i]) == 1 ? one_of_vartype(T) : subscripts[i])
            end
        elseif sh isa ShapeVecT
            for (i, (target_ax, cur_ax)) in enumerate(zip(bc.axes, sh))
                len1 = length(cur_ax)
                len2 = length(target_ax)
                push!(getindex_args, len1 < len2 ? Const{T}(first(cur_ax)) : subscripts[i])
            end
        end
        # manual construction is faster than calling `getindex`
        indexed_arg = Term{T}(getindex, getindex_args; type = eltype(symtype(arg)), shape = ShapeVecT())
        maybe_reallocate_getindex_buffer!(buffer, indexed_arg)
        push!(args, indexed_arg)
    end
    output_idxs = OutIdxT{T}()
    for (i, ax) in enumerate(bc.axes)
        push!(output_idxs, length(ax) == 1 ? 1 : subscripts[i])
    end
    expr = maketerm(BasicSymbolic{T}, bc.f, args, nothing)
    maybe_reallocate_args_buffer!(buffer, expr)
    args = buffer.args
    push!(args, Const{T}(bc.f))
    for arg in canonical_args
        push!(args, Const{T}(arg))
    end
    sh = ShapeVecT()
    for ax in bc.axes
        push!(sh, 1:length(ax))
    end
    type = Array{eltype(symtype(expr)), ndim}
    term = Term{T}(broadcast, args; type, shape = sh)
    maybe_reallocate_args_buffer!(buffer, term)
    resize!(buffer.canonical_args, length(buffer.canonical_args) - length(bc.args))

    return BSImpl.ArrayOp{T}(output_idxs, expr, +, term; type, shape = sh)
end

@noinline function _throw_unequal_lengths(x, y)
    throw(ArgumentError(LazyString("Arguments must have equal lengths. Got arguments with shapes ", x, " and ", y, ".")))
end

function promote_shape(::typeof(LinearAlgebra.dot), sha::ShapeT, shb::ShapeT)
    @nospecialize sha shb
    if sha isa ShapeVecT && shb isa ShapeVecT
        _length_from_shape(sha) == _length_from_shape(shb)
    end
    ShapeVecT()
end

function promote_symtype(::typeof(LinearAlgebra.dot), T::TypeT, S::TypeT)
    if T <: Number && S <: Number
        return promote_type_fast_path(T, S)
    elseif T <: AbstractArray && S <: AbstractArray
        return promote_symtype(LinearAlgebra.dot, T.parameters[1]::TypeT, S.parameters[1]::TypeT)
    else
        error(LazyString("Invalid types for `LinearAlgebra.dot`: ", T, ", ", S, "."))
    end
end

function LinearAlgebra.dot(x::BasicSymbolic{T}, y::BasicSymbolic{T}) where {T}
    shx = shape(x)
    if is_array_shape(shx)
        sh = promote_shape(LinearAlgebra.dot, shx, shape(y))
        type = promote_symtype(LinearAlgebra.dot, symtype(x), symtype(y))
        BSImpl.Term{T}(LinearAlgebra.dot, ArgsT{T}((x, y)); type, shape = sh)
    else
        conj(x) * y
    end
end
function LinearAlgebra.dot(x::Number, y::BasicSymbolic{T}) where {T}
    x = unwrap(x)
    promote_shape(LinearAlgebra.dot, ShapeVecT(), shape(y))
    return conj(x) * y
end
function LinearAlgebra.dot(x::BasicSymbolic{T}, y::Number) where {T}
    y = unwrap(y)
    promote_shape(LinearAlgebra.dot, shape(x), ShapeVecT())
    return conj(x) * y
end
function LinearAlgebra.dot(x::AbstractArray, y::BasicSymbolic{T}) where {T}
    LinearAlgebra.dot(Const{T}(x), y)
end
function LinearAlgebra.dot(x::BasicSymbolic{T}, y::AbstractArray) where {T}
    LinearAlgebra.dot(x, Const{T}(y))
end

function promote_symtype(::typeof(LinearAlgebra.det), T::TypeT)
    if T <: Number
        return T
    elseif T <: AbstractMatrix
        return T.parameters[1]::TypeT
    else
        error(LazyString("Invalid type for `LinearAlgebra.det`: ", T, "."))
    end
end

@noinline function _throw_not_matrix(x)
    throw(ArgumentError(LazyString("Expected argument to be a matrix, got argument of shape ", x, ".")))
end

function promote_shape(::typeof(LinearAlgebra.det), sh::ShapeT)
    @nospecialize sh
    if sh isa Unknown
        sh.ndims == -1 || sh.ndims == 2 || _throw_not_matrix(sh)
    elseif sh isa ShapeVecT
        length(sh) == 0 || length(sh) == 2 || _throw_not_matrix(sh)
    end
    return ShapeVecT()
end

function LinearAlgebra.det(A::BasicSymbolic{T}) where {T}
    type = promote_symtype(LinearAlgebra.det, symtype(A))
    sh = promote_shape(LinearAlgebra.det, shape(A))
    BSImpl.Term{T}(LinearAlgebra.det, ArgsT{T}((A,)); type, shape = sh)
end

function promote_symtype(::typeof(LinearAlgebra.norm), T::TypeT)
    if T <: Real
        return T
    elseif T <: Complex
        return T.parameters[1]::TypeT
    elseif T === Number
        return T
    elseif T <: AbstractArray
        return promote_symtype(LinearAlgebra.norm, T.parameters[1]::TypeT)
    else
        error(LazyString("Invalid type for `LinearAlgebra.norm`: ", T))
    end
end
function promote_symtype(::typeof(LinearAlgebra.norm), T::TypeT, S::TypeT)
    @assert S <: Real
    return promote_symtype(LinearAlgebra.norm, T)
end
function promote_shape(::typeof(LinearAlgebra.norm), sh::ShapeT)
    @nospecialize sh
    return ShapeVecT()
end
function promote_shape(::typeof(LinearAlgebra.norm), sh::ShapeT, sh2::ShapeT)
    @nospecialize sh sh2
    is_array_shape(sh2) && _throw_array(LinearAlgebra.norm, sh, sh2)
    return ShapeVecT()
end

function LinearAlgebra.norm(x::BasicSymbolic{T}) where {T}
    type = promote_symtype(LinearAlgebra.norm, symtype(x))
    sh = promote_shape(LinearAlgebra.norm, shape(x))
    return BSImpl.Term{T}(LinearAlgebra.norm, ArgsT{T}((x,)); type, shape = sh)
end
function LinearAlgebra.norm(x::BasicSymbolic{T}, y::Real) where {T}
    type = promote_symtype(LinearAlgebra.norm, symtype(x))
    sh = promote_shape(LinearAlgebra.norm, shape(x))
    return BSImpl.Term{T}(LinearAlgebra.norm, ArgsT{T}((x, Const{T}(y))); type, shape = sh)
end
function LinearAlgebra.norm(x::Union{BasicSymbolic{T}, AbstractArray}, y::BasicSymbolic{T}) where {T}
    x = Const{T}(x)
    type = promote_symtype(LinearAlgebra.norm, symtype(x), symtype(y))
    sh = promote_shape(LinearAlgebra.norm, shape(x), shape(y))
    return BSImpl.Term{T}(LinearAlgebra.norm, ArgsT{T}((x, y)); type, shape = sh)
end

@noinline function _vec_throw_non_array(T::TypeT)
    throw(ArgumentError(LazyString("`Base.vec` only accepts arrays. Got argument of type ", T, ".")))
end
@noinline function _vec_throw_non_array(@nospecialize(sh::ShapeT))
    throw(ArgumentError(LazyString("`Base.vec` only accepts arrays. Got argument of shape ", sh, ".")))
end

function promote_symtype(::typeof(vec), T::TypeT)
    if T <: AbstractArray
        return Vector{safe_eltype(T)::TypeT}
    end
    _vec_throw_non_array(T)
end

function promote_shape(::typeof(vec), sh::ShapeT)
    @nospecialize sh
    is_array_shape(sh) || _vec_throw_non_array(sh)
    if sh isa Unknown
        return Unknown(1)
    else
        return ShapeVecT((1:(_length_from_shape(sh)::Int),))
    end
end

function Base.vec(x::BasicSymbolic{T}) where {T}
    sh = shape(x)
    _ndims_from_shape(sh) == 1 && return x
    type = promote_symtype(vec, symtype(x))
    sh = promote_shape(vec, sh)
    return BSImpl.Term{T}(vec, ArgsT{T}((x,)); type, shape = sh)
end

"""
    Mapper(f)

Callable used as the `operation` of symbolic `map` terms: tracing
`map(f, xs...)` over symbolic arrays produces a term whose operation is
`Mapper(f)` and whose arguments are the mapped collections. Calling a `Mapper`
applies `map(f, xs...)`. Downstream analyses that walk symbolic expressions can
dispatch on this type (and on [`Mapreducer`](@ref)) to recognize mapped array
operations.
"""
struct Mapper{F}
    f::F
end

const MAPPER_SALT = 0x9e2a7b4c15d8f063
Base.:(==)(a::Mapper, b::Mapper) = a.f == b.f
Base.isequal(a::Mapper, b::Mapper) = isequal(a.f, b.f)
Base.hash(m::Mapper, h::UInt) = hash(m.f, hash(MAPPER_SALT, h))

function (f::Mapper)(xs...)
    map(f.f, xs...)
end

function __safe_ndims(@nospecialize(T::TypeT))
    if T <: Array
        return T.parameters[2]::Int
    elseif T <: AbstractArray
        return ndims(T)::Int
    elseif T <: Tuple
        return 1
    else
        return 0
    end
end

@inline __getfirstparam(T::TypeT) = T.parameters[1]::TypeT
# TODO: This method doesn't handle the case when all are tuples. Instead of
# a tuple type, this will return a `Vector{..}`.
function promote_symtype(f::Mapper, T::TypeT, Ts::TypeT...)
    # If all `ndims` are the same, the result has the same `ndims` (assuming sizes are
    # equal). If they're unequal, the result is a `Vector`.
    ndims_1 = __safe_ndims(T)
    all_same_ndims = true
    for Ti in Ts
        ndims_i = __safe_ndims(Ti)
        # They're all same if they're all equal to the first element
        all_same_ndims &= ndims_i == ndims_1
        all_same_ndims || break
    end
    Ts = ntuple(safe_eltype ∘ Base.Fix1(getindex, Ts), Val{length(Ts)}())::NTuple{length(Ts), TypeT}
    mappedT = promote_symtype(f.f, safe_eltype(T)::TypeT, Ts...)::TypeT
    # all scalars
    if all_same_ndims
        return ndims_1 == 0 ? mappedT : Array{mappedT, ndims_1}
    else
        return Vector{mappedT}
    end
end

@noinline function _throw_map_unequal_shapes_same_ndims(shs::ShapeT...)
    throw(ArgumentError(LazyString(
        "If all arguments to `map` have the same `ndims`,",
        " they must have the same shape.",
        " Found arguments of shapes ", shs, ".")))
end

function promote_shape(::Mapper, sh::ShapeT, shs::ShapeT...)
    @nospecialize sh shs
    all_known_shapes_equal = true
    all_same_ndims = true
    ndims_1 = _ndims_from_shape(sh)
    first_known_shape::Union{Nothing, ShapeVecT} = sh isa ShapeVecT ? sh : nothing
    min_length = sh isa ShapeVecT ? _length_from_shape(sh)::Int : typemax(Int)
    any_unknown = sh isa Unknown

    for shi in shs
        ndims_i = _ndims_from_shape(shi)
        all_same_ndims &= ndims_i == ndims_1
        if shi isa ShapeVecT
            first_known_shape = @something(first_known_shape, shi)
            all_known_shapes_equal &= first_known_shape == shi
            min_length = min(min_length, _length_from_shape(shi)::Int)
        else
            any_unknown = true
        end
    end

    if all_known_shapes_equal && all_same_ndims
        return @something(first_known_shape, Unknown(ndims_1))
    elseif all_same_ndims && ndims_1 != 1
        _throw_map_unequal_shapes_same_ndims(sh, shs...)
    elseif min_length == typemax(Int)
        return Unknown(1)
    else
        return ShapeVecT((1:min_length,))
    end
end

__safe_vec(x) = is_array_shape(shape(x)) ? vec(x) : x

function __index_args(::Type{T}, nd::Int, xs...) where {T}
    idxsym = idxs_for_arrayop(T)
    if nd == 1
        stable_idx = StableIndex(ArgsT{T}((idxsym[1],)))
        fn = Base.Fix2(getindex, stable_idx) ∘ __safe_vec ∘ Base.Fix1(getindex, xs)
        indexed = ntuple(fn, Val(length(xs)))
    else
        _idxs = ArgsT{T}()
        sizehint!(_idxs, nd)
        for i in 1:nd
            push!(_idxs, idxsym[i])
        end
        stable_idx = StableIndex(_idxs)
        indexed = ntuple(Base.Fix2(getindex, stable_idx) ∘ Base.Fix1(getindex, xs), Val(length(xs)))
    end
    return indexed
end


function _map(::Type{T}, f, xs...) where {T}
    f = Mapper(f)
    xs = Const{T}.(xs)
    type = promote_symtype(f, symtype.(xs)...)
    sh = promote_shape(f, shape.(xs)...)
    nd = _ndims_from_shape(sh)
    term = BSImpl.Term{T}(f, ArgsT{T}(xs); type, shape = sh)
    indexed = __index_args(T, nd, xs...)
    idxsym = idxs_for_arrayop(T)
    idxs = OutIdxT{T}()
    sizehint!(idxs, nd)
    for i in 1:nd
        push!(idxs, idxsym[i])
    end
    ranges = RangesT{T}()
    if nd == 1 && sh isa ShapeVecT
        ranges[idxsym[1]] = 1:1:(_length_from_shape(sh)::Int)
    end
    exp = BSImpl.Term{T}(f.f, ArgsT{T}(indexed); type = eltype(type)::TypeT, shape = ShapeVecT())
    return BSImpl.ArrayOp{T}(idxs, exp, +, term, ranges; type = type, shape = sh)
end

function Base.map(f::BasicSymbolic{T}, xs...) where {T}
    _map(T, f, xs...)
end
function Base.map(f::BasicSymbolic{T}, x::AbstractArray, xs...) where {T}
    _map(T, f, x, xs...)
end

for fT in [Any, :(BasicSymbolic{T})]
    @eval function Base.map(f::$fT, x::BasicSymbolic{T}, xs...) where {T}
        _map(T, f, x, xs...)
    end
    for x1T in [Any, :(BasicSymbolic{T})]
        @eval function Base.map(f::$fT, x1::$x1T, x::BasicSymbolic{T}, xs...) where {T}
            _map(T, f, x1, x, xs...)
        end
    end
end

"""
    @map_methods T argument_transform result_transform

Generate `Base.map` methods for a symbolic array-like type. `argument_transform`
converts the symbolic container to the arguments passed to `map`, and
`result_transform` wraps the mapped result. This is a developer interface and
must be used while defining the corresponding symbolic type.
"""
macro map_methods(T, arg_f, result_f)
    quote
        function (::$(typeof(Base.map)))(f, x::$T, xs...)
            $result_f($map(f, $arg_f(x), xs...))
        end
        function (::$(typeof(Base.map)))(f::$BasicSymbolic, x::$T, xs...)
            $result_f($map(f, $arg_f(x), xs...))
        end
        function (::$(typeof(Base.map)))(f, x1, x::$T, xs...)
            $result_f($map(f, x1, $arg_f(x), xs...))
        end
        function (::$(typeof(Base.map)))(f::$BasicSymbolic{V}, x1::$BasicSymbolic{V}, x::$T, xs...) where {V}
            $result_f($map(f, x1, $arg_f(x), xs...))
        end
    end |> esc
end

"""
    Mapreducer(f, reduce, dims, init)

Callable used as the `operation` of symbolic `mapreduce`-family terms: tracing
`sum`, `prod`, or `mapreduce(f, reduce, xs...; dims, init)` over symbolic
arrays produces a term whose operation is a `Mapreducer`. For example `sum(x)`
of a symbolic array `x` traces to a term with operation
`Mapreducer(identity, Base.add_sum, Colon(), nothing)`. `dims` is `Colon()` or
an `Int`, and `init === nothing` means no initial value was supplied. Calling a
`Mapreducer` applies the corresponding `mapreduce`. Downstream analyses that
walk symbolic expressions can dispatch on this type (and on [`Mapper`](@ref))
to recognize reductions over symbolic arrays.
"""
struct Mapreducer{F, R, D <: Union{Int, Colon}, I}
    f::F
    reduce::R
    dims::D
    init::I
end

const MAPREDUCER_SALT = 0x3f51c0a6e9b27d48
Base.:(==)(a::Mapreducer, b::Mapreducer) =
    a.f == b.f && a.reduce == b.reduce && a.dims == b.dims && a.init == b.init
Base.isequal(a::Mapreducer, b::Mapreducer) =
    isequal(a.f, b.f) && isequal(a.reduce, b.reduce) && isequal(a.dims, b.dims) && isequal(a.init, b.init)
Base.hash(m::Mapreducer, h::UInt) =
    hash(m.init, hash(m.dims, hash(m.reduce, hash(m.f, hash(MAPREDUCER_SALT, h)))))

function (f::Mapreducer{F, R, D, I})(xs...) where {F, R, D, I}
    if I === Nothing
        mapreduce(f.f, f.reduce, xs...; dims = f.dims)
    else
        mapreduce(f.f, f.reduce, xs...; dims = f.dims, init = f.init)
    end
end

function promote_symtype(f::Mapreducer, T::TypeT, Ts::TypeT...)
    mappedArrT = promote_symtype(Mapper(f.f), T, Ts...)
    mappedT = safe_eltype(mappedArrT)::TypeT
    mapped_ndims = __safe_ndims(mappedArrT)
    reducedT = if f.init === nothing
        promote_symtype(f.reduce, mappedT, mappedT)
    else
        promote_symtype(f.reduce, typeof(f.init)::TypeT, mappedT)
    end
    if f.dims isa Colon
        return reducedT
    else
        return Array{reducedT, mapped_ndims}
    end
end

function promote_shape(f::Mapreducer, shs::ShapeT...)
    @nospecialize shs
    mapped_shape = promote_shape(Mapper(f.f), shs...)
    if f.dims isa Colon
        return ShapeVecT()
    elseif mapped_shape isa Unknown
        return mapped_shape
    else
        ax = mapped_shape[f.dims]
        mapped_shape[f.dims] = first(ax):first(ax)
        return mapped_shape
    end
end

function _mapreduce(::Type{T}, f, red, xs...; dims = :, init = nothing) where {T}
    f = Mapreducer(f, red, dims, init)
    xs = Const{T}.(xs)
    shs = shape.(xs)
    type = promote_symtype(f, symtype.(xs)...)
    sh = promote_shape(f, shs...)
    term = BSImpl.Term{T}(f, ArgsT{T}(xs); type, shape = sh)
    idxs = OutIdxT{T}()
    _map_sh = promote_shape(Mapper(f), shs...)
    nd = _ndims_from_shape(_map_sh)

    indexed = __index_args(T, nd, xs...)::NTuple{length(xs), BasicSymbolic{T}}
    if f.f === identity
        exp = indexed[1]
    else
        exp = BSImpl.Term{T}(f.f, ArgsT{T}(indexed); type = eltype(type)::TypeT, shape = ShapeVecT())
    end
    ranges = RangesT{T}()
    if nd == 1 && _map_sh isa ShapeVecT
        ranges[idxs_for_arrayop(T)[1]] = 1:1:(_length_from_shape(_map_sh)::Int)
    end
    return BSImpl.ArrayOp{T}(idxs, exp, red, term; type = type, shape = sh)
end

for (Tf, Tr) in Iterators.product([:(BasicSymbolic{T}), Any], [:(BasicSymbolic{T}), Any])
    if Tf != Any || Tr != Any
        @eval function Base.mapreduce(f::$Tf, red::$Tr, xs...; kw...) where {T}
            return _mapreduce(T, f, red, xs...; kw...)
        end
        @eval function Base.mapreduce(f::$Tf, red::$Tr, x::AbstractArray, xs...; kw...) where {T}
            return _mapreduce(T, f, red, x, xs...; kw...)
        end
    end
    @eval function Base.mapreduce(f::$Tf, red::$Tr, x::BasicSymbolic{T}, xs...; kw...) where {T}
        _mapreduce(T, f, red, x, xs...; kw...)
    end
    for x1T in [Any, :(BasicSymbolic{T})]
        @eval function Base.mapreduce(f::$Tf, red::$Tr, x1::$x1T, x::BasicSymbolic{T}, xs...; kw...) where {T}
            _mapreduce(T, f, red, x1, x, xs...; kw...)
        end
    end
end

function _mapreduce_method(fT, redT, xTs...; splat = true, kw...)
    args = [:(f::$fT), :(red::$redT)]
    for (i, xT) in enumerate(xTs)
        name = Symbol(:x, i)
        push!(args, :($name::$xT))
    end
    splat && push!(args, :(xs::Vararg))
    EL.codegen_ast(EL.JLFunction(; name = :(::$(typeof(mapreduce))), args, kwargs = [:(kw...)], kw...))
end

"""
    @mapreduce_methods T argument_transform result_transform

Generate `Base.mapreduce` methods for a symbolic array-like type. The transform
expressions receive the mapped input and the result transform reconstructs the
symbolic representation.
"""
macro mapreduce_methods(T, arg_f, result_f)
    result = Expr(:block)

    Ts = [:($BasicSymbolic{T}), Any]
    for (Tf, Tred) in Iterators.product(Ts, Ts)
        whereparams = if Tf != Any || Tred != Any
            [:T]
        else
            nothing
        end

        body = :($result_f($mapreduce(f, red, $arg_f(x1); kw...)))
        push!(result.args, _mapreduce_method(Tf, Tred, T; splat = false, body, whereparams))
        body = :($result_f($mapreduce(f, red, $arg_f(x1), xs...; kw...)))
        push!(result.args, _mapreduce_method(Tf, Tred, T; body, whereparams))
        body = :($result_f($mapreduce(f, red, x1, $arg_f(x2), xs...; kw...)))
        push!(result.args, _mapreduce_method(Tf, Tred, Any, T; body, whereparams))
        push!(result.args, _mapreduce_method(Tf, Tred, BasicSymbolic, T; body, whereparams))
    end
    return esc(result)
end

"""
    operator_to_term(operator::Operator, ex::BasicSymbolic)

Return the symbolic term representing an operator application. The default
implementation returns `ex`; custom `Operator` subtypes may override it when
their printed or canonical term differs from the original expression.
"""
function operator_to_term(::Operator, ex::BasicSymbolic{T}) where {T}
    return ex
end

function Base.Symbol(ex::BasicSymbolic{T}) where {T}
    @match ex begin
        BSImpl.Term(; f) && if f isa Operator end => Symbol(string(operator_to_term(f, ex)::BasicSymbolic{T}))
        _ => Symbol(string(ex))
    end
end

function promote_symtype(::typeof(in), T::TypeT, S::TypeT)
    return Bool
end
function promote_shape(::typeof(in), sha::ShapeT, shb::ShapeT)
    @nospecialize sha shb
    @assert is_array_shape(shb) || throw(ArgumentError("Symbolic `in` requires an array as the second argument."))
    return ShapeVecT()
end

for T1 in [Real, :(BasicSymbolic{T})], T2 in [AbstractArray, :(BasicSymbolic{T})]
    if !(T1 isa Expr) && !(T2 isa Expr)
        continue
    end
    @eval function Base.in(a::$T1, b::$T2) where {T}
        sh = promote_shape(in, shape(a), shape(b))
        return BSImpl.Term{T}(in, ArgsT{T}((Const{T}(a), Const{T}(b))); type = Bool, shape = sh)
    end
end

function promote_symtype(::typeof(issubset), T::TypeT, S::TypeT)
    Bool
end
function promote_shape(::typeof(issubset), sha::ShapeT, shb::ShapeT)
    @nospecialize sha shb
    @assert is_array_shape(sha) || throw(ArgumentError("Symbolic `issubset` requires arrays as both arguments."))
    @assert is_array_shape(shb) || throw(ArgumentError("Symbolic `issubset` requires arrays as both arguments."))
    return ShapeVecT()
end

for T1 in [AbstractArray, :(BasicSymbolic{T})], T2 in [AbstractArray, :(BasicSymbolic{T})]
    if !(T1 isa Expr) && !(T2 isa Expr)
        continue
    end
    @eval function Base.issubset(a::$T1, b::$T2) where {T}
        sh = promote_shape(issubset, shape(a), shape(b))
        return BSImpl.Term{T}(issubset, ArgsT{T}((Const{T}(a), Const{T}(b))); type = Bool, shape = sh)
    end
end

for f in [union, intersect]
    @eval function promote_symtype(::$(typeof(f)), T::TypeT,
                             S::TypeT)
        return Vector{promote_type(T.parameters[1]::TypeT, S.parameters[1]::TypeT)}
    end
    @eval function promote_shape(::$(typeof(f)), sha::ShapeT, shb::ShapeT)
        @nospecialize sha shb
        @assert is_array_shape(sha) || throw(ArgumentError("Symbolic `$($f)` requires arrays as both arguments."))
        @assert is_array_shape(shb) || throw(ArgumentError("Symbolic `$($f)` requires arrays as both arguments."))
        return Unknown(1)
    end
    for T1 in [AbstractArray, :(BasicSymbolic{T})], T2 in [AbstractArray, :(BasicSymbolic{T})]
        if !(T1 isa Expr) && !(T2 isa Expr)
            continue
        end
        @eval function (::$(typeof(f)))(a::$T1, b::$T2) where {T}
            sh = promote_shape($f, shape(a), shape(b))
            type = promote_type($f, symtype(a), symtype(b))
            return BSImpl.Term{T}($f, ArgsT{T}((Const{T}(a), Const{T}(b))); type, shape = sh)
        end
    end
end

function promote_symtype(::typeof(complex), T::TypeT)
    if T <: Real
        return Complex{T}
    elseif T <: Number
        return T
    else
        error(LazyString("Invalid type for `complex`: ", T, "."))
    end
end
function promote_symtype(::typeof(complex), T::TypeT, S::TypeT)
    @assert T <: Real
    @assert S <: Real
    Complex{promote_type_fast_path(T, S)}
end

function promote_symtype(::typeof(binomial), T::TypeT, S::TypeT)
    @assert T <: Number
    @assert S <: Integer
    return T
end
function promote_shape(::typeof(binomial), sha::ShapeT, shb::ShapeT)
    @nospecialize sha shb
    is_array_shape(sha) && _throw_array(sha)
    is_array_shape(shb) && _throw_array(shb)

    return ShapeVecT()
end

for T1 in [Number, :(BasicSymbolic{T})], T2 in [Integer, :(BasicSymbolic{T})]
    if !(T1 isa Expr) && !(T2 isa Expr)
        continue
    end
    @eval function Base.binomial(a::$T1, b::$T2) where {T}
        sh = promote_shape(binomial, shape(a), shape(b))
        return BSImpl.Term{T}(binomial, ArgsT{T}((Const{T}(a), Const{T}(b))); type = symtype(a), shape = sh)
    end
end

function promote_symtype(::typeof(LinearAlgebra.cross), x::TypeT, y::TypeT)
    x <: AbstractVector || error("`LinearAlgebra.cross` expects vectors. Got value of symtype $x.")
    y <: AbstractVector || error("`LinearAlgebra.cross` expects vectors. Got value of symtype $y.")
    Vector{promote_symtype(*, x.parameters[1]::TypeT, y.parameters[1]::TypeT)}
end

function promote_shape(::typeof(LinearAlgebra.cross), shx::ShapeT, shy::ShapeT)
    @nospecialize shx shy

    if shx isa Unknown
        shx.ndims == 1 || shx.ndims == -1 || error(LazyString("`LinearAlgebra.cross` expects vectors. Got argument of shape ", shx, "."))
    else
        length(shx) == 1 && length(shx[1]) == 3 || error(LazyString("`LinearAlgebra.cross` expects a 3-vector. Got argument of shape ", shx, "."))
    end
    if shy isa Unknown
        shy.ndims == 1 || shy.ndims == -1 || error(LazyString("`LinearAlgebra.cross` expects vectors. Got argument of shape ", shy, "."))
    else
        length(shy) == 1 && length(shy[1]) == 3 || error(LazyString("`LinearAlgebra.cross` expects a 3-vector. Got argument of shape ", shy, "."))
    end

    return ShapeVecT((1:3,))
end

function _cross_product(::Type{T}, x, y) where {T}
    BSImpl.Const{T}(ArgsT{T}((x[2] * y[3] - x[3] * y[2], -x[1] * y[3] + x[3] * y[1], x[1] * y[2] - x[2] * y[1])))
end
function LinearAlgebra.cross(x::BasicSymbolic{T}, y::Union{BasicSymbolic{T}, AbstractVector{<:Number}, AbstractVector{BasicSymbolic{T}}}) where {T}
    if y isa Vector{BasicSymbolic{T}}
        st_y = symtype(BSImpl.Const{T}(y))
    else
        st_y = symtype(y)
    end
    promote_symtype(LinearAlgebra.cross, symtype(x), st_y)
    promote_shape(LinearAlgebra.cross, shape(x), shape(y))
    _cross_product(T, x, y)
end
function LinearAlgebra.cross(x::Union{AbstractVector{<:Number}, AbstractVector{BasicSymbolic{T}}}, y::BasicSymbolic{T}) where {T}
    if x isa Vector{BasicSymbolic{T}}
        st_y = symtype(BSImpl.Const{T}(x))
    else
        st_y = symtype(x)
    end
    promote_symtype(LinearAlgebra.cross, symtype(x), symtype(y))
    promote_shape(LinearAlgebra.cross, shape(x), shape(y))
    _cross_product(T, x, y)
end

struct Fill
    sh::ShapeVecT
end

const FILL_SALT = 0x7c8f3a1d6e2b9054
Base.:(==)(a::Fill, b::Fill) = a.sh == b.sh
Base.isequal(a::Fill, b::Fill) = isequal(a.sh, b.sh)
Base.hash(f::Fill, h::UInt) = hash(f.sh, hash(FILL_SALT, h))

function (f::Fill)(x::BasicSymbolic{T}) where {T}
    term = BSImpl.Term{T}(
        f, ArgsT{T}((x,)); type = promote_symtype(f, symtype(x)), shape = promote_shape(f, shape(x))
    )
    out_idxs = OutIdxT{T}()
    ranges = RangesT{T}()
    idx = idxs_for_arrayop(T)
    for i in eachindex(f.sh)
        idxi = idx[i]
        push!(out_idxs, idxi)
        ranges[idxi] = f.sh[i]
    end
    return BSImpl.ArrayOp{T}(out_idxs, x, +, term, ranges; type = term.type, shape = term.shape)
end

function (f::Fill)(x)
    ux = unwrap(x)
    if ux !== x
        return f(ux)
    end
    return fill(x, map(length, f.sh)...)
end

function promote_symtype(f::Fill, T::TypeT)
    return Array{T, length(f.sh)}
end

function promote_shape(f::Fill, ::ShapeT)
    @nospecialize sh
    return f.sh
end

struct SymbolicRound{T, R <: RoundingMode}
    mode::R
end

function promote_symtype(::SymbolicRound{T}, ::TypeT) where {T}
    return T::TypeT
end

function promote_shape(::SymbolicRound{T}, sh::ShapeT) where {T}
    @nospecialize sh
    return sh
end

function (fn::SymbolicRound{T})(ex::BasicSymbolic{R}) where {T, R}
    return BSImpl.Term{R}(fn, ArgsT{R}((ex,)); type = T, shape = shape(ex))
end
function (fn::SymbolicRound{T})(val) where {T}
    uval = unwrap(val)
    if uval === val
        return round(T, uval, fn.mode)
    end
    return fn(uval)
end

function Base.round(::Type{T}, ex::BasicSymbolic{R}, mode::Base.RoundingMode) where {T, R}
    SymbolicRound{T, typeof(mode)}(mode)(ex)
end

function promote_symtype(::Type{T}, R::TypeT) where {T <: Returns}
    return FnType{Tuple, R, Nothing}
end

function promote_shape(::Type{T}, @nospecialize(sh::ShapeT)) where {T <: Returns}
    return sh
end

function promote_symtype(::Type{SparseMatrixCSC}, Tm::TypeT, Tn::TypeT, TI::TypeT, TJ::TypeT, TV::TypeT)
    return Matrix{TV.parameters[1]::TypeT}
end

function promote_symtype(::typeof(reshape), Tarr::TypeT, Tidxs::TypeT...)
    return Array{safe_eltype(Tarr), length(Tidxs)}
end

"""
    $(TYPEDEF)

Sentinel value used for a cache miss, since cached functions may return `nothing`.
"""
struct CacheSentinel end

mutable struct IDType end

"""
    $(TYPEDEF)

Struct wrapping the `id` of a `BasicSymbolic`, since arguments annotated
`::Union{BasicSymbolic, UInt}` would not be able to differentiate between looking
up a symbolic or a `UInt`.
"""
struct SymbolicKey
    id::IDType
end

"""
    $(TYPEDSIGNATURES)

The key stored in the cache for a particular value. Returns a `SymbolicKey` for
`BasicSymbolic` and is the identity function otherwise.
"""
# can't dispatch because `BasicSymbolic` isn't defined here
function get_cache_key(x)
    @nospecialize x
    if x isa BasicSymbolic{SymReal}
        id = x.id
        if id === nothing
            return CacheSentinel()
        end
        return SymbolicKey(id)
    elseif x isa BasicSymbolic{SafeReal}
        id = x.id
        if id === nothing
            return CacheSentinel()
        end
        return SymbolicKey(id)
    elseif x isa BasicSymbolic{TreeReal}
        id = x.id
        if id === nothing
            return CacheSentinel()
        end
        return SymbolicKey(id)
    else
        x
    end
end

"""
    associated_cache(fn)

Given a function annotated with `@cache`, get the cache struct it uses. Automatically
implemented by `@cache`.
"""
function associated_cache end

"""
    $(TYPEDSIGNATURES)

Set the maximum size for the cache associated with function `fn` to `limit`.
"""
function set_limit!(fn, limit::Int)
    cache = associated_cache(fn)
    cache.limit = limit
end

"""
    $(TYPEDSIGNATURES)

Get the maximum size for the cache associated with function `fn`.
"""
function get_limit(fn)
    associated_cache(fn).limit
end

"""
    $(TYPEDSIGNATURES)

Set the fraction of entries to retain on clear for the cache associated with
function `fn` to `retain_fraction`.
"""
function set_retain_fraction!(fn, retain_fraction::Float64)
    cache = associated_cache(fn)
    cache.retain_fraction = retain_fraction
end

"""
    $(TYPEDSIGNATURES)

Get the `retain_fraction` for the cache associated with function `fn`.
"""
function get_retain_fraction(fn)
    associated_cache(fn).retain_fraction
end

"""
    $(TYPEDSIGNATURES)

Enable or disable the caching of `fn` according to `state`.
"""
function toggle_caching!(fn, state::Bool)
    cache = associated_cache(fn)
    cache.enabled = state
end

"""
    $(TYPEDSIGNATURES)

Check whether caching is enabled for `fn`.
"""
function is_caching_enabled(fn)
    associated_cache(fn).enabled
end

"""
    $(TYPEDSIGNATURES)

Get the statistics for the cached function `fn`. This is task-specific.

See also: [`SymbolicUtils.CacheStats`](@ref).
"""
function get_stats(fn)
    associated_cache(fn).tlv[][2]
end

"""
    $(TYPEDSIGNATURES)

Clear the cache for [`SymbolicUtils.@cache`](@ref)d function `fn`. This is task specific.
Also resets the stats.
"""
function clear_cache!(fn)
    dict, stats = associated_cache(fn).tlv[]
    empty!(dict)
    sizehint!(dict, get_limit(fn))
    reset_stats!(stats)
end

"""
    $(TYPEDEF)

Track statistics about a cached function.

# Fields

$(TYPEDFIELDS)
"""
mutable struct CacheStats
    """
    The number of cache hits.
    """
    hits::Int
    """
    The number of cache misses.
    """
    misses::Int
    """
    The number of times the cache has been randomly cleared.
    """
    clears::Int
end

CacheStats() = CacheStats(0, 0, 0)

"""
    $(TYPEDSIGNATURES)

Reset the tracked statistics for a cache.
"""
function reset_stats!(stats::CacheStats)
    stats.hits = 0
    stats.misses = 0
    stats.clears = 0
end

"""
    $(TYPEDSIGNATURES)

Reset the tracked statistics for cached function `fn`.
"""
function reset_stats!(fn)
    reset_stats!(get_stats(fn))
end

"""
    @cache [options...] function foo(arg1::Type, arg2::Type; kwargs...)::ReturnType
        # ...
    end

Create a cached version of the function `foo`. This is typically useful for recursive
functions that descend through an expression tree.

The return type of the function should be annotated to avoid warnings. If any of the
argument types is a `BasicSymbolic`, uses a special caching for efficiency. If an argument
has `Any` type or a `Union` containing `BasicSymbolic`, a runtime check is performed to
handle it. This can be avoided if the type is annotated with `BasicSymbolic`. The maximum
number of entries in the cache can be set using the `limit` option by providing an
integer size. This defaults to `100_000`. When this limit is hit, a fraction of the
entries in the cache will be cleared at random. The fraction of entries retained is given
by the `retain_fraction` option, which defaults to `0.5`.

Multiple methods of the same function cannot be cached and will lead to an error. This
should be avoided by creating a wrapper function which calls the one with ,multiple
methods, and caching the wrapper. The function with multiple methods should recursively
call the wrapper. Caching a single method is valid.

The cache is thread-safe and uses TaskLocalValues.jl to maintain a task-specific cache.

The caching behavior for this function is enabled by default. Use the `enabled` option
to toggle this.

See also: [`SymbolicUtils.get_limit`](@ref), [`SymbolicUtils.set_limit!`](@ref),
[`SymbolicUtils.get_retain_fraction`](@ref), [`SymbolicUtils.set_retain_fraction!`](@ref),
[`SymbolicUtils.toggle_caching!`](@ref), [`SymbolicUtils.is_caching_enabled`](@ref),
[`SymbolicUtils.get_stats`](@ref), [`SymbolicUtils.clear_cache!`](@ref),
[`SymbolicUtils.reset_stats!`](@ref).
"""
macro cache(args...)
    # the last argument is the function expression, all prior arguments are
    # config options of the form `key = value`
    fnexpr = last(args)
    configargs = Base.front(args)

    # parse configuration options
    config = Dict(:limit => 100_000, :retain_fraction => 0.5, :allow_any_return => false, :enabled => true)
    for carg in configargs
        if !Meta.isexpr(carg, :(=))
            throw(ArgumentError(LazyString("Expected `key = value` syntax, got ", carg)))
        end
        k, v = carg.args

        if !haskey(config, k)
            throw(ArgumentError(
                "Expected option to be one of $(collect(keys(config))), got $k"))
        end
        if typeof(v) != typeof(config[k])
            exT = typeof(config[k])
            vT = typeof(v)
            throw(ArgumentError(
                "Expected a value of type $exT for option $k, got $v of type $vT."))
        end
        config[k] = v
    end

    # Parse the function. This also throws a nice error if it isn't a valid function
    fn = EL.JLFunction(fnexpr)
    name = fn.name
    # this will now be an inner workhorse function, which the cached function will call
    fn.name = gensym(Symbol(name))
    # the name of the global constant cache
    cachename = Symbol("cacheof($name)")
    # conditions for performing caching. At the very least, need hashconsing enabled and
    # caching for this function is enabled.
    conditions = :($(@__MODULE__).ENABLE_HASHCONSING[] && $cachename.enabled)
    # They keys of the cache are arguments to the function, this is a list of expressions
    # of those arguments. This isn't just the arguments to the function since the key
    # for symbolic objects will be the ID
    keyexprs = []
    # The types of the arguments, matching the order in `keyexprs`
    keytypes = []
    # The arguments of the workhorse function
    argexprs = []
    # The name of the variable storing the result of looking up the cache
    cache_value_name = :val
    valid_key_condition = :(true)
    # The condition for a cache hit
    cache_hit_condition = :(!($cache_value_name isa $CacheSentinel))

    for arg in fn.args
        # handle arguments with defaults
        if Meta.isexpr(arg, :kw)
            arg = arg.args[1]
        end
        if Meta.isexpr(arg, :...)
            arg = arg.args[1]
            if Meta.isexpr(arg, :(::))
                argname = arg.args[1]
            else
                argname = arg
            end
            push!(keyexprs, :($get_cache_key.($argname)...))
            push!(argexprs, Expr(:..., argname))
            push!(keytypes, Vararg)
            valid_key_condition = :($valid_key_condition && !any(i -> key[i] isa $CacheSentinel, $(length(keyexprs)):length(key)))
            continue
        end
        if !Meta.isexpr(arg, :(::))
            # if the type is `Any`, branch on it being a `BasicSymbolic`
            push!(keyexprs, :($get_cache_key($arg)))
            push!(argexprs, arg)
            push!(keytypes, Any)
            valid_key_condition = :($valid_key_condition && !($(Symbol(:key_, length(keyexprs))) isa $CacheSentinel))
            continue
        end
        argname, Texpr = arg.args
        push!(argexprs, argname)

        if Texpr == :Any
            # if the type is `Any`, branch on it being a `BasicSymbolic`
            push!(keyexprs, :($get_cache_key($argname)))
            push!(keytypes, Any)
            valid_key_condition = :($valid_key_condition && !($(Symbol(:key_, length(keyexprs))) isa $CacheSentinel))
            continue
        end

        # handle Union types that may contain a `BasicSymbolic`
        if Meta.isexpr(Texpr, :curly) && Texpr.args[1] == :Union
            Texprs = Texpr.args[2:end]
            Ts = map(Base.Fix1(Base.eval, __module__), Texprs)
            keyTs = map(x -> x <: BasicSymbolic ? SymbolicKey : x, Ts)
            maybe_basicsymbolic = any(x -> x <: BasicSymbolic, Ts)
            push!(keytypes, Union{keyTs...})
            if maybe_basicsymbolic
                push!(keyexprs, :($get_cache_key($argname)))
                valid_key_condition = :($valid_key_condition && !($(Symbol(:key_, length(keyexprs))) isa $CacheSentinel))
            else
                push!(keyexprs, argname)
            end
            continue
        end

        # use `eval` to get the type because we need to know if it's a `BasicSymbolic`
        T = Base.eval(__module__, Texpr)
        if T <: BasicSymbolic
            push!(keytypes, SymbolicKey)
            push!(keyexprs, :($get_cache_key($argname)))
            valid_key_condition = :($valid_key_condition && !($(Symbol(:key_, length(keyexprs))) isa $CacheSentinel))
        else
            push!(keytypes, T)
            push!(keyexprs, argname)
        end
    end

    # the expression for getting the keys
    keyvarsexpr = Expr(:block)
    for (i, kex) in enumerate(keyexprs)
        kname = Symbol(:key_, i)
        if Meta.isexpr(kex, :...)
            push!(keyvarsexpr.args, :($kname = ($kex,)))
            keyexprs[i] = :($kname...)
        else
            push!(keyvarsexpr.args, :($kname = $kex))
            keyexprs[i] = kname
        end
    end

    is_singleton_key = false
    if length(keyexprs) == 1 && !Meta.isexpr(keyexprs[1], :...)
        keyexpr = only(keyexprs)
        keytypes = only(keytypes)
        is_singleton_key = true
    else
        keyexpr = EL.xtuple(keyexprs...)
    end

    rettype = fn.rettype
    if rettype === nothing
        if !config[:allow_any_return]
            @warn "`Any` return type detected. This leads to a type-unstable cache. Disable this warning by providing `allow_any_return = true` to `SymbolicUtils.@cache`."
        end
        rettype = Any
    end

    # construct an expression for the type of the cache keys
    if is_singleton_key
        keyT = keytypes
    else
        keyT = Expr(:curly, Tuple)
        append!(keyT.args, keytypes)
    end
    valT = rettype
    # the type of the cache
    cacheT = :(Dict{$keyT, $valT})
    # type of the `TaskLocalValue`
    tlvT = :($(TaskLocalValue){Tuple{$cacheT, $CacheStats}})
    # the name of the cache struct
    # this uses the name of the function so that trying to `@cache` two methods
    # of the same function results in a struct re-definition error
    structT = Symbol("cacheof($name)_type")
    # mutable to allow changing max size
    structdef = EL.JLStruct(; name = structT, ismutable = true)

    # struct fields
    push!(structdef.fields, EL.JLField(; name = :tlv, type = tlvT, isconst = true))
    push!(structdef.fields, EL.JLField(; name = :limit, type = Int, isconst = false))
    push!(structdef.fields, EL.JLField(; name = :retain_fraction, type = Float64, isconst = false))
    push!(structdef.fields, EL.JLField(; name = :enabled, type = Bool, isconst = false))

    # the struct itself is callable, acting as a filter function for emptying the cache
    filterfn = EL.JLFunction(; name = :(cache::$structT), args = [:kvp])
    filterfn.body = :(begin
        rand() <= cache.retain_fraction
    end)

    # instantiation of the TaskLocalValue
    tlvctor = :($tlvT(() -> ((dict = $cacheT(); sizehint!(dict, $get_limit($name)); dict), $CacheStats())))
    # instantiation expression for the constant value
    cachector = Expr(:call, structT, tlvctor, config[:limit], config[:retain_fraction], config[:enabled])

    # call to the workhorse function
    innercall = EL.codegen_ast(EL.JLCall(fn.name, argexprs, fn.kwargs))

    # wrapper which takes the name of the cached function
    wrapperfn = EL.JLFunction(; name = name, args = fn.args, kwargs = fn.kwargs)
    wrapperfn.body = :(begin
        # if we can cache
        if $conditions
            $keyvarsexpr
            # construct the `Tuple` key
            key = $keyexpr
            if !($valid_key_condition)
                return $innercall
            end
            # get the cache and stats from the `TaskLocalValue` to avoid accessing
            # `task_local_storage` repeatedly.
            cachedict, cachestats = $cachename.tlv[]
            # look it up
            # we use a custom sentinel value since `nothing` is a valid return value
            # which we might want to cache
            $cache_value_name = $(get)(cachedict, key, $(CacheSentinel)())
            if $cache_hit_condition
                # cache hit
                cachestats.hits += 1
                return $cache_value_name
            end
            # cache miss
            cachestats.misses += 1
            val = $innercall
            # filter if oversized
            if length(cachedict) >= $cachename.limit
                cachestats.clears += 1
                $(filter!)($cachename, cachedict)
            end
            # add to cache
            cachedict[key] = $cache_value_name
            return $cache_value_name
        end

        # if we're not doing caching
        return $innercall
    end)

    return quote
        $(EL.codegen_ast(structdef))
        $(EL.codegen_ast(filterfn))

        const $cachename = $cachector

        $(EL.codegen_ast(fn))
        Base.@__doc__ $(EL.codegen_ast(wrapperfn))

        function (::$(typeof(associated_cache)))(::typeof($name))
            $cachename
        end
    end |> esc
end

@noinline function throw_matmatpow(x, y)
    throw(ArgumentError(LazyString(
        "Cannot raise matrix to matrix power -",
        " tried to raise array of shape ", x,
        " to array of shape ", y, ".")))
end

@noinline function throw_nonmatbase(x)
    throw(ArgumentError(LazyString("Matrices are the only arrays that can be raised to a power. Found array of shape ", x, ".")))
end

@noinline function throw_nonmatexp(x)
    throw(ArgumentError(LazyString("Matrices are the only arrays that can be an exponent. Found array of shape ", x, ".")))
end

@noinline function throw_nonsquarebase(x)
    throw(ArgumentError(LazyString("Only square matrices can be raised to a power. Found array of shape ", x, ".")))
end

@noinline function throw_nonsquareexp(x)
    throw(ArgumentError(LazyString("Only a square matrix can be an exponent. Found array of shape ", x, ".")))
end

function promote_shape(::typeof(^), sh1::ShapeT, sh2::ShapeT)
    @nospecialize sh1 sh2
    if sh1 isa Unknown && sh2 isa Unknown
        throw_matmatpow(sh1, sh2)
    elseif sh1 isa Unknown && sh2 isa ShapeVecT
        isempty(sh2) || throw_matmatpow(sh1, sh2)
        sh1.ndims == 2 || sh1.ndims == -1 || throw_nonmatbase(sh1)
        return Unknown(2) # either the result is a matrix or the operation will error
    elseif sh1 isa ShapeVecT && sh2 isa Unknown
        isempty(sh1) || throw_matmatpow(sh1, sh2)
        sh2.ndims == 2 || sh2.ndims == -1 || throw_nonmatexp(sh2)
        return Unknown(2) # either the result is a matrix or the operation will error
    elseif sh1 isa ShapeVecT && sh2 isa ShapeVecT
        if isempty(sh1) && isempty(sh2)
            return sh1
        elseif isempty(sh1)
            length(sh2) == 2 || throw_nonmatexp(sh2)
            length(sh2[1]) == length(sh2[2]) || throw_nonsquareexp(sh2)
            return sh2
        elseif isempty(sh2)
            length(sh1) == 2 || throw_nonmatbase(sh1)
            length(sh1[1]) == length(sh1[2]) || throw_nonsquarebase(sh1)
            return sh1
        else
            throw_matmatpow(sh1, sh2)
        end
    end
end

function ^(a::BasicSymbolic{T}, b::Union{AbstractArray{<:Number}, Number, BasicSymbolic{T}}) where {T <: Union{SymReal, SafeReal}}
    if !_numeric_or_arrnumeric_symtype(a) || !_numeric_or_arrnumeric_symtype(b)
        throw(MethodError(^, (a, b)))
    end
    isconst(a) && return Const{T}(^(unwrap_const(a), b))
    b = unwrap_const(unwrap(b))
    sha = shape(a)
    shb = shape(b)
    newshape = promote_shape(^, sha, shb)
    type = promote_symtype(^, symtype(a), symtype(b))

    if is_array_shape(sha)
        @match a begin
            BSImpl.Term(; f, args) && if f === (^) && isconst(args[1]) end => begin
                base, exp = args
                return Term{T}(^, ArgsT{T}((base, exp * b)); type, shape = newshape)
            end
            BSImpl.Term(; f) && if f === (*) end => begin
                coeff, rest = _split_arrterm_scalar_coeff(T, a)
                if _isone(coeff)
                    return Term{T}(^, ArgsT{T}((rest, Const{T}(b))); type, shape = newshape)
                end
                return ((coeff ^ b)::BasicSymbolic{T} * (rest ^ b)::BasicSymbolic{T})
            end
            _ => return Term{T}(^, ArgsT{T}((a, Const{T}(b))); type, shape = newshape)
        end
    elseif is_array_shape(shb)
        return Term{T}(^, ArgsT{T}((a, Const{T}(b))); type, shape = newshape)::BasicSymbolic{T}
    end
    if b isa Number
        iszero(b) && return one_of_vartype(T)
        isone(b) && return Const{T}(a)
    end
    if b isa Real && b < 0
        return Div{T}(1, a ^ (-b), false; type)::BasicSymbolic{T}
    end
    if b isa Number
        @match a begin
            BSImpl.Term(; f, args) && if f === (^) && isconst(args[2]) && symtype(args[2]) <: Number end => begin
                base, exp = args
                exp = unwrap_const(exp)
                return Const{T}(base ^ (exp * b))
            end
            BSImpl.Term(; f, args) && if f === sqrt && (safe_isinteger(b) && Int(b) % 2 == 0 || b isa Rational && numerator(b)%2 == 0) end => begin
                exp = safe_isinteger(b) ? (Int(b) // 2) : (b::Rational // 2)
                return Const{T}(args[1] ^ exp)
            end
            BSImpl.Term(; f, args) && if f === cbrt && (safe_isinteger(b) && Int(b) % 3 == 0 || b isa Rational && numerator(b)%3 == 0) end => begin
                exp = safe_isinteger(b) ? (Int(b) // 3) : (b::Rational // 3)
                return Const{T}(args[1] ^ exp)
            end
            _ => nothing
        end
    end
    if b isa Number
        @match a begin
            BSImpl.AddMul(; coeff, dict, variant, shape, type) && if variant == AddMulVariant.MUL end => begin
                if coeff isa Real && coeff < 0 && !safe_isinteger(b)
                    coeff = (-coeff) ^ b
                    newmul = BSImpl.AddMul{T}(-1, dict, variant; shape, type)
                    # newpow = Term{T}(^, ArgsT{T}((newmul, b)); shape, type)
                    if _isone(coeff)
                        return Term{T}(^, ArgsT{T}((newmul, b)); shape, type)
                    else
                        return BSImpl.AddMul{T}(coeff, ACDict{T}(newmul => b), AddMulVariant.MUL; shape, type)
                    end
                    # return mul_worker(T, (coeff, newpow))
                else
                    coeff = coeff ^ b
                    dict = copy(dict)
                    map!(Base.Fix1(*, b), values(dict))
                    return BSImpl.AddMul{T}(coeff, dict, variant; shape, type)
                end
            end
            _ => nothing
        end
    end
    return BSImpl.Term{T}(^, ArgsT{T}((a, Const{T}(b))); type)
end

function ^(a::Union{Number, Matrix{<:Number}}, b::BasicSymbolic{T}) where {T}
    _numeric_or_arrnumeric_symtype(b) || throw(MethodError(^, (a, b)))
    isconst(b) && return Const{T}(a ^ unwrap_const(b))
    newshape = promote_shape(^, shape(a), shape(b))
    type = promote_symtype(^, symtype(a), symtype(b))
    if is_array_shape(newshape) && _isone(a)
        if newshape isa Unknown
            return Const{T}(LinearAlgebra.I)
        else
            return Const{T}(LinearAlgebra.I(length(newshape[1])))
        end
    end
    Term{T}(^, ArgsT{T}((Const{T}(a), b)); type, shape = newshape)
end
function ^(a::Matrix{BasicSymbolic{T}}, b::BasicSymbolic{T}) where {T <: Union{SafeReal, SymReal}}
    Const{T}(a) ^ b
end
function ^(a::BasicSymbolic{T}, b::Matrix{BasicSymbolic{T}}) where {T <: Union{SafeReal, SymReal}}
    a ^ Const{T}(b)
end

using SymbolicUtils: Sym, FnType, Term, Add, Mul, symtype, operation, arguments, issym, isterm, BasicSymbolic, term, basicsymbolic_to_polyvar, get_mul_coefficient, ACDict, Const, shape, ShapeVecT, ArgsT, isarrayop, query
using SymbolicUtils.Code: toexpr
using SymbolicUtils
using ConstructionBase: setproperties
import MultivariatePolynomials as MP
using Setfield
import SymbolicIndexingInterface as SII
using Test, ReferenceTests
import LinearAlgebra
using StaticArrays
using SparseArrays

include("utils.jl")

@testset "@syms" begin
    let
        @syms a b::Float64 f(::Real) g(p, h(q::Real))::Int

        @test issym(a) && symtype(a) == Number
        @test a.name === :a

        @test issym(b) && symtype(b) == Float64
        @test nameof(b) === :b

        @test issym(f)
        @test f.name === :f
        @test symtype(f) == FnType{Tuple{Real}, Number, Nothing}

        @test issym(g)
        @test g.name === :g
        @test symtype(g) == FnType{Tuple{Number, FnType{Tuple{Real}, Number, Nothing}}, Int, Nothing}

        @test isterm(f(b))
        @test symtype(f(b)) === Number
        @test_throws ErrorException f(a)

        @test isterm(g(b, f))
        @test_throws ErrorException g(b, a)

        @test symtype(g(b, f)) === Int

        # issue #91
        @syms h(a,b,c)
        @test isequal(h(1,2,3), h(1,2,3))

        @syms (f::typeof(max))(::Real, ::AbstractFloat)::Number a::Real
        @test issym(f)
        @test f.name == :f
        @test symtype(f) == FnType{Tuple{Real, AbstractFloat}, Number, typeof(max)}
        @test isterm(f(a, b))
        @test symtype(f(a, b)) == Number

        @syms g(p, (h::typeof(identity))(q::Real)::Number)::Number
        @test issym(g)
        @test g.name == :g
        @test symtype(g) == FnType{Tuple{Number, FnType{Tuple{Real}, Number, typeof(identity)}}, Number, Nothing}
        @test_throws "not a subtype of" g(a, f)
        @syms (f::typeof(identity))(::Real)::Number
        @test symtype(g(a, f)) == Number

        @syms a[1:2] b[1:2]::String c[1:2, 3:4] e::Vector{Int} g::Matrix{Int} i::Array{Int, 3} k(..)[1:2]::Int
        @test shape(a) == ShapeVecT([1:2])
        @test a.type == Vector{Number}
        @test shape(b) == ShapeVecT([1:2])
        @test b.type == Vector{String}
        @test shape(c) == ShapeVecT([1:2, 3:4])
        @test c.type == Matrix{Number}
        @test shape(e) == SymbolicUtils.Unknown(1)
        @test e.type == Vector{Int}
        @test shape(g) == SymbolicUtils.Unknown(2)
        @test g.type == Matrix{Int}
        @test shape(i) == SymbolicUtils.Unknown(3)
        @test i.type == Array{Int, 3}
        @test shape(k) == ShapeVecT([1:2])
        @test k.type == FnType{Tuple, Vector{Int}, Nothing}
    end
end

@testset "hashing" begin
    @syms a b f(x, y)
    @test hash(a) == hash(a)
    @test hash(a) != hash(b)
    @test hash(a+1) == hash(a+1)
    @test hash(sin(a+1)) == hash(sin(a+1))
    @test hash(f(1,a)) == hash(f(1, a))

    c = a
    g = f
    @syms a f(x, y)
    @test hash(a) == hash(c)
    @test hash(g(a, b)) == hash(f(a,b))
    @test hash(f(a, b)) == hash(f(c,b))
    @test hash(sin(a+1)) == hash(sin(c+1))

    ex = sin(a+1)
    h = hash(ex, UInt(0))
    @test ex.hash[] == h
    ex1 = sin(a+1)
    hash(asin(ex1), UInt(0))
    @test ex1.hash[] == h

    @testset "hash is same with and without hashconsing" begin
        @syms a b
        t1 = Term{SymReal}(+, [a, b])
        t2 = Term{SymReal}(+, [a, b]; unsafe = true)
        @test hash(t1) == hash(t2)
    end
end

struct Ctx1 end
struct Ctx2 end

# needs to be written like this to avoid a segfault on Julia 1.10
@info "Metadata test"
@syms a b c
for a = [a, sin(a), a+b, a*b, a^3]

    a′ = setmetadata(a, Ctx1, "meta_1")

    @test hasmetadata(a′, Ctx1)
    @test !hasmetadata(a′, Ctx2)

    a′ = setmetadata(a′, Ctx2, "meta_2")

    @test hasmetadata(a′, Ctx1)
    @test hasmetadata(a′, Ctx2)

    @test getmetadata(a′, Ctx1) == "meta_1"
    @test getmetadata(a′, Ctx2) == "meta_2"
end

# In substitute #283
#
@syms f(t) t
f = setmetadata(f(t), Ctx1, "yes")
hasmetadata(f, Ctx1) # true
newf = substitute(f, Dict(a=>b)) # unrelated substitution
@test hasmetadata(newf, Ctx1)
@test getmetadata(newf, Ctx1) == "yes"


@test isequal(substitute(1+sqrt(a), Dict(a => 2), fold=Val(false)),
              1 + term(sqrt, 2, type=Real))
@test unwrap_const(substitute(1+sqrt(a), Dict(a => 2), fold=Val(true))) isa Float64
@info "Metadata test ends"

@testset "Base methods" begin
    @syms w::Complex{Real} z::Complex{Real} a::Real b::Real x
    @test isequal(w + z, Add{SymReal}(0, ACDict{SymReal}(w => 1, z => 1); type = Complex{Real}))
    @test isequal(z + a, Add{SymReal}(0, ACDict{SymReal}(z => 1, a => 1); type = Complex{Real}))
    @test isequal(a + b, Add{SymReal}(0, ACDict{SymReal}(a => 1, b => 1); type = Real))
    @test isequal(a + x, Add{SymReal}(0, ACDict{SymReal}(a => 1, x => 1); type = Number))
    @test isequal(a + z, Add{SymReal}(0, ACDict{SymReal}(a => 1, z => 1); type = Complex{Real}))

    foo(w, z, a, b) = 1.0
    SymbolicUtils.promote_symtype(::typeof(foo), args...) = Real
    @test SymbolicUtils._promote_symtype(foo, (w, z, a, b,)) === Real

    # promote_symtype of identity
    @test isequal(Term{SymReal}(identity, [w]), Term{SymReal}(identity, [w]; type = Complex{Real}))
    @test isequal(+(w), w)
    @test isequal(+(a), a)

    @test isequal(rem2pi(a, RoundNearest), Term{SymReal}(rem2pi, [a, RoundNearest]; type = Real))

    # bool
    for f in [(==), (!=), (<=), (>=), (<)]
        @test isequal(f(a, 0), Term{SymReal}(f, [a, 0]; type = Bool))
        @test isequal(f(0, a), Term{SymReal}(f, [0, a]; type = Bool))
        @test isequal(f(a, a), Term{SymReal}(f, [a, a]; type = Bool))
    end

    @test symtype(ifelse(true, 4, 5)) == Int
    @test symtype(ifelse(a < 0, b, w)) == Complex{Real}
    @test SymbolicUtils.promote_symtype(ifelse, Bool, Int, Bool) == Int
    @test_throws MethodError w < 0
    @test isequal(w == 0, Term{SymReal}(==, [w, 0]; type = Bool))

    @syms x::Integer a::Integer
    @eqtest x // 5 == SymbolicUtils.Div{SymReal}(x, 5, false; type = Real)
    @eqtest (1//2 * x) / 5 == (1 // 10) * x
    @eqtest 5 // x == 5 / x
    @eqtest x // a == x / a

    # rename
    @set! x.name = :oof
    @test nameof(x) === :oof
end

@testset "array arithmetic" begin
    @syms a[1:2] a2[1:2] a3[2:3] b[1:3] c[1:2, 1:2] d::Vector{Number} d2::Vector{Number} e::Matrix{Number} f[1:2, 1:2, 1:2] g[1:3, 1:3] h q[1:2, 1:3] x y z

    @test_throws ErrorException BS[1, 2]
    # getindex
    @test BS{SymReal}[1, 2] isa Vector{BasicSymbolic{SymReal}}
    @test BS[1, a] isa Vector{BasicSymbolic{SymReal}}
    # typed_vcat
    @test BS{SymReal}[1; 2] isa Vector{BasicSymbolic{SymReal}}
    @test BS[1; a] isa Vector{BasicSymbolic{SymReal}}
    # typed_hcat
    @test BS{SymReal}[1 2] isa Matrix{BasicSymbolic{SymReal}}
    @test BS[1 a] isa Matrix{BasicSymbolic{SymReal}}
    # typed_hvcat
    @test BS{SymReal}[1 2; 3 4] isa Matrix{BasicSymbolic{SymReal}}
    @test BS[1 a; 3 4] isa Matrix{BasicSymbolic{SymReal}}
    # typed_hvncat, ::Int
    @test BS{SymReal}[1;; 2] isa Matrix{BasicSymbolic{SymReal}}
    @test BS[1;; a] isa Matrix{BasicSymbolic{SymReal}}
    # typed_hvncat, ::Dims ::Bool
    @test BS{SymReal}[1; 2;; 3; 4] isa Matrix{BasicSymbolic{SymReal}}
    @test BS[1; a;; 3; 4] isa Matrix{BasicSymbolic{SymReal}}
    symvec = BS[h, x]
    symmat = BS[h x; y z]
    @test symvec isa Vector{BasicSymbolic{SymReal}}
    @test symmat isa Matrix{BasicSymbolic{SymReal}}
    var = Const{SymReal}(symvec)
    @test var isa BasicSymbolic{SymReal}
    @test isterm(var)
    @test isequal(arguments(var), Const{SymReal}.([(2,), h, x]))
    @test symtype(var) == Vector{Number}
    @test shape(var) == ShapeVecT((1:2,))
    var = Const{SymReal}(symmat)
    @test var isa BasicSymbolic{SymReal}
    @test isterm(var)
    @test isequal(arguments(var), Const{SymReal}.([(2, 2), h, y, x, z]))
    @test symtype(var) == Matrix{Number}
    @test shape(var) == ShapeVecT((1:2, 1:2))
    csymvec = Const{SymReal}(symvec)
    csymmat = Const{SymReal}(symmat)

    var = a + a2
    @test var.dict == ACDict{SymReal}(a => 1, a2 => 1)
    @test shape(var) == ShapeVecT([1:2])
    @test symtype(var) == Vector{Number}
    var = a + symvec
    @test var.dict == ACDict{SymReal}(a => 1, csymvec => 1)
    @test shape(var) == ShapeVecT([1:2])
    @test symtype(var) == Vector{Number}
    var = a + a3
    @test var.dict == ACDict{SymReal}(a => 1, a3 => 1)
    # result is always 1-indexed
    @test shape(var) == ShapeVecT([1:2])
    @test symtype(var) == Vector{Number}
    var = a + d
    @test var.dict == ACDict{SymReal}(a => 1, d => 1)
    # result retains known shape
    @test shape(var) == ShapeVecT([1:2])
    @test symtype(var) == Vector{Number}
    var = d + d2
    @test var.dict == ACDict{SymReal}(d => 1, d2 => 1)
    @test shape(var) == SymbolicUtils.Unknown(1)
    @test symtype(var) == Vector{Number}

    @test_throws ArgumentError a + b
    @test_throws ArgumentError a3 + b
    @test_throws ArgumentError symvec + b
    @test_throws ArgumentError a + c
    @test_throws ArgumentError a3 + c
    @test_throws ArgumentError symvec + c
    @test_throws ArgumentError a + e
    @test_throws ArgumentError a3 + e
    @test_throws ArgumentError symvec + e

    var = a + a
    @test isequal(arguments(var), ArgsT{SymReal}([Const{SymReal}(2), a]))
    @test var.f === *
    @test shape(var) == ShapeVecT([1:2])
    @test symtype(var) == Vector{Number}

    var = c * a
    @test isequal(arguments(var), ArgsT{SymReal}([c, a]))
    @test var.f === *
    @test shape(var) == ShapeVecT([1:2])
    @test symtype(var) == Vector{Number}

    var = c * symvec
    @test isequal(arguments(var), ArgsT{SymReal}([c, csymvec]))
    @test var.f === *
    @test shape(var) == ShapeVecT([1:2])
    @test symtype(var) == Vector{Number}

    var = symmat * a
    @test isequal(arguments(var), ArgsT{SymReal}([csymmat, a]))
    @test var.f === *
    @test shape(var) == ShapeVecT([1:2])
    @test symtype(var) == Vector{Number}

    var = 2 * c * h * c * im
    @test var.f === *
    @test isequal(arguments(var), ArgsT{SymReal}((2 * h * im, c ^ 2)))
    @test shape(var) == ShapeVecT([1:2, 1:2])
    @test symtype(var) == Matrix{Number}
    var = var * a
    @test var.f === *
    @test isequal(arguments(var), ArgsT{SymReal}((2 * h * im, c^2, a)))
    @test shape(var) == ShapeVecT([1:2])
    @test symtype(var) == Vector{Number}

    var = c * e * c
    @test var.f === *
    @test isequal(arguments(var), ArgsT{SymReal}((c, e, c)))
    @test shape(var) == ShapeVecT([1:2, 1:2])
    @test symtype(var) == Matrix{Number}
    var = c * e
    @test var.f === *
    @test isequal(arguments(var), ArgsT{SymReal}((c, e)))
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    var = var * c
    @test var.f === *
    @test isequal(arguments(var), ArgsT{SymReal}((c, e, c)))
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    var = var * a
    @test var.f === *
    @test isequal(arguments(var), ArgsT{SymReal}((c, e, c, a)))
    @test shape(var) == SymbolicUtils.Unknown(1)
    @test symtype(var) == Vector{Number}

    var = c * e
    var = var * d
    @test var.f === *
    @test isequal(arguments(var), ArgsT{SymReal}((c, e, d)))
    @test shape(var) == SymbolicUtils.Unknown(1)
    @test symtype(var) == Vector{Number}

    var = e * a
    @test var.f === *
    @test isequal(arguments(var), ArgsT{SymReal}((e, a)))
    @test shape(var) == SymbolicUtils.Unknown(1)
    @test symtype(var) == Vector{Number}

    var = e * d
    @test var.f === *
    @test isequal(arguments(var), ArgsT{SymReal}((e, d)))
    @test shape(var) == SymbolicUtils.Unknown(1)
    @test symtype(var) == Vector{Number}

    var = c * c
    var = var * var
    @test var.f === ^
    @test isequal(var.args, ArgsT{SymReal}((c, Const{SymReal}(4))))
    @test shape(var) == ShapeVecT([1:2, 1:2])
    @test symtype(var) == Matrix{Number}

    @test unwrap_const(1 ^ c) == LinearAlgebra.I(2)
    @test unwrap_const(1 ^ e) == LinearAlgebra.I

    var = 2 ^ c
    @test var.f === ^
    @test isequal(var.args, ArgsT{SymReal}((Const{SymReal}(2), c)))
    @test shape(var) == ShapeVecT([1:2, 1:2])
    @test symtype(var) == Matrix{Number}

    # we can't support this without committing type piracy
    @test_throws MethodError 2 ^ symmat

    var = 2 ^ e
    @test var.f === ^
    @test isequal(var.args, ArgsT{SymReal}((Const{SymReal}(2), e)))
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}

    var = c ^ 2
    @test var.f === ^
    @test isequal(var.args, ArgsT{SymReal}((c, Const{SymReal}(2))))
    @test shape(var) == ShapeVecT([1:2, 1:2])
    @test symtype(var) == Matrix{Number}

    var = symmat ^ 2
    @test var isa Matrix{BasicSymbolic{SymReal}}
    @test size(var) == size(symmat)

    var = e ^ 2
    @test var.f === ^
    @test isequal(var.args, ArgsT{SymReal}((e, Const{SymReal}(2))))
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}

    var = h ^ c
    @test var.f === ^
    @test isequal(var.args, ArgsT{SymReal}((h, c)))
    @test shape(var) == ShapeVecT([1:2, 1:2])
    @test symtype(var) == Matrix{Number}

    var = h ^ symmat
    @test var.f === ^
    @test isequal(var.args, ArgsT{SymReal}((h, csymmat)))
    @test shape(var) == ShapeVecT([1:2, 1:2])
    @test symtype(var) == Matrix{Number}

    var = h ^ e
    @test var.f === ^
    @test isequal(var.args, ArgsT{SymReal}((h, e)))
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}

    var = c ^ h
    @test var.f === ^
    @test isequal(var.args, ArgsT{SymReal}((c, h)))
    @test shape(var) == ShapeVecT([1:2, 1:2])
    @test symtype(var) == Matrix{Number}

    var = symmat ^ h
    @test var.f === ^
    @test isequal(var.args, ArgsT{SymReal}((csymmat, h)))
    @test shape(var) == ShapeVecT([1:2, 1:2])
    @test symtype(var) == Matrix{Number}

    var = e ^ h
    @test var.f === ^
    @test isequal(var.args, ArgsT{SymReal}((e, h)))
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}

    @test_throws ArgumentError c * b
    @test_throws ArgumentError b * c
    @test_throws ArgumentError symmat * b
    @test_throws ArgumentError b * symmat
    @test_throws ArgumentError f * g
    @test_throws ArgumentError f * a
    @test_throws ArgumentError c * a * c
    @test_throws ArgumentError c * a * a
    @test_throws ArgumentError 2 ^ a
    @test_throws ArgumentError 2 ^ f
    @test_throws ArgumentError a ^ 2
    @test_throws ArgumentError f ^ 2
    @test_throws ArgumentError 2 ^ d
    @test_throws ArgumentError d ^ 2
    @test_throws ArgumentError q ^ 2
    @test_throws ArgumentError 2 ^ q

    @syms r[1:2, 1:2]::Real r2::Matrix{Real} i::Int j::Real

    var = r ^ 2
    @test shape(var) == ShapeVecT((1:2, 1:2))
    @test symtype(var) == Matrix{Real}
    var = r ^ i
    @test shape(var) == ShapeVecT((1:2, 1:2))
    @test symtype(var) == Matrix{Real}
    var = r ^ 2.4
    @test shape(var) == ShapeVecT((1:2, 1:2))
    @test symtype(var) == Matrix{Complex{Real}}
    var = r ^ h
    @test shape(var) == ShapeVecT((1:2, 1:2))
    @test symtype(var) == Matrix{Number}
    var = r ^ j
    @test shape(var) == ShapeVecT((1:2, 1:2))
    @test symtype(var) == Matrix{Complex{Real}}

    var = r2 ^ 2
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Real}
    var = r2 ^ i
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Real}
    var = r2 ^ 2.4
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Complex{Real}}
    var = r2 ^ h
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    var = r2 ^ j
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Complex{Real}}

    # FSLASH
    # * / Scalar
    var = a / h
    @test shape(var) == shape(a)
    @test symtype(var) == symtype(a)
    var = symvec / h
    @test shape(var) == shape(symvec)
    @test symtype(var) == symtype(csymvec)
    var = a3 / h
    @test shape(var) == shape(a3)
    @test symtype(var) == symtype(a3)
    var = c / h
    @test shape(var) == shape(c)
    @test symtype(var) == symtype(c)
    var = symmat / h
    @test shape(var) == shape(symmat)
    @test symtype(var) == symtype(csymmat)
    var = d / h
    @test shape(var) == shape(d)
    @test symtype(var) == symtype(d)
    var = f / h
    @test shape(var) == shape(f)
    @test symtype(var) == symtype(f)

    # Scalar / Vector
    var = h / a
    @test shape(var) == ShapeVecT((1:1, 1:2))
    @test symtype(var) == Matrix{Number}
    var = h / symvec
    @test shape(var) == ShapeVecT((1:1, 1:2))
    @test symtype(var) == Matrix{Number}
    var = h / a3
    @test shape(var) == ShapeVecT((1:1, 2:3))
    @test symtype(var) == Matrix{Number}
    var = h / d
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    # Scalar / Array
    @test_throws ArgumentError h / c
    @test_throws ArgumentError h / symmat
    @test_throws ArgumentError h / e
    @test_throws ArgumentError h / f

    # Vector / Vector
    var = a / a
    @test shape(var) == ShapeVecT((1:2, 1:2))
    @test symtype(var) == Matrix{Number}
    var = a / symvec
    @test shape(var) == ShapeVecT((1:2, 1:2))
    @test symtype(var) == Matrix{Number}
    var = a / a3
    @test shape(var) == ShapeVecT((1:2, 2:3))
    @test symtype(var) == Matrix{Number}
    var = a3 / a
    @test shape(var) == ShapeVecT((2:3, 1:2))
    @test symtype(var) == Matrix{Number}
    var = a3 / symvec
    @test shape(var) == ShapeVecT((2:3, 1:2))
    @test symtype(var) == Matrix{Number}
    var = a3 / b
    @test shape(var) == ShapeVecT((2:3, 1:3))
    @test symtype(var) == Matrix{Number}
    var = a / d
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    var = d / a
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}

    @syms cmat[1:3, 1:1] cmat2::Matrix{Number}
    # Vector / Matrix
    var = a / cmat
    @test shape(var) == ShapeVecT((1:2, 1:3))
    @test symtype(var) == Matrix{Number}
    var = symvec / cmat
    @test shape(var) == ShapeVecT((1:2, 1:3))
    @test symtype(var) == Matrix{Number}
    var = a3 / cmat
    @test shape(var) == ShapeVecT((2:3, 1:3))
    @test symtype(var) == Matrix{Number}
    var = d / cmat
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    var = a / cmat2
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    var = symvec / cmat2
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    var = a3 / cmat2
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    var = d / cmat2
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    @test_throws ArgumentError a / c
    @test_throws ArgumentError a3 / c
    @test_throws ArgumentError symvec / c
    @test_throws ArgumentError a / symmat

    # Matrix / Vector
    @test_throws ArgumentError c / a
    @test_throws ArgumentError c / a3
    @test_throws ArgumentError e / a
    @test_throws ArgumentError e / a3
    @test_throws ArgumentError c / d
    @test_throws ArgumentError e / d
    @test_throws ArgumentError symmat / a
    @test_throws ArgumentError c / symvec

    # Matrix / Matrix
    var = c / c
    @test shape(var) == ShapeVecT((1:2, 1:2))
    @test symtype(var) == Matrix{Number}
    var = c / symmat
    @test shape(var) == ShapeVecT((1:2, 1:2))
    @test symtype(var) == Matrix{Number}
    var = symmat / c
    @test shape(var) == ShapeVecT((1:2, 1:2))
    @test symtype(var) == Matrix{Number}
    var = g / q
    @test shape(var) == ShapeVecT((1:3, 1:2))
    @test symtype(var) == Matrix{Number}
    var = q / g
    @test shape(var) == ShapeVecT((1:2, 1:3))
    @test symtype(var) == Matrix{Number}
    var = c / e
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    var = e / c
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    @test_throws ArgumentError c / g
    @test_throws ArgumentError g / c
    @test_throws ArgumentError symmat / g
    @test_throws ArgumentError g / symmat

    # BSLASH
    # Scalar \ *
    var = h \ a
    @test shape(var) == ShapeVecT((1:2,))
    @test symtype(var) == Vector{Number}
    var = h \ symvec
    @test shape(var) == ShapeVecT((1:2,))
    @test symtype(var) == Vector{Number}
    var = h \ a3
    @test shape(var) == ShapeVecT((2:3,))
    @test symtype(var) == Vector{Number}
    var = h \ c
    @test shape(var) == ShapeVecT((1:2, 1:2))
    @test symtype(var) == Matrix{Number}
    var = h \ symmat
    @test shape(var) == ShapeVecT((1:2, 1:2))
    @test symtype(var) == Matrix{Number}
    var = h \ q
    @test shape(var) == ShapeVecT((1:2, 1:3))
    @test symtype(var) == Matrix{Number}
    var = h \ f
    @test shape(var) == ShapeVecT((1:2, 1:2, 1:2))
    @test symtype(var) == Array{Number, 3}
    var = h \ d
    @test shape(var) == SymbolicUtils.Unknown(1)
    @test symtype(var) == Vector{Number}
    var = h \ e
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}

    # Vector \ Scalar
    @test_throws ArgumentError a \ h
    @test_throws ArgumentError symvec \ h
    @test_throws ArgumentError a3 \ h
    @test_throws ArgumentError d \ h

    # Vector \ Vector
    var = a \ a
    @test shape(var) == ShapeVecT()
    @test symtype(var) == Number
    var = a \ symvec
    @test shape(var) == ShapeVecT()
    @test symtype(var) == Number
    var = a \ a3
    @test shape(var) == ShapeVecT()
    @test symtype(var) == Number
    var = a3 \ a
    @test shape(var) == ShapeVecT()
    @test symtype(var) == Number
    var = symvec \ a
    @test shape(var) == ShapeVecT()
    @test symtype(var) == Number
    var = a \ d
    @test shape(var) == ShapeVecT()
    @test symtype(var) == Number
    var = d \ a
    @test shape(var) == ShapeVecT()
    @test symtype(var) == Number
    var = d \ d
    @test shape(var) == ShapeVecT()
    @test symtype(var) == Number
    @test_throws ArgumentError b \ a
    @test_throws ArgumentError a \ b
    @test_throws ArgumentError b \ symvec
    @test_throws ArgumentError symvec \ b

    # Vector \ Matrix
    var = a \ c
    @test shape(var) == ShapeVecT((1:1, 1:2))
    @test symtype(var) == Matrix{Number}
    var = symvec \ c
    @test shape(var) == ShapeVecT((1:1, 1:2))
    @test symtype(var) == Matrix{Number}
    var = a \ symmat
    @test shape(var) == ShapeVecT((1:1, 1:2))
    @test symtype(var) == Matrix{Number}
    var = a3 \ c
    @test shape(var) == ShapeVecT((1:1, 1:2))
    @test symtype(var) == Matrix{Number}
    var = d \ c
    @test shape(var) == ShapeVecT((1:1, 1:2))
    @test symtype(var) == Matrix{Number}
    var = a \ e
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    var = d \ e
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    @test_throws ArgumentError a \ g
    @test_throws ArgumentError a3 \ g
    @test_throws ArgumentError symvec \ g

    # Matrix \ Scalar
    @test_throws ArgumentError c \ h
    @test_throws ArgumentError e \ h
    @test_throws ArgumentError symmat \ h

    # Matrix \ Vector
    var = c \ a
    @test shape(var) == ShapeVecT((1:2,))
    @test symtype(var) == Vector{Number}
    var = c \ symvec
    @test shape(var) == ShapeVecT((1:2,))
    @test symtype(var) == Vector{Number}
    var = symmat \ a
    @test shape(var) == ShapeVecT((1:2,))
    @test symtype(var) == Vector{Number}
    var = c \ a3
    @test shape(var) == ShapeVecT((1:2,))
    @test symtype(var) == Vector{Number}
    var = c \ d
    @test shape(var) == ShapeVecT((1:2,))
    @test symtype(var) == Vector{Number}
    var = e \ a
    @test shape(var) == SymbolicUtils.Unknown(1)
    @test symtype(var) == Vector{Number}
    var = e \ d
    @test shape(var) == SymbolicUtils.Unknown(1)
    @test symtype(var) == Vector{Number}
    @test_throws ArgumentError c \ b

    # Matrix \ Matrix
    var = c \ c
    @test shape(var) == ShapeVecT((1:2, 1:2))
    @test symtype(var) == Matrix{Number}
    var = c \ symmat
    @test shape(var) == ShapeVecT((1:2, 1:2))
    @test symtype(var) == Matrix{Number}
    var = symmat \ c
    @test shape(var) == ShapeVecT((1:2, 1:2))
    @test symtype(var) == Matrix{Number}
    var = c \ e
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    var = e \ c
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    var = e \ e
    @test shape(var) == SymbolicUtils.Unknown(2)
    @test symtype(var) == Matrix{Number}
    var = c \ q
    @test shape(var) == ShapeVecT((1:2, 1:3))
    @test symtype(var) == Matrix{Number}
    var = q \ c
    @test shape(var) == ShapeVecT((1:3, 1:2))
    @test symtype(var) == Matrix{Number}
    @test_throws ArgumentError c \ g
    @test_throws ArgumentError g \ c
end

@testset "Symbolic getindex" begin
    @syms a b[1:4] c[1:4, 1:4] e::Vector{Number} f::Matrix{Number}
    @syms ii::Integer i[1:2]::Int32 j[2:3]::Int k::Vector{Int} l[1:2, 1:2]::Int m

    csymvec = Const{SymReal}([a, m, a, m])
    csymmat = Const{SymReal}([a m a m; m a m a; a m a m; m a m a])
    @testset "$x - $(shape(x))" for x in [b, e, csymvec]
        @testset "idx = $idx" for idx in [2, ii]
            var = x[idx]
            @test symtype(var) == Number
            @test shape(var) == ShapeVecT()
        end

        @testset "idx = $idx" for idx in [1:2, 3:4, i, j]
            var = x[idx]
            @test symtype(var) == Vector{Number}
            @test shape(var) == ShapeVecT((1:2,))
        end

        if shape(x) isa SymbolicUtils.Unknown
            @test_throws ArgumentError x[:]
        else
            var = x[:]
            @test symtype(var) == Vector{Number}
            @test shape(var) == ShapeVecT((1:4,))
        end

        if isequal(x, csymvec)
            @test_throws BoundsError x[]
            @test_throws BoundsError x[1, 2]
        else
            @test_throws ArgumentError x[]
            @test_throws ArgumentError x[1, 2]
            @test_throws MethodError x[[1 2; 3 4]]
        end
        @test_throws ArgumentError x[k]
        @test_throws ArgumentError x[l]
        @test_throws ArgumentError x[m]
    end
    @testset "$x - $(shape(x))" for x in [c, f, csymmat]
        scalidxs = [ii, 3]
        @testset "idx = $idx" for idx in Iterators.product(scalidxs, scalidxs)
            var = x[idx...]
            @test symtype(var) == Number
            @test shape(var) == ShapeVecT()
        end
        arridxs = [1:2, 3:4, i, j]
        @testset "idx = $idx" for idx in Iterators.product(arridxs, arridxs)
            var = x[idx...]
            @test symtype(var) == Matrix{Number}
            @test shape(var) == ShapeVecT((1:2, 1:2))
        end

        @testset "idx = $idx" for idx in Iterators.product(scalidxs, arridxs)
            var = x[idx...]
            @test symtype(var) == Vector{Number}
            @test shape(var) == ShapeVecT((1:2,))
        end
        @testset "idx = $idx" for idx in Iterators.product(arridxs, scalidxs)
            var = x[idx...]
            @test symtype(var) == Vector{Number}
            @test shape(var) == ShapeVecT((1:2,))
        end

        if shape(x) isa SymbolicUtils.Unknown
            @test_throws ArgumentError x[:, :]
            @test_throws ArgumentError x[1, :]
            @test_throws ArgumentError x[:, 1]
        else
            var = x[:, :]
            @test symtype(var) == Matrix{Number}
            @test shape(var) == ShapeVecT((1:4, 1:4))
            @testset "idx = ($idx, :)" for idx in scalidxs
                var = x[idx, :]
                @test symtype(var) == Vector{Number}
                @test shape(var) == ShapeVecT((1:4,))
                var = x[:, idx]
                @test symtype(var) == Vector{Number}
                @test shape(var) == ShapeVecT((1:4,))
            end
            @testset "idx = ($idx, :)" for idx in arridxs
                var = x[idx, :]
                @test symtype(var) == Matrix{Number}
                @test shape(var) == ShapeVecT((1:2, 1:4))
                var = x[:, idx]
                @test symtype(var) == Matrix{Number}
                @test shape(var) == ShapeVecT((1:4, 1:2))
            end
        end
        if isequal(x, csymmat)
            @test_throws BoundsError x[]
        else
            @test_throws ArgumentError x[]
            @test_throws MethodError x[[1 2; 3 4], 1]
            @test_throws ArgumentError x[1]
        end
        @test_throws ArgumentError x[k, 1]
        @test_throws ArgumentError x[l, 1]
        @test_throws ArgumentError x[m, 1]
    end
end

@testset "err test" begin
    @syms t()
    @test_throws ErrorException t(2)
end

@testset "substitute" begin
    @syms a b
    @test unwrap_const(substitute(a, Dict(a=>1))) == 1
    @test isequal(substitute(sin(a+b), Dict(a=>1)), sin(b+1))
    @test unwrap_const(substitute(a+b, Dict(a=>1, b=>3))) == 4
    @test unwrap_const(substitute(exp(a), Dict(a=>2); fold = Val(true))) ≈ exp(2)
end

@testset "query" begin
    @syms a b c
    @test query(isequal(a), a + b)
    @test !query(isequal(sin(a)), a + b + c)
    @test query(isequal(sin(a)),  a * b + c + sin(a^2 * sin(a)))
    @test query(isequal(Const{SymReal}(0.01)), 0.01^a)
    @test !query(isequal(Const{SymReal}(0.01)), a * b * c)
end

@testset "printing" begin
    @syms a b c
    @test repr(a+b) == "a + b"
    @test repr(-a) == "-a"
    @test repr(term(-, a; type = Real)) == "-a"
    @test repr(-a + 3) == "3 - a"
    @test repr(-(a + b)) == "-a - b"
    @test repr((2a)^(-2a)) == "(2a)^(-2a)"
    @test repr(1/2a) == "1 / (2a)"
    @test repr(2/(2*a)) == "1 / a"
    @test repr(Term{SymReal}(*, [1, 1])) == "1"
    @test repr(Term{SymReal}(*, [2, 1])) == "2*1"
    @test repr((a + b) - (b + c)) == "a - c"
    @test repr(a + -1*(b + c)) == "a - b - c"
    @test repr(a + -1*b) == "a - b"
    @test repr(-1^a) == "-(1^a)"
    @test repr((-1)^a) == "(-1)^a"

    struct PrintCtx end
    function SymbolicUtils.show_metadata(io::IO, x::SymbolicUtils.BasicSymbolic, ::Type{PrintCtx}, val)
        print(io, "CTX(", val, "):")
        SymbolicUtils.show_plain(io, x)
        return true
    end
    expr = SymbolicUtils.setmetadata(a + b, PrintCtx, "sum")
    @test repr(expr) == "CTX(sum):a + b"
end

@testset "polynomial printing" begin
    @syms a b c x[1:3]
    @test repr(b+a) == "a + b"
    @test repr(b-a) == "-a + b"
    @test repr(2a+1+3a^2) == "1 + 2a + 3(a^2)"
    @test repr(2a+1+3a^2+2b+3b^2+4a*b) == "1 + 2a + 2b + 3(a^2) + 4a*b + 3(b^2)"

    @syms a b[1:3] c d[1:3]
    _get(x, i) = term(getindex, x, i, type=Number)
    b1, b3, d1, d2 = _get(b,1),_get(b,3), _get(d,1), _get(d,2)
    @test repr(a + b3 + b1 + d2 + c) == "a + b[1] + b[3] + c + d[2]"
    @test repr(expand((c + b3 - d1)^3)) == "b[3]^3 + 3(b[3]^2)*c - 3(b[3]^2)*d[1] + 3b[3]*(c^2) - 6b[3]*c*d[1] + 3b[3]*(d[1]^2) + c^3 - 3(c^2)*d[1] + 3c*(d[1]^2) - (d[1]^3)"
    # test negative powers sorting
    @test repr((b3^2)^(-2) + a^(-3) + (c*d1)^(-2)) == "1 / (a^3) + 1 / (b[3]^4) + 1 / ((c^2)*(d[1]^2))"

    # test that the "x^2 + y^-1 + sin(a)^3.5 + 2t + 1//1" expression from Symbolics.jl/build_targets.jl is properly sorted
    @syms x1 y1 a1 t1
    @test repr(x1^2 + y1^-1 + sin(a1)^3.5 + 2t1 + 1//1) == "(1//1) + 2t1 + 1 / y1 + x1^2 + sin(a1)^3.5"
end

@testset "inspect" begin
    @syms x y z
    y = SymbolicUtils.setmetadata(y, Integer, 42) # Set some metadata
    ex = z*(2x + 3y + 1)^2/(z+2x)
    @test_reference "inspect_output/ex.txt" sprint(io->SymbolicUtils.inspect(io, ex))
    @test_reference "inspect_output/ex-md.txt" sprint(io->SymbolicUtils.inspect(io, ex, metadata=true))
    @test_reference "inspect_output/ex-nohint.txt" sprint(io->SymbolicUtils.inspect(io, ex, hint=false))
    @test unwrap_const(SymbolicUtils.pluck(ex, 12)) == 2
    @test_reference "inspect_output/sub10.txt" sprint(io->SymbolicUtils.inspect(io, SymbolicUtils.pluck(ex, 9)))
    @test_reference "inspect_output/sub14.txt" sprint(io->SymbolicUtils.inspect(io, SymbolicUtils.pluck(ex, 14)))
end

@testset "maketerm" begin
    @syms a b c
    t = SymbolicUtils.maketerm(typeof(b + c), +, [a,  (b+c)], nothing)
    @test isequal(t.dict, ACDict{SymReal}(a => 1, b => 1, c => 1))
    @test isequal(SymbolicUtils.maketerm(typeof(b^2), ^, [b^2,  1//2],  nothing), b)

    # test that maketerm doesn't hard-code BasicSymbolic subtype
    # and is consistent with BasicSymbolic arithmetic operations
    @test isequal(SymbolicUtils.maketerm(typeof(a / b), *, [a / b, c],  nothing), (a / b) * c)
    @test isequal(SymbolicUtils.maketerm(typeof(a * b), *, [0, c],  nothing), Const{SymReal}(0))
    @test isequal(SymbolicUtils.maketerm(typeof(a^b), ^, [a * b, 3],  nothing), (a * b)^3)

    # test that maketerm sets metadata correctly
    metadata = Base.ImmutableDict{DataType, Any}(Ctx1, "meta_1")
    metadata2 = Base.ImmutableDict{DataType, Any}(Ctx2, "meta_2")

    d = b * c
    @set! d.metadata = metadata2

    s = SymbolicUtils.maketerm(typeof(a + d), +, [a, d], metadata)
    args = arguments(s)
    idx = findfirst(isequal(d), args)
    @test getmetadata(args[idx], Ctx2) == "meta_2"
    @test hasmetadata(s, Ctx1)
    @test getmetadata(s, Ctx1) == "meta_1"

    s = SymbolicUtils.maketerm(typeof(a * d), *, [a, d], metadata)
    @test hasmetadata(s, Ctx1)
    @test getmetadata(s, Ctx1) == "meta_1"

    s = SymbolicUtils.maketerm(typeof(a^b), ^, [a * b, 3], metadata)
    @test !hasmetadata(s, Ctx1)

    s = SymbolicUtils.maketerm(typeof(a^b), *, [a * b, 3], metadata)
    @test hasmetadata(s, Ctx1)
    @test getmetadata(s, Ctx1) == "meta_1"

    # Correct symtype propagation
    ref_expr = a * b
    @test symtype(ref_expr) == Number
    new_expr = SymbolicUtils.maketerm(typeof(ref_expr), (==), [a, b], nothing)
    @test symtype(new_expr) == Bool

    # Doesn't know return type, promoted symtype is Any
    foo(x,y) = x^2 + x
    new_expr = SymbolicUtils.maketerm(typeof(ref_expr), foo, [a, b], nothing)
    @test symtype(new_expr) == Any
    new_expr = SymbolicUtils.maketerm(typeof(ref_expr), foo, [a, b], nothing; type = Number)
    @test symtype(new_expr) == Number

    # Promoted symtype is a subtype of referred
    @syms x::Int y::Int
    new_expr = SymbolicUtils.maketerm(typeof(ref_expr), (+), [x, y], nothing)
    @test symtype(new_expr) == Int64

    # Check that the Array type does not get changed to AbstractArray
    new_expr = SymbolicUtils.maketerm(
        SymbolicUtils.BasicSymbolic{SymReal}, sin, [1.0, 2.0], nothing; type = Vector{Float64})
    @test symtype(new_expr) == Vector{Float64}
end

toterm(t) = Term{vartype(t)}(operation(t), sorted_arguments(t); type = symtype(t))

@testset "diffs" begin
    @syms a b c
    @test isequal(toterm(-1c), Term{SymReal}(*, [-1, c]; type = Number))
    @test isequal(toterm(-1(a+b)), Term{SymReal}(+, [-a, -b]; type = Number))
    @test isequal(toterm((a + b) - (b + c)), Term{SymReal}(+, [a, -c]; type = Number))
end

@testset "hash" begin
    @syms a b
    @test hash(a + b, UInt(0)) === hash(a + b) === hash(a + b, UInt(0)) # test caching
    @test hash(a + b, UInt(2)) !== hash(a + b)
end

@testset "methoderror" begin
    @syms a::Any b::Any

    @test_throws MethodError a * b
    @test_throws MethodError a + b
end

@testset "canonical form" begin
    @syms a b c
    for x in [a, a*b, a^2, sin(a)]
        @test isequal(x * 1, x)
        @test x * 0 === Const{SymReal}(0)
        @test isequal(x + 0, x)
        @test isequal(x + x, 2x)
        @test isequal(x + 2x, 3x)
        @test unwrap_const(x - x) === 0
        @test isequal(-x, -1x)
        @test isequal(x^1, x)
        @test isequal(unwrap_const((x^-1)*inv(x^-1)), 1)
    end
end

@testset "isequal" begin
    @syms a b c
    @test isequal(a + b, a + b + 0.01 - 0.01)
    @test isequal(a + NaN, a + NaN)

    @test !isequal(a, missing)
    @test !isequal(missing, b)

    a1 = setmetadata(a, Ctx1, "meta_1")
    a2 = setmetadata(a, Ctx1, "meta_1")
    a3 = setmetadata(a, Ctx2, "meta_2")
    SymbolicUtils.@manually_scope SymbolicUtils.COMPARE_FULL => true begin
        @test !isequal(a, a1)
        @test isequal(a1, a2)
        @test !isequal(a1, a3)
    end
end

@testset "subtyping" begin
    T = FnType{Tuple{T,S,Int} where {T,S}, Real, Nothing}
    s = Sym{SymReal}(:t; type = T)
    @syms a b c::Int
    @test isequal(arguments(s(a, b, c)), [a, b, c])
end

@testset "div" begin
    @syms x y::Real vartype=SafeReal
    @test issym((2x/2y).num)
    @test get_mul_coefficient((2x/3y).num) == 2
    @test get_mul_coefficient((2x/3y).den) == 3
    @test get_mul_coefficient((2x/-3x).num) == -2
    @test get_mul_coefficient((2x/-3x).den) == 3
    @test get_mul_coefficient((2.5x/3x).num) == 2.5
    @test get_mul_coefficient((2.5x/3x).den) == 3
    @test get_mul_coefficient((x/3x).den) == 3

    @syms x y
    @test issym((2x/2y).num)
    @test get_mul_coefficient((2x/3y).num) == 2
    @test get_mul_coefficient((2x/3y).den) == 3
    @test unwrap_const(2x/-3x) == -2//3
    @test unwrap_const((2.5x/3x)) == 2.5/3
    @test unwrap_const(x/3x) == 1//3
    @test isequal(x / 1, x)
    @test isequal(x / -1, -x)
end

@testset "mul worker buffer is reentrancy-safe" begin
    @syms x y w
    p = Mul{SymReal}(2, Dict((x / y) => -1); type = Real)
    @test isequal(p * (1 // 2) * (1 / w), y / (x * w))

    t = Term{SymReal}(^, ArgsT{SymReal}((x / y, Const{SymReal}(-1))); type = Real, shape = ShapeVecT())
    @test isequal(t * (1 / w), y / (x * w))
end

@testset "Issue#717: Power with complex exponent" begin
    @syms x
    t = x ^ im
    @test iscall(t)
    @test operation(t) == (^)
    @test isequal(unwrap_const.(arguments(t)), [x, im])
end

@testset "LiteralReal" begin
    @syms x y z vartype=TreeReal
    @test repr(x+x) == "x + x"
    @test repr(x*x) == "x * x"
    @test repr(x*x + x*x) == "(x * x) + (x * x)"
    for ex in [sin(x), x+x, x*x, x\x, x/x]
        @test typeof(sin(x)) === BasicSymbolic{TreeReal}
    end
    @test repr(sin(x) + sin(x)) == "sin(x) + sin(x)"
end

@testset "Adjoint" begin
    @syms x::Real y
    ax = adjoint(x)
    @test isequal(ax, x)
    @test ax === x
    @test isequal(adjoint(y), conj(y))
end

@testset "`setproperties` clears hash" begin
    @syms a b c
    hash(a)
    hash(b)
    hash(c)
    @test hash(a) != hash(setproperties(a; name = :A))
    function foo end
    function bar end
    var = term(foo, [a, b]; type = Real)
    hash(var)
    @test hash(var) != hash(setproperties(var; f = bar))
    var = a + b
    hash(var)
    @test hash(var) != hash(setproperties(var; dict = ACDict{SymReal}(a => 2, b => 2)))
    @test hash(var) != hash(setproperties(var; coeff = 4))
    var = a * b
    hash(var)
    @test hash(var) != hash(setproperties(var; dict = ACDict{SymReal}(a => 2, b => 2)))
    @test hash(var) != hash(setproperties(var; coeff = 4))
    var = a / b
    hash(var)
    @test hash(var) != hash(setproperties(var; num = c))
end

@testset "`substitute` handles identity of */+" begin
    @syms t x(t) y
    x = setmetadata(x(t), Int, 3)
    ex = x * y
    res = substitute(ex, Dict(y => 1))
    SymbolicUtils.@manually_scope SymbolicUtils.COMPARE_FULL => true begin
        @test isequal(res, x)
    end
    ex = x + y
    res = substitute(ex, Dict(y => 0))
    SymbolicUtils.@manually_scope SymbolicUtils.COMPARE_FULL => true begin
        @test isequal(res, x)
    end
end

@testset "Negative coefficient to fractional power" begin
    @syms a
    @test isequal((-5a)^0.5, sqrt(5) * Term{SymReal}(^, [-a, 0.5]; type = Number, shape = ShapeVecT()))
end

@testset "Equivalent expressions across tasks are equal" begin
    @syms a
    task = Threads.@spawn @syms a
    a2 = only(fetch(task))
    @test isequal(a, a2)
    @test SymbolicUtils.@manually_scope SymbolicUtils.COMPARE_FULL => true begin
        isequal(a, a2)
    end
end

@testset "AddMul coefficients are hashconsed properly" begin
    @syms x
    v1 = 0.5x
    @test isequal(v1.coeff, 0.5)
    v2 = (1//2)x
    @test v2.coeff !== 0.5
    @test v2.coeff === 1//2
end

@testset "`imag(::Real)`" begin
    @syms x::Real
    @test SymbolicUtils._iszero(imag(x))
end

@testset "`StableIndices`" begin
    @syms x[1:3] y[-2:5, 3:7] z[-10:-4, 0:5, 1:2]
    for v in [x, y, z]
        idxs = SymbolicUtils.stable_eachindex(v)
        els = [v[i] for i in idxs]
        truth = vec(collect(v))
        @test isequal(els, truth)
        # Test that `eachindex(::StableIndices)` works as intended
        # Also tests `isequal(::StableIndex)`
        @test isequal(collect(idxs), [idxs[i] for i in eachindex(idxs)])

        for i in 1:length(v)
            @test Tuple(idxs[i]) == Tuple(CartesianIndices(Tuple(shape(v)))[i])
        end
    end
end

@testset "promote_symtype with sparse operations" begin
    S = sprand(5, 5, 0.1)
    @syms z[1:5, 1:5]::Real
    @test SymbolicUtils.promote_symtype(*, typeof(S), symtype(z)) == Matrix{Real}
    @test SymbolicUtils.promote_symtype(+, typeof(S), symtype(z)) == Matrix{Real}
    @test SymbolicUtils.promote_symtype(\, typeof(S), symtype(z)) == Matrix{Real}
    @test SymbolicUtils.promote_symtype(/, typeof(S), symtype(z)) == Matrix{Real}
end

@testset "Symbolic `StableIndex`" begin
    @syms x[1:3] y[-2:5, 3:7] z[-10:-4, 0:5, 1:2]
    @syms i::Int j::Int
    idxs = [i, i + j, i * j]
    for v in [x, y, z]
        idx = SymbolicUtils.StableIndex(idxs[1:ndims(v)])
        el = v[idx]
        truth = v[idxs[1:ndims(v)]...]
        @test isequal(el, truth)
    end
end

@testset "`StableIndex{Int}(::BasicSymbolic)`" begin
    @syms x[1:3, 1:3] y j::Int k::Int

    i = SymbolicUtils.StableIndex{Int}(x[1, 3])
    @test i.idxs == [1, 3]
    @test_throws ArgumentError SymbolicUtils.StableIndex{Int}(y)
    @test_throws TypeError SymbolicUtils.StableIndex{Int}(x[j, k])
end

@testset "`StableIndex{Int}` indexing of `Array`" begin
    i = SymbolicUtils.StableIndex([1, 2])
    arr = rand(3, 3)
    @test arr[i] == arr[1, 2]
    arr[i] = 4.5
    @test arr[1, 2] == 4.5
end

@testset "`LinearAlgebra.cross`" begin
    @syms x[1:3] xx[1:3] y::Vector{Real} z[1:4] w::Matrix{Real}

    @test isequal(LinearAlgebra.cross(x, xx), Const{SymReal}(LinearAlgebra.cross(collect(x), collect(xx))))
    @test isequal(LinearAlgebra.cross(x, y), Const{SymReal}(LinearAlgebra.cross(collect(x), [y[1], y[2], y[3]])))
    @test isequal(LinearAlgebra.cross(x, collect(xx)), Const{SymReal}(LinearAlgebra.cross(collect(x), collect(xx))))
    @test isequal(LinearAlgebra.cross(x, [1,2,3]), Const{SymReal}(LinearAlgebra.cross(collect(x), [1,2,3])))
    @test isequal(LinearAlgebra.cross(xx, x), Const{SymReal}(LinearAlgebra.cross(collect(xx), collect(x))))
    @test isequal(LinearAlgebra.cross(y, x), Const{SymReal}(LinearAlgebra.cross([y[1], y[2], y[3]], collect(x))))
    @test isequal(LinearAlgebra.cross(collect(xx), x), Const{SymReal}(LinearAlgebra.cross(collect(xx), collect(x))))
    @test isequal(LinearAlgebra.cross([1,2,3], x), Const{SymReal}(LinearAlgebra.cross([1,2,3], collect(x))))
    @test_throws "3-vector" LinearAlgebra.cross(x, z)
    @test_throws "3-vector" LinearAlgebra.cross(y, z)
    @test_throws "expects vectors" LinearAlgebra.cross(x, w)
    @test_throws "expects vectors" LinearAlgebra.cross(y, w)
end

@testset "`transpose`" begin
    @syms x[1:3] y[1:3, 1:3]

    var = transpose(x)
    @test operation(var) === transpose
    @test symtype(var) == LinearAlgebra.Adjoint{Number, Vector{Number}}
    @test shape(var) == [1:1, 1:3]

    var = transpose(y)
    @test operation(var) === transpose
    @test symtype(var) == LinearAlgebra.Adjoint{Number, Matrix{Number}}
    @test shape(var) == [1:3, 1:3]
end

@testset "`Const`-ification of `adjoint`/`transpose`" begin
    @syms a b c

    v1 = [a, b, c]
    var = Const{SymReal}(v1')
    @test operation(var) === adjoint
    @test symtype(var) == LinearAlgebra.Adjoint{Number, Vector{Number}}

    @test shape(var) == [1:1, 1:3]
    @test isequal(collect(var), v1')

    v1 = [a b c; b c a; c a b]
    var = Const{SymReal}(v1')
    @test operation(var) === adjoint
    @test symtype(var) == LinearAlgebra.Adjoint{Number, Matrix{Number}}
    @test shape(var) == [1:3, 1:3]
    @test isequal(collect(var), v1')
end

@testset "`^` doesn't distribute into `/`" begin
    @syms a b c
    ex = (a / b) ^ c
    @test operation(ex) === (^)
    @test isequal(arguments(ex), [a/b, c])
end

@testset "Vector * transpose(Vector) works" begin
    @syms b[1:3] c[2:6] d[3:3, -1:4]
    ex = b * c'
    @test symtype(ex) === Matrix{Number}
    @test shape(ex) == [1:3, 2:6]

    ex = b * d
    @test symtype(ex) === Matrix{Number}
    @test shape(ex) == [1:3, -1:4]
end

@testset "Issue#838: Handle `x'x` dot product" begin
    @syms x[1:3] y[1:3, 1:4]
    @test symtype(x') === LinearAlgebra.Adjoint{Number, Vector{Number}}
    @test symtype(x'x) === Number
    @test symtype(x'y) === LinearAlgebra.Adjoint{Number, Matrix{Number}}
end

@testset "`exp(::Matrix)`" begin
    @syms x y[1:3] z[1:3, 1:4] w[1:3, 1:3]

    ex = exp(x)
    @test symtype(ex) === Number
    @test shape(ex) == UnitRange{Int}[]

    @test_throws ErrorException exp(y)
    @test_throws ArgumentError exp(z)

    ex = exp(w)
    @test symtype(ex) === Matrix{Number}
    @test shape(ex) == shape(w)

    ex = exp(w')
    @test symtype(ex) === LinearAlgebra.Adjoint{Number, Matrix{Number}}
    @test shape(ex) == shape(w)

    @test SymbolicUtils.promote_symtype(exp, Real) === Real
    @test SymbolicUtils.promote_symtype(exp, Number) === Number
    @test SymbolicUtils.promote_symtype(exp, Int) === Real
    @test SymbolicUtils.promote_symtype(exp, Rational{Int}) === Real
    @test SymbolicUtils.promote_symtype(exp, ComplexF64) === ComplexF64
    @test SymbolicUtils.promote_symtype(exp, Complex{Int}) === Complex{Real}
    @test SymbolicUtils.promote_symtype(exp, Matrix{Int}) === Matrix{Real}
    @test SymbolicUtils.promote_symtype(exp, LinearAlgebra.Adjoint{Int, Matrix{Int}}) === LinearAlgebra.Adjoint{Real, Matrix{Real}}
end

@testset "`hasname` properly handles indexed variables" begin
    @syms x[1:3]
    @test !SII.hasname((2x)[1])
end

@testset "Div * Array" begin
    @syms x y z
    ex = (x / y) * BS[z, 1]
    @test operation(ex) === (*)
    @test issetequal(arguments(ex), [x / y, SymbolicUtils.Const{SymReal}(BS[z, 1])])
end

@testset "Addition of `Const` arrays" begin
    arr1 = Const{SymReal}(ones(3, 3))
    arr2 = Const{SymReal}(ones(3, 3))
    @test isequal(arr1 + arr2, Const{SymReal}(2ones(3, 3)))
end

@testset "ComposedFunction promote_symtype" begin
    # Test basic two-function compositions
    @test SymbolicUtils.promote_symtype(sin ∘ sqrt, Real) == Real
    @test SymbolicUtils.promote_symtype(cos ∘ sin, Real) == Real
    @test SymbolicUtils.promote_symtype(abs ∘ sin, Real) == Real
    @test SymbolicUtils.promote_symtype(exp ∘ log, Real) == Real

    # Test three-function compositions
    @test SymbolicUtils.promote_symtype(sin ∘ abs ∘ sqrt, Real) == Real
    @test SymbolicUtils.promote_symtype(cos ∘ sin ∘ abs, Real) == Real
    @test SymbolicUtils.promote_symtype(exp ∘ sin ∘ sqrt, Real) == Real

    # Test four-function compositions
    @test SymbolicUtils.promote_symtype(exp ∘ sin ∘ abs ∘ sqrt, Real) == Real

    # Test type propagation with different input types
    @test SymbolicUtils.promote_symtype(sin ∘ sqrt, Number) == Number
    @test SymbolicUtils.promote_symtype(sin ∘ abs ∘ sqrt, Number) == Number
    @test SymbolicUtils.promote_symtype(sin ∘ sqrt, Complex) == Number

    # Test edge cases
    @test SymbolicUtils.promote_symtype(abs ∘ abs, Real) == Real
    @test SymbolicUtils.promote_symtype(sin ∘ sin, Real) == Real
end

# https://github.com/JuliaSymbolics/Symbolics.jl/issues/1747
@testset "Composite splatted indices in array indexing" begin
    indices = repeat([1:2], 2)
    final_indices = 1:3

    @syms y[indices..., final_indices]
    @test SymbolicUtils.symtype(y) == Array{Number, 3}
    @test y[1, 1, 1] isa SymbolicUtils.BasicSymbolic
end

@testset "`adjoint(::Matrix) * ::Vector` promotes to `::Vector`" begin
    @syms R[1:3, 1:3] n[1:3]
    @test symtype(R') === LinearAlgebra.Adjoint{Number, Matrix{Number}}
    @test symtype(R' * n) === Vector{Number}
end

@testset "symbolic array + literal array" begin
    @syms x[1:3]::Real
    ex = x + [1, 2, 3]
    @test isequal(ex.coeff, [1, 2, 3])
    @test isequal(ex.dict, Dict(x => 1))
    ex = ex + [3, 4, 5]
    @test isequal(ex.coeff, [4, 6, 8])
    @test isequal(ex.dict, Dict(x => 1))
end

@testset "`StaticArray` as operation" begin
    @syms x y z
    t = term(SVector{3}, x, y, z)
    @test symtype(t) === Vector{Number}
    @test shape(t) == [1:3]
    @test isequal(t[1], x)
    @test isequal(t[2], y)
    @test isequal(t[3], z)
end

@testset "Non-`Sym` expression as operation" begin
    @syms x y z o(..)::FnType{Tuple{Number}, Number, Nothing}
    @test_nowarn repr(o(x)(y + z))
end

@testset "`maketerm` on `map`/`mapreduce` works correctly" begin
    @syms x[1:3]
    ex = map(identity, x)
    ex2 = SymbolicUtils.maketerm(typeof(ex), operation(ex), arguments(ex), nothing)
    @test isequal(ex2, ex)

    ex = sum(x)
    ex2 = SymbolicUtils.maketerm(typeof(ex), operation(ex), arguments(ex), nothing)
    @test isequal(ex2, ex)
end

using SymbolicUtils
using SymbolicUtils: Sym, Term, symtype, BasicSymbolic, Const, ArgsT, promote_symtype, promote_shape, ShapeVecT, Unknown, array_literal, Fill, SymbolicRound, FnType, SymReal
using Test
import NaNMath
import LinearAlgebra

@testset "public shape promotion interface" begin
    if isdefined(Base, :ispublic)
        @test Base.ispublic(SymbolicUtils, :Unknown)
        @test Base.ispublic(SymbolicUtils, :ShapeVecT)
        @test Base.ispublic(SymbolicUtils, :ShapeT)
        @test Base.ispublic(SymbolicUtils, :shape)
        @test Base.ispublic(SymbolicUtils, :promote_shape)
    end
end
import SpecialFunctions: besselj, bessely, besseli, besselk, polygamma, beta, logbeta, hankelh1, hankelh2, expint, gamma, erf

@testset "promote_symtype with BigInt" begin
    # promote_symtype with BigInt combinations
    @test promote_symtype(+, BigInt, BigInt) == BigInt
    @test promote_symtype(+, BigInt, Int) == promote_type(Int, Integer)
    @test promote_symtype(+, Int, BigInt) == promote_type(Int, Integer)
    @test promote_symtype(-, BigInt, BigInt) == BigInt
    @test promote_symtype(*, BigInt, BigInt) == BigInt
    @test promote_symtype(^, BigInt, BigInt) == BigInt
    @test promote_symtype(max, BigInt, BigInt) == BigInt
    @test promote_symtype(min, BigInt, BigInt) == BigInt
end

@testset "promote_symtype with BigFloat" begin
    # promote_symtype with BigFloat combinations
    @test promote_symtype(+, BigFloat, BigFloat) == BigFloat
    @test promote_symtype(+, BigFloat, Int) == promote_type(Int, Real)
    @test promote_symtype(+, Int, BigFloat) == promote_type(Int, Real)
    @test promote_symtype(+, BigInt, BigFloat) == BigFloat
    @test promote_symtype(+, BigFloat, BigInt) == BigFloat
    @test promote_symtype(-, BigFloat, BigFloat) == BigFloat
    @test promote_symtype(*, BigFloat, BigFloat) == BigFloat
end

@testset "promote_symtype with Rational and BigInt" begin
    # Rational and BigInt combinations
    @test promote_symtype(+, Rational{Int}, BigInt) == Real
    @test promote_symtype(+, BigInt, Rational{Int}) == Real
end

@testset "promote_symtype with Rational and Integer" begin
    # Rational and Integer combinations
    @test promote_symtype(+, Rational{Int}, Int) == Real
    @test promote_symtype(+, Int, Rational{Int}) == Real
    @test promote_symtype(+, Complex{Rational{Int}}, Int) == Complex{Real}
    @test promote_symtype(+, Int, Complex{Rational{Int}}) == Complex{Real}
end

@testset "promote_symtype with Complex{Rational} and BigInt" begin
    # Complex{Rational} and BigInt
    @test promote_symtype(+, Complex{Rational{Int}}, BigInt) == Complex{Real}
    @test promote_symtype(+, BigInt, Complex{Rational{Int}}) == Complex{Real}
end

@testset "promote_symtype for division with Integer/Rational" begin
    # division promote_symtype
    @test promote_symtype(/, Int, Int) == Real
    @test promote_symtype(/, Rational{Int}, Int) == Real
    @test promote_symtype(/, Int, Rational{Int}) == Real
    @test promote_symtype(/, Complex{Int}, Int) == Complex{promote_type(Int, Real)}
    @test promote_symtype(/, Int, Complex{Int}) == Complex{promote_type(Real, Int)}
    @test promote_symtype(/, Complex{Float64}, Complex{Int}) == Complex{promote_type(promote_type(Float64, Int), Real)}

    # Backslash operator
    @test promote_symtype(\, Int, Int) == Real
    @test promote_symtype(\, Rational{Int}, Int) == Real
    @test promote_symtype(\, Int, Rational{Int}) == Real
end

@testset "promote_symtype for identity" begin
    @test promote_symtype(identity, Float64) == Float64
    @test promote_symtype(identity, Int) == Int
end

@testset "promote_shape for identity" begin
    @test promote_shape(identity, ShapeVecT()) == ShapeVecT()
    @test promote_shape(identity, ShapeVecT((1:2, 1:3))) == ShapeVecT((1:2, 1:3))
end
@testset "promote_symtype for `array_literal`" begin
    @test promote_symtype(array_literal, NTuple{2, Int}, Int, Float64, Int32) == Array{Float64, 2}
    @test promote_symtype(array_literal, NTuple{3, Int}, Int, Int, Int) == Array{Int, 3}
end

@testset "promote_symtype for rem2pi" begin
    @test promote_symtype(rem2pi, Float64, typeof(RoundNearest)) == Float64
end

@testset "promote_shape for diadic functions with arrays" begin
    sh_arr = ShapeVecT((1:2,))
    @test_throws ArgumentError promote_shape(max, sh_arr, ShapeVecT())
    @test_throws ArgumentError promote_shape(max, ShapeVecT(), sh_arr)
end

@testset "promote_shape for NaNMath.pow" begin
    @test promote_shape(NaNMath.pow, ShapeVecT(), ShapeVecT()) == ShapeVecT()
end

@testset "promote_shape for log with matrices" begin
    @test promote_shape(log, Unknown(2)) == Unknown(2)
    @test promote_shape(log, Unknown(-1)) == Unknown(-1)
    @test promote_shape(log, ShapeVecT()) == ShapeVecT()
    @test promote_shape(log, ShapeVecT((1:2, 1:2))) == ShapeVecT((1:2, 1:2))
    @test_throws ArgumentError promote_shape(log, ShapeVecT((1:3,)))

    @test promote_shape(NaNMath.log, Unknown(2)) == Unknown(2)
end

@testset "promote_shape for monadic functions with arrays" begin
    @test_throws ArgumentError promote_shape(sin, ShapeVecT((1:2,)))
end

@testset "promote_shape for rem2pi" begin
    @test promote_shape(rem2pi, ShapeVecT(), ShapeVecT()) == ShapeVecT()
    @test_throws ArgumentError promote_shape(rem2pi, ShapeVecT((1:2,)), ShapeVecT())
end

@testset "promote_symtype for inv with error" begin
    @test_throws ErrorException promote_symtype(inv, String)
end

@testset "promote_shape for inv" begin
    @test promote_shape(inv, Unknown(-1)) == Unknown(-1)
    @test promote_shape(inv, Unknown(2)) == Unknown(2)
    @test promote_shape(inv, ShapeVecT()) == ShapeVecT()
    @test promote_shape(inv, ShapeVecT((1:2, 1:3))) == ShapeVecT((1:3, 1:2))
    @test_throws ArgumentError promote_shape(inv, ShapeVecT((1:2,)))
end

@testset "literal_pow promote_symtype" begin
    result = promote_symtype(Base.literal_pow, typeof(^), Float64, Type{Val{2}})
    @test result == promote_symtype(^, Float64, Int) || result == Any
end

@testset "default promote_symtype" begin
    function foofn end
    @test promote_symtype(foofn, Float64) == promote_type(Float64, Real)
end

@testset "promote_symtype for real" begin
    @test promote_symtype(real, Complex{Float64}) == Float64
    @test promote_symtype(real, Float64) == Float64
end

@testset "promote_shape for real/imag/conj" begin
    @test promote_shape(real, ShapeVecT((1:2, 1:3))) == ShapeVecT((1:2, 1:3))
    @test promote_shape(imag, ShapeVecT((1:2,))) == ShapeVecT((1:2,))
    @test promote_shape(conj, ShapeVecT()) == ShapeVecT()
end

@testset "real on symbolic" begin
    @syms z::Complex{Float64}
    r = real(z)
    @test symtype(r) == Real

    @syms x::Real
    @test real(x) === x
end

@testset "promote_symtype for imag" begin
    @test promote_symtype(imag, Complex{Float64}) == Float64
    @test promote_symtype(imag, Float64) == Float64
end

@testset "promote_symtype for adjoint" begin
    @test promote_symtype(adjoint, Float64) == Float64
    @test promote_symtype(adjoint, Matrix{Float64}) == LinearAlgebra.Adjoint{Float64, Matrix{Float64}}
end

@testset "promote_shape for adjoint" begin
    @test promote_shape(adjoint, Unknown(2)) == Unknown(2)
    @test_throws ArgumentError promote_shape(adjoint, Unknown(3))
    @test_throws ArgumentError promote_shape(adjoint, Unknown(0))
    @test promote_shape(adjoint, ShapeVecT()) == ShapeVecT()
    @test promote_shape(adjoint, ShapeVecT((1:3,))) == ShapeVecT((1:1, 1:3))
    @test promote_shape(adjoint, ShapeVecT((1:2, 1:3))) == ShapeVecT((1:3, 1:2))
    @test_throws ArgumentError promote_shape(adjoint, Unknown(0))
end

@testset "Boolean operators with type errors" begin
    @syms a::Real b::Real
    @syms p::Bool q::Bool

    # Test that operations work
    @test symtype(a == b) == Bool
    @test symtype(a != b) == Bool
    @test symtype(a < b) == Bool
    @test symtype(a <= b) == Bool
    @test symtype(a > b) == Bool
    @test symtype(a >= b) == Bool
    @test symtype(isless(a, b)) == Bool
    @test symtype(p & q) == Bool
    @test symtype(p | q) == Bool
    @test symtype(xor(p, q)) == Bool

    # Test with mixed symbolic and concrete
    @test symtype(a == 1.0) == Bool
    @test symtype(1.0 == a) == Bool
end

@testset "Boolean negation" begin
    @syms p::Bool
    @test symtype(!p) == Bool
    @test symtype(~p) == Bool

    @syms x::Real
    @test_throws MethodError !x
end

@testset "Boolean operators short-circuit on constant arguments" begin
    @syms p::Bool q::Bool
    ct = Const{SymReal}(true)
    cf = Const{SymReal}(false)

    # `&`: a literal `true` drops out, a literal `false` short-circuits to `false`
    @test isequal(p & true, p)
    @test isequal(true & p, p)
    @test isequal(p & false, cf)
    @test isequal(false & p, cf)
    @test operation(p & q) === (&)

    # `|`: a literal `false` drops out, a literal `true` short-circuits to `true`
    @test isequal(p | false, p)
    @test isequal(false | p, p)
    @test isequal(p | true, ct)
    @test isequal(true | p, ct)
    @test operation(p | q) === (|)

    # `xor`: only a literal `false` short-circuits (to the other argument);
    # a literal `true` does not fold to a negation
    @test isequal(xor(p, false), p)
    @test isequal(xor(false, p), p)
    @test operation(xor(p, true)) === xor
    @test operation(xor(true, p)) === xor
    @test operation(xor(p, q)) === xor
end

@testset "Boolean negation short-circuits on constant arguments" begin
    ct = Const{SymReal}(true)
    cf = Const{SymReal}(false)
    @test isequal(!ct, cf)
    @test isequal(!cf, ct)
    @test isequal(~ct, cf)
    @test isequal(~cf, ct)
end

@testset "ifelse with error" begin
    @syms x::Real
    @test_throws ArgumentError promote_symtype(ifelse, Real, Int, Float64)
end

@testset "ifelse short-circuits on constant condition" begin
    @syms cond::Bool x::Real y::Real
    ct = Const{SymReal}(true)
    cf = Const{SymReal}(false)
    @test isequal(ifelse(ct, x, y), x)
    @test isequal(ifelse(cf, x, y), y)
    @test operation(ifelse(cond, x, y)) === ifelse
end

@testset "ifelse short-circuits on constant boolean branches" begin
    @syms cond::Bool
    ct = Const{SymReal}(true)
    cf = Const{SymReal}(false)
    @test isequal(ifelse(cond, ct, cf), cond)
    @test isequal(ifelse(cond, cf, ct), !cond)
end

@testset "IndexStyle" begin
    @test Base.IndexStyle(BasicSymbolic) == Base.IndexCartesian()
end

@testset "CartesianIndex promote" begin
    @test promote_symtype(CartesianIndex, Int, Int) == CartesianIndex{2}
    @test promote_symtype(CartesianIndex{3}, Int, Int, Int) == CartesianIndex{3}
end

@testset "CartesianIndex promote_shape" begin
    sh1 = promote_shape(CartesianIndex, ShapeVecT(), ShapeVecT())
    @test sh1 == ShapeVecT((1:2,))

    sh2 = promote_shape(CartesianIndex{2}, ShapeVecT(), ShapeVecT())
    @test sh2 == ShapeVecT((1:2,))
end

@testset "clamp promote_symtype" begin
    @test promote_symtype(clamp, Float64, Int, Float32) == Float64
    @test promote_symtype(clamp, Vector{Float64}, Vector{Int}, Vector{Float32}) == Vector{Float64}
end

@testset "clamp promote_shape" begin
    sh = promote_shape(clamp, ShapeVecT(), ShapeVecT(), ShapeVecT())
    @test sh == ShapeVecT()
    shu = promote_shape(clamp, Unknown(1), Unknown(1), Unknown(1))
    @test shu == Unknown(1)
end

@testset "LinearAlgebra.dot promote" begin
    sh = promote_shape(LinearAlgebra.dot, ShapeVecT((1:3,)), ShapeVecT((1:3,)))
    @test sh == ShapeVecT()

    @test promote_symtype(LinearAlgebra.dot, Float64, Int) == Float64
    @test promote_symtype(LinearAlgebra.dot, Vector{Float64}, Vector{Int}) == Float64
end

@testset "LinearAlgebra.det promote" begin
    @test promote_symtype(LinearAlgebra.det, Float64) == Float64
    @test promote_symtype(LinearAlgebra.det, Matrix{Float64}) == Float64

    sh1 = promote_shape(LinearAlgebra.det, Unknown(-1))
    @test sh1 == ShapeVecT()

    sh2 = promote_shape(LinearAlgebra.det, Unknown(2))
    @test sh2 == ShapeVecT()

    sh3 = promote_shape(LinearAlgebra.det, ShapeVecT())
    @test sh3 == ShapeVecT()

    sh4 = promote_shape(LinearAlgebra.det, ShapeVecT((1:2, 1:2)))
    @test sh4 == ShapeVecT()

    @test_throws ArgumentError promote_shape(LinearAlgebra.det, Unknown(3))
    @test_throws ArgumentError promote_shape(LinearAlgebra.det, ShapeVecT((1:3,)))
end

@testset "Array symbolic operations" begin
    @syms a[1:3]::Float64 b[1:3]::Float64

    # Test size, axes, length operations
    @test size(a) == (3,)
    @test length(a) == 3
    @test ndims(a) == 1
    ax = axes(a)
    @test ax == (1:3,)
    ax1 = axes(a, 1)
    @test ax1 == 1:3

    bc = Base.broadcastable(a)
    @test bc === a

    @syms x::Float64
    bc_scalar = Base.broadcastable(x)
    @test isa(bc_scalar, Base.RefValue)

    # First iteration
    iter_result = iterate(a)
    @test iter_result !== nothing

    ei = eachindex(a)
    @test isa(ei, CartesianIndices)
end

@testset "Complex number operations with Const" begin
    @syms z::Complex{Float64}

    # Create a symbolic Const
    c1 = Const{SymReal}(1.0 + 2.0im)

    @test isequal(real(c1), Const{SymReal}(1.0))
    @test isequal(conj(c1), Const{SymReal}(1.0 - 2.0im))
    @test isequal(imag(c1), Const{SymReal}(2.0))
end

@testset "More numeric operations on symbolics" begin
    @syms x::Float64

    # Test various functions to increase coverage
    @test operation(sign(x)) === sign
    @test operation(signbit(x)) === signbit
    @test operation(ceil(x)) === ceil
    @test operation(floor(x)) === floor

    @syms n::Int
    @test operation(factorial(n)) === factorial
end

@testset "CartesianIndex with symbolics" begin
    @syms i::Int j::Int
    ci = CartesianIndex(i, j)
    @test isa(ci, BasicSymbolic)
end

@testset "Promote symtype for array operations" begin
    @test promote_symtype(+, Matrix{Float64}, Matrix{Int}) == Matrix{Float64}
    @test promote_symtype(*, Matrix{Float64}, Matrix{Int}) == Matrix{Float64}
    @test promote_symtype(*, Matrix{Float64}, Vector{Int}) == Vector{Float64}
    @test promote_symtype(*, Vector{Float64}, Int) == Vector{promote_symtype(*, Float64, Int)}
    @test promote_symtype(*, Int, Vector{Float64}) == Vector{promote_symtype(*, Int, Float64)}
    @test promote_symtype(^, Float64, Matrix{Int}) == Matrix{promote_type(Float64, Int)}
    @test promote_symtype(\, Float64, Vector{Int}) == Vector{promote_symtype(/, Int, Float64)}
    @test promote_symtype(\, Vector{Float64}, Vector{Int}) == promote_symtype(/, Int, Float64)
    @test promote_symtype(\, Matrix{Float64}, Vector{Int}) == Vector{promote_symtype(/, Int, Float64)}
    @test promote_symtype(\, Matrix{Float64}, Matrix{Int}) == Matrix{promote_symtype(/, Int, Float64)}
    @test promote_symtype(/, Matrix{Float64}, Matrix{Int}) == Matrix{promote_symtype(/, Float64, Int)}
    @test promote_symtype(/, Float64, Vector{Int}) == Matrix{promote_symtype(/, Float64, Int)}
    @test promote_symtype(/, Vector{Float64}, Float64) == Vector{promote_symtype(/, Float64, Float64)}
end

@testset "Map operations on symbolics" begin
    @syms a[1:3]::Float64 b[1:3]::Float64

    result = map(sin, a)
    @test isequal(collect(result), [sin(a[1]), sin(a[2]), sin(a[3])])

    result2 = map(+, a, b)
    @test isequal(collect(result2), [a[1] + b[1], a[2] + b[2], a[3] + b[3]])

    result3 = map(+, a, [1.0, 2.0, 3.0])
    @test isequal(collect(result3), [a[1] + 1.0, a[2] + 2.0, a[3] + 3.0])
end

@testset "in operator on symbolics" begin
    @syms x::Float64 a[1:3]::Float64

    @test promote_symtype(in, Float64, Vector{Float64}) == Bool

    psh = promote_shape(in, ShapeVecT(), ShapeVecT((1:3,)))
    @test psh == ShapeVecT()

    result = in(x, a)
    @test isa(result, BasicSymbolic)
    @test symtype(result) == Bool

    result2 = in(1.0, a)
    @test isa(result2, BasicSymbolic)

    result3 = in(x, [1.0, 2.0, 3.0])
    @test isa(result3, BasicSymbolic)
end

@testset "Symbol conversion" begin
    @syms x::Float64
    sym = Symbol(x)
    @test isa(sym, Symbol)
end

@testset "Fill" begin
    f1 = Fill(ShapeVecT((1:3,)))
    f2 = Fill(ShapeVecT((1:2, 1:4)))

    @testset "promote_symtype" begin
        @test promote_symtype(f1, Float64) == Array{Float64, 1}
        @test promote_symtype(f2, Int) == Array{Int, 2}
        @test promote_symtype(f1, Real) == Array{Real, 1}
    end

    @testset "promote_shape" begin
        @test promote_shape(f1, ShapeVecT()) == ShapeVecT((1:3,))
        @test promote_shape(f2, ShapeVecT()) == ShapeVecT((1:2, 1:4))
        @test promote_shape(f1, ShapeVecT((1:5,))) == ShapeVecT((1:3,))
    end

    @testset "symbolic expression" begin
        @syms x::Real
        expr = f1(x)
        @test symtype(expr) == Array{Real, 1}
        @test SymbolicUtils.shape(expr) == ShapeVecT((1:3,))
        @test SymbolicUtils.operation(expr) === f1
        @test isequal(SymbolicUtils.arguments(expr), [x])
    end
end

@testset "SymbolicRound promote_symtype" begin
    sr = SymbolicRound{Int, typeof(RoundNearest)}(RoundNearest)
    @test promote_symtype(sr, Float64) == Int
    @test promote_symtype(sr, Real) == Int

    sr2 = SymbolicRound{Float32, typeof(RoundDown)}(RoundDown)
    @test promote_symtype(sr2, Float64) == Float32
end

@testset "SymbolicRound promote_shape" begin
    sr = SymbolicRound{Int, typeof(RoundNearest)}(RoundNearest)
    @test promote_shape(sr, ShapeVecT()) == ShapeVecT()
    @test promote_shape(sr, ShapeVecT((1:3,))) == ShapeVecT((1:3,))
    @test promote_shape(sr, ShapeVecT((1:2, 1:4))) == ShapeVecT((1:2, 1:4))
end

@testset "Base.round on symbolic" begin
    @syms x::Float64

    expr = round(Int, x, RoundNearest)
    @test isa(expr, BasicSymbolic)
    @test symtype(expr) == Int
    @test isa(operation(expr), SymbolicRound{Int, typeof(RoundNearest)})
    @test isequal(arguments(expr), [x])

    expr_down = round(Int, x, RoundDown)
    @test isa(expr_down, BasicSymbolic)
    @test symtype(expr_down) == Int
    @test isa(operation(expr_down), SymbolicRound{Int, typeof(RoundDown)})

    expr_up = round(Float32, x, RoundUp)
    @test isa(expr_up, BasicSymbolic)
    @test symtype(expr_up) == Float32
end

@testset "Base.round on concrete value via SymbolicRound" begin
    sr = SymbolicRound{Int, typeof(RoundNearest)}(RoundNearest)
    @test sr(3.7) == 4
    @test sr(3.2) == 3

    sr_down = SymbolicRound{Int, typeof(RoundDown)}(RoundDown)
    @test sr_down(3.9) == 3
    @test sr_down(-3.1) == -4
end

@testset "Base.round printing" begin
    @syms x::Float64
    expr = round(Int, x, RoundNearest)
    str = string(expr)
    @test occursin("round", str)
    @test occursin("Int", str)
    @test occursin(string(x), str)
    @test occursin("Nearest", str)
end

@testset "promote_symtype and promote_shape for Returns" begin
    @test promote_symtype(Returns{Float64}, Vector{Float64}) == FnType{Tuple, Vector{Float64}, Nothing}
    @test promote_symtype(Returns{Int}, Matrix{Int}) == FnType{Tuple, Matrix{Int}, Nothing}
    @test promote_symtype(Returns{Nothing}, Int) == FnType{Tuple, Int, Nothing}

    sh1d = ShapeVecT((1:3,))
    sh2d = ShapeVecT((1:2, 1:4))
    @test promote_shape(Returns{Float64}, sh1d) === sh1d
    @test promote_shape(Returns{Float64}, sh2d) === sh2d
    @test promote_shape(Returns{Int}, Unknown(1)) == Unknown(1)
    @test promote_shape(Returns{Int}, Unknown(-1)) == Unknown(-1)
end

@testset "`ifelse` with array cases" begin
    @syms cond::Bool x[1:3] y[1:3] z[1:4]
    @test_throws ErrorException ifelse(cond, x, z)
    @test SymbolicUtils.shape(ifelse(cond, x, y)) == [1:3]
end

@testset "`promote_symtype`, `promote_shape` for `tuple`" begin
    @test SymbolicUtils.promote_symtype(tuple) == Tuple{}
    @test SymbolicUtils.promote_symtype(tuple, Real) == Tuple{Real}
    @test SymbolicUtils.promote_symtype(tuple, Real, Int) == Tuple{Real, Int}
    @test SymbolicUtils.promote_symtype(tuple, Float64, Float64, Int) == Tuple{Float64, Float64, Int}
    @test SymbolicUtils.promote_shape(tuple, Unknown(1), ShapeVecT((1:3, 1:3,)), ShapeVecT()) == [1:3]
end


@testset "`Fill` with non-symbolic argument" begin
    f = Fill(ShapeVecT((1:3, 1:3)))
    @test f(1) == fill(1, 3, 3)
end

@testset "`promote_symtype` for `reshape`" begin
    @test SymbolicUtils.promote_symtype(reshape, Vector{Int}, Int, Int) === Matrix{Int}
    @test SymbolicUtils.promote_symtype(reshape, Vector{Real}, Int, Int, Int) === Array{Real, 3}
end

using BenchmarkTools, SymbolicUtils
using SymbolicUtils: is_literal_number, @rule, ArrayMaker, IRStructure, populate_ir!, BasicSymbolic,
                     search_variables!

using Random

SUITE = BenchmarkGroup()
SUITE["printing"] = BenchmarkGroup()

@syms a b c d x y[1:3] z[1:2, 1:2]; Random.seed!(123);

_make_bench_ir(expr::BasicSymbolic{T}) where {T} =
    (ir = IRStructure{T}(); populate_ir!(ir, expr); ir)

_symtype_param(::BasicSymbolic{T}) where {T} = T

@syms _poly_x::Real _poly_y::Real _poly_z::Real _poly_w::Real
@syms _wide_xs[1:100]::Real _wide_ys[1:100]::Real
@syms _ma_xs[1:400]::Real _ma_ys[1:400]::Real _ma_zs[1:400]::Real

function make_bench_makearray(n::Int; seed::Int = 42)
    T   = _symtype_param(_ma_xs[1])
    rng = Random.MersenneTwister(seed)

    n_regions = clamp(
        n ÷ 5 + round(Int, randn(rng) * sqrt(n / 5)),
        4, n ÷ 2
    )

    split_pts = sort(Random.shuffle!(rng, collect(2:n))[1:n_regions - 1])
    starts    = [1; split_pts]
    stops     = [split_pts .- 1; n]
    regions   = [(starts[i]:stops[i],) for i in 1:n_regions]

    values = map(1:n_regions) do i
        start, stop = starts[i], stops[i]
        len = stop - start + 1
        if len == 1
            return [_ma_xs[mod1(start, 10)] + _ma_ys[mod1(start, 10)]]
        end
        choice = rand(rng, 1:3)
        if choice == 1
            return @arrayop (k,) _ma_xs[k] * _ma_ys[k] k in 1:len
        elseif choice == 2
            return [iseven(k) ? _ma_xs[mod1(k, 10)] : _ma_ys[mod1(k, 10)] for k in 1:len]
        else
            sub_v1 = [_ma_zs[1] + _ma_xs[1]]
            sub_v2 = @arrayop (k,) _ma_ys[k] k in 1:(len - 1)
            return ArrayMaker{T}([(1:1,), (2:len,)], (sub_v1, sub_v2))
        end
    end

    return ArrayMaker{T}(regions, values)
end

function _make_chain_expr(atoms, n)
    n == 0 && return atoms[1]
    return hypot(_make_chain_expr(atoms, n - 1), atoms[mod1(n, length(atoms))])
end

function random_term(len; atoms, funs, fallback_atom=1)
    xs = rand(atoms, len)
    while length(xs) > 1
        xs = map(Iterators.partition(xs, 2)) do xy
            x = xy[1]; y = get(xy, 2, fallback_atom)
            rand(funs)(x, y)
        end
    end
    xs[]
end

function build_deep_expr(vars, depth)
    expr = vars[1]
    for i in 1:depth
        v = vars[mod1(i, length(vars))]
        expr = sin(expr * v + v^2 - v)
    end
    return expr
end

function batch_isequal(xs, ys, reps)
    acc = true
    n = length(xs)
    for i in 1:reps
        acc &= isequal(xs[mod1(i, n)], ys[mod1(i, n)])
    end
    return acc
end

let r = @rule(~x => ~x), rs = RuleSet([r]),
    acr = @rule(~x::is_literal_number + ~y => ~y)

    overhead = SUITE["overhead"]  = BenchmarkGroup()

    iseq = overhead["isequal"] = BenchmarkGroup()
    exprs1 = [build_deep_expr([a, b, c, d], 300) for _ in 1:16]
    exprs2 = [build_deep_expr([b, c, d, a], 300) for _ in 1:16]
    iseq["identical"] = @benchmarkable batch_isequal($exprs1, $exprs1, 2000)
    iseq["different"] = @benchmarkable batch_isequal($exprs1, $exprs2, 2000)

    overhead["rule"]  = BenchmarkGroup()

    overhead["rule"]["noop:Int"]  = @benchmarkable $r(1)
    overhead["rule"]["noop:Sym"]  = @benchmarkable $r($a)
    overhead["rule"]["noop:Term"] = @benchmarkable $r($(a+2))

    overhead["acrule"]  = BenchmarkGroup()
    overhead["acrule"]["noop:Int"]  = @benchmarkable $acr(1)
    overhead["acrule"]["noop:Sym"]  = @benchmarkable $acr($a)
    overhead["acrule"]["a+2"] = @benchmarkable $acr($(a+2))
    overhead["acrule"]["a+b"] = @benchmarkable $acr($(a+b))
    overhead["acrule"]["a+2+b"] = @benchmarkable $acr($(a+2+b))

    overhead["ruleset"]  = BenchmarkGroup()
    overhead["ruleset"]["noop:Int"]  = @benchmarkable $rs(1)
    overhead["ruleset"]["noop:Sym"]  = @benchmarkable $rs($a)
    overhead["ruleset"]["noop:Term"] = @benchmarkable $rs($(a+2))

    overhead["simplify"]  = BenchmarkGroup()
    overhead["simplify"]["noop:Int"]  = @benchmarkable simplify(1)
    overhead["simplify"]["noop:Sym"]  = @benchmarkable simplify($a)
    overhead["simplify"]["noop:Term"] = @benchmarkable simplify($(a+2))

    ex1 = random_term(1000, atoms=[a, b, c, d, a^(-1), b^(-1), 1, 2.0], funs=[+, *])
    ex2 = random_term(1000, atoms=[a, b, c, d, a^(-1), b^(-1), 1, 2.0], funs=[/, *])

    overhead["simplify"]["randterm (+, *):serial"] = @benchmarkable simplify($ex1, simplify_fractions=false, threaded=false)
    overhead["simplify"]["randterm (/, *):serial"] = @benchmarkable simplify($ex2, simplify_fractions=false, threaded=false)
    overhead["simplify"]["randterm (+, *):thread"] = @benchmarkable simplify($ex1, simplify_fractions=false, threaded=true)
    overhead["simplify"]["randterm (/, *):thread"] = @benchmarkable simplify($ex2, simplify_fractions=false, threaded=true)

    overhead["substitute"] = BenchmarkGroup()


    # we use `fold = false` since otherwise it dynamic dispatches to `sin`/`cos` whenever
    # both arguments in the contained addition are substituted.

    overhead["substitute"]["a"] = @benchmarkable substitute(subs_expr, $(Dict(a=>1))) setup=begin
        subs_expr = (sin(a+b) + cos(b+c)) * (sin(b+c) + cos(c+a)) * (sin(c+a) + cos(a+b))
    end

    overhead["substitute"]["a,b"] = @benchmarkable substitute(subs_expr, $(Dict(a=>1, b=>2))) setup=begin
        subs_expr = (sin(a+b) + cos(b+c)) * (sin(b+c) + cos(c+a)) * (sin(c+a) + cos(a+b))
    end

    overhead["substitute"]["a,b,c"] = @benchmarkable substitute(subs_expr, $(Dict(a=>1, b=>2, c=>3))) setup=begin
        subs_expr = (sin(a+b) + cos(b+c)) * (sin(b+c) + cos(c+a)) * (sin(c+a) + cos(a+b))
    end

    overhead["get_degrees"] = BenchmarkGroup()

    let y1 = term(getindex, y, 1, type=Number),
        y2 = term(getindex, y, 2, type=Number),
        y3 = term(getindex, y, 3, type=Number),
        z11 = term(getindex, z, 1, 1, type=Number),
        z12 = term(getindex, z, 1, 2, type=Number),
        z23 = term(getindex, z, 2, 3, type=Number)

        # create a relatively large polynomial
        large_poly = SymbolicUtils.expand((x^2 + 2y1 + 3z12 + y2*z23 + x*y1*z12 - x^2*z12 + x*z11 + y3 + y2 + z23 + 1)^8)
        overhead["get_degrees"]["large_poly"] = @benchmarkable SymbolicUtils.get_degrees($large_poly)
        SUITE["printing"]["large_poly"] = @benchmarkable show(devnull, $large_poly)
    end
end

let
    pform = SUITE["polyform"]  = BenchmarkGroup()
    @syms a b c d e f g h i
    ex = (f + ((((g*(c^2)*(e^2)) / d - e*h*(c^2)) / b + (-c*e*f*g) / d + c*e*i) /
              (i + ((c*e*g) / d - c*h) / b + (-f*g) / d) - c*e) / b +
         ((g*(f^2)) / d + ((-c*e*f*g) / d + c*f*h) / b - f*i) /
         (i + ((c*e*g) / d - c*h) / b + (-f*g) / d)) / d

    o = (d + (e*((c*(g + (-d*g) / d)) / (i + (-c*(h + (-e*g) / d)) / b + (-f*g) / d))) / b +
         (-f*(g + (-d*g) / d)) / (i + (-c*(h + (-e*g) / d)) / b + (-f*g) / d)) / d
    pform["simplify_fractions"] = @benchmarkable simplify_fractions($ex)
    pform["iszero"] = @benchmarkable SymbolicUtils.fraction_iszero($ex)
    pform["isone"] = @benchmarkable SymbolicUtils.fraction_isone($ex)
    pform["isone:noop"] = @benchmarkable SymbolicUtils.fraction_isone($o)
    pform["iszero:noop"] = @benchmarkable SymbolicUtils.fraction_iszero($o)
    pform["easy_iszero"] = @benchmarkable SymbolicUtils.fraction_iszero($((b*(h + (-e*g) / d)) / b + (e*g) / d - h))
end

let
    arith = SUITE["arithmetic"] = BenchmarkGroup()
    atoms = [a, b, c, d, a^2, b^2, a^1.5, (b + c), b^c, 1, 2.0]
    funs = [+, *]
    exs = [random_term(5; atoms, funs) for _ in 1:50]
    @static if isdefined(SymbolicUtils, :SymReal)
        arith["addition"] = @benchmarkable SymbolicUtils.add_worker(SymReal, $exs)
    elseif isdefined(SymbolicUtils, :add_worker)
        arith["addition"] = @benchmarkable SymbolicUtils.add_worker($exs)
    else
        exs = Tuple(exs)
        arith["addition"] = @benchmarkable +($(exs)...)
    end

    funs = [*, /]
    exs = [random_term(5; atoms, funs) for _ in 1:50]
    @static if isdefined(SymbolicUtils, :SymReal)
        arith["2-arg mul"] = @benchmarkable SymbolicUtils.mul_worker(SymReal, $((exs[1], exs[2])))
        arith["multiplication"] = @benchmarkable SymbolicUtils.mul_worker(SymReal, $exs)
    elseif isdefined(SymbolicUtils, :mul_worker)
        arith["2-arg mul"] = @benchmarkable SymbolicUtils.mul_worker($((exs[1], exs[2])))
        arith["multiplication"] = @benchmarkable SymbolicUtils.mul_worker($exs)
    else
        exs = Tuple(exs)
        arith["2-arg mul"] = @benchmarkable *($(exs[1]), $(exs[2]))
        arith["multiplication"] = @benchmarkable *($(exs)...)
    end

    ex1 = random_term(50; atoms, funs)
    ex2 = random_term(50; atoms, funs)
    arith["division"] = @benchmarkable $ex1 / $ex2
end

@static if length(methods(SymbolicUtils.clear_cache!)) < 4
    SymbolicUtils.clear_cache!(sub::SymbolicUtils.IRSubstituter) = empty!(sub.cache)
end

function bench_sub(subber, ex)
    SymbolicUtils.clear_cache!(subber)
    subber(ex)
end

let
    atoms = atoms = [a, b, c, d, a^2, b^2, a^1.5, (b + c), b^c, 1, 2.0]
    funs = [+, *, hypot, (x, y) -> abs(x), (x, y) -> exp(x)]
    ex = random_term(100000; atoms, funs)
    rules = Dict(a => 2sin(b))
    SUITE["irstructure"] = BenchmarkGroup()
    SUITE["irstructure"]["substitute"] = BenchmarkGroup()

    subber = SymbolicUtils.Substituter{false}(rules)
    SUITE["irstructure"]["substitute"]["reference"] = @benchmarkable bench_sub($subber, $ex)
    ir = IRStructure{SymReal}()
    subber = SymbolicUtils.IRSubstituter{false}(ir, rules)
    SUITE["irstructure"]["substitute"]["IRSubstituter"] = @benchmarkable bench_sub($subber, $ex)

    # To benchmark a much more sparse substitution
    rules = Dict(abs(b + c) => 2sin(b))
    subber = SymbolicUtils.Substituter{false}(rules)
    SUITE["irstructure"]["substitute"]["sparse reference"] = @benchmarkable bench_sub($subber, $ex)
    ir = IRStructure{SymReal}()
    subber = SymbolicUtils.IRSubstituter{false}(ir, rules)
    SUITE["irstructure"]["substitute"]["sparse IRSubstituter"] = @benchmarkable bench_sub($subber, $ex)
end

let
    sv = SUITE["irstructure"]["search_variables"] = BenchmarkGroup()

    atoms_sv = [a, b, c, d, a^2, b^2, a^1.5, (b + c), b^c, 1, 2.0]
    funs_sv  = [+, *, hypot, (x, y) -> abs(x), (x, y) -> exp(x)]

    # Common structure: 10 expressions all containing a large shared subtree.
    # hypot wraps base_expr as a direct child, preventing AC-flattening that would
    # eliminate the shared node.
    base_expr    = random_term(5000; atoms=atoms_sv, funs=funs_sv)
    exprs_common = [hypot(base_expr, _poly_x + i) for i in 1:10]
    ir_common    = IRStructure{SymReal}()
    for e in exprs_common; populate_ir!(ir_common, e); end

    buf_common = Set{BasicSymbolic{SymReal}}()
    sv["common:reference"]   = @benchmarkable search_variables!($buf_common, $exprs_common) setup=(empty!($buf_common))
    sv["common:IRStructure"] = @benchmarkable begin
        for e in $exprs_common
            search_variables!($buf_common, $ir_common, e)
        end
    end setup=(empty!($buf_common))

    # Dissimilar structure: 10 independently-generated expressions with no intentional
    # shared subtrees.
    exprs_dissimilar = [random_term(1000; atoms=atoms_sv, funs=funs_sv) for _ in 1:10]
    ir_dissimilar    = IRStructure{SymReal}()
    for e in exprs_dissimilar; populate_ir!(ir_dissimilar, e); end

    buf_dissimilar = Set{BasicSymbolic{SymReal}}()
    sv["dissimilar:reference"]   = @benchmarkable search_variables!($buf_dissimilar, $exprs_dissimilar) setup=(empty!($buf_dissimilar))
    sv["dissimilar:IRStructure"] = @benchmarkable begin
        for e in $exprs_dissimilar
            search_variables!($buf_dissimilar, $ir_dissimilar, e)
        end
    end setup=(empty!($buf_dissimilar))
end

let
    si = SUITE["irstructure"]["subset_ir"] = BenchmarkGroup()

    n_chains    = 20
    chain_depth = 500

    # Build n_chains disjoint chains of chain_depth hypot nodes each using non-overlapping
    # slices of _wide_xs so that no node is shared across chains.
    # Max recursion depth = chain_depth, which is safe for populate_ir!.
    chains_si = [_make_chain_expr(_wide_xs[5i-4:5i], chain_depth) for i in 1:n_chains]

    rules = Dict(a => 2sin(b))
    ir_si = IRStructure{SymReal}()
    for ch in chains_si
        populate_ir!(ir_si, ch)
    end
    subber_si = SymbolicUtils.IRSubstituter{false}(ir_si, rules)

    # Small: 1 chain covers ~5% of the IR (<10%)
    small_exprs_si = Set{BasicSymbolic{SymReal}}([chains_si[1]])
    # Large: first 12 chains cover ~60% of the IR (>50%), leaving 8 chains out
    large_exprs_si = chains_si[1:12]

    si["small"] = @benchmarkable SymbolicUtils.subset_ir($(subber_si.ir), $small_exprs_si)
    si["large"] = @benchmarkable SymbolicUtils.subset_ir($(subber_si.ir), $large_exprs_si)
end

let
    codegen = SUITE["codegen"] = BenchmarkGroup()

    codegen["wide_poly"] = BenchmarkGroup()
    for n_terms in (25, 50, 100)
        expr     = sum(_wide_xs[i] * _wide_ys[i] for i in 1:n_terms)
        cse_expr = SymbolicUtils.Code.cse(expr)
        ir       = _make_bench_ir(expr)
        codegen["wide_poly"]["n=$n_terms:toexpr"]      = @benchmarkable SymbolicUtils.Code.toexpr($cse_expr)
        codegen["wide_poly"]["n=$n_terms:fast_toexpr"] = @benchmarkable SymbolicUtils.Code.fast_toexpr($expr, $ir, Dict{Any,Any}())
    end

    codegen["deep_poly"] = BenchmarkGroup()
    for deg in (6, 10, 14)
        expr     = SymbolicUtils.expand((_poly_x + _poly_y + _poly_z)^deg)
        cse_expr = SymbolicUtils.Code.cse(expr)
        ir       = _make_bench_ir(expr)
        codegen["deep_poly"]["deg=$deg:toexpr"]      = @benchmarkable SymbolicUtils.Code.toexpr($cse_expr)
        codegen["deep_poly"]["deg=$deg:fast_toexpr"] = @benchmarkable SymbolicUtils.Code.fast_toexpr($expr, $ir, Dict{Any,Any}())
    end

    let
        expr     = SymbolicUtils.expand((_poly_x + _poly_y + _poly_z + _poly_w)^12)
        cse_expr = SymbolicUtils.Code.cse(expr)
        ir       = _make_bench_ir(expr)
        codegen["wide_deep_poly"] = BenchmarkGroup()
        codegen["wide_deep_poly"]["toexpr"]      = @benchmarkable SymbolicUtils.Code.toexpr($cse_expr)
        codegen["wide_deep_poly"]["fast_toexpr"] = @benchmarkable SymbolicUtils.Code.fast_toexpr($expr, $ir, Dict{Any,Any}())
    end

    codegen["makearray"] = BenchmarkGroup()
    for n in (100, 200, 400)
        expr     = make_bench_makearray(n)
        cse_expr = SymbolicUtils.Code.cse(expr)
        ir       = _make_bench_ir(expr)
        codegen["makearray"]["n=$n:toexpr"]      = @benchmarkable SymbolicUtils.Code.toexpr($cse_expr)
        codegen["makearray"]["n=$n:fast_toexpr"] = @benchmarkable SymbolicUtils.Code.fast_toexpr($expr, $ir, Dict{Any,Any}())
    end

    let
        @syms _ao_A[1:8, 1:8, 1:8]::Real _ao_B[1:8, 1:8, 1:8]::Real
        expr     = @arrayop (i, j) _ao_A[i, k, l] * _ao_B[j, k, l]
        cse_expr = SymbolicUtils.Code.cse(expr)
        ir       = _make_bench_ir(expr)
        codegen["arrayop_nested"] = BenchmarkGroup()
        codegen["arrayop_nested"]["toexpr"]      = @benchmarkable SymbolicUtils.Code.toexpr($cse_expr)
        codegen["arrayop_nested"]["fast_toexpr"] = @benchmarkable SymbolicUtils.Code.fast_toexpr($expr, $ir, Dict{Any,Any}())
    end
end

using Pkg, Test, SafeTestsets

const GROUP = get(ENV, "GROUP", "Core")

function activate_qa_env()
    Pkg.activate("qa")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    return Pkg.instantiate()
end

if GROUP == "Core"
    @testset "Core" begin
        if haskey(ENV, "SU_BENCHMARK_ONLY")
            @safetestset "Benchmark" begin include("benchmark.jl") end
        else
            if v"1.11" <= VERSION < v"1.12"
                # as of this comment, `@snoop_inference` on 1.12 has a tendency to never
                # end. I have kept a REPL going for 24 hours.
                #
                # The test is commented out because it behaves weirdly. It fails in CI,
                # fails differently in Pkg.test locally, and is fine when run as a script.
                # @safetestset "Precompilation" begin include("precompilation.jl") end
            end
            @safetestset "Basics" begin include("basics.jl") end
            @safetestset "ArrayOp" begin include("arrayop.jl") end
            @safetestset "ArrayMaker" begin include("arraymaker.jl") end
            @safetestset "Order" begin include("order.jl") end
            @safetestset "PolyForm" begin include("polyform.jl") end
            @safetestset "Rewrite" begin include("rewrite.jl") end
            @safetestset "Rulesets" begin include("rulesets.jl") end
            @safetestset "Inference" begin include("inference.jl") end
            @safetestset "Code" begin include("code.jl") end
            @safetestset "New codegen" begin include("new_code.jl") end
            @safetestset "Symbolic codegen primitives" begin include("symbolic_codegen_primitives.jl") end
            @safetestset "CSE" begin include("cse.jl") end
            @safetestset "Conditionals" begin include("conditionals.jl") end
            @safetestset "Interface" begin include("interface.jl") end
            # Disabled until https://github.com/JuliaMath/SpecialFunctions.jl/issues/446 is fixed
            @safetestset "Fuzz" begin include("fuzz.jl") end
            @safetestset "Adjoints" begin include("adjoints.jl") end
            @safetestset "Hash Consing" begin include("hash_consing.jl") end
            @safetestset "Cache macro" begin include("cache_macro.jl") end
            @safetestset "Recursive utilities" begin include("recursive_utils.jl") end
            @safetestset "Misc" begin include("misc.jl") end
            @safetestset "Method library" begin include("methods.jl") end
            @safetestset "IRStructure" begin include("irstructure.jl") end
            @safetestset "OrderedDiGraph" begin include("ordereddigraph.jl") end
        end
    end
end

if GROUP == "QA"
    activate_qa_env()
    @safetestset "SciMLTesting QA" begin include("qa/qa.jl") end
    @safetestset "AdjView JET" begin include("qa/adjview_jet.jl") end
end

"""
A rewriter is any function which takes an expression and returns an expression
or `nothing`. If `nothing` is returned that means there was no changes applicable
to the input expression.

The `Rewriters` module contains some types which create and transform
rewriters.

- `Empty()` is a rewriter which always returns `nothing`
- `Chain(itr)` chain an iterator of rewriters into a single rewriter which applies
   each chained rewriter in the given order.
   If a rewriter returns `nothing` this is treated as a no-change.
- `RestartedChain(itr)` like `Chain(itr)` but restarts from the first rewriter once on the
   first successful application of one of the chained rewriters.
- `IfElse(cond, rw1, rw2)` runs the `cond` function on the input, applies `rw1` if cond
   returns true, `rw2` if it returns false
- `If(cond, rw)` is the same as `IfElse(cond, rw, Empty())`
- `Prewalk(rw; threaded=false, thread_cutoff=100)` returns a rewriter which does a pre-order
   traversal of a given expression and applies the rewriter `rw`. Note that if
   `rw` returns `nothing` when a match is not found, then `Prewalk(rw)` will
   also return nothing unless a match is found at every level of the walk.
   `threaded=true` will use multi threading for traversal. `thread_cutoff` is
   the minimum number of nodes in a subtree which should be walked in a
   threaded spawn.
- `Postwalk(rw; threaded=false, thread_cutoff=100)` similarly does post-order traversal.
- `Fixpoint(rw)` returns a rewriter which applies `rw` repeatedly until there are no changes to be made.
- `FixpointNoCycle` behaves like [`Fixpoint`](@ref) but instead it applies `rw` repeatedly only while it is returning new results.
- `PassThrough(rw)` returns a rewriter which if `rw(x)` returns `nothing` will instead
   return `x` otherwise will return `rw(x)`.

"""
module Rewriters
using TermInterface

import SymbolicUtils: iscall, operation, arguments, sorted_arguments, metadata, node_count,
                      _promote_symtype, @manually_scope, COMPARE_FULL, ROArgsT, ArgsT,
                      Const, SmallV, BSImpl, unwrap_const, BasicSymbolic, isconst
export Empty, IfElse, If, Chain, RestartedChain, Fixpoint, Postwalk, Prewalk, PassThrough

"""
    Empty()

A rewriter that always returns `nothing`, indicating no rewrite occurred.

This is useful as a placeholder or for conditional rewriting patterns.

# Examples
```julia-repl
julia> Empty()(x)
nothing
```
"""
struct Empty end

(rw::Empty)(x) = nothing

instrument(x, f) = f(x)
instrument(x::Empty, f) = x

"""
    IfElse(cond, yes, no)

A conditional rewriter that applies `yes` if `cond(x)` is true, otherwise applies `no`.

# Arguments
- `cond`: A function that returns true or false for the input
- `yes`: The rewriter to apply if the condition is true
- `no`: The rewriter to apply if the condition is false

# Examples
```julia-repl
julia> r = IfElse(x -> x > 0, x -> -x, x -> x)
julia> r(5)  # Returns -5
julia> r(-3) # Returns -3
```

See also: [`If`](@ref)
"""
struct IfElse{F, A, B}
    cond::F
    yes::A
    no::B
end

instrument(x::IfElse, f) = IfElse(x.cond, instrument(x.yes, f), instrument(x.no, f))

function (rw::IfElse)(x)
    rw.cond(x)::Bool ?  rw.yes(x) : rw.no(x)
end

"""
    If(cond, yes)

A conditional rewriter that applies `yes` if `cond(x)` is true, otherwise returns the input unchanged.

This is equivalent to `IfElse(cond, yes, Empty())`.

# Arguments
- `cond`: A function that returns true or false for the input
- `yes`: The rewriter to apply if the condition is true

# Examples
```julia-repl
julia> r = If(x -> x > 0, x -> -x)
julia> r(5)  # Returns -5
julia> r(-3) # Returns -3 (unchanged)
```
"""
If(f, x) = IfElse(f, x, Empty())

"""
    Chain(rws; stop_on_match=false)

Apply a sequence of rewriters to an expression, chaining the results.

Each rewriter in the chain receives the result of the previous rewriter.
If a rewriter returns `nothing`, the input is passed unchanged to the next rewriter.

# Arguments
- `rws`: A collection of rewriters to apply in sequence
- `stop_on_match`: If true, stop at the first rewriter that produces a change

# Examples
```julia-repl
julia> r1 = @rule sin(~x)^2 + cos(~x)^2 => 1
julia> r2 = @rule sin(2*(~x)) => 2*sin(~x)*cos(~x)
julia> chain = Chain([r1, r2])
julia> chain(sin(x)^2 + cos(x)^2)  # Returns 1
```
"""
mutable struct Chain{Cs}
    const rws::Cs
    const stop_on_match::Bool
end
Chain(rws) = Chain(rws, false)

function (rw::Chain)(x)
    for f in rw.rws
        y = f(x)
        if rw.stop_on_match && !isnothing(y) && !isequal(y, x)
            return y
        end

        if y !== nothing
            x = y
        end
    end
    return x
end

@generated function (rw::Chain{<:NTuple{N, Any}})(x) where {N}
    quote
        Base.@nexprs $N i -> begin
            f = rw.rws[i]
            y = f(x)
            if rw.stop_on_match && y !== nothing && !isequal(x, y)
                return y
            end
            if y !== nothing
                x = y
            end
        end
        return x
    end
end

instrument(c::Chain, f) = Chain(map(x->instrument(x,f), c.rws))

"""
    RestartedChain(rws)

Apply rewriters in sequence, restarting the chain when any rewriter produces a change.

When any rewriter in the chain produces a non-nothing result, the entire chain
is restarted with that result as the new input.

# Arguments
- `rws`: A collection of rewriters to apply

# Examples
```julia-repl
julia> r1 = @rule ~x + ~x => 2 * ~x
julia> r2 = @rule 2 * ~x => ~x * 2
julia> chain = RestartedChain([r1, r2])
julia> chain(x + x)  # Applies r1, then restarts and applies r2
```
"""
mutable struct RestartedChain{Cs}
    const rws::Cs
end

instrument(c::RestartedChain, f) = RestartedChain(map(x->instrument(x,f), c.rws))

function (rw::RestartedChain)(x)
    for f in rw.rws
        y = f(x)
        if y !== nothing
            return Chain(rw.rws)(y)
        end
    end
    return x
end

@generated function (rw::RestartedChain{<:NTuple{N,Any}})(x) where N
    quote
        Base.@nexprs $N i->begin
            let f = rw.rws[i]
                y = f(x)
                if y !== nothing
                    return Chain(rw.rws)(y)
                end
            end
        end
        return x
    end
end


"""
    Fixpoint(rw)

Apply a rewriter repeatedly until a fixed point is reached.

The rewriter is applied repeatedly until the output equals the input
(either by identity or by `isequal`), indicating a fixed point has been reached.

# Arguments
- `rw`: The rewriter to apply repeatedly

# Examples
```julia-repl
julia> r = @rule ~x + ~x => 2 * ~x
julia> fp = Fixpoint(r)
julia> fp(x + x + x + x)  # Keeps applying until no more changes
```

See also: [`FixpointNoCycle`](@ref)
"""
struct Fixpoint{C}
    rw::C
end

instrument(x::Fixpoint, f) = Fixpoint(instrument(x.rw, f))

function (rw::Fixpoint)(x)
    f = rw.rw
    y = f(x)
    while (x !== y) && !isequal(x, y)
        y === nothing && return x
        x = y
        y = f(x)
    end
    return x
end

"""
    FixpointNoCycle(rw)

`FixpointNoCycle` behaves like [`Fixpoint`](@ref),
but returns a rewriter which applies `rw` repeatedly until
it produces a result that was already produced before, for example,
if the repeated application of `rw` produces results `a, b, c, d, b` in order,
`FixpointNoCycle` stops because `b` has been already produced.
"""
struct FixpointNoCycle{C}
    rw::C
    hist::Vector{UInt64} # vector of hashes for history
end

instrument(x::FixpointNoCycle, f) = Fixpoint(instrument(x.rw, f))

function (rw::FixpointNoCycle)(x)
    f = rw.rw
    push!(rw.hist, hash(x))
    y = f(x)
    while x !== y && hash(x) ∉ rw.hist
        if y === nothing
            empty!(rw.hist)
            return x
        end
        push!(rw.hist, y)
        x = y
        y = f(x)
    end
    empty!(rw.hist)
    return x
end

struct Walk{ord, C, F, M, threaded}
    rw::C
    filter::F
    thread_cutoff::Int
    maketerm::M
end

function instrument(x::Walk{ord, C,F, M,threaded}, f) where {ord,C,F, M,threaded}
    irw = instrument(x.rw, f)
    Walk{ord, typeof(irw), typeof(x.filter), typeof(x.maketerm), threaded}(irw,
                                                            x.filter,
                                                            x.thread_cutoff,
                                                            x.maketerm)
end

using .Threads


"""
    Postwalk(rw; threaded=false, thread_cutoff=100, maketerm=maketerm)

Apply a rewriter to a symbolic expression tree in post-order (bottom-up).

Post-order traversal visits child nodes before their parents, allowing for
simplification of subexpressions before the containing expression.

# Arguments
- `rw`: The rewriter to apply at each node
- `threaded`: If true, use multi-threading for large expressions
- `thread_cutoff`: Minimum node count to trigger threading
- `maketerm`: Function to construct terms (defaults to `maketerm`)
- `filter`: Function which returns whether to search into a subtree

# Examples
```julia-repl
julia> r = @rule ~x + ~x => 2 * ~x
julia> pw = Postwalk(r)
julia> pw((x + x) * (y + y))  # Simplifies both additions
2x * 2y
```

See also: [`Prewalk`](@ref)
"""
function Postwalk(rw; threaded::Bool=false, thread_cutoff=100, maketerm=maketerm, filter=Returns(true))
    Walk{:post, typeof(rw), typeof(filter), typeof(maketerm), threaded}(rw, filter, thread_cutoff, maketerm)
end

"""
    Prewalk(rw; threaded=false, thread_cutoff=100, maketerm=maketerm)

Apply a rewriter to a symbolic expression tree in pre-order (top-down).

Pre-order traversal visits parent nodes before their children, allowing for
transformation of the overall structure before processing subexpressions.

# Arguments
- `rw`: The rewriter to apply at each node
- `threaded`: If true, use multi-threading for large expressions
- `thread_cutoff`: Minimum node count to trigger threading
- `maketerm`: Function to construct terms (defaults to `maketerm`)
- `filter`: Function which returns whether to search into a subtree

# Examples
```julia-repl
julia> r = @rule sin(~x) => cos(~x)
julia> pw = Prewalk(r)
julia> pw(sin(sin(x)))  # Transforms outer sin first
cos(cos(x))
```

See also: [`Postwalk`](@ref)
"""
function Prewalk(rw; threaded::Bool=false, thread_cutoff=100, maketerm=maketerm, filter=Returns(true))
    Walk{:pre, typeof(rw), typeof(filter), typeof(maketerm), threaded}(rw, filter, thread_cutoff, maketerm)
end

"""
    PassThrough(rw)

A rewriter that returns the input unchanged if the wrapped rewriter returns `nothing`.

This is useful for making rewriters that preserve the input when no rule applies.

# Arguments
- `rw`: The rewriter to wrap

# Examples
```julia-repl
julia> r = @rule sin(~x) => cos(~x)
julia> pt = PassThrough(r)
julia> pt(sin(x))  # Returns cos(x)
julia> pt(tan(x))  # Returns tan(x) unchanged
```
"""
struct PassThrough{C}
    rw::C
end
instrument(x::PassThrough, f) = PassThrough(instrument(x.rw, f))

(p::PassThrough)(x) = (y=p.rw(x); y === nothing ? x : y)

function (p::Walk{ord, C, F, M, false})(x::BasicSymbolic{T}) where {ord, C, F, M, T}
    @assert ord === :pre || ord === :post
    if iscall(x)
        if ord === :pre
            x = Const{T}(@something(p.rw(x), x))
        end

        if iscall(x) && p.filter(x)
            args = arguments(x)::ROArgsT{T}
            op = PassThrough(p)
            for i in eachindex(args)
                arg = args[i]
                newarg = op(arg)
                if args isa ROArgsT{T}
                    if arg === newarg || @manually_scope COMPARE_FULL => true isequal(arg, newarg)::Bool
                        continue
                    end
                    args = copy(parent(args))::ArgsT{T}
                end
                args[i] = Const{T}(newarg)
            end
            if args isa ArgsT{T}
                x = p.maketerm(typeof(x), operation(x), args, metadata(x))
            end
        end

        return ord === :post ? Const{T}(@something(p.rw(x), x)) : x
    else
        return Const{T}(@something(p.rw(x), x))
    end
end
(p::Walk)(x) = x

function (p::Walk{ord, C, F, M, true})(x::BasicSymbolic{T}) where {ord, C, F, M, T}
    @assert ord === :pre || ord === :post
    if iscall(x)
        if ord === :pre
            x = p.rw(x)
        end
        if iscall(x) && p.filter(x)
            args = arguments(x)::ROArgsT{T}
            op = PassThrough(p)
            for i in eachindex(args)
                arg = args[i]
                newarg = if node_count(arg) > p.thread_cutoff
                    Const{T}(Threads.@spawn op(arg); unsafe=true)
                else
                    Const{T}(op(arg))
                end
                if args isa ROArgsT{T}
                    if arg === newarg || @manually_scope COMPARE_FULL => true isequal(arg, newarg)::Bool
                        continue
                    end
                    args = copy(parent(args))::ArgsT{T}
                end
                args[i] = newarg
            end
            if args isa ArgsT{T}
                for i in eachindex(args)
                    if unwrap_const(args[i]) isa Task
                        args[i] = Const{T}(fetch(unwrap_const(args[i])))
                    end
                end
                x = p.maketerm(typeof(x), operation(x), args, metadata(x))
            end
        end
        return ord === :post ? Const{T}(p.rw(x)) : x
    else
        return Const{T}(p.rw(x))
    end
end

end # end module

"""
    $(TYPEDEF)

A mutable resizeable 3-length vector to implement non-allocating small vectors.

$(TYPEDFIELDS)
"""
mutable struct Backing{T} <: AbstractVector{T}
    """
    Length of the buffer.
    """
    len::Int
    x1::T
    x2::T
    x3::T

    Backing{T}() where {T} = new{T}(0)
    Backing{T}(x1) where {T} = new{T}(1, x1)
    Backing{T}(x1, x2) where {T} = new{T}(2, x1, x2)
    Backing{T}(x1, x2, x3) where {T} = new{T}(3, x1, x2, x3)
end

Base.size(x::Backing) = (x.len,)
Base.isempty(x::Backing) = x.len == 0

"""
    $(TYPEDSIGNATURES)

Value to use when removing an element from a `Backing`. Used so stored entries can be
GC'ed when removed.
"""
defaultval(::Type{T}) where {T <: Number} = zero(T)
defaultval(::Type{UnitRange{Int}}) = 1:0
defaultval(::Type{Any}) = nothing

_unreachable() = error("Unreachable reached.")

Base.@propagate_inbounds function Base.getindex(x::Backing, i::Int)
    @boundscheck 1 <= i <= x.len
    if i == 1
        x.x1
    elseif i == 2
        x.x2
    elseif i == 3
        x.x3
    else
        _unreachable()
    end
end

Base.@propagate_inbounds function Base.getindex(x::Backing{T}, i::Vector{Int}) where {T}
    n = length(i)
    if n == 1
        return Backing{T}(x[i[1]])
    elseif n == 2
        return Backing{T}(x[i[1]], x[i[2]])
    elseif n == 3
        return Backing{T}(x[i[1]], x[i[2]], x[i[3]])
    end
end

Base.@propagate_inbounds function Base.setindex!(x::Backing, v, i::Int)
    @boundscheck 1 <= i <= x.len
    if i == 1
        setfield!(x, :x1, v)
    elseif i == 2
        setfield!(x, :x2, v)
    elseif i == 3
        setfield!(x, :x3, v)
    end
end

Base.@propagate_inbounds function Base.push!(x::Backing{T}, v::T) where {T}
    @boundscheck x.len < 3
    x.len += 1
    x[x.len] = v
    x
end

Base.@propagate_inbounds function Base.pop!(x::Backing{T}) where {T}
    @boundscheck x.len > 0
    v = x[x.len]
    x[x.len] = defaultval(T)
    x.len -= 1
    v
end

function Base.any(f::F, x::Backing) where {F <: Function}
    if x.len == 0
        return false
    elseif x.len == 1
        return f(x.x1)
    elseif x.len == 2
        return f(x.x1) || f(x.x2)
    elseif x.len == 3
        return f(x.x1) || f(x.x2) || f(x.x3)
    end
    _unreachable()
end

function Base.all(f::F, x::Backing) where {F <: Function}
    if x.len == 0
        return true
    elseif x.len == 1
        return f(x.x1)
    elseif x.len == 2
        return f(x.x1) && f(x.x2)
    elseif x.len == 3
        return f(x.x1) && f(x.x2) && f(x.x3)
    end
    _unreachable()
end

function Base.map(f::F, x::Backing{T}) where {F, T}
    if x.len == 0
        # StaticArrays does this, so we are only as bad as they are
        return Backing{Core.Compiler.return_type(f, Tuple{T})}()
    elseif x.len == 1
        x1 = f(x.x1)
        return Backing{typeof(x1)}(x1)
    elseif x.len == 2
        x1 = f(x.x1)
        x2 = f(x.x2)
        return Backing{Base.promote_typejoin(typeof(x1), typeof(x2))}(x1, x2)
    elseif x.len == 3
        x1 = f(x.x1)
        x2 = f(x.x2)
        x3 = f(x.x3)
        _T = Base.promote_typejoin(typeof(x1), typeof(x2))
        _T = Base.promote_typejoin(_T, typeof(x3))
        return Backing{_T}(x1, x2, x3)
    end
    _unreachable()
end

function Base.empty!(x::Backing{T}) where {T}
    x.x1 = defaultval(T)
    x.x2 = defaultval(T)
    x.x3 = defaultval(T)
    x.len = 0
    return x
    # if x.len >= 1
    #     x.x1 = defaultval(T)
    # end
    # if x.len >= 2
    #     x.x2 = defaultval(T)
    # end
    # if x.len == 3
    #     x.x3 = defaultval(T)
    # end
    # x.len = 0
    # return x
end

function Base.copy(x::Backing{T}) where {T}
    if x.len == 0
        return Backing{T}()
    elseif x.len == 1
        return Backing{T}(x.x1)
    elseif x.len == 2
        return Backing{T}(x.x1, x.x2)
    elseif x.len == 3
        return Backing{T}(x.x1, x.x2, x.x3)
    end
    _unreachable()
end

function Base.resize!(x::Backing, sz::Integer)
    if sz > 3
        throw(ArgumentError("New length must be <= 3"))
    elseif sz < 0
        throw(ArgumentError("New length must be >= 0"))
    end
    x.len = sz
    return x
end

function Base.insert!(x::Backing{T}, i::Integer, val::T) where {T}
    @boundscheck !isfull(x)
    @boundscheck 1 <= i <= x.len + 1
    x.len += 1
    if x.len == 1 && i == 1
        x.x1 = val
    elseif x.len == 2 && i == 1
        x.x2 = x.x1
        x.x1 = val
    elseif x.len == 2 && i == 2
        x.x2 = val
    elseif x.len == 3 && i == 1
        x.x3 = x.x2
        x.x2 = x.x1
        x.x1 = val
    elseif x.len == 3 && i == 2
        x.x3 = x.x2
        x.x2 = val
    elseif x.len == 3 && i == 3
        x.x3 = val
    else
        error("Unreachable")
    end
    return x
end

function Base.hash(x::Backing{T}, h::UInt) where {T}
    h += Base.hash_abstractarray_seed
    h = hash((1,), h)
    h = hash((3,), h)
    if x.len == 1
        h = hash(x.x1, h)
    elseif x.len == 2
        h = hash(x.x1, h)
        h = hash(x.x2, h)
    elseif x.len == 3
        h = hash(x.x1, h)
        h = hash(x.x2, h)
        h = hash(x.x3, h)
    end
    return h
end

"""
    $(TYPEDSIGNATURES)

Whether the `Backing` is full.
"""
isfull(x::Backing) = x.len == 3

"""
    $(TYPEDSIGNATURES)

A small-buffer-optimized `AbstractVector`. Uses a `Backing` when the number of elements
is within the size of `Backing`, and allocates a `V` when the number of elements exceed
this limit.
"""
mutable struct SmallVec{T, V <: AbstractVector{T}} <: AbstractVector{T}
    data::Union{Backing{T}, V}

    function SmallVec{T}(x::AbstractVector{T}) where {T}
        V = typeof(x)
        if length(x) < 4
            new{T, V}(Backing{T}(x...))
        else
            new{T, V}(x)
        end
    end

    function SmallVec{T, V}(x::Backing{T}) where {T, V}
        new{T, V}(x)
    end

    function SmallVec{T, V}() where {T, V}
        new{T, V}(Backing{T}())
    end

    function SmallVec{T, V}(x::Union{Tuple, AbstractVector}) where {T, V}
        if length(x) <= 3
            new{T, V}(Backing{T}(x...))
        else
            new{T, V}(V(x isa Tuple ? collect(x) : x))
        end
    end

    function SmallVec{T, V}(::UndefInitializer, n::Integer) where {T, V}
        if n <= 3
            inner = Backing{T}()
            inner.len = n
        else
            inner = V(undef, n)
        end
        return new{T, V}(inner)
    end
end


Base.size(x::SmallVec) = size(x.data)
Base.isempty(x::SmallVec) = isempty(x.data)
Base.@propagate_inbounds Base.getindex(x::SmallVec, i::Int) = x.data[i]
Base.@propagate_inbounds Base.setindex!(x::SmallVec, v, i::Int) = setindex!(x.data, v, i)
Base.@propagate_inbounds function Base.getindex(x::SmallVec{T, V}, i::Vector{Int}) where {T, V}
    SmallVec{T, V}(x.data[i])
end

Base.@propagate_inbounds function Base.push!(x::SmallVec{T, V}, v::T) where {T, V}
    buf = x.data
    if buf isa V
        push!(buf, v)
        return x
    elseif buf isa Backing{T}
        if !isfull(buf)
            push!(buf, v)
            return x
        end
        buf = x.data = V(buf)::V
        push!(buf, v)
        return x
    end
    _unreachable()
end

Base.@propagate_inbounds Base.pop!(x::SmallVec) = pop!(x.data)

function Base.sizehint!(x::SmallVec{T, V}, n::Int; kwargs...) where {T, V}
    x.data isa Backing && return x
    sizehint!(x.data, n; kwargs...)
    x
end

Base.iterate(x::SmallVec, i::Int = 1) = i > length(x) ? nothing : (@inbounds x[i], i + 1)
Base.any(f::F, x::SmallVec) where {F <: Function} = any(f, x.data)
Base.all(f::F, x::SmallVec) where {F <: Function} = all(f, x.data)
function Base.map(f::F, x::SmallVec{T, Vector{T}}) where {F, T}
    arr = map(f, x.data)
    SmallVec{eltype(arr),Vector{eltype(arr)}}(arr)
end
Base.empty!(x::SmallVec) = empty!(x.data)
Base.copy(x::SmallVec{T, V}) where {T, V} = SmallVec{T, V}(copy(x.data))
function Base.resize!(x::SmallVec{T, V}, sz::Integer) where {T, V}
    tmp = x.data
    if tmp isa Backing{T}
        if sz > 3
            tmp = x.data = V(tmp)
            resize!(tmp, sz)
        else
            resize!(tmp, sz)
        end
    else
        resize!(tmp, sz)
    end
    return x
end
function Base.insert!(x::SmallVec{T, V}, i::Integer, val) where {T, V}
    if x.data isa Backing{T} && isfull(x.data)
        x.data = V(x.data)
    end
    insert!(x.data, i, val)
    return x
end
function Base.hash(x::SmallVec{T, V}, h::UInt) where {T, V}
    return hash(x.data, h)
end

backingtype(::Type{SmallVec{T, V}}) where {T, V} = Backing{T}
backingtype(x::SmallVec) = backingtype(typeof(x))
buffertype(::Type{SmallVec{T, V}}) where {T, V} = V
buffertype(x::SmallVec) = buffertype(typeof(x))

macro union_split_smallvec(svec::Symbol, body)
    svec = esc(svec)
    quote
        inner = $(svec).data
        if inner isa $backingtype($svec)
            let $svec = inner
                $(esc(body))
            end
        elseif inner isa $buffertype($svec)
            let $svec = inner
                $(esc(body))
            end
        else
            $_unreachable()
        end
    end
end

using SymbolicUtils
using SymbolicUtils: Sym, Term, symtype, BasicSymbolic, Const, substitute, query, Operator, scalarize
import SymbolicUtils: search_variables!, default_substitute_filter, evaluate, default_is_atomic, search_variables, Code
using Test
using SparseArrays
using LinearAlgebra

@testset "Substitute with Pair" begin
    @syms x y
    result = substitute(x + y, x => 2)
    @test isequal(result, 2 + y)
end

@testset "Substitute with Array of Pairs" begin
    @syms x y z
    result = substitute(x + y + z, [x => 1, y => 2])
    @test isequal(result, 3 + z)
end

@testset "Substitute SparseMatrixCSC" begin
    @syms x
    sparse_mat = sparse([1, 2], [1, 2], [x, 2x])
    result = substitute(sparse_mat, x => 3)
    # Test that result is a sparse matrix with correct values
    @test result isa SparseMatrixCSC
    @test nnz(result) == 2  # 2 non-zero entries
end

@testset "Substitute division with can_fold" begin
    @syms x y
    expr = x / y
    # When both are constants, should fold
    result = substitute(expr, Dict(x => 10, y => 2); fold=Val(true))
    # Just test that substitute works with fold parameter
    @test result isa BasicSymbolic{SymReal}
    @test isequal(unwrap_const(result), 5)
end

@testset "Substitute with 3 args can_fold" begin
    @syms x y z
    expr = clamp(x, y, z)
    result = substitute(expr, Dict(x => 5, y => 1, z => 10); fold=Val(true))
    # Just test that substitute works with fold parameter
    @test result isa BasicSymbolic{SymReal}
    @test isequal(unwrap_const(result), 5)
end

@testset "Substitute with 4+ args can_fold" begin
    # We need a function that takes 4+ arguments
    f = (a, b, c, d) -> a + b + c + d
    @syms w x y z
    # Register the function with SymbolicUtils
    expr = Term{SymbolicUtils.SymReal}(f, [w, x, y, z]; type = Real, shape = SymbolicUtils.ShapeVecT())
    # Substitute all variables with constants
    result = substitute(expr, Dict(w => 1, x => 2, y => 3, z => 4); fold=Val(true))
    # Just test that substitute works with fold parameter
    @test result isa BasicSymbolic{SymReal}
    @test isequal(unwrap_const(result), 10)
end

@testset "Query with AddMul" begin
    @syms x y z
    # Create an expression that uses Add/Mul optimization
    expr = x + y + z
    # Query if it contains x
    has_x = query(ex -> isequal(ex, x), expr)
    @test has_x == true
end

@testset "Query with Div" begin
    @syms x y z
    expr = (x + z) / y
    # Query if it contains y
    has_y = query(ex -> isequal(ex, y), expr)
    @test has_y == true
end

@testset "Query with ArrayOp" begin
    @syms x[1:3]
    # Create an array operation
    expr = x .+ 1
    # Query if it contains any symbolic
    has_symbolic = query(isequal(x), expr)
    @test has_symbolic == true
end

@testset "search_variables! with Div" begin
    @syms x y z
    expr = (x + 2) / (y + 3)
    vars = Set{Any}()
    search_variables!(vars, expr)
    @test x in vars
    @test y in vars
    let_block = Code.cse(expr)
    let_vars = search_variables(let_block)
    @test issetequal(vars, let_vars)
end

@testset "search_variables! with ArrayOp" begin
    @syms x[1:3]
    expr = x .+ 1
    vars = Set{Any}()
    search_variables!(vars, expr)
    @test any(v -> v isa BasicSymbolic, vars)
    let_block = Code.cse(expr)
    let_vars = search_variables(let_block)
    @test issetequal(vars, let_vars)
end

@testset "search_variables! with AbstractArray" begin
    @syms x y z
    arr = [x + y, y + z, x + z]
    vars = Set{Any}()
    search_variables!(vars, arr)
    @test x in vars
    @test y in vars
    @test z in vars
    let_block = Code.cse(arr)
    let_vars = search_variables(let_block)
    @test issetequal(vars, let_vars)
end

@testset "search_variables! with SparseMatrixCSC" begin
    @syms x y
    sparse_mat = sparse([1, 2], [1, 2], [x, y])
    vars = Set{Any}()
    search_variables!(vars, sparse_mat)
    @test x in vars
    @test y in vars
    vars = search_variables(sparse_mat)
    @test x in vars
    @test y in vars
end

@testset "det scalarization" begin
    for N in 2:5
        @syms M[1:N, 1:N]
        det_expr = LinearAlgebra.det(M)

        det_scal = SymbolicUtils.scalarize(det_expr)

        vals = reshape(1:(N*N), N, N)
        @test det(vals) ≈ unwrap_const(substitute(det_scal, Dict(M => vals); fold = Val(true))) atol = 1e-16
    end
end

@testset "evaluate function" begin
    # Test lines 139-140: evaluate function
    @syms x
    expr = sin(x)
    # Substitute and evaluate
    result = evaluate(substitute(expr, Dict(x => 2)))
    @test result isa BasicSymbolic{SymReal}
    @test unwrap_const(result) ≈ sin(2.0)
end

@testset "scalarize with AbstractArray" begin
    @syms x[1:2]
    arr = [x]
    # Scalarize an array
    result = scalarize(arr)
    @test result isa Vector
    @test length(result) == 1
    @test isequal(result[1], scalarize(x))
end

@testset "scalarize with non-symbolic input" begin
    # Test that scalarize returns non-symbolic values unchanged
    result = scalarize(5)
    @test result == 5
end

@testset "scalarize with toplevel ArrayOp" begin
    @syms x[1:2, 1:2]
    # Create an ArrayOp expression
    expr = x .+ 1
    # Scalarize with toplevel=true
    result = scalarize(expr, Val{true}())
    @test result isa AbstractArray
end

@testset "scalarize with array shape expressions" begin
    @syms x[1:2]
    # Test scalarize with array expressions
    expr = x .* 2
    result = scalarize(expr)
    @test isequal(result, [2x[1], 2x[2]])
end

@testset "substitute with custom filterer" begin
    @syms x y z
    expr = x + y * z
    # Use a custom filterer that blocks certain operations
    custom_filter = !isequal(y * z)
    result = substitute(expr, Dict(z => 1); filterer=custom_filter, fold=Val(true))
    @test isequal(result, expr)
end

@testset "query with recurse parameter" begin
    @syms x y z
    expr = x + y * z
    # Query with custom recurse function
    has_z = query(ex -> isequal(ex, z), expr; recurse = x -> operation(x) !== (*))
    @test has_z == false

    result = query(ex -> false, 5)
    @test result == false
end

@testset "query with ArrayOp and term field" begin
    @syms x[1:3]
    expr = 2 .* x
    result = query(ex -> iscall(ex) && operation(ex) === broadcast, expr; default=false)
    @test result == true
end

@testset "default_is_atomic edge cases" begin
    @test !default_is_atomic(SymbolicUtils.IDXS_SYMREAL)
    @test !default_is_atomic(SymbolicUtils.IDXS_SYMREAL[1])
end

@testset "Scalarization of matmul with scalar coeff" begin
    @syms x y[1:2, 1:2] z[1:2]
    expr = x * y * z
    scal = SymbolicUtils.scalarize(expr)
    @test scal isa Vector
    @test length(scal) == 2
    truth = x .* (collect(y) * collect(z))
    @test isequal(truth, scal)
end

@testset "Scalarization of array addition" begin
    @syms x[1:3] y[1:3] z[1:3]
    expr = x + y + z
    scal = SymbolicUtils.scalarize(expr)
    @test scal isa Vector
    @test length(scal) == 3
    truth = collect(x) + collect(y) + collect(z)
    @test isequal(truth, scal)
end

@testset "Scalarization of array division" begin
    @syms x y[1:2, 1:2] z[1:2]
    expr = (y * z) / x
    scal = SymbolicUtils.scalarize(expr)
    @test scal isa Vector
    @test length(scal) == 2
    truth = [(y[1, 1] * z[1] + y[1, 2] * z[2]) / x, (y[2, 1] * z[1] + y[2, 2] * z[2]) / x]
    @test isequal(scal, truth)

    expr = x \ (y * z)
    scal = SymbolicUtils.scalarize(expr)
    @test scal isa Vector
    @test length(scal) == 2
    @test isequal(scal, truth)
end

@testset "Scalarization of ldiv" begin
    @syms x y A[1:3, 1:3] b[1:3]
    @test isequal(SymbolicUtils.scalarize(x \ y), x \ y)
    @test isequal(SymbolicUtils.scalarize(A \ b), [(A \ b)[1], (A \ b)[2], (A \ b)[3]])
end

@testset "Substitution inside large symbolic arrays" begin
    @syms a b
    arr = zeros(BasicSymbolic{SymReal}, 100, 100)
    arr[5, 5] = a
    arr = Const{SymReal}(arr)
    @test_nowarn substitute(arr, [a => b])
end

@noinline function throw_unequal_shape_error(x, y)
    throw(ArgumentError(LazyString("Cannot add arguments of different sizes - encountered shapes ", x, " and ", y, ".")))
end

promote_shape(::typeof(+), shape::ShapeT) = shape
function promote_shape(::typeof(+), sh1::ShapeT, sh2::ShapeT, shs::ShapeT...)
    @nospecialize sh1 sh2 shs
    nd1 = _ndims_from_shape(sh1)
    nd2 = _ndims_from_shape(sh2)
    nd1 == -1 || nd2 == -1 || nd1 == nd2 || throw_unequal_shape_error(sh1, sh2)
    if sh1 isa Unknown && sh2 isa Unknown
        promote_shape(+, Unknown(max(nd1, nd2)), shs...)
    elseif sh1 isa Unknown
        promote_shape(+, sh2, shs...)
    elseif sh2 isa Unknown
        promote_shape(+, sh1, shs...)
    elseif sh1 isa ShapeVecT && sh2 isa ShapeVecT
        if isempty(sh1)
            # `isempty(sh2)` guaranteed because `nd1 == nd2`
            all(s -> s isa ShapeVecT && isempty(s), shs) && return sh1
            return promote_shape(+, sh1, shs...)
        end
        new_shape = ShapeVecT()
        sizehint!(new_shape, length(sh1))
        for (shi, shj) in zip(sh1, sh2)
            length(shi) == length(shj) || throw_unequal_shape_error(sh1, sh2)
            # resultant shape is always 1-indexed for consistency
            push!(new_shape, 1:length(shi))
        end
        promote_shape(+, new_shape, shs...)
    end
end
promote_shape(::typeof(-), args::ShapeT...) = promote_shape(+, args...)

function +(x::T, args::Union{Number, T, AbstractArray{<:Number}, AbstractArray{T}}...) where {T <: NonTreeSym}
    add_worker(vartype(T), (x, args...))
end

@noinline Base.@nospecializeinfer function promoted_symtype(op, terms)
    a, bs = Iterators.peel(terms)
    type::TypeT = symtype(a)
    for b in bs
        type = promote_symtype(op, type, symtype(b))
    end
    return type
end

mutable struct AddWorkerBuffer{T}
    dict::ACDict{T}
    busy::Bool
end

AddWorkerBuffer{T}() where {T} = AddWorkerBuffer{T}(ACDict{T}(), false)

Base.empty!(awb::AddWorkerBuffer) = empty!(awb.dict)

const SYMREAL_ADDBUFFER = TaskLocalValue{AddWorkerBuffer{SymReal}}(AddWorkerBuffer{SymReal})
const SAFEREAL_ADDBUFFER = TaskLocalValue{AddWorkerBuffer{SafeReal}}(AddWorkerBuffer{SafeReal})

@inline function _run_addbuffer(buf::AddWorkerBuffer{T}, terms) where {T}
    if buf.busy
        buf = AddWorkerBuffer{T}()
    end
    buf.busy = true
    try
        return buf(terms)
    finally
        buf.busy = false
    end
end

"""
    $METHODLIST

Add an indexable list or tuple of terms `terms` with the given vartype. Applicable only for
symbolic expressions with numeric or array of numeric symtype.
"""
add_worker(::Type{SymReal}, terms) = _run_addbuffer(SYMREAL_ADDBUFFER[], terms)
add_worker(::Type{SafeReal}, terms) = _run_addbuffer(SAFEREAL_ADDBUFFER[], terms)

function _added_shape(terms::Tuple)
    promote_shape(+, ntuple(shape ∘ Base.Fix1(getindex, terms), Val(length(terms)))...)
end

function _added_shape(terms)
    isempty(terms) && return Unknown(-1)
    length(terms) == 1 && return shape(first(terms))
    a, bs = Iterators.peel(terms)
    sh::ShapeT = shape(a)
    for t in bs
        sh = promote_shape(+, sh, shape(t))
    end
    return sh
end

function (awb::AddWorkerBuffer{T})(terms) where {T}
    if !all(_numeric_or_arrnumeric_symtype, terms)
        throw(MethodError(+, Tuple(terms)))
    end
    isempty(terms) && return zero_of_vartype(T)
    if isone(length(terms))
        return Const{T}(only(terms))
    end
    empty!(awb)
    shape = _added_shape(terms)
    type::TypeT = symtype(Const{T}(first(terms)))
    # type = promoted_symtype(+, terms)
    newcoeff = 0
    result = awb.dict
    for term in terms
        term = unwrap(term)
        if _is_array_of_symbolics(term)
            term = Const{T}(term)
        end
        type = promote_symtype(+, type, symtype(term))
        if term isa BasicSymbolic{T}
            @match term begin
                BSImpl.Const(; val) => (newcoeff = newcoeff .+ val)
                BSImpl.AddMul(; coeff, dict, variant, shape, type, metadata) => begin
                    @match variant begin
                        AddMulVariant.ADD => begin
                            newcoeff = newcoeff .+ coeff
                            for (k, v) in dict
                                _accumulate!(result, k, v)
                            end
                        end
                        AddMulVariant.MUL => begin
                            newterm = Mul{T}(1, dict; shape, type, metadata)
                            _accumulate!(result, newterm, coeff)
                        end
                    end
                end
                _ => begin
                    if is_array_shape(SymbolicUtils.shape(term))
                        coeff, arrterm = _split_arrterm_scalar_coeff(T, term)
                        if isconst(coeff)
                            _accumulate!(result, arrterm, unwrap_const(coeff))
                        else
                            _accumulate!(result, term, 1)
                        end
                    else
                        _accumulate!(result, term, 1)
                    end
                end
            end
        elseif term isa BasicSymbolic{SymReal} || term isa BasicSymbolic{SafeReal} || term isa BasicSymbolic{TreeReal}
            error(LazyString("Cannot operate on symbolics with different vartypes. Found `", T, "` and `", vartype(term), "`."))
        elseif term isa AbstractIrrational
            term = BSImpl.Term{T}(identity, ArgsT{T}((Const{T}(term),)); type = Real, shape = ShapeVecT())
            _accumulate!(result, term, 1)
        else
            newcoeff = newcoeff .+ term
        end
    end
    # If every term cancels we still need to preserve the array shape (a scalar `0` cannot
    # stand in for a zero vector). Grab a surviving array-shaped key before filtering so the
    # all-cancel case can be rebuilt as `coeff * arr` (e.g. `y - y` => `0y`).
    arr_witness = nothing
    if is_array_shape(shape)
        for k in keys(result)
            if is_array_shape(SymbolicUtils.shape(k))
                arr_witness = k
                break
            end
        end
    end
    filter!(!(iszero ∘ last), result)
    if isempty(result)
        if arr_witness !== nothing && !(newcoeff isa AbstractArray)
            return (newcoeff * arr_witness)::BasicSymbolic{T}
        end
        return Const{T}(newcoeff)
    end
    var = Add{T}(newcoeff, result; type, shape)::BasicSymbolic{T}
    @match var begin
        BSImpl.AddMul(; dict) && if dict === result end => (awb.dict = ACDict{T}())
        _ => nothing
    end
    return var
end

const PolyadicNumericOpFirstArgT{T} = Union{Number, AbstractArray{<:Number}, AbstractArray{T}}

for T in [:(PolyadicNumericOpFirstArgT{T}), Int, Float64, Bool]
    @eval function +(a::$T, b::T, bs...) where {T <: NonTreeSym}
        return add_worker(vartype(T), (a, b, bs...))
    end
end

function -(a::BasicSymbolic{T}) where {T}
    if !_numeric_or_arrnumeric_symtype(a)
        throw(MethodError(-, (symtype(a),)))
    end
    @match a begin
        BSImpl.Const(; val) => Const{T}(-val)
        _ => nothing
    end
    @match a begin
        BSImpl.AddMul(; coeff, dict, variant, shape, type) => begin
            @match variant begin
                AddMulVariant.ADD => begin
                    coeff = -coeff
                    dict = copy(dict)
                    map!(-, values(dict))
                    return BSImpl.AddMul{T}(coeff, dict, variant; shape, type)
                end
                AddMulVariant.MUL => begin
                    return Mul{T}(-coeff, dict; shape, type)::BasicSymbolic{T}
                end
            end
        end
        _ => (-1 * a)::BasicSymbolic{T}
    end
end

function -(a::S, b::S) where {S <: NonTreeSym}
    if !_numeric_or_arrnumeric_symtype(a) || !_numeric_or_arrnumeric_symtype(b)
        throw(MethodError(-, (a, b)))
    end
    T = vartype(S)
    @match (a, b) begin
        (BSImpl.Const(; val = val1), BSImpl.Const(; val = val2)) => begin
            return Const{T}(val1 - val2)
        end
        _ => return add_worker(T, (a, -b))::BasicSymbolic{T}
    end
end

-(a::Union{Number, AbstractArray{<:Number}}, b::BasicSymbolic) = a + (-b)
-(a::BasicSymbolic, b::Union{Number, AbstractArray{<:Number}}) = a + (-b)
function -(a::AbstractArray{<:BasicSymbolic}, b::BasicSymbolic)
    Const{vartype(b)}(a) + (-b)
end
function -(a::BasicSymbolic, b::AbstractArray{<:BasicSymbolic})
    a - Const{vartype(a)}(b)
end

"""
$(DocStringExtensions.README)
"""
module SymbolicUtils

if isdefined(Base, :Experimental) && isdefined(Base.Experimental, Symbol("@max_methods"))
    @eval Base.Experimental.@compiler_options max_methods=1
end

using DocStringExtensions

export @syms, term, hasmetadata, getmetadata, setmetadata

using Moshi.Data: @data
import Moshi.Data as MData
using Moshi.Match: @match
using EnumX: @enumx
using TermInterface
using Setfield
import Setfield: PropertyLens
using SymbolicIndexingInterface
import Base: +, -, *, /, //, \, ^, ImmutableDict
using ConstructionBase
using TermInterface
import TermInterface: iscall, operation, arguments, metadata, maketerm, sorted_arguments
# For ReverseDiffExt
import ArrayInterface
import ExproniconLite as EL
import TaskLocalValues: TaskLocalValue
using WeakCacheSets: WeakCacheSet, getkey!
using Base: RefValue
import MacroTools
import PrecompileTools
PrecompileTools.@recompile_invalidations begin
    import MultivariatePolynomials as MP
    import DynamicPolynomials as DP
    import MutableArithmetics as MA
    import SparseArrays: SparseMatrixCSC, findnz, sparse
    using DataStructures
    import DataStructures: OrderedCollections
    using ReadOnlyArrays
    import Graphs
    import StaticArraysCore
end
import LinearAlgebra
using SciMLPublic: @public

macro manually_scope(val, expr, is_forced = false)
    @assert Meta.isexpr(val, :call)
    @assert val.args[1] == :(=>)

    var_name = val.args[2]
    new_val = val.args[3]
    old_name = gensym(:old_val)
    cur_name = gensym(:cur_val)
    retval_name = gensym(:retval)
    close_expr = :($var_name[] = $old_name)
    interpolated_expr = MacroTools.postwalk(expr) do ex
        if Meta.isexpr(ex, :$) && length(ex.args) == 1 && ex.args[1] == :$
            return cur_name
        else
            return ex
        end
    end
    basic_result = quote
        $cur_name = $var_name[] = $new_val
        $retval_name = try
            $interpolated_expr
        finally
            $close_expr
        end
    end
    is_forced && return quote
        $old_name = $var_name[]
        $basic_result
    end |> esc

    return quote
        $old_name = $var_name[]
        if $iszero($old_name)
            $basic_result
        else
            $cur_name = $old_name
            $retval_name = begin
                $interpolated_expr
            end
        end
        $retval_name
    end |> esc
end

# copied from https://github.com/JuliaLang/julia/blob/80f7db8e51b2ba1dd21e913611c23a6d5b75ecab/base/lock.jl#L371-L381
# and adapted for readlock/readunlock
macro readlock(l, expr)
    quote
        temp = $(esc(l))
        $readlock(temp)
        try
            $(esc(expr))
        finally
            $readunlock(temp)
        end
    end
end

include("cache.jl")
Base.@deprecate istree iscall

"""
    istree(x)

Deprecated spelling of [`iscall`](@ref). Returns `true` if `x` is a function call
expression, i.e. one for which [`operation`](@ref) and [`arguments`](@ref) are defined.

`istree` was the name used by the pre-`TermInterface` symbolic interface. It is retained
only so that older code keeps running, emits a deprecation warning on every call, and will
be removed in the next breaking release. New code should call `iscall` instead:

```julia
iscall(x)      # instead of istree(x)
```

Note that `iscall` is not merely a rename: the term interface splits the old notion of "is
this a tree node" into `iscall` (the expression is an `operation` applied to `arguments`)
and the container-specific predicates such as [`SymbolicUtils.issym`](@ref). Code that used
`istree` to mean "not a leaf" should check `iscall`; code that used `!istree(x)` to mean "is
a symbol" should check `SymbolicUtils.issym(x)`, which is the precise question.

See also: [`iscall`](@ref), [`operation`](@ref), [`arguments`](@ref).
"""
istree

include("small_array.jl")

export istree, operation, arguments, sorted_arguments, iscall, unwrap_const
# Sym, Term,
# Add, Mul and Pow
PrecompileTools.@recompile_invalidations begin
    include("types.jl")
    include("terminterface.jl")
    include("hashconsing.jl")
    include("inner_ctors.jl")
    include("safe_ctors.jl")
    include("symbolic_ops/common.jl")
    include("symbolic_ops/addsub.jl")
    include("symbolic_ops/mul.jl")
    include("symbolic_ops/div.jl")
    include("symbolic_ops/pow.jl")
    include("symbolic_ops/getindex.jl")
end

export BS
include("syms.jl")
export @arrayop
include("arrayop.jl")
export @makearray
include("arraymaker.jl")

# Methods on symbolic objects
export ifelse_eager, ifelse_branching
PrecompileTools.@recompile_invalidations begin
using SpecialFunctions, NaNMath
include("methods.jl")
include("printing.jl")
end
# LinkedList, simplification utilities
include("utils.jl")

# Tree inspection
include("inspect.jl")
export Rewriters

# A library for composing together expr -> expr functions

using Combinatorics: permutations, combinations
export @rule, @acrule, RuleSet

# Rule type and @rule macro
include("rule.jl")
include("matchers.jl")
include("rewriters.jl")

# Convert to an efficient multi-variate polynomial representation
import DynamicPolynomials
export expand
include("polyform.jl")

# Term ordering
include("ordering.jl")

# Default rules for expression simplification
include("simplify_rules.jl")

# API = simplify + substitute
export simplify
include("simplify.jl")

export substitute
include("substitute.jl")

include("ordereddigraph.jl")
include("graph_traversal.jl")

export IRStructure, populate_ir!, print_ir, get_reachability
include("irstructure.jl")

include("code.jl")

PrecompileTools.@recompile_invalidations begin
    include("despecialize.jl")
end

@public add_worker, mul_worker
@public BasicSymbolic, unwrap, isadd, ismul
@public symtype, issym, isterm, isdiv, Sym
@public isconst
@public ispow
@public fntype_ret_type
@public FnType
@public Mapper, Mapreducer

# `simplify_rules.jl` does `using .Rewriters`, so these already resolve as
# `SymbolicUtils.X` and callers depend on that spelling. Declare them public here so
# reaching them through this module is API rather than a side effect of that import.
@public Empty, IfElse, If, Chain, RestartedChain, Fixpoint, Postwalk, Prewalk, PassThrough

PrecompileTools.@setup_workload begin
    fold1 = Val{false}()
    fold2 = Val{true}()
    PrecompileTools.@compile_workload begin
        @syms x y f(t) q[1:5]
        Sym{SymReal}(:a; type = Real, shape = ShapeVecT())
        x + y
        x * y
        x / y
        x ^ y
        x ^ 5
        6 ^ x
        x - y
        -y
        2y
        symtype(y)
        f(x)
        (5x / 5)
        z = 2
        x ^ z
        Const{SymReal}(x; unsafe=true)
        show(devnull, x ^ 2 + y * x + y / 3x)
        expand((x + y) ^ 2)
        simplify(x ^ (1//2) + (sin(x) ^ 2 + cos(x) ^ 2) + 2(x + y) - x - y)
        ex = x + 2y + sin(x)
        rules1 = Dict(x => y)
        rules2 = Dict(x => 1)
        # Running `fold = Val(true)` invalidates the precompiled statements
        # for `fold = Val(false)` and itself doesn't precompile anyway.
        substitute(ex, rules1)
        # substitute(ex, rules1; fold = fold1)
        # substitute(ex, rules2; fold = fold1)
        # substitute(ex, rules2)
        # substitute(ex, rules1; fold = fold2)
        # substitute(ex, rules2; fold = fold2)
        q[1]
        q'q
        sorted_arguments(x ^ 2 + 2x + x / y + q[1] + f(x) ^ x)
    end
end

precompile(Tuple{typeof(Base.show), Base.TTY, SymbolicUtils.BasicSymbolicImpl.var"typeof(BasicSymbolicImpl)"{SymbolicUtils.SymReal}})
precompile(Tuple{typeof(Core.kwcall), NamedTuple{(:color,), Tuple{Symbol}}, typeof(Base.printstyled), Base.TTY, Int64})

let BS = BasicSymbolic{SymReal}
    precompile(Tuple{typeof(Base.collect), BS})
    precompile(Tuple{typeof(SymbolicUtils._getindex), Type{SymReal}, BS, Int64, Vararg{Int64}})
end

end # module

struct RecursiveDFS{G, N, E, X}
    graph::G
    visited::BitVector
    neighbors_fn::N
    on_enter::E
    on_exit::X
end

function RecursiveDFS(
        g::G; neighbors_fn::N = Graphs.outneighbors,
        on_enter::E = Returns(nothing), on_exit::X = Returns(nothing),
        visited::BitVector = falses(Graphs.nv(g))
    ) where {G <: Graphs.AbstractGraph, N, E, X}
    return RecursiveDFS{G, N, E, X}(g, visited, neighbors_fn, on_enter, on_exit)
end

function (rdfs::RecursiveDFS)(cur::Integer)
    (; graph, visited, neighbors_fn, on_enter, on_exit) = rdfs
    visited[cur] && return
    visited[cur] = true
    on_enter(cur)
    for nbor in neighbors_fn(graph, cur)
        rdfs(nbor)
    end
    on_exit(cur)
    return nothing
end

struct PushToBuffer{T} <: Function
    buffer::Vector{T}
end

(ptb::PushToBuffer)(val) = push!(ptb.buffer, val)

struct FilteredNeighbors{F, N} <: Function
    filter::F
    nbors::N
end

function (fn::FilteredNeighbors)(graph::Graphs.AbstractGraph, i::Integer)
    return Iterators.filter(fn.filter, fn.nbors(graph, i))
end

using SciMLTesting
using SymbolicUtils

run_qa(
    SymbolicUtils;
    ei_kwargs = (;
        no_implicit_imports = (; allow_unanalyzable = (SymbolicUtils.BasicSymbolicImpl,)),
        no_stale_explicit_imports = (; ignore = (:children,), allow_unanalyzable = (SymbolicUtils.BasicSymbolicImpl,)),
        all_qualified_accesses_via_owners = (; ignore = (:copy,)),
        all_qualified_accesses_are_public = (;
            ignore = (
                Symbol("@__doc__"), Symbol("@compiler_options"), Symbol("@nany"),
                Symbol("@nexprs"), Symbol("@nospecializeinfer"), Symbol("@deprecate_binding"),
                :Commutative,
                :Compiler, :Experimental, :CreationOrder, :Monomial, :StaticArray,
                :_setindex!, :acos, :acosh, :asin, :atanh, :copy, :cos, :eval,
                :hash_abstractarray_seed, :hasha_seed, :ht_keyindex2,
                :ht_keyindex2_shorthash!, :instantiate, :kwcall, :lgamma, :literal_pow,
                :log, :log1p, :log10, :log2, :mul_prod, :pow, :postwalk,
                :promote_typejoin, :return_type, :show_unquoted, :sin, :sqrt, :tan,
                :typed_hcat, :typed_hvncat, :typed_hvcat, :typed_vcat, :RefValue, :add_sum,
                :ReinterpretArray, :ReshapedArray, :promote_eltypeof, :promote_typeof,
            ),
        ),
    ),
    # These polynomial aliases are part of the documented developer conversion
    # interface; the underlying representations are owned by DynamicPolynomials.
    reexports_allow = (
        :arguments, :iscall, :operation, :sorted_arguments,
        :ACDict, :MonomialOrder, :MonomialT, :PolyCoeffT, :PolyVarOrder,
        :PolyVarT, :PolynomialT, :ROArgsT, :TypeT,
    ),
)

export SymReal, SafeReal, TreeReal, vartype

abstract type SymVariant end
"""
    $TYPEDEF

One of three possible values of the [`vartype`](@ref). This variant is the default and
behaves as a typical ideal scalar algebra would be expected to.
"""
abstract type SymReal <: SymVariant end
"""
    $TYPEDEF

One of three possible values of the [`vartype`](@ref). This variant is identical to
[`SymReal`](@ref) except common terms in the numerator and denominator of a division are
not cancelled out.
"""
abstract type SafeReal <: SymVariant end
"""
    $TYPEDEF

One of three possible values of the [`vartype`](@ref). This variant does not assume anything
about the algebra and always uses the default tree form for expressions.
"""
abstract type TreeReal <: SymVariant end

###
### Uni-type design
###

# Unknown(-1) is an array of unknown ndims
# Empty ShapeVecT is a scalar
"""
    $TYPEDEF

A struct used as the `shape` of symbolic expressions with unknown size.

# Fields

$TYPEDFIELDS
"""
struct Unknown
    """
    An integer >= -1 indicating the number of dimensions of the symbolic expression of
    unknown size. A value of `-1` indicates the number of dimensions is also unknown.
    """
    ndims::Int

    function Unknown(x::Int)
        x >= -1 || throw(ArgumentError("Unknown ndims must be -1."))
        new(x)
    end
end

const SCALARS = [Bool, Int, Int32, BigInt, Float64, Float32, BigFloat, Rational{Int}, Rational{Int32}, Rational{BigInt}, ComplexF32, ComplexF64, Complex{BigFloat}]

"""
    $TYPEDEF

Type of metadata field for symbolics.
"""
const MetadataT = Union{Base.ImmutableDict{DataType, Any}, Nothing}
"""
    $TYPEDEF

A custom vector type which does not allocate for small numbers of elements. If the number of elements is
known at compile time, it should be passed as a `Tuple` to the constructor.
"""
const SmallV{T} = SmallVec{T, Vector{T}}

"""
    ShapeVecT(ranges)

Concrete shape representation for a symbolic scalar or array.

# Arguments

- `ranges`: a tuple or iterable of `UnitRange{Int}` axes. An empty collection
  represents a scalar.

# Returns

- A compact vector of axes suitable for `SymbolicUtils.shape` and
  [`promote_shape`](@ref).

# Examples

```jldoctest
julia> using SymbolicUtils

julia> SymbolicUtils.ShapeVecT((1:2, 1:3))
2-element SymbolicUtils.ShapeVecT:
 1:2
 1:3

julia> isempty(SymbolicUtils.ShapeVecT())
true
```
"""
const ShapeVecT = SmallV{UnitRange{Int}}

"""
    ShapeT

Union of the concrete [`ShapeVecT`](@ref) representation and [`Unknown`](@ref),
which records a known or unknown number of dimensions when the axes are unavailable.
"""
const ShapeT = Union{Unknown, ShapeVecT}
"""
    $TYPEDEF

Type for the `regions` field of `ArrayMaker`.
"""
const RegionsT = SmallV{ShapeVecT}
const IdentT = Union{IDType, Nothing}
const MonomialOrder = MP.Graded{MP.Reverse{MP.InverseLexOrder}}
const PolyVarOrder = DP.Commutative{DP.CreationOrder}
const ExamplePolyVar = only(DP.@polyvar __DUMMY__ monomial_order=MonomialOrder)
const PolyVarT = typeof(ExamplePolyVar)
const PolyCoeffT = Number
const _PolynomialT{T} = DP.Polynomial{PolyVarOrder, MonomialOrder, T}
# we can't actually print a zero polynomial of this type, since it attempts to call
# `zero(Any)` but that doesn't matter because we shouldn't ever store a zero polynomial
const PolynomialT = _PolynomialT{PolyCoeffT}
"""
    $TYPEDEF

Allowed types for the [`SymbolicUtils.symtype`](@ref) of symbolics.
"""
const TypeT = DataType
const MonomialT = DP.Monomial{PolyVarOrder, MonomialOrder}
const MonomialVecT = DP.MonomialVector{PolyVarOrder, MonomialOrder}

"""
    $TYPEDSIGNATURES

Create a zero polynomial with empty monomial vector.

# Returns
- A `PolynomialT` representing the zero polynomial
"""
function zeropoly()
    mv = DP.MonomialVector{PolyVarOrder, MonomialOrder}()
    PolynomialT(PolyCoeffT[], mv)
end

"""
    $TYPEDSIGNATURES

Create a polynomial representing the constant 1.

# Returns
- A `PolynomialT` representing the constant polynomial 1 with an empty monomial vector
"""
function onepoly()
    V = DP.Commutative{DP.CreationOrder}
    mv = DP.MonomialVector{V, MonomialOrder}(DP.Variable{V, MonomialOrder}[], [Int[]])
    PolynomialT(PolyCoeffT[1], mv)
end

"""
    $(TYPEDEF)

An EnumX.jl enum used to distinguish between addition and multiplication in
[`SymbolicUtils.BSImpl.AddMul`](@ref).
"""
@enumx AddMulVariant::Bool begin
    ADD
    MUL
end

"""
    $(TYPEDEF)

Core ADT for symbolic expressions.
"""
@data mutable BasicSymbolicImpl{T <: SymVariant} begin
    struct Const
        const val::Any
        hash::UInt
        id::IdentT
    end
    struct Sym
        const name::Symbol
        const metadata::MetadataT
        const shape::ShapeT
        const type::TypeT
        hash::UInt
        hash2::UInt
        id::IdentT
    end
    struct Term
        const f::Any
        const args::SmallV{BasicSymbolicImpl.Type{T}}
        const metadata::MetadataT
        const shape::ShapeT
        const type::TypeT
        hash::UInt
        hash2::UInt
        id::IdentT
    end
    struct AddMul
        const coeff::Any
        const dict::Dict{BasicSymbolicImpl.Type{T}, Number}
        const variant::AddMulVariant.T
        const metadata::MetadataT
        const shape::ShapeT
        const type::TypeT
        const args::SmallV{BasicSymbolicImpl.Type{T}}
        hash::UInt
        hash2::UInt
        id::IdentT
    end
    struct Div
        const num::BasicSymbolicImpl.Type{T}
        const den::BasicSymbolicImpl.Type{T}
        # TODO: Keep or remove?
        # Flag for whether this div is in the most simplified form we can compute.
        # This being false doesn't mean no elimination is performed. Trivials such as
        # constant factors can be eliminated. However, polynomial elimination may not
        # have been performed yet. Typically used as an early-exit for simplification
        # algorithms to not try to eliminate more.
        const simplified::Bool
        const metadata::MetadataT
        const shape::ShapeT
        const type::TypeT
        hash::UInt
        hash2::UInt
        id::IdentT
    end
    struct ArrayOp
        # The indices on the LHS of the einsum. Either an `Int` for a reduced yet
        # uncollapsed dimension (e.g. `prod(x; dims = 1)` generates `[1, i]`) or
        # a symbolic idx. We avoid Const since it stores the value as `::Any`.
        const output_idx::SmallV{Union{Int, BasicSymbolicImpl.Type{T}}}
        # The expression on the RHS of the einsum. Uses the indices in `output_idx`
        const expr::BasicSymbolicImpl.Type{T}
        # The reduction function for reduced dimensions
        const reduce::Any
        # The operation expressed as a function of array arguments. Takes preference
        # in codegen. E.g. if this is `x * y` codegen will generate `x * y` instead
        # of writing the matmul with loops.
        const term::Union{BasicSymbolicImpl.Type{T}, Nothing}
        # Optional map from symbolic indices in `output_idx` to the range they can
        # take. Any index not present in this takes its full range of values.
        const ranges::Dict{BasicSymbolicImpl.Type{T}, StepRange{Int, Int}}
        const metadata::MetadataT
        const shape::ShapeT
        const type::TypeT
        const args::SmallV{BasicSymbolicImpl.Type{T}}
        hash::UInt
        hash2::UInt
        id::IdentT
    end
    struct ArrayMaker
        # List of subarray regions that the `ArrayMaker` is composed of. In case of
        # overlapping regions, later ones take priority.
        const regions::RegionsT
        # Values at each region above. Must be of same length as `regions`. Values must
        # have the same shape as the corresponding region, excluding singleton dimensions.
        const values::SmallV{BasicSymbolicImpl.Type{T}}
        const metadata::MetadataT
        # _has_ to be an array shape.
        const shape::ShapeT
        const type::TypeT
        const args::SmallV{BasicSymbolicImpl.Type{T}}
        hash::UInt
        hash2::UInt
        id::IdentT
    end
end

"""
Alias for `SymbolicUtils.BasicSymbolicImpl`.
"""
const BSImpl = BasicSymbolicImpl
"""
Alias for `SymbolicUtils.BasicSymbolicImpl.Type`.
"""
const BasicSymbolic = BSImpl.Type
"""
The type of a mutable buffer containing symbolic arguments. Passing this to the
[`SymbolicUtils.Term`](@ref) constructor will avoid allocating a new array.
"""
const ArgsT{T} = SmallV{BasicSymbolic{T}}
"""
The type of a read-only buffer containing symbolic arguments. Passing this to the
[`SymbolicUtils.Term`](@ref) constructor will avoid allocating a new array. This is
the type returned from [`TermInterface.arguments`](@ref).
"""
const ROArgsT{T} = ReadOnlyVector{BasicSymbolic{T}, ArgsT{T}}
"""
The type of the dictionary stored in [`BSImpl.AddMul`](@ref). Passing this to the
[`SymbolicUtils.Add`](@ref) or [`SymbolicUtils.Mul`](@ref) constructors will avoid
allocating a new dictionary.
"""
const ACDict{T} = Dict{BasicSymbolic{T}, Number}

# Add `val` to the value stored at `key` in `h`, inserting `val` if `key` is absent.
function _accumulate!(h::AbstractDict, key, val)
    h[key] = get(h, key, 0) + val
    return h
end
# Specialized to only do one lookup.
function _accumulate!(h::OrderedDict{K, V}, key::K, val) where {K, V}
    index = OrderedCollections.ht_keyindex2(h, key)
    if index > 0
        @inbounds h.vals[index] = h.vals[index] + val
    else
        v = val isa V ? val : convert(V, val)::V
        OrderedCollections._setindex!(h, v, key, -index)
    end
    return h
end
function _accumulate!(h::Dict{K, V}, key::K, val) where {K, V}
    index, sh = Base.ht_keyindex2_shorthash!(h, key)
    if index > 0
        @inbounds h.vals[index] = h.vals[index] + val
    else
        v = val isa V ? val : convert(V, val)::V
        @inbounds Base._setindex!(h, v, key, -index, sh)
    end
    return h
end


"""
The type of the `output_idxs` field in [`BSImpl.ArrayOp`](@ref).
"""
const OutIdxT{T} = SmallV{Union{Int, BasicSymbolic{T}}}
"""
The type of the `ranges` field in [`BSImpl.ArrayOp`](@ref).
"""
const RangesT{T} = Dict{BasicSymbolic{T}, StepRange{Int, Int}}
"""
    The type of the `sequence` field in [`BSImpl.ArrayMaker`](@ref).
"""
const SequenceT{T} = SmallV{Tuple{SmallV{Union{Int, UnitRange{Int}}}, BasicSymbolic{T}}}

"""
    $TYPEDSIGNATURES

Return the Julia type that the given symbolic expression `x` represents.
Can also be called on non-symbolic values, in which case it is equivalent to
`typeof`.
"""
function symtype(x::BasicSymbolic)
    # use `@match` instead of `x.type` since it is faster
    @match x begin
        BSImpl.Const(; val) => typeof(val)
        BSImpl.Sym(; type) => type
        BSImpl.Term(; type) => type
        BSImpl.AddMul(; type) => type
        BSImpl.Div(; type) => type
        BSImpl.ArrayOp(; type) => type
        BSImpl.ArrayMaker(; type) => type
    end
end
symtype(x) = typeof(x)

"""
    $METHODLIST

Extract the variant type of a `BasicSymbolic`.
"""
vartype(x::BasicSymbolic{T}) where {T} = T
vartype(::Type{BasicSymbolic{T}}) where {T} = T

"""
    shape(x)

Get the shape of a value or symbolic expression. Generally equivalent to `axes` for
non-symbolic `x`, but also works on non-array values.
"""
function shape end

macro __generate_shape_notsymbolic()
    expr = Expr(:if)
    cur_expr = expr
    i = 0
    N = length(SCALARS)
    for t1 in SCALARS
        for T in [t1, Vector{t1}, Matrix{t1}, LinearAlgebra.UniformScaling{t1}]
            i += 1
            push!(cur_expr.args, :(x isa $T))
            push!(cur_expr.args, T <: LinearAlgebra.UniformScaling ? Unknown(2) : :($ShapeVecT(axes(x))))
            new_expr = Expr(:elseif)
            push!(cur_expr.args, new_expr)
            cur_expr = new_expr
        end
    end
    push!(cur_expr.args, :(x isa $(Colon)))
    push!(cur_expr.args, :($shape($Colon())))
    new_expr = Expr(:elseif)
    push!(cur_expr.args, new_expr)
    cur_expr = new_expr

    push!(cur_expr.args, :(x isa $(LinearAlgebra.UniformScaling)))
    push!(cur_expr.args, Unknown(2))
    new_expr = Expr(:elseif)
    push!(cur_expr.args, new_expr)
    cur_expr = new_expr

    push!(cur_expr.args, :(x isa $(Number)))
    push!(cur_expr.args, ShapeVecT())
    new_expr = Expr(:elseif)
    push!(cur_expr.args, new_expr)
    cur_expr = new_expr

    push!(cur_expr.args, :(x isa $(AbstractArray)))
    push!(cur_expr.args, :($ShapeVecT(axes(x))))
    push!(cur_expr.args, :($ShapeVecT()))

    return esc(expr)
end

Base.@nospecializeinfer function _shape_notsymbolic(@nospecialize(x))
    @__generate_shape_notsymbolic
end

function shape(x::BasicSymbolic)
    # use `@match` instead of `x.type` since it is faster
    @match x begin
        BSImpl.Const(; val) => _shape_notsymbolic(val)::ShapeT
        BSImpl.Sym(; shape) => shape
        BSImpl.Term(; shape) => shape
        BSImpl.AddMul(; shape) => shape
        BSImpl.Div(; shape) => shape
        BSImpl.ArrayOp(; shape) => shape
        BSImpl.ArrayMaker(; shape) => shape
    end
end

function shape(x)
    ux = unwrap(x)
    if ux === x
        return _shape_notsymbolic(x)::ShapeT
    else
        return shape(ux)::ShapeT
    end
end
shape(::Colon) = ShapeVecT((1:0,))

function SymbolicIndexingInterface.symbolic_type(x::BasicSymbolic)
    if isconst(x)
        # 0-dim arrays wrapped in `Const` are not `is_array_shape(shape(x))` but should presumably still be
        # considered `ArraySymbolic`
        return symtype(x) <: AbstractArray ? ArraySymbolic() : ScalarSymbolic()
    end
    return is_array_shape(shape(x)) ? ArraySymbolic() : ScalarSymbolic()
end
SymbolicIndexingInterface.symbolic_type(::Type{BasicSymbolic}) = ScalarSymbolic()
SymbolicIndexingInterface.symbolic_type(::Type{BasicSymbolic{T}}) where {T} = ScalarSymbolic()

function SymbolicIndexingInterface.getname(x::BasicSymbolic{T}) where {T}
    @match x begin
        BSImpl.Sym(; name) => name
        BSImpl.Term(; f, args) && if f === getindex end => getname(args[1])
        BSImpl.Term(; f) && if f isa BasicSymbolic{T} end => getname(f)
    end
end

function SymbolicIndexingInterface.hasname(x::BasicSymbolic{T}) where {T}
    @match x begin
        BSImpl.Sym(;) => true
        BSImpl.Term(; f, args) => if f === getindex
            hasname(args[1])
        elseif f isa BasicSymbolic{T}
            hasname(f)
        else
            false
        end
        _ => false
    end
end

"""
    $(TYPEDSIGNATURES)

Return the inner `Symbolic` wrapped in a non-symbolic subtype. Defaults to
returning the input as-is.
"""
unwrap(@nospecialize(x)) = x

"""
    $(TYPEDSIGNATURES)

Properties of `obj` that override any explicitly provided values in
`ConstructionBase.setproperties`.
"""
override_properties(obj::BSImpl.Type) = override_properties(MData.variant_type(obj))

function override_properties(obj::Type{<:BSImpl.Variant})
    @match obj begin
        ::Type{<:BSImpl.Const} => (; id = nothing, hash = 0)
        ::Type{<:BSImpl.Sym} => (; id = nothing, hash = 0, hash2 = 0)
        ::Type{<:BSImpl.AddMul} => (; id = nothing, hash = 0, hash2 = 0)
        ::Type{<:BSImpl.Term} => (; id = nothing, hash = 0, hash2 = 0)
        ::Type{<:BSImpl.Div} => (; id = nothing, hash = 0, hash2 = 0)
        ::Type{<:BSImpl.ArrayOp} => (; id = nothing, hash = 0, hash2 = 0)
        ::Type{<:BSImpl.ArrayMaker} => (; id = nothing, hash = 0, hash2 = 0)
    end
end

ordered_override_properties(::Type{<:BSImpl.Const}) = (0, nothing,)
ordered_override_properties(::Type{<:BSImpl.Sym}) = (0, 0, nothing)
ordered_override_properties(::Type{<:BSImpl.Term}) = (0, 0, nothing)
ordered_override_properties(::Type{BSImpl.AddMul{T}}) where {T} = (ArgsT{T}(), 0, 0, nothing)
ordered_override_properties(::Type{<:BSImpl.Div}) = (0, 0, nothing)
ordered_override_properties(::Type{<:BSImpl.ArrayOp{T}}) where {T} = (ArgsT{T}(), 0, 0, nothing)
ordered_override_properties(::Type{<:BSImpl.ArrayMaker{T}}) where {T} = (ArgsT{T}(), 0, 0, nothing)

function ConstructionBase.getproperties(obj::BSImpl.Type)
    @match obj begin
        BSImpl.Const(; val, hash, id) => (; val, hash, id)
        BSImpl.Sym(; name, metadata, hash, hash2, shape, type, id) => (; name, metadata, hash, hash2, shape, type, id)
        BSImpl.Term(; f, args, metadata, hash, hash2, shape, type, id) => (; f, args, metadata, hash, hash2, shape, type, id)
        BSImpl.AddMul(; coeff, dict, variant, metadata, shape, type, args, hash, hash2, id) => (; coeff, dict, variant, metadata, shape, type, args, hash, hash2, id)
        BSImpl.Div(; num, den, simplified, metadata, hash, hash2, shape, type, id) => (; num, den, simplified, metadata, hash, hash2, shape, type, id)
        BSImpl.ArrayOp(; output_idx, expr, reduce, term, ranges, metadata, shape, type, args, hash, hash2, id) => (; output_idx, expr, reduce, term, ranges, metadata, shape, type, args, hash, hash2, id)
        BSImpl.ArrayMaker(; regions, values, metadata, shape, type, args, hash, hash2, id) => (; regions, values, metadata, shape, type, args, hash, hash2, id)
    end
end

function ConstructionBase.setproperties(obj::BSImpl.Type{T}, patch::NamedTuple) where {T}
    Z = zero(UInt)
    p = patch
    newobj = @match obj begin
        BSImpl.Const(; val) =>
            BSImpl.Const{T}(get(p, :val, val), Z, nothing)
        BSImpl.Sym(; name, metadata, shape, type) =>
            BSImpl.Sym{T}(get(p, :name, name), get(p, :metadata, metadata),
                          get(p, :shape, shape), get(p, :type, type), Z, Z, nothing)
        BSImpl.Term(; f, args, metadata, shape, type) =>
            BSImpl.Term{T}(get(p, :f, f), get(p, :args, args), get(p, :metadata, metadata),
                           get(p, :shape, shape), get(p, :type, type), Z, Z, nothing)
        BSImpl.AddMul(; coeff, dict, variant, metadata, shape, type) =>
            BSImpl.AddMul{T}(get(p, :coeff, coeff), get(p, :dict, dict), get(p, :variant, variant),
                             get(p, :metadata, metadata), get(p, :shape, shape), get(p, :type, type),
                             ArgsT{T}(), Z, Z, nothing)
        BSImpl.Div(; num, den, simplified, metadata, shape, type) =>
            BSImpl.Div{T}(get(p, :num, num), get(p, :den, den), get(p, :simplified, simplified),
                          get(p, :metadata, metadata), get(p, :shape, shape), get(p, :type, type),
                          Z, Z, nothing)
        BSImpl.ArrayOp(; output_idx, expr, reduce, term, ranges, metadata, shape, type) =>
            BSImpl.ArrayOp{T}(get(p, :output_idx, output_idx), get(p, :expr, expr),
                              get(p, :reduce, reduce), get(p, :term, term), get(p, :ranges, ranges),
                              get(p, :metadata, metadata), get(p, :shape, shape), get(p, :type, type),
                              ArgsT{T}(), Z, Z, nothing)
        BSImpl.ArrayMaker(; regions, values, metadata, shape, type) =>
            BSImpl.ArrayMaker{T}(get(p, :regions, regions), get(p, :values, values),
                                 get(p, :metadata, metadata), get(p, :shape, shape),
                                 get(p, :type, type), ArgsT{T}(), Z, Z, nothing)
    end
    hashcons(newobj::BasicSymbolic{T})
end

"""
    $TYPEDSIGNATURES

Check if a value is a `Const` variant of `BasicSymbolic`.

# Arguments
- `x`: Value to check (for `BasicSymbolic` input returns true if `Const`, for others returns false)

# Returns
- `true` if `x` is a `BasicSymbolic` with `Const` variant, `false` otherwise
"""
isconst(x::BSImpl.Type) = MData.isa_variant(x, BSImpl.Const)

"""
    $TYPEDSIGNATURES

Check if a value is a `Sym` variant of `BasicSymbolic`.

# Arguments
- `x`: Value to check (for `BasicSymbolic` input returns true if `Sym`, for others returns false)

# Returns
- `true` if `x` is a `BasicSymbolic` with `Sym` variant, `false` otherwise
"""
issym(x::BSImpl.Type) = MData.isa_variant(x, BSImpl.Sym)

"""
    $TYPEDSIGNATURES

Check if a value is a `Term` variant of `BasicSymbolic`.

# Arguments
- `x`: Value to check (for `BasicSymbolic` input returns true if `Term`, for others returns false)

# Returns
- `true` if `x` is a `BasicSymbolic` with `Term` variant, `false` otherwise
"""
isterm(x::BSImpl.Type) = MData.isa_variant(x, BSImpl.Term)

"""
    $TYPEDSIGNATURES

Check if a value is an `AddMul` variant of `BasicSymbolic`.

# Arguments
- `x`: Value to check (for `BasicSymbolic` input returns true if `AddMul`, for others returns false)

# Returns
- `true` if `x` is a `BasicSymbolic` with `AddMul` variant, `false` otherwise
"""
isaddmul(x::BSImpl.Type) = MData.isa_variant(x, BSImpl.AddMul)

"""
    $TYPEDSIGNATURES

Check if a value is an addition (`AddMul` with ADD variant).

# Arguments
- `x`: Value to check (for `BasicSymbolic` input returns true if addition, for others returns false)

# Returns
- `true` if `x` is an `AddMul` with `ADD` variant, `false` otherwise
"""
isadd(x::BSImpl.Type) = isaddmul(x) && MData.variant_getfield(x, BSImpl.AddMul, :variant) == AddMulVariant.ADD

"""
    $TYPEDSIGNATURES

Check if a value is a multiplication (`AddMul` with MUL variant).

# Arguments
- `x`: Value to check (for `BasicSymbolic` input returns true if multiplication, for others returns false)

# Returns
- `true` if `x` is an `AddMul` with `MUL` variant, `false` otherwise
"""
ismul(x::BSImpl.Type) = isaddmul(x) && MData.variant_getfield(x, BSImpl.AddMul, :variant) == AddMulVariant.MUL

"""
    $TYPEDSIGNATURES

Check if a value is a `Div` variant of `BasicSymbolic`.

# Arguments
- `x`: Value to check (for `BasicSymbolic` input returns true if `Div`, for others returns false)

# Returns
- `true` if `x` is a `BasicSymbolic` with `Div` variant, `false` otherwise
"""
isdiv(x::BSImpl.Type) = MData.isa_variant(x, BSImpl.Div)

"""
    $TYPEDSIGNATURES

Check if a value is a power expression (`Term` with `^` operation).

# Arguments
- `x`: Value to check (for `BasicSymbolic` input returns true if power, for others returns false)

# Returns
- `true` if `x` is a `Term` with exponentiation operation, `false` otherwise

# Details
Power expressions are `Term` variants where the operation is `^` (6 uses).
"""
ispow(x::BSImpl.Type) = isterm(x) && operation(x) === (^)

"""
    $TYPEDSIGNATURES

Check if a value is an `ArrayOp` variant of `BasicSymbolic`.

# Arguments
- `x`: Value to check (for `BasicSymbolic` input returns true if `ArrayOp`, for others returns false).

# Returns
- `true` if `x` is a `BasicSymbolic` with `ArrayOp` variant, `false` otherwise.

# Details
Array operations represent vectorized computations created by the `@arrayop` macro.
"""
isarrayop(x::BSImpl.Type) = MData.isa_variant(x, BSImpl.ArrayOp)

"""
    $TYPEDSIGNATURES

Check if a value is an `ArrayMaker` variant of `BasicSymbolic`.

# Arguments
- `x`: Value to check (for `BasicSymbolic` input returns true if `ArrayMaker`, for others returns false).

# Returns
- `true` if `x` is a `BasicSymbolic` with `ArrayMaker` variant, `false` otherwise.
"""
isarraymaker(x::BSImpl.Type) = MData.isa_variant(x, BSImpl.ArrayMaker)

for fname in [:isconst, :issym, :isterm, :isaddmul, :isadd, :ismul, :isdiv, :ispow, :isarrayop, :isarraymaker]
    @eval $fname(x) = false
end

###
### Base interface
###

"""
    $TYPEDSIGNATURES

Return `one(symtype(s))`
"""
Base.one( s::BSImpl.Type) = one( symtype(s))
"""
    $TYPEDSIGNATURES

Return a `Const` symbolic wrapping `1`.
"""
Base.one(::Type{BSImpl.Type{T}}) where {T} = one_of_vartype(T)
Base.oneunit(::Type{BSImpl.Type{T}}) where {T} = one_of_vartype(T)
"""
    $TYPEDSIGNATURES

Return `zero(symtype(s))`
"""
Base.zero(s::BSImpl.Type) = zero(symtype(s))
"""
    $TYPEDSIGNATURES

Return a `Const` symbolic wrapping `0`.
"""
Base.zero(::Type{BSImpl.Type{T}}) where {T} = zero_of_vartype(T)

function _name_as_operator(x::BasicSymbolic)
    @match x begin
        BSImpl.Sym(; name) => name
        BSImpl.Term(; f) => _name_as_operator(f)
        _ => _name_as_operator(operation(x))
    end
end
_name_as_operator(x) = nameof(x)

"""
    Base.nameof(s::BasicSymbolic)

Return the name of a symbolic variable. Valid only if `issym(s)`.
"""
Base.nameof(s::BasicSymbolic) = issym(s) ? s.name : error("Non-Sym BasicSymbolic doesn't have a name")

Base.convert(::Type{B}, x) where {R, B <: BasicSymbolic{R}} = BSImpl.Const{R}(unwrap(x))
Base.convert(::Type{B}, x::B) where {R, B <: BasicSymbolic{R}} = x

Base.copy(x::BasicSymbolic) = x

###
### Utilities
###

"""
    $TYPEDSIGNATURES

Extract the numeric coefficient from a multiplication expression.

# Arguments
- `x`: A symbolic expression that must be a multiplication

# Returns
- The numeric coefficient of the multiplication

# Details
This function extracts the leading numeric coefficient from a multiplication expression.
For `Term` variants, it recursively searches for nested multiplications. For `AddMul`
variants with `MUL` operation, it returns the stored coefficient. Throws an error if
the input is not a multiplication expression.
"""
function get_mul_coefficient(x)
    iscall(x) && operation(x) === (*) || throw(ArgumentError(LazyString(x, " is not a multiplication")))
    @match x begin
        BSImpl.Term(; args) => begin
            if ismul(args[1])
                return get_mul_coefficient(args[1])
            else
                return 1
            end
        end
        BSImpl.AddMul(; coeff) => return coeff
    end
end

"""
    $(TYPEDSIGNATURES)

Return the numerator of expression `x` as an array of multiplied terms.
"""
@inline function numerators(x)
    isdiv(x) && return numerators(x.num)
    iscall(x) && operation(x) === (*) && return arguments(x)
    return SmallV{Any}((x,))
end

"""
    $(TYPEDSIGNATURES)

Return the denominator of expression `x` as an array of multiplied terms.
"""
@inline denominators(x) = isdiv(x) ? numerators(x.den) : SmallV{Any}((1,))

"""
    $TYPEDSIGNATURES

Extract the constant value from a `Const` variant, or return the input unchanged.

# Arguments
- `x`: Any value, potentially a `BasicSymbolic` with a `Const` variant

# Returns
- The wrapped constant value if `x` is a `Const` variant of `BasicSymbolic`
- The input `x` unchanged otherwise

# Details
This function unwraps constant symbolic expressions to their underlying values. It handles
all three symbolic variants (`SymReal`, `SafeReal`, `TreeReal`). For non-`Const` symbolic
expressions or non-symbolic values, returns the input unchanged.
"""
@inline function unwrap_const(x::Any)
    @nospecialize x
    if x isa BasicSymbolic{SymReal}
        @match x begin
            BSImpl.Const(; val) => val
            _ => x
        end
    elseif x isa BasicSymbolic{SafeReal}
        @match x begin
            BSImpl.Const(; val) => val
            _ => x
        end
    elseif x isa BasicSymbolic{TreeReal}
        @match x begin
            BSImpl.Const(; val) => val
            _ => x
        end
    else
        x
    end
end

"""
    term(f, args...; vartype = SymReal, type = promote_symtype(f, symtype.(args)...), shape = promote_shape(f, SymbolicUtils.shape.(args)...))

Create a symbolic term with operation `f` and arguments `args`.

# Arguments
- `f`: The operation or function head of the term
- `args...`: The arguments to the operation
- `vartype`: The variant type for the term (default: `SymReal`)
- `type`: The symbolic type of the term. If not provided, it is inferred using `promote_symtype` on the function and argument types.
- `shape`: The shape of the term. If not provided, it is inferred using `promote_shape` on the function and argument shapes.

# Examples
```julia-repl
julia> @syms x y
(x, y)

julia> term(+, x, y)
x + y

julia> term(sin, x)
sin(x)

julia> term(^, x, 2)
x^2
```
"""
function term(f, args...; vartype = SymReal, type = promote_symtype(f, symtype.(args)...), shape = promote_shape(f, SymbolicUtils.shape.(args)...))
    @nospecialize f
    Term{vartype}(f, args; type, shape)
end

###
### Metadata
###
metadata(s::BSImpl.Type) = isconst(s) ? nothing : s.metadata
metadata(s::BasicSymbolic, meta) = Setfield.@set! s.metadata = meta

"""
    hasmetadata(s::Symbolic, ctx)

Check if a symbolic expression has metadata for a given context.

# Arguments
- `s::Symbolic`: The symbolic expression to check
- `ctx`: The metadata context key (typically a DataType)

# Returns
- `true` if the expression has metadata for the given context, `false` otherwise

# Examples
```julia-repl
julia> @syms x
x

julia> hasmetadata(x, Float64)
false
```
"""
function hasmetadata(s::BasicSymbolic, ctx)
    metadata(s) isa AbstractDict && haskey(metadata(s), ctx)
end

"""
    getmetadata(s::Symbolic, ctx)

Retrieve metadata associated with a symbolic expression for a given context.

# Arguments
- `s::Symbolic`: The symbolic expression
- `ctx`: The metadata context key (typically a DataType)

# Returns
The metadata value associated with the given context

# Throws
- `ArgumentError` if the expression does not have metadata for the given context

# Examples
```julia-repl
julia> @syms x::Float64
x

julia> getmetadata(x, symtype)  # Get the type metadata
Float64
```
"""
function getmetadata(s::BasicSymbolic, ctx)
    md = metadata(s)
    if md isa AbstractDict
        md[ctx]
    else
        throw(ArgumentError(LazyString(s, " does not have metadata for ", ctx)))
    end
end

"""
    getmetadata(s::Symbolic, ctx, default)

Retrieve metadata associated with a symbolic expression for a given context,
returning a default value if not found.

# Arguments
- `s::Symbolic`: The symbolic expression
- `ctx`: The metadata context key (typically a DataType)
- `default`: The default value to return if metadata is not found

# Returns
The metadata value associated with the given context, or `default` if not found

# Examples
```julia-repl
julia> @syms x
x

julia> getmetadata(x, Float64, "no type")
"no type"
```
"""
function getmetadata(s::BasicSymbolic, @nospecialize(ctx), default)
    md = metadata(s)
    md === nothing && return default
    return get(md, ctx, default)
end

# pirated for Setfield purposes:
using Base: ImmutableDict
Base.ImmutableDict(d::ImmutableDict{K,V}, x, y)  where {K, V} = ImmutableDict{K,V}(d, x, y)

assocmeta(d::Dict, ctx, val) = (d=copy(d); d[ctx] = val; d)
function assocmeta(d::Base.ImmutableDict{DataType, Any}, @nospecialize(ctx::DataType), @nospecialize(val))::ImmutableDict{DataType,Any}
    val = unwrap(val)
    # optimizations
    # If using upto 3 contexts, things stay compact
    if isdefined(d, :parent)
        d.key === ctx && return @set d.value = val
        d1 = d.parent
        if isdefined(d1, :parent)
            d1.key === ctx && return @set d.parent.value = val
            d2 = d1.parent
            if isdefined(d2, :parent)
                d2.key === ctx && return @set d.parent.parent.value = val
            end
        end
    end
    Base.ImmutableDict{DataType, Any}(d, ctx, val)
end

"""
    setmetadata(s::Symbolic, ctx::DataType, val)

Set metadata for a symbolic expression in a given context.

# Arguments
- `s::Symbolic`: The symbolic expression
- `ctx::DataType`: The metadata context key
- `val`: The metadata value to set

# Returns
A new symbolic expression with the updated metadata

# Examples
```julia-repl
julia> @syms x
x

julia> x_with_meta = setmetadata(x, Float64, "custom value")
x

julia> getmetadata(x_with_meta, Float64)
"custom value"
```
"""
function setmetadata(s::BasicSymbolic, @nospecialize(ctx::DataType), @nospecialize(val))
    meta = metadata(s)
    if meta isa Base.ImmutableDict{DataType, Any}
        @set s.metadata = assocmeta(meta, ctx, val)
    else
        # fresh Dict
        @set s.metadata = Base.ImmutableDict{DataType, Any}(ctx, unwrap(val))
    end
end

###
### Symbolic function / type inference
###

"""
    $TYPEDSIGNATURES

The result of applying `f` to arguments of [`SymbolicUtils.symtype`](@ref) `Ts...`

```julia-repl
julia> promote_symtype(+, Real, Real)
Real

julia> promote_symtype(+, Complex, Real)
Number

julia> @syms f(x)::Complex
(f(::Number)::Complex,)

julia> promote_symtype(f, Number)
Complex
```

When constructing expressions without an explicit symtype,
`promote_symtype` is used to figure out the symtype of the Term.

It is recommended that all type arguments be annotated with [`SymbolicUtils.TypeT`](@ref)
and one method be implemented for any combination of `f` and the number of arguments. For
example, one method is implemented for unary `-` and one method for binary `-`. Each method
has an `if..elseif` chain to handle possible types. Any call to `promote_type` should be
typeasserted with `::TypeT`.
"""
promote_symtype(f, Ts...) = Any

"""
    promote_shape(f, shs::ShapeT...)

Infer the symbolic result shape for applying `f` to operands with shapes `shs`.

Packages that introduce symbolic operations may extend this function. Each method must
return a [`ShapeT`](@ref), use [`ShapeVecT`](@ref) for known axes, and use
[`Unknown`](@ref) when only the dimensionality is known. Implementations should
`@nospecialize` shape arguments unless dispatch requires a concrete shape type.

# Arguments

- `f`: operation or callable whose result shape is being inferred.
- `shs::ShapeT...`: symbolic operand shapes.

# Returns

- A [`ShapeT`](@ref) describing the result.

# Examples

```jldoctest
julia> using SymbolicUtils

julia> struct PreserveShape end

julia> SymbolicUtils.promote_shape(
           ::PreserveShape, sh::SymbolicUtils.ShapeT
       ) = sh

julia> SymbolicUtils.promote_shape(
           PreserveShape(), SymbolicUtils.ShapeVecT((1:4,))
       )
1-element SymbolicUtils.ShapeVecT:
 1:4
```
"""
promote_shape(f, szs::ShapeT...) = Unknown(-1)

#---------------------------
#---------------------------
#### Function-like variables
#---------------------------

struct FnType{X<:Tuple,Y,Z} end

function (f::BasicSymbolic{T})(args...) where {T}
    symtype(f) <: FnType || error("Sym $f is not callable. " *
          "Use @syms $f(var1, var2,...) to create it as a callable.")
    Term{T}(f, args; type = promote_symtype(f, symtype.(args)...), shape = f.shape, metadata = f.metadata)
end

fntype_X_Y(::Type{<: FnType{X, Y}}) where {X, Y} = (X, Y)

"""
    $TYPEDSIGNATURES

Get the return type of a `T <: FnType`.
"""
function fntype_ret_type(T::TypeT)
    @assert T <: FnType
    return T.parameters[2]::TypeT
end

function promote_shape(f::BasicSymbolic{T}, args::ShapeT...) where {T}
    @nospecialize args
    return shape(f)
end

"""
    $(TYPEDSIGNATURES)

Check if `x` is a symbolic representing a function (as opposed to a dependent variable).
A symbolic function either has a defined signature or the function type defined. For
example, all of the below are considered symbolic functions:

```julia
@syms f(::Real, ::Real) g(::Real)::Integer h(::Real)[1:2]::Integer (ff::MyCallableT)(..)
```

However, the following is considered a dependent variable with unspecified independent
variable:

```julia
@syms x(..)
```

See also: [`SymbolicUtils.is_function_symtype`](@ref).
"""
is_function_symbolic(x::BasicSymbolic) = is_function_symtype(symtype(x))
"""
    $(TYPEDSIGNATURES)

Check if the given `symtype` represents a function (as opposed to a dependent variable).

See also: [`SymbolicUtils.is_function_symbolic`](@ref).
"""
is_function_symtype(::Type{T}) where {T} = false
is_function_symtype(::Type{FnType{Tuple, Y, Nothing}}) where {Y} = false
is_function_symtype(::Type{FnType{X, Y, Z}}) where {X, Y, Z} = true
"""
    $(TYPEDSIGNATURES)

Check if the given symbolic `x` is the result of calling a symbolic function (as opposed
to a dependent variable).

See also: [`SymbolicUtils.is_function_symbolic`](@ref).
"""
function is_called_function_symbolic(x::BasicSymbolic{T}) where {T}
    @match x begin
        BSImpl.Term(; f) && if f isa BasicSymbolic{T} end => is_function_symbolic(f)
        _ => false
    end
end

"""
    promote_symtype(f::FnType{X,Y}, arg_symtypes...)

The output symtype of applying variable `f` to arguments of symtype `arg_symtypes...`.
if the arguments are of the wrong type then this function will error.
"""
function promote_symtype(f::BasicSymbolic, args...)
    T = symtype(f)
    X, Y = fntype_X_Y(T)

    if X === Tuple
        return Y
    end

    # This is to handle `Tuple{T} where T`, so we cannot reliably query the type
    # parameters of the `Tuple` in `FnType`.
    t = Tuple{args...}
    if !(t <: X)
        error(LazyString(t, " is not a subtype of ", X, "."))
    end
    return Y
end

@inline isassociative(op) = op === (+) || op === (*)

function _promote_symtype(@nospecialize(f), @nospecialize(args))
    if issym(f)
        promote_symtype(f, map(symtype, args)...)
    else
        if length(args) == 0
            promote_symtype(f)
        elseif length(args) == 1
            promote_symtype(f, symtype(args[1]))
        elseif length(args) == 2
            promote_symtype(f, symtype(args[1]), symtype(args[2]))
        elseif isassociative(f)
            mapfoldl(symtype, (x,y) -> promote_symtype(f, x, y), args)
        else
            promote_symtype(f, map(symtype, args)...)
        end
    end
end

"""
    $TYPEDSIGNATURES

Convert various metadata inputs into standardized `ImmutableDict` format.

# Arguments
- `x`: Metadata input (can be `MetadataT`, `Nothing`, or an iterable of key-value pairs)

# Returns
- `Nothing` if input is `Nothing`
- The input unchanged if already in `MetadataT` format
- A new `ImmutableDict{DataType, Any}` constructed from the key-value pairs otherwise
"""
parse_metadata(x::MetadataT) = x
parse_metadata(::Nothing) = nothing
function parse_metadata(x)
    meta = Base.ImmutableDict{DataType, Any}()
    for kvp in x
        meta = Base.ImmutableDict(meta, kvp)
    end
    return meta
end

default_shape(::Type{T}) where {E, N, T <: AbstractArray{E, N}} = Unknown(N)
default_shape(::Type{T}) where {T <: AbstractArray} = Unknown(-1)
default_shape(_) = ShapeVecT()

"""
    $TYPEDSIGNATURES

Convert argument tuples or vectors into standardized `ArgsT` format for a variant type.

# Arguments
- `T`: The `SymVariant` type (`SymReal`, `SafeReal`, or `TreeReal`)
- `args`: Tuple or vector of arguments to convert

# Returns
- An `ArgsT{T}` containing the arguments, with non-`BasicSymbolic` values wrapped in `Const{T}`

# Details
This function normalizes arguments for symbolic operations. If arguments are already in
`ArgsT{T}` format, returns them unchanged. For `ROArgsT{T}`, extracts the parent. Otherwise,
creates a new `ArgsT{T}` and wraps each non-symbolic argument in a `Const{T}` variant. This
ensures all arguments to symbolic operations are properly typed `BasicSymbolic` objects.
"""
function parse_args(::Type{T}, args::Union{Tuple, AbstractVector}) where {T <: SymVariant}
    args isa ROArgsT{T} && return parent(args)::ArgsT{T}
    args isa ArgsT{T} && return args
    _args = ArgsT{T}()
    sizehint!(_args, length(args))
    for arg in args
        push!(_args, Const{T}(arg))
    end
    return _args::ArgsT{T}
end

"""
    $TYPEDSIGNATURES

Unwrap arguments if any need unwrapping, otherwise return them unchanged.

# Arguments
- `args`: Arguments to potentially unwrap (can be `ArgsT`, `ROArgsT`, or other collections)

# Returns
- The original `args` if already in `ArgsT` or `ROArgsT` format
- The original `args` if no element needs unwrapping
- A new collection with all elements unwrapped otherwise

# Details
This function optimizes argument unwrapping by checking first if any element needs unwrapping.
If none do, it returns the original collection to avoid unnecessary allocations. For `ArgsT`
and `ROArgsT` types, which are already in normalized form, always returns the input unchanged.
Used in constructor functions to ensure arguments are in their simplest form.
"""
function unwrap_args(args)
    if any(x -> unwrap(x) !== x, args)
        map(unwrap, args)
    else
        args
    end
end
unwrap_args(args::ArgsT) = args
unwrap_args(args::ROArgsT) = args

"""
    $TYPEDSIGNATURES

Convert a dictionary into standardized `ACDict{T}` format for `AddMul`.

# Arguments
- `::Type{T}`: The `SymVariant` type (`SymReal`, `SafeReal`, or `TreeReal`)
- `dict::AbstractDict`: Dictionary to convert

# Returns
- The input if already in `ACDict{T}` format
- A new `ACDict{T}` populated with all key-value pairs otherwise
"""
function parse_dict(::Type{T}, dict::AbstractDict) where {T}
    dict isa ACDict{T} && return dict
    _dict = ACDict{T}()
    for (k, v) in dict
        _dict[k] = v
    end
    return _dict::ACDict{T}
end

"""
    $TYPEDSIGNATURES

Unwrap dictionary keys if any need unwrapping, preserving values unchanged.

# Arguments
- `dict`: A dictionary whose keys might need unwrapping

# Returns
- The original dictionary if no key needs unwrapping
- A new dictionary of the same type with unwrapped keys otherwise

# Details
This function optimizes dictionary key unwrapping by checking first if any key needs
unwrapping. If none do, returns the original dictionary to avoid allocations. Otherwise,
creates a new dictionary of the same type with all keys unwrapped but values preserved.
Used to normalize dictionaries used in symbolic expressions where keys might be wrapped
symbolic values.
"""
function unwrap_dict(dict)
    if any(x -> unwrap(x) !== x, keys(dict))
        typeof(dict)(unwrap(k) => v for (k, v) in dict)
    else
        dict
    end
end
unwrap_dict(dict::OrderedDict{<:BasicSymbolic}) = dict

"""
    $TYPEDSIGNATURES

Convert output indices into standardized `OutIdxT{T}` format for `ArrayOp` variants.

# Arguments
- `::Type{T}`: The `SymVariant` type (`SymReal`, `SafeReal`, or `TreeReal`)
- `outidxs`: Tuple or vector of output indices

# Returns
- The input if already in `OutIdxT{T}` format
- A new `OutIdxT{T}` with all indices unwrapped to their constant values otherwise
"""
function parse_output_idxs(::Type{T}, outidxs::Union{Tuple, AbstractVector}) where {T}
    outidxs isa OutIdxT{T} && return outidxs
    _outidxs = OutIdxT{T}()
    sizehint!(_outidxs, length(outidxs))
    for i in outidxs
        push!(_outidxs, unwrap_const(unwrap(i)))
    end
    return _outidxs::OutIdxT{T}
end

"""
    $TYPEDSIGNATURES

Normalize shape inputs into either `Unknown` or `ShapeVecT` format.

# Arguments
- `sh`: Shape input (can be `Unknown`, `ShapeVecT`, or an iterable of ranges)

# Returns
- The input if already `Unknown` or `ShapeVecT`
- A new `ShapeVecT` constructed from the iterable otherwise
"""
function parse_shape(sh)
    sh isa Unknown && return sh
    sh isa ShapeVecT && return sh
    _sh = ShapeVecT()
    for dim in sh
        push!(_sh, dim)
    end
    return _sh
end

"""
    $TYPEDSIGNATURES

Convert a dictionary of ranges into standardized `RangesT{T}` format for `ArrayOp`.

# Arguments
- `::Type{T}`: The `SymVariant` type (`SymReal`, `SafeReal`, or `TreeReal`)
- `dict::AbstractDict`: Dictionary mapping index variables to ranges

# Returns
- The input if already in `RangesT{T}` format
- A new `RangesT{T}` with all keys and values unwrapped otherwise
"""
function parse_rangedict(::Type{T}, dict::AbstractDict) where {T}
    dict isa RangesT{T} && return dict
    _dict = RangesT{T}()
    for (k, v) in dict
        _dict[unwrap_const(unwrap(k))] = unwrap_const(unwrap(v))
    end
    return _dict::RangesT{T}
end

"""
    $TYPEDSIGNATURES

Check if an object is or contains symbolic expressions.

# Arguments
- `O`: Any object to check

# Returns
- `Bool`: `true` if `O` is a symbolic, code primitive, array of symbolics, or tuple of symbolics
"""
function _is_tuple_or_array_of_symbolics(O)
    return O isa Code.CodegenPrimitive ||
        (symbolic_type(O) != NotSymbolic() && !(O isa Union{Symbol, Expr})) ||
        _is_array_of_symbolics(O) ||
        _is_tuple_of_symbolics(O)
end

"""
    $TYPEDSIGNATURES

Check if an object is a non-symbolic array containing symbolic elements.
"""
function _is_array_of_symbolics(O)
    # O is an array, not a symbolic array, and either has a non-symbolic eltype or contains elements that are
    # symbolic or arrays of symbolics
    return O isa AbstractArray && symbolic_type(O) == NotSymbolic() &&
        (symbolic_type(eltype(O)) != NotSymbolic() && !(eltype(O) <: Union{Symbol, Expr}) ||
        any(_is_tuple_or_array_of_symbolics, O))
end

# workaround for https://github.com/JuliaSparse/SparseArrays.jl/issues/599
function _is_array_of_symbolics(O::SparseMatrixCSC)
    return symbolic_type(eltype(O)) != NotSymbolic() && !(eltype(O) <: Union{Symbol, Expr}) ||
        any(_is_tuple_or_array_of_symbolics, findnz(O)[3])
end

"""
    $TYPEDSIGNATURES

Check if a tuple contains symbolic elements.
"""
function _is_tuple_of_symbolics(O::Tuple)
    return any(_is_tuple_or_array_of_symbolics, O)
end
_is_tuple_of_symbolics(O) = false

"""
    $TYPEDSIGNATURES

Utility function used as the operation of expressions representing an array of symbolic values.
See [`SymbolicUtils.BSImpl.Const`](@ref) for more details.

The first argument `sz` is the `size` of the represented array. `args...` is `prod(sz)`
elements representing the elements of the array in column-major order.
"""
array_literal(sz::NTuple{N, Int}, args...) where {N} = reshape(Base.vect(args...), sz)

"""
    BSImpl.Const{T}(val) where {T}

Constructor for a symbolic expression that wraps a constant value `val`. Also converts
arrays/tuples of symbolics to symbolic expressions.

# Arguments
- `val`: The value to wrap (can be any type including arrays and tuples)

# Returns
- `BasicSymbolic{T}`: A `Const` variant or specialized representation

# Details
This is the low-level constructor for constant expressions. It handles several special cases:
1. If `val` is already a `BasicSymbolic{T}`, returns it unchanged
2. If `val` is a `BasicSymbolic` of a different variant type, throws an error
3. If `val` is an array containing symbolic elements, creates a `Term` with
   [`SymbolicUtils.array_literal`](@ref) operation
4. If `val` is a tuple containing symbolic elements, creates a `Term` with `tuple` operation
5. Otherwise, creates a `Const` variant wrapping the value

# Extended help

The `unsafe` flag skips hash consing for performance in internal operations.
"""
@inline function BSImpl.Const{T}(val; unsafe = false) where {T}
    @nospecialize val
    val = unwrap(val)
    if val isa BasicSymbolic{T}
        return val
    elseif val isa BasicSymbolic{SymReal}
        error(LazyString("Cannot construct `BasicSymbolic{", T, "}` from `BasicSymbolic{SymReal}`."))
    elseif val isa BasicSymbolic{SafeReal}
        error(LazyString("Cannot construct `BasicSymbolic{", T, "}` from `BasicSymbolic{SymReal}`."))
    elseif val isa BasicSymbolic{TreeReal}
        error(LazyString("Cannot construct `BasicSymbolic{", T, "}` from `BasicSymbolic{TreeReal}`."))
    elseif val isa AbstractArray && _is_array_of_symbolics(val)
        isadjoint = val isa LinearAlgebra.Adjoint
        istranspose = val isa LinearAlgebra.Transpose
        if isadjoint || istranspose
            val = parent(val)
        end
        args = ArgsT{T}((BSImpl.Const{T}(size(val); unsafe),))
        sizehint!(args, length(val) + 1)
        type = Union{}
        for v in val
            push!(args, BSImpl.Const{T}(v))
            type = promote_type(type, symtype(v))
        end
        shape = ShapeVecT(axes(val))
        type = Array{type, ndims(val)}
        term = BSImpl.Term{T}(array_literal, args; type, shape, unsafe)
        if isadjoint
            type = promote_symtype(adjoint, type)
            shape = promote_shape(adjoint, shape)
            term = BSImpl.Term{T}(adjoint, ArgsT{T}((term,)); type, shape, unsafe)
        elseif istranspose
            type = promote_symtype(transpose, type)
            shape = promote_shape(transpose, shape)
            term = BSImpl.Term{T}(transpose, ArgsT{T}((term,)); type, shape, unsafe)
        end
        return term
    elseif val isa Tuple && _is_tuple_of_symbolics(val)
        args = ArgsT{T}()
        sizehint!(args, length(val))
        for v in val
            push!(args, BSImpl.Const{T}(v))
        end
        types = symtype.(val)
        type = Tuple{types...}
        shape = ShapeVecT((1:length(val),))
        return BSImpl.Term{T}(tuple, args; type, shape, unsafe)
    else
        props = ordered_override_properties(BSImpl.Const)
        var = BSImpl.Const{T}(val, props...)
        if !unsafe
            var = hashcons(var)
        end
        return var
    end
end

"""
    BSImpl.Sym{T}(name::Symbol; metadata = nothing, type, shape = default_shape(type)) where {T}

Internal constructor for symbolic variables.

# Arguments
- `name::Symbol`: The name of the symbolic variable
- `metadata`: Optional metadata dictionary (default: `nothing`)
- `type`: The symbolic type of the variable (required keyword argument)
- `shape`: The shape of the variable (default: inferred from `type`)

# Returns
- `BasicSymbolic{T}`: A `Sym` variant representing the symbolic variable

# Details
This is the low-level constructor for symbolic variables. It normalizes the metadata
and shape inputs, populates default properties using `ordered_override_properties`,
and performs hash consing. The `type` parameter determines the Julia type
that this symbolic variable represents.

# Extended help

The `unsafe` keyword argument (default: `false`) can be used to skip hash consing for
performance in internal operations.
"""
@inline function BSImpl.Sym{T}(name::Symbol; metadata = nothing, type, shape = default_shape(type), unsafe = false) where {T}
    metadata = parse_metadata(metadata)
    shape = parse_shape(shape)
    props = ordered_override_properties(BSImpl.Sym)
    var = BSImpl.Sym{T}(name, metadata, shape, type, props...)
    if !unsafe
        var = hashcons(var)
    end
    return var
end

"""
    BSImpl.Term{T}(f, args; metadata = nothing, type, shape = default_shape(type)) where {T}

Internal constructor for function application terms.

# Arguments
- `f`: The function or operation to apply
- `args`: The arguments to the function (normalized to `ArgsT{T}`)
- `metadata`: Optional metadata dictionary (default: `nothing`)
- `type`: The result type of the function application (required keyword argument)
- `shape`: The shape of the result (default: inferred from `type`)

# Returns
- `BasicSymbolic{T}`: A `Term` variant representing the function application

# Details
This is the low-level constructor for function application expressions. It represents
`f(args...)` symbolically. The constructor normalizes metadata, shape, and arguments,
populates default properties, and performs hash consing. The `type` parameter
should be the expected return type of calling `f` with `args`.

# Extended help

The `unsafe` keyword argument (default: `false`) can be used to skip hash consing for
performance in internal operations.
"""
@inline function BSImpl.Term{T}(@nospecialize(f), args; metadata = nothing, type, shape = default_shape(type), unsafe = false) where {T}
    metadata = parse_metadata(metadata)
    shape = parse_shape(shape)
    args = parse_args(T, args)
    props = ordered_override_properties(BSImpl.Term)
    var = BSImpl.Term{T}(f, args, metadata, shape, type, props...)
    if !unsafe
        var = hashcons(var)
    end
    return var
end

"""
    BSImpl.AddMul{T}(coeff, dict, variant::AddMulVariant.T; metadata = nothing, type, shape = default_shape(type)) where {T}

Internal constructor for addition and multiplication expressions.

# Arguments
- `coeff`: The leading coefficient (for addition) or coefficient (for multiplication)
- `dict`: Dictionary mapping terms to their coefficients/exponents (normalized to `ACDict{T}`)
- `variant::AddMulVariant.T`: Either `AddMulVariant.ADD` or `AddMulVariant.MUL`
- `metadata`: Optional metadata dictionary (default: `nothing`)
- `type`: The result type of the operation (required keyword argument)
- `shape`: The shape of the result (default: inferred from `type`)

# Returns
- `BasicSymbolic{T}`: An `AddMul` variant representing the sum or product

# Details
This is the low-level constructor for optimized addition and multiplication expressions.
For addition, represents `coeff + sum(k * v for (k, v) in dict)`. For multiplication,
represents `coeff * prod(k ^ v for (k, v) in dict)`. The constructor normalizes all
inputs and performs hash consing.

# Extended help

The `unsafe` keyword argument (default: `false`) can be used to skip hash consing for
performance in internal operations.
"""
@inline function BSImpl.AddMul{T}(coeff, dict, variant::AddMulVariant.T; metadata = nothing, type, shape = default_shape(type), unsafe = false) where {T}
    @nospecialize coeff
    metadata = parse_metadata(metadata)
    shape = parse_shape(shape)
    dict = parse_dict(T, dict)
    props = ordered_override_properties(BSImpl.AddMul{T})
    var = BSImpl.AddMul{T}(coeff, dict, variant, metadata, shape, type, props...)
    if !unsafe
        var = hashcons(var)
    end
    return var
end

"""
    BSImpl.Div{T}(num, den, simplified::Bool; metadata = nothing, type, shape = default_shape(type)) where {T}

Internal constructor for division expressions.

# Arguments
- `num`: The numerator (converted to `Const{T}`)
- `den`: The denominator (converted to `Const{T}`)
- `simplified::Bool`: Whether the division has been simplified
- `metadata`: Optional metadata dictionary (default: `nothing`)
- `type`: The result type of the division (required keyword argument)
- `shape`: The shape of the result (default: inferred from `type`)

# Returns
- `BasicSymbolic{T}`: A `Div` variant representing the division

# Details
This is the low-level constructor for division expressions. It represents `num / den`
symbolically. Both numerator and denominator are automatically wrapped in `Const{T}`
if not already symbolic. The `simplified` flag tracks whether simplification has been
attempted. The constructor normalizes all inputs and performs hash consing.

# Extended help

The `unsafe` keyword argument (default: `false`) can be used to skip hash consing for
performance in internal operations.
"""
@inline function BSImpl.Div{T}(num, den, simplified::Bool; metadata = nothing, type, shape = default_shape(type), unsafe = false) where {T}
    metadata = parse_metadata(metadata)
    shape = parse_shape(shape)
    num = Const{T}(num)
    den = Const{T}(den)
    props = ordered_override_properties(BSImpl.Div)
    var = BSImpl.Div{T}(num, den, simplified, metadata, shape, type, props...)
    if !unsafe
        var = hashcons(var)
    end
    return var
end

const DEFAULT_RANGES_SYMREAL = RangesT{SymReal}()
const DEFAULT_RANGES_SAFEREAL = RangesT{SafeReal}()
const DEFAULT_RANGES_TREEREAL = RangesT{TreeReal}()

default_ranges(::Type{SymReal}) = DEFAULT_RANGES_SYMREAL
default_ranges(::Type{SafeReal}) = DEFAULT_RANGES_SAFEREAL
default_ranges(::Type{TreeReal}) = DEFAULT_RANGES_TREEREAL

"""
    BSImpl.ArrayOp{T}(output_idx, expr::BasicSymbolic{T}, reduce, term, ranges = default_ranges(T); metadata = nothing, type, shape = default_shape(type)) where {T}

Internal constructor for array operation expressions.

# Arguments
- `output_idx`: Output indices defining the result array dimensions (normalized to `OutIdxT{T}`)
- `expr::BasicSymbolic{T}`: The expression to evaluate for each index combination
- `reduce`: Reduction operation to apply (or `nothing` for direct assignment)
- `term`: Optional term for accumulation (or `nothing`)
- `ranges`: Dictionary mapping index variables to their ranges (default: empty)
- `metadata`: Optional metadata dictionary (default: `nothing`)
- `type`: The result type (required keyword argument, typically an array type)
- `shape`: The shape of the result (default: inferred from `type`)

# Returns
- `BasicSymbolic{T}`: An `ArrayOp` variant representing the array operation

# Details
This is the low-level constructor for array comprehension-like operations. It represents
operations like `[expr for i in range1, j in range2]` with optional reduction. The
constructor normalizes all inputs, unwraps constants where appropriate, and optionally
performs hash consing.

The [`ArrayOp`](@ref) constructor should be strongly preferred.

# Extended help

The `unsafe` keyword argument (default: `false`) can be used to skip hash consing for
performance in internal operations.
"""
@inline function BSImpl.ArrayOp{T}(output_idx, expr::BasicSymbolic{T}, reduce, term, ranges = default_ranges(T); metadata = nothing, type, shape = default_shape(type), unsafe = false) where {T}
    metadata = parse_metadata(metadata)
    shape = parse_shape(shape)
    output_idx = parse_output_idxs(T, output_idx)
    term = unwrap_const(unwrap(term))
    ranges = parse_rangedict(T, ranges)
    props = ordered_override_properties(BSImpl.ArrayOp{T})
    var = BSImpl.ArrayOp{T}(output_idx, expr, reduce, term, ranges, metadata, shape, type, props...)
    if !unsafe
        var = hashcons(var)
    end
    return var
end

function parse_regions(args::Union{Tuple, AbstractVector})
    args isa RegionsT && return args
    _args = RegionsT()
    sizehint!(_args, length(args))
    for arg in args
        push!(_args, parse_shape(arg))
    end
    return _args
end

"""
    BSImpl.ArrayMaker{T}(regions, values; metadata = nothing, type, shape = default_shape(type)) where {T}

Internal constructor for array maker expressions.

# Arguments
- `regions`: List of subarray regions the `ArrayMaker` is composed of
- `values`: Values for each region in `regions`
- `metadata`: Optional metadata dictionary (default: `nothing`)
- `type`: The result type (required keyword argument, typically an array type)
- `shape`: The shape of the result (default: inferred from `type`)

# Returns
- `BasicSymbolic{T}`: An `ArrayMaker` variant representing the array operation

# Extended help

The `unsafe` keyword argument (default: `false`) can be used to skip hash consing for
performance in internal operations.
"""
@inline function BSImpl.ArrayMaker{T}(regions, values; metadata = nothing, type, shape = default_shape(type), unsafe = false) where {T}
    metadata = parse_metadata(metadata)
    shape = parse_shape(shape)
    values = parse_args(T, values)
    regions = parse_regions(regions)
    props = ordered_override_properties(BSImpl.ArrayMaker{T})
    @assert type <: AbstractArray
    @assert is_array_shape(shape)
    var = BSImpl.ArrayMaker{T}(regions, values, metadata, shape, type, props...)
    if !unsafe
        var = hashcons(var)
    end
    return var
end

using SymbolicUtils, Test
using SymbolicUtils: Term, symtype
using BenchmarkTools

function goldstein_price()
    @syms x1 x2
    f1 = x1+x2+1
    f2 = 19-14*x1+3*x1^2-14*x2+6*x1*x2+3*x2^2
    f3 = 2*x1-3*x2
    f4 = 18-32*x1+12*x1^2+48*x2-36*x1*x2+27*x2^2

    # f(x) is the Goldstein-Price function
    f = (1+f1^2*f2)*(30+f3^2*f4)
    @btime expand($f)
    f2 = f^2
    @btime expand($f2)
    f3 = f^3
    @btime expand($f3)
end

using Test
using SymbolicUtils
using SymbolicUtils: BasicSymbolic, vartype, shape, onepoly
using SymbolicIndexingInterface
using LinearAlgebra

@testset "vartype function" begin
    @syms x::Real
    @test vartype(x) == SymbolicUtils.SymReal
    @test vartype(BasicSymbolic{SymbolicUtils.SymReal}) == SymbolicUtils.SymReal
end

@testset "onepoly function" begin
    result = onepoly()
    @test result isa SymbolicUtils.PolynomialT
    @test isone(result)
end

@testset "operation()/arguments() error cases" begin
    @syms x::Real

    const_val = SymbolicUtils.Const{SymbolicUtils.SymReal}(5)
    @test_throws ArgumentError SymbolicUtils.TermInterface.operation(const_val)
    @test_throws ArgumentError SymbolicUtils.TermInterface.operation(x)
    @test_throws ArgumentError SymbolicUtils.TermInterface.arguments(const_val)
    @test_throws ArgumentError SymbolicUtils.TermInterface.arguments(x)
end

@testset "SymbolicIndexingInterface functions" begin
    @syms x::Real y::Real

    @syms A[1:3]::Real
    @test symbolic_type(A) == ArraySymbolic()

    @test symbolic_type(BasicSymbolic) == ScalarSymbolic()
    @test symbolic_type(BasicSymbolic{SymbolicUtils.SymReal}) == ScalarSymbolic()

    # Test getname with getindex term
    expr = A[1]
    @test getname(expr) == :A

    # Test getname with symbolic function
    @syms f(t)::Real
    @test getname(f) == :f

    # Test hasname on Sym
    @test hasname(x) == true

    # Test hasname on getindex
    @test hasname(A[1]) == true

    # Test hasname on non-named expression
    @test hasname(x + y) == false
end

@testset "shape for non-symbolic values" begin
    # Test shape on Colon
    @test shape(:) == SymbolicUtils.ShapeVecT((1:0,))

    # Test shape on Number
    @test shape(5) == SymbolicUtils.ShapeVecT()
    @test shape(3.14) == SymbolicUtils.ShapeVecT()

    # Test shape on Array
    arr = [1, 2, 3]
    s = shape(arr)
    @test s == SymbolicUtils.ShapeVecT((1:3,))

    # Test shape on Matrix
    mat = [1 2; 3 4]
    s = shape(mat)
    @test s == SymbolicUtils.ShapeVecT((1:2, 1:2))

    # Test shape on UniformScaling
    @test shape(LinearAlgebra.I) isa SymbolicUtils.Unknown
end

@testset "is* functions on non-BasicSymbolic" begin
    # Test that isconst, issym, etc. return false for non-BasicSymbolic
    @test SymbolicUtils.isconst(5) == false
    @test SymbolicUtils.issym("test") == false
    @test SymbolicUtils.isterm(3.14) == false
end

@testset "isequal with Number/Array/Missing" begin
    @syms x::Real
    # Test isequal with Number
    @test isequal(x, 5) == false
    @test isequal(5, x) == false
    @test isequal(SymbolicUtils.Const{SymReal}(5), 5) == false
    @test isequal(5, SymbolicUtils.Const{SymReal}(5)) == false

    # Test isequal with Array
    @test isequal(x, [1, 2, 3]) == false
    @test isequal([1, 2, 3], x) == false
    @test isequal(SymbolicUtils.Const{SymReal}([1, 2, 3]), [1, 2, 3]) == false
    @test isequal([1, 2, 3], SymbolicUtils.Const{SymReal}([1, 2, 3])) == false

    # Test isequal with Missing
    @test isequal(x, missing) == false
    @test isequal(missing, x) == false
end

@testset "defaultval and one_of_vartype for all vartypes" begin
    # Test defaultval for SafeReal and TreeReal
    @test SymbolicUtils.defaultval(BasicSymbolic{SafeReal}) isa BasicSymbolic{SafeReal}
    @test SymbolicUtils.defaultval(BasicSymbolic{TreeReal}) isa BasicSymbolic{TreeReal}
    @test SymbolicUtils._iszero(SymbolicUtils.defaultval(BasicSymbolic{SafeReal}))
    @test SymbolicUtils._iszero(SymbolicUtils.defaultval(BasicSymbolic{TreeReal}))

    # Test zero_of_vartype for SafeReal and TreeReal
    @test SymbolicUtils.zero_of_vartype(SafeReal) isa BasicSymbolic{SafeReal}
    @test SymbolicUtils.zero_of_vartype(TreeReal) isa BasicSymbolic{TreeReal}
    @test SymbolicUtils._iszero(SymbolicUtils.zero_of_vartype(SafeReal))
    @test SymbolicUtils._iszero(SymbolicUtils.zero_of_vartype(TreeReal))

    # Test one_of_vartype for TreeReal
    @test SymbolicUtils.one_of_vartype(SafeReal) isa BasicSymbolic{SafeReal}
    @test SymbolicUtils.one_of_vartype(TreeReal) isa BasicSymbolic{TreeReal}
    @test SymbolicUtils._isone(SymbolicUtils.one_of_vartype(SafeReal))
    @test SymbolicUtils._isone(SymbolicUtils.one_of_vartype(TreeReal))
end

@testset "get_mul_coefficient" begin
    @syms x::Real y::Real
    # Test get_mul_coefficient with nested multiplication
    expr = 2 * x * y
    coeff = SymbolicUtils.get_mul_coefficient(expr)
    @test coeff == 2

    # Test error for non-multiplication
    @test_throws ArgumentError SymbolicUtils.get_mul_coefficient(x + y)
end

@testset "parse_metadata with iterable" begin
    # Test parse_metadata with key-value pairs
    meta_pairs = [Int => 1, String => "test"]
    result = SymbolicUtils.parse_metadata(meta_pairs)
    @test result isa Base.ImmutableDict

    # Test parse_metadata with nothing
    @test SymbolicUtils.parse_metadata(nothing) === nothing
end

@testset "default_shape for AbstractArray" begin
    # Test default_shape for AbstractArray without N parameter
    @test SymbolicUtils.default_shape(AbstractArray{Int}) isa SymbolicUtils.Unknown
end

@testset "parse_shape with iterable" begin
    # Test parse_shape with iterable
    ranges = [(1:3), (1:4)]
    result = SymbolicUtils.parse_shape(ranges)
    @test result isa SymbolicUtils.ShapeVecT
    @test result == SymbolicUtils.ShapeVecT((1:3, 1:4))
end

@testset "Const construction errors" begin
    @syms x::Real
    # Test error when constructing Const with wrong variant type
    @test_throws ErrorException SymbolicUtils.BSImpl.Const{SafeReal}(x)
end

@testset "ratcoeff function" begin
    @syms x::Real
    # Test ratcoeff with multiplication
    expr = 3 * x
    has_rat, coeff = SymbolicUtils.ratcoeff(expr)
    @test has_rat == true
    @test coeff == 3

    # Test ratcoeff with integer
    has_rat, coeff = SymbolicUtils.ratcoeff(5)
    @test has_rat == true
    @test coeff == 5

    # Test ratcoeff with rational
    has_rat, coeff = SymbolicUtils.ratcoeff(3//2)
    @test has_rat == true
    @test coeff == 3//2

    # Test ratcoeff with non-rational
    has_rat, coeff = SymbolicUtils.ratcoeff(3.5)
    @test has_rat == false
end

@testset "safe_div function" begin
    # Test safe_div with integers
    result = SymbolicUtils.safe_div(6, 3)
    @test result == 2//1

    # Test safe_div with floats
    result = SymbolicUtils.safe_div(6.0, 3.0)
    @test result == 2.0
end

@testset "Division operations" begin
    @syms x::Real y::Real

    # Test basic division (covers lines in division code)
    expr = x / y
    @test expr isa BasicSymbolic
    @test SymbolicUtils.isdiv(expr)

    # Test division by one
    expr3 = x / 1
    @test !SymbolicUtils.isdiv(expr3)
end

@testset "Power operations" begin
    @syms x::Real y::Real

    # Test matrix power
    @syms A[1:2,1:2]::Real
    expr = 3x * A
    expr2 = expr ^ 2
    @test SymbolicUtils.isterm(expr2)
    @test operation(expr2) === (*)
    args = arguments(expr2)
    @test isequal(args[1], (3x) ^ 2)
    @test isequal(args[2], A ^ 2)
end

@testset "Array operations with symbolics" begin
    @syms x::Real y::Real

    # Test array of symbolics
    arr = [x, y, x+y]
    const_arr = SymbolicUtils.Const{SymbolicUtils.SymReal}(arr)
    @test operation(const_arr) === SymbolicUtils.array_literal
    args = arguments(const_arr)
    @test unwrap_const(args[1]) == (3,)
    @test length(args) == 4

    # Test tuple of symbolics
    tup = (x, y)
    const_tup = SymbolicUtils.Const{SymbolicUtils.SymReal}(tup)
    @test operation(const_tup) === tuple
    @test length(arguments(const_tup)) == 2
end

@testset "WeakRef isequal" begin
    @syms x::Real y::Real
    # Test isequal with WeakRef
    wr = WeakRef(x)
    @test isequal(x, wr) == isequal(x, x)
    @test isequal(wr, x) == isequal(x, x)
end

@testset "parse_dict" begin
    @syms x::Real y::Real
    # Test parse_dict
    dict = Base.ImmutableDict(x => 1, y => 2)
    result = SymbolicUtils.parse_dict(SymbolicUtils.SymReal, dict)
    @test result isa SymbolicUtils.ACDict{SymbolicUtils.SymReal}
    @test isequal(result, dict)
end

@testset "parse_rangedict" begin
    @syms x::Real i::Int
    # Test parse_rangedict
    dict = Base.ImmutableDict(i => 1:5)
    result = SymbolicUtils.parse_rangedict(SymbolicUtils.SymReal, dict)
    @test result isa SymbolicUtils.RangesT{SymbolicUtils.SymReal}
end

@testset "Base.one and Base.zero on Type" begin
    # Test Base.one and Base.zero on Type
    @test Base.one(BasicSymbolic{SymReal}) === SymbolicUtils.one_of_vartype(SymReal)
    @test Base.zero(BasicSymbolic{SymReal}) === SymbolicUtils.zero_of_vartype(SymReal)
end

@testset "Backslash division operator \\" begin
    @syms x::Real
    @test isequal(x \ 2, 2 / x)
end

@testset "Operations with irrational numbers" begin
    @syms x::Real
    # Test operations with AbstractIrrational
    expr = x + π
    idpi = SymbolicUtils.Term{SymReal}(identity, [pi]; type = Real, shape = [])
    @test expr.dict[idpi] == 1

    expr2 = x * π
    @test expr.dict[idpi] == 1
end

@testset "Matrix and array powers" begin
    @syms x::Real
    # Test power with matrix const
    mat = [1 0; 0 1]
    result = mat ^ x
    @test isequal(unwrap_const(result), mat)

    # Test symbolic matrix power
    @syms A[1:2,1:2]::Real
    result2 = A ^ 2
    @test operation(result2) === (^)
end

@testset "Metadata operations" begin
    @syms x::Real
    @test hasmetadata(x, Float64) == false

    # Test setmetadata and getmetadata
    x_with_meta = SymbolicUtils.setmetadata(x, Float64, 1.5)
    @test SymbolicUtils.hasmetadata(x_with_meta, Float64)
    @test SymbolicUtils.getmetadata(x_with_meta, Float64) == 1.5

    # Test getmetadata with default
    @test SymbolicUtils.getmetadata(x, Float64, "default") == "default"
end

@testset "`quick_cancel` handles `adjoint(vec) * vec`" begin
    @syms x[1:3]
    num = x[1] * x[2]
    den = x'x
    @test isequal(quick_cancel(num, den), (num, den))
end

# WARN: `IRStructure` should NOT subtype `AbstractArray`, or this will cause
# invalidations/ambiguities due to symbolic array `getindex`.

"""
    $TYPEDEF

Linear IR representation of a (collection of) symbolic expressions. This can be used to
accelerate operations such as `search_variables!` if frequently performed on the same/similar
expressions.

# Invariants

The `dependency_graph` correctly encodes the argument structure of every expression in the
IR. No ordering constraint is imposed on the indices of expressions and their arguments.

## Extended help

The following details are internal

### Fields

$TYPEDFIELDS
"""
struct IRStructure{T}
    """
    Dependency graph (DAG), where `Graphs.outneighbors(g, v)` denotes the nodes that the
    expression at index `v` depends on. In other words, `outneighbors` is the analogue of
    `arguments`.

    Specifically, `outneighbors` is guaranteed to have the same order as `arguments`. In
    case the operation is also symbolic, it will prefix the neighbors corresponding to the
    arguments. This invariant is maintained even when the canonical form is broken.
    """
    dependency_graph::OrderedDiGraph{Int32}
    """
    Mapping from linear indices to the expression at that index.
    """
    symbols::Vector{BasicSymbolic{T}}
    """
    Inverse mapping of `symbols`.
    """
    definition::IdDict{BasicSymbolic{T}, Int32}
    """
    Map from expressions to all nodes they are `isequal` to. This is not `definition` since
    that uses `===` equality.
    """
    weak_definitions::Dict{BasicSymbolic{T}, Vector{Int32}}
    """
    A cached `BitVector` to be used for several operations supported by this struct. It
    is required for many common operations, and `fill!(false, cached_mask)` is much faster
    than allocating a new one of the appropriate size.
    """
    cached_mask::BitVector
    """
    Similar to `cached_mask` but a `Vector{Int32}`.
    """
    cached_idxs::Vector{Int32}
    """
    Set of indices whose expressions have been replaced via [`SymbolicUtils.replace_node!`](@ref).
    The `IRStructure` is in canonical form when this set is empty. Canonical form implies that
    for an expression `ex` at index `idx` in `ir::IRStructure`, there exists an edge
    from `idx` to `ir[arguments(ex)[j]]` for all valid `j` and that
    `arguments(ex)[j] === ir[ir[arguments(ex)[j]]]`. The graph invariants are still maintained
    after the canonical form is broken.
    """
    non_canonical_idxs::BitSet
end

"""
    $TYPEDSIGNATURES

Create an empty `IRStructure` to store `BasicSymbolic{T}` expressions.
"""
function IRStructure{T}() where {T}
    ir = IRStructure{T}(
        OrderedDiGraph{Int32}(), BasicSymbolic{T}[],
        IdDict{BasicSymbolic{T}, Int32}(), Dict{BasicSymbolic{T}, Vector{Int32}}(),
        BitVector(), Int32[], BitSet()
    )
    # It's pretty easy to hit this
    sizehint!(ir, 100)
    return ir
end

"""
    $TYPEDSIGNATURES

Get the cached `BitVector` inside IR, after filling it with `false`.
"""
function get_cached_mask!(ir::IRStructure)
    mask = ir.cached_mask
    fill!(mask, false)
    return mask
end

"""
    $TYPEDSIGNATURES

Get the cached `BitVector` inside IR, after resizing it to have a length of at least `n` and
filling it with `false`.
"""
function get_cached_mask!(ir::IRStructure, n::Integer)
    mask = ir.cached_mask
    length(mask) < n && resize!(mask, n)
    fill!(mask, false)
    return mask
end

"""
    $TYPEDSIGNATURES

Get the cached `Vector{Int32}` inside IR.
"""
function get_cached_idxs!(ir::IRStructure)
    return ir.cached_idxs
end

struct IRStructureNotCanonicalError <: Exception
end

function Base.showerror(io::IO, err::IRStructureNotCanonicalError)
    print(io, """
    This operation requires the `IRStructure` to be in canonical form. Canonical form \
    is typically broken when `SymbolicUtils.replace_node!` is used. Prefer using \
    `SymbolicUtils.IRSubstituter` to maintain canonical form at the cost of performance.
    """)
end

@noinline function require_canonical(ir::IRStructure)
    isempty(ir.non_canonical_idxs) && return
    throw(IRStructureNotCanonicalError())
end

"""
    $TYPEDSIGNATURES

Compute the transitive closure of `dependency_graph` from node `idx` via DFS postorder,
returning a topologically sorted `Vector{Int32}` of all node indices that `idx` (directly or
indirectly) depends on. Dependencies (children) appear before the expressions that depend on
them (parents). Writes the result to and returns `reachability`.

This function allocates its own scratch space and does not use `ir.cached_mask` or
`ir.cached_idxs`, so it is safe to call even when those are held by an outer caller.
"""
function get_reachability!(reachability::Vector{Int32}, ir::IRStructure, idx::Int32; visited::BitVector = falses(Graphs.nv(ir.dependency_graph)))
    g = ir.dependency_graph
    rdfs = RecursiveDFS(g; on_exit = PushToBuffer(reachability), visited)
    n = length(ir)
    rdfs.visited[idx] = true
    for nbor in Graphs.outneighbors(g, idx)
        rdfs.visited[nbor] && continue
        rdfs(nbor)
    end
    return reachability
end

"""
    $TYPEDSIGNATURES

Out-of-place version of [`get_reachability!`](@ref).
"""
get_reachability(ir::IRStructure, idx::Int32) = get_reachability!(Int32[], ir, idx)

"""
    $TYPEDSIGNATURES

Preallocate space for `n` nodes in `ir`.
"""
function Base.sizehint!(ir::IRStructure, n::Integer)
    sizehint!(ir.symbols, n)
    sizehint!(ir.definition, n)
    sizehint!(ir.weak_definitions, n)
    sizehint!(ir.cached_mask, n)
    sizehint!(ir.cached_idxs, n)
    return ir
end

"""
    $TYPEDSIGNATURES

Number of nodes in `ir`.
"""
Base.length(ir::IRStructure) = length(ir.symbols)

# Copies a dictionary where the values are shallow copied
# without having to rehash the keys
function dict_copy_depth_1_no_rehash(d)
    d2 = copy(d)
    vals = d2.vals
    for i in eachindex(vals)
        if isassigned(vals, i)
            @inbounds vals[i] = copy(vals[i])
        end
    end
    return d2
end

function Base.copy(ir::IRStructure{T}) where {T}
    return IRStructure{T}(
        copy(ir.dependency_graph),
        copy(ir.symbols),
        copy(ir.definition),
        dict_copy_depth_1_no_rehash(ir.weak_definitions),
        copy(ir.cached_mask),
        copy(ir.cached_idxs),
        copy(ir.non_canonical_idxs),
    )
end

"""
    $TYPEDSIGNATURES

Find the symbolic expression at index `i`.
"""
Base.getindex(ir::IRStructure, i::Integer) = ir.symbols[i]
"""
    $TYPEDSIGNATURES

Get the index that a symbolic expression occurs at in `ir`. Does not modify `ir`.
"""
Base.getindex(ir::IRStructure{T}, i::BasicSymbolic{T}) where {T} = ir.definition[i]
Base.IndexStyle(::Type{T}) where {T <: IRStructure} = IndexLinear()

"""
    $TYPEDSIGNATURES

Check if `x` exists in `ir`.
"""
Base.haskey(ir::IRStructure{T}, x::BasicSymbolic{T}) where {T} = haskey(ir.definition, x)

"""
    $TYPEDSIGNATURES

Iterate over valid node indices in `ir`.
"""
Base.eachindex(ir::IRStructure) = eachindex(ir.symbols)

function _print_ssa_var(io::IO, i::Int32)
    printstyled(io, "%", i; color = :yellow)
end

"""
    $TYPEDSIGNATURES

Print the IR representation of `ir` to `io`, showing at most `limit` statements.
If the IR has more statements than `limit`, the remaining statements are truncated
and a summary line is printed instead. Pass `limit = nothing` to print all statements.

See also [`SymbolicUtils.print_ir`](@ref) which defaults to printing all statements.
"""
function _show_ir(io::IO, ir::IRStructure; limit::Union{Integer, Nothing} = 50)
    n = length(ir)
    println(io, "IRStructure with $n node$(n == 1 ? "" : "s"):")
    n == 0 && return

    g = ir.dependency_graph

    # A node is a "print leaf" if it will be emitted as a single unit by Julia's
    # symbolic printer rather than decomposed into op + SSA-ref arguments.
    # This covers:
    #   - default_is_atomic: plain Syms, Operator calls, dependent-variable calls
    #   - calls whose operation is any BasicSymbolic (e.g. x(t) from @syms x(t)),
    #     since those will be printed as "x(t)" directly regardless of whether x
    #     is a function symbolic or a dependent variable.
    is_print_leaf = default_is_atomic ∘ Base.Fix1(getindex, ir)

    # Compute topological order once: parents before children (since edges go
    # parent→dependency). Used to propagate visibility top-down and to print
    # dependencies before the nodes that reference them.
    topo = Graphs.topological_sort_by_dfs(g)

    # `to_expand[i]`: i is visible (reachable from a root without crossing print-leaves)
    # `indeg[i]`:     number of visible non-leaf ancestors that directly use i
    #
    # Expansion pass: iterate parents before children so that `to_expand` is
    # propagated correctly from roots downward.
    to_expand = falses(n)
    indeg = zeros(Int32, n)
    for i in 1:n
        Graphs.indegree(g, i) == 0 && (to_expand[i] = true)
    end
    for i in topo
        to_expand[i] || continue
        is_print_leaf(i) && continue
        for j in Graphs.outneighbors(g, i)
            indeg[j] += 1
            to_expand[j] = true
        end
    end

    # Assign consecutive SSA indices to non-inlineable visible nodes
    # (indeg == 0 are roots; indeg > 1 are shared).
    # Iterate children before parents so dependencies receive lower SSA numbers.
    new_idx = zeros(Int32, n)
    counter = 0
    for i in Iterators.reverse(topo)
        (to_expand[i] && indeg[i] != 1) || continue
        new_idx[i] = (counter += 1)
    end

    total_stmts = counter

    # Recursively print the expression at node `i`. Print-leaves are emitted
    # directly via Julia's symbolic printer so their internal structure is never
    # decomposed into SSA references. Single-use (inlineable) non-leaf nodes are
    # expanded in place; shared nodes are referenced by their SSA variable.
    function print_expr(i)
        sym = ir[i]
        if is_print_leaf(i) || !iscall(sym)
            print(io, sym)
            return
        end
        print(io, operation(sym))
        print(io, "(")
        for (j, arg) in enumerate(arguments(sym))
            j > 1 && print(io, ", ")
            arg_idx = ir.definition[arg]
            indeg[arg_idx] == 1 ? print_expr(arg_idx) : _print_ssa_var(io, new_idx[arg_idx])
        end
        print(io, ")")
    end

    # Print in children-before-parents order so that each SSA variable is defined
    # before it is referenced by a later statement.
    printed = 0
    for i in Iterators.reverse(topo)
        (to_expand[i] && indeg[i] != 1) || continue
        if limit !== nothing && printed >= limit
            remaining = total_stmts - printed
            print(io, "  ⋮ ($remaining more statement$(remaining == 1 ? "" : "s") omitted; use `print_ir` to show all)")
            println(io)
            return
        end
        print(io, "  ")
        _print_ssa_var(io, new_idx[i])
        print(io, " = ")
        print_expr(i)
        println(io)
        printed += 1
    end
end

function Base.show(io::IO, ir::IRStructure)
    _show_ir(io, ir; limit = 50)
end

"""
    print_ir([io::IO], ir::IRStructure)

Print the complete IR of `ir` to `io` (defaulting to `stdout`) without truncation.

By default, `show` limits the output to 50 statements. Use this function when
you need to inspect an `IRStructure` with more statements than that limit.
"""
print_ir(io::IO, ir::IRStructure) = _show_ir(io, ir; limit = nothing)
print_ir(ir::IRStructure) = print_ir(stdout, ir)

"""
    $TYPEDEF

Closure used to make [`populate_ir!`](@ref) type-stable.
"""
struct PopulateClosure{T} <: Function
    """
    The IR begin populated.
    """
    ir::IRStructure{T}
    """
    The expression to add to the IR, if it doesn't already exist.
    """
    expr::BasicSymbolic{T}
end

function (pc::PopulateClosure{T})() where {T}
    (; ir, expr) = pc
    # `outneighbors`
    expr_uses = Int32[]
    if iscall(expr)
        # `op` must be processed before `args` to maintain the `outneighbors` ordering
        # invariant: op prefixes the arg neighbors when op isa BasicSymbolic{T}.
        op = operation(expr)
        if op isa BasicSymbolic{T}
            op_idx = populate_ir!(ir, op)
            push!(expr_uses, op_idx)
        end
        args = parent(arguments(expr))
        sizehint!(expr_uses, length(args) + 1)
        @union_split_smallvec args for arg in args
            # Add each argument to the IR. This is effectively a postorder traversal.
            arg_idx = populate_ir!(ir, arg)
            push!(expr_uses, arg_idx)
        end
    end
    # Edges are added in argument order to preserve the outneighbors == arguments invariant.
    Graphs.add_vertex!(ir.dependency_graph)
    idx = Graphs.nv(ir.dependency_graph)
    for dst in expr_uses
        Graphs.add_edge!(ir.dependency_graph, idx, dst)
    end
    empty!(expr_uses)
    # Add `expr` to the IR
    push!(ir.symbols, expr)

    buffer = get!(Returns(expr_uses), ir.weak_definitions, expr)
    push!(buffer, idx)

    return idx
end

"""
    $TYPEDSIGNATURES

Add the expression `expr` to `ir`.
"""
function populate_ir!(ir::IRStructure{T}, expr::BasicSymbolic{T}) where {T}
    return get!(PopulateClosure(ir, expr), ir.definition, expr)
end

"""
    $TYPEDSIGNATURES

Add the each expression in `exprs` to `ir`, in order.
"""
function populate_ir!(ir::IRStructure{T}, exprs::AbstractArray{BasicSymbolic{T}}) where {T}
    map(Base.Fix1(populate_ir!, ir), exprs)
end

@noinline function _throw_expr_not_in_ir(expr)
    throw(ArgumentError(lazy"Expression was not found in the IR!"))
end

"""
    $TYPEDSIGNATURES

Return a new [`SymbolicUtils.IRStructure`](@ref) containing only the expressions in `exprs`
along with their dependencies.
"""
function subset_ir(ir::IRStructure{T}, expr) where {T}
    exprs = OrderedSet{BasicSymbolic{T}}()
    buffer = IRStructureSearchBuffer(ir, exprs)
    # `Returns(true)` gets all top-level expressions
    search_variables!(buffer, expr; is_atomic = Returns(true))
    return subset_ir(ir, exprs)
end

function subset_ir(
        ir::IRStructure{T},
        exprs::Union{AbstractArray{BasicSymbolic{T}}, AbstractSet{BasicSymbolic{T}}}
    ) where {T}
    new_ir = IRStructure{T}()
    visited = get_cached_mask!(ir, length(ir))
    reachables = get_cached_idxs!(ir)
    empty!(reachables)
    for expr in exprs
        expr_i = get(ir.definition, expr, 0)
        iszero(expr_i) && _throw_expr_not_in_ir(expr)
        get_reachability!(reachables, ir, expr_i; visited)
        visited[expr_i] = true
        push!(reachables, expr_i)
    end

    n_new_verts = length(reachables)
    Graphs.add_vertices!(new_ir.dependency_graph, n_new_verts)
    sizehint!(new_ir, n_new_verts)

    old2new = zeros(Int32, length(ir))
    inew = 0
    # `reachables` is in topological order
    for iold in reachables
        inew += 1
        old2new[iold] = inew
        # Add expression to the IR
        sym = ir.symbols[iold]
        push!(new_ir.symbols, sym)
        new_ir.definition[sym] = inew
        buffer = get!(() -> Int32[], new_ir.weak_definitions, sym)
        push!(buffer, inew)

        # Translate old neighbors to new ones. Since we're iterating
        # `reachables` in topologically sorted order, we can guarantee that these
        # have already been added to `new_ir`.
        oldnbors = Graphs.outneighbors(ir.dependency_graph, iold)
        for nbor in oldnbors
            Graphs.add_edge!(new_ir.dependency_graph, inew, old2new[nbor])
        end
    end

    return new_ir
end

struct IRStructureSearchBuffer{T, S <: AbstractSet{BasicSymbolic{T}}} <: AbstractSet{BasicSymbolic{T}}
    ir::IRStructure{T}
    buffer::S
    searched::BitSet
end

function IRStructureSearchBuffer(ir::IRStructure{T}, buffer::S) where {T, S <: AbstractSet{BasicSymbolic{T}}}
    return IRStructureSearchBuffer{T, S}(ir, buffer, BitSet())
end

Base.length(s::IRStructureSearchBuffer) = length(s.buffer)
Base.iterate(s::IRStructureSearchBuffer, state...) = iterate(s.buffer, state...)
Base.in(x::BasicSymbolic{T}, s::IRStructureSearchBuffer{T}) where {T} = in(x, s.buffer)

function Base.empty(s::IRStructureSearchBuffer{T, S}) where {T, S}
    return IRStructureSearchBuffer{T, S}(s.ir, empty(s.buffer), empty(s.searched))
end

function Base.empty!(s::IRStructureSearchBuffer)
    empty!(s.buffer)
    empty!(s.searched)
    return s
end

function Base.push!(s::IRStructureSearchBuffer{T}, x::BasicSymbolic{T}) where {T}
    push!(s.buffer, x)
    return s
end

Base.keytype(::Type{I}) where {T, I <: IRStructureSearchBuffer{T}} = BasicSymbolic{T}

function Base.delete!(s::IRStructureSearchBuffer{T}, x::BasicSymbolic{T}) where {T}
    was_in_buffer = x in s.buffer
    delete!(s.buffer, x)
    was_in_buffer || return s
    # Deleting invalidates the cache. Find all nodes `isequal` to this one.
    defs = get(s.ir.weak_definitions, x, nothing)
    defs isa Vector{Int32} || return s
    # Go through `defs`, walk the dependency tree backwards and delete any entries in
    # `s.searched` that we find.
    rdfs = RecursiveDFS(
        s.ir.dependency_graph;
        neighbors_fn = FilteredNeighbors(in(s.searched), Graphs.inneighbors),
        on_exit = Base.Fix1(delete!, s.searched)
    )
    for def in defs
        def in s.searched || continue
        rdfs(def)
    end
    return s
end

function Base.setdiff!(s::IRStructureSearchBuffer{T}, ss...) where {T}
    idxs = get_cached_idxs!(s.ir)
    empty!(idxs)
    for other in ss
        for x in other
            was_in_buffer = x in s.buffer
            delete!(s.buffer, x)
            was_in_buffer || continue
            defs = get(s.ir.weak_definitions, x, nothing)
            if defs isa Vector{Int32}
                append!(idxs, defs)
            end
        end
    end
    isempty(idxs) && return s
    rdfs = RecursiveDFS(
        s.ir.dependency_graph;
        neighbors_fn = FilteredNeighbors(in(s.searched), Graphs.inneighbors),
        on_exit = Base.Fix1(delete!, s.searched)
    )
    for idx in idxs
        idx in s.searched || continue
        rdfs(idx)
    end
    return s
end

function Base.filter!(pred::F, s::IRStructureSearchBuffer{T}) where {F, T}
    idxs = get_cached_idxs!(s.ir)
    empty!(idxs)

    for x in s
        pred(x) && continue
        delete!(s.buffer, x)
        defs = get(s.ir.weak_definitions, x, nothing)
        if defs isa Vector{Int32}
            append!(idxs, defs)
        end
    end
    isempty(idxs) && return s
    rdfs = RecursiveDFS(
        s.ir.dependency_graph;
        neighbors_fn = FilteredNeighbors(in(s.searched), Graphs.inneighbors),
        on_exit = Base.Fix1(delete!, s.searched)
    )
    for idx in idxs
        idx in s.searched || continue
        rdfs(idx)
    end
    return s
end

function search_variables!(
        buffer::IRStructureSearchBuffer{T, S}, expr::BasicSymbolic{T};
        is_atomic::F = default_is_atomic, recurse::G = iscall
    ) where {T, S, F, G}
    if is_atomic(expr)
        push!(buffer, expr)
        return
    end
    recurse(expr) || return
    # We call `populate_ir!` late because it's possible that `recurse` filters
    # out a big expression before we have to put it into the IR.
    ir = buffer.ir
    idx = populate_ir!(ir, expr)
    idx in buffer.searched && return

    reachability = get_cached_idxs!(ir)
    empty!(reachability)
    get_reachability!(reachability, ir, idx; visited = get_cached_mask!(ir, length(ir)))

    mask = get_cached_mask!(ir, length(ir))
    for arg_i in Graphs.outneighbors(ir.dependency_graph, idx)
        mask[arg_i] = true
    end

    for cur_i in Iterators.reverse(reachability)
        mask[cur_i] || continue
        cur_i in buffer.searched && continue
        push!(buffer.searched, cur_i)
        cur = ir[cur_i]
        if is_atomic(cur)
            push!(buffer, cur)
            continue
        end
        recurse(cur) || continue
        for arg_i in Graphs.outneighbors(ir.dependency_graph, cur_i)
            mask[arg_i] = true
        end
    end

    push!(buffer.searched, idx)

    return nothing
end

"""
    $TYPEDSIGNATURES

Optimized version of [`SymbolicUtils.search_variables!`](@ref) that leverages the provided
[`SymbolicUtils.IRStructure`](@ref). May also add `expr` to `ir` in the process.
"""
function search_variables!(
        buffer::AbstractSet{BasicSymbolic{T}}, ir::IRStructure{T}, expr::BasicSymbolic{T};
        is_atomic::F = default_is_atomic, recurse::G = iscall
    ) where {T, F, G}
    search_variables!(IRStructureSearchBuffer(ir, buffer), expr; is_atomic, recurse)
    return nothing
end

"""
    $TYPEDSIGNATURES

Optimized version of [`SymbolicUtils.query`](@ref) that leverages the provided
[`SymbolicUtils.IRStructure`](@ref). Requires that `expr` is present in `ir`.
"""
function query(predicate::F, ir::IRStructure{T}, expr::BasicSymbolic{T}; recurse::G = iscall) where {F, T, G}
    predicate(expr) && return true
    idx = ir.definition[expr]
    reachability = get_cached_idxs!(ir)
    # Fast path when we know we don't have to filter out subtrees
    if recurse === iscall
        empty!(reachability)
        get_reachability!(reachability, ir, idx)
        for i in reachability
            predicate(ir.symbols[i]) && return true
        end

        return false
    end

    # Similar to BFS in `search_variables!`
    mask = get_cached_mask!(ir, length(ir))
    for arg_i in Graphs.outneighbors(ir.dependency_graph, idx)
        mask[arg_i] = true
    end

    empty!(reachability)
    get_reachability!(reachability, ir, idx)
    for cur_i in Iterators.reverse(reachability)
        mask[cur_i] || continue
        cur = ir[cur_i]
        predicate(cur) && return false
        recurse(cur) || continue
        for arg_i in Graphs.outneighbors(ir.dependency_graph, cur_i)
            mask[arg_i] = true
        end
    end
    return false
end

"""
    $TYPEDEF

A struct similar to [`SymbolicUtils.Substituter`](@ref) which leverages the information
in a [`SymbolicUtils.IRStructure`](@ref) to provide a faster implementation of substitution.
This may mutate the wrapped `IRStructure`. Note that `IRSubstituter` is restricted to working
on substitution rules mapping `BasicSymbolic{T}` to `BasicSymbolic{T}`.
"""
struct IRSubstituter{Fold, T, D <: AbstractDict{BasicSymbolic{T}, BasicSymbolic{T}}, F} <: Substituter{Fold}
    ir::IRStructure{T}
    rules::D
    filterer::F
    cache::Dict{Int32, Int32}
    reachability::Vector{Int32}
    dfs_visited::BitVector
end

"""
    $TYPEDSIGNATURES

Create an `IRSubstituter` using the given `ir` and `rules`.
"""
function IRSubstituter{Fold}(
        ir::IRStructure{T}, rules::D; filterer::F = default_substitute_filter
    ) where {Fold, T, D <: AbstractDict, F}
    IRSubstituter{Fold, T, D, F}(ir, rules, filterer, Dict{Int32, Int32}(), Int32[], falses(length(ir)))
end

get_substitution_dict(sub::IRSubstituter) = sub.rules
clear_cache!(sub::IRSubstituter) = empty!(sub.cache)


"""
    $TYPEDSIGNATURES

Perform the substitution on element `idx` in the IR, returning the index of the new
element.
"""
function substitute_ir!(sub::IRSubstituter{Fold, T}, idx::Int32) where {Fold, T}
    # Substitution requires checking if argument expressions are present in the
    # substitution rules. If canonical form is violated, the symbolic expressions
    # are not necessarily accurate and thus substitution cannot be guaranteed to
    # work correctly.
    require_canonical(sub.ir)

    (; rules, filterer, ir, dfs_visited) = sub

    # Check the cache, filter, and rules for `idx`
    cached = get(sub.cache, idx, zero(Int32))
    iszero(cached) || return cached
    idxsym = ir[idx]
    other = get(rules, idxsym, nothing)
    if other isa BasicSymbolic{T}
        return sub.cache[idx] = populate_ir!(ir, other)
    end
    if !filterer(idxsym)
        # Match behavior with `DefaultSubstituter`. A filtered expression does not
        # populate the cache.
        return idx
    end
    if !iscall(idxsym)
        return idx
    end

    # Now, it's _possible_ `idx` is changed by the substitution

    # `modified` keeps track of which reachable indices from `idx` are modified by the
    # substitution
    modified = get_cached_mask!(ir, length(ir))
    # Queue of indices that are modified but the modified version isn't present in the IR
    # (needs to be computed)
    queue = get_cached_idxs!(ir)
    empty!(queue)
    reachability = sub.reachability
    empty!(reachability)
    # We don't use `get_reachability!` because that won't respect `filterer`
    nbors_fn = let filterer = filterer, ir = ir
        function __nbors_fn(graph, idx)
            nbors = Graphs.outneighbors(graph, idx)
            return filterer(ir[idx]) ? nbors : empty(nbors)
        end
    end
    resize!(dfs_visited, length(ir))
    fill!(dfs_visited, false)
    rdfs = RecursiveDFS(ir.dependency_graph; neighbors_fn = nbors_fn, on_exit = PushToBuffer(reachability), visited = dfs_visited)
    rdfs(idx)
    # Remove `idx` from the end
    pop!(reachability)

    can_fold = false
    for i in reachability
        # Check the cache, filter, and rules for `i`
        cached = get(sub.cache, i, zero(Int32))
        if !iszero(cached) && cached != i
            modified[i] = true
            continue
        end

        sym = ir[i]
        other = get(rules, sym, nothing)
        if other isa BasicSymbolic{T}
            sub.cache[i] = populate_ir!(ir, other)
            modified[i] = true
            continue
        end
        if !filterer(sym)
            continue
        end
        if !iscall(sym)
            continue
        end

        # We will already have processed the children since we're iterating
        # reachable nodes in topological order (dependencies before dependents)
        children = Graphs.outneighbors(ir.dependency_graph, i)
        if Fold && !(operation(sym) isa BasicSymbolic{T}) && all(isconst ∘ Base.Fix1(getindex, ir), children)
            modified[i] = true
            push!(queue, i)
            can_fold = true
            continue
        end
        # If none of the children are modified, `i` isn't modified and we can skip it
        if !any(Base.Fix1(getindex, modified), children)
            sub.cache[i] = i
            continue
        end
        # We need to find the updated expression and insert it into `ir`
        modified[i] = true
        push!(queue, i)
    end

    # The reason we used a queue is that it is possible for `idx` to remain unmodified.
    # This avoids unnecessary work substituting the intermediates only for `idx` to
    # be skipped since the children are all filtered out. As a result, this method is
    # very useful for sparse substitutions.
    children = Graphs.outneighbors(ir.dependency_graph, idx)
    if !any(Base.Fix1(getindex, modified), children) && !(Fold && can_fold)
        return sub.cache[idx] = idx
    end
    push!(queue, idx)

    for i in queue
        # Process the queue
        i_sym = ir[i]
        # Get the new `args` using `new_children`
        args = copy(parent(arguments(i_sym)))
        # `Fold` is a type parameter, so we statically elide the `can_fold` checking
        # if we don't need it.
        if Fold
            can_fold = true
        end
        for j in eachindex(args)
            new_child = args[j] = ir[get(sub.cache, ir[args[j]], ir[args[j]])]
            if Fold
                can_fold &= isconst(new_child)
            end
        end
        op = operation(i_sym)
        if op isa BasicSymbolic{T}
            op_i = ir[op]
            op = ir[get(sub.cache, op_i, op_i)]
            if isconst(op)
                op = unwrap_const(op)
            elseif Fold
                can_fold = false
            end
        end
        # Get the new symbolic expression
        newsym = if Fold
            can_fold &= !(op isa BasicSymbolic{T})
            combine_fold(T, op, args, metadata(i_sym), can_fold)::BasicSymbolic{T}
        else
            maketerm(BasicSymbolic{T}, op, args, metadata(i_sym))::BasicSymbolic{T}
        end

        sub.cache[i] = populate_ir!(ir, newsym)
    end

    # `idx` was in the queue, so it is now in the cache
    return sub.cache[idx]
end

function (sub::IRSubstituter{Fold, T})(expr::BasicSymbolic{T}) where {Fold, T}
    rules = sub.rules
    filterer = sub.filterer
    ir = sub.ir

    idx = populate_ir!(ir, expr)
    newidx = substitute_ir!(sub, idx)
    return ir[newidx]
end

"""
    $TYPEDSIGNATURES

Replace the expression `old` in `ir` with the expression `new`. `old` must already exist in `ir`.
Note that this is not symbolic substitution, since any expressions that depend on `old` will not
be updated. This will simply update the internal graph data structure such that the expression
at `old` is now `new`, and the arguments of `new` form the out-neighbors of the vertex. This breaks
the canonical form of `ir`.
"""
function replace_node!(ir::IRStructure{T}, old::BasicSymbolic{T}, new::BasicSymbolic{T}) where {T}
    idx = ir[old]
    # Any nodes that currently depend on `old` are non-canonical
    union!(ir.non_canonical_idxs, Graphs.inneighbors(ir.dependency_graph, idx))

    # If `ir` already contains `new`, then proceeding normally would
    # break `IRStructure` invariants. `ir.definition` already contains `new`,
    # so after this function it would point to `old`, and the index it used
    # to point to would also contain `new` but not be referred to in `definition`.
    # To fix this, we simply add metadata to `new`. We know `old` is unique in
    # `ir`, so its `objectid` is a simple way to make `new` unique even if
    # there are additional `replace_node!` calls with the same `new`, since they
    # will have different `old`.
    if haskey(ir, new)
        if isconst(new)
            # We can't `setmetadata` on `Const`
            new = BSImpl.Term{T}(
                identity, ArgsT{T}((new,));
                type = symtype(new), shape = shape(new),
                metadata = Base.ImmutableDict(
                    Base.ImmutableDict{DataType, Any}(),
                    typeof(replace_node!) => objectid(old)
                )
            )
        end
        new = setmetadata(new, typeof(replace_node!), objectid(old))
    end
    ir.symbols[idx] = new
    delete!(ir.definition, old)
    ir.definition[new] = idx
    weakdefs = ir.weak_definitions[old]
    filter!(!isequal(idx), weakdefs)
    isempty(weakdefs) && delete!(ir.weak_definitions, old)

    buffer = get!(() -> Int32[], ir.weak_definitions, new)
    push!(buffer, idx)

    rem_outedges!(ir.dependency_graph, idx)

    iscall(new) || return

    op = operation(new)
    if op isa BasicSymbolic{T}
        Graphs.add_edge!(ir.dependency_graph, idx, populate_ir!(ir, op))
    end
    args = parent(arguments(new))
    @union_split_smallvec args for arg in args
        Graphs.add_edge!(ir.dependency_graph, idx, populate_ir!(ir, arg))
    end
    return nothing
end

"""
    $TYPEDSIGNATURES

Replace all out-edges from `src` to `old_dst` in `ir` with edges from `src` to `new_dst`.
Similar to `replace_node!`, this does not change the symbolic information stored in `ir`.
This is a no-op of `old_dst == new_dst` or if no edge from `src` to `old_dst` exists in the
graph. Outside of these cases, `ir` is non-canonical after this operation.
"""
function replace_edge!(ir::IRStructure, src::Integer, old_dst::Integer, new_dst::Integer)
    old_dst == new_dst && return

    old_nbors = get_cached_idxs!(ir)
    empty!(old_nbors)
    append!(old_nbors, Graphs.outneighbors(ir.dependency_graph, src))
    any(==(old_dst), old_nbors) || return

    push!(ir.non_canonical_idxs, src)
    rem_outedges!(ir.dependency_graph, src)
    for v in old_nbors
        Graphs.add_edge!(ir.dependency_graph, src, v == old_dst ? new_dst : v)
    end

    return nothing
end

"""
    $TYPEDSIGNATURES

If `ir.non_canonical_idxs` is empty, return `ir[idx]`. Otherwise, find the canonical expression
that `ir[idx]` should be, were `IRSubstituter` used instead of `replace_node!`.
"""
function get_canonical_expr!(ir::IRStructure{T}, idx::Integer) where {T}
    isempty(ir.non_canonical_idxs) && return ir[idx]

    return __get_canonical_expr(ir, idx)
end

# `get_canonical_expr` was never exported; the default `export_old = true` of `@deprecate`
# would silently add it to the public API that the (also non-public) `get_canonical_expr!`
# does not have.
@deprecate get_canonical_expr(ir, idx) get_canonical_expr!(ir, idx) false

"""
    $TYPEDSIGNATURES

Helper function for `get_canonical_expr`. Returns the canonical expression at index `idx`
by recursively descending through the DAG.
"""
function __get_canonical_expr(ir::IRStructure{T}, idx::Integer) where {T}
    i_sym = ir[idx]

    reachability = get_cached_idxs!(ir)
    empty!(reachability)
    get_reachability!(reachability, ir, idx; visited = get_cached_mask!(ir, length(ir)))
    push!(reachability, idx)
    # `reachability` is in topological order. We can iterate over it, and update
    # any non-canonical nodes as we encounter them. Once we update a node, we mark
    # all its `inneighbors` as non-canonical.
    for node in reachability
        node in ir.non_canonical_idxs || continue
        i_sym = ir[node]
        nbors = Graphs.outneighbors(ir.dependency_graph, node)
        n_drop = 0
        op = operation(i_sym)
        # If the operation is symbolic, it is the first entry in `nbors`.
        if op isa BasicSymbolic{T}
            n_drop = 1
            new_op = ir[first(nbors)]
            # If the operation is different, the tree is dirty
            if new_op !== op
                op = new_op
            end
        end
        new_args = parent(arguments(i_sym))
        # Avoid copying and allocating a new buffer if possible
        args_dirty = false
        for (i, arg_idx) in enumerate(Iterators.drop(nbors, n_drop))
            new_expr = ir[arg_idx]
            # If the argument changed, then it is dirty
            if new_expr !== new_args[i]
                # Allocate a new buffer if we haven't already
                if !args_dirty
                    new_args = copy(new_args)
                end
                args_dirty = true
                new_args[i] = new_expr
            end
        end
        # Update the expression for this node
        ir.symbols[node] = new_sym = maketerm(BasicSymbolic{T}, op, new_args, metadata(i_sym))::BasicSymbolic{T}
        ir.definition[new_sym] = node
        weakdefs = ir.weak_definitions[i_sym]
        if length(weakdefs) == 1
            delete!(ir.weak_definitions, i_sym)
        else
            filter!(!isequal(node), weakdefs)
        end
        weakdefs = get!(Vector{Int32}, ir.weak_definitions, new_sym)
        push!(weakdefs, node)
        rem_outedges!(ir.dependency_graph, node)

        if op isa BasicSymbolic{T}
            Graphs.add_edge!(ir.dependency_graph, node, populate_ir!(ir, op))
        end
        args = parent(arguments(new_sym))
        @union_split_smallvec args for arg in args
            Graphs.add_edge!(ir.dependency_graph, node, populate_ir!(ir, arg))
        end
        # `node` is now canonical
        delete!(ir.non_canonical_idxs, node)
        # All its `inneighbors` are still non-canonical
        union!(ir.non_canonical_idxs, Graphs.inneighbors(ir.dependency_graph, node))
    end

    return ir[idx]
end

module SymbolicUtilsDistributionsExt

using SymbolicUtils
using SymbolicUtils: BasicSymbolic, BSImpl, ArgsT, Const, ShapeT, ShapeVecT,
                     promote_symtype, promote_shape, shape, symtype
using Distributions: pdf, logpdf, cdf, logcdf, quantile
import Distributions

for f in [pdf, logpdf, cdf, logcdf, quantile]
    @eval function SymbolicUtils.promote_symtype(::$(typeof(f)), ::Type{T},
                                   ::Type{S}) where {T <: Distributions.Distribution,
                                                     S <: Number}
        S
    end
    @eval function SymbolicUtils.promote_symtype(::$(typeof(f)), ::Type{T},
                                   ::Type{S}) where {T <: Distributions.Distribution,
                                                     eS <: Number, S <: AbstractArray{eS}}
        S
    end
    @eval function SymbolicUtils.promote_symtype(::$(typeof(f)), ::Type{T},
                                   ::Type{S}) where {T <: Distributions.Distribution, S}
        error("Distributions can only be sampled with numbers or arrays of numbers.")
    end
    @eval function SymbolicUtils.promote_symtype(::$(typeof(f)), ::Type{T},
                                   ::Type{S}) where {T, S}
        error("Distributions.jl sample functions require a distribution as the first argument.")
    end
    @eval function SymbolicUtils.promote_shape(::$(typeof(f)), sh::ShapeT)
        @nospecialize sh
        return sh
    end
    @eval function (::$(typeof(f)))(dist::Distributions.Distribution, x::BasicSymbolic{T}) where {T}
        return BSImpl.Term{T}($f, ArgsT{T}((Const{T}(dist), x)); shape = shape(x), type = symtype(x))
    end
    @eval function (::$(typeof(f)))(dist::BasicSymbolic{T}, x::BasicSymbolic{T}) where {T}
        return BSImpl.Term{T}($f, ArgsT{T}((dist, x)); shape = shape(x), type = symtype(x))
    end
    @eval function (::$(typeof(f)))(dist::BasicSymbolic{T}, x) where {T}
        return BSImpl.Term{T}($f, ArgsT{T}((dist, Const{T}(x))); shape = shape(x), type = symtype(x))
    end
end

for f in [Distributions.Uniform, Distributions.Normal]
    @eval function SymbolicUtils.promote_symtype(::Type{$f}, ::Type{T}, ::Type{S}) where {T <: Real, S <: Real}
        $f{promote_type(T, S)}
    end
    @eval function SymbolicUtils.promote_shape(::Type{$f}, sha::ShapeT, shb::ShapeT)
        @nospecialize sha shb
        @assert sha isa ShapeVecT && isempty(sha) "Distribution requires scalar inputs"
        @assert shb isa ShapeVecT && isempty(shb) "Distribution requires scalar inputs"
        return ShapeVecT()
    end
    for (T1, T2) in Iterators.product(Iterators.repeated([Real, :($BasicSymbolic{T})], 2)...)
        if T1 == T2 == Real
            continue
        end
        @eval function (::Type{$f})(a::$T1, b::$T2) where {T}
            type = promote_symtype($f, symtype(a), symtype(b))
            sh = promote_shape($f, shape(a), shape(b))
            BSImpl.Term{T}($f, ArgsT{T}((Const{T}(a), Const{T}(b))); type, shape = sh)
        end
    end
end

end

using Test
using Combinatorics
using SymbolicUtils
using SymbolicUtils: <ₑ, arguments, Term, Const, get_degrees

@syms a b c

function istotal(x, y)
    #either
    if x <ₑ y
        return !(y <ₑ x)
    elseif y <ₑ x
        return !(x <ₑ y) # already tested
    else
        # neither, equal
        return isequal(x, y)
    end
end

@test istotal(a,a)
@test istotal(a,b)
@test istotal(2,a)
@test 2 <ₑ Const{SymReal}(2)
@test Const{SymReal}(2) <ₑ Const{SymReal}(3)
@test Const{SymReal}(2) <ₑ a
@test !(Const{SymReal}(3) <ₑ Const{SymReal}(2))
@test 2 <ₑ a
@test a <ₑ b
@test istotal(a, 2a)
@test a <ₑ 2a
@test istotal(b*a, a)
@test istotal(a, b*a)
@test !(b*a <ₑ b+a)
@test Term{SymReal}(^, [1,-1]) <ₑ a
@test istotal(a, Term{SymReal}(^, [1,-1]))

@testset "operator order" begin
    fs = (*, -, +)
    for i in 1:length(fs)
        f = fs[i]
        @test f(a, b) <ₑ f(b, c)
        @test istotal(f(a, b), f(b, c))
        @test !(f(b, b) <ₑ f(b, b))
        @test istotal(f(b, b), f(b, b))
        @test !(f(b, c) <ₑ f(a, b))
        @test istotal(f(b, c), f(a, b))

        @test f(1, b) <ₑ f(2, b)
        @test !(f(2, b) <ₑ f(1, b))
        @test istotal(f(1, b), f(2, b))
        @test istotal(f(2, b), f(1, b))
        @test b <ₑ f(2,b) && !(f(2,b) <ₑ b)

        for j in i+1:length(fs)
            g = fs[j]
            @test istotal(f(a, b), g(a, b))
        end
    end
end
@testset "callable variable order" begin
    @syms z() ρ()

    @test istotal(ρ(), -1z())

    @syms b(t) a(t) t
    @test istotal(a(t), b(t))

    @syms y() x()
    @test istotal(x(), y())
end

@testset "Sym vs Term" begin
    @syms x y

    @test x <ₑ (3 + x) && !((3 + x) <ₑ x)
    @test istotal(y, x^2)
end

@testset "small terms" begin
    # this failing was a cause of a nasty stackoverflow #82
    @syms a
    istotal(Term{SymReal}(^, [a, -1]), (a + 2))
end

@testset "transitivity" begin
    # issue #160
    @syms σ x y z
    expr = σ*sin(x + -1y)*(sin(z)^2)*(-1x + y)
    # Note that arguments(expr) no more uses <ₑ
    args = sort(arguments(expr), lt=<ₑ)
    @test all(((a, b), )->a <ₑ b,  combinations(args, 2))
end

"""
    $TYPEDSIGNATURES

Extract the operation (function) from a symbolic function call expression.
Only valid for expressions where `iscall(expr)` returns `true`.

Returns the function/operator that is being applied in the expression. For basic
arithmetic, this returns the operator function (+, -, *, /, ^). For function calls
like `sin(x)`, this returns the function `sin`.

# Examples
```julia
using SymbolicUtils
@variables x y

# Arithmetic operations
expr1 = x + y
operation(expr1)    # returns +

expr2 = x * y
operation(expr2)    # returns *

# Function calls
expr3 = sin(x)
operation(expr3)    # returns sin

# Nested expressions
expr4 = sin(x + y)
operation(expr4)    # returns sin
operation(arguments(expr4)[1])  # returns +
```

See also: [`TermInterface.iscall`](@ref), [`arguments`](@ref)
"""
@inline function TermInterface.operation(x::BSImpl.Type{T}) where {T}
    @nospecialize x
    @match x begin
        BSImpl.Const(_) => throw(ArgumentError("`Const` does not have an operation."))
        BSImpl.Sym(_) => throw(ArgumentError("`Sym` does not have an operation."))
        BSImpl.Term(; f) => f
        BSImpl.AddMul(; variant) => @match variant begin
            AddMulVariant.ADD => (+)
            AddMulVariant.MUL => (*)
        end
        BSImpl.Div(_) => (/)
        BSImpl.ArrayOp(; term) => begin
            if term === nothing
                ArrayOp{T}
            elseif term isa BasicSymbolic{T}
                operation(term)
            end
        end
        BSImpl.ArrayMaker(;) => ArrayMaker{T}
    end
end

"""
    sorted_arguments(x::BasicSymbolic)

Get the arguments of a symbolic expression in canonical sorted order.

For commutative operations like addition and multiplication, the arguments
are sorted according to a canonical ordering. This ensures that equivalent
expressions have the same representation.

# Arguments
- `x::BasicSymbolic`: The symbolic expression

# Returns
A vector of the arguments in sorted order. For non-commutative operations,
returns the arguments in their original order.

# Examples
```julia
julia> @syms x y z
(x, y, z)

julia> expr = x + z + y
x + y + z

julia> sorted_arguments(expr)
3-element Vector{Any}:
 x
 y
 z
```
"""
function TermInterface.sorted_arguments(x::BasicSymbolic{T})::ROArgsT{T} where {T}
    if T === SymReal
        return _sorted_args1(x)
    elseif T === SafeReal
        return _sorted_args2(x)
    elseif T === TreeReal
        return _sorted_args3(x)
    end
    _unreachable()
end

@cache function _sorted_args1(x::BasicSymbolic{SymReal})::ROArgsT{SymReal}
    __sorted_args(x)
end
@cache function _sorted_args2(x::BasicSymbolic{SafeReal})::ROArgsT{SafeReal}
    __sorted_args(x)
end
@cache function _sorted_args3(x::BasicSymbolic{TreeReal})::ROArgsT{TreeReal}
    __sorted_args(x)
end
function __sorted_args(x::BasicSymbolic{T})::ROArgsT{T} where {T}
    @match x begin
        BSImpl.AddMul(; variant) => begin
            args = copy(parent(arguments(x)))
            @match variant begin
                AddMulVariant.ADD => begin
                    @union_split_smallvec args begin
                        sort!(args; lt = <ₑ)
                    end
                    return ROArgsT{T}(ArgsT{T}(args))
                end
                AddMulVariant.MUL => begin
                    degrees = SmallV{RODegreesT}()
                    sizehint!(degrees, length(args))
                    @union_split_smallvec args begin
                        for arg in args
                            push!(degrees, get_degrees(arg))
                        end
                    end
                    idxs = @union_split_smallvec degrees begin
                        sortperm(degrees)
                    end
                    return ROArgsT{T}(ArgsT{T}(args[idxs]))
                end
            end
        end
        _ => return arguments(x)
    end
end

"""
    arguments(expr)

Extract the arguments from a symbolic function call expression.
Only valid for expressions where `iscall(expr)` returns `true`.

Returns a collection (typically a vector) containing the arguments passed to the operation.
For binary operations like `+` or `*`, this returns a collection of all operands.
For function calls, this returns the function arguments.

# Examples
```julia
using SymbolicUtils
@variables x y z

# Binary arithmetic operations
expr1 = x + y
arguments(expr1)    # returns collection containing x and y

expr2 = x * y * z
arguments(expr2)    # returns collection containing x, y, and z

# Function calls
expr3 = sin(x)
arguments(expr3)    # returns collection containing x

# Nested expressions
expr4 = sin(x + y)
arguments(expr4)             # returns collection containing (x + y)
arguments(arguments(expr4)[1])  # returns collection containing x and y
```

See also: [`iscall`](@ref), [`operation`](@ref)
"""
function TermInterface.arguments(x::BSImpl.Type{T})::ROArgsT{T} where {T}
    @match x begin
        BSImpl.Const(_) => throw(ArgumentError("`Const` does not have arguments."))
        BSImpl.Sym(_) => throw(ArgumentError("`Sym` does not have arguments."))
        BSImpl.Term(; args) => ROArgsT{T}(args)
        BSImpl.AddMul(; coeff, dict, variant, args, shape, type) => begin
            isempty(args) || return ROArgsT{T}(args)
            @match variant begin
                AddMulVariant.ADD => begin
                    if !iszero(coeff)
                        push!(args, Const{T}(coeff))
                    end
                    for (k, v) in dict
                        newterm = @match k begin
                            BSImpl.AddMul(; dict = d2, variant = v2, type, shape, metadata) && if v2 == AddMulVariant.MUL end => begin
                                Mul{T}(v, d2; shape, type, metadata)
                            end
                            _ => Mul{T}(v, ACDict{T}(k => 1); shape, type)
                        end
                        push!(args, newterm)
                    end
                end
                AddMulVariant.MUL => begin
                    if !_isone(coeff)
                        push!(args, Const{T}(coeff))
                    end
                    for (k, v) in dict
                        push!(args, k ^ v)
                    end
                end
            end
            return ROArgsT{T}(args)
        end
        BSImpl.Div(num, den) => ROArgsT{T}(ArgsT{T}((num, den)))
        BSImpl.ArrayOp(; output_idx, expr, reduce, term, ranges, shape, type, args) => begin
            if term === nothing
                isempty(args) || return ROArgsT{T}(args)
                push!(args, Const{T}(output_idx))
                push!(args, Const{T}(expr))
                push!(args, Const{T}(reduce))
                push!(args, Const{T}(term))
                push!(args, Const{T}(ranges))
                return ROArgsT{T}(args)
            elseif term isa BasicSymbolic{T}
                return arguments(term)
            end
        end
        BSImpl.ArrayMaker(; regions, values, args) => begin
            isempty(args) || return ROArgsT{T}(args)
            push!(args, BSImpl.Const{T}(regions))
            push!(args, BSImpl.Const{T}(values))
            return ROArgsT{T}(args)
        end
    end
end

"""
    $TYPEDSIGNATURES

Check if a symbolic expression `expr` represents a function call. Returns `true` if the
expression is a composite expression with an operation and arguments, `false` otherwise.

This function is fundamental for traversing and analyzing symbolic expressions. In
SymbolicUtils.jl, an expression is considered a "call" if it represents a function
application (including operators like +, -, *, etc.).

# Examples
```julia
using SymbolicUtils
@variables x y

# Basic variables are not calls
iscall(x)           # false

# Function calls are calls
expr = sin(x + y)
iscall(expr)        # true

# Arithmetic expressions are calls
iscall(x + y)       # true
iscall(x * y)       # true
```

See also: [`operation`](@ref), [`arguments`](@ref)
"""
function TermInterface.iscall(s::BSImpl.Type)
    !MData.isa_variant(s, BSImpl.Sym) && !MData.isa_variant(s, BSImpl.Const)
end

function TermInterface.maketerm(::Type{BasicSymbolic{TreeReal}}, f, args, metadata; @nospecialize(type = _promote_symtype(f, args)))
    sh = promote_shape(f, shape.(args)...)::ShapeT
    Term{TreeReal}(f, args; type, shape=sh, metadata=metadata)
end

function TermInterface.maketerm(::Type{BasicSymbolic{T}}, f, args, metadata; @nospecialize(type = _promote_symtype(f, args))) where {T}
    @nospecialize f
    args = unwrap_args(args)
    if f isa Symbol
        error(LazyString(f, " must not be a Symbol"))
    elseif f === ArrayOp{T}
        return ArrayOp{T}(args...)::BasicSymbolic{T}
    elseif f isa Mapper
        return f(args...)::BasicSymbolic{T}
    elseif f isa Mapreducer
        return f(args...)::BasicSymbolic{T}
    elseif f === ArrayMaker{T}
        values_arg = args[2]
        @match values_arg begin
            BSImpl.Term(; f = vf, args = vargs) => if vf === array_literal
                return ArrayMaker{T}(unwrap_const(args[1])::RegionsT, @view(vargs[2:end]))
            elseif vf <: StaticArraysCore.SVector
                return ArrayMaker{T}(unwrap_const(args[1])::RegionsT, vargs)
            else
                _unreachable()
            end
            BSImpl.Const(; val) => return ArrayMaker{T}(unwrap_const(args[1])::RegionsT, val)
            _ => _unreachable()
        end
    elseif f === broadcast
        _f, _args = Iterators.peel(args)
        res = broadcast(unwrap_const(_f), _args...)
        if metadata !== nothing && iscall(res)
            @set! res.metadata = metadata
        end
        return res::BasicSymbolic{T}
    elseif f isa Fill
        return f(args[1])
    elseif f === getindex
        # This can't call `getindex` because that goes through `@cache`, which is unstable
        # and doesn't precompile.
        res = _getindex(T, unwrap_const.(args)...)
        if metadata !== nothing && iscall(res)
            @set! res.metadata = metadata
        end
        return res::BasicSymbolic{T}
    elseif f === array_literal
        sh = ShapeVecT()
        for dim in unwrap_const(args[1])
            push!(sh, 1:dim)
        end
        BSImpl.Term{T}(f, args; type, shape = sh)
    elseif _numeric_or_arrnumeric_type(type)
        if f === (+)
            res = add_worker(T, args)
            if metadata !== nothing && (isadd(res) || (isterm(res) && operation(res) == (+)))
                @set! res.metadata = metadata
            end
            return res
        elseif f === (-)
            if length(args) == 1
                res = mul_worker(T, (-1, args[1]))
            else
                res = add_worker(T, (args[1], -args[2]))
            end
            if metadata !== nothing && (isadd(res) || (isterm(res) && operation(res) == (+)))
                @set! res.metadata = metadata
            end
            return res
        elseif f === (*)
            res = mul_worker(T, args)
            if metadata !== nothing && (ismul(res) || (isterm(res) && operation(res) == (*)))
                @set! res.metadata = metadata
            end
            return res
        elseif f === (/)
            @assert length(args) == 2
            res = args[1] / args[2]
            if metadata !== nothing && isdiv(res)
                @set! res.metadata = metadata
            end
            return res
        elseif f === (^) && length(args) == 2
            res = args[1] ^ args[2]
            if metadata !== nothing && ispow(res)
                @set! res.metadata = metadata
            end
            return res
        else
            @goto FALLBACK
        end
    else
        @label FALLBACK
        sh = promote_shape(f, shape.(args)...)
        Term{T}(f, args; type, shape=sh, metadata=metadata)
    end
end

using SymbolicUtils, SymbolicUtils.Code
using SymbolicUtils: IRStructure, SymReal, ShapeVecT, FnType
using Test

test_repr(a, b) = @test repr(Base.remove_linenums!(a)) == repr(Base.remove_linenums!(b))

@testset "`symFunc` construction" begin
    @syms x::Real y::Real

    # Scalar body: type and shape
    f = Code.symFunc([x, y], x + y)
    @test SymbolicUtils.iscall(f)
    @test SymbolicUtils.operation(f) === Code.Func
    args_t, body_t = SymbolicUtils.arguments(f)
    @test SymbolicUtils.operation(args_t) === tuple
    @test SymbolicUtils.symtype(f) == FnType{Tuple{Real, Real}, Real, Nothing}
    @test SymbolicUtils.shape(f) == ShapeVecT()

    # Array body: shape propagates from body
    @syms A::AbstractMatrix{Real}
    body_arr = A * [x, y]
    f_arr = Code.symFunc([x, y], body_arr)
    @test SymbolicUtils.symtype(f_arr) == FnType{Tuple{Real, Real}, Vector{Real}, Nothing}
    @test SymbolicUtils.shape(f_arr) == SymbolicUtils.shape(body_arr)
end

@testset "`symFunc` codegen — scalar body" begin
    @syms x::Real y::Real
    f = Code.symFunc([x, y], x + y)
    ir = IRStructure{SymReal}()
    expr = Code.fast_toexpr(f, ir, Dict{Any,Any}())
    fn = eval(expr)
    @test fn(3.0, 4.0) ≈ 7.0
    @test fn(-1.0, 1.0) ≈ 0.0
end

@testset "`symFunc` codegen — array body" begin
    @syms x::Real y::Real A::AbstractMatrix{Real}
    body = A * [x, y]
    f = Code.symFunc([x, y], body)
    ir = IRStructure{SymReal}()
    Av = [1.0 2.0; 3.0 4.0]
    expr = Code.fast_toexpr(f, ir, Dict{Any,Any}())
    fn = eval(quote
        let A = $Av
            $expr
        end
    end)
    @test fn(1.0, 2.0) ≈ [5.0, 11.0]
    @test fn(0.0, 1.0) ≈ [2.0, 4.0]
end

@testset "`symFunc` CSE — body shared with outer expression" begin
    @syms x::Real y::Real
    shared = x + y
    f = Code.symFunc([x, y], shared * shared)
    ir = IRStructure{SymReal}()
    expr = Code.fast_toexpr(f, ir, Dict{Any,Any}())
    fn = eval(expr)
    @test fn(2.0, 3.0) ≈ 25.0
end

@testset "`symFunc` rewrites restored — args usable after symFunc in shared rewrites" begin
    @syms x::Real y::Real
    f = Code.symFunc([x, y], x + y)
    # Share one rewrites dict across two fast_toexpr calls.
    # Without the fix, codegenning `f` permanently adds `x` and `y` to `rewrites`
    # as function-parameter names (only valid inside the function body). The
    # second fast_toexpr would then emit `__cse = __argₛᵧₘXXX` for `x`, so the
    # generated `x + y` expression would reference undefined names.
    rewrites = Dict{Any,Any}()
    ir1 = IRStructure{SymReal}()
    Code.fast_toexpr(f, ir1, rewrites)   # populates rewrites; must not pollute x/y entries

    ir2 = IRStructure{SymReal}()
    expr_xy = Code.fast_toexpr(x + y, ir2, rewrites)
    result = eval(quote
        let x = 3.0, y = 4.0
            $expr_xy
        end
    end)
    @test result ≈ 7.0
end

@testset "`promote_symtype` for `Assignment`" begin
    @test SymbolicUtils.promote_symtype(Code.Assignment, Real, Real) == Real
    @test SymbolicUtils.promote_symtype(Code.Assignment, Any, Float64) == Float64
    @test SymbolicUtils.promote_symtype(Code.Assignment, Any, Vector{Real}) == Vector{Real}
end

@testset "`symAssignment` construction" begin
    @syms x::Real y::Real
    asgn = Code.symAssignment(x, x + y)
    @test SymbolicUtils.iscall(asgn)
    @test SymbolicUtils.operation(asgn) === Code.Assignment
    lhs_t, rhs_t = SymbolicUtils.arguments(asgn)
    @test isequal(lhs_t, x)
    @test isequal(rhs_t, x + y)
    @test SymbolicUtils.symtype(asgn) == Real
    @test SymbolicUtils.shape(asgn) == ShapeVecT()

    # Array rhs: shape propagates from rhs
    @syms A::AbstractMatrix{Real}
    body_arr = A * [x, y]
    asgn_arr = Code.symAssignment(x, body_arr)
    @test SymbolicUtils.symtype(asgn_arr) == Vector{Real}
    @test SymbolicUtils.shape(asgn_arr) == SymbolicUtils.shape(body_arr)
end

@testset "`symAssignment` codegen — scalar rhs" begin
    @syms x::Real y::Real
    asgn = Code.symAssignment(x, x + y)
    ir = IRStructure{SymReal}()
    expr = Code.fast_toexpr(asgn, ir, Dict{Any,Any}())
    result = eval(quote
        let x = 3.0, y = 4.0
            $expr
        end
    end)
    @test result ≈ 7.0
end

@testset "`symAssignment` codegen — array rhs" begin
    @syms x::Real y::Real A::AbstractMatrix{Real}
    @syms out[1:2]::Real
    body = A * [x, y]
    asgn = Code.symAssignment(out, body)
    ir = IRStructure{SymReal}()
    Av = [1.0 2.0; 3.0 4.0]
    expr = Code.fast_toexpr(asgn, ir, Dict{Any,Any}())
    result = eval(quote
        let A = $Av, x = 1.0, y = 2.0, out = zeros(2)
            $expr
        end
    end)
    @test result ≈ [5.0, 11.0]
end

@testset "`symAssignment` inside `symFunc`" begin
    # A symAssignment inside a symFunc body: f(x,y) evaluates (x = x+y; x)
    @syms x::Real y::Real
    asgn = Code.symAssignment(x, x + y)
    f = Code.symFunc([x, y], asgn)
    @test SymbolicUtils.symtype(f) == FnType{Tuple{Real, Real}, Real, Nothing}
    ir = IRStructure{SymReal}()
    expr = Code.fast_toexpr(f, ir, Dict{Any,Any}())
    fn = eval(expr)
    @test fn(3.0, 4.0) ≈ 7.0
end

@testset "`symAssignment` with `x(t)` lhs does not generate function" begin
    @syms t::Real x(t)::Real
    asgn = Code.symAssignment(x(t), t + 1)
    ir = IRStructure{SymReal}()
    expr = Code.fast_toexpr(asgn, ir, Dict{Any, Any}(:readable_variables => true))
    test_repr(
        expr, quote
            local var"##cse#0" = (var"x(t)" = begin
                local var"##cse#0" = 1
                local var"##cse#1" = t
                local var"##cse#2" = $(+)(var"##cse#0", var"##cse#1")
            end)
        end
    )
end

@testset "`promote_symtype` for `Let`" begin
    @test SymbolicUtils.promote_symtype(Code.Let, Real) == Real
    @test SymbolicUtils.promote_symtype(Code.Let, Real, Float64) == Float64
    @test SymbolicUtils.promote_symtype(Code.Let, Real, Real, Vector{Real}) == Vector{Real}
end

@testset "`symLet` construction" begin
    @syms x::Real y::Real z::Real
    asgn = Code.symAssignment(x, y + 1)
    l = Code.symLet([asgn], x * z)
    @test SymbolicUtils.iscall(l)
    @test SymbolicUtils.operation(l) === Code.Let
    args = SymbolicUtils.arguments(l)
    @test length(args) == 2
    @test isequal(args[1], asgn)
    @test isequal(args[2], x * z)
    @test SymbolicUtils.symtype(l) == Real
    @test SymbolicUtils.shape(l) == ShapeVecT()

    # Empty assignments — body type propagates
    l_empty = Code.symLet(typeof(x)[], x + y)
    @test SymbolicUtils.symtype(l_empty) == Real
    @test length(SymbolicUtils.arguments(l_empty)) == 1
end

@testset "`symLet` codegen — single assignment" begin
    @syms x::Real y::Real
    # let x = y + 1; x * 2 end  →  (y+1)*2
    l = Code.symLet([Code.symAssignment(x, y + 1)], x * 2)
    ir = IRStructure{SymReal}()
    expr = Code.fast_toexpr(l, ir, Dict{Any,Any}())
    result = eval(quote
        let x = 0.0, y = 3.0
            $expr
        end
    end)
    @test result ≈ 8.0   # (3+1)*2
end

@testset "`symLet` codegen — sequential assignments" begin
    @syms x::Real y::Real z::Real
    # let x = y + 1; z = x * 2; z + x end  →  ((y+1)*2) + (y+1)
    asgn1 = Code.symAssignment(x, y + 1)
    asgn2 = Code.symAssignment(z, x * 2)
    l = Code.symLet([asgn1, asgn2], z + x)
    ir = IRStructure{SymReal}()
    expr = Code.fast_toexpr(l, ir, Dict{Any,Any}())
    result = eval(quote
        let x = 0.0, y = 3.0, z = 0.0
            $expr
        end
    end)
    @test result ≈ 12.0  # (3+1)*2 + (3+1) = 8 + 4
end

@testset "`symLet` codegen — empty assignments" begin
    @syms x::Real y::Real
    l = Code.symLet(typeof(x)[], x + y)
    ir = IRStructure{SymReal}()
    expr = Code.fast_toexpr(l, ir, Dict{Any,Any}())
    result = eval(quote
        let x = 3.0, y = 4.0
            $expr
        end
    end)
    @test result ≈ 7.0
end

@testset "Self-referential assignment inside `symLet`" begin
    @syms x::Real y::Real
    l = Code.symLet([Code.symAssignment(x, x + y)], x + y)
    ir = IRStructure{SymReal}()
    # `test_repr` won't work without `:readable_variables => true`, but that
    # also masks the codegen intricacies with self-referential assignments.
    expr = Code.fast_toexpr(l, ir, Dict{Any,Any}())
    result = eval(quote
        let x = 3.0, y = 4.0
            $expr
        end
    end)
    @test result ≈ 11.0
end

@testset "`symLet` inside `symFunc`" begin
    @syms x::Real y::Real tmp::Real
    # f(x,y) = let tmp = x+y; tmp*tmp end  →  (x+y)^2
    l = Code.symLet([Code.symAssignment(tmp, x + y)], tmp * tmp)
    f = Code.symFunc([x, y], l)
    @test SymbolicUtils.symtype(f) == FnType{Tuple{Real,Real}, Real, Nothing}
    ir = IRStructure{SymReal}()
    expr = Code.fast_toexpr(f, ir, Dict{Any,Any}())
    fn = eval(expr)
    @test fn(2.0, 3.0) ≈ 25.0
    @test fn(1.0, 0.0) ≈ 1.0
end

@testset "`promote_symtype` for `DestructuredArgs`" begin
    @test SymbolicUtils.promote_symtype(Code.DestructuredArgs, Vector{Real}) == Vector{Real}
    @test SymbolicUtils.promote_symtype(Code.DestructuredArgs, Vector{Real}, Real, Real) == Vector{Real}
end

@testset "`symDestructuredArgs` construction" begin
    @syms arr[1:2]::Real x::Real y::Real
    da = Code.symDestructuredArgs(arr, [x, y])
    @test SymbolicUtils.iscall(da)
    @test SymbolicUtils.operation(da) === Code.DestructuredArgs
    args = SymbolicUtils.arguments(da)
    @test length(args) == 3
    @test isequal(args[1], arr)
    @test isequal(args[2], x)
    @test isequal(args[3], y)
    @test SymbolicUtils.symtype(da) == SymbolicUtils.symtype(arr)
    @test SymbolicUtils.shape(da) == SymbolicUtils.shape(arr)
end

@testset "`symDestructuredArgs` in `symFunc` — basic destructuring" begin
    @syms arr[1:2]::Real x::Real y::Real
    da = Code.symDestructuredArgs(arr, [x, y])
    f = Code.symFunc([da], x + y)
    @test SymbolicUtils.symtype(f) == FnType{Tuple{Vector{Real}}, Real, Nothing}
    ir = IRStructure{SymReal}()
    expr = Code.fast_toexpr(f, ir, Dict{Any,Any}())
    fn = eval(expr)
    @test fn([3.0, 4.0]) ≈ 7.0
    @test fn([1.0, -1.0]) ≈ 0.0
end

@testset "`symDestructuredArgs` in `symFunc` — mixed with plain args" begin
    # f(x, arr) = x + arr[1] + arr[2]
    @syms arr[1:2]::Real x::Real a::Real b::Real
    da = Code.symDestructuredArgs(arr, [a, b])
    f = Code.symFunc([x, da], x + a + b)
    @test SymbolicUtils.symtype(f) == FnType{Tuple{Real, Vector{Real}}, Real, Nothing}
    ir = IRStructure{SymReal}()
    expr = Code.fast_toexpr(f, ir, Dict{Any,Any}())
    fn = eval(expr)
    @test fn(1.0, [2.0, 3.0]) ≈ 6.0
    @test fn(10.0, [0.0, -5.0]) ≈ 5.0
end

@testset "`symDestructuredArgs` rewrites restored after `symFunc`" begin
    @syms arr[1:2]::Real x::Real y::Real
    da = Code.symDestructuredArgs(arr, [x, y])
    f = Code.symFunc([da], x + y)
    rewrites = Dict{Any,Any}()
    ir1 = IRStructure{SymReal}()
    Code.fast_toexpr(f, ir1, rewrites)   # must not leave arr, x, y in rewrites
    ir2 = IRStructure{SymReal}()
    expr_xy = Code.fast_toexpr(x + y, ir2, rewrites)
    result = eval(quote
        let x = 3.0, y = 4.0
            $expr_xy
        end
    end)
    @test result ≈ 7.0
end

@testset "`symFunc` involving already-generated expression of argument" begin
    # If `symFunc` took an argument that is already present in the outer function and
    # contained in its body an expression already generated, it would refer to the
    # previously generated expression instead of re-computing it in terms of the argument.
    # See the test case for an example.
    @syms x y
    sfn = Code.symFunc([x], 2x + y)
    # `fn` takes `x` as an argument, same as `sfn`. `atan` ensures `2x` is already generated
    # before the body of `sfn`. Previously, the body of `sfn` would refer to the outer `2x`.
    # In other words, calling `fn` would have been equivalent to `atan(2x, 2x + y)` instead
    # of the correct `atan(2x, 2 * (2x + y) + y)`.
    fn = Code.Func([x, y], [], atan(2x, sfn(2x + y)))
    f = eval(Code.fast_toexpr(fn, IRStructure{SymReal}(), Dict()))
    @test f(1.0, 2.0) ≈ atan(2.0, 2 * (2.0 + 2.0) + 2.0)
end

using SymbolicUtils
using SymbolicUtils: BasicSymbolic, @cache, associated_cache, set_limit!, get_limit,
                     clear_cache!, SymbolicKey, metadata, maketerm, get_cache_key,
                     unwrap_const
using OhMyThreads: tmap
using Random

@cache function f1(x::BasicSymbolic)::BasicSymbolic
    return 2x + 1
end

@testset "::BasicSymbolic" begin
    @syms x
    val = f1(x)
    @test isequal(val, 2x + 1)
    cachestruct = associated_cache(f1)
    cache, stats = cachestruct.tlv[]
    @test cache isa Dict{SymbolicKey, BasicSymbolic}
    @test length(cache) == 1
    @test cache[get_cache_key(x)] === val
    @test stats.hits == 0
    @test stats.misses == 1
    f1(x)
    @test stats.hits == 1
    @test stats.misses == 1

    xx = setmetadata(x, Int, 0)
    val = f1(xx)
    @test length(cache) == 2
    @test stats.misses == 2

    set_limit!(f1, 10)
    @test get_limit(f1) == 10
    SymbolicUtils.set_retain_fraction!(f1, 0.1)
    @test SymbolicUtils.get_retain_fraction(f1) == 0.1
    for i in 1:8
        xx = setmetadata(xx, Int, i)
        f1(xx)
        @test length(cache) == i + 2
    end
    xx = setmetadata(xx, Int, 9)
    f1(xx)
    @test length(cache) < 10
    @test stats.clears == 1

    hits = stats.hits
    misses = stats.misses
    len = length(cache)

    @syms x::Float64 # different symtype
    val = f1(x)
    @test length(cache) == len + 1
    @test stats.hits == hits
    @test stats.misses == misses + 1
    @test f1(x) === val
    @test stats.hits == hits + 1

    clear_cache!(f1)
    @test length(cache) == 0
    stats = SymbolicUtils.get_stats(f1)
    @test stats.hits == stats.misses == stats.clears == 0
    @test SymbolicUtils.is_caching_enabled(f1)
    SymbolicUtils.toggle_caching!(f1, false)
    @test !SymbolicUtils.is_caching_enabled(f1)
    f1(x)
    @test isempty(cache)
    @test stats.hits == stats.misses == stats.clears == 0
end

@cache function f2(x::Union{BasicSymbolic, UInt})::Union{BasicSymbolic, UInt}
    return 2x + 1
end

# @testset "::Union (with `UInt`)" begin
#     @syms x
#     val = f2(x)
#     @test isequal(val, 2x + 1)
#     cachestruct = associated_cache(f2)
#     cache, stats = cachestruct.tlv[]
#     @test cache isa Dict{Tuple{Union{SymbolicKey, UInt}}, Union{BasicSymbolic, UInt}}
#     @test length(cache) == 1
#     @test cache[(get_cache_key(x),)] === val
#     @test stats.hits == 0
#     @test stats.misses == 1
#     f2(x)
#     @test stats.hits == 1
#     @test stats.misses == 1

#     y = get_cache_key(x).id
#     val = f2(y)
#     @test val == 2y + 1
#     @test length(cache) == 2
#     @test cache[(y,)] == val
#     @test stats.misses == 2

#     clear_cache!(f2)
#     @test length(cache) == 0
#     @test stats.hits == stats.misses == stats.clears == 0
# end

@cache function f3(x)::Union{BasicSymbolic, Int}
    return 2x + 1
end

@cache function f3_2(x::Any)::Union{BasicSymbolic, Int}
    return 2x + 1
end

@testset "$name" for (name, fn) in [("implicit ::Any", f3), ("explicit ::Any", f3_2)]
    @syms x
    val = fn(x)
    @test isequal(val, 2x + 1)
    cachestruct = associated_cache(fn)
    cache, stats = cachestruct.tlv[]
    @test cache isa Dict{Any, Union{BasicSymbolic, Int}}
    @test length(cache) == 1
    @test cache[get_cache_key(x)] === val
    @test stats.hits == 0
    @test stats.misses == 1
    fn(x)
    @test stats.hits == 1
    @test stats.misses == 1

    val = fn(3)
    @test val == 7
    @test length(cache) == 2
    @test stats.misses == 2

    clear_cache!(fn)
    @test length(cache) == 0
    @test stats.hits == stats.misses == stats.clears == 0
end

@cache function f4(x::Union{BasicSymbolic, Number})::Union{BasicSymbolic, Number}
    unwrap_const(x) isa Number && return x
    if iscall(x)
        return maketerm(typeof(x), operation(x), map(f4, arguments(x)), metadata(x))
    end
    return f3(x)
end

@testset "Threading" begin
    @syms x y z
    @test isequal(f4(2x + 1), 2(2x + 1) + 1)
    rng = Xoshiro(3)
    function build_rand_expr(vars, depth, maxdepth)
        if depth < maxdepth
            v = build_rand_expr(vars, depth + 1, maxdepth)
        else
            v = rand(rng, vars)
        end
        if isodd(depth)
            return v + rand(rng, [1:3; vars])
        else
            return v * rand(rng, [1:3; vars])
        end
    end

    exprs = [build_rand_expr([x, y, z], 0, 100) for _ in 1:1000]
    result = tmap(f4, exprs)
    truevals = map(f4, exprs)
    @test isequal(result, truevals)
end

@cache limit = 10 retain_fraction = 0.1 function f6(x::BasicSymbolic, y::Union{BasicSymbolic, Int}, z)::BasicSymbolic
    return x + y + z
end

@testset "Keyword argument syntax works" begin
    @test SymbolicUtils.get_limit(f6) == 10
    @test SymbolicUtils.get_retain_fraction(f6) ≈ 0.1
end

"""
```julia
simplify(x; expand=false,
            threaded=false,
            thread_subtree_cutoff=100,
            rewriter=nothing)
```

Simplify an expression (`x`) by applying `rewriter` until there are no changes.
`expand=true` applies [`expand`](@ref) in the beginning of each fixpoint iteration.

By default, simplify will assume denominators are not zero and allow cancellation in fractions.
Pass `simplify_fractions=false` to prevent this.
"""
@inline function simplify(x;
                  expand=false,
                  polynorm=nothing,
                  threaded=false,
                  simplify_fractions=true,
                  thread_subtree_cutoff=100,
                  rewriter=nothing)
    if polynorm !== nothing
        Base.depwarn("simplify(..; polynorm=$polynorm) is deprecated, use simplify(..; expand=$polynorm) instead",
                        :simplify)
        expand = polynorm  # Use polynorm value as expand for backward compatibility
    end

    f = if rewriter === nothing
        if threaded
            threaded_simplifier(thread_subtree_cutoff)
        elseif expand
            serial_expand_simplifier
        else
            serial_simplifier
        end
    else
        Fixpoint(rewriter)
    end

    x = PassThrough(f)(x)
    simplify_fractions && query(isdiv, x) ?
        SymbolicUtils.simplify_fractions(x) : x
end

Base.@deprecate simplify(x, ctx; kwargs...)  simplify(x; rewriter=ctx, kwargs...)

include("fuzzlib.jl")

using Random: seed!

seed!(8258)
    @time @testset "expand fuzz" begin
        for i=1:500
            i % 100 == 0 && @info "expand fuzz" iter=i
            fuzz_test(5, num_spec, SymbolicUtils.expand; min_depth=3)
        end
    end

    @testset "simplify_fractions fuzz" begin
        for i=1:200
            i % 100 == 0 && @info "simplify_fractions fuzz" iter=i
            fuzz_test(5, num_spec, SymbolicUtils.simplify_fractions; min_depth=3)
        end
    end

    @time @testset "num fuzz" begin
        for i=1:1500
            i % 100 == 0 && @info "num fuzz" iter=i
            fuzz_test(5, num_spec)
        end
    end
    @time @testset "bool fuzz" begin
        for i=1:500
            seed!(i)
            i % 100 == 0 && @info "bool fuzz" iter=i
            fuzz_test(5, bool_spec)
        end
    end
    @testset "fuzz addmulpow" begin
        @time for i=1:100
            fuzz_addmulpow(1)
        end
        @time for i=1:50
            fuzz_addmulpow(2)
        end
        @time for i=1:25
            fuzz_addmulpow(3)
        end
        @time for i=1:12
            fuzz_addmulpow(4)
        end
    end

    @testset "fuzz StableIndex" begin
        for _ in 1:10
            axes = UnitRange{Int}[]
            nd = rand(2:5)
            for i in 1:nd
                left = rand(-5:5)
                right = rand(left:10)
                push!(axes, left:right)
            end
            axes_tup = Tuple(axes)

            for _ in 1:100
                idx = Int[]
                for i in 1:nd
                    push!(idx, rand(axes[i]))
                end
                si = SymbolicUtils.StableIndex(idx)

                cartidx = CartesianIndex(Tuple(idx))
                cart_idx_truth = findfirst(isequal(cartidx), CartesianIndices(axes_tup))
                lin_idx_truth = LinearIndices(axes_tup)[cart_idx_truth]
                lin_idx_generated = SymbolicUtils.as_linear_idx(axes_tup, si)
                lin_idx_shapevect = SymbolicUtils.as_linear_idx(SymbolicUtils.ShapeVecT(axes), si)
                if lin_idx_generated == lin_idx_truth == lin_idx_shapevect
                    @test true
                else
                    @test_broken false
                    println("""
                    Broken StableIndex test:
                    - axes: $axes
                    - idx: $idx
                    - lin_idx_truth: $lin_idx_truth
                    - lin_idx_generated: $lin_idx_generated
                    - lin_idx_shapevect: $lin_idx_shapevect
                    """)
                end
            end
        end
    end

"""
    show_metadata(io, x) -> Bool

Hook for custom printing based on metadata. Return `true` if printing has been handled.
Downstream packages can extend `show_metadata(io, x, ::Type{Ctx}, val)` for their
metadata context and call `show_plain(io, x)` to bypass this hook.
"""
function show_metadata(io::IO, x::BasicSymbolic)
    md = metadata(x)
    md isa Base.ImmutableDict{DataType, Any} || return false
    for (ctx, val) in md
        show_metadata(io, x, ctx, val) && return true
    end
    return false
end

show_metadata(::IO, ::BasicSymbolic, ::DataType, @nospecialize(val)) = false

function show_plain(io::IO, x::BasicSymbolic{TreeReal})
    @match x begin
        BSImpl.Sym(; name) => Base.show_unquoted(io, name)
        BSImpl.Const(; val) => begin
            paren = val isa Union{Complex, Rational}
            if paren
                printstyled(io, "("; color = :blue)
            end
            printstyled(io, val; color = :blue)
            if paren
                printstyled(io, ")"; color = :blue)
            end
        end
        _ => show_term(io, x)
    end
end

function show_plain(io::IO, x::BasicSymbolic)
    @match x begin
        BSImpl.Sym(; name) => Base.show_unquoted(io, name)
        BSImpl.Const(; val) => begin
            paren = val isa Union{Complex, Rational}
            if paren
                printstyled(io, "("; color = :blue)
            end
            printstyled(io, val; color = :blue)
            if paren
                printstyled(io, ")"; color = :blue)
            end
        end
        BSImpl.ArrayOp(;) => show_arrayop(io, x)
        BSImpl.ArrayMaker(;) => show_arraymaker(io, x)
        BSImpl.AddMul(; variant) => if variant === AddMulVariant.ADD
                show_add(io, x)
            else
                show_mul(io, x)
            end
        _ => show_term(io, x)
    end
end

function Base.show(io::IO, x::BasicSymbolic{TreeReal})
    show_metadata(io, x) && return
    show_plain(io, x)
end

function Base.show(io::IO, x::BasicSymbolic)
    show_metadata(io, x) && return
    show_plain(io, x)
end

show_term(io::IO, x::BasicSymbolic{TreeReal}) = show_call(io, operation(x), x)

function show_term(io::IO, x::BasicSymbolic)
    f = operation(x)
    if f === (+)
        show_add(io, x)
    elseif f === (*)
        show_mul(io, x)
    elseif f === (^)
        show_pow(io, x)
    elseif f === getindex
        show_ref(io, x)
    elseif f === identity && (arg = arguments(x)[1]; isconst(arg))
        show(io, arg)
    else
        # Break the back edge to avoid invalidations cascading up
        @invokelatest show_call(io, f, x)
    end
end

function show_call(io::IO, @nospecialize(f), x::BasicSymbolic{T}; @nospecialize(kw...)) where {T}
    args = parent(arguments(x))
    len_args = length(args)
    fname = applicable(nameof, f)::Bool && !(f isa BasicSymbolic{T}) ? nameof(f)::Symbol : :_
    if Base.isunaryoperator(fname) && len_args == 1
        print(io, fname)
        print_arg(io, args[1])
        return
    end
    if Base.isbinaryoperator(fname) && len_args > 1
        @union_split_smallvec args begin
            for (i, t) in enumerate(args)
                i == 1 || print(io, " ", fname, " ")
                print_arg(io, t)
            end
        end
        return
    end
    Base.show(io, f)
    print(io, "(")
    @union_split_smallvec args begin
        for (i, t) in enumerate(args)
            print(io, t)
            i == len_args || print(io, ", ")
        end
    end
    if !isempty(kw)
        print(io, "; ")
        len_kwargs = length(kw)
        for (i, (k, v)) in enumerate(kw)
            print(io, k, " = ")
            print_arg(io, v)
            i == len_kwargs || print(io, ", ")
        end
    end
    print(io, ")")
end

function show_call(io::IO, @nospecialize(f::SymbolicRound), x::BasicSymbolic{T}) where {T}
    inner = first(arguments(x))
    print(io, "round(")
    printstyled(io, symtype(x); color = :blue)
    print(io, ", ")
    print(io, inner)
    print(io, ", ")
    printstyled(io, f.mode; color = :blue)
    print(io, ")")
end

function show_call(io::IO, @nospecialize(f::Mapper), x::BasicSymbolic{T}) where {T}
    _args = arguments(x)
    args = ArgsT{T}()
    sizehint!(args, length(_args) + 1)
    push!(args, BSImpl.Const{T}(f.f; unsafe = false))
    append!(args, _args)

    newx = BSImpl.Term{T}(map, args; type = Any, shape = ShapeVecT(), unsafe = false)
    show_call(io, map, newx)
end

function show_call(io::IO, @nospecialize(f::Mapreducer), x::BasicSymbolic{T}) where {T}
    _args = arguments(x)
    args = ArgsT{T}()
    sizehint!(args, length(_args) + 2)
    push!(args, BSImpl.Const{T}(f.f; unsafe = false))
    push!(args, BSImpl.Const{T}(f.reduce; unsafe = false))
    append!(args, _args)

    newx = BSImpl.Term{T}(mapreduce, args; type = Any, shape = ShapeVecT(), unsafe = false)
    if f.dims isa Colon && f.init === nothing
        show_call(io, mapreduce, newx)
    elseif f.dims isa Colon
        show_call(io, mapreduce, newx; init = f.init)
    elseif f.init === nothing
        show_call(io, mapreduce, newx; dims = f.dims)
    else
        show_call(io, mapreduce, newx; dims = f.dims, init = f.init)
    end
end

function show_pow(io::IO, x::BasicSymbolic)
    base, exp = @match x begin
        BSImpl.Term(; args) => args
    end
    if isnegative(base)
        print(io, "(")
        print(io, base)
        print(io, ")")
    else
        print_arg(io, base)
    end
    print(io, "^")
    print_arg(io, exp)
end

function show_ref(io::IO, var::BasicSymbolic)
    args = @match var begin
        BSImpl.Term(; args) => args
    end
    @union_split_smallvec args begin
        x = args[1]
        idx = @view(args[2:end])
        @match x begin
            BSImpl.Sym(; name) && if name === IDXS_SYM end => begin
                @assert length(idx) == 1
                print(io, "_", idx[1])
                return
            end
            _ => nothing
        end
        ic = iscall(x)
        ic && print(io, "(")
        print(io, x)
        ic && print(io, ")")
        print(io, "[")
        for (i, ii) in enumerate(idx)
            print_arg(io, ii)
            i == lastindex(idx) || print(io, ", ")
        end
        print(io, "]")
    end
end

function _isnegative(@nospecialize(val))
    if val isa Int
        return val < 0
    elseif val isa Int32
        return val < 0
    elseif val isa BigInt
        return val < 0
    elseif val isa Float64
        return val < 0
    elseif val isa Float32
        return val < 0
    elseif val isa BigFloat
        return val < 0
    elseif val isa Rational{Int}
        return val < 0
    elseif val isa Real
        return (val < 0)::Bool
    else
        return false
    end
end

function isnegative(x::BasicSymbolic)
    @match x begin
        BSImpl.Const(; val) => _isnegative(val)
        BSImpl.AddMul(; coeff, variant) && if variant === AddMulVariant.MUL end => _isnegative(coeff)
        _ => false
    end
end

print_arg(io::IO, x) = print(io, x)
function print_arg(io::IO, x::BasicSymbolic; paren = true)
    paren && iscall(x) && return print_arg(io, operation(x), x; paren)
    print(io, x)
end

function print_arg(io::IO, @nospecialize(f), x::BasicSymbolic; paren = true)
    paren || return print(io, x)
    iscall(f)::Bool && return print(io, x)

    if f === (*) || f === (+) || f === (^) || f === (/) || (applicable(nameof, f)::Bool && Base.isbinaryoperator(nameof(f)::Symbol)::Bool)
        print(io, "(", x, ")")
    else
        print(io, x)
    end
end

function remove_minus(t::BasicSymbolic{T}) where {T}
    @match t begin
        BSImpl.Const(; val) => return BSImpl.Const{T}(-val; unsafe = false)
        BSImpl.AddMul(; coeff, dict, type, shape, variant) && if variant === AddMulVariant.MUL end => begin
            return BSImpl.AddMul{T}(-coeff, dict, variant; type, shape, unsafe = false)
        end
    end
end

function show_add(io::IO, x::BasicSymbolic)
    show_add(io, parent(sorted_arguments(x)))
end

function show_add(io::IO, args::ArgsT{T}) where {T}
    @union_split_smallvec args begin
        for (i, t) in enumerate(args)
            neg_result = isnegative(t)
            neg = neg_result isa Bool ? neg_result : false
            if i == 1
                neg && print(io, "-")
            else
                print(io, neg ? " - " : " + ")
            end
            if !neg
                show(io, t)
                continue
            end
            @match t begin
                BSImpl.Const(; val) => show(io, BSImpl.Const{T}(-val; unsafe = true))
                BSImpl.AddMul(;) => begin
                    args = copy(parent(sorted_arguments(t)))
                    @union_split_smallvec args begin
                        args[1] = BSImpl.Const{T}(-unwrap_const(args[1]); unsafe = true)
                    end
                    show_mul(io, args)
                end
            end
        end
    end
end

function _isminus(@nospecialize(val))
    if val isa Int
        return val == -1
    elseif val isa Int32
        return val == -1
    elseif val isa BigInt
        return val == -1
    elseif val isa Float64
        return val == -1
    elseif val isa Float32
        return val == -1
    elseif val isa BigFloat
        return val == -1
    elseif val isa Rational{Int}
        return val == -1
    elseif val isa Number
        return (val == -1)::Bool
    else
        return false
    end
end
function _isunit(@nospecialize(val))
    if val isa Int
        return val == 1
    elseif val isa Int32
        return val == 1
    elseif val isa BigInt
        return val == 1
    elseif val isa Float64
        return val == 1
    elseif val isa Float32
        return val == 1
    elseif val isa BigFloat
        return val == 1
    elseif val isa Rational{Int}
        return val == 1
    elseif val isa Number
        return (val == 1)::Bool
    else
        return false
    end
end

function _is_paren_scalar(@nospecialize(x))
    return x isa Complex && !iszero(imag(x))::Bool || x isa Rational || x isa Number && !isfinite(x)::Bool
end

function isnumberconst(x::BasicSymbolic)
    @match x begin
        BSImpl.Const(; val) => val isa Number
        _ => false
    end
end

function show_mul(io::IO, x::BasicSymbolic)
    show_mul(io, parent(sorted_arguments(x)))
end

function show_mul(io::IO, args::ArgsT{T}) where {T}
    length(args) == 1 && return print_arg(io, args[1])

    arg1 = args[1]
    arg2 = args[2]
    isminus = @match arg1 begin
        BSImpl.Const(; val) => _isminus(val)
        _ => false
    end
    isunit = @match arg1 begin
        BSImpl.Const(; val) => _isunit(val)
        _ => false
    end
    isparenscalar = @match arg1 begin
        BSImpl.Const(; val) => _is_paren_scalar(val)
        _ => false
    end
    nostar = isminus || isunit || (!isparenscalar && isnumberconst(arg1) && !isnumberconst(arg2))

    @union_split_smallvec args begin
        for (i, t) in enumerate(args)
            if i == 1
                if isminus
                    print(io, "-")
                elseif !isunit
                    print_arg(io, t)
                end
                continue
            end
            if !(i == 2 && nostar)
                print(io, "*")
            end
            print_arg(io, t)
        end
    end
end

const SHOW_ARRAYOP = Ref{Bool}(false)
function show_arrayop(io::IO, aop::BasicSymbolic)
    @match aop begin
        BSImpl.ArrayOp(; output_idx, expr, term, reduce, ranges) => begin
            if !SHOW_ARRAYOP[] && term !== nothing && iscall(term)
                return show(io, term)
            end
            print(io, "@arrayop")
            print(io, "(_[$(join(string.(output_idx), ","))] := $(expr))")
            if reduce != +
                print(io, " ($(reduce))")
            end

            if !isempty(ranges)
                print(io, " ", join(["$k in $v" for (k, v) in ranges], ", "))
            end
        end
    end
end

function show_arraymaker(io::IO, x::BasicSymbolic)
    regions, values, shape = @match x begin
        BSImpl.ArrayMaker(; regions, values, shape) => (regions, values, shape)
    end
    shape = shape::ShapeVecT
    compact = get(io, :compact, false)::Bool
    print(io, "@makearray")
    print(io, compact ? "(" : " ")
    print(io, "_[")
    @union_split_smallvec shape join(io, shape, ", ")
    print(io, "]")
    print(io, compact ? ", " : " ")
    print(io, "begin")
    print(io, compact ? "; " : "\n")
    @union_split_smallvec regions @union_split_smallvec values begin
        for (reg, val) in zip(regions, values)
            compact || print(io, "    ")
            print(io, "_[")
            @union_split_smallvec reg join(io, reg, ", ")
            print(io, "] => ")
            print_arg(IOContext(io, :compact => true), val)
            print(io, compact ? "; " : "\n")
        end
    end
    print(io, "end")
    compact && print(io, ")")
end

using SymbolicUtils, Test
using SymbolicUtils: Term, Add, Mul, Div, metadata, BasicSymbolic, PolyCoeffT, ACDict
using SymbolicUtils: Fill, Mapper, Mapreducer, ShapeVecT, SymReal
import MultivariatePolynomials as MP
import TermInterface

isequal2(a, b) = SymbolicUtils.@manually_scope SymbolicUtils.COMPARE_FULL => true isequal(a, b)

const BSImpl = SymbolicUtils.BasicSymbolicImpl

struct Ctx1 end
struct Ctx2 end

struct ThrowingEqualityScalar
    tag::Symbol
    value::Int
end

Base.hash(x::ThrowingEqualityScalar, h::UInt) = hash(x.value, h)
function Base.isequal(a::ThrowingEqualityScalar, b::ThrowingEqualityScalar)
    a.tag === b.tag && return isequal(a.value, b.value)
    throw(ArgumentError("incomparable scalar tags"))
end

@testset "Sym" begin
    x1 = only(@syms x)
    x2 = only(@syms x)
    @test x1.id === x2.id
    x3 = only(@syms x::Float64)
    @test x1.id !== x3.id
    x4 = only(@syms x::Float64)
    @test x1.id !== x4.id
    @test x3.id === x4.id
    x5 = only(@syms x::Int)
    x6 = only(@syms x::Int)
    @test x1.id !== x5.id
    @test x3.id !== x5.id
    @test x5.id === x6.id

    xm1 = setmetadata(x1, Ctx1, "meta_1")
    xm2 = setmetadata(x1, Ctx1, "meta_1")
    @test xm1.id === xm2.id
    xm3 = setmetadata(x1, Ctx2, "meta_2")
    @test xm1.id !== xm3.id
end

@syms a b c

@testset "Term" begin
    t1 = sin(a)
    t2 = sin(a)
    @test t1.id === t2.id
    t3 = Term{SymReal}(identity, [a])
    t4 = Term{SymReal}(identity, [a])
    @test t3.id === t4.id
    t5 = Term{SymReal}(identity, [a]; type = Int)
    @test t3.id !== t5.id
    tm1 = setmetadata(t1, Ctx1, "meta_1")
    @test t1.id !== tm1.id
end

@testset "Add" begin
    d1 = a + b
    d2 = b + a
    @test d1.id === d2.id
    d3 = b - 2 + a
    d4 = a + b - 2
    @test d3.id === d4.id
    d5 = Add{SymReal}(0, ACDict{SymReal}(a => 1, b => 1); type = Int)
    @test d5.id !== d1.id

    dm1 = setmetadata(d1, Ctx1, "meta_1")
    @test d1.id !== dm1.id
end

@testset "Mul" begin
    m1 = a * b
    m2 = b * a
    @test m1.id === m2.id
    m3 = 6 * a * b
    m4 = 3 * a * 2 * b
    @test m3.id === m4.id
    m5 = Mul{SymReal}(1, ACDict{SymReal}(a => 1, b => 1); type = Int)
    @test m5.id !== m1.id

    mm1 = setmetadata(m1, Ctx1, "meta_1")
    @test m1.id !== mm1.id
end

@testset "Div" begin
    v1 = a / b
    v2 = a / b
    @test v1.id === v2.id
    v3 = -1 / a
    v4 = -1 / a
    @test v3.id === v4.id
    v5 = 3a / 6
    v6 = 2a / 4
    @test v5.id === v6.id
    v7 = Div{SymReal}(-1, a, false; type = Float64)
    @test v7.id !== v3.id

    vm1 = setmetadata(v1, Ctx1, "meta_1")
    @test vm1.id !== v1.id
end

@testset "Pow" begin
    p1 = a^b
    p2 = a^b
    @test p1.id === p2.id
    p3 = a^(2^-b)
    p4 = a^(2^-b)
    @test p3.id === p4.id

    pm1 = setmetadata(p1, Ctx1, "meta_1")
    @test pm1.id !== p1.id
end

@testset "Symbolics in metadata" begin
    @syms a b
    a1 = setmetadata(a, Int, b)
    b1 = setmetadata(b, Int, 3)
    a2 = setmetadata(a, Int, b1)
    @test a1.id !== a2.id
    @test !isequal2(a1, a2)
    @test metadata(metadata(a1)[Int]) === nothing
    @test metadata(metadata(a2)[Int])[Int] == 3
end

@testset "Compare metadata of expression tree" begin
    @syms a b
    aa = setmetadata(a, Int, b)
    @test aa.id !== a.id
    @test isequal(a, aa)
    @test !isequal2(a, aa)
    @test !isequal2(2a, 2aa)
end

@testset "Hashconsing can be toggled" begin
    SymbolicUtils.ENABLE_HASHCONSING[] = false
    @syms a b
    x1 = a + b
    x2 = a + b
    @test x1.id === nothing === x2.id
    SymbolicUtils.ENABLE_HASHCONSING[] = true
end

@testset "`hash` is cached" begin
    @syms a b f(..)
    for ex in [a + b, a * b, f(a)]
        h = hash(ex)
        @test h == ex.hash[]
        ex2 = setmetadata(ex, Int, 3)
        # the hash is metadata-free
        @test hash(ex2) == h
    end
end

@testset "Metadata type is considered in hashconsing" begin
    @syms x
    x1 = setmetadata(x, Int, 1)
    x2 = setmetadata(x, Int, 1.0)
    @test x1 !== x2
    @test !isequal2(x1, x2)

    x1 = setmetadata(x, Int, [1])
    x2 = setmetadata(x, Int, [1])
    @test x1 === x2
    @test hash(x1) == hash(x2)
end

@testset "Throwing scalar equality is not a hashconsing match" begin
    @test_throws ArgumentError isequal(
        ThrowingEqualityScalar(:tag1, 1), ThrowingEqualityScalar(:tag2, 1)
    )

    x1 = BSImpl.Const{SymReal}(ThrowingEqualityScalar(:tag1, 1))
    x2 = BSImpl.Const{SymReal}(ThrowingEqualityScalar(:tag2, 1))
    x3 = BSImpl.Const{SymReal}(ThrowingEqualityScalar(:tag1, 1))

    @test x1 !== x2
    @test x1 === x3
    @test !isequal2(x1, x2)
end

@testset "Operations hash by content" begin
    @syms p q

    @testset "Fill" begin
        f1 = Fill(ShapeVecT([1:3, 1:2]))
        f2 = Fill(ShapeVecT([1:3, 1:2]))
        f3 = Fill(ShapeVecT([1:3, 1:4]))
        @test f1 == f2
        @test isequal(f1, f2)
        @test hash(f1) == hash(f2)
        @test isequal(f1, deepcopy(f1)) && hash(f1) == hash(deepcopy(f1))
        @test f1 != f3
        @test hash(f1) != hash(f3)
        # As an `ArrayOp` operation, content-identical fills hash-cons together.
        a1 = f1(p)
        a2 = f2(p)
        @test isequal(a1, a2)
        @test hash(a1) == hash(a2)
    end

    @testset "Mapper" begin
        m1 = Mapper(sin)
        m2 = Mapper(sin)
        m3 = Mapper(cos)
        @test m1 == m2
        @test isequal(m1, m2)
        @test hash(m1) == hash(m2)
        @test isequal(m1, deepcopy(m1)) && hash(m1) == hash(deepcopy(m1))
        @test m1 != m3
        @test hash(m1) != hash(m3)
        # As a `Term` operation, content-identical mappers hash-cons to the same node.
        t1 = Term{SymReal}(Mapper(sin), [p])
        t2 = Term{SymReal}(Mapper(sin), [p])
        @test t1.id === t2.id
        @test hash(t1) == hash(t2)
    end

    @testset "Mapreducer" begin
        r1 = Mapreducer(sin, +, 1, nothing)
        r2 = Mapreducer(sin, +, 1, nothing)
        r3 = Mapreducer(sin, +, 2, nothing)   # different dims
        r4 = Mapreducer(cos, +, 1, nothing)   # different f
        r5 = Mapreducer(sin, +, 1, 0.0)       # different init
        @test r1 == r2
        @test isequal(r1, r2)
        @test hash(r1) == hash(r2)
        @test isequal(r1, deepcopy(r1)) && hash(r1) == hash(deepcopy(r1))
        @test r1 != r3 && hash(r1) != hash(r3)
        @test r1 != r4 && hash(r1) != hash(r4)
        @test r1 != r5 && hash(r1) != hash(r5)
        t1 = Term{SymReal}(Mapreducer(sin, +, 1, nothing), [p])
        t2 = Term{SymReal}(Mapreducer(sin, +, 1, nothing), [p])
        @test t1.id === t2.id
        @test hash(t1) == hash(t2)
    end
end

Base.isequal(::BasicSymbolic, x::Union{Number, AbstractArray}) = false
Base.isequal(x::Union{Number, AbstractArray}, ::BasicSymbolic) = false
Base.isequal(::BasicSymbolic, ::Missing) = false
Base.isequal(::Missing, ::BasicSymbolic) = false

"""
Task-local flag to control whether equality comparisons include metadata and full type
information.
"""
const COMPARE_FULL = TaskLocalValue{Bool}(Returns(false))

macro __generate_isequal_somescalar()
    expr = Expr(:if)
    cur_expr = expr

    N = length(SCALARS)
    for (i, (t1, t2)) in enumerate(Iterators.product(SCALARS, SCALARS))
        push!(cur_expr.args, :(a isa $t1 && b isa $t2))
        push!(cur_expr.args, :(_safe_isequal_somescalar(a, b)))
        i == N * N && continue
        new_expr = Expr(:elseif)
        push!(cur_expr.args, new_expr)
        cur_expr = new_expr
    end

    push!(cur_expr.args, :(_safe_isequal_somescalar(a, b)))
    return esc(expr)
end

"""
    $TYPEDSIGNATURES

Generated function which manually dispatches on `isequal` for common scalar types,
avoiding dynamic dispatch in common cases.
"""
function isequal_somescalar(@nospecialize(a), @nospecialize(b))
    return @__generate_isequal_somescalar
end

function _safe_isequal_somescalar(@nospecialize(a), @nospecialize(b))
    try
        return isequal(a, b)::Bool
    catch err
        err isa InterruptException && rethrow()
        return false
    end
end

"""
    $TYPEDSIGNATURES

Compare two dictionaries of the form inside `AddMul`. Handles the edge case where
the keys are hashed with `full=false` but the current comparison is with `full=true`.
`full` is a boolean which should be the current value of `COMPARE_FULL[]`. Passing it
allows avoiding repeatedly accessing a `TaskLocalValue`, which can be slow.
"""
function isequal_addmuldict(d1::ACDict{T}, d2::ACDict{T}, full::Bool) where {T}
    full || return isequal(d1, d2)
    length(d1) == length(d2) || return false
    for (k, v) in d1
        k2 = nothing
        v2 = nothing
        @manually_scope COMPARE_FULL => false begin
            k2 = getkey(d2, k, nothing)
            k2 === nothing && return false
            v2 = d2[k2]
        end true
        isequal_somescalar(v, v2) && isequal_bsimpl(k, k2, true) || return false
    end
    return true
end

"""
    $TYPEDSIGNATURES

Compare two dictionaries of the form of `ArrayOp.ranges`. Handles the edge case where
the keys are hashed with `full=false` but the current comparison is with `full=true`.
`full` is a boolean which should be the current value of `COMPARE_FULL[]`. Passing it
allows avoiding repeatedly accessing a `TaskLocalValue`, which can be slow.
"""
function isequal_rangesdict(d1::RangesT{T}, d2::RangesT{T}, full) where {T}
    full || return isequal(d1, d2)
    length(d1) == length(d2) || return false
    for (k, v) in d1
        k2 = nothing
        v2 = nothing
        @manually_scope COMPARE_FULL => false begin
            k2 = getkey(d2, k, nothing)
            k2 === nothing && return false
            v2 = d2[k2]
        end true
        isequal(v, v2) && isequal_bsimpl(k, k2, true) || return false
    end
    return true
end

isequal_bsimpl(::BSImpl.Type, ::BSImpl.Type, ::Bool) = false

function isequal_argsvec(v1::ArgsT{T}, v2::ArgsT{T}, full::Bool) where {T}
    @union_split_smallvec v1 begin
        @union_split_smallvec v2 begin
            length(v1) == length(v2) || return false
            for (a, b) in zip(v1, v2)
                isequal_bsimpl(a, b, full) || return false
            end
        end
    end
    return true
end

function metadata_isequal_metadict(m1::Base.ImmutableDict{DataType, Any}, m2::Base.ImmutableDict{DataType, Any})
    xor(isdefined(m1, :parent), isdefined(m2, :parent)) && return false
    isdefined(m1, :parent) || return true
    isequal(m1.key, m2.key) || return false
    metadata_isequal(m1.value, m2.value)::Bool || return false
    return metadata_isequal_metadict(m1.parent, m2.parent)
end

function metadata_isequal(m1::MetadataT, m2::MetadataT)
    @nospecialize m1 m2
    if m1 === nothing && m2 === nothing
        return true
    elseif m1 === nothing || m2 === nothing
        return false
    end
    return metadata_isequal_metadict(m1, m2)
end

function metadata_isequal(m1, m2)
    @nospecialize m1 m2
    typeof(m1) === typeof(m2) || return false
    if m1 isa BasicSymbolic{SymReal} && m2 isa BasicSymbolic{SymReal}
        return isequal_bsimpl(m1, m2, true)
    elseif m1 isa BasicSymbolic{SafeReal} && m2 isa BasicSymbolic{SafeReal}
        return isequal_bsimpl(m1, m2, true)
    elseif m1 isa BasicSymbolic{TreeReal} && m2 isa BasicSymbolic{TreeReal}
        return isequal_bsimpl(m1, m2, true)
    elseif m1 isa Vector{BasicSymbolic{SymReal}} && m2 isa Vector{BasicSymbolic{SymReal}}
        return isequal(m1, m2)
    elseif m1 isa Vector{BasicSymbolic{SafeReal}} && m2 isa Vector{BasicSymbolic{SafeReal}}
        return isequal(m1, m2)
    elseif m1 isa Vector{BasicSymbolic{TreeReal}} && m2 isa Vector{BasicSymbolic{TreeReal}}
        return isequal(m1, m2)
    elseif m1 isa Matrix{BasicSymbolic{SymReal}} && m2 isa Matrix{BasicSymbolic{SymReal}}
        return isequal(m1, m2)
    elseif m1 isa Matrix{BasicSymbolic{SafeReal}} && m2 isa Matrix{BasicSymbolic{SafeReal}}
        return isequal(m1, m2)
    elseif m1 isa Matrix{BasicSymbolic{TreeReal}} && m2 isa Matrix{BasicSymbolic{TreeReal}}
        return isequal(m1, m2)
    elseif m1 isa Float64 && m2 isa Float64
        return isequal(m1, m2)
    elseif m1 isa Int && m2 isa Int
        return isequal(m1, m2)
    elseif m1 isa Vector{Float64} && m2 isa Vector{Float64}
        return isequal(m1, m2)
    elseif m1 isa Vector{Int} && m2 isa Vector{Int}
        return isequal(m1, m2)
    elseif m1 isa Matrix{Float64} && m2 isa Matrix{Float64}
        return isequal(m1, m2)
    elseif m1 isa Matrix{Int} && m2 isa Matrix{Int}
        return isequal(m1, m2)
    else
        return isequal(m1, m2)::Bool
    end
end

function isequal_shapes(@nospecialize(sh1::ShapeT), @nospecialize(sh2::ShapeT))
    if sh1 isa Unknown && sh2 isa Unknown
        return sh1.ndims == sh2.ndims
    elseif sh1 isa ShapeVecT && sh2 isa ShapeVecT
        length(sh1) == length(sh2) || return false
        return @union_split_smallvec sh1 @union_split_smallvec sh2 all(splat(isequal), zip(sh1, sh2))
    end
    return false
end

"""
    $TYPEDSIGNATURES

Core equality comparison for `BasicSymbolic`. `full` is the current value of
`COMPARE_FULL[]`, but passed explicitly to reduce accessing a `TaskLocalValue`.
"""
function isequal_bsimpl(a::BSImpl.Type{T}, b::BSImpl.Type{T}, full::Bool) where {T}
    a === b && return true
    ida = a.id
    idb = b.id
    ida === idb && ida !== nothing && return true

    Ta = MData.variant_type(a)
    Tb = MData.variant_type(b)
    Ta === Tb || return false

    if full && ida !== idb && ida !== nothing && idb !== nothing
        return false
    end

    partial = @match (a, b) begin
        (BSImpl.Const(; val = v1), BSImpl.Const(; val = v2)) => begin
            isequal_somescalar(v1, v2)::Bool && (!full || (typeof(v1) === typeof(v2))::Bool)
        end
        (BSImpl.Sym(; name = n1, shape = s1, type = t1), BSImpl.Sym(; name = n2, shape = s2, type = t2)) => begin
            n1 === n2 && isequal_shapes(s1, s2) && t1 === t2
        end
        (BSImpl.Term(; f = f1, args = args1, shape = s1, type = t1), BSImpl.Term(; f = f2, args = args2, shape = s2, type = t2)) => begin
            (f1 === f2 || isequal(f1, f2)::Bool) && isequal_argsvec(args1, args2, full) && isequal_shapes(s1, s2) && t1 === t2
        end
        (BSImpl.AddMul(; coeff = c1, dict = d1, variant = v1, shape = s1, type = t1), BSImpl.AddMul(; coeff = c2, dict = d2, variant = v2, shape = s2, type = t2)) => begin
            isequal_somescalar(c1, c2) && (!full || (typeof(c1) === typeof(c2))) && isequal_addmuldict(d1, d2, full) && isequal(v1, v2) && isequal_shapes(s1, s2) && t1 === t2
        end
        (BSImpl.Div(; num = n1, den = d1, type = t1, shape = s1), BSImpl.Div(; num = n2, den = d2, type = t2, shape = s2)) => begin
            isequal_bsimpl(n1, n2, full) && isequal_bsimpl(d1, d2, full) && isequal_shapes(s1, s2) && t1 === t2
        end
        (BSImpl.ArrayOp(; output_idx = o1, expr = e1, reduce = f1, term = t1, ranges = r1, shape = s1, type = type1), BSImpl.ArrayOp(; output_idx = o2, expr = e2, reduce = f2, term = t2, ranges = r2, shape = s2, type = type2)) => begin
            isequal(o1, o2) && isequal(e1, e2) && (f1 === f2 || isequal(f1, f2)::Bool) && isequal(t1, t2) && isequal_rangesdict(r1, r2, full) && isequal_shapes(s1, s2) && type1 === type2
        end
        (BSImpl.ArrayMaker(; regions = r1, values = v1, shape = s1, type = t1), BSImpl.ArrayMaker(; regions = r2, values = v2, shape = s2, type = t2)) => begin
            r1 == r2 && isequal_argsvec(v1, v2, full) && isequal_shapes(s1, s2) && t1 === t2
        end
    end
    if full && partial && !(Ta <: BSImpl.Const)
        partial = metadata_isequal(metadata(a), metadata(b))
    end
    return partial
end

function Base.isequal(a::BSImpl.Type, b::BSImpl.Type)
    # Copy the early-exit checks in `isequal_bsimpl` here as a fast-path
    # that doesn't have to hit the `COMPARE_FULL` lookup.
    a === b && return true
    ida = a.id
    idb = b.id
    ida === idb && ida !== nothing && return true

    Ta = MData.variant_type(a)
    Tb = MData.variant_type(b)
    Ta === Tb || return false

    return isequal_bsimpl(a, b, COMPARE_FULL[])
end

Base.isequal(a::BSImpl.Type, b::WeakRef) = isequal(a, b.value)
Base.isequal(a::WeakRef, b::BSImpl.Type) = isequal(a.value, b)

const SYM_SALT = 0x4de7d7c66d41da43 % UInt
const DIV_SALT = 0x334b218e73bbba53 % UInt

macro __generate_hash_somescalar()
    expr = Expr(:if)
    cur_expr = expr

    N = length(SCALARS)
    for (i, t1) in enumerate(SCALARS)
        push!(cur_expr.args, :(a isa $t1))
        push!(cur_expr.args, :(hash(a, h)))
        i == N && continue
        new_expr = Expr(:elseif)
        push!(cur_expr.args, new_expr)
        cur_expr = new_expr
    end

    push!(cur_expr.args, :(hash(a, h)::UInt))
    return esc(expr)
end
"""
    $TYPEDSIGNATURES

Manual dispatch on `hash` for common scalar types, avoiding dynamic dispatch when
`a` is uninferred.
"""
function hash_somescalar(@nospecialize(a), h::UInt)
    # Done this way because the manual dispatch chain is too long to write out
    # by hand, `@eval` causes Revise to error, and `@generated` completely
    # negates the `@nospecialize`.
    return @__generate_hash_somescalar
end

const UNITRANGE_SALT = 0x65888b97ed76e7a3 % UInt
const STEPRANGE_SALT = 0x84a577a5769bf2c2 % UInt

"""
    $TYPEDSIGNATURES

Specialized `hash` for range types used in `BasicSymbolic`, since the one in `Base`
iterates over the full range and is thus `O(n)` in the length.
"""
function hash_range(a::UnitRange{Int}, h::UInt)
    return hash(first(a), hash(last(a), h)) ⊻ UNITRANGE_SALT
end
function hash_range(a::StepRange{Int, Int}, h::UInt)
    return hash(first(a), hash(last(a), h)) ⊻ STEPRANGE_SALT
end

"""
    $TYPEDSIGNATURES

Hash `AddMul.dict`, accounting for the fact that the keys are inserted with `full=false`
when currently `full` may be `true`. `full` should be equal to the current value of
`COMPARE_FULL`. Passing `full` prevents repeatedly accessing a `TaskLocalValue`.
"""
function hash_addmuldict(d::ACDict, h::UInt, full::Bool)
    hv = Base.hasha_seed
    for (k, v) in d
        h1 = hash_somescalar(v, zero(UInt))
        h1 = hash_bsimpl(k, h1, full)
        hv ⊻= h1
    end
    return hash(hv, h)
end

"""
    $TYPEDSIGNATURES


Hash `ArrayOp.ranges`, accounting for the fact that the keys are inserted with `full=false`
when currently `full` may be `true`. `full` should be equal to the current value of
`COMPARE_FULL`. Passing `full` prevents repeatedly accessing a `TaskLocalValue`.
Compute a hash value for a ranges dictionary used in `ArrayOp` variants.
"""
function hash_rangesdict(d::RangesT, h::UInt, full::Bool)
    hv = Base.hasha_seed
    for (k, v) in d
        h1 = hash_range(v, zero(UInt))
        h1 = hash_bsimpl(k, h1, full)
        hv ⊻= h1
    end
    return hash(hv, h)
end

const SHAPEVECT_SEED = 0x70840b1b2d005176 % UInt

"""
    $TYPEDSIGNATURES

Specialized hash for `ShapeT` to hit `hash_range`.
"""
function hash_shape(sh::ShapeVecT, h::UInt)
    @union_split_smallvec sh for ax in sh
        h = hash_range(ax, h)
    end
    return h ⊻ SHAPEVECT_SEED
end
hash_shape(sh::Unknown, h::UInt) = hash(sh, h)

const ARGSVEC_SEED = 0x6b2f4a9c1d8e7053 % UInt

"""
    $TYPEDSIGNATURES

Specialized hash for a vector of symbolic arguments (e.g. `Term`/`ArrayMaker` args).
"""
function hash_argsvec(v::ArgsT{T}, h::UInt, full::Bool) where {T}
    @union_split_smallvec v for el in v
        h = hash_bsimpl(el, h, full)
    end
    return h ⊻ ARGSVEC_SEED
end

"""
    $TYPEDSIGNATURES

Specialized hash for `ArrayOp.output_idx`, whose elements are `Int` or symbolic.
"""
function hash_outputidx(v::SmallV{Union{Int, BasicSymbolic{T}}}, h::UInt, full::Bool) where {T}
    @union_split_smallvec v for el in v
        h = el isa Int ? hash(el, h) : hash_bsimpl(el, h, full)
    end
    return h ⊻ ARGSVEC_SEED
end

"""
    $TYPEDSIGNATURES

Specialized hash for `ArrayMaker.regions`, a vector of shapes.
"""
function hash_regions(v::RegionsT, h::UInt)
    @union_split_smallvec v for el in v
        h = hash_shape(el, h)
    end
    return h ⊻ ARGSVEC_SEED
end

"""
    $METHODLIST

Custom hash functions for `vartype(x)`, since hashes of types defined in a module are not
stable across machines or processes.
"""
vartype_hash(::Type{SymReal}, h::UInt) = hash(0x3fffc14710d3391a, h)
vartype_hash(::Type{SafeReal}, h::UInt) = hash(0x0e8c1e3ac836f40d, h)
vartype_hash(::Type{TreeReal}, h::UInt) = hash(0x44ec30357ff75155, h)

"""
    $TYPEDSIGNATURES

Custom hash functions for `AddMul.variant`, since it falls back to the `Base.Enum`
implementation, which uses `objectid`, which changes across runs.
"""
hash_addmulvariant(x::AddMulVariant.T, h::UInt) = hash(x === AddMulVariant.ADD ? 0x6d86258fc9cc0742 : 0x5e0a17a14cd8c815, h)

const FNTYPE_SEED = 0x8b414291138f6c45

"""
    $TYPEDSIGNATURES

Custom hash function for a type that may be an `FnType`, since hashes of types defined in a module are not
stable across machines or processes.
"""
function hash_maybe_fntype(T::TypeT, h::UInt)
    @nospecialize T
    return if T === Number
        hash(Number, h)
    elseif T === Real
        hash(Real, h)
    elseif T === Bool
        hash(Bool, h)
    elseif T === Int
        hash(Int, h)
    elseif T === BigInt
        hash(BigInt, h)
    elseif T === Float64
        hash(Float64, h)
    elseif T === Rational{Int}
        hash(Rational{Int}, h)
    elseif T === Integer
        hash(Integer, h)
    elseif T === Vector{Real}
        hash(Vector{Real}, h)
    elseif T === Vector{Number}
        hash(Vector{Number}, h)
    elseif T === Vector{Bool}
        hash(Vector{Bool}, h)
    elseif T === Matrix{Real}
        hash(Matrix{Real}, h)
    elseif T === Matrix{Number}
        hash(Matrix{Number}, h)
    elseif T === Matrix{Bool}
        hash(Matrix{Bool}, h)
    elseif T <: FnType
        hash(T.parameters[1], hash(T.parameters[2], hash(T.parameters[3], h)::UInt)::UInt)::UInt ⊻ FNTYPE_SEED
    else
        hash(T, h)::UInt
    end
end

function value_typed_hash(m, h::UInt)
    @nospecialize m
    h = hash(typeof(m), h)
    if m isa BasicSymbolic{SymReal}
        return hash_bsimpl(m, h, true)
    elseif m isa BasicSymbolic{SafeReal}
        return hash_bsimpl(m, h, true)
    elseif m isa BasicSymbolic{TreeReal}
        return hash_bsimpl(m, h, true)
    elseif m isa Vector{BasicSymbolic{SymReal}}
        return hash(m, h)
    elseif m isa Vector{BasicSymbolic{SafeReal}}
        return hash(m, h)
    elseif m isa Vector{BasicSymbolic{TreeReal}}
        return hash(m, h)
    elseif m isa Matrix{BasicSymbolic{SymReal}}
        return hash(m, h)
    elseif m isa Matrix{BasicSymbolic{SafeReal}}
        return hash(m, h)
    elseif m isa Matrix{BasicSymbolic{TreeReal}}
        return hash(m, h)
    elseif m isa Float64
        return hash(m, h)
    elseif m isa Int
        return hash(m, h)
    else
        return hash(m, h)::UInt
    end
end

function hash_metadict(m::Base.ImmutableDict{DataType, Any}, h::UInt)
    isdefined(m, :parent) || return h
    kvh = hash(m.key, value_typed_hash(m.value, zero(UInt))) ⊻ h
    return hash_metadict(m.parent, kvh)
end

function hash_metadata(m::MetadataT, h::UInt)
    @nospecialize m
    if m === nothing
        return hash(nothing, h)
    elseif m isa Base.ImmutableDict{DataType, Any}
        hv = Base.hasha_seed
        return hash(hash_metadict(m, hv), h)
    end
    return _unreachable()
end

"""
    hash_bsimpl(s::BSImpl.Type{T}, h::UInt, full) where {T}

Core hash function for `BasicSymbolic`. `full` must be equal to the current value of
`COMPARE_FULL[]`. Passing it reduces repeated access of a `TaskLocalValue`.
"""
function hash_bsimpl(s::BSImpl.Type{T}, h::UInt, full) where {T}
    if !iszero(h)
        return hash(hash_bsimpl(s, zero(h), full), h)::UInt
    end
    h = vartype_hash(T, h)

    partial::UInt = @match s begin
        BSImpl.Const(; val, hash) => begin
            if iszero(hash)
                h = s.hash = hash_somescalar(val, h)::UInt
            else
                h = hash
            end
            if full
                h = hash_maybe_fntype(typeof(val)::TypeT, h)::UInt
            end
            return h
        end
        BSImpl.Sym(; name, shape, type, hash, hash2) => begin
            full && !iszero(hash2) && return hash2
            !full && !iszero(hash) && return hash
            h = Base.hash(name, h)
            h = hash_shape(shape, h)
            h = hash_maybe_fntype(type, h)
            h ⊻ SYM_SALT
        end
        BSImpl.Term(; f, args, shape, hash, hash2, type) => begin
            full && !iszero(hash2) && return hash2
            !full && !iszero(hash) && return hash
            h = hash_maybe_fntype(type, h)
            if shape isa Unknown
                h = hash_shape(shape, h)
            elseif shape isa ShapeVecT
                h = hash_shape(shape, h)
            else
                _unreachable()
            end
            Base.hash(f, hash_argsvec(args, h, full))::UInt
        end
        BSImpl.AddMul(; coeff, dict, variant, shape, type, hash, hash2) => begin
            full && !iszero(hash2) && return hash2
            !full && !iszero(hash) && return hash
            htmp = hash_somescalar(coeff, hash_addmuldict(dict, hash_addmulvariant(variant, hash_shape(shape, hash_maybe_fntype(type, h))), full))
            if full
                htmp = hash_maybe_fntype(typeof(coeff)::TypeT, htmp)
            end
            htmp
        end
        BSImpl.Div(; num, den, shape, type, hash, hash2) => begin
            full && !iszero(hash2) && return hash2
            !full && !iszero(hash) && return hash
            hash_bsimpl(num, hash_bsimpl(den, hash_shape(shape, hash_maybe_fntype(type, h)), full), full) ⊻ DIV_SALT
        end
        BSImpl.ArrayOp(; output_idx, expr, reduce, term, ranges, shape, type, hash, hash2) => begin
            full && !iszero(hash2) && return hash2
            !full && !iszero(hash) && return hash
            hash_outputidx(output_idx, hash_bsimpl(expr, Base.hash(reduce, Base.hash(term, hash_rangesdict(ranges, hash_shape(shape, hash_maybe_fntype(type, h)), full)))::UInt, full), full)
        end
        BSImpl.ArrayMaker(; regions, values, shape, type, hash, hash2) => begin
            full && !iszero(hash2) && return hash2
            !full && !iszero(hash) && return hash
            hash_regions(regions, hash_argsvec(values, hash_shape(shape, hash_maybe_fntype(type, h)), full))
        end
    end

    if full
        partial = s.hash2 = hash_metadata(metadata(s), partial)::UInt
    else
        s.hash = partial
    end
    return partial
end

function Base.hash(s::BSImpl.Type, h::UInt)
    # Always use the metadata-free hash to avoids a task-local lookup on every hash.
    # This is coarser than `full = true` but is still ok as a hash function in both modes.
    return hash_bsimpl(s, h, false)
end

const ENABLE_HASHCONSING = Ref(true)
const WCS_LOCK = ReentrantLock()
const WCS_SYMREAL = WeakCacheSet{BasicSymbolic{SymReal}}()
const WCS_SAFEREAL = WeakCacheSet{BasicSymbolic{SafeReal}}()
const WCS_TREEREAL = WeakCacheSet{BasicSymbolic{TreeReal}}()

@inline wcs_for_vartype(::Type{SymReal}) = WCS_SYMREAL
@inline wcs_for_vartype(::Type{SafeReal}) = WCS_SAFEREAL
@inline wcs_for_vartype(::Type{TreeReal}) = WCS_TREEREAL

function generate_id()
    return IDType()
end

"""
$(TYPEDSIGNATURES)

Implements hash consing (flyweight design pattern) for `BasicSymbolic` objects.

This function checks if an equivalent `BasicSymbolic` object already exists. It uses a
custom hash function (`hash2`) incorporating metadata and symtypes to search for existing
objects in a `WeakCacheSet` (`wcs`). Due to the possibility of hash collisions (where
different objects produce the same hash), a custom equality check (`isequal_with_metadata`)
which includes metadata comparison, is used to confirm the equivalence of objects with
matching hashes. If an equivalent object is found, the existing object is returned;
otherwise, the input `s` is returned. This reduces memory usage, improves compilation time
for runtime code generation, and supports built-in common subexpression elimination,
particularly when working with symbolic objects with metadata.

Using a `WeakCacheSet` ensures that only weak references to `BasicSymbolic` objects are
stored, allowing objects that are no longer strongly referenced to be garbage collected.
Custom functions `hash2` and `isequal_with_metadata` are used instead of `Base.hash` and
`Base.isequal` to accommodate metadata without disrupting existing tests reliant on the
original behavior of those functions.
"""

function hashcons(s::BSImpl.Type{T}, reregister = false) where {T}
    if !ENABLE_HASHCONSING[]
        return s
    end
    s.id === nothing || reregister || return s
    @manually_scope COMPARE_FULL => true begin
        k = (@lock WCS_LOCK getkey!(wcs_for_vartype(T), s))::typeof(s)
        if k.id === nothing
            k.id = generate_id()
        end
        return k::typeof(s)
    end true
end

const CONST_ZERO_SYMREAL = hashcons(BSImpl.Const{SymReal}(0, 0, nothing))
const CONST_ZERO_SAFEREAL = hashcons(BSImpl.Const{SafeReal}(0, 0, nothing))
const CONST_ZERO_TREEREAL = hashcons(BSImpl.Const{TreeReal}(0, 0, nothing))
const CONST_ONE_SYMREAL = hashcons(BSImpl.Const{SymReal}(1, 0, nothing))
const CONST_ONE_SAFEREAL = hashcons(BSImpl.Const{SafeReal}(1, 0, nothing))
const CONST_ONE_TREEREAL = hashcons(BSImpl.Const{TreeReal}(1, 0, nothing))

"""
    $TYPEDSIGNATURES

Get the default zero constant for a given `BasicSymbolic` variant type.

# Arguments
- Type parameter: `BasicSymbolic{SymReal}`, `BasicSymbolic{SafeReal}`, or `BasicSymbolic{TreeReal}`

# Returns
- A `Const` variant representing zero with the appropriate variant type
"""
@inline defaultval(::Type{BasicSymbolic{SymReal}}) = CONST_ZERO_SYMREAL
@inline defaultval(::Type{BasicSymbolic{SafeReal}}) = CONST_ZERO_SAFEREAL
@inline defaultval(::Type{BasicSymbolic{TreeReal}}) = CONST_ZERO_TREEREAL

"""
    $(TYPEDSIGNATURES)

Return a `Const` representing `0` with the provided `vartype`.
"""
@inline zero_of_vartype(::Type{SymReal}) = CONST_ZERO_SYMREAL
@inline zero_of_vartype(::Type{SafeReal}) = CONST_ZERO_SAFEREAL
@inline zero_of_vartype(::Type{TreeReal}) = CONST_ZERO_TREEREAL
"""
    $(TYPEDSIGNATURES)

Return a `Const` representing `1` with the provided `vartype`.
"""
@inline one_of_vartype(::Type{SymReal}) = CONST_ONE_SYMREAL
@inline one_of_vartype(::Type{SafeReal}) = CONST_ONE_SAFEREAL
@inline one_of_vartype(::Type{TreeReal}) = CONST_ONE_TREEREAL

import AbstractTrees

const inspect_metadata = Ref{Bool}(false)

function AbstractTrees.nodevalue(x::BSImpl.Type)
    T = nameof(MData.variant_type(x))
    str = if !iscall(x)
        string(T, "(", x, ")")
    elseif isadd(x)
        string(T,
            (variant=string(x.variant),))
    elseif ismul(x)
        string(T,
            (variant=string(x.variant),))
    elseif isdiv(x) || ispow(x)
        string(T)
    else
        string(T,"{", operation(x), "}")
    end

    if inspect_metadata[] && !isnothing(metadata(x))
        str *= string(" metadata=", Tuple(k=>v for (k, v) in metadata(x)))
    end
    Text(str)
end

"""
$(TYPEDSIGNATURES)

Return the children of the symbolic expression `x`, sorted by their order in
the expression.

This function is used internally for printing via AbstractTrees.
"""
function AbstractTrees.children(x::BasicSymbolic)
    iscall(x) ? sorted_arguments(x) : ()
end

"""
    inspect([io::IO=stdout], expr; hint=true, metadata=false)

Inspect an expression tree `expr`. Uses AbstractTrees to print out an expression.

BasicSymbolic expressions will print the Unityper type (ADD, MUL, DIV, POW, SYM, TERM) and the relevant internals as the head, and the children in the subsequent lines as accessed by `arguments`. Other types will get printed as subtrees. Set `metadata=true` to print any metadata carried by the nodes.

Line numbers will be shown, use `pluck(expr, line_number)` to get the sub expression or leafnode starting at line_number.
"""
function inspect end

function inspect(io::IO, x::BasicSymbolic;
        hint=true,
        metadata=inspect_metadata[])

    prev_state = inspect_metadata[]
    inspect_metadata[] = metadata
    lines = readlines(IOBuffer(sprint(io->AbstractTrees.print_tree(io, x))))
    inspect_metadata[] = prev_state
    digits = ceil(Int, log10(length(lines)))
    line_numbers = lpad.(string.(1:length(lines)), digits)
    print(io, join(string.(line_numbers, " ", lines), "\n"))
    hint && print(io, "\n\nHint: call SymbolicUtils.pluck(expr, line_number) to get the subexpression starting at line_number")
end

function inspect(x; hint=true, metadata=inspect_metadata[])
    inspect(stdout, x; hint=hint, metadata=metadata)
end

inspect(io::IO, x; kw...) = println(io, "Not Symbolic: $x")

"""
    pluck(expr, n)

Pluck the `n`th subexpression from `expr` as given by pre-order DFS.
This is the same as the node numbering in `inspect`.
"""
function pluck(x, item)
    collect(Iterators.take(AbstractTrees.PreOrderDFS(x), item))[end]
end

export simplify_fractions, quick_cancel, flatten_fractions

"""
    $TYPEDSIGNATURES

Convert a `BasicSymbolic` expression to a polynomial variable, caching the result.

# Arguments
- `bs_to_poly::AbstractDict`: Dictionary cache mapping `BasicSymbolic` to `PolyVarT`
- `x::BasicSymbolic`: The symbolic expression to convert

# Returns
- A `PolyVarT` polynomial variable representing `x`, created or retrieved from cache
"""
function basicsymbolic_to_polyvar(bs_to_poly::AbstractDict, x::BasicSymbolic)::PolyVarT
    get!(bs_to_poly, x) do
        inner_name = _name_as_operator(x)
        name = Symbol(inner_name, :_, hash(x))
        MP.similar_variable(ExamplePolyVar, name)
    end
end

"""
    $TYPEDSIGNATURES

Convert polynomial terms back into `BasicSymbolic` expressions by substitution.

# Arguments
- `poly`: A polynomial expression, either `PolyVarT` or `PolynomialT`
- `vars`: Vector of `BasicSymbolic` variables corresponding to each entry of
  `MultivariatePolynomials.variables(poly)`.

# Returns
- A `BasicSymbolic{T}` expression representing the polynomial with substituted variables
"""
function subs_poly(poly, vars::AbstractVector{BasicSymbolic{T}}) where {T}
    add_buffer = ArgsT{T}()
    mul_buffer = ArgsT{T}()
    for term in MP.terms(poly)
        empty!(mul_buffer)
        coeff = MP.coefficient(term)
        push!(mul_buffer, Const{T}(coeff))
        mono = MP.monomial(term)
        for (i, exp) in enumerate(MP.exponents(mono))
            iszero(exp) && continue
            push!(mul_buffer, (vars[i] ^ exp))
        end
        push!(add_buffer, mul_worker(T, mul_buffer))
    end
    return add_worker(T, add_buffer)
end
function subs_poly(poly::PolyVarT, vars::AbstractVector{BasicSymbolic{T}}) where {T}
    return only(vars)
end

to_poly!(::AbstractDict, ::AbstractDict, expr, ::Bool) = MA.operate!(+, zeropoly(), expr)
function to_poly!(poly_to_bs::AbstractDict, bs_to_poly::AbstractDict, expr::BasicSymbolic{T}, recurse::Bool = true)::Union{PolyVarT, PolynomialT} where {T}
    @match expr begin
        BSImpl.Const(; val) => to_poly!(poly_to_bs, bs_to_poly, val, recurse)
        BSImpl.Sym(;) => begin
            pvar = basicsymbolic_to_polyvar(bs_to_poly, expr)
            get!(poly_to_bs, pvar, expr)
            return pvar
        end
        BSImpl.AddMul(; coeff, dict, variant) => begin
            @match variant begin
                AddMulVariant.ADD => begin
                    poly = zeropoly()
                    MA.operate!(+, poly, MA.copy_if_mutable(coeff))
                    for (k, v) in dict
                        tpoly = to_poly!(poly_to_bs, bs_to_poly, k, recurse)
                        if tpoly isa PolyVarT
                            tpoly = tpoly * v
                        else
                            MA.operate!(*, tpoly, v)
                        end
                        MA.operate!(+, poly, tpoly)
                    end
                    return poly
                end
                AddMulVariant.MUL => begin
                    poly = onepoly()
                    MA.operate!(*, poly, MA.copy_if_mutable(coeff))
                    for (k, v) in dict
                        if safe_isinteger(v)
                            tpoly = to_poly!(poly_to_bs, bs_to_poly, k, recurse) ^ Int(v)
                        else
                            tpoly = to_poly!(poly_to_bs, bs_to_poly, k ^ v, recurse)
                        end
                        MA.operate!(*, poly, tpoly)
                    end
                    return poly
                end
            end
        end
        BSImpl.Term(; f, args, type, shape) => begin
            if f === (^) && isconst(args[2]) && (exp = unwrap_const(args[2]); exp isa Real) && safe_isinteger(exp)
                base = args[1]
                poly = to_poly!(poly_to_bs, bs_to_poly, base)
                if poly isa PolyVarT
                    _isone(exp) && return poly
                    mv = DP.MonomialVector{PolyVarOrder, MonomialOrder}([poly], [Int[exp]])
                    return PolynomialT(PolyCoeffT[1], mv)
                end
                poly = poly ^ Int(exp)
                new_expr = from_poly(poly_to_bs, poly)
                if !isequal(expr, new_expr)
                    poly = to_poly!(poly_to_bs, bs_to_poly, from_poly(poly_to_bs, poly), recurse)
                end
                return poly
            elseif f === (*) || f === (+)
               arg1, restargs = Iterators.peel(args)
                poly = to_poly!(poly_to_bs, bs_to_poly, arg1)
                if !(poly isa PolynomialT)
                    _poly = zeropoly()
                    MA.operate!(+, _poly, poly)
                    poly = _poly
                end
                for arg in restargs
                    MA.operate!(f, poly, to_poly!(poly_to_bs, bs_to_poly, arg))
                end
                return poly
            else
                if recurse
                    expr = BSImpl.Term{T}(f, map(expand, args); type, shape)
                end
                pvar = basicsymbolic_to_polyvar(bs_to_poly, expr)
                get!(poly_to_bs, pvar, expr)
                return pvar
            end
        end
        BSImpl.Div(; num, den, type, shape) => begin
            if isconst(den)
                npoly = to_poly!(poly_to_bs, bs_to_poly, num, recurse)
                den = unwrap_const(den)
                if npoly isa PolyVarT
                    mv = DP.MonomialVector{PolyVarOrder, MonomialOrder}([npoly], [Int[1]])
                    coeff = den isa Union{Integer, Rational} ? (1 // den) : (1 / den)
                    return PolynomialT(PolyCoeffT[coeff], mv)
                elseif den isa Union{Integer, Rational}
                    coeffs = MP.coefficients(npoly)
                    for (i, c) in enumerate(coeffs)
                        coeffs[i] = c isa Union{Integer, Rational} ? (c // den) : (c / den)
                    end
                    return npoly
                else
                    coeffs = MP.coefficients(npoly)
                    map!(Base.Fix2(/, den), coeffs, coeffs)
                    return npoly
                end
            end
            if recurse
                expr = BSImpl.Div{T}(expand(num), expand(den), false; type, shape)
            end
            pvar = basicsymbolic_to_polyvar(bs_to_poly, expr)
            get!(poly_to_bs, pvar, expr)
            return pvar
        end
    end
end

function from_poly(poly_to_bs::AbstractDict{PolyVarT, BasicSymbolic{T}}, poly) where {T}
    partial_pvars = MP.variables(poly)
    vars = SmallV{BasicSymbolic{T}}()
    sizehint!(vars, length(partial_pvars))
    for ppvar in partial_pvars
        var = poly_to_bs[ppvar]
        push!(vars, var)
    end
    return subs_poly(poly, vars)::BasicSymbolic{T}
end

"""
    expand(expr)

Expand expressions by distributing multiplication over addition, e.g.,
`a*(b+c)` becomes `ab+ac`.

`expand` uses replace symbols and non-algebraic expressions by variables of type
`variable_type` to compute the distribution using a specialized sparse
multivariate polynomials implementation.
`variable_type` can be any subtype of `MultivariatePolynomials.AbstractVariable`.
"""
function expand(expr::BasicSymbolic{T}, recurse = true)::BasicSymbolic{T} where {T}
    iscall(expr) || return expr
    poly_to_bs = Dict{PolyVarT, BasicSymbolic{T}}()
    bs_to_poly = Dict{BasicSymbolic{T}, PolyVarT}()
    partial_poly = to_poly!(poly_to_bs, bs_to_poly, expr, recurse)
    return from_poly(poly_to_bs, partial_poly)
end
expand(x, _...) = x

## Rational Polynomial form with Div

function simplify_div(d::T)::T where {T <: BasicSymbolic}
    isdiv(d) || return d
    d.simplified && return d
    num, den = simplify_div(d.num, d.den)
    isequal(num, d) && return d
    return simplify_fractions(num) / simplify_fractions(den)
end

function canonicalize_coeffs!(coeffs::Vector{PolyCoeffT})
    for i in eachindex(coeffs)
        v = coeffs[i]
        safe_isinteger(v) || continue
        coeffs[i] = Int(v)
    end
end
canonicalize_coeffs!(x) = nothing

function poly_to_gcd_form(p::PolynomialT)
    all_int = true
    all_rat = true
    any_complex = false
    for c in MP.coefficients(p)
        isint = safe_isinteger(c)
        all_int &= isint
        all_rat &= isint || c isa Rational
        any_complex |= c isa Complex
        all_int || all_rat || break
    end
    cs = if all_int
        Integer.(MP.coefficients(p))
    elseif all_rat
        rationalize.(MP.coefficients(p))
    elseif any_complex
        (complex ∘ float).(MP.coefficients(p))
    else
        float.(MP.coefficients(p))
    end
    # Broadcast preserves the abstractness of the input vector's eltype:
    # `Integer.(::Vector{Number})` returns `Vector{Number}` if the values
    # are heterogeneous concrete subtypes of Integer (e.g. `Int8 + Int64`
    # broadcasts to `Vector{Signed}`). The resulting `DP.Polynomial` then
    # carries an abstract type parameter (`Integer`/`Signed`/`AbstractFloat`/
    # `Real`), which crashes `MP.gcd`'s `isolate_variable` reconstruction.
    # Narrow to a concrete eltype here when needed; on the homogeneous fast
    # path (eltype already concrete) this is a single `isconcretetype` check
    # and no extra allocation.
    if !isconcretetype(eltype(cs))
        T = isempty(cs) ? (all_int ? Int : all_rat ? Rational{Int} :
                           any_complex ? ComplexF64 : Float64) :
            mapreduce(typeof, promote_type, cs)
        cs = Vector{T}(cs)
    end
    return DP.Polynomial(cs, MP.monomials(p))
end

function safe_gcd(p1::Union{PolyVarT, PolynomialT}, p2::Union{PolyVarT, PolynomialT})
    if p1 isa PolyVarT && p2 isa PolyVarT
        return gcd(p1, p2)
    elseif p1 isa PolyVarT && p2 isa PolynomialT
        return gcd(p1, poly_to_gcd_form(p2))
    elseif p1 isa PolynomialT && p2 isa PolyVarT
        return gcd(poly_to_gcd_form(p1), p2)
    elseif p1 isa PolynomialT && p2 isa PolynomialT
        return gcd(poly_to_gcd_form(p1), poly_to_gcd_form(p2))
    end
end

function simplify_div(num::BasicSymbolic{T}, den::BasicSymbolic{T}) where {T <: SymVariant}
    poly_to_bs = Dict{PolyVarT, BasicSymbolic{T}}()
    bs_to_poly = Dict{BasicSymbolic{T}, PolyVarT}()
    partial_poly1 = to_poly!(poly_to_bs, bs_to_poly, num, false)
    partial_poly2 = to_poly!(poly_to_bs, bs_to_poly, den, false)
    factor = safe_gcd(partial_poly1, partial_poly2)
    if isone(factor)
        return num, den
    end
    # NOTE: This does not mutate `partial_poly1` to be the result, it just
    # uses it as buffer. The result is the returned value.
    partial_poly1 = MP.div_multiple(partial_poly1, factor, MA.IsMutable())
    partial_poly2 = MP.div_multiple(partial_poly2, factor, MA.IsMutable())
    canonicalize_coeffs!(MP.coefficients(partial_poly1))
    canonicalize_coeffs!(MP.coefficients(partial_poly2))
    return from_poly(poly_to_bs, partial_poly1), from_poly(poly_to_bs, partial_poly2)
end

"""
    quick_cancel(d)

Cancel out matching factors from numerator and denominator.
This is not as effective as `simplify_fractions`, for example,
it wouldn't simplify `(x^2 + 15 -  8x)  / (x - 5)` to `(x - 3)`.
But it will simplify `(x - 5)^2*(x - 3) / (x - 5)` to `(x - 5)*(x - 3)`.
Has optimized processes for `Mul` and `Pow` terms.
"""
quick_cancel(d) = d
function quick_cancel(d::BasicSymbolic{T})::BasicSymbolic{T} where {T}
    iscall(d) || return d
    op = operation(d)
    if op === (^)
        base, exp = arguments(d)
        isconst(base) && return d
        isdiv(base) || return d
        num, den = quick_cancel(base.num, base.den)
        return Div{T}(num ^ exp, den ^ exp, false; type = symtype(d))
    elseif op === (/)
        num, den = arguments(d)
        num, den = quick_cancel(num, den)
        return Div{T}(num, den, false; type = symtype(d))
    else
        return d
    end
end

function quick_cancel(x::S, y::S)::Tuple{S, S} where {T <: SymVariant, S <: BasicSymbolic{T}}
    isequal(x, y) && return one_of_vartype(T), one_of_vartype(T)
    opx = iscall(x) ? operation(x) : nothing
    opy = iscall(y) ? operation(y) : nothing
    icx = isconst(x)
    icy = isconst(y)
    if opx === (^) && opy === (^)
        return quick_powpow(x, y)
    elseif opx === (*) && opy === (^)
        return quick_mulpow(x, y)
    elseif opx === (^) && opy === (*)
        return reverse(quick_mulpow(y, x))
    elseif opx === (*) && opy === (*)
        return quick_mulmul(x, y)
    elseif opx === (^) && !icy
        return quick_pow(x, y)
    elseif opy === (^) && !icx
        return reverse(quick_pow(y, x))
    elseif opx === (*) && !icy
        return quick_mul(x, y)
    elseif opy === (*) && !icx
        return reverse(quick_mul(y, x))
    else
        return x, y
    end
end

# ispow(x) case
function quick_pow(x::S, y::S)::Tuple{S, S} where {T <: SymVariant, S <: BasicSymbolic{T}}
    base, exp = arguments(x)
    exp = unwrap_const(exp)
    exp isa Number || return (x, y)
    isequal(base, y) && exp >= 1 ? (base ^ (exp - 1), one_of_vartype(T)) : (x, y)
end

# Double Pow case
function quick_powpow(x::S, y::S)::Tuple{S, S} where {T <: SymVariant, S <: BasicSymbolic{T}}
    base1, exp1 = arguments(x)
    base2, exp2 = arguments(y)
    isequal(base1, base2) || return x, y
    exp1 = unwrap_const(exp1)
    exp2 = unwrap_const(exp2)
    !(exp1 isa Number && exp2 isa Number) && return (x, y)
    if exp1 > exp2
        return base1 ^ (exp1 - exp2), one_of_vartype(T)
    elseif exp1 == exp2
        return one_of_vartype(T), one_of_vartype(T)
    else # exp1 < exp2
        return one_of_vartype(T), base2 ^ (exp2 - exp1)
    end
end

# ismul(x)
function quick_mul(x::S, y::S)::Tuple{S, S} where {T <: SymVariant, S <: BasicSymbolic{T}}
    yy = BSImpl.Term{T}(^, ArgsT{T}((y, one_of_vartype(T))); type = symtype(y))
    newx, newy = quick_mulpow(x, yy)
    return isequal(newy, yy) ? (x, y) : (newx, newy)
end

# mul, pow case
function quick_mulpow(x::S, y::S)::Tuple{S, S} where {T <: SymVariant, S <: BasicSymbolic{T}}
    base, exp = arguments(y)
    exp = unwrap_const(exp)
    exp isa Number || return (x, y)
    args = parent(arguments(x))
    idx = 0
    argbase = argexp = nothing
    @union_split_smallvec args begin
        for (i, arg) in enumerate(args)
            if isequal(arg, base)
                idx = i
                argbase = arg
                argexp = 1
                break
            end

            if iscall(arg) && operation(arg) === (^) && isequal(arguments(arg)[1], base)
                idx = i
                argbase, argexp = arguments(arg)
                break
            end
        end
    end
    iszero(idx) && return x, y
    argexp = unwrap_const(argexp)
    argexp isa Number || return x, y
    # cheat by mutating `args` to avoid allocating
    oldval = args[idx]
    if argexp > exp
        args[idx] = argbase ^ (argexp - exp)
        result = mul_worker(T, args), one_of_vartype(T)
    elseif argexp == exp
        args[idx] = one_of_vartype(T)
        result = mul_worker(T, args), one_of_vartype(T)
    else
        args[idx] = one_of_vartype(T)
        result = mul_worker(T, args), base ^ (exp - argexp)
    end
    args[idx] = oldval
    return result
end

# Double mul case
function quick_mulmul(x::S, y::S)::Tuple{S, S} where {T <: SymVariant, S <: BasicSymbolic{T}}
    @match (x, y) begin
        (BSImpl.AddMul(; coeff = c1, dict = d1, type = t1, shape = s1, variant = vr1), BSImpl.AddMul(; coeff = c2, dict = d2, type = t2, shape = s2, variant = vr2)) => begin
            newd1 = d1
            newd2 = d2
            for (k1, v1) in d1
                haskey(d2, k1) || continue
                v2 = d2[k1]
                if newd1 === d1
                    newd1 = copy(d1)
                    newd2 = copy(d2)
                end
                delete!((v1 >= v2) ? newd2 : newd1, k1)
                setindex!((v1 >= v2) ? newd1 : newd2, abs(v1 - v2), k1)
            end
            if newd1 === d1
                return x, y
            end
            filter!(!iszero ∘ last, newd1)
            filter!(!iszero ∘ last, newd2)
            xx = Mul{T}(c1, newd1; type = t1, shape = s1)
            yy = Mul{T}(c2, newd2; type = t2, shape = s2)

            return xx, yy
        end
        # Not `_unreachable` since `adjoint(vec) * vec` can end up here, and we just want
        # to ignore it.
        _ => (x, y)
    end
end

function add_with_div(x::BasicSymbolic{T})::BasicSymbolic{T} where {T}
    (!iscall(x) || operation(x) !== (+)) && return x
    aa = parent(arguments(x))
    !any(isdiv, aa) && return x # no rewrite necessary

    # find and multiply all denominators
    dens = ArgsT{T}()
    for a in aa
        isdiv(a) || continue
        push!(dens, a.den)
    end
    type = symtype(x)
    den = mul_worker(T, dens)

    # add all numerators
    div_idx = 1
    nums = ArgsT{T}()
    for a in aa
        # if it is a division, we don't want to multiply the numerator by
        # its own denominator, so temporarily overwrite the index in `dens`
        # that is the denominator of this term (tracked by `div_idx`), multiply
        # and voila! numerator. Remember to reset `dens` at the end.
        if isdiv(a)
            _den = dens[div_idx]
            dens[div_idx] = a.num
            _num = mul_worker(T, dens)
            dens[div_idx] = _den
            div_idx += 1
        else
            _num = den * a
        end
        push!(nums, _num)
    end
    num = add_worker(T, nums)

    num, den = quick_cancel(num, den)
    return num / den
end

const FRAC_SIMPLIFIER = Rewriters.Postwalk(simplify_div ∘ quick_cancel) ∘ Rewriters.Postwalk(add_with_div)
const QUICK_CANCELER = Rewriters.Postwalk(quick_cancel)

"""
    simplify_fractions(x; polyform=false)

Find `Div` nodes and simplify them by cancelling a set of factors of numerators
and denominators.
"""
function simplify_fractions(x::BasicSymbolic{T})::BasicSymbolic{T} where {T}

    x = QUICK_CANCELER(x)

    !needs_div_rules(x) && return x

    return FRAC_SIMPLIFIER(x)
end
simplify_fractions(x) = x

const FRACTION_FLATTENER = Rewriters.Fixpoint(Rewriters.Postwalk(add_with_div))

"""
    flatten_fractions(x)

Flatten nested fractions that are added together.

```julia-repl
julia> flatten_fractions((1+(1+1/a)/a)/a)
(1 + a + a^2) / (a^3)
```
"""
function flatten_fractions(x::BasicSymbolic{T})::BasicSymbolic{T} where {T}
    FRACTION_FLATTENER(x)
end

function fraction_iszero(x)
    !iscall(x) && return _iszero(x)
    ff = flatten_fractions(x)
    # fast path and then slow path
    return (any(_iszero, numerators(ff)) ||
    any(_iszero∘expand, numerators(ff)))::Bool
end

function fraction_isone(x)
    !iscall(x) && return _isone(x)
    _isone(simplify_fractions(flatten_fractions(x)))
end

function needs_div_rules(x)
    (isdiv(x) && !(unwrap_const(x.num) isa Number) && !(unwrap_const(x.den) isa Number)) ||
    (iscall(x) && operation(x) === (+) && count(has_div, arguments(x)) > 1) ||
    (iscall(x) && any(needs_div_rules, arguments(x)))
end

function has_div(x)
    return isdiv(x) || (iscall(x) && any(has_div, arguments(x)))
end

# == / != syntax is nice, let's use it in tests
macro eqtest(expr)
    @assert expr.head == :call && expr.args[1] in [:(==), :(!=)]
    if expr.args[1] == :(==)
        :(@test isequal($(expr.args[2]), $(expr.args[3])))
    else
        :(@test !isequal($(expr.args[2]), $(expr.args[3])))
    end |> esc
end

using SymbolicUtils
using SymbolicUtils: BasicSymbolic, Term, issym, symtype
using SpecialFunctions
using Test
using NaNMath
import Random

function rand_input(T)
    if T == Bool
        return rand(Bool)
    elseif T <: Integer
        x = rand(-100:100)
        while iszero(x)
            x = rand(-100:100)
        end
        return x
    elseif T <: Rational
        return Rational(rand_input(Int), rand(1:50)) # no 0 denominator tests yet!
    elseif T == Real
        return rand_input(rand([Int, Float64, Rational]))
    elseif T <: Complex
        return rand_input(Real) + rand_input(Real) * im
    elseif T == Number
        # more real than complex
        return rand_input(rand([Real, Real, Real, Complex{Float64}]))
    elseif !isabstracttype(T)
        return rand(T)
    else
        error("Don't know how to generate input of type $T")
    end
end

rand_input(i::BasicSymbolic{T}) where {T} = rand_input(symtype(i))

const num_spec = let
    @syms a b::Real c::Integer d::Float64 e::Rational{Int} f

    leaf_funcs = [()->rand_input(Real),
                  ()->rand_input(Complex),
                  ()->rand([a b c d e f]),
                  ()->rand([a b c d e f])]

    binops = SymbolicUtils.diadic
    nopow  = setdiff(binops, [(^), NaNMath.pow, besselj0, besselj1, bessely0, bessely1, besselj, bessely, besseli, besselk, expint])
    twoargfns = vcat(nopow, (x,y)->x isa Union{Int, Rational, Complex{<:Rational}} ? x * y : x^y)
    fns = vcat(1 .=> setdiff(vcat(SymbolicUtils.monadic, [one, zero]), [factorial, expint]),
               2 .=> vcat(twoargfns, fill(+, 5), [-,-], fill(*, 5), fill(/, 40)),
               3 .=> [+, *])


    (leaves=leaf_funcs, funcs=fns, input=rand_input)
end

const bool_spec = let
    @syms b::Bool x::Real y::Real z::Complex{Real}

    bool_leaf_funcs = [()->rand(Bool),
                       ()->rand([b, (x, b) => ((x > 0) | b), (x,)=>(x < 0), (y,z) => y==z, (y, z) => y!=z])]

    fns = vcat(1 .=> [(!), (~)],
               2 .=> [(|), (&), xor],
               3 .=> [ifelse]) # cond will still stay in bool by construction

    (leaves=bool_leaf_funcs,
     funcs=fns,
     input=rand_input
    )
end

function gen_rand_expr(inputs;
                       spec=num_spec,
                       leaf_prob=0.92,
                       depth=0,
                       min_depth=1,
                       max_depth=5)

    if depth > max_depth  || (min_depth <= depth && rand() < leaf_prob)
        leaf = rand(spec.leaves)()
        if issym(leaf)
            push!(inputs, leaf)
        elseif leaf isa Pair
            foreach(i->push!(inputs, i), leaf[1])
            return leaf[2]
        end
        return leaf
    end
    arity, f = rand(spec.funcs)
    args = [gen_rand_expr(inputs,
                          spec=spec,
                          leaf_prob=leaf_prob,
                          depth=depth+1,
                          min_depth=min_depth,
                          max_depth=max_depth) for i in 1:arity]
    try
        return f(args...)
    catch err
        if err isa DomainError || err isa DivideError || err isa MethodError ||
            err isa SymbolicUtils.SpecialFunctions.AmosException
            return gen_rand_expr(inputs,
                                 spec=spec,
                                 leaf_prob=leaf_prob,
                                 depth=depth,
                                 min_depth=min_depth,
                                 max_depth=max_depth)
        else
            @show f
            @show arity
            @show args
            rethrow(err)
        end
    end
end

struct Errored
    err
end

function fuzz_test(ntrials, spec, simplify=simplify;kwargs...)
    inputs = Set()
    @static if isdefined(Random, :getstate)
        rstate = Random.getstate(Random.GLOBAL_RNG)
    else
        rstate = nothing
    end
    expr = gen_rand_expr(inputs; spec=spec, kwargs...)
    inputs = collect(inputs)
    code = try
        SymbolicUtils.Code.toexpr(expr)
    catch err
        rethrow(err)
    end
    unsimplifiedstr = """
    function $(tuple(inputs...))
        $(sprint(io->print(io, code)))
    end
    """

    simplifiedstr = """
    function $(tuple(inputs...))
        $(sprint(io->show(io, simplify(expr))))
    end
    """
    f = include_string(Main, unsimplifiedstr)
    g = include_string(Main, simplifiedstr)

    for i=1:ntrials
        args = [spec.input(i) for i in inputs]
        unsimplified = try
            Base.invokelatest(f, args...)
        catch err
            Errored(err)
        end

        simplified  = try
            Base.invokelatest(g, args...)
        catch err
            Errored(err)
        end
        if unsimplified isa Errored
            if !(simplified isa Errored)
                @test_skip false
                @goto print_err
            end
            @test true
        elseif simplified isa Errored
            if !(unsimplified isa Errored)
                @test_skip false
                @goto print_err
            end
            @test true
        elseif isnan(unsimplified)
            if !isnan(simplified)
                @test_skip false
                @goto print_err
            end
            @test true
        elseif isnan(simplified)
            if !isnan(unsimplified)
                @test_skip false
                @goto print_err
            end
            @test true
        else
            if !(unsimplified ≈ simplified)
                @test_skip false
                @goto print_err
            end
            @test true
        end
        continue

        @label print_err
        println("""Test failed for expression
                    $(sprint(io->show(io, expr))) = $unsimplified
                Simplified:
                    $(sprint(io->show(io, simplify(expr)))) = $simplified
                Inputs:
                    $inputs = $args
                State:
                    $rstate
                """)
    end
end

leaves = [(@syms a b c d e g)..., a^3, a^-2, b^2, b^(-1), big.((3//5, 0//2, -1//2, 1//2, 1//2+2im))...]
function gen_expr(lvl=5)
    if lvl == 0
        x = rand(leaves)
        x, x
    elseif rand() < 0.5
        f = rand((+, *))
        n = rand(1:5)
        args = [gen_expr(lvl-1) for i in 1:n]

        Term{SymReal}(f, first.(args); type = Number), f(last.(args)...)
    else
        f = rand((-,/))
        l = gen_expr(lvl-1)
        r = gen_expr(lvl-1)
        if f === (/) && r[2] isa Number && iszero(r[2])
            return gen_expr(lvl)
        end
        args = [l, r]

        Term{SymReal}(f, first.(args); type = Number), f(last.(args)...)
    end
end

test_dict = Dict{Any, Rational{BigInt}}(a=>1,b=>-1,c=>2,d=>-2,e=>5//3,g=>-2//3)
function fuzz_addmulpow(lvl, d=test_dict)
    @static if isdefined(Random, :getstate)
        rstate = Random.getstate(Random.GLOBAL_RNG)
    else
        rstate = nothing
    end
    l, r = gen_expr(lvl)
    rl = try
        substitute(l, d)
    catch err
        err
    end
    rr = try
        substitute(r, d)
    catch err
        err
    end

    if !(rl isa Number) || !(rr isa Number)
        return
    end
    if rl isa Number || rr isa Number
        if isequal(rl, rr) || iszero(denominator(rl)) && iszero(denominator(rr))
            @test true
        else
            println("Weird bug here:")
            @show rstate
            @show d
            @show r l
            @show rl rr
            @test false
        end
    end
end

using SymbolicUtils: IRStructure, populate_ir!

include("stackdict.jl")

# NOTE:
# StackDict is an ordered container that tracks insertion order via a Vector of keys,
# allowing checkpointing by recording the last inserted key and rolling back to that
# state by popping entries in reverse order.

# NOTE:
# Codegen relies on fewer invariants than `IRStructure` in general. It is designed to work
# even when `ir.non_canonical_idxs` is non-empty. The invariants that it relies on are:
# 1. `operation(ir[idx::Integer])` is the correct operation to generate.
# 2. `symtype(ir[idx])` and `shape(ir[idx])` are the correct symtype and shape of the expression.
# 3. `outneighbors(ir.dependency_graph, idx)` corresponds in order to `arguments(ir[idx])`. In
#    case `operation(ir[idx]) isa BasicSymbolic{T}`, it is the first element in `outneighbors`,
#    followed by the arguments in order.

"""
    $TYPEDEF

Struct used for efficient codegen when coupled with a [`SymbolicUtils.IRStructure`](@ref).
Rewrites can be accessed using `.rewrites`, similar to `NameState`.

## Extended help

The following is an implementation detail and not public API.

### Fields

$TYPEDFIELDS
"""
mutable struct CodegenState{T}
    """
    The expression used as a result when codegen is finished.
    """
    const expr::Expr
    """
    An `Expr(:block)` that aliases some part of `expr`. All generated expressions are
    written to this block.
    """
    const block::Expr
    """
    The underlying `IRStructure`.
    """
    const ir::IRStructure{T}
    """
    A cache from indices of `ir` to the LHS of the assignment statement (name of the
    identifier) where it is calculated. For example, the expression `x + y` may be calculated
    as
    ```julia
    var"%1" = x
    var"%2" = y
    var"%3" = var"%1" + var"%2"
    ```
    In such a case, if we assume that the index of `x + y` in `ir` is `4`, then
    `cache[4] == Symbol("%3")`.
    """
    const cache::StackDict{Int32, Symbol}
    """
    Rewrite rules, similar to `NameState`.
    """
    const rewrites::Dict{Any, Any}
    misc_idx::Int

    function CodegenState{T}(expr, block, ir, cache, rewrites, misc_idx) where {T}
        # Verify that `block` is an `Expr(:block)`.
        @assert Meta.isexpr(block, :block)
        new{T}(expr, block, ir, cache, rewrites, misc_idx)
    end
end

"""
    $TYPEDSIGNATURES

Create a `CodegenState` where the resultant expression will be `expr`, IR will be
written to `block` and `ir` is the underlying `IRStructure`. Rewrite rules can optionally
be supplied as the last argument.
"""
function CodegenState(expr::Expr, block::Expr, ir::IRStructure{T}, rewrites = Dict()) where {T}
    CodegenState{T}(expr, block, ir, StackDict{Int32, Symbol}(), rewrites, 0)
end

"""
Key to use in the `rewrites` dictionary passed to [`fast_toexpr`](@ref) or [`CodegenState`](@ref)
for modifying the LHS of any declarations. The value should be a function which takes
`cs::CodegenState`, `idx::Integer` the integer index in `IRStructure` of the value
being generated (or `-1` if it is a miscellaneous variable), and `lhs::Symbol` the
current assignment LHS.
"""
const LHS_HOOK_KEY = :__lhs_hookₛᵧₘ

"""
    $TYPEDSIGNATURES

Generate the code in `sym` for the symbolic expression at index `idx` in `cs.ir::IRStructure`.
`sym` must be an `Expr`, `Symbol`, or similar which is valid to build an expression. It must
not be or contain other symbolic expressions.

Note that this is intended to be used to generate individual atomic expressions for symbolics.
In case a symbolic requires a larger compound expression, prefer to declare intermediates
via [`SymbolicUtils.Code.declare!`](@ref) and use them here.
"""
function codegen!(cs::CodegenState, idx::Integer, @nospecialize(sym))
    lhs = get_cse_name(length(cs.cache))
    lhs_hook = get(cs.rewrites, LHS_HOOK_KEY, nothing)
    # Declaring as `local` is necessary. Otherwise `symFunc` will
    # overwrite already-declared CSE variables.
    if lhs_hook !== nothing
        push!(cs.block.args, Expr(:local, Expr(:(=), lhs_hook(cs, idx, lhs), sym)))
    else
        push!(cs.block.args, Expr(:local, Expr(:(=), lhs, sym)))
    end
    insert!(cs.cache, idx, lhs)
    return lhs
end

"""
    $TYPEDSIGNATURES

Declare a variable named `lhs` which is assigned the value `rhs`. This is used to declare
ephemeral intermediate values in case the generated code for a symbolic is non-trivial. To
specify generated code for a symbolic, use [`SymbolicUtils.Code.codegen!`](@ref) instead.
`rhs` has the same restrictions as `sym` in that function.

Note that all-underscore identifiers can be assigned to in Julia but not used in later
expressions. Thus side-effecting expressions (such as `setindex!`) whose result is immaterial
can be generated by setting `lhs` to `:_`. The caller is responsible for ensuring the validity
of side-effecting expressions.

This function also does not check if the same `lhs` is declared twice. The variables
declared via this function are intended as temporaries, and repeated declarations will
overwrite the previous value.
"""
function declare!(cs::CodegenState, lhs, @nospecialize(rhs))
    lhs_hook = get(cs.rewrites, LHS_HOOK_KEY, nothing)
    if lhs_hook !== nothing
        push!(cs.block.args, Expr(:(=), lhs_hook(cs, -1, lhs), rhs))
    else
        push!(cs.block.args, Expr(:(=), lhs, rhs))
    end
    return lhs
end

const MISC_PREFIX = Vector{UInt8}("__miscₛᵧₘ")

"""
    $TYPEDSIGNATURES

Get a unique named miscellaneous identifier for use with [`SymbolicUtils.Code.declare!`](@ref).
"""
function get_misc_identifier(cs::CodegenState)
    name = get_numbered_symbol_with_prefix(MISC_PREFIX, cs.misc_idx)
    cs.misc_idx += 1
    return name
end

"""
    $TYPEDSIGNATURES

Get the allocator to use for a symbolic expression. If the rewrite rules contain
an entry for `ALLOCATOR_REWRITES_KEY`, will return that value and erase the rule
(since allocators cannot be reused). Otherwise, returns `default`.
"""
function get_allocator!(cs::CodegenState, @nospecialize(default))
    result = get(cs.rewrites, ALLOCATOR_REWRITES_KEY, default)
    delete!(cs.rewrites, ALLOCATOR_REWRITES_KEY)
    return result
end

const CodegenBookmarkT = Int32

"""
    $TYPEDSIGNATURES

Return a bookmark for `cs`, typically used to introduce new scopes and end them via
[`rollback!`](@ref).
"""
function bookmark(cs::CodegenState)
    return isempty(cs.cache) ? zero(Int32) : lastindex(cs.cache)
end

"""
    $TYPEDSIGNATURES

Rollback `cs` to the state identified by `bm`. This has similar semantics to `rollback!` for
[`SymbolicUtils.IRStructure`](@ref). It is typically used for scoping in `cs`.
"""
function rollback!(cs::CodegenState, bm::CodegenBookmarkT)
    last_cache_key = bm
    if iszero(last_cache_key)
        empty!(cs.cache)
    else
        k = lastindex(cs.cache)
        while k != last_cache_key
            delete!(cs.cache, k)
            k = lastindex(cs.cache)
        end
    end
    return cs
end

"""
    $TYPEDSIGNATURES

Introduce a new scope to `cs`. Some code generation paths may require inner scopes, for
example a `for` loop or `let` block. `enter_scope` can be used to introduce a new scope,
where expressions can be generated inside the block and are not accessible once the scope
is exited. This function takes the current `CodegenState`. It returns a new `CodegenState`
which contains an alias of this block and will write to it, alongside a bookmark object.
When the scope is exited, the caller is responsible for calling
[`SymbolicUtils.Code.exit_scope!`](@ref) with this returned `CodegenState` and bookmark
object.

Note that expressions generated in this scope may reference already-generated expressions
in the enclosing scope (the scope of `cs`). Calling `enter_scope` without a corresponding
`exit_scope!` is undefined behavior.
"""
function enter_scope(cs::CodegenState{T}) where {T}
    new_scope = Expr(:block)
    bm = bookmark(cs)
    scoped_cs = CodegenState{T}(new_scope, new_scope, cs.ir, cs.cache, cs.rewrites, cs.misc_idx)

    return scoped_cs, bm
end

"""
    $TYPEDSIGNATURES

End a scope introduced by [`SymbolicUtils.Code.enter_scope`](@ref). This function should
be called with the `CodegenState` and bookmark object returned by that function. It will
return an `Expr(:block)` of all code generated in this scope. Additionally, any subsequent
code generation using the `CodegenState` that `cs` was created from (the `CodegenState`
passed to `enter_scope`) will not reference expressions generated in this scope.

Note that the `Expr(:block)` returned by this function is not yet added to the outer
scope. That is the responsibility of the caller. Calling `exit_scope!` twice on the same
`cs` or with the same bookmark is undefined behavior.
"""
function exit_scope!(cs::CodegenState, bm::CodegenBookmarkT)
    result = cs.block
    rollback!(cs, bm)
    return result
end

function __default_allocator_call_expr(allocator_sym::Symbol, sz_expr::Expr)
    return Expr(:call, allocator_sym, sz_expr)
end

"""
    $TYPEDEF

Wraps an identifier already assigned to in codegen which represents a buffer that
should be written to by `with_allocator`. This pattern avoids having to do something
like

```julia
# Outer `codegen_function!` call
buffer = view(other_buffer, 1:4)
allocator = Returns(buffer)
# Inner `codegen_function!`
my_buffer = allocator((4,))
# stuff...
```

By enabling codegen to call `add_allocator!` with `ExistingBufferAllocator(:buffer)`.
This will then codegen into something like

```julia
# Outer `codegen_function!`
buffer = view(other_buffer, 1:4)
# Inner `codegen_function`
# Do stuff with `buffer`
```
"""
struct ExistingBufferAllocator
    name::Symbol
end

"""
    $TYPEDSIGNATURES

Generate an expression for calling the allocator `allocator` to store the result of `expr`.
"""
function codegen_allocator_call!(
        cs::CodegenState{T}, @nospecialize(allocator), expr::BasicSymbolic{T}, expr_idx::Integer;
        allocator_call_expr = __default_allocator_call_expr
    ) where {T}
    allocator isa ExistingBufferAllocator && return allocator.name
    allocator_sym::Symbol = if allocator isa BasicSymbolic{T}
        # If the allocator is a `Returns(buf)` expression, don't bother calling it. Just generate
        # `buf` and use it.
        @match allocator begin
            BSImpl.Term(; f) && if f === Returns || f isa DataType && f <: Returns end => begin
                allocator_idx = populate_ir!(cs.ir, allocator)
                buffer_sym = cs(cs.ir[Graphs.outneighbors(cs.ir.dependency_graph, allocator_idx)[1]])
                return codegen!(cs, expr_idx, buffer_sym)
            end
            _ => nothing
        end
        cs(allocator)
    else
        declare!(cs, get_misc_identifier(cs), allocator)
    end
    sh = shape(expr)::ShapeVecT
    sz_expr = Expr(:tuple)
    @union_split_smallvec sh for ax in sh
        push!(sz_expr.args, length(ax))
    end
    return codegen!(cs, expr_idx, allocator_call_expr(allocator_sym, sz_expr))
end

"""
    $TYPEDSIGNATURES

Replacement of [`SymbolicUtils.Code.toexpr`](@ref) using IR-based codegen.
"""
function fast_toexpr(sym::BasicSymbolic{T}, rewrites::Dict{Any, Any}) where {T}
    ir = IRStructure{T}()
    return fast_toexpr(sym, ir, rewrites)
end

function fast_toexpr(sym, ir::IRStructure{T}, rewrites::Dict{Any, Any}) where {T}
    expr = block = Expr(:block)
    state = CodegenState(expr, block, ir, rewrites)
    state(sym)
    return expr
end

"""
    $TYPEDSIGNATURES
"""
function fast_toexpr(sym::CodegenPrimitive, ir::IRStructure{T}, rewrites::Dict{Any, Any}) where {T}
    expr = block = Expr(:block)
    state = CodegenState(expr, block, ir, rewrites)
    lhs = state(sym)::Symbol
    for line in expr.args
        if Meta.isexpr(line, :(=)) && line.args[1] === lhs
            return line.args[2]
        end
    end
    _unreachable()
end

"""
    function codegen_function!(fn::F, cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {F, T}

Generate code for `expr` whose operation is `fn` and index in `cs.ir` is `expr_idx`.
Implementers of this function should _only_ dispatch on `F`, and the rest of the types should
be as provided in the signature above.

This function should generate a Julia expression `result` for `expr`, and call
[`SymbolicUtils.Code.codegen!`](@ref)`(cs, expr_idx, result)`. Temporary intermediate values
may be declared via [`SymbolicUtils.Code.declare!`](@ref). This function should return the
value returned by `SymbolicUtils.Code.codegen!`. Any other return value is undefined behavior.

In case the code generation process here requires the results of other symbolic expressions,
it should call `cs` to obtain them. For example, if it requires the generated code for
`arguments(expr)[1]`, it should call `cs(arguments(expr)[1])` to obtain it. This will return
a `Symbol` indicating the identifier in the generated code which is assigned the requested
value.

This function is allowed to non-destructively mutate `cs.ir`. All information present in
`cs.ir` upon entry to this function should be present when it returns. The function may
add expressions to `cs.ir` and choose to use [`SymbolicUtils.rollback!`](@ref) to restore
to an earlier state, but this earlier state should not erase information that was not
added by this function.

In case the code generation process requires creating a new scope such as a `for` loop or
`let` block, it should use [`SymbolicUtils.Code.enter_scope`](@ref) and
[`SymbolicUtils.Code.exit_scope!`](@ref).

The code generation in this function does not need to handle checking if `expr` is in
`cs.rewrites`. That functionality is handled elsewhere.
"""
function codegen_function! end

function codegen_function!(::Type{ArrayOp{T}}, cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {T}
    _allocator = get_allocator!(cs, zeros)
    output_buffer = codegen_allocator_call!(cs, _allocator, expr, expr_idx)

    # Use graph instead of destructuring `expr`
    nbors = Graphs.outneighbors(cs.ir.dependency_graph, expr_idx)
    innerexpr = SymbolicUtils.get_canonical_expr!(cs.ir, nbors[2])::BasicSymbolic{T}
    reducer = unwrap_const(cs.ir[nbors[3]])
    ranges = unwrap_const(cs.ir[nbors[5]])::SymbolicUtils.RangesT{T}

    new_ranges = RangesT{T}()
    new_expr = unidealize_indices(innerexpr, ranges, new_ranges)

    scoped_cs, bm = enter_scope(cs)

    inner_result = scoped_cs(new_expr)

    loopvar_order = BasicSymbolic{T}[]
    index_expr = Expr(:call, CartesianIndex)

    # `output_idxs` can be empty/all integers/symbolic. The first two cases are captured by
    # the `Const`, where all loops are reduction loops and we output a scalar or singleton
    # array. If we have parallel loops, then `output_idxs` will contain symbolic entries and
    # it will thus be present as an `array_literal`.
    out_idx_sym = cs.ir[nbors[1]]
    @match out_idx_sym begin
        BSImpl.Const(; val) && if val isa SymbolicUtils.OutIdxT{T} end => begin
            # If this is a `Const`, then none of the elements in `output_idx` are symbolic,
            # so we never populate `loopvar_order`.
            output_idx = val::SymbolicUtils.OutIdxT{T}
            @union_split_smallvec output_idx for i in output_idx
                push!(index_expr.args, scoped_cs(i))
                if i isa BasicSymbolic{T}
                    push!(loopvar_order, i)
                end
            end
        end
        BSImpl.Term(; f) && if f === SymbolicUtils.array_literal end => begin
            # Get the neighbors of the `array_literal`.
            out_idx_nbors = Graphs.outneighbors(cs.ir.dependency_graph, nbors[1])
            # The first neighbor is the size tuple, so ignore it.
            for out_idx_i in Iterators.drop(out_idx_nbors, 1)
                out_idx = cs.ir[out_idx_i]
                @match out_idx begin
                    # Constant index - singleton dimension
                    BSImpl.Const(; val) => push!(index_expr.args, val::Int)
                    # Symbolic index - parallel loop
                    _ => begin
                        push!(index_expr.args, scoped_cs(out_idx))
                        push!(loopvar_order, out_idx)
                    end
                end
            end
        end
    end
    reverse!(loopvar_order)
    ref_expr = Expr(:ref, output_buffer, index_expr)

    declare!(scoped_cs, :__accum, Expr(:call, reducer, ref_expr, inner_result))
    declare!(scoped_cs, :_, Expr(:(=), ref_expr, :__accum))

    merge!(new_ranges, ranges)
    append!(loopvar_order, keys(new_ranges))
    unique!(loopvar_order)

    outer_expr = Expr(:block)
    cur_expr = outer_expr
    for lv in loopvar_order
        new_cur_expr = Expr(:block)
        push!(cur_expr.args, Expr(:for, Expr(:(=), scoped_cs(lv), new_ranges[lv]), new_cur_expr))
        cur_expr = new_cur_expr
    end

    scoped_block = exit_scope!(scoped_cs, bm)
    push!(cur_expr.args, scoped_block)

    declare!(cs, :_, outer_expr)

    return output_buffer
end

function codegen_function!(f::SymbolicUtils.Fill, cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {T}
    _allocator = get_allocator!(cs, nothing)
    result = Expr(:call)
    if _allocator === nothing
        push!(result.args, fill)
    else
        push!(result.args, fill!)
        output_buffer = codegen_allocator_call!(cs, _allocator, expr, expr_idx)
        push!(result.args, output_buffer)
    end

    push!(result.args, cs(cs.ir[Graphs.outneighbors(cs.ir.dependency_graph, expr_idx)[1]]))
    if _allocator === nothing
        for ax in f.sh
            push!(result.args, length(ax))
        end
        return codegen!(cs, expr_idx, result)
    end
    declare!(cs, get_misc_identifier(cs), result)
    return output_buffer
end

function write_constant_array!(cs::CodegenState{T}, vw::Symbol, val::AbstractArray) where {T}
    for (i, v) in enumerate(val)
        write_target = Expr(:ref, vw, i)
        declare!(cs, write_target, v)
    end
end

@generated function fill_arr!(buffer::AbstractArray, ::Val{sz}, args...) where {sz}
    @assert prod(sz) == length(args)
    result = Expr(:block)
    for (i, idx) in enumerate(CartesianIndices(sz))
        push!(result.args, :(buffer[$(Tuple(idx)...)] = args[$i]))
    end
    push!(result.args, :(return buffer))
    return result
end

@generated function fill_sarr(::Val{sz}, args...) where {sz}
    @assert prod(sz) == length(args)
    if length(sz) == 1
        return :(SVector{$(sz[1])}(args...))
    elseif length(sz) == 2
        return :(SMatrix{$(sz[1]), $(sz[2])}(args...))
    else
        error("fill_sarr only supports 1D and 2D arrays, got shape $sz")
    end
end

"""
Maximum total element count for which `fill_sarr` (returning a StaticArray)
will be used instead of the mutable `fill_arr!`.
"""
const STATIC_ARRAY_LIMIT::Int = 4

"""
Limit until which the generated code for an `ArrayMaker`/`array_literal` will use `fill_arr!`
over the standard codegen.
"""
const FILL_ARR_LIMIT = 16

@noinline function get_allocator_and_fill_zero!(allocator, sz)
    buffer = allocator(sz)
    fill!(buffer, 0)
    return buffer
end

function __allocator_call_and_fill_expr(allocator_sym::Symbol, sz_expr::Expr)
    return Expr(:call, get_allocator_and_fill_zero!, allocator_sym, sz_expr)
end

function __is_fill_zero(ex::BasicSymbolic{T}) where {T}
    @match ex begin
        BSImpl.ArrayOp(; term) && if term !== nothing end => @match term begin
            BSImpl.Term(; f, args) => f isa SymbolicUtils.Fill && SymbolicUtils._iszero(args[1])
            _ => false
        end
        _ => false
    end
end

function __allocator_is_returns_expr(::Type{T}, @nospecialize(ex)) where {T}
    if ex isa BasicSymbolic{T}
        @match ex begin
            BSImpl.Term(; f) => return f === Returns || f isa DataType && f <: Returns
            _ => return false
        end
    end
    return false
end

@noinline function batched_setindex!(buffer::AbstractArray{T, D}, values::NTuple{N, T}, idxs::NTuple{N, CartesianIndex{D}}) where {T, D, N}
    @inbounds for i in 1:N
        buffer[idxs[i]] = values[i]
    end
end
@noinline function batched_setindex!(buffer::AbstractArray{T, D}, value::T, idxs::AbstractArray{CartesianIndex{D}}) where {T, D}
    @inbounds for idx in idxs
        buffer[idx] = value
    end
end

BATCHED_SETINDEX_BATCH_SIZE::Int = 64

function codegen_function!(::Type{ArrayMaker{T}}, cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {T}
    _allocator = get_allocator!(cs, zeros)
    len = length(expr)::Int

    # We can only rely on the graph during codegen, so this is a roundabout way of obtaining
    # the `regions` and `values` fields of the `ArrayMaker`.
    expr_nbors = Graphs.outneighbors(cs.ir.dependency_graph, expr_idx)
    regions = unwrap_const(cs.ir[expr_nbors[1]])::SymbolicUtils.RegionsT
    values_expr_idx = expr_nbors[2]
    values_args = Graphs.outneighbors(cs.ir.dependency_graph, values_expr_idx)
    # Indices of the expressions in `values`.
    values_exprs_idxs = collect(Iterators.drop(values_args, 1))
    sh = shape(expr)

    # The array is small enough, so scalarize it and use `fill_arr!` or `fill_sarr`.
    if len <= FILL_ARR_LIMIT
        expr = SymbolicUtils.get_canonical_expr!(cs.ir, expr_idx)
        sz_expr = Expr(:tuple)
        for ax in sh
            push!(sz_expr.args, length(ax))
        end
        if all(<=(STATIC_ARRAY_LIMIT), sz_expr.args) && length(sz_expr.args) <= 2 && _allocator === zeros
            result = Expr(:call, fill_sarr, Expr(:call, Val, sz_expr))
            for idx in SymbolicUtils.stable_eachindex(expr)
                push!(result.args, cs(expr[idx]))
            end
        else
            output_buffer = codegen_allocator_call!(cs, _allocator, expr, expr_idx)
            result = Expr(:call, fill_arr!, output_buffer)
            push!(result.args, Expr(:call, Val, sz_expr))
            for idx in SymbolicUtils.stable_eachindex(expr)
                push!(result.args, cs(expr[idx]))
            end
        end
        return declare!(cs, get_misc_identifier(cs), result)
    end

    if _allocator !== zeros && !__allocator_is_returns_expr(T, _allocator) &&
            isequal(regions[1], sh) && __is_fill_zero(cs.ir[first(values_exprs_idxs)])
        output_buffer = codegen_allocator_call!(
            cs, _allocator, expr, expr_idx;
            allocator_call_expr = __allocator_call_and_fill_expr
        )
        ndrop = 1
    else
        output_buffer = codegen_allocator_call!(cs, _allocator, expr, expr_idx)
        ndrop = 0
    end

    # Indices and values of regions that write to a scalar
    scalar_idxs = Dict{ShapeVecT, Any}()
    D = length(sh)::Int
    # Utility buffers
    one_regions = ShapeVecT[]
    negone_regions = ShapeVecT[]
    other_regions = ShapeVecT[]
    other_values = Any[]

    eltype_expr = declare!(cs, get_misc_identifier(cs), Expr(:call, eltype, output_buffer))
    one_expr = Expr(:call, one, eltype_expr)
    negone_expr = Expr(:call, :(-), one_expr)

    function materialize_scalar_writes()
        empty!(one_regions)
        empty!(negone_regions)
        empty!(other_regions)
        empty!(other_values)
        # Batch all writes of +-1 together
        for region in keys(scalar_idxs)
            _val = scalar_idxs[region]
            if _val === 1
                push!(one_regions, region)
            elseif _val === -1
                push!(negone_regions, region)
            else
                push!(other_regions, region)
                push!(other_values, _val)
            end
        end
        if !isempty(one_regions)
            idxs_buffer = Vector{CartesianIndex{D}}(map(CartesianIndex{D} ∘ Tuple ∘ Base.Fix1(map, first), one_regions))
            # Directly interpolating an array into an expression avoids the allocation.
            declare!(cs, :_, Expr(:call, batched_setindex!, output_buffer, one_expr, idxs_buffer))
        end
        if !isempty(negone_regions)
            idxs_buffer = Vector{CartesianIndex{D}}(map(CartesianIndex{D} ∘ Tuple ∘ Base.Fix1(map, first), negone_regions))
            declare!(cs, :_, Expr(:call, batched_setindex!, output_buffer, negone_expr, idxs_buffer))
        end
        # Use `Iterators.partition` to avoid creating overly large tuples
        for (regs, vals) in zip(
                Iterators.partition(other_regions, BATCHED_SETINDEX_BATCH_SIZE),
                Iterators.partition(other_values, BATCHED_SETINDEX_BATCH_SIZE)
            )
            vals_expr = Expr(:tuple)
            for val in vals
                push!(vals_expr.args, Expr(:call, eltype_expr, val))
            end
            idxs_expr = Expr(:tuple)
            for reg in regs
                push!(idxs_expr.args, CartesianIndex{D}(Tuple(map(first, reg))))
            end
            declare!(cs, :_, Expr(:call, batched_setindex!, output_buffer, vals_expr, idxs_expr))
        end
    end

    for cur_region in Iterators.drop(eachindex(regions), ndrop)
        region = regions[cur_region]
        val_idx = values_exprs_idxs[cur_region]
        val = cs.ir[val_idx]
        # We are writing to a single element
        if all(isone ∘ length, region)
            # The goal is to batch scalar writes, so we defer them. Storing them in a
            # `Dict` allows later writes to overwrite earlier ones without additional
            # codegen.
            @match val begin
                BSImpl.Const(; val = _val) => begin
                    _inner = first(_val)
                    if _isone(_inner)
                        scalar_idxs[region] = 1
                    elseif _isone(-_inner)
                        scalar_idxs[region] = -1
                    else
                        scalar_idxs[region] = _inner
                    end
                end
                BSImpl.Term(; f) && if f === SymbolicUtils.array_literal end => begin
                    first_val_idx = Graphs.outneighbors(cs.ir.dependency_graph, val_idx)[2]
                    scalar_idxs[region] = cs(cs.ir[first_val_idx])
                end
                BSImpl.Term(; f) && if f isa Union{DataType, UnionAll} && f <: StaticArraysCore.StaticArray end => begin
                    first_val_idx = Graphs.outneighbors(cs.ir.dependency_graph, val_idx)[1]
                    scalar_idxs[region] = cs(cs.ir[first_val_idx])
                end
                _ => begin
                    # Unfortunately, scalarizing `val` requires getting the canonical expr.
                    canon_ex = SymbolicUtils.get_canonical_expr!(cs.ir, val_idx)
                    scalar_idxs[region] = cs(canon_ex[SymbolicUtils.stable_eachindex(canon_ex)[1]])
                end
            end
            continue
        end

        # We are writing to a block. First, materialize all scalar writes that happened until now.
        # This is operating on the assumption that non-scalar writes conflict with all scalar writes.
        # If this case is hit frequently, it might be useful to check for actual conflicts.
        if !isempty(scalar_idxs)
            materialize_scalar_writes()
        end
        empty!(scalar_idxs)
        # Materialize the view into the output buffer that we will write to.
        view_expr = Expr(:call, view, output_buffer)
        @union_split_smallvec region append!(view_expr.args, region)
        vw = declare!(cs, get_misc_identifier(cs), view_expr)
        @match val begin
            # Replace the allocator. We want it to write directly to the output
            # No point constructing a new expression, just do what `with_allocator`
            # would do in `codegen_ir!`.
            BSImpl.Term(; f) && if f === with_allocator end => begin
                old_allocator = add_allocator!(cs, ExistingBufferAllocator(vw))
                val_nbors = Graphs.outneighbors(cs.ir.dependency_graph, val_idx)
                cs(cs.ir[val_nbors[2]])
                reset_allocator!(cs, old_allocator)
            end
            # Any other operation that supports `with_allocator` should be generated to
            # write to the buffer directly.
            _ && if supports_with_allocator(val) end => begin
                old_allocator = add_allocator!(cs, ExistingBufferAllocator(vw))
                cs(val)
                reset_allocator!(cs, old_allocator)
            end
            # Constant arrays can special-case
            BSImpl.Const(; val) => write_constant_array!(cs, vw, val)
            # We don't have a fallback, so materialize the array corresponding to `val`
            # and `copyto!` it into the output buffer.
            _ => begin
                temp_array = cs(val)
                declare!(cs, get_misc_identifier(cs), Expr(:call, copyto!, vw, temp_array))
            end
        end
    end
    if !isempty(scalar_idxs)
        materialize_scalar_writes()
    end
    return declare!(cs, get_misc_identifier(cs), output_buffer)
end

function codegen_function!(
        ::typeof(SymbolicUtils.array_literal), cs::CodegenState{T}, expr::BasicSymbolic{T},
        expr_idx::Integer
    ) where {T}
    _allocator = get_allocator!(cs, nothing)
    if _allocator === nothing
        return codegen_function_no_nanmath!(SymbolicUtils.array_literal, cs, expr, expr_idx)
    end
    args_idxs = Graphs.outneighbors(cs.ir.dependency_graph, expr_idx)
    sh = @match expr begin
        BSImpl.Term(; shape) => shape
    end
    len = length(expr)::Int

    if len <= FILL_ARR_LIMIT
        sz_val = unwrap_const(cs.ir[first(args_idxs)])
        ndims_arr = length(sz_val)
        if all(<=(STATIC_ARRAY_LIMIT), sz_val) && ndims_arr <= 2 && _allocator === zeros
            result = Expr(:call, fill_sarr, Expr(:call, Val, sz_val))
            for arg_idx in Iterators.drop(args_idxs, 1)
                push!(result.args, cs(cs.ir[arg_idx]))
            end
        else
            output_buffer = codegen_allocator_call!(cs, _allocator, expr, expr_idx)
            result = Expr(:call, fill_arr!, output_buffer, Expr(:call, Val, sz_val))
            for arg_idx in Iterators.drop(args_idxs, 1)
                push!(result.args, cs(cs.ir[arg_idx]))
            end
        end
        return declare!(cs, get_misc_identifier(cs), result)
    end
    output_buffer = codegen_allocator_call!(cs, _allocator, expr, expr_idx)

    eltype_expr = declare!(cs, get_misc_identifier(cs), Expr(:call, eltype, output_buffer))
    cart_idxs = CartesianIndices(Tuple(sh::ShapeVecT))
    for iter in Iterators.partition(enumerate(Iterators.drop(args_idxs, 1)), BATCHED_SETINDEX_BATCH_SIZE)
        vals_expr = Expr(:tuple)
        idxs_expr = Expr(:tuple)
        for (idx, arg_idx) in iter
            push!(vals_expr.args, Expr(:call, eltype_expr, cs(cs.ir[arg_idx])))
            push!(idxs_expr.args, cart_idxs[idx])
        end
        declare!(cs, :_, Expr(:call, batched_setindex!, output_buffer, vals_expr, idxs_expr))
    end

    return output_buffer
end

"""
Somewhat arbitrary limit for the maximum number of arguments when calling n-ary
functions such as `+` or `*`.
"""
const NARY_CALL_LIMIT = 12

function codegen_function!(@nospecialize(op::Union{typeof(*), typeof(+)}), cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {T}
    if get(cs.rewrites, :sort_addmul, true)::Bool
        @assert isempty(cs.ir.non_canonical_idxs) "Sorted add/mul requires canonical IRStructure"
        args_idxs = Int32[]
        sargs = sorted_arguments(expr)
        for arg in sargs
            push!(args_idxs, cs.ir[arg])
        end
        # For type-stability, so it matches with the other branch
        args_idxs = SymbolicUtils.AdjView{Int32}(args_idxs)
    else
        args_idxs = Graphs.outneighbors(cs.ir.dependency_graph, expr_idx)
    end

    if length(args_idxs) == 1
        return codegen!(cs, expr_idx, Expr(:call, op, cs(cs.ir[first(args_idxs)])))
    elseif length(args_idxs) == 2
        return codegen!(cs, expr_idx, Expr(:call, op, cs(cs.ir[args_idxs[1]]), cs(cs.ir[args_idxs[2]])))
    end

    if symtype(expr) <: Number
        cur = Expr(:call, op)
        for (i, idx) in enumerate(args_idxs)
            if i % NARY_CALL_LIMIT == 0
                cur = Expr(:call, op, cur, cs(cs.ir[idx]))
            else
                push!(cur.args, cs(cs.ir[idx]))
            end
        end
        return codegen!(cs, expr_idx, cur)
    end

    # This is tensor add/mul. Do a `foldl`-esque implementation reinserting into the IR. This
    # CSEs identical matrix multiplications reliably. `A * B * C` and `A * B * D` will
    # reuse the common prefix result. Reuse in addition relies on hash ordering.
    prefix_args = ArgsT{T}()
    resize!(prefix_args, length(args_idxs) - 1)
    for i in 1:length(prefix_args)
        prefix_args[i] = cs.ir[args_idxs[i]]
    end
    # Yes, we could call `promote_symtype` and `promote_shape` but those don't really make
    # a difference in codegen and the entire point is to reuse common prefixes. Reusing
    # `symtype` and `shape` of `expr` is problematic because of `Matrix * Vector` et. al.
    # All we want is to recurse back into this method and for identical prefixes to hashcons
    # identically, which this accomplishes.
    prefix_term = BSImpl.Term{T}(op, prefix_args; type = Any, shape = Unknown(-1))
    prefix_expr = cs(prefix_term)
    last_term = cs.ir[args_idxs[length(args_idxs)]]
    last_expr = cs(last_term)
    return codegen!(cs, expr_idx, Expr(:call, op, prefix_expr, last_expr))
end

function codegen_function!(op::typeof(^), cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {T}
    base_idx, exp_idx = Graphs.outneighbors(cs.ir.dependency_graph, expr_idx)
    base_sym = cs(cs.ir[base_idx])
    exp = cs.ir[exp_idx]
    @match exp begin
        BSImpl.Const(; val) => begin
            if val isa Real
                if _isone(val)
                    return codegen!(cs, expr_idx, base_sym)
                end
                if _isone(-val)
                    return codegen!(cs, expr_idx, Expr(:call, inv, base_sym))
                end
                if !(val isa Integer) && get(cs.rewrites, :nanmath, false)::Bool
                    op = NaNMath.pow
                end
            end
            return codegen!(cs, expr_idx, Expr(:call, op, base_sym, val))
        end
        _ => begin
            sT = symtype(exp)
            exp_sym = cs(exp)
            if get(cs.rewrites, :nanmath, false)::Bool
                return codegen!(cs, expr_idx, Expr(:call, NaNMath.pow, base_sym, exp_sym))
            else
                return codegen!(cs, expr_idx, Expr(:call, ^, base_sym, exp_sym))
            end
        end
    end
end

function codegen_function!(::typeof(ifelse), cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {T}
    cond_idx, true_idx, false_idx = Graphs.outneighbors(cs.ir.dependency_graph, expr_idx)
    return codegen!(cs, expr_idx, Expr(:if, cs(cs.ir[cond_idx]), cs(cs.ir[true_idx]), cs(cs.ir[false_idx])))
end

# `ifelse_branching` emits each branch body into its own codegen scope so it lands inside the
# corresponding `if`/`else` arm rather than being hoisted ahead of the conditional. Together
# with `cse_inside_expr(_, ::typeof(ifelse_branching)) = false`, this guarantees the untaken
# branch is never evaluated, even when CSE is enabled. (`ifelse_eager` needs no method here:
# it lowers via the generic `codegen_function!` fallback to an eager call.)
function codegen_function!(::typeof(ifelse_branching), cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {T}
    cond_idx, true_idx, false_idx = Graphs.outneighbors(cs.ir.dependency_graph, expr_idx)
    cond = cs(cs.ir[cond_idx])

    true_cs, true_bm = enter_scope(cs)
    true_val = true_cs(cs.ir[true_idx])
    true_block = exit_scope!(true_cs, true_bm)
    push!(true_block.args, true_val)

    false_cs, false_bm = enter_scope(cs)
    false_val = false_cs(cs.ir[false_idx])
    false_block = exit_scope!(false_cs, false_bm)
    push!(false_block.args, false_val)

    return codegen!(cs, expr_idx, Expr(:if, cond, true_block, false_block))
end

function codegen_function_no_nanmath!(@nospecialize(op), cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {T}
    result = Expr(:call)
    if !(op isa BasicSymbolic{T})
        push!(result.args, op)
    end
    # If the operation is symbolic, we'll push it as the function to call here.
    # If it isn't symbolic, we'll push it above and here we add the arguments.
    nbors = Graphs.outneighbors(cs.ir.dependency_graph, expr_idx)
    for nbor in nbors
        push!(result.args, cs(cs.ir[nbor]))
    end
    return codegen!(cs, expr_idx, result)
end

function codegen_function!(@nospecialize(op), cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {T}
    # Avoid using `op in NaNMathFuns` since that is dynamic dispatch.
    # Also avoid using `nameof(op)` for the same reason.
    if !get(cs.rewrites, :nanmath, false)::Bool
        return codegen_function_no_nanmath!(op, cs, expr, expr_idx)
    elseif op === sin
        name = :sin
    elseif op === cos
        name = :cos
    elseif op === tan
        name = :tan
    elseif op === asin
        name = :asin
    elseif op === acos
        name = :acos
    elseif op === acosh
        name = :acosh
    elseif op === atanh
        name = :atanh
    elseif op === log
        name = :log
    elseif op === log2
        name = :log2
    elseif op === log10
        name = :log10
    elseif op === lgamma
        name = :lgamma
    elseif op === log1p
        name = :log1p
    elseif op === sqrt
        name = :sqrt
    else
        return codegen_function_no_nanmath!(op, cs, expr, expr_idx)
    end
    op = GlobalRef(NaNMath, name)
    return codegen_function_no_nanmath!(op, cs, expr, expr_idx)
end

function codegen_function!(::typeof(getindex), cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {T}
    args_idxs = Graphs.outneighbors(cs.ir.dependency_graph, expr_idx)
    if isequal(cs.ir[first(args_idxs)], SymbolicUtils.idxs_for_arrayop(T))
        offset = unwrap_const(cs.ir[args_idxs[2]])::Int
        return codegen_arrayop_indexer(offset)
    end
    result = Expr(:ref)
    for idx in args_idxs
        push!(result.args, cs(cs.ir[idx]))
    end
    return codegen!(cs, expr_idx, result)
end

function codegen_function!(@nospecialize(op::SymbolicUtils.Mapper), cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {T}
    result = Expr(:call, map)
    fn = op.f
    if fn isa BasicSymbolic{T}
        push!(result.args, cs(fn))
    else
        push!(result.args, fn)
    end
    args_idxs = Graphs.outneighbors(cs.ir.dependency_graph, expr_idx)
    for idx in args_idxs
        push!(result.args, cs(cs.ir[idx]))
    end
    return codegen!(cs, expr_idx, result)
end

function codegen_function!(@nospecialize(op::SymbolicUtils.Mapreducer), cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {T}
    result = Expr(:call, mapreduce)
    kws = Expr(:parameters)
    if op.dims isa Int
        dims = op.dims
        if dims isa BasicSymbolic{T}
            push!(kws.args, Expr(:kw, :dims, cs(dims)))
        else
            push!(kws.args, Expr(:kw, :dims, dims))
        end
    end
    if op.init !== nothing
        init = op.init
        if init isa BasicSymbolic{T}
            push!(kws.args, Expr(:kw, :init, cs(init)))
        else
            push!(kws.args, Expr(:kw, :init, init))
        end
    end
    if !isempty(kws.args)
        push!(result.args, kws)
    end
    fn = op.f
    if fn isa BasicSymbolic{T}
        push!(result.args, cs(fn))
    else
        push!(result.args, fn)
    end
    reducer = op.reduce
    if reducer isa BasicSymbolic{T}
        push!(result.args, cs(reducer))
    else
        push!(result.args, reducer)
    end
    args_idxs = Graphs.outneighbors(cs.ir.dependency_graph, expr_idx)
    for idx in args_idxs
        push!(result.args, cs(cs.ir[idx]))
    end
    return codegen!(cs, expr_idx, result)
end

function add_allocator!(cs::CodegenState, @nospecialize(alloc))
    old_allocator = get(cs.rewrites, ALLOCATOR_REWRITES_KEY, nothing)
    cs.rewrites[ALLOCATOR_REWRITES_KEY] = alloc
    return old_allocator
end

function reset_allocator!(cs::CodegenState, @nospecialize(old_alloc))
    cs.rewrites[ALLOCATOR_REWRITES_KEY] = old_alloc
    return nothing
end

function codegen_ir!(cs::CodegenState{T}, idx::Integer) where {T}
    cached = get(cs.cache, idx, nothing)
    if cached isa Symbol
        return cached
    end
    ir = cs.ir
    sym = ir[idx]
    if !SymbolicUtils.isconst(sym)
        new_expr = get(cs.rewrites, sym, nothing)
        if new_expr isa BasicSymbolic{T}
            new_idx = populate_ir!(ir, new_expr)
            return codegen_ir!(cs, new_idx)
        elseif new_expr isa Expr
            return codegen!(cs, idx, new_expr)
        elseif new_expr isa Symbol
            return codegen!(cs, idx, new_expr)
        elseif new_expr !== nothing
            _unreachable()
        end
    end

    @match sym begin
        BSImpl.Const(; val) => if val isa CodegenPrimitive
            return cs(val)
        else
            return codegen!(cs, idx, val)
        end
        BSImpl.Sym(; name) => return codegen!(cs, idx, name)
        BSImpl.ArrayOp(; term) => if term isa BasicSymbolic{T}
            # NOTE: This used to call `populate_ir!(ir, term)` and
            # then `codegen_ir!` on that. However, if the IR is non-canonical
            # this leads to incorrect results since `term` is incorrect
            # and we should use the graph at this node (which reflects what
            # `term` should be). `codegen_function!` overcomes this by doing
            # the "normal" thing with the correct operation.
            return codegen_function!(operation(term), cs, sym, idx)
        else
            return codegen_function!(ArrayOp{T}, cs, sym, idx)
        end
        BSImpl.ArrayMaker(;) => return codegen_function!(ArrayMaker{T}, cs, sym, idx)
        BSImpl.Term(; f) => begin
            if f === (^)
                return codegen_function!(^, cs, sym, idx)
            elseif f === ifelse
                return codegen_function!(ifelse, cs, sym, idx)
            elseif f === getindex
                return codegen_function!(getindex, cs, sym, idx)
            elseif f === with_allocator
                args_idxs = Graphs.outneighbors(ir.dependency_graph, idx)
                new_allocator = ir[first(args_idxs)]
                old_allocator = add_allocator!(cs, new_allocator)
                result = cs(ir[args_idxs[2]])
                reset_allocator!(cs, old_allocator)
                return result
            else
                return codegen_function!(f, cs, sym, idx)::Symbol
            end
        end
        BSImpl.Div(;) => begin
            num_idx, den_idx = Graphs.outneighbors(ir.dependency_graph, idx)
            return codegen!(cs, idx, Expr(:call, /, cs(ir[num_idx]), cs(ir[den_idx])))
        end
        BSImpl.AddMul(; variant) => if variant === AddMulVariant.ADD
            return codegen_function!((+), cs, sym, idx)
        else
            return codegen_function!((*), cs, sym, idx)
        end
    end
end

function (cs::CodegenState)(arr::AbstractArray)
    uarr = unwrap(arr)
    if uarr !== arr
        return cs(uarr)
    end
    return cs(MakeArray(arr, typeof(arr)))
end

function (cs::CodegenState)(arr::Union{SparseVector, SparseMatrixCSC})
    return cs(MakeSparseArray(arr))
end

function (cs::CodegenState)(@nospecialize(thing))
    uthing = unwrap(thing)
    if uthing !== thing
        return cs(uthing)
    end
    return declare!(cs, get_misc_identifier(cs), thing)
end

function (cs::CodegenState)(expr::BasicSymbolic{T})::Symbol where {T}
    idx = populate_ir!(cs.ir, expr)
    codegen_ir!(cs, idx)
end

function (cs::CodegenState)(expr::Assignment)
    lhs = manual_dispatch_toexpr(expr.lhs, NameState(cs.rewrites))
    # Previously this only generated a block if `Meta.isexpr(lhs, :call)` for inline
    # function declarations. This was changed when CSE variables were made to declare
    # as `local`, since `let` block's don't allow `local` for assignments in the header.
    scs, bm = enter_scope(cs)
    scs(expr.rhs)
    rhs = exit_scope!(scs, bm)
    
    return declare!(cs, lhs, rhs)
end

const ARGNAME_PREFIX = Vector{UInt8}("__argₛᵧₘ")

function add_arg_to_rewrites!(rewrites::Dict{Any, Any}, lhs::BasicSymbolic{T}) where {T}
    rewrites[lhs] = if get(rewrites, :readable_variables, false)::Bool
        Symbol(string(lhs)::String)
    else
        get_numbered_symbol_with_prefix(ARGNAME_PREFIX, hash(lhs))
    end
end

function (cs::CodegenState{T})(l::Let) where {T}
    if all(x->x isa Assignment && !(x.lhs isa DestructuredArgs), l.pairs)
        dargs = Vector{Assignment}(l.pairs)
    else
        dargs = Assignment[]
        for x in l.pairs
            handle_let_pair!(dargs, x, cs)
        end
    end

    if l.let_block
        scs, bm = enter_scope(cs)
        for asg in dargs
            lhs = asg.lhs
            if lhs isa BasicSymbolic{T} && iscall(lhs)
                add_arg_to_rewrites!(scs.rewrites, lhs)
            end
            scs(asg)
        end
        bindings = exit_scope!(scs, bm)

        scs, bm = enter_scope(cs)
        scs(l.body)
        body = exit_scope!(scs, bm)
        result = Expr(:let, bindings, body)
        return declare!(cs, get_misc_identifier(cs), result)
    end
    isempty(dargs) && return cs(l.body)

    for asg in dargs
        lhs = asg.lhs
        if lhs isa BasicSymbolic{T} && iscall(lhs)
            add_arg_to_rewrites!(cs.rewrites, lhs)
        end
        cs(asg)
    end

    return cs(l.body)
end

function (cs::CodegenState{T})(fn::Func) where {T}
    dargs = Union{Assignment, DestructuredArgs}[]
    for arg in fn.args
        if arg isa BasicSymbolic{T}
            add_arg_to_rewrites!(cs.rewrites, arg)
        elseif arg isa Assignment
            lhs = arg.lhs
            if lhs isa BasicSymbolic{T}
                add_arg_to_rewrites!(cs.rewrites, lhs)
            end
        elseif arg isa DestructuredArgs
            push!(dargs, arg)
        end
    end
    for kw in fn.kwargs
        lhs = kw.lhs
        if lhs isa BasicSymbolic{T}
            # Does not use `add_arg_to_rewrites!` because kwarg names matter
            cs.rewrites[lhs] = Symbol(string(lhs)::String)
        end
    end

    scs, bm = enter_scope(cs)
    scs(Let(dargs, fn.body, false))
    body = exit_scope!(scs, bm)

    fn_args = Expr(:tuple)
    if !isempty(fn.kwargs)
        fn_kws = Expr(:parameters)
        for asg in fn.kwargs
            lhs = manual_dispatch_toexpr(asg.lhs, NameState(cs.rewrites))
            asg_cs, bm = enter_scope(cs)
            asg_cs(asg.rhs)
            rhs = exit_scope!(asg_cs, bm)
            push!(fn_kws.args, Expr(:kw, lhs, rhs))
        end
        push!(fn_args.args, fn_kws)
    end

    for arg in fn.args
        if arg isa BasicSymbolic{T}
            push!(fn_args.args, cs.rewrites[arg]::Symbol)
        elseif arg isa Assignment
            asg_cs, bm = enter_scope(cs)
            asg_cs(arg.rhs)
            rhs = exit_scope!(asg_cs, bm)
            lhs = manual_dispatch_toexpr(arg.lhs, NameState(cs.rewrites))
            push!(fn_args.args, Expr(:(=), lhs, rhs))
        elseif arg isa DestructuredArgs
            name = arg.name
            if name isa BasicSymbolic{T}
                push!(fn_args.args, manual_dispatch_toexpr(name, NameState(cs.rewrites)))
            else
                push!(fn_args.args, name::Symbol)
            end
        else
            push!(fn_args.args, manual_dispatch_toexpr(arg, NameState(cs.rewrites)))
        end
    end

    fn_body = Expr(:block)
    append!(fn_body.args, fn.pre)
    push!(fn_body.args, body)
    return declare!(cs, get_misc_identifier(cs), Expr(:function, fn_args, fn_body))
end

function (cs::CodegenState)(ex::SetArray)
    arr = cs(ex.arr)::Symbol
    lhss = []
    rhss = Symbol[]
    for (i, elem) in enumerate(ex.elems)
        if elem isa AtIndex
            push!(lhss, cs(elem.i))
            push!(rhss, cs(elem.elem))
        else
            push!(lhss, i)
            push!(rhss, cs(elem))
        end
    end

    scs, bm = enter_scope(cs)
    for (lhs, rhs) in zip(lhss, rhss)
        declare!(scs, Expr(:ref, arr, lhs), rhs)
    end
    declare!(scs, get_misc_identifier(cs), ex.return_arr ? arr : nothing)
    body = exit_scope!(scs, bm)
    if ex.inbounds
        body = Expr(:macrocall, nameof(var"@inbounds"), LineNumberNode(0), body)
    end
    return declare!(cs, get_misc_identifier(cs), body)
end

function (cs::CodegenState)(ex::MakeArray)
    _similarto = ex.similarto
    if _similarto isa Type
        similarto = cs(_similarto)
    else
        similarto = declare!(cs, get_misc_identifier(cs), Expr(:call, typeof, cs(_similarto)))
    end
    ndim = ndims(ex.elems)::Int
    elT = ex.output_eltype
    result = Expr(
        :call, create_array, similarto, elT, Expr(:call, Expr(:curly, Val, ndim)),
        Expr(:call, Expr(:curly, Val, size(ex.elems)))
    )
    for x in ex.elems
        push!(result.args, cs(x))
    end
    return declare!(cs, get_misc_identifier(cs), result)
end

function (cs::CodegenState{T})(a::MakeSparseArray{<:SparseMatrixCSC}) where {T}
    I, J, V = findnz(a.array)
    m, n = size(a.array)
    result = Expr(:call, sparse, I, J, cs(Const{T}(V)), m, n)
    return declare!(cs, get_misc_identifier(cs), result)
end

function (cs::CodegenState{T})(a::MakeSparseArray{<:SparseVector}) where {T}
    I, V = findnz(a.array)
    n = length(a.array)
    result = Expr(:call, SparseVector, n, I, cs(Const{T}(V)))
    return declare!(cs, get_misc_identifier(cs), result)
end

function (cs::CodegenState)(a::MakeTuple)
    result = Expr(:tuple)
    for ex in a.elems
        push!(result.args, cs(ex))
    end
    return declare!(cs, get_misc_identifier(cs), result)
end

function (cs::CodegenState)(ex::LiteralExpr)
    declare!(cs, get_misc_identifier(cs), recurse_expr(ex.ex, NameState(cs.rewrites)))
end

function (cs::CodegenState)(f::ForLoop)
    st = NameState(cs.rewrites)
    result = Expr(
        :for, Expr(
            :(=), manual_dispatch_toexpr(f.itervar, st), manual_dispatch_toexpr(f.range, st)
        )
    )
    scs, bm = enter_scope(cs)
    scs(f.body)
    body = exit_scope!(scs, bm)
    push!(result.args, body)
    return declare!(cs, get_misc_identifier(cs), result)
end

function codegen_function!(::Type{Let}, cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {T}
    nbors = Graphs.outneighbors(cs.ir.dependency_graph, expr_idx)
    n = length(nbors)
    body_idx = nbors[n]

    # Codegen each symAssignment as a side effect in order
    for i in 1:n-1
        cs(cs.ir[nbors[i]])
    end

    return codegen!(cs, expr_idx, cs(cs.ir[body_idx]))
end

function codegen_function!(::Type{Assignment}, cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {T}
    nbors = Graphs.outneighbors(cs.ir.dependency_graph, expr_idx)
    lhs_expr = cs.ir[nbors[1]]
    rhs = cs.ir[nbors[2]]

    # Generate the RHS before the LHS in its own scope. If the RHS involves the LHS
    # (e.g. `x ← x + y`) The `x` on the RHS will not generate correctly without this.
    # The scope allows `x + y` to refer to the symbol `x`, and then for the assignment
    # to redefine `x` as the rewrite created below.
    scoped_cs, bm = enter_scope(cs)
    scoped_cs(rhs)
    rhs_result = exit_scope!(scoped_cs, bm)
    # This is intentionally different from normal assignment codegen. That has to be
    # backward compatible, but this comes from `symAssignment` and doesn't. The old
    # version turns `Assignment(x(t), rhs)` into `x(t) = rhs` which is an inline
    # function. `symAssignment` turns it into `var"x(t)" = rhs`, and to declare
    # a function the user can use `symFunc`.
    lhs = add_arg_to_rewrites!(cs.rewrites, lhs_expr)
    return codegen!(cs, expr_idx, Expr(:(=), lhs, rhs_result))
end

function codegen_function!(::Type{Func}, cs::CodegenState{T}, expr::BasicSymbolic{T}, expr_idx::Integer) where {T}
    nbors = Graphs.outneighbors(cs.ir.dependency_graph, expr_idx)
    args_term_idx = nbors[1]
    body_idx = nbors[2]

    args_nbors = Graphs.outneighbors(cs.ir.dependency_graph, args_term_idx)
    n_args = length(args_nbors)
    body = cs.ir[body_idx]

    # We actually want to use a whole now `CodegenState` here. The arguments to this function
    # can be variables already present in the outer code. An expression already generated in `cs`
    # involving these arguments would then point to the outer code instead of something
    # dependent on the argument of this inner closure.
    #
    # Since we're copying the current `rewrites`, arguments passed to the outer function
    # will be available to the closure.
    new_rewrites = copy(cs.rewrites)

    # (name, elems): array param + the element variables to bind inside the body
    dargs_info = Tuple{BasicSymbolic{T}, Vector{BasicSymbolic{T}}}[]

    for i in 1:n_args
        arg = cs.ir[args_nbors[i]]
        @match arg begin
            BSImpl.Sym(;) => begin
                add_arg_to_rewrites!(new_rewrites, arg)
            end
            BSImpl.Term(; f) && if f === DestructuredArgs end => begin
                da_nbors = Graphs.outneighbors(cs.ir.dependency_graph, args_nbors[i])
                name = cs.ir[da_nbors[1]]
                elems = BasicSymbolic{T}[cs.ir[da_nbors[j]] for j in 2:length(da_nbors)]
                add_arg_to_rewrites!(new_rewrites, name)
                push!(dargs_info, (name, elems))
            end
            _ => nothing
        end
    end

    fn_body_block = let block = Expr(:block), expr = block, inner_cs = CodegenState(
            expr, block, cs.ir, new_rewrites
        )
        # Emit destructuring bindings — elem_i = array_param[i] — before the body
        for (name, elems) in dargs_info
            name_sym = inner_cs.rewrites[name]::Symbol
            for (i, elem) in enumerate(elems)
                elem_name = manual_dispatch_toexpr(elem, NameState(inner_cs.rewrites))
                declare!(inner_cs, elem_name, Expr(:ref, name_sym, i))
            end
        end

        inner_cs(body)
        inner_cs.expr
    end

    fn_args = Expr(:tuple)
    for i in 1:n_args
        arg = cs.ir[args_nbors[i]]
        @match arg begin
            BSImpl.Sym(;) => push!(fn_args.args, new_rewrites[arg]::Symbol)
            BSImpl.Term(; f) && if f === DestructuredArgs end => begin
                da_nbors = Graphs.outneighbors(cs.ir.dependency_graph, args_nbors[i])
                name = cs.ir[da_nbors[1]]
                push!(fn_args.args, new_rewrites[name]::Symbol)
            end
            _ => push!(fn_args.args, manual_dispatch_toexpr(arg, NameState(cs.rewrites)))
        end
    end

    result = codegen!(cs, expr_idx, Expr(:function, fn_args, Expr(:block, fn_body_block)))

    return result
end

using SymbolicUtils: OrderedDiGraph, AdjView, OrderedDiGraphEdgeIter
using Graphs
using Test
using JET

# Helper: build AdjView variants directly.
const _ntup0 = AdjView{Int}((0, 0))
const _ntup1 = AdjView{Int}((3, 0))
const _ntup2 = AdjView{Int}((3, 7))
const _vec3  = AdjView{Int}([4, 5, 6])
const _set3  = AdjView{Int}(Set([4, 5, 6]))

# ── AdjView iteration type-stability ──────────────────────────────────────────

@testset "JET: AdjView NTuple variant" begin
    @test_opt iterate(_ntup0)
    @test_opt iterate(_ntup1)
    @test_opt iterate(_ntup2)
    @test_opt iterate(_ntup2, 2)
    @test_opt length(_ntup2)
    @test_opt (3 in _ntup2)
end

@testset "JET: AdjView Vector variant" begin
    @test_opt iterate(_vec3)
    @test_opt iterate(_vec3, 2)
    @test_opt length(_vec3)
    @test_opt (5 in _vec3)
end

@testset "JET: AdjView Set variant" begin
    @test_opt iterate(_set3)
    @test_opt length(_set3)
    @test_opt (5 in _set3)
end

# ── Graph operations ───────────────────────────────────────────────────────────

function _sum_outneighbors_jet(g::OrderedDiGraph{Int}, v::Int)
    s = 0
    for x in outneighbors(g, v)
        s += x
    end
    return s
end

function _sum_inneighbors_jet(g::OrderedDiGraph{Int}, v::Int)
    s = 0
    for x in inneighbors(g, v)
        s += x
    end
    return s
end

@testset "JET: loop over outneighbors (NTuple backing)" begin
    g = OrderedDiGraph{Int}(3)
    add_edge!(g, 1, 2); add_edge!(g, 1, 3)
    @test_opt _sum_outneighbors_jet(g, 1)
end

@testset "JET: loop over outneighbors (Vector backing)" begin
    g = OrderedDiGraph{Int}(4)
    add_edge!(g, 1, 2); add_edge!(g, 1, 3); add_edge!(g, 1, 4)
    @test_opt _sum_outneighbors_jet(g, 1)
end

@testset "JET: loop over inneighbors (NTuple backing)" begin
    g = OrderedDiGraph{Int}(3)
    add_edge!(g, 2, 1); add_edge!(g, 3, 1)
    @test_opt _sum_inneighbors_jet(g, 1)
end

@testset "JET: loop over inneighbors (Set backing)" begin
    g = OrderedDiGraph{Int}(4)
    add_edge!(g, 2, 1); add_edge!(g, 3, 1); add_edge!(g, 4, 1)
    @test_opt _sum_inneighbors_jet(g, 1)
end

# ── Graphs.jl API type-stability ───────────────────────────────────────────────

function _edges_sum_jet(g::OrderedDiGraph{Int})
    s = 0
    for e in edges(g)
        s += src(e) + dst(e)
    end
    return s
end

@testset "JET: nv, ne, vertices, is_directed" begin
    g = OrderedDiGraph{Int}(4)
    add_edge!(g, 1, 2); add_edge!(g, 1, 3)
    @test_opt nv(g)
    @test_opt ne(g)
    @test_opt vertices(g)
    @test_opt is_directed(g)
    @test_opt is_directed(OrderedDiGraph{Int})
end

@testset "JET: has_vertex, has_edge" begin
    g = OrderedDiGraph{Int}(4)
    add_edge!(g, 1, 2)
    @test_opt has_vertex(g, 1)
    @test_opt has_edge(g, 1, 2)
    @test_opt has_edge(g, 1, 4)
end

@testset "JET: outneighbors / inneighbors return AdjView{T}" begin
    g = OrderedDiGraph{Int}(4)
    add_edge!(g, 1, 2); add_edge!(g, 1, 3)
    add_edge!(g, 2, 1); add_edge!(g, 3, 1); add_edge!(g, 4, 1)
    @test_opt outneighbors(g, 1)
    @test_opt inneighbors(g, 1)
end

@testset "JET: edges iterator" begin
    g = OrderedDiGraph{Int}(4)
    add_edge!(g, 1, 2); add_edge!(g, 1, 3); add_edge!(g, 2, 4)
    @test_opt edges(g)
    @test_opt length(edges(g))
    @test_opt iterate(edges(g))
    @test_opt (Graphs.Edge(1, 2) in edges(g))
    @test_opt _edges_sum_jet(g)
end

@testset "JET: add_vertex!, add_edge!" begin
    g = OrderedDiGraph{Int}(4)
    @test_opt add_vertex!(g)
    @test_opt add_edge!(g, 1, 3)
end

@testset "JET: copy, ==, zero" begin
    g = OrderedDiGraph{Int}(3)
    add_edge!(g, 1, 2); add_edge!(g, 2, 3)
    h = copy(g)
    @test_opt copy(g)
    @test_opt (g == h)
    @test_opt zero(OrderedDiGraph{Int})
end

"""
    _indexed_ndims(index_types...)

Return the number of array dimensions selected by a tuple of index types.
Integer and scalar indices consume no dimensions, while `Colon` and integer
vectors consume one. Invalid index types throw `ArgumentError`.

This helper is part of the developer indexing interface used by
`promote_symtype(getindex, ...)`.
"""
@inline _indexed_ndims() = 0
@inline _indexed_ndims(::Type{T}, rest...) where {T <: Integer} = _indexed_ndims(rest...)
@inline _indexed_ndims(::Type{<:AbstractVector{<:Integer}}, rest...) = 1 + _indexed_ndims(rest...)
@inline _indexed_ndims(::Type{Colon}, rest...) = 1 + _indexed_ndims(rest...)
@inline _indexed_ndims(::Type{T}, rest...) where {T} = throw(ArgumentError(LazyString("Invalid index type ", T, ".")))

function promote_symtype(::typeof(getindex), ::Type{T}, Ts::Vararg{Any, N}) where {N, eT, T <: AbstractArray{eT, N}}
    nD = _indexed_ndims(Ts...)
    nD == 0 ? eT : Array{eT, nD}
end

function promote_symtype(::typeof(getindex), ::Type{T}, Ts...) where {eT, T <: AbstractArray{eT}}
    nD = _indexed_ndims(Ts...)
    nD == 0 ? eT : Array{eT, nD}
end

function promote_symtype(::typeof(getindex), ::Type{T}) where {T <: Number}
    T
end

promote_symtype(::typeof(getindex), ::Type{Symbol}, Ts...) = Any

@noinline function _throw_cartesian_indexing()
    throw(ArgumentError("Symbolic `getindex` requires cartesian indexing."))
end

function promote_symtype(::typeof(getindex), ::Type{T}, Ts...) where {N, eT, T <: AbstractArray{eT, N}}
    _throw_cartesian_indexing()
end

@noinline function throw_no_unknown_colon()
    throw(ArgumentError("Cannot index array of unknown shape with `Colon` (`:`)."))
end

@noinline function throw_index_larger_than_shape(i, ii, shi)
    throw(ArgumentError(LazyString("Tried to index array whose `", i, "`th dimension has shape ", shi, " with index ", ii, ".")))
end

@noinline function throw_not_array(x)
    throw(ArgumentError(LazyString("Cannot call `getindex` on non-array symbolics - found array of shape ", x, ".")))
end

function promote_shape(::typeof(getindex), sharr::ShapeT, shidxs::ShapeVecT...)
    @nospecialize sharr
    # `promote_symtype` rules out the presence of multidimensional indices - each index
    # is either an integer, Colon or vector of integers.
    is_array_shape(sharr) || isempty(shidxs) || throw_not_array(sharr)
    result = ShapeVecT()
    for (i, idx) in enumerate(shidxs)
        isempty(idx) && continue
        idx[1] == 1:0 && sharr isa Unknown && throw_no_unknown_colon()
        ii = idx[1] == 1:0 ? sharr[i] : 1:length(idx[1])
        push!(result, ii)
        if sharr isa ShapeVecT && length(ii) > length(sharr[i])
            throw_index_larger_than_shape(i, ii, sharr[i])
        end
    end

    return result
end

function promote_shape(::typeof(getindex), sharr::ShapeT, shidxs::ShapeT...)
    throw(ArgumentError("Cannot use arrays of unknown size for indexing."))
end

function Base.getindex(arr::BasicSymbolic{T}, idxs::Union{BasicSymbolic{T}, Int, AbstractRange{Int}, Colon}...) where {T}
    # Fast path: scalar integer indexing into ArrayOp bypasses @cache (each index is unique).
    # Guarded on VERSION because calling _getindex directly from this Vararg Union method
    # triggers a segfault in Julia 1.10's codegen (general_use_analysis).
    @static if VERSION >= v"1.11"
        if isarrayop(arr) && all(x -> x isa Int, idxs)
            return _getindex(T, arr, idxs...)
        end
    end
    if T === SymReal
        return _getindex_1(arr, idxs...)
    elseif T === SafeReal
        return _getindeX_2(arr, idxs...)
    end
    _unreachable()
end

@cache function _getindex_1(arr::BasicSymbolic{SymReal}, idxs::Union{BasicSymbolic{SymReal}, Int, AbstractRange{Int}, Colon}...)::BasicSymbolic{SymReal}
    _getindex(SymReal, arr, idxs...)
end
@cache function _getindex_2(arr::BasicSymbolic{SafeReal}, idxs::Union{BasicSymbolic{SafeReal}, Int, AbstractRange{Int}, Colon}...)::BasicSymbolic{SafeReal}
    _getindex(SafeReal, arr, idxs...)
end

"""
    $TYPEDEF

A wrapper around a small vector of integer indices that provides a stable,
allocation-efficient representation of multi-dimensional array indices.

This type is used in conjunction with [`StableIndices`](@ref) to iterate over
multi-dimensional index spaces in a type-stable manner. It implements the
standard iteration and indexing interfaces.

This is effectively equivalent to `CartesianIndex` for symbolic arrays, but
avoids type-instability due to `N` in `CartesianIndex{N}` being uninferrable.

# Fields
$TYPEDFIELDS

# See also
- [`StableIndices`](@ref): An iterator that produces `StableIndex` values.
- [`stable_eachindex`](@ref): Returns a `StableIndices` iterator for a symbolic array.
"""
struct StableIndex{I}
    """
    A small vector storing the indices for each dimension. Indices can either be integers
    or `BasicSymbolic`s where all values have integer symtypes.
    """
    idxs::SmallV{I}

    StableIndex(idxs::SmallV{Int}) = new{Int}(idxs)
    function StableIndex(idxs::AbstractVector{Int})
        _idxs = SmallV{Int}()
        sizehint!(_idxs, length(idxs))
        append!(_idxs, idxs)
        return new{Int}(_idxs)
    end
    StableIndex(idxs::SmallV{BasicSymbolic{T}}) where {T} = new{BasicSymbolic{T}}(idxs)
    function StableIndex(idxs::AbstractVector{BasicSymbolic{T}}) where {T}
        _idxs = SmallV{BasicSymbolic{T}}()
        sizehint!(_idxs, length(idxs))
        for x in idxs
            @assert symtype(x) <: Integer
        end
        append!(_idxs, idxs)
        return new{BasicSymbolic{T}}(_idxs)
    end
end

"""
    $TYPEDSIGNATURES

Build a `StableIndex` from an indexed symbolic `sym`. Requires that all indices are
integers.
"""
function StableIndex{Int}(sym::BasicSymbolic{T}) where {T}
    idxs = SmallV{Int}()
    @match sym begin
        BSImpl.Term(; f, args) && if f === getindex end => begin
            sizehint!(idxs, length(args) - 1)
            for i in 2:length(args)
                push!(idxs, unwrap_const(args[i])::Int)
            end
            return StableIndex(idxs)
        end
        _ => throw(ArgumentError("Can only build `StableIndex{Int}` from indexed symbolic."))
    end
end

Base.getindex(x::StableIndex, i::Int) = x.idxs[i]
Base.length(x::StableIndex) = length(x.idxs)
Base.iterate(x::StableIndex, args...) = iterate(x.idxs, args...)
Base.eltype(::Type{StableIndex}) = Int
Base.isequal(a::StableIndex{T}, b::StableIndex{T}) where {T} = isequal(a.idxs, b.idxs)
const STABLE_INDEX_SEED = 0x47da907bc9126ce1
Base.hash(a::StableIndex, h::UInt) = hash(a.idxs, h) ⊻ STABLE_INDEX_SEED

function Base.to_indices(A, inds, I::Tuple{StableIndex{Int}})
    return (as_linear_idx(axes(A), I[1]),)
end

"""
    $TYPEDSIGNATURES

Turn the index `I` into a linear index into an array for which `Base.axes` returns `sh`.
"""
@generated function as_linear_idx(sh::NTuple{N}, I::StableIndex{Int}) where {N}
    return quote
        linear_idx = 1
        acc = 1
        Base.@nexprs $N i -> begin
            ax = sh[i]
            linear_idx += (I.idxs[i] - first(ax)) * acc
            acc *= length(ax)
        end
        return linear_idx
    end
end

"""
    $TYPEDSIGNATURES

Turn the index `I` into a linear index into an array of shape `sh`.
"""
function as_linear_idx(sh::ShapeVecT, sidxs::StableIndex)
    linear_idx = 1
    acc = 1
    for i in eachindex(sh)
        ax = sh[i]
        linear_idx += (sidxs.idxs[i] - first(ax)) * acc
        acc *= length(ax)
    end
    return linear_idx
end

# To act as a function barrier
function scalar_index(@nospecialize(val), idx::Int)
    vec(val)[idx]
end

function Base.getindex(arr::BasicSymbolic{SymReal}, idxs::StableIndex)
    _stable_getindex_1(arr, idxs)
end
function Base.getindex(arr::BasicSymbolic{SafeReal}, idxs::StableIndex)
    _stable_getindex_2(arr, idxs)
end

@cache function _stable_getindex_1(arr::BasicSymbolic{SymReal}, sidxs::StableIndex{Int})::BasicSymbolic{SymReal}
    __stable_getindex(arr, sidxs)
end
@cache function _stable_getindex_2(arr::BasicSymbolic{SafeReal}, sidxs::StableIndex{Int})::BasicSymbolic{SafeReal}
    __stable_getindex(arr, sidxs)
end
function _stable_getindex_1(arr::BasicSymbolic{SymReal}, sidxs::StableIndex)
    __stable_getindex(arr, sidxs)
end
function _stable_getindex_2(arr::BasicSymbolic{SafeReal}, sidxs::StableIndex)
    __stable_getindex(arr, sidxs)
end

function _throw_arraymaker_out_of_range(x::BasicSymbolic, idx)
    throw(ArgumentError(LazyString("Index ", idx, " is out of range for `", x, "`.")))
end

function __stable_getindex(arr::BasicSymbolic{T}, sidxs::StableIndex{I}) where {T, I}
    idxs = sidxs.idxs
    isempty(idxs) && return arr
    sh = shape(arr)
    if I === Int
        sh = sh::ShapeVecT
        @match arr begin
            BSImpl.Const(; val) => return Const{T}(scalar_index(val, as_linear_idx(sh, sidxs)))
            BSImpl.Term(; f, args) && if f === array_literal end => begin
                return args[1 + as_linear_idx(sh, sidxs)]
            end
            BSImpl.Term(; f, args) && if f isa Union{DataType, UnionAll} && f <: StaticArraysCore.StaticArray end => begin
                return args[as_linear_idx(sh, sidxs)]
            end
            BSImpl.Term(; f, args) && if f isa TypeT && f <: CartesianIndex end => begin
                return args[as_linear_idx(sh, sidxs)]
            end
            BSImpl.ArrayMaker(; regions, values) => begin
                length(sh) == length(idxs) || _throw_cartesian_indexing()
                @union_split_smallvec regions @union_split_smallvec values @union_split_smallvec idxs begin
                    for (reg, val) in Iterators.reverse(zip(regions, values))
                        @union_split_smallvec reg begin
                            all(splat(in), zip(idxs, reg)) || continue
                            new_idxs = SmallV{Int}()
                            sizehint!(new_idxs, length(idxs))
                            for (idx, ax) in zip(idxs, reg)
                                push!(new_idxs, idx - first(ax) + 1)
                            end
                            return __stable_getindex(val, StableIndex(new_idxs))
                        end
                    end
                    _throw_arraymaker_out_of_range(arr, sidxs)
                end
            end
            _ => nothing
        end
    end
    @match arr begin
        BSImpl.Term(; f, args) && if f isa Operator && length(args) == 1 end => begin
            inner = args[1][sidxs]
            return BSImpl.Term{T}(f, ArgsT{T}((inner,)); type = symtype(inner), shape = ShapeVecT())
        end
        BSImpl.Term(; f, args) && if f === getindex && all(isconst, Iterators.drop(args, 1)) && !any(x -> x isa BasicSymbolic{T}, idxs) end => begin
            newargs = ArgsT{T}()
            push!(newargs, args[1])
            type = eltype(symtype(arr))::TypeT
            newshape = ShapeVecT()
            idxs_i = 1
            for oldidx in Iterators.drop(args, 1)
                oldidx_sh = shape(oldidx)
                if !is_array_shape(oldidx_sh)
                    push!(newargs, oldidx)
                    continue
                end
                idx = idxs[idxs_i]
                idxs_i += 1
                # special case when `oldidx` is `Colon()`
                if length(oldidx_sh) == 1 && oldidx_sh[1] == 1:0
                    push!(newargs, Const{T}(idx))
                else
                    push!(newargs, Const{T}(unwrap_const(oldidx)[idx]))
                end
            end
            @assert idxs_i == length(idxs) + 1
            return BSImpl.Term{T}(f, newargs; type, shape = newshape)
        end
        _ => nothing
    end
    type = eltype(symtype(arr))::TypeT
    newshape = ShapeVecT()
    @match arr begin
        BSImpl.ArrayOp(; output_idx, expr, ranges, reduce, term) => begin
            subrules = Dict{BasicSymbolic{T}, Union{BasicSymbolic{T}, Int}}()
            empty!(subrules)
            idxsym_idx = 1
            idxsym = idxs_for_arrayop(T)
            for (i, (newidx, outidx)) in enumerate(zip(idxs, output_idx))
                if outidx isa BasicSymbolic{T}
                    if haskey(ranges, outidx)
                        subrules[outidx] = ranges[outidx][newidx]
                    else
                        subrules[outidx] = newidx
                    end
                end
            end
            new_expr = reduce_eliminated_idxs(expr, output_idx, ranges, reduce)
            result = substitute(new_expr, subrules; filterer = !isarrayop)
            return result
        end
        _ => begin
            args = ArgsT{T}((arr,))
            for i in idxs
                push!(args, Const{T}(i))
            end
            return BSImpl.Term{T}(getindex, args; type, shape = newshape)
        end
    end
end

function _getindex(::Type{T}, arr::BasicSymbolic{T}, idxs::Union{BasicSymbolic{T}, Int, AbstractRange{Int}, Colon}...) where {T}
    @match arr begin
        BSImpl.Const(; val) && if all(x -> !(x isa BasicSymbolic{T}) || isconst(x), idxs) end => return Const{T}(val[unwrap_const.(idxs)...])
        BSImpl.Term(; f) && if f === array_literal && all(x -> !(x isa BasicSymbolic{T}) || isconst(x), idxs) end => begin
            return Const{T}(reshape(@view(arguments(arr)[2:end]), Tuple(size(arr)))[unwrap_const.(idxs)...])
        end
        BSImpl.Term(; f) && if f isa Union{DataType, UnionAll} && f <: StaticArraysCore.StaticArray && all(x -> !(x isa BasicSymbolic{T}) || isconst(x), idxs) end => begin
            return Const{T}(reshape(arguments(arr), Tuple(size(arr)))[unwrap_const.(idxs)...])
        end
        BSImpl.Term(; f, args) && if f isa TypeT && f <: CartesianIndex end => return args[idxs...]
        BSImpl.Term(; f, args) && if f isa Operator && length(args) == 1 end => begin
            inner = args[1][idxs...]
            return BSImpl.Term{T}(f, ArgsT{T}((inner,)); type = symtype(inner), shape = shape(inner))
        end
        BSImpl.Term(; f, args) && if f === getindex && all(isconst, Iterators.drop(args, 1)) && !any(x -> x isa BasicSymbolic{T}, idxs) end => begin
            newargs = ArgsT{T}()
            push!(newargs, args[1])
            sh = shape(arr)
            type = promote_symtype(getindex, symtype(arr), symtype.(idxs)...)
            newshape = promote_shape(getindex, sh, shape.(idxs)...)
            idxs_i = 1
            for oldidx in Iterators.drop(args, 1)
                oldidx_sh = shape(oldidx)
                if !is_array_shape(oldidx_sh)
                    push!(newargs, oldidx)
                    continue
                end
                idx = idxs[idxs_i]
                idxs_i += 1
                # special case when `oldidx` is `Colon()`
                if length(oldidx_sh) == 1 && oldidx_sh[1] == 1:0
                    push!(newargs, Const{T}(idx))
                elseif idx isa Colon
                    push!(newargs, oldidx)
                else
                    push!(newargs, Const{T}(unwrap_const(oldidx)[idx]))
                end
            end
            @assert idxs_i == length(idxs) + 1
            return BSImpl.Term{T}(f, newargs; type, shape = newshape)
        end
        _ => nothing
    end

    # Fast path: scalar integer indexing into ArrayOp (dominant path during scalarize).
    @match arr begin
        BSImpl.ArrayOp(; output_idx, expr, ranges, reduce, term) && if all(x -> x isa Int, idxs) end => begin
            subrules = Dict{BasicSymbolic{T}, Union{BasicSymbolic{T}, Int}}()
            for i in 1:length(idxs)
                outidx = output_idx[i]
                newidx = idxs[i]::Int
                if outidx isa BasicSymbolic{T}
                    if haskey(ranges, outidx)
                        subrules[outidx] = ranges[outidx][newidx]
                    else
                        subrules[outidx] = newidx
                    end
                end
            end
            new_expr = reduce_eliminated_idxs(expr, output_idx, ranges, reduce)
            result = substitute(new_expr, subrules; filterer = !isarrayop)
            return result
        end
        _ => nothing
    end

    sh = shape(arr)
    type = promote_symtype(getindex, symtype(arr), symtype.(idxs)...)
    newshape = promote_shape(getindex, sh, shape.(idxs)...)
    @boundscheck if sh isa ShapeVecT
        for (ax, idx) in zip(sh, idxs)
            idx isa BasicSymbolic{T} && continue
            idx isa Colon && continue
            checkindex(Bool, ax, idx) || throw(BoundsError(arr, idxs))
        end
    end
    @match arr begin
        BSImpl.ArrayOp(; output_idx, expr, ranges, reduce, term) => begin
            subrules = Dict{BasicSymbolic{T}, Union{BasicSymbolic{T}, Int}}()
            empty!(subrules)
            new_output_idx = OutIdxT{T}()
            new_ranges = RangesT{T}()
            idxsym_idx = 1
            idxsym = idxs_for_arrayop(T)
            for (i, (newidx, outidx)) in enumerate(zip(idxs, output_idx))
                if outidx isa Int
                    newidx isa Colon && push!(new_output_idx, outidx)
                elseif outidx isa BasicSymbolic{T}
                    if newidx isa Colon
                        new_out_idx = idxsym[idxsym_idx]
                        if !isequal(outidx, new_out_idx)
                            subrules[outidx] = new_out_idx
                        end
                        push!(new_output_idx, new_out_idx)
                        idxsym_idx += 1
                    elseif newidx isa AbstractRange{Int}
                        new_out_idx = idxsym[idxsym_idx]
                        if !isequal(outidx, new_out_idx)
                            subrules[outidx] = new_out_idx
                        end
                        push!(new_output_idx, new_out_idx)
                        idxsym_idx += 1
                        if haskey(ranges, outidx)
                            new_ranges[new_out_idx] = ranges[outidx][newidx]
                        else
                            new_ranges[new_out_idx] = newidx
                        end
                    else
                        if haskey(ranges, outidx)
                            _newidx = unwrap_const(newidx)::Union{BasicSymbolic{T}, Int}
                            subrules[outidx] = if _newidx isa Int
                                ranges[outidx][_newidx]
                            else
                                BSImpl.Const{T}(ranges[outidx])[_newidx]
                            end
                        else
                            subrules[outidx] = unwrap_const(newidx)::Union{BasicSymbolic{T}, Int}
                        end
                    end
                end
            end
            if isempty(new_output_idx)
                new_expr = reduce_eliminated_idxs(expr, output_idx, ranges, reduce)
                result = substitute(new_expr, subrules; filterer = !isarrayop)
                return result
            else
                new_expr = substitute(expr, subrules; filterer = !isarrayop)
                if term !== nothing
                    term = getindex(term, idxs...)
                end
                return BSImpl.ArrayOp{T}(new_output_idx, new_expr, reduce, term, new_ranges; type, shape = newshape)
            end
        end
        BSImpl.ArrayMaker(;) && if all(Base.Fix2(isa, Int), idxs) end => begin
            return getindex(arr, StableIndex(SmallV{Int}(idxs)))
        end
        _ => begin
            if is_array_shape(newshape)
                new_output_idx = OutIdxT{T}()
                expr_args = ArgsT{T}((arr,))
                term_args = ArgsT{T}((arr,))
                ranges = RangesT{T}()
                idxsym_idx = 1
                idxsym = idxs_for_arrayop(T)
                for idx in idxs
                    push!(term_args, Const{T}(idx))
                    if idx isa Int
                        push!(expr_args, Const{T}(idx))
                    elseif idx isa Colon
                        new_idx = idxsym[idxsym_idx]
                        push!(new_output_idx, new_idx)
                        push!(expr_args, new_idx)
                        idxsym_idx += 1
                    elseif idx isa AbstractRange{Int}
                        new_idx = idxsym[idxsym_idx]
                        push!(new_output_idx, new_idx)
                        push!(expr_args, new_idx)
                        ranges[new_idx] = idx
                        idxsym_idx += 1
                    elseif idx isa BasicSymbolic{T}
                        push!(expr_args, idx)
                    end
                end
                new_expr = BSImpl.Term{T}(getindex, expr_args; type = eltype(type), shape = ShapeVecT())
                new_term = BSImpl.Term{T}(getindex, term_args; type, shape = newshape)
                return BSImpl.ArrayOp{T}(new_output_idx, new_expr, +, new_term, ranges; type, shape = newshape)
            elseif is_array_shape(sh)
                return BSImpl.Term{T}(getindex, ArgsT{T}((arr, Const{T}.(idxs)...)); type, shape = newshape)
            else
                return arr
            end
        end
    end
end
function _getindex(::Type{T}, x::AbstractArray, idxs...) where {T}
    Const{T}(getindex(x, idxs...))
end
Base.getindex(x::BasicSymbolic{T}, i::CartesianIndex) where {T} = x[Tuple(i)...]

# Variant structure and types

This document aims to describe the structure of the Algebraic Data Type (ADT) used to represent
a symbolic tree, along with several utility types to allow robustly interacting with it.

SymbolicUtils uses Moshi.jl's ADT structure. The ADT is named `BasicSymbolicImpl`, and an alias
`BSImpl` is available for convenience. The actual type of a variable is `BSImpl.Type`, aliased
as `BasicSymbolic`. A `BasicSymbolic` is considered immutable. Mutating its fields is unsafe
behavior.

In SymbolicUtils v3, the type `T` in `BasicSymbolic{T}` was the type represented by the symbolic
variable. In other words, `T` was the [`SymbolicUtils.symtype`](@ref) of the variable.

In SymbolicUtils v4, the `symtype` is not stored in the type, and is instead a field of the
struct. This allows for greatly increased type-stability. The type `T` in `BasicSymbolic{T}`
now represents a tag known as the [`vartype`](@ref). This flag determines the assumptions
made about the symbolic algebra. It can take one of three values:

- [`SymReal`](@ref): The default behavior.
- [`SafeReal`](@ref): Identical to `SymReal`, but common factors in the numerator and denominator
  of a division are not cancelled.
- [`TreeReal`](@ref): Assumes nothing about the algebra, and always uses the `Term` variant to
  represent an expression.

A given expression must be pure in its `vartype`. In other words, no operation supports operands
of different `vartype`s.

!!! warning "A short note on (im-)mutability"

    While `ismutabletype(BasicSymbolic)` returns `true`, symbolic types are IMMUTABLE.
    Any mutation is undefined behavior and can lead to very confusing and hard-to-debug issues.
    This includes internal mutation, such as mutating `AddMul.dict`. The arrays returned from
    `TermInterface.arguments` and `TermInterface.sorted_arguments` are read-only arrays for this
    reason.

## Expression symtypes

The "symtype" of a symbolic variable/expression is the Julia type that the variable/expression
represents. It can be queried with [`SymbolicUtils.symtype`](@ref). Note that this query is
unstable - the returned type cannot be inferred.

## Expression shapes

In SymbolicUtils v4, arrays are first-class citizens. This is implemented by storing the shape
of the symbolic. The shape can be queried using [`SymbolicUtils.shape`](@ref) and is one of
two types.

### Symbolics with known shape

The most common case is when the shape of a symbolic variable is known. For example:

```julia
@syms x[1:2] y[-3:6, 4:7] z
```

All of the variables created above have known shape. In this case, `SymbolicUtils.shape`
returns a (custom) vector of `UnitRange{Int}` semantically equivalent to `Base.axes`. This
does not return a `Tuple` since the number of dimensions cannot be inferred and thus
returning a tuple would introduce type-instability. All array operations will perform
validation on the shapes of their inputs (e.g. matrix multiplication) and calculates the
shape of their outputs.

Scalar variables return an empty vector as their shape.

### Symbolics with known `ndims`

The next most common case is when the exact shape/size of the symbolic is unknown but the
number of dimensions is known. For example:

```julia
@syms x::Vector{Number} y::Matrix{Number} z::Array{Number, 3}
```

In this case, `SymbolicUtils.shape` returns a value of type [`SymbolicUtils.Unknown`](@ref).
This has a single field `ndims::Int` storing the number of dimensions of the symbolic. Note
that a shape of `SymbolicUtils.Unknown(0)` does not represent a scalar. All array operations
will perform as much validation as possible on their arguments. The shape of the result will
be calculated on a best-effort basis.

### Symbolics with unknown `ndims`

In this case, nothing is known about the symbolic except that it is an array. For example:

```julia
@syms x::Array{Number}
```

`Symbolics.shape(x)` will return `SymbolicUtils.Unknown(-1)`. This effectively disables most
shape checking for array operations.

## Variants

```julia
struct Const
    const val::Any
    # ...
end
```

Any non-symbolic values in an expression are stored in a `Const` variant. This is crucial for
type-stability, but it does mean that obtaining the value out of a `Const` is unstable and
should be avoided. This value can be obtained by pattern matching using `Moshi.Match.@match`
or using the [`unwrap_const`](@ref) utility. `unwrap_const` will act as an identity function
for any input that is not `Const`, including non-symbolic inputs. `Const` is the only variant
which does not have metadata.

[`SymbolicUtils.isconst`](@ref) can be used to check if a `BasicSymbolic` is the `Const`
variant. This variant can be constructed using `Const{T}(val)` or `BSImpl.Const{T}(val)`,
where `T` is the appropriate `vartype`.

The `Const` constructors have an additional special behavior. If given an array of symbolics
(or array of array of ... symbolics), it will return a `Term` (see below) with
[`SymbolicUtils.array_literal`](@ref) as the operation. This allows standard symbolic
operations (such as [`substitute`](@ref)) to work on arrays of symbolics without excessive
special-case handling and improved type-stability.

```julia
struct Sym
    const name::Symbol
    const metadata::MetadataT
    const shape::ShapeT
    const type::TypeT
    # ...
end
```

`Sym` represents a symbolic quantity with a given `name`. This and `Const` are the two atomic
variants. `metadata` is the symbolic metadata associated with this variable. `type` is the
tag for the type of quantity represented here. `shape` stores the shape if the variable is
an array symbolic.

- `metadata` is either `nothing` or a map from `DataType` keys to arbitrary values. Any
  interaction with metadata should be done by providing such a mapping during construction
  or using [`getmetadata`](@ref), [`setmetadata`](@ref), [`hasmetadata`](@ref).
- `type` is a Julia type.
- `shape` is as described above.

These three fields are present in all subsequent variants as well.

A `Sym` can be constructed using `Sym{T}(name::Symbol; type, shape, metadata)` or
`BSImpl.Sym{T}(name::Symbol; type, shape, metadata)`.

```julia
struct Term
    const f::Any
    const args::SmallV{BasicSymbolicImpl.Type{T}}
    const metadata::MetadataT
    const shape::ShapeT
    const type::TypeT
    # ...
end
```

`Term` is the generic expression form for an operation `f` applied to the arguments in
`args`. In other words, this represents `f(args...)`. Any constant (non-symbolic) arguments
(including arrays of symbolics) are converted to symbolics and wrapped in `Const`.

A `Term` can be constructed using `Term{T}(f, args; type, shape, metadata)` or
`BSImpl.Term{T}(f, args; type, shape, metadata)`.

```julia
struct AddMul
    const coeff::Any
    const dict::ACDict{T}
    const variant::AddMulVariant.T
    const metadata::MetadataT
    const shape::ShapeT
    const type::TypeT
    # ...
end
```

`AddMul` is a specialized representation for associative-commutative addition and
multiplication. The two operations are distinguished using the [`SymbolicUtils.AddMulVariant`](@ref)
EnumX.jl enum. It has two variants: `AddMulVariant.ADD` and `AddMulVariant.MUL`.

For multiplication terms, `coeff` is a constant non-symbolic coefficient multiplied
with the expression. `dict` is a map from terms being multiplied to their exponents. For
example, `2x^2 * (y + z)^3` is represented with `coeff = 2` and
`dict = ACDict{T}(x => 2, (y + z) => 3)`. A valid multiplication term is subject to the
following constraints:

- `coeff` must be non-symbolic.
- The values of `dict` must be non-symbolic.
- The keys of `dict` must not be expressions with `^` as the operation UNLESS the exponent
  is symbolic. For example, `x^x * y^2` is represented with
  `dict = ACDict{T}((x^x) => 1, y => 2)`.
- `dict` must not be empty.
- `coeff` must not be zero.
- If `dict` has only one element, `coeff` must not be one. Such a case should be
  represented as a power term (with `^` as the operation).
- If `dict` has only one element where the key is an addition, `coeff` must not be negative
  one. Such a case should be represented by distributing the negation.

The `Mul{T}(coeff, dict; type, shape, metadata)` constructor validates these constraints
and automatically returns the appropriate alternative form where applicable. It should
be preferred. `BSImpl.AddMul{T}(coeff, dict, variant; type, shape, metadata)` is
faster but does not validate the constraints and should be used with caution. Incorrect
usage can and will lead to both invalid expressions and undefined behavior.

For addition terms, `coeff` is a constant non-symbolic coefficient added to the
expression. `dict` is a map from terms being added to the constant non-symbolic
coefficients they are multiplied by. For example, to represent `1 + 2x + 3y * z`
`coeff` would be `1` and `dict` would be `Dict(x => 2, (y * z) => 3)`. A valid addition
term is subject to the following constraints:

- `coeff` must be non-symbolic.
- The values of `dict` must be non-symbolic.
- The keys of `dict` must not be additions expressions represented with `AddMul`.
- `dict` must not be empty.
- If `dict` has only one element, `coeff` must not be zero. Such a case should be
  represented using the appropriate multiplication form.

The `Add{T}(coeff, dict; type, shape, metadata)` constructor validates these constraints
and automatically returns the appropriate alternative form where applicable. It should
be preferred. `BSImpl.AddMul{T}(coeff, dict, variant; type, shape, metadata)` is
faster but does not validate the constraints and should be used with caution. Incorrect
usage can and will lead to both invalid expressions and undefined behavior.

```julia
struct Div
    const num::BasicSymbolicImpl.Type{T}
    const den::BasicSymbolicImpl.Type{T}
    const simplified::Bool
    const metadata::MetadataT
    const shape::ShapeT
    const type::TypeT
    # ...
end
```

The `Div` variant represents division (where the operation is `/`). `num` is the numerator
and `den` is the denominator expression. `simplified` is a boolean indicating whether this
expression is in the most simplified form possible. If it is `true`, certain algorithms in
[`simplify_fractions`](@ref) will not inspect this term. In almost all cases, it should be
provided as `false`. A valid division term is subject to the following constraints:

- Both the numerator and denominator cannot be `Const` variants. This should instead be
  represented as a `Const` variant wrapping the result of division.
- The numerator cannot be zero. This should instead be represented as a `Const` wrapping
  the appropriate zero.
- The denominator cannot be one. This should instead be represented as the numerator,
  possibly wrapped in a `Const`.
- The denominator cannot be zero. This should instead be represented as a `Const` with
  some form of infinity.
- The denominator cannot be negative one. This should instead be represented as the negation
  of the numerator.
- Non-symbolic coefficients should be propagated to the numerator if it is a constant or
  multiplication term.

The `Div{T}(num, den, simplified; type, shape, metadata)` constructor can be used to build
this form. If `T` is `SymReal`, the constructor will use [`quick_cancel`](@ref) to cancel
trivially identifiable common factors in the numerator and denominator. It will also perform
validation of the above constraints and return the appropriate alternative form where
applicable. Some of the constraints can be relaxed for non-scalar algebras. The
`BSImpl.Div{T}(num, den, simplified; type, shape, metadata)` does not perform such
validation or transformation.

```julia
struct ArrayOp
    const output_idx::SmallV{Union{Int, BasicSymbolicImpl.Type{T}}}
    const expr::BasicSymbolicImpl.Type{T}
    const reduce::Any
    const term::Union{BasicSymbolicImpl.Type{T}, Nothing}
    const ranges::Dict{BasicSymbolicImpl.Type{T}, StepRange{Int, Int}}
    const metadata::MetadataT
    const shape::ShapeT
    const type::TypeT
    # ...
end
```

`ArrayOp` is used to represent vectorized operations. This variant should not be created
manually. Instead, the [`@arrayop`](@ref) macro constructs this using a generalized
Einstein-summation notation, similar to that of Tullio.jl. Consider the following example:

```julia
ex = @arrayop (i, j) A[i, k] * B[k, j] + C[i, j]
```

This represents `A * B + C` for matrices `A, B, C` as a vectorized array operation. Some
operations, such as broadcasts, are automatically represented as such a form internally.
The following description of the fields assumes familiarity with the `@arrayop` macro.

When processing this macro, the indices `i, j, k` are converted to use a common global
index variable to avoid potential name conflicts with other symbolic variables named
`i, j, k` if `ex` is used in a larger expression. The `output_idx` field stores `[i, j]`.
`expr` stores the expression `A[i, k] * B[k, j] + C[i, j]`, with `i, j, k` replaced by the
common global index variable. `reduce` is the operation used to reduce indices not present
in `output_idx` (in this example, `k`). By default, it is `+`. `term` stores an expression
that represents an equivalent computation to use for printing/code-generation. For example,
here `A * B + C` would be a valid value for `term`. By default, `term` is `nothing` except
when the expression is generated via `broadcast` or a similar operation. `ranges` is a
dictionary mapping indices used in `expr` (converted to the common global index) to the
range of indices over which they should iterate, in case such a range is explicitly
provided.

!!! note

  The common global index variable is printed as `_1`, `_2`, ... in arrayops. It is not
  a valid symbolic variable outside of an `ArrayOp`'s `expr`.

A valid `ArrayOp` satisfies the following conditions:

- `output_idx` only contains the integer `1` or variants of the common global index
  variable.
- Any top-level indexing operations in `expr` use common global indices. A top-level
  indexing operation is a term whose operation is `getindex`, and which is not a
  descendant of any other term whose operation is `getindex`.
- `reduce` must be a valid reduction operation that can be passed to `Base.reduce`.
- If `term` is not `nothing`, it must be an expression with shape `shape` and type `type`.
- The keys of `ranges` must be variants of the common global index variable, and must
  be present in `expr`.

The `@arrayop` macro should be heavily preferred for creating `ArrayOp`s. In case this is
not possible (such as in recursive functions like `substitute`) the `ArrayOp` constructor
should be preferred. This does not allow specifying the `type` and `shape`, since these
values are tied to the fields of the variant and are thus determined. The `BSImpl.ArrayOp`
constructor should be used with extreme caution, since it does not validate input.

```julia
struct ArrayMaker
    const regions::SmallV{ShapeVecT}
    const values::SmallV{BasicSymbolicImpl.Type{T}}
    const metadata::MetadataT
    const shape::ShapeT
    const type::TypeT
    # ...
end
```

`ArrayMaker` is used to represent symbolic arrays composed of (potentially overlapping)
blocks of other arrays. It is represented as a sequence `regions` of subarrays of the result,
and a corresponding sequence `values` of values assigned to them. Each entry in `regions`
must have the same number of dimensions as the represented array; singleton dimensions
cannot be removed. The corresponding entry in `values` must have a size identical to
the assigned subarray. Again, singleton dimensions cannot be dropped. In case of overlaps,
later entries overwrite earlier ones. If a region of the array is left unassigned by all
blocks, accessing it is invalid. When used in code generation, these unassigned regions
can take arbitrary and possibly unassigned values.

In most cases, `ArrayMaker` should not be created directly. Prefer using [`@makearray`](@ref).

## Array arithmetic

SymbolicUtils implements a simple array algebra in addition to the default scalar algebra.
Similar to how [`SymbolicUtils.promote_symtype`](@ref) given a function and symtypes of
its arguments returns the symtype of the result, [`SymbolicUtils.promote_shape`](@ref)
does the same for the shapes of the arguments. Implementing _both_ methods is crucial
for correctly using custom functions in symbolic expressions. Without `promote_shape`,
SymbolicUtils will use `Unknown(-1)` as the shape.

The array algebra implemented aims to mimic that of base `Array`s as closely as possible.
For example, a symbolic `adjoint(::Vector) * (::Vector)` will return a symbolic scalar
instead of a one-element symbolic vector. `promote_shape` implementations will
propagate the shape information on a best-effort basis. Invalid shapes (such as
attempting to multiply a 3-dimensional array) will error. Following are notable exceptions
to Base-like behavior:

- `map` and `mapreduce` require that all input arrays have the same `shape`
- `promote_symtype` and `promote_shape` is not implemented for `map` and `mapreduce`, since
  doing so requires the function(s) passed to `map` and `mapreduce` instead of their types
  or shapes.
- Since `ndims` information is not present in the type, `eachindex`, `iterate`, `size`,
  `axes`, `ndims`, `collect` are type-unstable. [`SymbolicUtils.stable_eachindex`](@ref) is
  useful as a type-stable iteration alternative.
- `ifelse` requires that both the true and false cases have identical shape.
- Symbolic arrays _only_ support Cartesian indexing. For example, given `@syms x[1:3, 1:3]`
  accessing `x[4]` is invalid and `x[1, 2]` should be used. Valid indices are
  `Int`, `Colon`, `AbstractRange{Int}` and symbolic expressions with integer `symtype`.
  A single `CartesianIndex` of appropriate dimension can also be used to symbolically
  index arrays.

Symbolic array operations are also supported on arrays of symbolics. However, at least one
of the arguments to the function must be a symbolic (instead of an array of symbolics) to
allow the dispatches defined in SymbolicUtils to be targeted instead of those in Base. To
aid in constructing arrays of symbolics, the [`BS`](@ref) utility is provided. Similar to
the `T[...]` syntax for constructing an array of etype `T`, `BS[...]` will construct an
array of `BasicSymbolic`s. At least one value in the array must be a symbolic value to
infer `T` in `Array{BasicSymbolic{T}, N}`. To explicitly specify the `vartype`, use
`BS{T}[...]`.

## Symbolic functions and dependent variables

SymbolicUtils defines `FnType{A, R, T}` for symbolic functions and dependent variables.
Here, `A` is a `Tuple{...}` of the symtypes of arguments and `R` is the type returned by
the symbolic function. `T` is the type that the function itself subtypes, or `Nothing`.

The syntax

```julia
@syms f(::T1, ::T2)::R
```

creates `f` with a symtype of `FnType{Tuple{T1, T2}, R, Nothing}`. This is a symbolic
function taking arguments of type `T1` and `T2`, and returning `R`. `Nothing` is a
sentinel indicating that the supertype of the function is unknown. By contrast,

```julia
@syms f(..)::R
```

creates `f` with a symtype of `FnType{Tuple, R, Nothing}`. SymbolicUtils considers this
case to be a dependent variable with as-yet unspecified independent variables. In other
words,

```julia
@syms x f1(::Real)::Real f2(..)::Real
```

Here, `f1(x)` is considered a symbolic function `f1` called with the argument `x` and
`f2(x)` is considered a dependent variable that depends on `x`. The utilities
[`SymbolicUtils.is_function_symbolic`](@ref), [`SymbolicUtils.is_function_symtype`](@ref),
[`SymbolicUtils.is_called_function_symbolic`](@ref) can be used to differentiate between
these cases.

```@docs
SymbolicUtils.FnType
```

## API

### Basics

```@docs
SymbolicUtils.BasicSymbolic
@syms
SymbolicUtils.symtype
SymbolicUtils.vartype
SymReal
SafeReal
TreeReal
SymbolicUtils.shape
SymbolicUtils.Unknown
SymbolicUtils.AddMulVariant
unwrap_const
```

### Inner constructors

```@docs
SymbolicUtils.array_literal
SymbolicUtils.BSImpl.Const
SymbolicUtils.BSImpl.Sym
SymbolicUtils.BSImpl.Term
SymbolicUtils.BSImpl.AddMul
SymbolicUtils.BSImpl.Div
SymbolicUtils.BSImpl.ArrayOp
SymbolicUtils.BSImpl.ArrayMaker
```

### High-level constructors

```@docs; canonical=false
SymbolicUtils.Const
SymbolicUtils.Sym
SymbolicUtils.Term
SymbolicUtils.Add
SymbolicUtils.Mul
SymbolicUtils.Div
SymbolicUtils.ArrayOp
@arrayop
SymbolicUtils.ArrayMaker
@makearray
```

### Variant checking

Note that while these utilities are useful, prefer using `Moshi.Match.@match` to pattern
match against different variant types and access their fields.

```@docs
SymbolicUtils.isconst
SymbolicUtils.issym
SymbolicUtils.isterm
SymbolicUtils.isaddmul
SymbolicUtils.isadd
SymbolicUtils.ismul
SymbolicUtils.isdiv
SymbolicUtils.ispow
SymbolicUtils.isarrayop
SymbolicUtils.isarraymaker
```

### Using custom functions in expressions

```@docs
SymbolicUtils.promote_symtype
SymbolicUtils.promote_shape
```

### Symbolic array utilities

```@docs
SymbolicUtils.stable_eachindex
SymbolicUtils.StableIndices
SymbolicUtils.StableIndex
SymbolicUtils.as_linear_idx
BS
```

### Symbolic function utilities

```@docs
SymbolicUtils.is_function_symbolic
SymbolicUtils.is_function_symtype
SymbolicUtils.is_called_function_symbolic
```

### TermInterface.jl interface

```@docs
TermInterface.iscall
TermInterface.operation
TermInterface.arguments
TermInterface.sorted_arguments
TermInterface.maketerm
```

### Miscellaneous utilities

```@docs
SymbolicUtils.zero_of_vartype
SymbolicUtils.one_of_vartype
SymbolicUtils.get_mul_coefficient
SymbolicUtils.term
SymbolicUtils.add_worker
SymbolicUtils.mul_worker
```

### Utility types

SymbolicUtils exposes a plethora of type aliases to allow easily interacting with common
types used internally.

```@docs
SymbolicUtils.MetadataT
SymbolicUtils.SmallV
SymbolicUtils.ShapeVecT
SymbolicUtils.ShapeT
SymbolicUtils.OutIdxT
SymbolicUtils.RangesT
```

# Term Rewriting

## Rule-based rewriting

Rewrite rules match and transform an expression. A rule is written using either the `@rule` macro or the `@acrule` macro. It creates a callable `Rule` object.

### Basics of rule-based term rewriting in SymbolicUtils

Here is a simple rewrite rule, that uses formula for the double angle of the sine function:

```@example rewrite
using SymbolicUtils

@syms w z α::Real β::Real d(..)

(w, z, α, β) # hide

r1 = @rule sin(2(~x)) => 2sin(~x)*cos(~x)

r1(sin(2z))
```

The `@rule` macro takes a pair of patterns -- the _matcher_ and the _consequent_ (`@rule matcher => consequent`). If an expression matches the matcher pattern, it is rewritten to the consequent pattern. `@rule` returns a callable object that applies the rule to an expression.

`~x` in the example is what is a **slot variable** named `x`. In a matcher pattern, slot variables are placeholders that match exactly one expression. When used on the consequent side, they stand in for the matched expression. If a slot variable appears twice in a matcher pattern, all corresponding matches must be equal (as tested by `Base.isequal` function).

If you try to apply this rule to an expression with triple angle, it will return `nothing` -- this is the way a rule signifies failure to match.
```julia
r1(sin(3z))
```

Slot variable (matcher) is not necessary a single variable:
```@example rewrite
r1(sin(2*(w-z)))
```

And can also match a function:
```julia
r = @rule (~f)(z+1) => ~f

r(sin(z+1))
```
Rules are of course not limited to single slot variable

```@example rewrite
r2 = @rule sin(~x + ~y) => sin(~x)*cos(~y) + cos(~x)*sin(~y);

r2(sin(α+β))
```

Now let's say you want to catch the coefficients of a second degree polynomial in z. You can do that with:
```@example rewrite
c2d = @rule ~a + ~b*z + ~c*z^2 => (~a, ~b, ~c)

2d(3 + 2z + 5z^2)
```

Great! But if you try:
```@example rewrite
c2d(3 + 2z + z^2)
```

the rule is not applied. This is because in the input polynomial there isn't a multiplication in front of the `z^2`. For this you can use **defslot variables**, with syntax `~!a`:
```@example rewrite
c2d = @rule ~!a + ~!b*z + ~!c*z^2 => (~a, ~b, ~c)

2d(3 + 2z + z^2)
```
They work like normal slot variables, but if they are not present they take a default value depending on the operation they are in, in the above example `~b = 1`. Currently defslot variables can be defined in:

Operation | Default value
----------|--------------
multiplication `*` | 1
addition `+` | 0
2nd argument of `^` | 1

If you want to match a variable number of subexpressions at once, you will need a **segment variable**. `~~xs` in the following example is a segment variable:

```@example rewrite
@syms x y z
@rule(+(~~xs) => ~~xs)(x + y + z)
```

`~~xs` is a vector of subexpressions matched. You can use it to construct something more useful:

```@example rewrite
r3 = @rule ~x * +(~~ys) => sum(map(y-> ~x * y, ~~ys));

r3(2 * (w+w+α+β))
```

Notice that the expression was autosimplified before application of the rule.

```@example rewrite
2 * (w+w+α+β)
```

Note that writing a single tilde `~` as consequent, will make the rule return a dictionary of [slot variable, expression matched].

```@example rewrite
r = @rule (~x + (~y)^(~m)) => ~

r(z+w^α)
```

### Predicates for matching

Matcher pattern may contain slot variables with attached predicates, written as `~x::f` where `f` is a function that takes a matched expression and returns a boolean value. Such a slot will be considered a match only if `f` returns true.

Similarly `~~x::g` is a way of attaching a predicate `g` to a segment variable. In the case of segment variables `g` gets a vector of 0 or more expressions and must return a boolean value. If the same slot or segment variable appears twice in the matcher pattern, then at most one of the occurrence should have a predicate.

For example,

```@example pred
using SymbolicUtils
@syms a b c d

r = @rule ~x + ~~y::(ys->iseven(length(ys))) => "odd terms";

@show r(a + b + c + d)
@show r(b + c + d)
@show r(b + c + b)
@show r(a + b)
```


### Associative-Commutative Rules

Given an expression `f(x, f(y, z, u), v, w)`, a `f` is said to be associative if the expression is equivalent to `f(x, y, z, u, v, w)` and commutative if the order of arguments does not matter.  SymbolicUtils has a special `@acrule` macro meant for rules on functions which are associate and commutative such as addition and multiplication of real and complex numbers.

```@example acr
using SymbolicUtils
@syms x y z

acr = @acrule((~a)^(~x) * (~a)^(~y) => (~a)^(~x + ~y))

acr(x^y * x^z)
```

although in case of `Number` it also works the same way with regular `@rule` since autosimplification orders and applies associativity and commutativity to the expression.

### Example of applying the rules to simplify expression

Consider expression `(cos(x) + sin(x))^2` that we would like simplify by applying some trigonometric rules. First, we need rule to expand square of `cos(x) + sin(x)`. First we try the simplest rule to expand square of the sum and try it on simple expression
```@example rewriteex
using SymbolicUtils

@syms x::Real y::Real

sqexpand = @rule (~x + ~y)^2 => (~x)^2 + (~y)^2 + 2 * ~x * ~y

sqexpand((cos(x) + sin(x))^2)
```

It works. This can be further simplified using Pythagorean identity and check it

```@example rewriteex
pyid = @rule sin(~x)^2 + cos(~x)^2 => 1

pyid(sin(x)^2 + 2sin(x)*cos(x) + cos(x)^2)===nothing
```

Why does it return `nothing`? If we look at the expression, we see that we have an additional addend `+ 2sin(x)*cos(x)`. Therefore, in order to work, the rule needs to be associative-commutative.

```@example rewriteex
acpyid = @acrule sin(~x)^2 + cos(~x)^2 => 1

acpyid(cos(x)^2 + sin(x)^2 + 2cos(x)*sin(x))
```

It has been some work. Fortunately rules may be [chained together](@ref "Chaining rewriters") into more sophisticated rewriters to avoid manual application of the rules.


## Composing rewriters

A rewriter is any callable object which takes an expression and returns an expression
or `nothing`. If `nothing` is returned that means there was no changes applicable
to the input expression. The Rules we created above are rewriters.

The `SymbolicUtils.Rewriters` module contains some types which create and transform
rewriters.

- `Empty()` is a rewriter which always returns `nothing`
- `Chain(itr)` chain an iterator of rewriters into a single rewriter which applies
   each chained rewriter in the given order.
   If a rewriter returns `nothing` this is treated as a no-change.
- `RestartedChain(itr)` like `Chain(itr)` but restarts from the first rewriter once on the
   first successful application of one of the chained rewriters.
- `IfElse(cond, rw1, rw2)` runs the `cond` function on the input, applies `rw1` if cond
   returns true, `rw2` if it returns false
- `If(cond, rw)` is the same as `IfElse(cond, rw, Empty())`
- `Prewalk(rw; threaded=false, thread_cutoff=100)` returns a rewriter which does a pre-order
   (*from top to bottom and from left to right*) traversal of a given expression and applies
   the rewriter `rw`. `threaded=true` will use multi threading for traversal.
   Note that if `rw` returns `nothing` when a match is not found, then `Prewalk(rw)` will
   also return nothing unless a match is found at every level of the walk. If you are
   applying multiple rules, then `Chain` already has the appropriate passthrough behavior.
   If you only want to apply one rule, then consider using `PassThrough`.
   `thread_cutoff`
   is the minimum number of nodes in a subtree which should be walked in a threaded spawn.
- `Postwalk(rw; threaded=false, thread_cutoff=100)` similarly does post-order
   (*from left to right and from bottom to top*) traversal.
- `Fixpoint(rw)` returns a rewriter which applies `rw` repeatedly until there are no changes to be made.
- `PassThrough(rw)` returns a rewriter which if `rw(x)` returns `nothing` will instead
   return `x` otherwise will return `rw(x)`.

### Chaining rewriters

Several rules may be chained to give chain of rules. Chain is an array of rules which are subsequently applied to the expression.

To check that, we will combine rules from [previous example](@ref "Example of applying the rules to simplify expression") into a chain

```@example composing
using SymbolicUtils
using SymbolicUtils.Rewriters

@syms x

sqexpand = @rule (~x + ~y)^2 => (~x)^2 + (~y)^2 + 2 * ~x * ~y
acpyid = @acrule sin(~x)^2 + cos(~x)^2 => 1

csa = Chain([sqexpand, acpyid])

csa((cos(x) + sin(x))^2)
```

Important feature of `Chain` is that it returns the expression instead of `nothing` if it doesn't change the expression

```@example composing
Chain([@acrule sin(~x)^2 + cos(~x)^2 => 1])((cos(x) + sin(x))^2)
```

it's important to notice, that chain is ordered, so if rules are in different order it wouldn't work the same as in earlier example

```@example composing
cas = Chain([acpyid, sqexpand])

cas((cos(x) + sin(x))^2)
```
since Pythagorean identity is applied before square expansion, so it is unable to match squares of sine and cosine.

One way to circumvent the problem of order of applying rules in chain is to use `RestartedChain`

```@example composing
using SymbolicUtils.Rewriters: RestartedChain

rcas = RestartedChain([acpyid, sqexpand])

rcas((cos(x) + sin(x))^2)
```

It restarts the chain after each successful application of a rule, so after `sqexpand` is hit it (re)starts again and successfully applies `acpyid` to resulting expression.

You can also use `Fixpoint` to apply the rules until there are no changes.

```@example composing
Fixpoint(cas)((cos(x) + sin(x))^2)
```

# Recursive utility functions

SymbolicUtils.jl provides several utility functions to perform common operations that
require recursing over the expression tree.

```@docs; canonical=false
SymbolicUtils.substitute
SymbolicUtils.Substituter
SymbolicUtils.clear_cache!
SymbolicUtils.get_substitution_dict
SymbolicUtils.default_substitute_filter
SymbolicUtils.query
SymbolicUtils.default_is_atomic
SymbolicUtils.scalarize
SymbolicUtils.scalarization_function
```

# Developer API

The names on this page are public extension points for packages that build on
SymbolicUtils, including Symbolics.jl. They are intentionally not generally
exported. User code should prefer the higher-level symbolic constructors,
rewriters, and substitution APIs documented on the main [API page](@ref "API Reference").

## Expression and cache interfaces

```@docs; canonical=false
SymbolicUtils.:<ₑ
SymbolicUtils.@cache
SymbolicUtils.ACDict
SymbolicUtils.AddMulVariant
SymbolicUtils.ArgsT
SymbolicUtils.BSImpl
SymbolicUtils.BasicSymbolicImpl
SymbolicUtils.Const
SymbolicUtils.Div
SymbolicUtils.MetadataT
SymbolicUtils.Operator
SymbolicUtils.ROArgsT
SymbolicUtils.Substituter
SymbolicUtils.Term
SymbolicUtils.TypeT
SymbolicUtils._isone
SymbolicUtils._iszero
SymbolicUtils.clear_cache!
SymbolicUtils.default_is_atomic
SymbolicUtils.default_substitute_filter
SymbolicUtils.evaluate
SymbolicUtils.get_substitution_dict
SymbolicUtils.hashcons
SymbolicUtils.is_array_shape
SymbolicUtils.is_function_symbolic
SymbolicUtils.is_called_function_symbolic
SymbolicUtils.isarrayop
SymbolicUtils.isbinop
SymbolicUtils.numerators
SymbolicUtils.denominators
SymbolicUtils.one_of_vartype
SymbolicUtils.operator_to_term
SymbolicUtils.promote_symtype
SymbolicUtils.query
SymbolicUtils.scalarize
SymbolicUtils.search_variables
SymbolicUtils.search_variables!
SymbolicUtils.show_call
SymbolicUtils.stable_eachindex
SymbolicUtils.toggle_caching!
SymbolicUtils.zero_of_vartype
SymbolicUtils.zeropoly
```

## Parsing and polynomial conversion

```@docs; canonical=false
SymbolicUtils.MonomialOrder
SymbolicUtils.MonomialT
SymbolicUtils.PolyCoeffT
SymbolicUtils.PolyVarOrder
SymbolicUtils.PolyVarT
SymbolicUtils.PolynomialT
SymbolicUtils._indexed_ndims
SymbolicUtils.basicsymbolic_to_polyvar
SymbolicUtils.from_poly
SymbolicUtils.parse_variable
SymbolicUtils.sym_from_parse_result
SymbolicUtils.to_poly!
```

## Rewriting and broadcasting helpers

```@docs; canonical=false
SymbolicUtils.@map_methods
SymbolicUtils.@mapreduce_methods
SymbolicUtils.@number_methods
SymbolicUtils.number_methods
SymbolicUtils.Rule
SymbolicUtils.SymBroadcast
```

## Code generation

```@docs; canonical=false
SymbolicUtils.Code
SymbolicUtils.Code.LazyState
SymbolicUtils.Code.cse_inside_expr
SymbolicUtils.Code.fast_toexpr
SymbolicUtils.Code.function_to_expr
SymbolicUtils.Code.get_rewrites
SymbolicUtils.Code.supports_with_allocator
SymbolicUtils.Code.with_allocator
```

# SymbolicUtils.jl — Symbolic programming in Julia

## Features

- Fast expressions
- A [rule-based rewriting language](@ref "Rule-based rewriting").
- A [combinator library](@ref "Composing rewriters") for making rewriters.
- Efficient representation of numeric expressions
- Type promotion:
  - Symbols (`Sym`s) carry type information. ([read more](@ref "Creating symbolic expressions"))
  - Compound expressions composed of `Sym`s propagate type information. ([read more](@ref "Expression interface"))
- Set of extendable [simplification rules](@ref "Simplification").


## Creating symbolic expressions

First, let's use the `@syms` macro to create a few symbols.

```julia:syms1
using SymbolicUtils

@syms w z α::Real β::Real

(w, z, α, β) # hide

```

Type annotations are optional when creating symbols. Here `α`, `β` behave like Real numbers. `w` and `z` behave like `Number`, which is the default. You can use the `symtype` function to find the type of a symbol.

```julia:symtype
using SymbolicUtils: symtype

symtype(w), symtype(z),  symtype(α), symtype(β)
```

Note however that they are not subtypes of these types!

```julia:symtype2
@show w isa Number
@show α isa Real
```

As their types are different:

```julia:symtype3
@show typeof(w)
@show typeof(α)
```

(see [this post](https://discourse.julialang.org/t/ann-symbolicutils-jl-groundwork-for-a-symbolic-ecosystem-in-julia/38455/13?u=shashi) for why they are all not just subtypes of `Number`)

You can do basic arithmetic on symbols to get symbolic expressions:

```julia:expr
expr1 = α*sin(w)^2 + β*cos(z)^2
expr2 = α*cos(z)^2 + β*sin(w)^2

expr1 + expr2
```

SymbolicUtils automatically simplifies

```julia:creating1
2w + 3w - 3z + α
```

and reorders

```julia:creating2
(z + w)*(α + β)
```

expressions of type `Symbolic{<:Number}` (which includes `Sym{Real}`) when they are created. It also does constant elimination (including rational numbers)

```julia:creating3
5 + 2w - 3z + α - (β + 5//3) + 3w - 2 + 3//2 * β
```

It's worth remembering that the expression may be transformed with respect to the input when it's created.


## Function-like symbols

Symbols can be defined to behave like functions. Both the input and output types for the function can be specified. Any application to that function will only admit either values of those types or symbols of the same `symtype`.

```julia:syms2
using SymbolicUtils
@syms f(x) g(x::Real, y::Real)::Real

f(z) + g(1, α) + sin(w)
```

This does not work since `z` is a `Number`, not a `Real`.

```julia:sym3
g(1, z)
```

This works because `g` "returns" a `Real`.

```julia:sym4
g(2//5, g(1, β))
```



## Expression interface

Symbolic expressions are of type `Term{T}`, `Add{T}`, `Mul{T}`, `Pow{T}` or `Div{T}` and denote some function call where one or more arguments are themselves such expressions or `Sym`s.

All the expression types support the [TermInterface.jl](https://github.com/0x0f0f0f/TermInterface.jl) interface.
Please refer to the package for the complete reference of the interface.

## Term rewriting

SymbolicUtils contains [a rule-based rewriting language](@ref "Rule-based rewriting") for easy pattern matching and rewriting of expression. There is also a [combinator library](@ref "Composing rewriters") to combine rules to chain, branch and loop over rules.

## Simplification

By default `+`, `*` and `^` operations apply the most basic simplification upon construction of the expression.

The rules with which the canonical form of `Symbolic{<:Number}` terms are constructed are the next (where `x isa Symbolic` and `c isa Number`)

 -  `0 + x`, `1 * x` and `x^1` always gives `x`
 -  `0 * x` always gives `0` and `x ^ 0` gives `1`
 -  `-x` becomes `(-1)*x`
 -  commutativity and associativity over `+` and `*` are assumed. Re-ordering of terms will be done under a [total order](https://github.com/JuliaSymbolics/SymbolicUtils.jl/blob/master/src/ordering.jl)
 - `p/q * x` or `x * p/q` results in `(p*x)/q`
 - `p/q * x/y` results in `(p*x)/(q*y)`
 -  `x + ... + x` will be fused into `n*x` with type `Mul`
 -  `x * ... * x` will be fused into `x^n` with type `Pow`
 -  sum of `Add`'s are fused
 -  product of `Mul`'s are fused
 -  `c * (c₁x₁ + ... + cₙxₙ)` will be converted into `c*c₁*x₁ + ... + c*cₙ*xₙ`
 -  `(x₁^c₁ * ... * xₙ^cₙ)^c` will be converted into `x₁^(c*c₁) * ... * xₙ^(c*cₙ)`
 -  there are come other simplifications on construction that you can check [here](https://github.com/JuliaSymbolics/SymbolicUtils.jl/blob/master/src/methods.jl)


Here is an example of this

```julia:simplify1
2 * (w+w+α+β + sin(z)^2 + cos(z)^2 - 1)
```

The `simplify` function applies a built-in set of rules to rewrite expressions in order to simplify it.

```julia:simplify2
simplify(2 * (w+w+α+β + sin(z)^2 + cos(z)^2 - 1))
```

The rules in the default simplify applies simple constant elimination and trigonometric identities.

If you read the previous section on the rules DSL, you should be able to read and understand the [rules](https://github.com/JuliaSymbolics/SymbolicUtils.jl/blob/master/src/simplify_rules.jl) that are used by `simplify`.

## Code generation

**Experimental feature**

It is common to want to generate executable code from symbolic expressions and blocks of them. We are working on experimental support for turning Symbolic expressions into executable functions with specific focus on array input and output and performance which is critical to the Differential Equations ecosystem which is making heavy use of this package.

See [Code generation](@ref codegen) for more about this.

## Learn more

If you have a package that you would like to utilize rule-based rewriting in, look at the suggestions in the [Interfacing](@ref "Interfacing with SymbolicUtils.jl") section to find out how you can do that without any fundamental changes to your package. Look at the [API Reference](@ref) for docstrings about specific functions or macros.

Head over to the github repository to ask questions and [report problems](https://github.com/JuliaSymbolics/SymbolicUtils.jl)! Join the [Zulip stream](https://julialang.zulipchat.com/#narrow/stream/236639-symbolic-programming) to chat!

# Upgrade to SymbolicUtils v1

The version 1 of SymbolicUtils utilizes
[Unityper](https://github.com/YingboMa/Unityper.jl) to speed up the compilation
time. We introduce a new type `BasicSymbolic <: Symbolic` to represent all the
previous types `Sym`, `Term`, `Add`, `Mul`, `Pow` and `Div`. Since
`BasicSymbolic` is a concrete type, checking `x isa Sym` or `x isa Pow` no
longer works. Instead, one should use `issym(x)` or `ispow(x)` to check the
"type" of the expression. Also, note that if one does not need to work on a
specific symbolic representation, `issym(x)` and `isterm(x)` should be replaced
by `x isa Symbolic && !istree(x)` and `istree(x)` to be more generic.
Furthermore, dispatching on `Sym`, `Term`, etc no longer works. Instead, a
function that takes `BasicSymbolic` should check the type of the expression
using a `if` statement to select the right code path.

Although we don't have `Sym`, `Term`, etc in the Julia type system anymore, we
still provide convenient constructors for them. For example, `Sym{Real}(:x)`
would still work. For constructor that takes a collection like `Term`s, we
recommend directly construct `Any` element type constructors like `Term(f,
Any[x1, x2])` to reduce extra memory allocation and compile time.

# [Code generation](@id codegen)

**Note: this feature is experimental and the API might change frequently**

`toexpr(ex)` turns any expression (`ex`) into the equivalent `Expr` which is suitable for `eval`. The `SymbolicUtils.Code` module provides some combinators which provides the ability to construct more complex expressions than just function calls. These include:



- Let blocks
- Functions with arguments and keyword arguments
  - Functions with arguments which are to be de-structured
- Expressions that set array elements in-place
- Expressions that create an array similar in type to a reference array (currently supports `Array`, `StaticArrays.SArray`, and `LabelledArrays.SLArray`)
- Expressions that create sparse arrays

**Do `using SymbolicUtils.Code` to get the following bindings**

## `toexpr`

```@docs
SymbolicUtils.Code.toexpr
```

## Code Combinators

These are all exported when you do `using SymbolicUtils.Code`

```@docs
SymbolicUtils.Code.Assignment
SymbolicUtils.Code.Let
SymbolicUtils.Code.Func
SymbolicUtils.Code.SpawnFetch
SymbolicUtils.Code.SetArray
SymbolicUtils.Code.MakeArray
SymbolicUtils.Code.create_array
SymbolicUtils.Code.MakeSparseArray
SymbolicUtils.Code.MakeTuple
SymbolicUtils.Code.LiteralExpr
SymbolicUtils.Code.ForLoop
```

## Optimizations

### Common Subexpression Elimination (CSE)

SymbolicUtils can perform CSE on symbolic expressions, and codegen primitives composed of the above "Code Combinators".
This ensures that common subexpressions in the expression are only computed once. Note that this assumes that all functions
called within the expression are pure. SymbolicUtils can and will change the number and order of function calls.

```@docs; canonical=false
SymbolicUtils.Code.cse
SymbolicUtils.Code.cse_inside_expr
SymbolicUtils.Code.cse_bind_expr
```

### Conditionals

`ifelse` lowers to an `if`/`else` whose branches are still subject to CSE. Two variants pin
the evaluation strategy: `ifelse_eager` always evaluates both branches, while
`ifelse_branching` guarantees the untaken branch is never evaluated — its branch interiors
are excluded from CSE (the conditional itself is still bound; see the
`SymbolicUtils.Code.cse_bind_expr` API entry above).

```@docs
SymbolicUtils.ifelse_eager
SymbolicUtils.ifelse_branching
```

# API Reference

## Symbols and Terms

### Creating Symbols and Terms
```@docs; canonical=false
SymbolicUtils.@syms
SymbolicUtils.term
```

### Metadata
```@docs
SymbolicUtils.hasmetadata
SymbolicUtils.getmetadata
SymbolicUtils.setmetadata
```

### Type Promotion
```@docs; canonical=false
SymbolicUtils.promote_symtype
```

### Array Operation Callables
```@docs
SymbolicUtils.Mapper
SymbolicUtils.Mapreducer
```

### Intermediate Representation
```@docs
SymbolicUtils.IRStructure
```

## Rewriting System

### Rule Creation
```@docs
@rule
@acrule
```

### Rewriters

Every combinator below except `FixpointNoCycle` is also public as `SymbolicUtils.X`, so
`using SymbolicUtils: Chain, Prewalk` and `using SymbolicUtils.Rewriters: Chain, Prewalk`
are both supported.

```@docs
SymbolicUtils.Rewriters
SymbolicUtils.Rewriters.Empty
SymbolicUtils.Rewriters.IfElse
SymbolicUtils.Rewriters.If
SymbolicUtils.Rewriters.Chain
SymbolicUtils.Rewriters.RestartedChain
SymbolicUtils.Rewriters.Fixpoint
SymbolicUtils.Rewriters.FixpointNoCycle
SymbolicUtils.Rewriters.Postwalk
SymbolicUtils.Rewriters.Prewalk
SymbolicUtils.Rewriters.PassThrough
```

## Simplification and Transformation

```@docs
SymbolicUtils.simplify
SymbolicUtils.expand
SymbolicUtils.substitute
```

## Polynomial Forms

```@docs
SymbolicUtils.simplify_fractions
SymbolicUtils.quick_cancel
SymbolicUtils.flatten_fractions
```

## Deprecated

These names are still exported so that existing code keeps working, but each one warns on
use and will be removed in the next breaking release. Their entries record what to write
instead.

```@docs
SymbolicUtils.istree
SymbolicUtils.RuleSet
```

# Caching recursive functions

Many functions benefit greatly from caching their results such that repeated calls with the same arguments
can return cached values. As an example, `getindex` on symbolic arrays is a cached function since the operation can
be expensive. SymbolicUtils.jl provides the `@cache` macro to allow easily caching such functions, with special
benefits when the arguments are symbolic.

```@docs
SymbolicUtils.@cache
SymbolicUtils.associated_cache
SymbolicUtils.get_limit
SymbolicUtils.set_limit!
SymbolicUtils.get_retain_fraction
SymbolicUtils.set_retain_fraction!
SymbolicUtils.toggle_caching!
SymbolicUtils.is_caching_enabled
SymbolicUtils.clear_cache!
SymbolicUtils.get_stats
SymbolicUtils.reset_stats!
```

# Interfacing with SymbolicUtils.jl

This section is for Julia package developers who may want to use the `simplify` and rule rewriting system on their own expression types.

## Defining the interface

SymbolicUtils matchers can match any Julia object that implements an interface to traverse it as a tree. The interface in question, is defined in the [TermInterface.jl](https://github.com/JuliaSymbolics/TermInterface.jl) package. Its purpose is to provide a shared interface between various symbolic programming Julia packages.

In particular, you should define methods from TermInterface.jl for an expression tree type `T` with symbol types `S` to  work
with SymbolicUtils.jl

You can read the documentation of [TermInterface.jl](https://github.com/JuliaSymbolics/TermInterface.jl) on the [Github repository](https://github.com/JuliaSymbolics/TermInterface.jl).
